/******/ (function() { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./lib/swap-helpers.js":
/*!*****************************!*\
  !*** ./lib/swap-helpers.js ***!
  \*****************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ensureInFuture": function() { return /* binding */ ensureInFuture; },
/* harmony export */   "makeSwapPluginQuote": function() { return /* binding */ makeSwapPluginQuote; },
/* harmony export */   "getCodes": function() { return /* binding */ getCodes; },
/* harmony export */   "checkInvalidCodes": function() { return /* binding */ checkInvalidCodes; },
/* harmony export */   "safeCurrencyCodes": function() { return /* binding */ safeCurrencyCodes; },
/* harmony export */   "getCodesWithMainnetTranscription": function() { return /* binding */ getCodesWithMainnetTranscription; }
/* harmony export */ });
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__);
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _nullishCoalesce(lhs, rhsFn) {
  if (lhs != null) {
    return lhs;
  } else {
    return rhsFn();
  }
}

function _optionalChain(ops) {
  var lastAccessLHS = undefined;
  var value = ops[0];
  var i = 1;

  while (i < ops.length) {
    var op = ops[i];
    var fn = ops[i + 1];
    i += 2;

    if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) {
      return undefined;
    }

    if (op === 'access' || op === 'optionalAccess') {
      lastAccessLHS = value;
      value = fn(value);
    } else if (op === 'call' || op === 'optionalCall') {
      value = fn(function () {
        var _value;

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return (_value = value).call.apply(_value, [lastAccessLHS].concat(args));
      });
      lastAccessLHS = undefined;
    }
  }

  return value;
} // 



/**
 * Ensures that a date is in the future by at least the given amount.
 */

function ensureInFuture(date) {
  var marginSeconds = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 30;
  if (date == null) return;
  var target = Date.now() + marginSeconds * 1000;
  return target < date.valueOf() ? date : new Date(target);
}
function makeSwapPluginQuote(request, fromNativeAmount, toNativeAmount, tx, destinationAddress, pluginId) {
  var isEstimate = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : false;
  var expirationDate = arguments.length > 7 ? arguments[7] : undefined;
  var quoteId = arguments.length > 8 ? arguments[8] : undefined;
  var fromWallet = request.fromWallet;
  var out = {
    fromNativeAmount: fromNativeAmount,
    toNativeAmount: toNativeAmount,
    networkFee: {
      currencyCode: fromWallet.currencyInfo.currencyCode,
      nativeAmount: tx.parentNetworkFee != null ? tx.parentNetworkFee : tx.networkFee
    },
    destinationAddress: destinationAddress,
    pluginId: pluginId,
    expirationDate: expirationDate,
    quoteId: quoteId,
    isEstimate: isEstimate,
    approve: function approve() {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var signedTransaction, broadcastedTransaction;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return fromWallet.signTx(tx);

              case 2:
                signedTransaction = _context.sent;
                _context.next = 5;
                return fromWallet.broadcastTx(signedTransaction);

              case 5:
                broadcastedTransaction = _context.sent;
                _context.next = 8;
                return fromWallet.saveTx(signedTransaction);

              case 8:
                return _context.abrupt("return", {
                  transaction: broadcastedTransaction,
                  orderId: quoteId,
                  destinationAddress: destinationAddress
                });

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },
    close: function close() {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }))();
    }
  };
  return out;
}
var getCodes = function getCodes(request) {
  return {
    fromMainnetCode: request.fromWallet.currencyInfo.currencyCode,
    toMainnetCode: request.toWallet.currencyInfo.currencyCode,
    fromCurrencyCode: request.fromCurrencyCode,
    toCurrencyCode: request.toCurrencyCode
  };
};

var getPluginIds = function getPluginIds(request) {
  return {
    fromPluginId: request.fromWallet.currencyInfo.pluginId,
    toPluginId: request.toWallet.currencyInfo.pluginId
  };
};
/**
 * Throws if either currency code has been disabled by the plugin
 */


function checkInvalidCodes(invalidCodes, request, swapInfo) {
  var _getPluginIds = getPluginIds(request),
      fromPluginId = _getPluginIds.fromPluginId,
      toPluginId = _getPluginIds.toPluginId;

  var _getCodes = getCodes(request),
      fromMainnetCode = _getCodes.fromMainnetCode,
      toMainnetCode = _getCodes.toMainnetCode,
      fromCurrencyCode = _getCodes.fromCurrencyCode,
      toCurrencyCode = _getCodes.toCurrencyCode;

  function check(direction, pluginId, main, token) {
    switch (invalidCodes[direction][pluginId]) {
      case undefined:
        return false;

      case 'allCodes':
        return true;

      case 'allTokens':
        return main !== token;

      default:
        return invalidCodes[direction][pluginId].some(function (code) {
          return code === token;
        });
    }
  }

  if (check('from', fromPluginId, fromMainnetCode, fromCurrencyCode) || check('to', toPluginId, toMainnetCode, toCurrencyCode)) throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);
}
/**
 * Transcribes requested currency codes into plugin compatible unique IDs
 */

function safeCurrencyCodes(transcriptionMap, request) {
  var toLowerCase = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  var _getPluginIds2 = getPluginIds(request),
      fromPluginId = _getPluginIds2.fromPluginId,
      toPluginId = _getPluginIds2.toPluginId;

  var _getCodes2 = getCodes(request),
      fromCurrencyCode = _getCodes2.fromCurrencyCode,
      toCurrencyCode = _getCodes2.toCurrencyCode;

  var out = {
    safeFromCurrencyCode: fromCurrencyCode,
    safeToCurrencyCode: toCurrencyCode
  };

  if (_optionalChain([transcriptionMap, 'access', function (_) {
    return _[fromPluginId];
  }, 'optionalAccess', function (_2) {
    return _2[request.fromCurrencyCode];
  }])) {
    out.safeFromCurrencyCode = transcriptionMap[fromPluginId][request.fromCurrencyCode];
  }

  if (_optionalChain([transcriptionMap, 'access', function (_3) {
    return _3[toPluginId];
  }, 'optionalAccess', function (_4) {
    return _4[request.toCurrencyCode];
  }])) {
    out.safeToCurrencyCode = transcriptionMap[toPluginId][request.toCurrencyCode];
  }

  if (toLowerCase) Object.keys(out).forEach(function (key) {
    out[key] = out[key].toLowerCase();
  });
  return out;
}
/**
 * Returns all four codes with mainnet transcription
 */

var getCodesWithMainnetTranscription = function getCodesWithMainnetTranscription(request, transcriptionMap) {
  var _getCodes3 = getCodes(request),
      fromCurrencyCode = _getCodes3.fromCurrencyCode,
      toCurrencyCode = _getCodes3.toCurrencyCode,
      fromMainnetCode = _getCodes3.fromMainnetCode,
      toMainnetCode = _getCodes3.toMainnetCode;

  return {
    fromMainnetCode: _nullishCoalesce(transcriptionMap[request.fromWallet.currencyInfo.pluginId], function () {
      return fromMainnetCode;
    }),
    toMainnetCode: _nullishCoalesce(transcriptionMap[request.toWallet.currencyInfo.pluginId], function () {
      return toMainnetCode;
    }),
    fromCurrencyCode: fromCurrencyCode,
    toCurrencyCode: toCurrencyCode
  };
};

/***/ }),

/***/ "./lib/swap/changenow.js":
/*!*******************************!*\
  !*** ./lib/swap/changenow.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeChangeNowPlugin": function() { return /* binding */ makeChangeNowPlugin; },
/* harmony export */   "asOptionalBlank": function() { return /* binding */ asOptionalBlank; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../swap-helpers.js */ "./lib/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// 




var pluginId = 'changenow';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Change NOW',
  supportEmail: 'support@changenow.io'
};
var orderUri = 'https://changenow.io/exchange/txs/';
var uri = 'https://api.changenow.io/v2/';
var dontUseLegacy = {
  DGB: true
};
var INVALID_CURRENCY_CODES = {
  from: {},
  to: {
    zcash: ['ZEC']
  }
}; // Network names that don't match parent network currency code

var MAINNET_CODE_TRANSCRIPTION = {
  binancesmartchain: 'BSC'
};

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(wallet, currencyCode) {
    var addressInfo;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context5.sent;
            return _context5.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _getAddress.apply(this, arguments);
}

function makeChangeNowPlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io;
  var fetch = io.fetch;

  if (initOptions.apiKey == null) {
    throw new Error('No ChangeNow apiKey provided.');
  }

  var apiKey = initOptions.apiKey;
  var headers = {
    'Content-Type': 'application/json',
    'x-changenow-api-key': apiKey
  };
  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var promoCode, _yield$Promise$all, _yield$Promise$all2, fromAddress, toAddress, _getCodesWithMainnetT, fromCurrencyCode, toCurrencyCode, fromMainnetCode, toMainnetCode, currencyString, nativeAmount, quoteFor, createOrder, _createOrder, swapSell, _swapSell, swapBuy, _swapBuy;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _swapBuy = function _swapBuy3() {
                  _swapBuy = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(flow) {
                    var largeDenomAmount, _yield$createOrder2, fromAmount, payinAddress, payinExtraId, id, validUntil, fromNativeAmount, spendInfo, tx;

                    return regeneratorRuntime.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            _context3.next = 2;
                            return request.toWallet.nativeToDenomination(nativeAmount, toCurrencyCode);

                          case 2:
                            largeDenomAmount = _context3.sent;
                            _context3.next = 5;
                            return createOrder(flow, false, largeDenomAmount);

                          case 5:
                            _yield$createOrder2 = _context3.sent;
                            fromAmount = _yield$createOrder2.fromAmount;
                            payinAddress = _yield$createOrder2.payinAddress;
                            payinExtraId = _yield$createOrder2.payinExtraId;
                            id = _yield$createOrder2.id;
                            validUntil = _yield$createOrder2.validUntil;
                            _context3.next = 13;
                            return request.fromWallet.denominationToNative(fromAmount.toString(), fromCurrencyCode);

                          case 13:
                            fromNativeAmount = _context3.sent;
                            spendInfo = {
                              currencyCode: fromCurrencyCode,
                              spendTargets: [{
                                nativeAmount: fromNativeAmount,
                                publicAddress: payinAddress,
                                uniqueIdentifier: payinExtraId
                              }],
                              networkFeeOption: fromCurrencyCode === 'BTC' ? 'high' : 'standard',
                              swapData: {
                                orderId: id,
                                orderUri: orderUri + id,
                                isEstimate: false,
                                payoutAddress: toAddress,
                                payoutCurrencyCode: toCurrencyCode,
                                payoutNativeAmount: nativeAmount,
                                payoutWalletId: request.toWallet.id,
                                plugin: _objectSpread({}, swapInfo),
                                refundAddress: fromAddress
                              }
                            };
                            _context3.next = 17;
                            return request.fromWallet.makeSpend(spendInfo);

                          case 17:
                            tx = _context3.sent;
                            return _context3.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.makeSwapPluginQuote)(request, fromNativeAmount, nativeAmount, tx, toAddress, pluginId, false, validUntil != null ? (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.ensureInFuture)(validUntil) : new Date(Date.now() + 1000 * 60 * 20), id));

                          case 19:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));
                  return _swapBuy.apply(this, arguments);
                };

                swapBuy = function _swapBuy2(_x7) {
                  return _swapBuy.apply(this, arguments);
                };

                _swapSell = function _swapSell3() {
                  _swapSell = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(flow) {
                    var largeDenomAmount, marketRangeResponse, marketRangeResponseJson, _asMarketRange, minAmount, maxAmount, minNativeAmount, maxNativeAmount, _yield$createOrder, toAmount, payinAddress, payinExtraId, id, validUntil, toNativeAmount, spendInfo, tx;

                    return regeneratorRuntime.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            _context2.next = 2;
                            return request.fromWallet.nativeToDenomination(nativeAmount, fromCurrencyCode);

                          case 2:
                            largeDenomAmount = _context2.sent;
                            _context2.next = 5;
                            return fetch(uri + "exchange/range?flow=".concat(flow, "&").concat(currencyString), {
                              headers: headers
                            });

                          case 5:
                            marketRangeResponse = _context2.sent;
                            _context2.next = 8;
                            return marketRangeResponse.json();

                          case 8:
                            marketRangeResponseJson = _context2.sent;

                            if (!(marketRangeResponseJson.error != null)) {
                              _context2.next = 11;
                              break;
                            }

                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapCurrencyError(swapInfo, fromCurrencyCode, toCurrencyCode);

                          case 11:
                            _asMarketRange = asMarketRange(marketRangeResponseJson), minAmount = _asMarketRange.minAmount, maxAmount = _asMarketRange.maxAmount;

                            if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(largeDenomAmount, minAmount.toString())) {
                              _context2.next = 17;
                              break;
                            }

                            _context2.next = 15;
                            return request.fromWallet.denominationToNative(minAmount.toString(), fromCurrencyCode);

                          case 15:
                            minNativeAmount = _context2.sent;
                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapBelowLimitError(swapInfo, minNativeAmount);

                          case 17:
                            if (!(maxAmount != null && (0,biggystring__WEBPACK_IMPORTED_MODULE_0__.gt)(largeDenomAmount, maxAmount.toString()))) {
                              _context2.next = 22;
                              break;
                            }

                            _context2.next = 20;
                            return request.fromWallet.denominationToNative(maxAmount.toString(), fromCurrencyCode);

                          case 20:
                            maxNativeAmount = _context2.sent;
                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapAboveLimitError(swapInfo, maxNativeAmount);

                          case 22:
                            _context2.next = 24;
                            return createOrder(flow, true, largeDenomAmount);

                          case 24:
                            _yield$createOrder = _context2.sent;
                            toAmount = _yield$createOrder.toAmount;
                            payinAddress = _yield$createOrder.payinAddress;
                            payinExtraId = _yield$createOrder.payinExtraId;
                            id = _yield$createOrder.id;
                            validUntil = _yield$createOrder.validUntil;
                            _context2.next = 32;
                            return request.toWallet.denominationToNative(toAmount.toString(), toCurrencyCode);

                          case 32:
                            toNativeAmount = _context2.sent;
                            spendInfo = {
                              currencyCode: fromCurrencyCode,
                              spendTargets: [{
                                nativeAmount: nativeAmount,
                                publicAddress: payinAddress,
                                uniqueIdentifier: payinExtraId
                              }],
                              networkFeeOption: fromCurrencyCode === 'BTC' ? 'high' : 'standard',
                              swapData: {
                                orderId: id,
                                orderUri: orderUri + id,
                                isEstimate: flow === 'standard',
                                payoutAddress: toAddress,
                                payoutCurrencyCode: toCurrencyCode,
                                payoutNativeAmount: toNativeAmount,
                                payoutWalletId: request.toWallet.id,
                                plugin: _objectSpread({}, swapInfo),
                                refundAddress: fromAddress
                              }
                            };
                            _context2.next = 36;
                            return request.fromWallet.makeSpend(spendInfo);

                          case 36:
                            tx = _context2.sent;
                            return _context2.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.makeSwapPluginQuote)(request, nativeAmount, toNativeAmount, tx, toAddress, pluginId, flow === 'standard', validUntil != null ? (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.ensureInFuture)(validUntil) : new Date(Date.now() + 1000 * 60 * 20), id));

                          case 38:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2);
                  }));
                  return _swapSell.apply(this, arguments);
                };

                swapSell = function _swapSell2(_x6) {
                  return _swapSell.apply(this, arguments);
                };

                _createOrder = function _createOrder3() {
                  _createOrder = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(flow, isSelling, largeDenomAmount) {
                    var type, exchangeAmountResponse, exchangeAmountResponseJson, _asExchange, rateId, validUntil, orderBody, orderResponse, orderResponseJson;

                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            type = isSelling ? 'direct' : 'reverse'; // Get rateId and Date

                            _context.next = 3;
                            return fetch(uri + "exchange/estimated-amount?flow=".concat(flow, "&useRateId=").concat(String(flow === 'fixed-rate'), "&").concat(isSelling ? 'fromAmount' : 'toAmount', "=").concat(largeDenomAmount, "&type=").concat(type, "&").concat(currencyString), {
                              headers: headers
                            });

                          case 3:
                            exchangeAmountResponse = _context.sent;
                            _context.next = 6;
                            return exchangeAmountResponse.json();

                          case 6:
                            exchangeAmountResponseJson = _context.sent;

                            if (!(exchangeAmountResponseJson.error != null)) {
                              _context.next = 9;
                              break;
                            }

                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapCurrencyError(swapInfo, fromCurrencyCode, toCurrencyCode);

                          case 9:
                            _asExchange = asExchange(exchangeAmountResponseJson), rateId = _asExchange.rateId, validUntil = _asExchange.validUntil; // Create order

                            orderBody = {
                              fromCurrency: fromCurrencyCode,
                              toCurrency: toCurrencyCode,
                              fromNetwork: fromMainnetCode,
                              toNetwork: toMainnetCode,
                              fromAmount: isSelling ? largeDenomAmount : '',
                              toAmount: isSelling ? '' : largeDenomAmount,
                              type: type,
                              address: toAddress,
                              refundAddress: fromAddress,
                              flow: flow,
                              rateId: rateId,
                              payload: {
                                promoCode: promoCode
                              }
                            };
                            _context.next = 13;
                            return fetch(uri + 'exchange', {
                              method: 'POST',
                              body: JSON.stringify(orderBody),
                              headers: headers
                            });

                          case 13:
                            orderResponse = _context.sent;

                            if (orderResponse.ok) {
                              _context.next = 16;
                              break;
                            }

                            throw new Error("ChangeNow call returned error code ".concat(orderResponse.status));

                          case 16:
                            _context.next = 18;
                            return orderResponse.json();

                          case 18:
                            orderResponseJson = _context.sent;
                            return _context.abrupt("return", _objectSpread(_objectSpread({}, asOrder(orderResponseJson)), {}, {
                              validUntil: validUntil
                            }));

                          case 20:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));
                  return _createOrder.apply(this, arguments);
                };

                createOrder = function _createOrder2(_x3, _x4, _x5) {
                  return _createOrder.apply(this, arguments);
                };

                promoCode = opts.promoCode;
                (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo); // Grab addresses:

                _context4.next = 10;
                return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

              case 10:
                _yield$Promise$all = _context4.sent;
                _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
                fromAddress = _yield$Promise$all2[0];
                toAddress = _yield$Promise$all2[1];
                _getCodesWithMainnetT = (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.getCodesWithMainnetTranscription)(request, MAINNET_CODE_TRANSCRIPTION), fromCurrencyCode = _getCodesWithMainnetT.fromCurrencyCode, toCurrencyCode = _getCodesWithMainnetT.toCurrencyCode, fromMainnetCode = _getCodesWithMainnetT.fromMainnetCode, toMainnetCode = _getCodesWithMainnetT.toMainnetCode;
                currencyString = "fromCurrency=".concat(fromCurrencyCode, "&toCurrency=").concat(toCurrencyCode, "&fromNetwork=").concat(fromMainnetCode, "&toNetwork=").concat(toMainnetCode);
                nativeAmount = request.nativeAmount, quoteFor = request.quoteFor;

                if (!(quoteFor === 'from')) {
                  _context4.next = 37;
                  break;
                }

                _context4.prev = 18;
                _context4.next = 21;
                return swapSell('fixed-rate');

              case 21:
                return _context4.abrupt("return", _context4.sent);

              case 24:
                _context4.prev = 24;
                _context4.t0 = _context4["catch"](18);
                _context4.prev = 26;
                _context4.next = 29;
                return swapSell('standard');

              case 29:
                return _context4.abrupt("return", _context4.sent);

              case 32:
                _context4.prev = 32;
                _context4.t1 = _context4["catch"](26);
                throw _context4.t0;

              case 35:
                _context4.next = 38;
                break;

              case 37:
                return _context4.abrupt("return", swapBuy('fixed-rate'));

              case 38:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, null, [[18, 24], [26, 32]]);
      }))();
    }
  };
  return out;
}
/**
 * An optional value, where a blank string means undefined.
 */

function asOptionalBlank(cleaner) {
  return function asIgnoredBlank(raw) {
    if (raw == null || raw === '') return;
    return cleaner(raw);
  };
}
var asMarketRange = (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asObject)({
  maxAmount: (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asMaybe)(cleaners__WEBPACK_IMPORTED_MODULE_1__.asNumber),
  minAmount: cleaners__WEBPACK_IMPORTED_MODULE_1__.asNumber
});
var asExchange = (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asObject)({
  rateId: (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_1__.asString),
  validUntil: (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_1__.asDate)
});
var asOrder = (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asObject)({
  fromAmount: cleaners__WEBPACK_IMPORTED_MODULE_1__.asNumber,
  toAmount: cleaners__WEBPACK_IMPORTED_MODULE_1__.asNumber,
  payinAddress: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  payinExtraId: asOptionalBlank(cleaners__WEBPACK_IMPORTED_MODULE_1__.asString),
  id: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString
});

/***/ }),

/***/ "./lib/swap/letsexchange.js":
/*!**********************************!*\
  !*** ./lib/swap/letsexchange.js ***!
  \**********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeLetsExchangePlugin": function() { return /* binding */ makeLetsExchangePlugin; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../swap-helpers.js */ "./lib/swap-helpers.js");
/* harmony import */ var _changenow__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./changenow */ "./lib/swap/changenow.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// 





var pluginId = 'letsexchange';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'LetsExchange',
  supportEmail: 'support@letsexchange.io'
};
var orderUri = 'https://letsexchange.io/?exchangeId=';
var uri = 'https://api.letsexchange.io/api/v1/';
var expirationMs = 1000 * 60 * 20;
var asQuoteInfo = (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asObject)({
  transaction_id: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  status: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  coin_from: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  coin_to: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  coin_from_network: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  coin_to_network: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  deposit_amount: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  withdrawal_amount: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  deposit: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  deposit_extra_id: (0,_changenow__WEBPACK_IMPORTED_MODULE_4__.asOptionalBlank)(cleaners__WEBPACK_IMPORTED_MODULE_1__.asString),
  withdrawal: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  withdrawal_extra_id: (0,_changenow__WEBPACK_IMPORTED_MODULE_4__.asOptionalBlank)(cleaners__WEBPACK_IMPORTED_MODULE_1__.asString),
  rate: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  fee: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  "return": cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  hash_in: (0,_changenow__WEBPACK_IMPORTED_MODULE_4__.asOptionalBlank)(cleaners__WEBPACK_IMPORTED_MODULE_1__.asString),
  hash_out: (0,_changenow__WEBPACK_IMPORTED_MODULE_4__.asOptionalBlank)(cleaners__WEBPACK_IMPORTED_MODULE_1__.asString)
});
var dontUseLegacy = {
  DGB: true
};
var INVALID_CURRENCY_CODES = {
  from: {},
  to: {
    zcash: ['ZEC']
  }
};
var MAINNET_CODE_TRANSCRIPTION = {
  ethereum: 'ERC20',
  binancesmartchain: 'BEP20',
  tron: 'TRC20',
  binance: 'BEP2',
  rsk: 'RSK',
  avalanche: 'AVAXC'
};

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(wallet, currencyCode) {
    var addressInfo;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context3.sent;
            return _context3.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _getAddress.apply(this, arguments);
}

function makeLetsExchangePlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;

  function call(_x3, _x4, _x5) {
    return _call.apply(this, arguments);
  }

  function _call() {
    _call = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(url, request, data) {
      var body, headers, response;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              body = JSON.stringify(data.params);
              headers = {
                'Content-Type': 'application/json',
                Accept: 'application/json'
              };
              _context2.next = 4;
              return fetchCors(url, {
                method: 'POST',
                body: body,
                headers: headers
              });

            case 4:
              response = _context2.sent;

              if (response.ok) {
                _context2.next = 9;
                break;
              }

              if (!(response.status === 422)) {
                _context2.next = 8;
                break;
              }

              throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

            case 8:
              throw new Error("letsexchange returned error code ".concat(response.status));

            case 9:
              return _context2.abrupt("return", response.json());

            case 10:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return _call.apply(this, arguments);
  }

  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _yield$Promise$all, _yield$Promise$all2, fromAddress, toAddress, quoteAmount, _getCodesWithMainnetT, fromMainnetCode, toMainnetCode, networkFrom, networkTo, quoteParams, fromAmount, fromNativeAmount, toNativeAmount, reply, nativeMin, promoCode, sendReply, quoteInfo, spendInfo, tx;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo); // Grab addresses:

                _context.next = 3;
                return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

              case 3:
                _yield$Promise$all = _context.sent;
                _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
                fromAddress = _yield$Promise$all2[0];
                toAddress = _yield$Promise$all2[1];

                if (!(request.quoteFor === 'from')) {
                  _context.next = 13;
                  break;
                }

                _context.next = 10;
                return request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode);

              case 10:
                _context.t0 = _context.sent;
                _context.next = 16;
                break;

              case 13:
                _context.next = 15;
                return request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

              case 15:
                _context.t0 = _context.sent;

              case 16:
                quoteAmount = _context.t0;
                _getCodesWithMainnetT = (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.getCodesWithMainnetTranscription)(request, MAINNET_CODE_TRANSCRIPTION), fromMainnetCode = _getCodesWithMainnetT.fromMainnetCode, toMainnetCode = _getCodesWithMainnetT.toMainnetCode;
                networkFrom = request.fromCurrencyCode === request.fromWallet.currencyInfo.currencyCode ? request.fromCurrencyCode : fromMainnetCode;
                networkTo = request.toCurrencyCode === request.toWallet.currencyInfo.currencyCode ? request.toCurrencyCode : toMainnetCode; // Swap the currencies if we need a reverse quote:

                quoteParams = {
                  from: request.fromCurrencyCode,
                  to: request.toCurrencyCode,
                  network_from: networkFrom,
                  network_to: networkTo,
                  amount: quoteAmount
                };
                log('quoteParams:', quoteParams); // Calculate the amounts:

                if (!(request.quoteFor === 'from')) {
                  _context.next = 33;
                  break;
                }

                _context.next = 25;
                return call(uri + 'info', request, {
                  params: quoteParams
                });

              case 25:
                reply = _context.sent;
                fromAmount = quoteAmount;
                fromNativeAmount = request.nativeAmount;
                _context.next = 30;
                return request.toWallet.denominationToNative(reply.amount.toString(), request.toCurrencyCode);

              case 30:
                toNativeAmount = _context.sent;
                _context.next = 41;
                break;

              case 33:
                _context.next = 35;
                return call(uri + 'info-revert', request, {
                  params: quoteParams
                });

              case 35:
                reply = _context.sent;
                fromAmount = reply.amount;
                _context.next = 39;
                return request.fromWallet.denominationToNative(fromAmount.toString(), request.fromCurrencyCode);

              case 39:
                fromNativeAmount = _context.sent;
                toNativeAmount = request.nativeAmount;

              case 41:
                _context.next = 43;
                return request.fromWallet.denominationToNative(reply.min_amount, request.fromCurrencyCode);

              case 43:
                nativeMin = _context.sent;

                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(fromNativeAmount, nativeMin)) {
                  _context.next = 46;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapBelowLimitError(swapInfo, nativeMin);

              case 46:
                promoCode = opts.promoCode;
                _context.next = 49;
                return call(uri + 'transaction', request, {
                  params: {
                    deposit_amount: fromAmount,
                    coin_from: request.fromCurrencyCode,
                    coin_to: request.toCurrencyCode,
                    network_from: networkFrom,
                    network_to: networkTo,
                    withdrawal: toAddress,
                    "return": fromAddress,
                    return_extra_id: null,
                    withdrawal_extra_id: null,
                    affiliate_id: initOptions.apiKey,
                    promocode: promoCode != null ? promoCode : '',
                    type: 'edge',
                    "float": false,
                    isEstimate: false
                  }
                });

              case 49:
                sendReply = _context.sent;
                log('sendReply', sendReply);
                quoteInfo = asQuoteInfo(sendReply); // Make the transaction:

                spendInfo = {
                  currencyCode: request.fromCurrencyCode,
                  spendTargets: [{
                    nativeAmount: fromNativeAmount,
                    publicAddress: quoteInfo.deposit,
                    uniqueIdentifier: quoteInfo.deposit_extra_id
                  }],
                  networkFeeOption: request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                  swapData: {
                    orderId: quoteInfo.transaction_id,
                    orderUri: orderUri + quoteInfo.transaction_id,
                    isEstimate: false,
                    payoutAddress: toAddress,
                    payoutCurrencyCode: request.toCurrencyCode,
                    payoutNativeAmount: toNativeAmount,
                    payoutWalletId: request.toWallet.id,
                    plugin: _objectSpread({}, swapInfo),
                    refundAddress: fromAddress
                  }
                };
                log('spendInfo', spendInfo);
                _context.next = 56;
                return request.fromWallet.makeSpend(spendInfo);

              case 56:
                tx = _context.sent;
                return _context.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.makeSwapPluginQuote)(request, fromNativeAmount, toNativeAmount, tx, toAddress, 'letsexchange', false, // isEstimate, correct?
                new Date(Date.now() + expirationMs), quoteInfo.transaction_id));

              case 58:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/_version.js":
/*!*************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/_version.js ***!
  \*************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "abi/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/abi-coder.js":
/*!**************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/abi-coder.js ***!
  \**************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "AbiCoder": function() { return /* binding */ AbiCoder; },
/* harmony export */   "defaultAbiCoder": function() { return /* binding */ defaultAbiCoder; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/abi/lib.esm/_version.js");
/* harmony import */ var _coders_abstract_coder__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./coders/abstract-coder */ "./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js");
/* harmony import */ var _coders_address__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./coders/address */ "./node_modules/@ethersproject/abi/lib.esm/coders/address.js");
/* harmony import */ var _coders_array__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./coders/array */ "./node_modules/@ethersproject/abi/lib.esm/coders/array.js");
/* harmony import */ var _coders_boolean__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./coders/boolean */ "./node_modules/@ethersproject/abi/lib.esm/coders/boolean.js");
/* harmony import */ var _coders_bytes__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./coders/bytes */ "./node_modules/@ethersproject/abi/lib.esm/coders/bytes.js");
/* harmony import */ var _coders_fixed_bytes__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./coders/fixed-bytes */ "./node_modules/@ethersproject/abi/lib.esm/coders/fixed-bytes.js");
/* harmony import */ var _coders_null__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./coders/null */ "./node_modules/@ethersproject/abi/lib.esm/coders/null.js");
/* harmony import */ var _coders_number__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./coders/number */ "./node_modules/@ethersproject/abi/lib.esm/coders/number.js");
/* harmony import */ var _coders_string__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./coders/string */ "./node_modules/@ethersproject/abi/lib.esm/coders/string.js");
/* harmony import */ var _coders_tuple__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./coders/tuple */ "./node_modules/@ethersproject/abi/lib.esm/coders/tuple.js");
/* harmony import */ var _fragments__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./fragments */ "./node_modules/@ethersproject/abi/lib.esm/fragments.js");
 // See: https://github.com/ethereum/wiki/wiki/Ethereum-Contract-ABI

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }





var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);











var paramTypeBytes = new RegExp(/^bytes([0-9]*)$/);
var paramTypeNumber = new RegExp(/^(u?int)([0-9]*)$/);
var AbiCoder = /*#__PURE__*/function () {
  function AbiCoder(coerceFunc) {
    _classCallCheck(this, AbiCoder);

    logger.checkNew(this instanceof AbiCoder ? this.constructor : void 0, AbiCoder);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(this, "coerceFunc", coerceFunc || null);
  }

  _createClass(AbiCoder, [{
    key: "_getCoder",
    value: function _getCoder(param) {
      var _this = this;

      switch (param.baseType) {
        case "address":
          return new _coders_address__WEBPACK_IMPORTED_MODULE_3__.AddressCoder(param.name);

        case "bool":
          return new _coders_boolean__WEBPACK_IMPORTED_MODULE_4__.BooleanCoder(param.name);

        case "string":
          return new _coders_string__WEBPACK_IMPORTED_MODULE_5__.StringCoder(param.name);

        case "bytes":
          return new _coders_bytes__WEBPACK_IMPORTED_MODULE_6__.BytesCoder(param.name);

        case "array":
          return new _coders_array__WEBPACK_IMPORTED_MODULE_7__.ArrayCoder(this._getCoder(param.arrayChildren), param.arrayLength, param.name);

        case "tuple":
          return new _coders_tuple__WEBPACK_IMPORTED_MODULE_8__.TupleCoder((param.components || []).map(function (component) {
            return _this._getCoder(component);
          }), param.name);

        case "":
          return new _coders_null__WEBPACK_IMPORTED_MODULE_9__.NullCoder(param.name);
      } // u?int[0-9]*


      var match = param.type.match(paramTypeNumber);

      if (match) {
        var size = parseInt(match[2] || "256");

        if (size === 0 || size > 256 || size % 8 !== 0) {
          logger.throwArgumentError("invalid " + match[1] + " bit length", "param", param);
        }

        return new _coders_number__WEBPACK_IMPORTED_MODULE_10__.NumberCoder(size / 8, match[1] === "int", param.name);
      } // bytes[0-9]+


      match = param.type.match(paramTypeBytes);

      if (match) {
        var _size = parseInt(match[1]);

        if (_size === 0 || _size > 32) {
          logger.throwArgumentError("invalid bytes length", "param", param);
        }

        return new _coders_fixed_bytes__WEBPACK_IMPORTED_MODULE_11__.FixedBytesCoder(_size, param.name);
      }

      return logger.throwArgumentError("invalid type", "type", param.type);
    }
  }, {
    key: "_getWordSize",
    value: function _getWordSize() {
      return 32;
    }
  }, {
    key: "_getReader",
    value: function _getReader(data, allowLoose) {
      return new _coders_abstract_coder__WEBPACK_IMPORTED_MODULE_12__.Reader(data, this._getWordSize(), this.coerceFunc, allowLoose);
    }
  }, {
    key: "_getWriter",
    value: function _getWriter() {
      return new _coders_abstract_coder__WEBPACK_IMPORTED_MODULE_12__.Writer(this._getWordSize());
    }
  }, {
    key: "getDefaultValue",
    value: function getDefaultValue(types) {
      var _this2 = this;

      var coders = types.map(function (type) {
        return _this2._getCoder(_fragments__WEBPACK_IMPORTED_MODULE_13__.ParamType.from(type));
      });
      var coder = new _coders_tuple__WEBPACK_IMPORTED_MODULE_8__.TupleCoder(coders, "_");
      return coder.defaultValue();
    }
  }, {
    key: "encode",
    value: function encode(types, values) {
      var _this3 = this;

      if (types.length !== values.length) {
        logger.throwError("types/values length mismatch", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INVALID_ARGUMENT, {
          count: {
            types: types.length,
            values: values.length
          },
          value: {
            types: types,
            values: values
          }
        });
      }

      var coders = types.map(function (type) {
        return _this3._getCoder(_fragments__WEBPACK_IMPORTED_MODULE_13__.ParamType.from(type));
      });
      var coder = new _coders_tuple__WEBPACK_IMPORTED_MODULE_8__.TupleCoder(coders, "_");

      var writer = this._getWriter();

      coder.encode(writer, values);
      return writer.data;
    }
  }, {
    key: "decode",
    value: function decode(types, data, loose) {
      var _this4 = this;

      var coders = types.map(function (type) {
        return _this4._getCoder(_fragments__WEBPACK_IMPORTED_MODULE_13__.ParamType.from(type));
      });
      var coder = new _coders_tuple__WEBPACK_IMPORTED_MODULE_8__.TupleCoder(coders, "_");
      return coder.decode(this._getReader((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_14__.arrayify)(data), loose));
    }
  }]);

  return AbiCoder;
}();
var defaultAbiCoder = new AbiCoder();

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js":
/*!**************************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "checkResultErrors": function() { return /* binding */ checkResultErrors; },
/* harmony export */   "Coder": function() { return /* binding */ Coder; },
/* harmony export */   "Writer": function() { return /* binding */ Writer; },
/* harmony export */   "Reader": function() { return /* binding */ Reader; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../_version */ "./node_modules/@ethersproject/abi/lib.esm/_version.js");


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }






var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
function checkResultErrors(result) {
  // Find the first error (if any)
  var errors = [];

  var checkErrors = function checkErrors(path, object) {
    if (!Array.isArray(object)) {
      return;
    }

    for (var key in object) {
      var childPath = path.slice();
      childPath.push(key);

      try {
        checkErrors(childPath, object[key]);
      } catch (error) {
        errors.push({
          path: childPath,
          error: error
        });
      }
    }
  };

  checkErrors([], result);
  return errors;
}
var Coder = /*#__PURE__*/function () {
  function Coder(name, type, localName, dynamic) {
    _classCallCheck(this, Coder);

    // @TODO: defineReadOnly these
    this.name = name;
    this.type = type;
    this.localName = localName;
    this.dynamic = dynamic;
  }

  _createClass(Coder, [{
    key: "_throwError",
    value: function _throwError(message, value) {
      logger.throwArgumentError(message, this.localName, value);
    }
  }]);

  return Coder;
}();
var Writer = /*#__PURE__*/function () {
  function Writer(wordSize) {
    _classCallCheck(this, Writer);

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(this, "wordSize", wordSize || 32);
    this._data = [];
    this._dataLength = 0;
    this._padding = new Uint8Array(wordSize);
  }

  _createClass(Writer, [{
    key: "data",
    get: function get() {
      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexConcat)(this._data);
    }
  }, {
    key: "length",
    get: function get() {
      return this._dataLength;
    }
  }, {
    key: "_writeData",
    value: function _writeData(data) {
      this._data.push(data);

      this._dataLength += data.length;
      return data.length;
    }
  }, {
    key: "appendWriter",
    value: function appendWriter(writer) {
      return this._writeData((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.concat)(writer._data));
    } // Arrayish items; padded on the right to wordSize

  }, {
    key: "writeBytes",
    value: function writeBytes(value) {
      var bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(value);
      var paddingOffset = bytes.length % this.wordSize;

      if (paddingOffset) {
        bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.concat)([bytes, this._padding.slice(paddingOffset)]);
      }

      return this._writeData(bytes);
    }
  }, {
    key: "_getValue",
    value: function _getValue(value) {
      var bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(value));

      if (bytes.length > this.wordSize) {
        logger.throwError("value out-of-bounds", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.BUFFER_OVERRUN, {
          length: this.wordSize,
          offset: bytes.length
        });
      }

      if (bytes.length % this.wordSize) {
        bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.concat)([this._padding.slice(bytes.length % this.wordSize), bytes]);
      }

      return bytes;
    } // BigNumberish items; padded on the left to wordSize

  }, {
    key: "writeValue",
    value: function writeValue(value) {
      return this._writeData(this._getValue(value));
    }
  }, {
    key: "writeUpdatableValue",
    value: function writeUpdatableValue() {
      var _this = this;

      var offset = this._data.length;

      this._data.push(this._padding);

      this._dataLength += this.wordSize;
      return function (value) {
        _this._data[offset] = _this._getValue(value);
      };
    }
  }]);

  return Writer;
}();
var Reader = /*#__PURE__*/function () {
  function Reader(data, wordSize, coerceFunc, allowLoose) {
    _classCallCheck(this, Reader);

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(this, "_data", (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(data));
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(this, "wordSize", wordSize || 32);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(this, "_coerceFunc", coerceFunc);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(this, "allowLoose", allowLoose);
    this._offset = 0;
  }

  _createClass(Reader, [{
    key: "data",
    get: function get() {
      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexlify)(this._data);
    }
  }, {
    key: "consumed",
    get: function get() {
      return this._offset;
    } // The default Coerce function

  }, {
    key: "coerce",
    value: function coerce(name, value) {
      if (this._coerceFunc) {
        return this._coerceFunc(name, value);
      }

      return Reader.coerce(name, value);
    }
  }, {
    key: "_peekBytes",
    value: function _peekBytes(offset, length, loose) {
      var alignedLength = Math.ceil(length / this.wordSize) * this.wordSize;

      if (this._offset + alignedLength > this._data.length) {
        if (this.allowLoose && loose && this._offset + length <= this._data.length) {
          alignedLength = length;
        } else {
          logger.throwError("data out-of-bounds", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.BUFFER_OVERRUN, {
            length: this._data.length,
            offset: this._offset + alignedLength
          });
        }
      }

      return this._data.slice(this._offset, this._offset + alignedLength);
    }
  }, {
    key: "subReader",
    value: function subReader(offset) {
      return new Reader(this._data.slice(this._offset + offset), this.wordSize, this._coerceFunc, this.allowLoose);
    }
  }, {
    key: "readBytes",
    value: function readBytes(length, loose) {
      var bytes = this._peekBytes(0, length, !!loose);

      this._offset += bytes.length; // @TODO: Make sure the length..end bytes are all 0?

      return bytes.slice(0, length);
    }
  }, {
    key: "readValue",
    value: function readValue() {
      return _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(this.readBytes(this.wordSize));
    }
  }], [{
    key: "coerce",
    value: function coerce(name, value) {
      var match = name.match("^u?int([0-9]+)$");

      if (match && parseInt(match[1]) <= 48) {
        value = value.toNumber();
      }

      return value;
    }
  }]);

  return Reader;
}();

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/coders/address.js":
/*!*******************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/coders/address.js ***!
  \*******************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "AddressCoder": function() { return /* binding */ AddressCoder; }
/* harmony export */ });
/* harmony import */ var _ethersproject_address__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/address */ "./node_modules/@ethersproject/address/lib.esm/index.js");
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _abstract_coder__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./abstract-coder */ "./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }




var AddressCoder = /*#__PURE__*/function (_Coder) {
  _inherits(AddressCoder, _Coder);

  var _super = _createSuper(AddressCoder);

  function AddressCoder(localName) {
    _classCallCheck(this, AddressCoder);

    return _super.call(this, "address", "address", localName, false);
  }

  _createClass(AddressCoder, [{
    key: "defaultValue",
    value: function defaultValue() {
      return "0x0000000000000000000000000000000000000000";
    }
  }, {
    key: "encode",
    value: function encode(writer, value) {
      try {
        value = (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_0__.getAddress)(value);
      } catch (error) {
        this._throwError(error.message, value);
      }

      return writer.writeValue(value);
    }
  }, {
    key: "decode",
    value: function decode(reader) {
      return (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_0__.getAddress)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_1__.hexZeroPad)(reader.readValue().toHexString(), 20));
    }
  }]);

  return AddressCoder;
}(_abstract_coder__WEBPACK_IMPORTED_MODULE_2__.Coder);

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/coders/anonymous.js":
/*!*********************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/coders/anonymous.js ***!
  \*********************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "AnonymousCoder": function() { return /* binding */ AnonymousCoder; }
/* harmony export */ });
/* harmony import */ var _abstract_coder__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./abstract-coder */ "./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

 // Clones the functionality of an existing Coder, but without a localName

var AnonymousCoder = /*#__PURE__*/function (_Coder) {
  _inherits(AnonymousCoder, _Coder);

  var _super = _createSuper(AnonymousCoder);

  function AnonymousCoder(coder) {
    var _this;

    _classCallCheck(this, AnonymousCoder);

    _this = _super.call(this, coder.name, coder.type, undefined, coder.dynamic);
    _this.coder = coder;
    return _this;
  }

  _createClass(AnonymousCoder, [{
    key: "defaultValue",
    value: function defaultValue() {
      return this.coder.defaultValue();
    }
  }, {
    key: "encode",
    value: function encode(writer, value) {
      return this.coder.encode(writer, value);
    }
  }, {
    key: "decode",
    value: function decode(reader) {
      return this.coder.decode(reader);
    }
  }]);

  return AnonymousCoder;
}(_abstract_coder__WEBPACK_IMPORTED_MODULE_0__.Coder);

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/coders/array.js":
/*!*****************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/coders/array.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "pack": function() { return /* binding */ pack; },
/* harmony export */   "unpack": function() { return /* binding */ unpack; },
/* harmony export */   "ArrayCoder": function() { return /* binding */ ArrayCoder; }
/* harmony export */ });
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../_version */ "./node_modules/@ethersproject/abi/lib.esm/_version.js");
/* harmony import */ var _abstract_coder__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./abstract-coder */ "./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js");
/* harmony import */ var _anonymous__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./anonymous */ "./node_modules/@ethersproject/abi/lib.esm/coders/anonymous.js");


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }



var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);


function pack(writer, coders, values) {
  var arrayValues = null;

  if (Array.isArray(values)) {
    arrayValues = values;
  } else if (values && _typeof(values) === "object") {
    var unique = {};
    arrayValues = coders.map(function (coder) {
      var name = coder.localName;

      if (!name) {
        logger.throwError("cannot encode object for signature with missing names", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INVALID_ARGUMENT, {
          argument: "values",
          coder: coder,
          value: values
        });
      }

      if (unique[name]) {
        logger.throwError("cannot encode object for signature with duplicate names", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INVALID_ARGUMENT, {
          argument: "values",
          coder: coder,
          value: values
        });
      }

      unique[name] = true;
      return values[name];
    });
  } else {
    logger.throwArgumentError("invalid tuple value", "tuple", values);
  }

  if (coders.length !== arrayValues.length) {
    logger.throwArgumentError("types/value length mismatch", "tuple", values);
  }

  var staticWriter = new _abstract_coder__WEBPACK_IMPORTED_MODULE_2__.Writer(writer.wordSize);
  var dynamicWriter = new _abstract_coder__WEBPACK_IMPORTED_MODULE_2__.Writer(writer.wordSize);
  var updateFuncs = [];
  coders.forEach(function (coder, index) {
    var value = arrayValues[index];

    if (coder.dynamic) {
      // Get current dynamic offset (for the future pointer)
      var dynamicOffset = dynamicWriter.length; // Encode the dynamic value into the dynamicWriter

      coder.encode(dynamicWriter, value); // Prepare to populate the correct offset once we are done

      var updateFunc = staticWriter.writeUpdatableValue();
      updateFuncs.push(function (baseOffset) {
        updateFunc(baseOffset + dynamicOffset);
      });
    } else {
      coder.encode(staticWriter, value);
    }
  }); // Backfill all the dynamic offsets, now that we know the static length

  updateFuncs.forEach(function (func) {
    func(staticWriter.length);
  });
  var length = writer.appendWriter(staticWriter);
  length += writer.appendWriter(dynamicWriter);
  return length;
}
function unpack(reader, coders) {
  var values = []; // A reader anchored to this base

  var baseReader = reader.subReader(0);
  coders.forEach(function (coder) {
    var value = null;

    if (coder.dynamic) {
      var offset = reader.readValue();
      var offsetReader = baseReader.subReader(offset.toNumber());

      try {
        value = coder.decode(offsetReader);
      } catch (error) {
        // Cannot recover from this
        if (error.code === _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.BUFFER_OVERRUN) {
          throw error;
        }

        value = error;
        value.baseType = coder.name;
        value.name = coder.localName;
        value.type = coder.type;
      }
    } else {
      try {
        value = coder.decode(reader);
      } catch (error) {
        // Cannot recover from this
        if (error.code === _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.BUFFER_OVERRUN) {
          throw error;
        }

        value = error;
        value.baseType = coder.name;
        value.name = coder.localName;
        value.type = coder.type;
      }
    }

    if (value != undefined) {
      values.push(value);
    }
  }); // We only output named properties for uniquely named coders

  var uniqueNames = coders.reduce(function (accum, coder) {
    var name = coder.localName;

    if (name) {
      if (!accum[name]) {
        accum[name] = 0;
      }

      accum[name]++;
    }

    return accum;
  }, {}); // Add any named parameters (i.e. tuples)

  coders.forEach(function (coder, index) {
    var name = coder.localName;

    if (!name || uniqueNames[name] !== 1) {
      return;
    }

    if (name === "length") {
      name = "_length";
    }

    if (values[name] != null) {
      return;
    }

    var value = values[index];

    if (value instanceof Error) {
      Object.defineProperty(values, name, {
        enumerable: true,
        get: function get() {
          throw value;
        }
      });
    } else {
      values[name] = value;
    }
  });

  var _loop = function _loop(i) {
    var value = values[i];

    if (value instanceof Error) {
      Object.defineProperty(values, i, {
        enumerable: true,
        get: function get() {
          throw value;
        }
      });
    }
  };

  for (var i = 0; i < values.length; i++) {
    _loop(i);
  }

  return Object.freeze(values);
}
var ArrayCoder = /*#__PURE__*/function (_Coder) {
  _inherits(ArrayCoder, _Coder);

  var _super = _createSuper(ArrayCoder);

  function ArrayCoder(coder, length, localName) {
    var _this;

    _classCallCheck(this, ArrayCoder);

    var type = coder.type + "[" + (length >= 0 ? length : "") + "]";
    var dynamic = length === -1 || coder.dynamic;
    _this = _super.call(this, "array", type, localName, dynamic);
    _this.coder = coder;
    _this.length = length;
    return _this;
  }

  _createClass(ArrayCoder, [{
    key: "defaultValue",
    value: function defaultValue() {
      // Verifies the child coder is valid (even if the array is dynamic or 0-length)
      var defaultChild = this.coder.defaultValue();
      var result = [];

      for (var i = 0; i < this.length; i++) {
        result.push(defaultChild);
      }

      return result;
    }
  }, {
    key: "encode",
    value: function encode(writer, value) {
      if (!Array.isArray(value)) {
        this._throwError("expected array value", value);
      }

      var count = this.length;

      if (count === -1) {
        count = value.length;
        writer.writeValue(value.length);
      }

      logger.checkArgumentCount(value.length, count, "coder array" + (this.localName ? " " + this.localName : ""));
      var coders = [];

      for (var i = 0; i < value.length; i++) {
        coders.push(this.coder);
      }

      return pack(writer, coders, value);
    }
  }, {
    key: "decode",
    value: function decode(reader) {
      var count = this.length;

      if (count === -1) {
        count = reader.readValue().toNumber(); // Check that there is *roughly* enough data to ensure
        // stray random data is not being read as a length. Each
        // slot requires at least 32 bytes for their value (or 32
        // bytes as a link to the data). This could use a much
        // tighter bound, but we are erroring on the side of safety.

        if (count * 32 > reader._data.length) {
          logger.throwError("insufficient data length", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.BUFFER_OVERRUN, {
            length: reader._data.length,
            count: count
          });
        }
      }

      var coders = [];

      for (var i = 0; i < count; i++) {
        coders.push(new _anonymous__WEBPACK_IMPORTED_MODULE_3__.AnonymousCoder(this.coder));
      }

      return reader.coerce(this.name, unpack(reader, coders));
    }
  }]);

  return ArrayCoder;
}(_abstract_coder__WEBPACK_IMPORTED_MODULE_2__.Coder);

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/coders/boolean.js":
/*!*******************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/coders/boolean.js ***!
  \*******************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "BooleanCoder": function() { return /* binding */ BooleanCoder; }
/* harmony export */ });
/* harmony import */ var _abstract_coder__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./abstract-coder */ "./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }


var BooleanCoder = /*#__PURE__*/function (_Coder) {
  _inherits(BooleanCoder, _Coder);

  var _super = _createSuper(BooleanCoder);

  function BooleanCoder(localName) {
    _classCallCheck(this, BooleanCoder);

    return _super.call(this, "bool", "bool", localName, false);
  }

  _createClass(BooleanCoder, [{
    key: "defaultValue",
    value: function defaultValue() {
      return false;
    }
  }, {
    key: "encode",
    value: function encode(writer, value) {
      return writer.writeValue(value ? 1 : 0);
    }
  }, {
    key: "decode",
    value: function decode(reader) {
      return reader.coerce(this.type, !reader.readValue().isZero());
    }
  }]);

  return BooleanCoder;
}(_abstract_coder__WEBPACK_IMPORTED_MODULE_0__.Coder);

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/coders/bytes.js":
/*!*****************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/coders/bytes.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "DynamicBytesCoder": function() { return /* binding */ DynamicBytesCoder; },
/* harmony export */   "BytesCoder": function() { return /* binding */ BytesCoder; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _abstract_coder__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./abstract-coder */ "./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }



var DynamicBytesCoder = /*#__PURE__*/function (_Coder) {
  _inherits(DynamicBytesCoder, _Coder);

  var _super = _createSuper(DynamicBytesCoder);

  function DynamicBytesCoder(type, localName) {
    _classCallCheck(this, DynamicBytesCoder);

    return _super.call(this, type, type, localName, true);
  }

  _createClass(DynamicBytesCoder, [{
    key: "defaultValue",
    value: function defaultValue() {
      return "0x";
    }
  }, {
    key: "encode",
    value: function encode(writer, value) {
      value = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_0__.arrayify)(value);
      var length = writer.writeValue(value.length);
      length += writer.writeBytes(value);
      return length;
    }
  }, {
    key: "decode",
    value: function decode(reader) {
      return reader.readBytes(reader.readValue().toNumber(), true);
    }
  }]);

  return DynamicBytesCoder;
}(_abstract_coder__WEBPACK_IMPORTED_MODULE_1__.Coder);
var BytesCoder = /*#__PURE__*/function (_DynamicBytesCoder) {
  _inherits(BytesCoder, _DynamicBytesCoder);

  var _super2 = _createSuper(BytesCoder);

  function BytesCoder(localName) {
    _classCallCheck(this, BytesCoder);

    return _super2.call(this, "bytes", localName);
  }

  _createClass(BytesCoder, [{
    key: "decode",
    value: function decode(reader) {
      return reader.coerce(this.name, (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_0__.hexlify)(_get(_getPrototypeOf(BytesCoder.prototype), "decode", this).call(this, reader)));
    }
  }]);

  return BytesCoder;
}(DynamicBytesCoder);

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/coders/fixed-bytes.js":
/*!***********************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/coders/fixed-bytes.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "FixedBytesCoder": function() { return /* binding */ FixedBytesCoder; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _abstract_coder__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./abstract-coder */ "./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }


 // @TODO: Merge this with bytes

var FixedBytesCoder = /*#__PURE__*/function (_Coder) {
  _inherits(FixedBytesCoder, _Coder);

  var _super = _createSuper(FixedBytesCoder);

  function FixedBytesCoder(size, localName) {
    var _this;

    _classCallCheck(this, FixedBytesCoder);

    var name = "bytes" + String(size);
    _this = _super.call(this, name, name, localName, false);
    _this.size = size;
    return _this;
  }

  _createClass(FixedBytesCoder, [{
    key: "defaultValue",
    value: function defaultValue() {
      return "0x0000000000000000000000000000000000000000000000000000000000000000".substring(0, 2 + this.size * 2);
    }
  }, {
    key: "encode",
    value: function encode(writer, value) {
      var data = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_0__.arrayify)(value);

      if (data.length !== this.size) {
        this._throwError("incorrect data length", value);
      }

      return writer.writeBytes(data);
    }
  }, {
    key: "decode",
    value: function decode(reader) {
      return reader.coerce(this.name, (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_0__.hexlify)(reader.readBytes(this.size)));
    }
  }]);

  return FixedBytesCoder;
}(_abstract_coder__WEBPACK_IMPORTED_MODULE_1__.Coder);

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/coders/null.js":
/*!****************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/coders/null.js ***!
  \****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "NullCoder": function() { return /* binding */ NullCoder; }
/* harmony export */ });
/* harmony import */ var _abstract_coder__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./abstract-coder */ "./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }


var NullCoder = /*#__PURE__*/function (_Coder) {
  _inherits(NullCoder, _Coder);

  var _super = _createSuper(NullCoder);

  function NullCoder(localName) {
    _classCallCheck(this, NullCoder);

    return _super.call(this, "null", "", localName, false);
  }

  _createClass(NullCoder, [{
    key: "defaultValue",
    value: function defaultValue() {
      return null;
    }
  }, {
    key: "encode",
    value: function encode(writer, value) {
      if (value != null) {
        this._throwError("not null", value);
      }

      return writer.writeBytes([]);
    }
  }, {
    key: "decode",
    value: function decode(reader) {
      reader.readBytes(0);
      return reader.coerce(this.name, null);
    }
  }]);

  return NullCoder;
}(_abstract_coder__WEBPACK_IMPORTED_MODULE_0__.Coder);

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/coders/number.js":
/*!******************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/coders/number.js ***!
  \******************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "NumberCoder": function() { return /* binding */ NumberCoder; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_constants__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @ethersproject/constants */ "./node_modules/@ethersproject/constants/lib.esm/bignumbers.js");
/* harmony import */ var _abstract_coder__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./abstract-coder */ "./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }




var NumberCoder = /*#__PURE__*/function (_Coder) {
  _inherits(NumberCoder, _Coder);

  var _super = _createSuper(NumberCoder);

  function NumberCoder(size, signed, localName) {
    var _this;

    _classCallCheck(this, NumberCoder);

    var name = (signed ? "int" : "uint") + size * 8;
    _this = _super.call(this, name, name, localName, false);
    _this.size = size;
    _this.signed = signed;
    return _this;
  }

  _createClass(NumberCoder, [{
    key: "defaultValue",
    value: function defaultValue() {
      return 0;
    }
  }, {
    key: "encode",
    value: function encode(writer, value) {
      var v = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_0__.BigNumber.from(value); // Check bounds are safe for encoding

      var maxUintValue = _ethersproject_constants__WEBPACK_IMPORTED_MODULE_1__.MaxUint256.mask(writer.wordSize * 8);

      if (this.signed) {
        var bounds = maxUintValue.mask(this.size * 8 - 1);

        if (v.gt(bounds) || v.lt(bounds.add(_ethersproject_constants__WEBPACK_IMPORTED_MODULE_1__.One).mul(_ethersproject_constants__WEBPACK_IMPORTED_MODULE_1__.NegativeOne))) {
          this._throwError("value out-of-bounds", value);
        }
      } else if (v.lt(_ethersproject_constants__WEBPACK_IMPORTED_MODULE_1__.Zero) || v.gt(maxUintValue.mask(this.size * 8))) {
        this._throwError("value out-of-bounds", value);
      }

      v = v.toTwos(this.size * 8).mask(this.size * 8);

      if (this.signed) {
        v = v.fromTwos(this.size * 8).toTwos(8 * writer.wordSize);
      }

      return writer.writeValue(v);
    }
  }, {
    key: "decode",
    value: function decode(reader) {
      var value = reader.readValue().mask(this.size * 8);

      if (this.signed) {
        value = value.fromTwos(this.size * 8);
      }

      return reader.coerce(this.name, value);
    }
  }]);

  return NumberCoder;
}(_abstract_coder__WEBPACK_IMPORTED_MODULE_2__.Coder);

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/coders/string.js":
/*!******************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/coders/string.js ***!
  \******************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "StringCoder": function() { return /* binding */ StringCoder; }
/* harmony export */ });
/* harmony import */ var _ethersproject_strings__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/strings */ "./node_modules/@ethersproject/strings/lib.esm/utf8.js");
/* harmony import */ var _bytes__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./bytes */ "./node_modules/@ethersproject/abi/lib.esm/coders/bytes.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }



var StringCoder = /*#__PURE__*/function (_DynamicBytesCoder) {
  _inherits(StringCoder, _DynamicBytesCoder);

  var _super = _createSuper(StringCoder);

  function StringCoder(localName) {
    _classCallCheck(this, StringCoder);

    return _super.call(this, "string", localName);
  }

  _createClass(StringCoder, [{
    key: "defaultValue",
    value: function defaultValue() {
      return "";
    }
  }, {
    key: "encode",
    value: function encode(writer, value) {
      return _get(_getPrototypeOf(StringCoder.prototype), "encode", this).call(this, writer, (0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_0__.toUtf8Bytes)(value));
    }
  }, {
    key: "decode",
    value: function decode(reader) {
      return (0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_0__.toUtf8String)(_get(_getPrototypeOf(StringCoder.prototype), "decode", this).call(this, reader));
    }
  }]);

  return StringCoder;
}(_bytes__WEBPACK_IMPORTED_MODULE_1__.DynamicBytesCoder);

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/coders/tuple.js":
/*!*****************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/coders/tuple.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "TupleCoder": function() { return /* binding */ TupleCoder; }
/* harmony export */ });
/* harmony import */ var _abstract_coder__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./abstract-coder */ "./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js");
/* harmony import */ var _array__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./array */ "./node_modules/@ethersproject/abi/lib.esm/coders/array.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }



var TupleCoder = /*#__PURE__*/function (_Coder) {
  _inherits(TupleCoder, _Coder);

  var _super = _createSuper(TupleCoder);

  function TupleCoder(coders, localName) {
    var _this;

    _classCallCheck(this, TupleCoder);

    var dynamic = false;
    var types = [];
    coders.forEach(function (coder) {
      if (coder.dynamic) {
        dynamic = true;
      }

      types.push(coder.type);
    });
    var type = "tuple(" + types.join(",") + ")";
    _this = _super.call(this, "tuple", type, localName, dynamic);
    _this.coders = coders;
    return _this;
  }

  _createClass(TupleCoder, [{
    key: "defaultValue",
    value: function defaultValue() {
      var values = [];
      this.coders.forEach(function (coder) {
        values.push(coder.defaultValue());
      }); // We only output named properties for uniquely named coders

      var uniqueNames = this.coders.reduce(function (accum, coder) {
        var name = coder.localName;

        if (name) {
          if (!accum[name]) {
            accum[name] = 0;
          }

          accum[name]++;
        }

        return accum;
      }, {}); // Add named values

      this.coders.forEach(function (coder, index) {
        var name = coder.localName;

        if (!name || uniqueNames[name] !== 1) {
          return;
        }

        if (name === "length") {
          name = "_length";
        }

        if (values[name] != null) {
          return;
        }

        values[name] = values[index];
      });
      return Object.freeze(values);
    }
  }, {
    key: "encode",
    value: function encode(writer, value) {
      return (0,_array__WEBPACK_IMPORTED_MODULE_0__.pack)(writer, this.coders, value);
    }
  }, {
    key: "decode",
    value: function decode(reader) {
      return reader.coerce(this.name, (0,_array__WEBPACK_IMPORTED_MODULE_0__.unpack)(reader, this.coders));
    }
  }]);

  return TupleCoder;
}(_abstract_coder__WEBPACK_IMPORTED_MODULE_1__.Coder);

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/fragments.js":
/*!**************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/fragments.js ***!
  \**************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "FormatTypes": function() { return /* binding */ FormatTypes; },
/* harmony export */   "ParamType": function() { return /* binding */ ParamType; },
/* harmony export */   "Fragment": function() { return /* binding */ Fragment; },
/* harmony export */   "EventFragment": function() { return /* binding */ EventFragment; },
/* harmony export */   "ConstructorFragment": function() { return /* binding */ ConstructorFragment; },
/* harmony export */   "FunctionFragment": function() { return /* binding */ FunctionFragment; },
/* harmony export */   "ErrorFragment": function() { return /* binding */ ErrorFragment; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/abi/lib.esm/_version.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }





var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
;
var _constructorGuard = {};
var ModifiersBytes = {
  calldata: true,
  memory: true,
  storage: true
};
var ModifiersNest = {
  calldata: true,
  memory: true
};

function checkModifier(type, name) {
  if (type === "bytes" || type === "string") {
    if (ModifiersBytes[name]) {
      return true;
    }
  } else if (type === "address") {
    if (name === "payable") {
      return true;
    }
  } else if (type.indexOf("[") >= 0 || type === "tuple") {
    if (ModifiersNest[name]) {
      return true;
    }
  }

  if (ModifiersBytes[name] || name === "payable") {
    logger.throwArgumentError("invalid modifier", "name", name);
  }

  return false;
} // @TODO: Make sure that children of an indexed tuple are marked with a null indexed


function parseParamType(param, allowIndexed) {
  var originalParam = param;

  function throwError(i) {
    logger.throwArgumentError("unexpected character at position ".concat(i), "param", param);
  }

  param = param.replace(/\s/g, " ");

  function newNode(parent) {
    var node = {
      type: "",
      name: "",
      parent: parent,
      state: {
        allowType: true
      }
    };

    if (allowIndexed) {
      node.indexed = false;
    }

    return node;
  }

  var parent = {
    type: "",
    name: "",
    state: {
      allowType: true
    }
  };
  var node = parent;

  for (var i = 0; i < param.length; i++) {
    var c = param[i];

    switch (c) {
      case "(":
        if (node.state.allowType && node.type === "") {
          node.type = "tuple";
        } else if (!node.state.allowParams) {
          throwError(i);
        }

        node.state.allowType = false;
        node.type = verifyType(node.type);
        node.components = [newNode(node)];
        node = node.components[0];
        break;

      case ")":
        delete node.state;

        if (node.name === "indexed") {
          if (!allowIndexed) {
            throwError(i);
          }

          node.indexed = true;
          node.name = "";
        }

        if (checkModifier(node.type, node.name)) {
          node.name = "";
        }

        node.type = verifyType(node.type);
        var child = node;
        node = node.parent;

        if (!node) {
          throwError(i);
        }

        delete child.parent;
        node.state.allowParams = false;
        node.state.allowName = true;
        node.state.allowArray = true;
        break;

      case ",":
        delete node.state;

        if (node.name === "indexed") {
          if (!allowIndexed) {
            throwError(i);
          }

          node.indexed = true;
          node.name = "";
        }

        if (checkModifier(node.type, node.name)) {
          node.name = "";
        }

        node.type = verifyType(node.type);
        var sibling = newNode(node.parent); //{ type: "", name: "", parent: node.parent, state: { allowType: true } };

        node.parent.components.push(sibling);
        delete node.parent;
        node = sibling;
        break;
      // Hit a space...

      case " ":
        // If reading type, the type is done and may read a param or name
        if (node.state.allowType) {
          if (node.type !== "") {
            node.type = verifyType(node.type);
            delete node.state.allowType;
            node.state.allowName = true;
            node.state.allowParams = true;
          }
        } // If reading name, the name is done


        if (node.state.allowName) {
          if (node.name !== "") {
            if (node.name === "indexed") {
              if (!allowIndexed) {
                throwError(i);
              }

              if (node.indexed) {
                throwError(i);
              }

              node.indexed = true;
              node.name = "";
            } else if (checkModifier(node.type, node.name)) {
              node.name = "";
            } else {
              node.state.allowName = false;
            }
          }
        }

        break;

      case "[":
        if (!node.state.allowArray) {
          throwError(i);
        }

        node.type += c;
        node.state.allowArray = false;
        node.state.allowName = false;
        node.state.readArray = true;
        break;

      case "]":
        if (!node.state.readArray) {
          throwError(i);
        }

        node.type += c;
        node.state.readArray = false;
        node.state.allowArray = true;
        node.state.allowName = true;
        break;

      default:
        if (node.state.allowType) {
          node.type += c;
          node.state.allowParams = true;
          node.state.allowArray = true;
        } else if (node.state.allowName) {
          node.name += c;
          delete node.state.allowArray;
        } else if (node.state.readArray) {
          node.type += c;
        } else {
          throwError(i);
        }

    }
  }

  if (node.parent) {
    logger.throwArgumentError("unexpected eof", "param", param);
  }

  delete parent.state;

  if (node.name === "indexed") {
    if (!allowIndexed) {
      throwError(originalParam.length - 7);
    }

    if (node.indexed) {
      throwError(originalParam.length - 7);
    }

    node.indexed = true;
    node.name = "";
  } else if (checkModifier(node.type, node.name)) {
    node.name = "";
  }

  parent.type = verifyType(parent.type);
  return parent;
}

function populate(object, params) {
  for (var key in params) {
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(object, key, params[key]);
  }
}

var FormatTypes = Object.freeze({
  // Bare formatting, as is needed for computing a sighash of an event or function
  sighash: "sighash",
  // Human-Readable with Minimal spacing and without names (compact human-readable)
  minimal: "minimal",
  // Human-Readable with nice spacing, including all names
  full: "full",
  // JSON-format a la Solidity
  json: "json"
});
var paramTypeArray = new RegExp(/^(.*)\[([0-9]*)\]$/);
var ParamType = /*#__PURE__*/function () {
  function ParamType(constructorGuard, params) {
    _classCallCheck(this, ParamType);

    if (constructorGuard !== _constructorGuard) {
      logger.throwError("use fromString", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
        operation: "new ParamType()"
      });
    }

    populate(this, params);
    var match = this.type.match(paramTypeArray);

    if (match) {
      populate(this, {
        arrayLength: parseInt(match[2] || "-1"),
        arrayChildren: ParamType.fromObject({
          type: match[1],
          components: this.components
        }),
        baseType: "array"
      });
    } else {
      populate(this, {
        arrayLength: null,
        arrayChildren: null,
        baseType: this.components != null ? "tuple" : this.type
      });
    }

    this._isParamType = true;
    Object.freeze(this);
  } // Format the parameter fragment
  //   - sighash: "(uint256,address)"
  //   - minimal: "tuple(uint256,address) indexed"
  //   - full:    "tuple(uint256 foo, address bar) indexed baz"


  _createClass(ParamType, [{
    key: "format",
    value: function format(_format) {
      if (!_format) {
        _format = FormatTypes.sighash;
      }

      if (!FormatTypes[_format]) {
        logger.throwArgumentError("invalid format type", "format", _format);
      }

      if (_format === FormatTypes.json) {
        var _result = {
          type: this.baseType === "tuple" ? "tuple" : this.type,
          name: this.name || undefined
        };

        if (typeof this.indexed === "boolean") {
          _result.indexed = this.indexed;
        }

        if (this.components) {
          _result.components = this.components.map(function (comp) {
            return JSON.parse(comp.format(_format));
          });
        }

        return JSON.stringify(_result);
      }

      var result = ""; // Array

      if (this.baseType === "array") {
        result += this.arrayChildren.format(_format);
        result += "[" + (this.arrayLength < 0 ? "" : String(this.arrayLength)) + "]";
      } else {
        if (this.baseType === "tuple") {
          if (_format !== FormatTypes.sighash) {
            result += this.type;
          }

          result += "(" + this.components.map(function (comp) {
            return comp.format(_format);
          }).join(_format === FormatTypes.full ? ", " : ",") + ")";
        } else {
          result += this.type;
        }
      }

      if (_format !== FormatTypes.sighash) {
        if (this.indexed === true) {
          result += " indexed";
        }

        if (_format === FormatTypes.full && this.name) {
          result += " " + this.name;
        }
      }

      return result;
    }
  }], [{
    key: "from",
    value: function from(value, allowIndexed) {
      if (typeof value === "string") {
        return ParamType.fromString(value, allowIndexed);
      }

      return ParamType.fromObject(value);
    }
  }, {
    key: "fromObject",
    value: function fromObject(value) {
      if (ParamType.isParamType(value)) {
        return value;
      }

      return new ParamType(_constructorGuard, {
        name: value.name || null,
        type: verifyType(value.type),
        indexed: value.indexed == null ? null : !!value.indexed,
        components: value.components ? value.components.map(ParamType.fromObject) : null
      });
    }
  }, {
    key: "fromString",
    value: function fromString(value, allowIndexed) {
      function ParamTypify(node) {
        return ParamType.fromObject({
          name: node.name,
          type: node.type,
          indexed: node.indexed,
          components: node.components
        });
      }

      return ParamTypify(parseParamType(value, !!allowIndexed));
    }
  }, {
    key: "isParamType",
    value: function isParamType(value) {
      return !!(value != null && value._isParamType);
    }
  }]);

  return ParamType;
}();
;

function parseParams(value, allowIndex) {
  return splitNesting(value).map(function (param) {
    return ParamType.fromString(param, allowIndex);
  });
}

var Fragment = /*#__PURE__*/function () {
  function Fragment(constructorGuard, params) {
    _classCallCheck(this, Fragment);

    if (constructorGuard !== _constructorGuard) {
      logger.throwError("use a static from method", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
        operation: "new Fragment()"
      });
    }

    populate(this, params);
    this._isFragment = true;
    Object.freeze(this);
  }

  _createClass(Fragment, null, [{
    key: "from",
    value: function from(value) {
      if (Fragment.isFragment(value)) {
        return value;
      }

      if (typeof value === "string") {
        return Fragment.fromString(value);
      }

      return Fragment.fromObject(value);
    }
  }, {
    key: "fromObject",
    value: function fromObject(value) {
      if (Fragment.isFragment(value)) {
        return value;
      }

      switch (value.type) {
        case "function":
          return FunctionFragment.fromObject(value);

        case "event":
          return EventFragment.fromObject(value);

        case "constructor":
          return ConstructorFragment.fromObject(value);

        case "error":
          return ErrorFragment.fromObject(value);

        case "fallback":
        case "receive":
          // @TODO: Something? Maybe return a FunctionFragment? A custom DefaultFunctionFragment?
          return null;
      }

      return logger.throwArgumentError("invalid fragment object", "value", value);
    }
  }, {
    key: "fromString",
    value: function fromString(value) {
      // Make sure the "returns" is surrounded by a space and all whitespace is exactly one space
      value = value.replace(/\s/g, " ");
      value = value.replace(/\(/g, " (").replace(/\)/g, ") ").replace(/\s+/g, " ");
      value = value.trim();

      if (value.split(" ")[0] === "event") {
        return EventFragment.fromString(value.substring(5).trim());
      } else if (value.split(" ")[0] === "function") {
        return FunctionFragment.fromString(value.substring(8).trim());
      } else if (value.split("(")[0].trim() === "constructor") {
        return ConstructorFragment.fromString(value.trim());
      } else if (value.split(" ")[0] === "error") {
        return ErrorFragment.fromString(value.substring(5).trim());
      }

      return logger.throwArgumentError("unsupported fragment", "value", value);
    }
  }, {
    key: "isFragment",
    value: function isFragment(value) {
      return !!(value && value._isFragment);
    }
  }]);

  return Fragment;
}();
var EventFragment = /*#__PURE__*/function (_Fragment) {
  _inherits(EventFragment, _Fragment);

  var _super = _createSuper(EventFragment);

  function EventFragment() {
    _classCallCheck(this, EventFragment);

    return _super.apply(this, arguments);
  }

  _createClass(EventFragment, [{
    key: "format",
    value: function format(_format2) {
      if (!_format2) {
        _format2 = FormatTypes.sighash;
      }

      if (!FormatTypes[_format2]) {
        logger.throwArgumentError("invalid format type", "format", _format2);
      }

      if (_format2 === FormatTypes.json) {
        return JSON.stringify({
          type: "event",
          anonymous: this.anonymous,
          name: this.name,
          inputs: this.inputs.map(function (input) {
            return JSON.parse(input.format(_format2));
          })
        });
      }

      var result = "";

      if (_format2 !== FormatTypes.sighash) {
        result += "event ";
      }

      result += this.name + "(" + this.inputs.map(function (input) {
        return input.format(_format2);
      }).join(_format2 === FormatTypes.full ? ", " : ",") + ") ";

      if (_format2 !== FormatTypes.sighash) {
        if (this.anonymous) {
          result += "anonymous ";
        }
      }

      return result.trim();
    }
  }], [{
    key: "from",
    value: function from(value) {
      if (typeof value === "string") {
        return EventFragment.fromString(value);
      }

      return EventFragment.fromObject(value);
    }
  }, {
    key: "fromObject",
    value: function fromObject(value) {
      if (EventFragment.isEventFragment(value)) {
        return value;
      }

      if (value.type !== "event") {
        logger.throwArgumentError("invalid event object", "value", value);
      }

      var params = {
        name: verifyIdentifier(value.name),
        anonymous: value.anonymous,
        inputs: value.inputs ? value.inputs.map(ParamType.fromObject) : [],
        type: "event"
      };
      return new EventFragment(_constructorGuard, params);
    }
  }, {
    key: "fromString",
    value: function fromString(value) {
      var match = value.match(regexParen);

      if (!match) {
        logger.throwArgumentError("invalid event string", "value", value);
      }

      var anonymous = false;
      match[3].split(" ").forEach(function (modifier) {
        switch (modifier.trim()) {
          case "anonymous":
            anonymous = true;
            break;

          case "":
            break;

          default:
            logger.warn("unknown modifier: " + modifier);
        }
      });
      return EventFragment.fromObject({
        name: match[1].trim(),
        anonymous: anonymous,
        inputs: parseParams(match[2], true),
        type: "event"
      });
    }
  }, {
    key: "isEventFragment",
    value: function isEventFragment(value) {
      return value && value._isFragment && value.type === "event";
    }
  }]);

  return EventFragment;
}(Fragment);

function parseGas(value, params) {
  params.gas = null;
  var comps = value.split("@");

  if (comps.length !== 1) {
    if (comps.length > 2) {
      logger.throwArgumentError("invalid human-readable ABI signature", "value", value);
    }

    if (!comps[1].match(/^[0-9]+$/)) {
      logger.throwArgumentError("invalid human-readable ABI signature gas", "value", value);
    }

    params.gas = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_3__.BigNumber.from(comps[1]);
    return comps[0];
  }

  return value;
}

function parseModifiers(value, params) {
  params.constant = false;
  params.payable = false;
  params.stateMutability = "nonpayable";
  value.split(" ").forEach(function (modifier) {
    switch (modifier.trim()) {
      case "constant":
        params.constant = true;
        break;

      case "payable":
        params.payable = true;
        params.stateMutability = "payable";
        break;

      case "nonpayable":
        params.payable = false;
        params.stateMutability = "nonpayable";
        break;

      case "pure":
        params.constant = true;
        params.stateMutability = "pure";
        break;

      case "view":
        params.constant = true;
        params.stateMutability = "view";
        break;

      case "external":
      case "public":
      case "":
        break;

      default:
        console.log("unknown modifier: " + modifier);
    }
  });
}

function verifyState(value) {
  var result = {
    constant: false,
    payable: true,
    stateMutability: "payable"
  };

  if (value.stateMutability != null) {
    result.stateMutability = value.stateMutability; // Set (and check things are consistent) the constant property

    result.constant = result.stateMutability === "view" || result.stateMutability === "pure";

    if (value.constant != null) {
      if (!!value.constant !== result.constant) {
        logger.throwArgumentError("cannot have constant function with mutability " + result.stateMutability, "value", value);
      }
    } // Set (and check things are consistent) the payable property


    result.payable = result.stateMutability === "payable";

    if (value.payable != null) {
      if (!!value.payable !== result.payable) {
        logger.throwArgumentError("cannot have payable function with mutability " + result.stateMutability, "value", value);
      }
    }
  } else if (value.payable != null) {
    result.payable = !!value.payable; // If payable we can assume non-constant; otherwise we can't assume

    if (value.constant == null && !result.payable && value.type !== "constructor") {
      logger.throwArgumentError("unable to determine stateMutability", "value", value);
    }

    result.constant = !!value.constant;

    if (result.constant) {
      result.stateMutability = "view";
    } else {
      result.stateMutability = result.payable ? "payable" : "nonpayable";
    }

    if (result.payable && result.constant) {
      logger.throwArgumentError("cannot have constant payable function", "value", value);
    }
  } else if (value.constant != null) {
    result.constant = !!value.constant;
    result.payable = !result.constant;
    result.stateMutability = result.constant ? "view" : "payable";
  } else if (value.type !== "constructor") {
    logger.throwArgumentError("unable to determine stateMutability", "value", value);
  }

  return result;
}

var ConstructorFragment = /*#__PURE__*/function (_Fragment2) {
  _inherits(ConstructorFragment, _Fragment2);

  var _super2 = _createSuper(ConstructorFragment);

  function ConstructorFragment() {
    _classCallCheck(this, ConstructorFragment);

    return _super2.apply(this, arguments);
  }

  _createClass(ConstructorFragment, [{
    key: "format",
    value: function format(_format3) {
      if (!_format3) {
        _format3 = FormatTypes.sighash;
      }

      if (!FormatTypes[_format3]) {
        logger.throwArgumentError("invalid format type", "format", _format3);
      }

      if (_format3 === FormatTypes.json) {
        return JSON.stringify({
          type: "constructor",
          stateMutability: this.stateMutability !== "nonpayable" ? this.stateMutability : undefined,
          payable: this.payable,
          gas: this.gas ? this.gas.toNumber() : undefined,
          inputs: this.inputs.map(function (input) {
            return JSON.parse(input.format(_format3));
          })
        });
      }

      if (_format3 === FormatTypes.sighash) {
        logger.throwError("cannot format a constructor for sighash", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
          operation: "format(sighash)"
        });
      }

      var result = "constructor(" + this.inputs.map(function (input) {
        return input.format(_format3);
      }).join(_format3 === FormatTypes.full ? ", " : ",") + ") ";

      if (this.stateMutability && this.stateMutability !== "nonpayable") {
        result += this.stateMutability + " ";
      }

      return result.trim();
    }
  }], [{
    key: "from",
    value: function from(value) {
      if (typeof value === "string") {
        return ConstructorFragment.fromString(value);
      }

      return ConstructorFragment.fromObject(value);
    }
  }, {
    key: "fromObject",
    value: function fromObject(value) {
      if (ConstructorFragment.isConstructorFragment(value)) {
        return value;
      }

      if (value.type !== "constructor") {
        logger.throwArgumentError("invalid constructor object", "value", value);
      }

      var state = verifyState(value);

      if (state.constant) {
        logger.throwArgumentError("constructor cannot be constant", "value", value);
      }

      var params = {
        name: null,
        type: value.type,
        inputs: value.inputs ? value.inputs.map(ParamType.fromObject) : [],
        payable: state.payable,
        stateMutability: state.stateMutability,
        gas: value.gas ? _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_3__.BigNumber.from(value.gas) : null
      };
      return new ConstructorFragment(_constructorGuard, params);
    }
  }, {
    key: "fromString",
    value: function fromString(value) {
      var params = {
        type: "constructor"
      };
      value = parseGas(value, params);
      var parens = value.match(regexParen);

      if (!parens || parens[1].trim() !== "constructor") {
        logger.throwArgumentError("invalid constructor string", "value", value);
      }

      params.inputs = parseParams(parens[2].trim(), false);
      parseModifiers(parens[3].trim(), params);
      return ConstructorFragment.fromObject(params);
    }
  }, {
    key: "isConstructorFragment",
    value: function isConstructorFragment(value) {
      return value && value._isFragment && value.type === "constructor";
    }
  }]);

  return ConstructorFragment;
}(Fragment);
var FunctionFragment = /*#__PURE__*/function (_ConstructorFragment) {
  _inherits(FunctionFragment, _ConstructorFragment);

  var _super3 = _createSuper(FunctionFragment);

  function FunctionFragment() {
    _classCallCheck(this, FunctionFragment);

    return _super3.apply(this, arguments);
  }

  _createClass(FunctionFragment, [{
    key: "format",
    value: function format(_format4) {
      if (!_format4) {
        _format4 = FormatTypes.sighash;
      }

      if (!FormatTypes[_format4]) {
        logger.throwArgumentError("invalid format type", "format", _format4);
      }

      if (_format4 === FormatTypes.json) {
        return JSON.stringify({
          type: "function",
          name: this.name,
          constant: this.constant,
          stateMutability: this.stateMutability !== "nonpayable" ? this.stateMutability : undefined,
          payable: this.payable,
          gas: this.gas ? this.gas.toNumber() : undefined,
          inputs: this.inputs.map(function (input) {
            return JSON.parse(input.format(_format4));
          }),
          outputs: this.outputs.map(function (output) {
            return JSON.parse(output.format(_format4));
          })
        });
      }

      var result = "";

      if (_format4 !== FormatTypes.sighash) {
        result += "function ";
      }

      result += this.name + "(" + this.inputs.map(function (input) {
        return input.format(_format4);
      }).join(_format4 === FormatTypes.full ? ", " : ",") + ") ";

      if (_format4 !== FormatTypes.sighash) {
        if (this.stateMutability) {
          if (this.stateMutability !== "nonpayable") {
            result += this.stateMutability + " ";
          }
        } else if (this.constant) {
          result += "view ";
        }

        if (this.outputs && this.outputs.length) {
          result += "returns (" + this.outputs.map(function (output) {
            return output.format(_format4);
          }).join(", ") + ") ";
        }

        if (this.gas != null) {
          result += "@" + this.gas.toString() + " ";
        }
      }

      return result.trim();
    }
  }], [{
    key: "from",
    value: function from(value) {
      if (typeof value === "string") {
        return FunctionFragment.fromString(value);
      }

      return FunctionFragment.fromObject(value);
    }
  }, {
    key: "fromObject",
    value: function fromObject(value) {
      if (FunctionFragment.isFunctionFragment(value)) {
        return value;
      }

      if (value.type !== "function") {
        logger.throwArgumentError("invalid function object", "value", value);
      }

      var state = verifyState(value);
      var params = {
        type: value.type,
        name: verifyIdentifier(value.name),
        constant: state.constant,
        inputs: value.inputs ? value.inputs.map(ParamType.fromObject) : [],
        outputs: value.outputs ? value.outputs.map(ParamType.fromObject) : [],
        payable: state.payable,
        stateMutability: state.stateMutability,
        gas: value.gas ? _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_3__.BigNumber.from(value.gas) : null
      };
      return new FunctionFragment(_constructorGuard, params);
    }
  }, {
    key: "fromString",
    value: function fromString(value) {
      var params = {
        type: "function"
      };
      value = parseGas(value, params);
      var comps = value.split(" returns ");

      if (comps.length > 2) {
        logger.throwArgumentError("invalid function string", "value", value);
      }

      var parens = comps[0].match(regexParen);

      if (!parens) {
        logger.throwArgumentError("invalid function signature", "value", value);
      }

      params.name = parens[1].trim();

      if (params.name) {
        verifyIdentifier(params.name);
      }

      params.inputs = parseParams(parens[2], false);
      parseModifiers(parens[3].trim(), params); // We have outputs

      if (comps.length > 1) {
        var returns = comps[1].match(regexParen);

        if (returns[1].trim() != "" || returns[3].trim() != "") {
          logger.throwArgumentError("unexpected tokens", "value", value);
        }

        params.outputs = parseParams(returns[2], false);
      } else {
        params.outputs = [];
      }

      return FunctionFragment.fromObject(params);
    }
  }, {
    key: "isFunctionFragment",
    value: function isFunctionFragment(value) {
      return value && value._isFragment && value.type === "function";
    }
  }]);

  return FunctionFragment;
}(ConstructorFragment); //export class StructFragment extends Fragment {
//}

function checkForbidden(fragment) {
  var sig = fragment.format();

  if (sig === "Error(string)" || sig === "Panic(uint256)") {
    logger.throwArgumentError("cannot specify user defined ".concat(sig, " error"), "fragment", fragment);
  }

  return fragment;
}

var ErrorFragment = /*#__PURE__*/function (_Fragment3) {
  _inherits(ErrorFragment, _Fragment3);

  var _super4 = _createSuper(ErrorFragment);

  function ErrorFragment() {
    _classCallCheck(this, ErrorFragment);

    return _super4.apply(this, arguments);
  }

  _createClass(ErrorFragment, [{
    key: "format",
    value: function format(_format5) {
      if (!_format5) {
        _format5 = FormatTypes.sighash;
      }

      if (!FormatTypes[_format5]) {
        logger.throwArgumentError("invalid format type", "format", _format5);
      }

      if (_format5 === FormatTypes.json) {
        return JSON.stringify({
          type: "error",
          name: this.name,
          inputs: this.inputs.map(function (input) {
            return JSON.parse(input.format(_format5));
          })
        });
      }

      var result = "";

      if (_format5 !== FormatTypes.sighash) {
        result += "error ";
      }

      result += this.name + "(" + this.inputs.map(function (input) {
        return input.format(_format5);
      }).join(_format5 === FormatTypes.full ? ", " : ",") + ") ";
      return result.trim();
    }
  }], [{
    key: "from",
    value: function from(value) {
      if (typeof value === "string") {
        return ErrorFragment.fromString(value);
      }

      return ErrorFragment.fromObject(value);
    }
  }, {
    key: "fromObject",
    value: function fromObject(value) {
      if (ErrorFragment.isErrorFragment(value)) {
        return value;
      }

      if (value.type !== "error") {
        logger.throwArgumentError("invalid error object", "value", value);
      }

      var params = {
        type: value.type,
        name: verifyIdentifier(value.name),
        inputs: value.inputs ? value.inputs.map(ParamType.fromObject) : []
      };
      return checkForbidden(new ErrorFragment(_constructorGuard, params));
    }
  }, {
    key: "fromString",
    value: function fromString(value) {
      var params = {
        type: "error"
      };
      var parens = value.match(regexParen);

      if (!parens) {
        logger.throwArgumentError("invalid error signature", "value", value);
      }

      params.name = parens[1].trim();

      if (params.name) {
        verifyIdentifier(params.name);
      }

      params.inputs = parseParams(parens[2], false);
      return checkForbidden(ErrorFragment.fromObject(params));
    }
  }, {
    key: "isErrorFragment",
    value: function isErrorFragment(value) {
      return value && value._isFragment && value.type === "error";
    }
  }]);

  return ErrorFragment;
}(Fragment);

function verifyType(type) {
  // These need to be transformed to their full description
  if (type.match(/^uint($|[^1-9])/)) {
    type = "uint256" + type.substring(4);
  } else if (type.match(/^int($|[^1-9])/)) {
    type = "int256" + type.substring(3);
  } // @TODO: more verification


  return type;
} // See: https://github.com/ethereum/solidity/blob/1f8f1a3db93a548d0555e3e14cfc55a10e25b60e/docs/grammar/SolidityLexer.g4#L234


var regexIdentifier = new RegExp("^[a-zA-Z$_][a-zA-Z0-9$_]*$");

function verifyIdentifier(value) {
  if (!value || !value.match(regexIdentifier)) {
    logger.throwArgumentError("invalid identifier \"".concat(value, "\""), "value", value);
  }

  return value;
}

var regexParen = new RegExp("^([^)(]*)\\((.*)\\)([^)(]*)$");

function splitNesting(value) {
  value = value.trim();
  var result = [];
  var accum = "";
  var depth = 0;

  for (var offset = 0; offset < value.length; offset++) {
    var c = value[offset];

    if (c === "," && depth === 0) {
      result.push(accum);
      accum = "";
    } else {
      accum += c;

      if (c === "(") {
        depth++;
      } else if (c === ")") {
        depth--;

        if (depth === -1) {
          logger.throwArgumentError("unbalanced parenthesis", "value", value);
        }
      }
    }
  }

  if (accum) {
    result.push(accum);
  }

  return result;
}

/***/ }),

/***/ "./node_modules/@ethersproject/abi/lib.esm/interface.js":
/*!**************************************************************!*\
  !*** ./node_modules/@ethersproject/abi/lib.esm/interface.js ***!
  \**************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "checkResultErrors": function() { return /* reexport safe */ _coders_abstract_coder__WEBPACK_IMPORTED_MODULE_2__.checkResultErrors; },
/* harmony export */   "LogDescription": function() { return /* binding */ LogDescription; },
/* harmony export */   "TransactionDescription": function() { return /* binding */ TransactionDescription; },
/* harmony export */   "ErrorDescription": function() { return /* binding */ ErrorDescription; },
/* harmony export */   "Indexed": function() { return /* binding */ Indexed; },
/* harmony export */   "Interface": function() { return /* binding */ Interface; }
/* harmony export */ });
/* harmony import */ var _ethersproject_address__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @ethersproject/address */ "./node_modules/@ethersproject/address/lib.esm/index.js");
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_hash__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @ethersproject/hash */ "./node_modules/@ethersproject/hash/lib.esm/id.js");
/* harmony import */ var _ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @ethersproject/keccak256 */ "./node_modules/@ethersproject/keccak256/lib.esm/index.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _abi_coder__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./abi-coder */ "./node_modules/@ethersproject/abi/lib.esm/abi-coder.js");
/* harmony import */ var _coders_abstract_coder__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./coders/abstract-coder */ "./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js");
/* harmony import */ var _fragments__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./fragments */ "./node_modules/@ethersproject/abi/lib.esm/fragments.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/abi/lib.esm/_version.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }












var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);

var LogDescription = /*#__PURE__*/function (_Description) {
  _inherits(LogDescription, _Description);

  var _super = _createSuper(LogDescription);

  function LogDescription() {
    _classCallCheck(this, LogDescription);

    return _super.apply(this, arguments);
  }

  return LogDescription;
}(_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.Description);
var TransactionDescription = /*#__PURE__*/function (_Description2) {
  _inherits(TransactionDescription, _Description2);

  var _super2 = _createSuper(TransactionDescription);

  function TransactionDescription() {
    _classCallCheck(this, TransactionDescription);

    return _super2.apply(this, arguments);
  }

  return TransactionDescription;
}(_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.Description);
var ErrorDescription = /*#__PURE__*/function (_Description3) {
  _inherits(ErrorDescription, _Description3);

  var _super3 = _createSuper(ErrorDescription);

  function ErrorDescription() {
    _classCallCheck(this, ErrorDescription);

    return _super3.apply(this, arguments);
  }

  return ErrorDescription;
}(_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.Description);
var Indexed = /*#__PURE__*/function (_Description4) {
  _inherits(Indexed, _Description4);

  var _super4 = _createSuper(Indexed);

  function Indexed() {
    _classCallCheck(this, Indexed);

    return _super4.apply(this, arguments);
  }

  _createClass(Indexed, null, [{
    key: "isIndexed",
    value: function isIndexed(value) {
      return !!(value && value._isIndexed);
    }
  }]);

  return Indexed;
}(_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.Description);
var BuiltinErrors = {
  "0x08c379a0": {
    signature: "Error(string)",
    name: "Error",
    inputs: ["string"],
    reason: true
  },
  "0x4e487b71": {
    signature: "Panic(uint256)",
    name: "Panic",
    inputs: ["uint256"]
  }
};

function wrapAccessError(property, error) {
  var wrap = new Error("deferred error during ABI decoding triggered accessing ".concat(property));
  wrap.error = error;
  return wrap;
}
/*
function checkNames(fragment: Fragment, type: "input" | "output", params: Array<ParamType>): void {
    params.reduce((accum, param) => {
        if (param.name) {
            if (accum[param.name]) {
                logger.throwArgumentError(`duplicate ${ type } parameter ${ JSON.stringify(param.name) } in ${ fragment.format("full") }`, "fragment", fragment);
            }
            accum[param.name] = true;
        }
        return accum;
    }, <{ [ name: string ]: boolean }>{ });
}
*/


var Interface = /*#__PURE__*/function () {
  function Interface(fragments) {
    var _this = this;

    _classCallCheck(this, Interface);

    logger.checkNew(this instanceof Interface ? this.constructor : void 0, Interface);
    var abi = [];

    if (typeof fragments === "string") {
      abi = JSON.parse(fragments);
    } else {
      abi = fragments;
    }

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "fragments", abi.map(function (fragment) {
      return _fragments__WEBPACK_IMPORTED_MODULE_4__.Fragment.from(fragment);
    }).filter(function (fragment) {
      return fragment != null;
    }));
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "_abiCoder", (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.getStatic)(this instanceof Interface ? this.constructor : void 0, "getAbiCoder")());
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "functions", {});
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "errors", {});
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "events", {});
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "structs", {}); // Add all fragments by their signature

    this.fragments.forEach(function (fragment) {
      var bucket = null;

      switch (fragment.type) {
        case "constructor":
          if (_this.deploy) {
            logger.warn("duplicate definition - constructor");
            return;
          } //checkNames(fragment, "input", fragment.inputs);


          (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_this, "deploy", fragment);
          return;

        case "function":
          //checkNames(fragment, "input", fragment.inputs);
          //checkNames(fragment, "output", (<FunctionFragment>fragment).outputs);
          bucket = _this.functions;
          break;

        case "event":
          //checkNames(fragment, "input", fragment.inputs);
          bucket = _this.events;
          break;

        case "error":
          bucket = _this.errors;
          break;

        default:
          return;
      }

      var signature = fragment.format();

      if (bucket[signature]) {
        logger.warn("duplicate definition - " + signature);
        return;
      }

      bucket[signature] = fragment;
    }); // If we do not have a constructor add a default

    if (!this.deploy) {
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "deploy", _fragments__WEBPACK_IMPORTED_MODULE_4__.ConstructorFragment.from({
        payable: false,
        type: "constructor"
      }));
    }

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "_isInterface", true);
  }

  _createClass(Interface, [{
    key: "format",
    value: function format(_format) {
      if (!_format) {
        _format = _fragments__WEBPACK_IMPORTED_MODULE_4__.FormatTypes.full;
      }

      if (_format === _fragments__WEBPACK_IMPORTED_MODULE_4__.FormatTypes.sighash) {
        logger.throwArgumentError("interface does not support formatting sighash", "format", _format);
      }

      var abi = this.fragments.map(function (fragment) {
        return fragment.format(_format);
      }); // We need to re-bundle the JSON fragments a bit

      if (_format === _fragments__WEBPACK_IMPORTED_MODULE_4__.FormatTypes.json) {
        return JSON.stringify(abi.map(function (j) {
          return JSON.parse(j);
        }));
      }

      return abi;
    } // Sub-classes can override these to handle other blockchains

  }, {
    key: "getFunction",
    value: // Find a function definition by any means necessary (unless it is ambiguous)
    function getFunction(nameOrSignatureOrSighash) {
      if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(nameOrSignatureOrSighash)) {
        for (var name in this.functions) {
          if (nameOrSignatureOrSighash === this.getSighash(name)) {
            return this.functions[name];
          }
        }

        logger.throwArgumentError("no matching function", "sighash", nameOrSignatureOrSighash);
      } // It is a bare name, look up the function (will return null if ambiguous)


      if (nameOrSignatureOrSighash.indexOf("(") === -1) {
        var _name = nameOrSignatureOrSighash.trim();

        var matching = Object.keys(this.functions).filter(function (f) {
          return f.split("("
          /* fix:) */
          )[0] === _name;
        });

        if (matching.length === 0) {
          logger.throwArgumentError("no matching function", "name", _name);
        } else if (matching.length > 1) {
          logger.throwArgumentError("multiple matching functions", "name", _name);
        }

        return this.functions[matching[0]];
      } // Normalize the signature and lookup the function


      var result = this.functions[_fragments__WEBPACK_IMPORTED_MODULE_4__.FunctionFragment.fromString(nameOrSignatureOrSighash).format()];

      if (!result) {
        logger.throwArgumentError("no matching function", "signature", nameOrSignatureOrSighash);
      }

      return result;
    } // Find an event definition by any means necessary (unless it is ambiguous)

  }, {
    key: "getEvent",
    value: function getEvent(nameOrSignatureOrTopic) {
      if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(nameOrSignatureOrTopic)) {
        var topichash = nameOrSignatureOrTopic.toLowerCase();

        for (var name in this.events) {
          if (topichash === this.getEventTopic(name)) {
            return this.events[name];
          }
        }

        logger.throwArgumentError("no matching event", "topichash", topichash);
      } // It is a bare name, look up the function (will return null if ambiguous)


      if (nameOrSignatureOrTopic.indexOf("(") === -1) {
        var _name2 = nameOrSignatureOrTopic.trim();

        var matching = Object.keys(this.events).filter(function (f) {
          return f.split("("
          /* fix:) */
          )[0] === _name2;
        });

        if (matching.length === 0) {
          logger.throwArgumentError("no matching event", "name", _name2);
        } else if (matching.length > 1) {
          logger.throwArgumentError("multiple matching events", "name", _name2);
        }

        return this.events[matching[0]];
      } // Normalize the signature and lookup the function


      var result = this.events[_fragments__WEBPACK_IMPORTED_MODULE_4__.EventFragment.fromString(nameOrSignatureOrTopic).format()];

      if (!result) {
        logger.throwArgumentError("no matching event", "signature", nameOrSignatureOrTopic);
      }

      return result;
    } // Find a function definition by any means necessary (unless it is ambiguous)

  }, {
    key: "getError",
    value: function getError(nameOrSignatureOrSighash) {
      if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(nameOrSignatureOrSighash)) {
        var getSighash = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.getStatic)(this.constructor, "getSighash");

        for (var name in this.errors) {
          var error = this.errors[name];

          if (nameOrSignatureOrSighash === getSighash(error)) {
            return this.errors[name];
          }
        }

        logger.throwArgumentError("no matching error", "sighash", nameOrSignatureOrSighash);
      } // It is a bare name, look up the function (will return null if ambiguous)


      if (nameOrSignatureOrSighash.indexOf("(") === -1) {
        var _name3 = nameOrSignatureOrSighash.trim();

        var matching = Object.keys(this.errors).filter(function (f) {
          return f.split("("
          /* fix:) */
          )[0] === _name3;
        });

        if (matching.length === 0) {
          logger.throwArgumentError("no matching error", "name", _name3);
        } else if (matching.length > 1) {
          logger.throwArgumentError("multiple matching errors", "name", _name3);
        }

        return this.errors[matching[0]];
      } // Normalize the signature and lookup the function


      var result = this.errors[_fragments__WEBPACK_IMPORTED_MODULE_4__.FunctionFragment.fromString(nameOrSignatureOrSighash).format()];

      if (!result) {
        logger.throwArgumentError("no matching error", "signature", nameOrSignatureOrSighash);
      }

      return result;
    } // Get the sighash (the bytes4 selector) used by Solidity to identify a function

  }, {
    key: "getSighash",
    value: function getSighash(fragment) {
      if (typeof fragment === "string") {
        try {
          fragment = this.getFunction(fragment);
        } catch (error) {
          try {
            fragment = this.getError(fragment);
          } catch (_) {
            throw error;
          }
        }
      }

      return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.getStatic)(this.constructor, "getSighash")(fragment);
    } // Get the topic (the bytes32 hash) used by Solidity to identify an event

  }, {
    key: "getEventTopic",
    value: function getEventTopic(eventFragment) {
      if (typeof eventFragment === "string") {
        eventFragment = this.getEvent(eventFragment);
      }

      return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.getStatic)(this.constructor, "getEventTopic")(eventFragment);
    }
  }, {
    key: "_decodeParams",
    value: function _decodeParams(params, data) {
      return this._abiCoder.decode(params, data);
    }
  }, {
    key: "_encodeParams",
    value: function _encodeParams(params, values) {
      return this._abiCoder.encode(params, values);
    }
  }, {
    key: "encodeDeploy",
    value: function encodeDeploy(values) {
      return this._encodeParams(this.deploy.inputs, values || []);
    }
  }, {
    key: "decodeErrorResult",
    value: function decodeErrorResult(fragment, data) {
      if (typeof fragment === "string") {
        fragment = this.getError(fragment);
      }

      var bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.arrayify)(data);

      if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexlify)(bytes.slice(0, 4)) !== this.getSighash(fragment)) {
        logger.throwArgumentError("data signature does not match error ".concat(fragment.name, "."), "data", (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexlify)(bytes));
      }

      return this._decodeParams(fragment.inputs, bytes.slice(4));
    }
  }, {
    key: "encodeErrorResult",
    value: function encodeErrorResult(fragment, values) {
      if (typeof fragment === "string") {
        fragment = this.getError(fragment);
      }

      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexlify)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.concat)([this.getSighash(fragment), this._encodeParams(fragment.inputs, values || [])]));
    } // Decode the data for a function call (e.g. tx.data)

  }, {
    key: "decodeFunctionData",
    value: function decodeFunctionData(functionFragment, data) {
      if (typeof functionFragment === "string") {
        functionFragment = this.getFunction(functionFragment);
      }

      var bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.arrayify)(data);

      if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexlify)(bytes.slice(0, 4)) !== this.getSighash(functionFragment)) {
        logger.throwArgumentError("data signature does not match function ".concat(functionFragment.name, "."), "data", (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexlify)(bytes));
      }

      return this._decodeParams(functionFragment.inputs, bytes.slice(4));
    } // Encode the data for a function call (e.g. tx.data)

  }, {
    key: "encodeFunctionData",
    value: function encodeFunctionData(functionFragment, values) {
      if (typeof functionFragment === "string") {
        functionFragment = this.getFunction(functionFragment);
      }

      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexlify)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.concat)([this.getSighash(functionFragment), this._encodeParams(functionFragment.inputs, values || [])]));
    } // Decode the result from a function call (e.g. from eth_call)

  }, {
    key: "decodeFunctionResult",
    value: function decodeFunctionResult(functionFragment, data) {
      if (typeof functionFragment === "string") {
        functionFragment = this.getFunction(functionFragment);
      }

      var bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.arrayify)(data);
      var reason = null;
      var errorArgs = null;
      var errorName = null;
      var errorSignature = null;

      switch (bytes.length % this._abiCoder._getWordSize()) {
        case 0:
          try {
            return this._abiCoder.decode(functionFragment.outputs, bytes);
          } catch (error) {}

          break;

        case 4:
          {
            var selector = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexlify)(bytes.slice(0, 4));
            var builtin = BuiltinErrors[selector];

            if (builtin) {
              errorArgs = this._abiCoder.decode(builtin.inputs, bytes.slice(4));
              errorName = builtin.name;
              errorSignature = builtin.signature;

              if (builtin.reason) {
                reason = errorArgs[0];
              }
            } else {
              try {
                var error = this.getError(selector);
                errorArgs = this._abiCoder.decode(error.inputs, bytes.slice(4));
                errorName = error.name;
                errorSignature = error.format();
              } catch (error) {}
            }

            break;
          }
      }

      return logger.throwError("call revert exception", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.CALL_EXCEPTION, {
        method: functionFragment.format(),
        errorArgs: errorArgs,
        errorName: errorName,
        errorSignature: errorSignature,
        reason: reason
      });
    } // Encode the result for a function call (e.g. for eth_call)

  }, {
    key: "encodeFunctionResult",
    value: function encodeFunctionResult(functionFragment, values) {
      if (typeof functionFragment === "string") {
        functionFragment = this.getFunction(functionFragment);
      }

      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexlify)(this._abiCoder.encode(functionFragment.outputs, values || []));
    } // Create the filter for the event with search criteria (e.g. for eth_filterLog)

  }, {
    key: "encodeFilterTopics",
    value: function encodeFilterTopics(eventFragment, values) {
      var _this2 = this;

      if (typeof eventFragment === "string") {
        eventFragment = this.getEvent(eventFragment);
      }

      if (values.length > eventFragment.inputs.length) {
        logger.throwError("too many arguments for " + eventFragment.format(), _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNEXPECTED_ARGUMENT, {
          argument: "values",
          value: values
        });
      }

      var topics = [];

      if (!eventFragment.anonymous) {
        topics.push(this.getEventTopic(eventFragment));
      }

      var encodeTopic = function encodeTopic(param, value) {
        if (param.type === "string") {
          return (0,_ethersproject_hash__WEBPACK_IMPORTED_MODULE_6__.id)(value);
        } else if (param.type === "bytes") {
          return (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_7__.keccak256)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexlify)(value));
        } // Check addresses are valid


        if (param.type === "address") {
          _this2._abiCoder.encode(["address"], [value]);
        }

        return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexZeroPad)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexlify)(value), 32);
      };

      values.forEach(function (value, index) {
        var param = eventFragment.inputs[index];

        if (!param.indexed) {
          if (value != null) {
            logger.throwArgumentError("cannot filter non-indexed parameters; must be null", "contract." + param.name, value);
          }

          return;
        }

        if (value == null) {
          topics.push(null);
        } else if (param.baseType === "array" || param.baseType === "tuple") {
          logger.throwArgumentError("filtering with tuples or arrays not supported", "contract." + param.name, value);
        } else if (Array.isArray(value)) {
          topics.push(value.map(function (value) {
            return encodeTopic(param, value);
          }));
        } else {
          topics.push(encodeTopic(param, value));
        }
      }); // Trim off trailing nulls

      while (topics.length && topics[topics.length - 1] === null) {
        topics.pop();
      }

      return topics;
    }
  }, {
    key: "encodeEventLog",
    value: function encodeEventLog(eventFragment, values) {
      var _this3 = this;

      if (typeof eventFragment === "string") {
        eventFragment = this.getEvent(eventFragment);
      }

      var topics = [];
      var dataTypes = [];
      var dataValues = [];

      if (!eventFragment.anonymous) {
        topics.push(this.getEventTopic(eventFragment));
      }

      if (values.length !== eventFragment.inputs.length) {
        logger.throwArgumentError("event arguments/values mismatch", "values", values);
      }

      eventFragment.inputs.forEach(function (param, index) {
        var value = values[index];

        if (param.indexed) {
          if (param.type === "string") {
            topics.push((0,_ethersproject_hash__WEBPACK_IMPORTED_MODULE_6__.id)(value));
          } else if (param.type === "bytes") {
            topics.push((0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_7__.keccak256)(value));
          } else if (param.baseType === "tuple" || param.baseType === "array") {
            // @TODO
            throw new Error("not implemented");
          } else {
            topics.push(_this3._abiCoder.encode([param.type], [value]));
          }
        } else {
          dataTypes.push(param);
          dataValues.push(value);
        }
      });
      return {
        data: this._abiCoder.encode(dataTypes, dataValues),
        topics: topics
      };
    } // Decode a filter for the event and the search criteria

  }, {
    key: "decodeEventLog",
    value: function decodeEventLog(eventFragment, data, topics) {
      if (typeof eventFragment === "string") {
        eventFragment = this.getEvent(eventFragment);
      }

      if (topics != null && !eventFragment.anonymous) {
        var topicHash = this.getEventTopic(eventFragment);

        if (!(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(topics[0], 32) || topics[0].toLowerCase() !== topicHash) {
          logger.throwError("fragment/topic mismatch", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INVALID_ARGUMENT, {
            argument: "topics[0]",
            expected: topicHash,
            value: topics[0]
          });
        }

        topics = topics.slice(1);
      }

      var indexed = [];
      var nonIndexed = [];
      var dynamic = [];
      eventFragment.inputs.forEach(function (param, index) {
        if (param.indexed) {
          if (param.type === "string" || param.type === "bytes" || param.baseType === "tuple" || param.baseType === "array") {
            indexed.push(_fragments__WEBPACK_IMPORTED_MODULE_4__.ParamType.fromObject({
              type: "bytes32",
              name: param.name
            }));
            dynamic.push(true);
          } else {
            indexed.push(param);
            dynamic.push(false);
          }
        } else {
          nonIndexed.push(param);
          dynamic.push(false);
        }
      });
      var resultIndexed = topics != null ? this._abiCoder.decode(indexed, (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.concat)(topics)) : null;

      var resultNonIndexed = this._abiCoder.decode(nonIndexed, data, true);

      var result = [];
      var nonIndexedIndex = 0,
          indexedIndex = 0;
      eventFragment.inputs.forEach(function (param, index) {
        if (param.indexed) {
          if (resultIndexed == null) {
            result[index] = new Indexed({
              _isIndexed: true,
              hash: null
            });
          } else if (dynamic[index]) {
            result[index] = new Indexed({
              _isIndexed: true,
              hash: resultIndexed[indexedIndex++]
            });
          } else {
            try {
              result[index] = resultIndexed[indexedIndex++];
            } catch (error) {
              result[index] = error;
            }
          }
        } else {
          try {
            result[index] = resultNonIndexed[nonIndexedIndex++];
          } catch (error) {
            result[index] = error;
          }
        } // Add the keyword argument if named and safe


        if (param.name && result[param.name] == null) {
          var value = result[index]; // Make error named values throw on access

          if (value instanceof Error) {
            Object.defineProperty(result, param.name, {
              enumerable: true,
              get: function get() {
                throw wrapAccessError("property ".concat(JSON.stringify(param.name)), value);
              }
            });
          } else {
            result[param.name] = value;
          }
        }
      }); // Make all error indexed values throw on access

      var _loop = function _loop(i) {
        var value = result[i];

        if (value instanceof Error) {
          Object.defineProperty(result, i, {
            enumerable: true,
            get: function get() {
              throw wrapAccessError("index ".concat(i), value);
            }
          });
        }
      };

      for (var i = 0; i < result.length; i++) {
        _loop(i);
      }

      return Object.freeze(result);
    } // Given a transaction, find the matching function fragment (if any) and
    // determine all its properties and call parameters

  }, {
    key: "parseTransaction",
    value: function parseTransaction(tx) {
      var fragment = this.getFunction(tx.data.substring(0, 10).toLowerCase());

      if (!fragment) {
        return null;
      }

      return new TransactionDescription({
        args: this._abiCoder.decode(fragment.inputs, "0x" + tx.data.substring(10)),
        functionFragment: fragment,
        name: fragment.name,
        signature: fragment.format(),
        sighash: this.getSighash(fragment),
        value: _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_8__.BigNumber.from(tx.value || "0")
      });
    } // @TODO
    //parseCallResult(data: BytesLike): ??
    // Given an event log, find the matching event fragment (if any) and
    // determine all its properties and values

  }, {
    key: "parseLog",
    value: function parseLog(log) {
      var fragment = this.getEvent(log.topics[0]);

      if (!fragment || fragment.anonymous) {
        return null;
      } // @TODO: If anonymous, and the only method, and the input count matches, should we parse?
      //        Probably not, because just because it is the only event in the ABI does
      //        not mean we have the full ABI; maybe just a fragment?


      return new LogDescription({
        eventFragment: fragment,
        name: fragment.name,
        signature: fragment.format(),
        topic: this.getEventTopic(fragment),
        args: this.decodeEventLog(fragment, log.data, log.topics)
      });
    }
  }, {
    key: "parseError",
    value: function parseError(data) {
      var hexData = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexlify)(data);
      var fragment = this.getError(hexData.substring(0, 10).toLowerCase());

      if (!fragment) {
        return null;
      }

      return new ErrorDescription({
        args: this._abiCoder.decode(fragment.inputs, "0x" + hexData.substring(10)),
        errorFragment: fragment,
        name: fragment.name,
        signature: fragment.format(),
        sighash: this.getSighash(fragment)
      });
    }
    /*
    static from(value: Array<Fragment | string | JsonAbi> | string | Interface) {
        if (Interface.isInterface(value)) {
            return value;
        }
        if (typeof(value) === "string") {
            return new Interface(JSON.parse(value));
        }
        return new Interface(value);
    }
    */

  }], [{
    key: "getAbiCoder",
    value: function getAbiCoder() {
      return _abi_coder__WEBPACK_IMPORTED_MODULE_9__.defaultAbiCoder;
    }
  }, {
    key: "getAddress",
    value: function getAddress(address) {
      return (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_10__.getAddress)(address);
    }
  }, {
    key: "getSighash",
    value: function getSighash(fragment) {
      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexDataSlice)((0,_ethersproject_hash__WEBPACK_IMPORTED_MODULE_6__.id)(fragment.format()), 0, 4);
    }
  }, {
    key: "getEventTopic",
    value: function getEventTopic(eventFragment) {
      return (0,_ethersproject_hash__WEBPACK_IMPORTED_MODULE_6__.id)(eventFragment.format());
    }
  }, {
    key: "isInterface",
    value: function isInterface(value) {
      return !!(value && value._isInterface);
    }
  }]);

  return Interface;
}();

/***/ }),

/***/ "./node_modules/@ethersproject/abstract-provider/lib.esm/_version.js":
/*!***************************************************************************!*\
  !*** ./node_modules/@ethersproject/abstract-provider/lib.esm/_version.js ***!
  \***************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "abstract-provider/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/abstract-provider/lib.esm/index.js":
/*!************************************************************************!*\
  !*** ./node_modules/@ethersproject/abstract-provider/lib.esm/index.js ***!
  \************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ForkEvent": function() { return /* binding */ ForkEvent; },
/* harmony export */   "BlockForkEvent": function() { return /* binding */ BlockForkEvent; },
/* harmony export */   "TransactionForkEvent": function() { return /* binding */ TransactionForkEvent; },
/* harmony export */   "TransactionOrderForkEvent": function() { return /* binding */ TransactionOrderForkEvent; },
/* harmony export */   "Provider": function() { return /* binding */ Provider; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/abstract-provider/lib.esm/_version.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};






var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
;
; //export type CallTransactionable = {
//    call(transaction: TransactionRequest): Promise<TransactionResponse>;
//};

var ForkEvent = /*#__PURE__*/function (_Description) {
  _inherits(ForkEvent, _Description);

  var _super = _createSuper(ForkEvent);

  function ForkEvent() {
    _classCallCheck(this, ForkEvent);

    return _super.apply(this, arguments);
  }

  _createClass(ForkEvent, null, [{
    key: "isForkEvent",
    value: function isForkEvent(value) {
      return !!(value && value._isForkEvent);
    }
  }]);

  return ForkEvent;
}(_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.Description);
var BlockForkEvent = /*#__PURE__*/function (_ForkEvent) {
  _inherits(BlockForkEvent, _ForkEvent);

  var _super2 = _createSuper(BlockForkEvent);

  function BlockForkEvent(blockHash, expiry) {
    _classCallCheck(this, BlockForkEvent);

    if (!(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isHexString)(blockHash, 32)) {
      logger.throwArgumentError("invalid blockHash", "blockHash", blockHash);
    }

    return _super2.call(this, {
      _isForkEvent: true,
      _isBlockForkEvent: true,
      expiry: expiry || 0,
      blockHash: blockHash
    });
  }

  return BlockForkEvent;
}(ForkEvent);
var TransactionForkEvent = /*#__PURE__*/function (_ForkEvent2) {
  _inherits(TransactionForkEvent, _ForkEvent2);

  var _super3 = _createSuper(TransactionForkEvent);

  function TransactionForkEvent(hash, expiry) {
    _classCallCheck(this, TransactionForkEvent);

    if (!(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isHexString)(hash, 32)) {
      logger.throwArgumentError("invalid transaction hash", "hash", hash);
    }

    return _super3.call(this, {
      _isForkEvent: true,
      _isTransactionForkEvent: true,
      expiry: expiry || 0,
      hash: hash
    });
  }

  return TransactionForkEvent;
}(ForkEvent);
var TransactionOrderForkEvent = /*#__PURE__*/function (_ForkEvent3) {
  _inherits(TransactionOrderForkEvent, _ForkEvent3);

  var _super4 = _createSuper(TransactionOrderForkEvent);

  function TransactionOrderForkEvent(beforeHash, afterHash, expiry) {
    _classCallCheck(this, TransactionOrderForkEvent);

    if (!(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isHexString)(beforeHash, 32)) {
      logger.throwArgumentError("invalid transaction hash", "beforeHash", beforeHash);
    }

    if (!(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isHexString)(afterHash, 32)) {
      logger.throwArgumentError("invalid transaction hash", "afterHash", afterHash);
    }

    return _super4.call(this, {
      _isForkEvent: true,
      _isTransactionOrderForkEvent: true,
      expiry: expiry || 0,
      beforeHash: beforeHash,
      afterHash: afterHash
    });
  }

  return TransactionOrderForkEvent;
}(ForkEvent); ///////////////////////////////
// Exported Abstracts

var Provider = /*#__PURE__*/function () {
  function Provider() {
    _classCallCheck(this, Provider);

    logger.checkAbstract(this instanceof Provider ? this.constructor : void 0, Provider);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(this, "_isProvider", true);
  }

  _createClass(Provider, [{
    key: "getFeeData",
    value: function getFeeData() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _yield$resolvePropert, block, gasPrice, maxFeePerGas, maxPriorityFeePerGas;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.resolveProperties)({
                  block: this.getBlock("latest"),
                  gasPrice: this.getGasPrice()["catch"](function (error) {
                    // @TODO: Why is this now failing on Calaveras?
                    //console.log(error);
                    return null;
                  })
                });

              case 2:
                _yield$resolvePropert = _context.sent;
                block = _yield$resolvePropert.block;
                gasPrice = _yield$resolvePropert.gasPrice;
                maxFeePerGas = null, maxPriorityFeePerGas = null;

                if (block && block.baseFeePerGas) {
                  // We may want to compute this more accurately in the future,
                  // using the formula "check if the base fee is correct".
                  // See: https://eips.ethereum.org/EIPS/eip-1559
                  maxPriorityFeePerGas = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from("1500000000");
                  maxFeePerGas = block.baseFeePerGas.mul(2).add(maxPriorityFeePerGas);
                }

                return _context.abrupt("return", {
                  maxFeePerGas: maxFeePerGas,
                  maxPriorityFeePerGas: maxPriorityFeePerGas,
                  gasPrice: gasPrice
                });

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
    } // Alias for "on"

  }, {
    key: "addListener",
    value: function addListener(eventName, listener) {
      return this.on(eventName, listener);
    } // Alias for "off"

  }, {
    key: "removeListener",
    value: function removeListener(eventName, listener) {
      return this.off(eventName, listener);
    }
  }], [{
    key: "isProvider",
    value: function isProvider(value) {
      return !!(value && value._isProvider);
    }
  }]);

  return Provider;
}();

/***/ }),

/***/ "./node_modules/@ethersproject/abstract-signer/lib.esm/_version.js":
/*!*************************************************************************!*\
  !*** ./node_modules/@ethersproject/abstract-signer/lib.esm/_version.js ***!
  \*************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "abstract-signer/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/abstract-signer/lib.esm/index.js":
/*!**********************************************************************!*\
  !*** ./node_modules/@ethersproject/abstract-signer/lib.esm/index.js ***!
  \**********************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Signer": function() { return /* binding */ Signer; },
/* harmony export */   "VoidSigner": function() { return /* binding */ VoidSigner; }
/* harmony export */ });
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/abstract-signer/lib.esm/_version.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};




var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
var allowedTransactionKeys = ["accessList", "ccipReadEnabled", "chainId", "customData", "data", "from", "gasLimit", "gasPrice", "maxFeePerGas", "maxPriorityFeePerGas", "nonce", "to", "type", "value"];
var forwardErrors = [_ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INSUFFICIENT_FUNDS, _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.NONCE_EXPIRED, _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.REPLACEMENT_UNDERPRICED];
;
;
var Signer = /*#__PURE__*/function () {
  ///////////////////
  // Sub-classes MUST call super
  function Signer() {
    _classCallCheck(this, Signer);

    logger.checkAbstract(this instanceof Signer ? this.constructor : void 0, Signer);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(this, "_isSigner", true);
  } ///////////////////
  // Sub-classes MAY override these


  _createClass(Signer, [{
    key: "getBalance",
    value: function getBalance(blockTag) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                this._checkProvider("getBalance");

                _context.next = 3;
                return this.provider.getBalance(this.getAddress(), blockTag);

              case 3:
                return _context.abrupt("return", _context.sent);

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
    }
  }, {
    key: "getTransactionCount",
    value: function getTransactionCount(blockTag) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this._checkProvider("getTransactionCount");

                _context2.next = 3;
                return this.provider.getTransactionCount(this.getAddress(), blockTag);

              case 3:
                return _context2.abrupt("return", _context2.sent);

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));
    } // Populates "from" if unspecified, and estimates the gas for the transaction

  }, {
    key: "estimateGas",
    value: function estimateGas(transaction) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var tx;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                this._checkProvider("estimateGas");

                _context3.next = 3;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.resolveProperties)(this.checkTransaction(transaction));

              case 3:
                tx = _context3.sent;
                _context3.next = 6;
                return this.provider.estimateGas(tx);

              case 6:
                return _context3.abrupt("return", _context3.sent);

              case 7:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));
    } // Populates "from" if unspecified, and calls with the transaction

  }, {
    key: "call",
    value: function call(transaction, blockTag) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var tx;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                this._checkProvider("call");

                _context4.next = 3;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.resolveProperties)(this.checkTransaction(transaction));

              case 3:
                tx = _context4.sent;
                _context4.next = 6;
                return this.provider.call(tx, blockTag);

              case 6:
                return _context4.abrupt("return", _context4.sent);

              case 7:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));
    } // Populates all fields in a transaction, signs it and sends it to the network

  }, {
    key: "sendTransaction",
    value: function sendTransaction(transaction) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
        var tx, signedTx;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                this._checkProvider("sendTransaction");

                _context5.next = 3;
                return this.populateTransaction(transaction);

              case 3:
                tx = _context5.sent;
                _context5.next = 6;
                return this.signTransaction(tx);

              case 6:
                signedTx = _context5.sent;
                _context5.next = 9;
                return this.provider.sendTransaction(signedTx);

              case 9:
                return _context5.abrupt("return", _context5.sent);

              case 10:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));
    }
  }, {
    key: "getChainId",
    value: function getChainId() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
        var network;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                this._checkProvider("getChainId");

                _context6.next = 3;
                return this.provider.getNetwork();

              case 3:
                network = _context6.sent;
                return _context6.abrupt("return", network.chainId);

              case 5:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));
    }
  }, {
    key: "getGasPrice",
    value: function getGasPrice() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                this._checkProvider("getGasPrice");

                _context7.next = 3;
                return this.provider.getGasPrice();

              case 3:
                return _context7.abrupt("return", _context7.sent);

              case 4:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));
    }
  }, {
    key: "getFeeData",
    value: function getFeeData() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                this._checkProvider("getFeeData");

                _context8.next = 3;
                return this.provider.getFeeData();

              case 3:
                return _context8.abrupt("return", _context8.sent);

              case 4:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));
    }
  }, {
    key: "resolveName",
    value: function resolveName(name) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                this._checkProvider("resolveName");

                _context9.next = 3;
                return this.provider.resolveName(name);

              case 3:
                return _context9.abrupt("return", _context9.sent);

              case 4:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));
    } // Checks a transaction does not contain invalid keys and if
    // no "from" is provided, populates it.
    // - does NOT require a provider
    // - adds "from" is not present
    // - returns a COPY (safe to mutate the result)
    // By default called from: (overriding these prevents it)
    //   - call
    //   - estimateGas
    //   - populateTransaction (and therefor sendTransaction)

  }, {
    key: "checkTransaction",
    value: function checkTransaction(transaction) {
      for (var key in transaction) {
        if (allowedTransactionKeys.indexOf(key) === -1) {
          logger.throwArgumentError("invalid transaction key: " + key, "transaction", transaction);
        }
      }

      var tx = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.shallowCopy)(transaction);

      if (tx.from == null) {
        tx.from = this.getAddress();
      } else {
        // Make sure any provided address matches this signer
        tx.from = Promise.all([Promise.resolve(tx.from), this.getAddress()]).then(function (result) {
          if (result[0].toLowerCase() !== result[1].toLowerCase()) {
            logger.throwArgumentError("from address mismatch", "transaction", transaction);
          }

          return result[0];
        });
      }

      return tx;
    } // Populates ALL keys for a transaction and checks that "from" matches
    // this Signer. Should be used by sendTransaction but NOT by signTransaction.
    // By default called from: (overriding these prevents it)
    //   - sendTransaction
    //
    // Notes:
    //  - We allow gasPrice for EIP-1559 as long as it matches maxFeePerGas

  }, {
    key: "populateTransaction",
    value: function populateTransaction(transaction) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee11() {
        var _this = this;

        var tx, hasEip1559, feeData, gasPrice;
        return regeneratorRuntime.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.resolveProperties)(this.checkTransaction(transaction));

              case 2:
                tx = _context11.sent;

                if (tx.to != null) {
                  tx.to = Promise.resolve(tx.to).then(function (to) {
                    return __awaiter(_this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
                      var address;
                      return regeneratorRuntime.wrap(function _callee10$(_context10) {
                        while (1) {
                          switch (_context10.prev = _context10.next) {
                            case 0:
                              if (!(to == null)) {
                                _context10.next = 2;
                                break;
                              }

                              return _context10.abrupt("return", null);

                            case 2:
                              _context10.next = 4;
                              return this.resolveName(to);

                            case 4:
                              address = _context10.sent;

                              if (address == null) {
                                logger.throwArgumentError("provided ENS name resolves to null", "tx.to", to);
                              }

                              return _context10.abrupt("return", address);

                            case 7:
                            case "end":
                              return _context10.stop();
                          }
                        }
                      }, _callee10, this);
                    }));
                  }); // Prevent this error from causing an UnhandledPromiseException

                  tx.to["catch"](function (error) {});
                } // Do not allow mixing pre-eip-1559 and eip-1559 properties


                hasEip1559 = tx.maxFeePerGas != null || tx.maxPriorityFeePerGas != null;

                if (tx.gasPrice != null && (tx.type === 2 || hasEip1559)) {
                  logger.throwArgumentError("eip-1559 transaction do not support gasPrice", "transaction", transaction);
                } else if ((tx.type === 0 || tx.type === 1) && hasEip1559) {
                  logger.throwArgumentError("pre-eip-1559 transaction do not support maxFeePerGas/maxPriorityFeePerGas", "transaction", transaction);
                }

                if (!((tx.type === 2 || tx.type == null) && tx.maxFeePerGas != null && tx.maxPriorityFeePerGas != null)) {
                  _context11.next = 10;
                  break;
                }

                // Fully-formed EIP-1559 transaction (skip getFeeData)
                tx.type = 2;
                _context11.next = 18;
                break;

              case 10:
                if (!(tx.type === 0 || tx.type === 1)) {
                  _context11.next = 14;
                  break;
                }

                // Explicit Legacy or EIP-2930 transaction
                // Populate missing gasPrice
                if (tx.gasPrice == null) {
                  tx.gasPrice = this.getGasPrice();
                }

                _context11.next = 18;
                break;

              case 14:
                _context11.next = 16;
                return this.getFeeData();

              case 16:
                feeData = _context11.sent;

                if (tx.type == null) {
                  // We need to auto-detect the intended type of this transaction...
                  if (feeData.maxFeePerGas != null && feeData.maxPriorityFeePerGas != null) {
                    // The network supports EIP-1559!
                    // Upgrade transaction from null to eip-1559
                    tx.type = 2;

                    if (tx.gasPrice != null) {
                      // Using legacy gasPrice property on an eip-1559 network,
                      // so use gasPrice as both fee properties
                      gasPrice = tx.gasPrice;
                      delete tx.gasPrice;
                      tx.maxFeePerGas = gasPrice;
                      tx.maxPriorityFeePerGas = gasPrice;
                    } else {
                      // Populate missing fee data
                      if (tx.maxFeePerGas == null) {
                        tx.maxFeePerGas = feeData.maxFeePerGas;
                      }

                      if (tx.maxPriorityFeePerGas == null) {
                        tx.maxPriorityFeePerGas = feeData.maxPriorityFeePerGas;
                      }
                    }
                  } else if (feeData.gasPrice != null) {
                    // Network doesn't support EIP-1559...
                    // ...but they are trying to use EIP-1559 properties
                    if (hasEip1559) {
                      logger.throwError("network does not support EIP-1559", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
                        operation: "populateTransaction"
                      });
                    } // Populate missing fee data


                    if (tx.gasPrice == null) {
                      tx.gasPrice = feeData.gasPrice;
                    } // Explicitly set untyped transaction to legacy


                    tx.type = 0;
                  } else {
                    // getFeeData has failed us.
                    logger.throwError("failed to get consistent fee data", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
                      operation: "signer.getFeeData"
                    });
                  }
                } else if (tx.type === 2) {
                  // Explicitly using EIP-1559
                  // Populate missing fee data
                  if (tx.maxFeePerGas == null) {
                    tx.maxFeePerGas = feeData.maxFeePerGas;
                  }

                  if (tx.maxPriorityFeePerGas == null) {
                    tx.maxPriorityFeePerGas = feeData.maxPriorityFeePerGas;
                  }
                }

              case 18:
                if (tx.nonce == null) {
                  tx.nonce = this.getTransactionCount("pending");
                }

                if (tx.gasLimit == null) {
                  tx.gasLimit = this.estimateGas(tx)["catch"](function (error) {
                    if (forwardErrors.indexOf(error.code) >= 0) {
                      throw error;
                    }

                    return logger.throwError("cannot estimate gas; transaction may fail or may require manual gas limit", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNPREDICTABLE_GAS_LIMIT, {
                      error: error,
                      tx: tx
                    });
                  });
                }

                if (tx.chainId == null) {
                  tx.chainId = this.getChainId();
                } else {
                  tx.chainId = Promise.all([Promise.resolve(tx.chainId), this.getChainId()]).then(function (results) {
                    if (results[1] !== 0 && results[0] !== results[1]) {
                      logger.throwArgumentError("chainId address mismatch", "transaction", transaction);
                    }

                    return results[0];
                  });
                }

                _context11.next = 23;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.resolveProperties)(tx);

              case 23:
                return _context11.abrupt("return", _context11.sent);

              case 24:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));
    } ///////////////////
    // Sub-classes SHOULD leave these alone

  }, {
    key: "_checkProvider",
    value: function _checkProvider(operation) {
      if (!this.provider) {
        logger.throwError("missing provider", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
          operation: operation || "_checkProvider"
        });
      }
    }
  }], [{
    key: "isSigner",
    value: function isSigner(value) {
      return !!(value && value._isSigner);
    }
  }]);

  return Signer;
}();
var VoidSigner = /*#__PURE__*/function (_Signer) {
  _inherits(VoidSigner, _Signer);

  var _super = _createSuper(VoidSigner);

  function VoidSigner(address, provider) {
    var _this2;

    _classCallCheck(this, VoidSigner);

    logger.checkNew(this instanceof VoidSigner ? this.constructor : void 0, VoidSigner);
    _this2 = _super.call(this);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this2), "address", address);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this2), "provider", provider || null);
    return _this2;
  }

  _createClass(VoidSigner, [{
    key: "getAddress",
    value: function getAddress() {
      return Promise.resolve(this.address);
    }
  }, {
    key: "_fail",
    value: function _fail(message, operation) {
      return Promise.resolve().then(function () {
        logger.throwError(message, _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
          operation: operation
        });
      });
    }
  }, {
    key: "signMessage",
    value: function signMessage(message) {
      return this._fail("VoidSigner cannot sign messages", "signMessage");
    }
  }, {
    key: "signTransaction",
    value: function signTransaction(transaction) {
      return this._fail("VoidSigner cannot sign transactions", "signTransaction");
    }
  }, {
    key: "_signTypedData",
    value: function _signTypedData(domain, types, value) {
      return this._fail("VoidSigner cannot sign typed data", "signTypedData");
    }
  }, {
    key: "connect",
    value: function connect(provider) {
      return new VoidSigner(this.address, provider);
    }
  }]);

  return VoidSigner;
}(Signer);

/***/ }),

/***/ "./node_modules/@ethersproject/address/lib.esm/_version.js":
/*!*****************************************************************!*\
  !*** ./node_modules/@ethersproject/address/lib.esm/_version.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "address/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/address/lib.esm/index.js":
/*!**************************************************************!*\
  !*** ./node_modules/@ethersproject/address/lib.esm/index.js ***!
  \**************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getAddress": function() { return /* binding */ getAddress; },
/* harmony export */   "isAddress": function() { return /* binding */ isAddress; },
/* harmony export */   "getIcapAddress": function() { return /* binding */ getIcapAddress; },
/* harmony export */   "getContractAddress": function() { return /* binding */ getContractAddress; },
/* harmony export */   "getCreate2Address": function() { return /* binding */ getCreate2Address; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/keccak256 */ "./node_modules/@ethersproject/keccak256/lib.esm/index.js");
/* harmony import */ var _ethersproject_rlp__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @ethersproject/rlp */ "./node_modules/@ethersproject/rlp/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/address/lib.esm/_version.js");








var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);

function getChecksumAddress(address) {
  if (!(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.isHexString)(address, 20)) {
    logger.throwArgumentError("invalid address", "address", address);
  }

  address = address.toLowerCase();
  var chars = address.substring(2).split("");
  var expanded = new Uint8Array(40);

  for (var i = 0; i < 40; i++) {
    expanded[i] = chars[i].charCodeAt(0);
  }

  var hashed = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.arrayify)((0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_3__.keccak256)(expanded));

  for (var _i = 0; _i < 40; _i += 2) {
    if (hashed[_i >> 1] >> 4 >= 8) {
      chars[_i] = chars[_i].toUpperCase();
    }

    if ((hashed[_i >> 1] & 0x0f) >= 8) {
      chars[_i + 1] = chars[_i + 1].toUpperCase();
    }
  }

  return "0x" + chars.join("");
} // Shims for environments that are missing some required constants and functions


var MAX_SAFE_INTEGER = 0x1fffffffffffff;

function log10(x) {
  if (Math.log10) {
    return Math.log10(x);
  }

  return Math.log(x) / Math.LN10;
} // See: https://en.wikipedia.org/wiki/International_Bank_Account_Number
// Create lookup table


var ibanLookup = {};

for (var i = 0; i < 10; i++) {
  ibanLookup[String(i)] = String(i);
}

for (var _i2 = 0; _i2 < 26; _i2++) {
  ibanLookup[String.fromCharCode(65 + _i2)] = String(10 + _i2);
} // How many decimal digits can we process? (for 64-bit float, this is 15)


var safeDigits = Math.floor(log10(MAX_SAFE_INTEGER));

function ibanChecksum(address) {
  address = address.toUpperCase();
  address = address.substring(4) + address.substring(0, 2) + "00";
  var expanded = address.split("").map(function (c) {
    return ibanLookup[c];
  }).join(""); // Javascript can handle integers safely up to 15 (decimal) digits

  while (expanded.length >= safeDigits) {
    var block = expanded.substring(0, safeDigits);
    expanded = parseInt(block, 10) % 97 + expanded.substring(block.length);
  }

  var checksum = String(98 - parseInt(expanded, 10) % 97);

  while (checksum.length < 2) {
    checksum = "0" + checksum;
  }

  return checksum;
}

;
function getAddress(address) {
  var result = null;

  if (typeof address !== "string") {
    logger.throwArgumentError("invalid address", "address", address);
  }

  if (address.match(/^(0x)?[0-9a-fA-F]{40}$/)) {
    // Missing the 0x prefix
    if (address.substring(0, 2) !== "0x") {
      address = "0x" + address;
    }

    result = getChecksumAddress(address); // It is a checksummed address with a bad checksum

    if (address.match(/([A-F].*[a-f])|([a-f].*[A-F])/) && result !== address) {
      logger.throwArgumentError("bad address checksum", "address", address);
    } // Maybe ICAP? (we only support direct mode)

  } else if (address.match(/^XE[0-9]{2}[0-9A-Za-z]{30,31}$/)) {
    // It is an ICAP address with a bad checksum
    if (address.substring(2, 4) !== ibanChecksum(address)) {
      logger.throwArgumentError("bad icap checksum", "address", address);
    }

    result = (0,_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__._base36To16)(address.substring(4));

    while (result.length < 40) {
      result = "0" + result;
    }

    result = getChecksumAddress("0x" + result);
  } else {
    logger.throwArgumentError("invalid address", "address", address);
  }

  return result;
}
function isAddress(address) {
  try {
    getAddress(address);
    return true;
  } catch (error) {}

  return false;
}
function getIcapAddress(address) {
  var base36 = (0,_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__._base16To36)(getAddress(address).substring(2)).toUpperCase();

  while (base36.length < 30) {
    base36 = "0" + base36;
  }

  return "XE" + ibanChecksum("XE00" + base36) + base36;
} // http://ethereum.stackexchange.com/questions/760/how-is-the-address-of-an-ethereum-contract-computed

function getContractAddress(transaction) {
  var from = null;

  try {
    from = getAddress(transaction.from);
  } catch (error) {
    logger.throwArgumentError("missing from address", "transaction", transaction);
  }

  var nonce = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.stripZeros)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.arrayify)(_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(transaction.nonce).toHexString()));
  return getAddress((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexDataSlice)((0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_3__.keccak256)((0,_ethersproject_rlp__WEBPACK_IMPORTED_MODULE_5__.encode)([from, nonce])), 12));
}
function getCreate2Address(from, salt, initCodeHash) {
  if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexDataLength)(salt) !== 32) {
    logger.throwArgumentError("salt must be 32 bytes", "salt", salt);
  }

  if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexDataLength)(initCodeHash) !== 32) {
    logger.throwArgumentError("initCodeHash must be 32 bytes", "initCodeHash", initCodeHash);
  }

  return getAddress((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexDataSlice)((0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_3__.keccak256)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.concat)(["0xff", getAddress(from), salt, initCodeHash])), 12));
}

/***/ }),

/***/ "./node_modules/@ethersproject/base64/lib.esm/base64.js":
/*!**************************************************************!*\
  !*** ./node_modules/@ethersproject/base64/lib.esm/base64.js ***!
  \**************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "decode": function() { return /* binding */ decode; },
/* harmony export */   "encode": function() { return /* binding */ encode; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");



function decode(textData) {
  textData = atob(textData);
  var data = [];

  for (var i = 0; i < textData.length; i++) {
    data.push(textData.charCodeAt(i));
  }

  return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_0__.arrayify)(data);
}
function encode(data) {
  data = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_0__.arrayify)(data);
  var textData = "";

  for (var i = 0; i < data.length; i++) {
    textData += String.fromCharCode(data[i]);
  }

  return btoa(textData);
}

/***/ }),

/***/ "./node_modules/@ethersproject/basex/lib.esm/index.js":
/*!************************************************************!*\
  !*** ./node_modules/@ethersproject/basex/lib.esm/index.js ***!
  \************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "BaseX": function() { return /* binding */ BaseX; },
/* harmony export */   "Base32": function() { return /* binding */ Base32; },
/* harmony export */   "Base58": function() { return /* binding */ Base58; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * var basex = require("base-x");
 *
 * This implementation is heavily based on base-x. The main reason to
 * deviate was to prevent the dependency of Buffer.
 *
 * Contributors:
 *
 * base-x encoding
 * Forked from https://github.com/cryptocoinjs/bs58
 * Originally written by Mike Hearn for BitcoinJ
 * Copyright (c) 2011 Google Inc
 * Ported to JavaScript by Stefan Thomas
 * Merged Buffer refactorings from base58-native by Stephen Pair
 * Copyright (c) 2013 BitPay Inc
 *
 * The MIT License (MIT)
 *
 * Copyright base-x contributors (c) 2016
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.

 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 *
 */


var BaseX = /*#__PURE__*/function () {
  function BaseX(alphabet) {
    _classCallCheck(this, BaseX);

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_0__.defineReadOnly)(this, "alphabet", alphabet);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_0__.defineReadOnly)(this, "base", alphabet.length);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_0__.defineReadOnly)(this, "_alphabetMap", {});
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_0__.defineReadOnly)(this, "_leader", alphabet.charAt(0)); // pre-compute lookup table

    for (var i = 0; i < alphabet.length; i++) {
      this._alphabetMap[alphabet.charAt(i)] = i;
    }
  }

  _createClass(BaseX, [{
    key: "encode",
    value: function encode(value) {
      var source = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_1__.arrayify)(value);

      if (source.length === 0) {
        return "";
      }

      var digits = [0];

      for (var i = 0; i < source.length; ++i) {
        var carry = source[i];

        for (var j = 0; j < digits.length; ++j) {
          carry += digits[j] << 8;
          digits[j] = carry % this.base;
          carry = carry / this.base | 0;
        }

        while (carry > 0) {
          digits.push(carry % this.base);
          carry = carry / this.base | 0;
        }
      }

      var string = ""; // deal with leading zeros

      for (var k = 0; source[k] === 0 && k < source.length - 1; ++k) {
        string += this._leader;
      } // convert digits to a string


      for (var q = digits.length - 1; q >= 0; --q) {
        string += this.alphabet[digits[q]];
      }

      return string;
    }
  }, {
    key: "decode",
    value: function decode(value) {
      if (typeof value !== "string") {
        throw new TypeError("Expected String");
      }

      var bytes = [];

      if (value.length === 0) {
        return new Uint8Array(bytes);
      }

      bytes.push(0);

      for (var i = 0; i < value.length; i++) {
        var _byte = this._alphabetMap[value[i]];

        if (_byte === undefined) {
          throw new Error("Non-base" + this.base + " character");
        }

        var carry = _byte;

        for (var j = 0; j < bytes.length; ++j) {
          carry += bytes[j] * this.base;
          bytes[j] = carry & 0xff;
          carry >>= 8;
        }

        while (carry > 0) {
          bytes.push(carry & 0xff);
          carry >>= 8;
        }
      } // deal with leading zeros


      for (var k = 0; value[k] === this._leader && k < value.length - 1; ++k) {
        bytes.push(0);
      }

      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_1__.arrayify)(new Uint8Array(bytes.reverse()));
    }
  }]);

  return BaseX;
}();
var Base32 = new BaseX("abcdefghijklmnopqrstuvwxyz234567");
var Base58 = new BaseX("123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz");
 //console.log(Base58.decode("Qmd2V777o5XvJbYMeMb8k2nU5f8d3ciUQ5YpYuWhzv8iDj"))
//console.log(Base58.encode(Base58.decode("Qmd2V777o5XvJbYMeMb8k2nU5f8d3ciUQ5YpYuWhzv8iDj")))

/***/ }),

/***/ "./node_modules/@ethersproject/bignumber/lib.esm/_version.js":
/*!*******************************************************************!*\
  !*** ./node_modules/@ethersproject/bignumber/lib.esm/_version.js ***!
  \*******************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "bignumber/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js":
/*!********************************************************************!*\
  !*** ./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js ***!
  \********************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "isBigNumberish": function() { return /* binding */ isBigNumberish; },
/* harmony export */   "BigNumber": function() { return /* binding */ BigNumber; },
/* harmony export */   "_base36To16": function() { return /* binding */ _base36To16; },
/* harmony export */   "_base16To36": function() { return /* binding */ _base16To36; }
/* harmony export */ });
/* harmony import */ var bn_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! bn.js */ "./node_modules/bn.js/lib/bn.js");
/* harmony import */ var bn_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(bn_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/bignumber/lib.esm/_version.js");

/**
 *  BigNumber
 *
 *  A wrapper around the BN.js object. We use the BN.js library
 *  because it is used by elliptic, so it is required regardless.
 *
 */

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }


var BN = (bn_js__WEBPACK_IMPORTED_MODULE_0___default().BN);



var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger(_version__WEBPACK_IMPORTED_MODULE_2__.version);
var _constructorGuard = {};
var MAX_SAFE = 0x1fffffffffffff;
function isBigNumberish(value) {
  return value != null && (BigNumber.isBigNumber(value) || typeof value === "number" && value % 1 === 0 || typeof value === "string" && !!value.match(/^-?[0-9]+$/) || (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isHexString)(value) || typeof value === "bigint" || (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isBytes)(value));
} // Only warn about passing 10 into radix once

var _warnedToStringRadix = false;
var BigNumber = /*#__PURE__*/function () {
  function BigNumber(constructorGuard, hex) {
    _classCallCheck(this, BigNumber);

    logger.checkNew(this instanceof BigNumber ? this.constructor : void 0, BigNumber);

    if (constructorGuard !== _constructorGuard) {
      logger.throwError("cannot call constructor directly; use BigNumber.from", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.UNSUPPORTED_OPERATION, {
        operation: "new (BigNumber)"
      });
    }

    this._hex = hex;
    this._isBigNumber = true;
    Object.freeze(this);
  }

  _createClass(BigNumber, [{
    key: "fromTwos",
    value: function fromTwos(value) {
      return toBigNumber(toBN(this).fromTwos(value));
    }
  }, {
    key: "toTwos",
    value: function toTwos(value) {
      return toBigNumber(toBN(this).toTwos(value));
    }
  }, {
    key: "abs",
    value: function abs() {
      if (this._hex[0] === "-") {
        return BigNumber.from(this._hex.substring(1));
      }

      return this;
    }
  }, {
    key: "add",
    value: function add(other) {
      return toBigNumber(toBN(this).add(toBN(other)));
    }
  }, {
    key: "sub",
    value: function sub(other) {
      return toBigNumber(toBN(this).sub(toBN(other)));
    }
  }, {
    key: "div",
    value: function div(other) {
      var o = BigNumber.from(other);

      if (o.isZero()) {
        throwFault("division-by-zero", "div");
      }

      return toBigNumber(toBN(this).div(toBN(other)));
    }
  }, {
    key: "mul",
    value: function mul(other) {
      return toBigNumber(toBN(this).mul(toBN(other)));
    }
  }, {
    key: "mod",
    value: function mod(other) {
      var value = toBN(other);

      if (value.isNeg()) {
        throwFault("division-by-zero", "mod");
      }

      return toBigNumber(toBN(this).umod(value));
    }
  }, {
    key: "pow",
    value: function pow(other) {
      var value = toBN(other);

      if (value.isNeg()) {
        throwFault("negative-power", "pow");
      }

      return toBigNumber(toBN(this).pow(value));
    }
  }, {
    key: "and",
    value: function and(other) {
      var value = toBN(other);

      if (this.isNegative() || value.isNeg()) {
        throwFault("unbound-bitwise-result", "and");
      }

      return toBigNumber(toBN(this).and(value));
    }
  }, {
    key: "or",
    value: function or(other) {
      var value = toBN(other);

      if (this.isNegative() || value.isNeg()) {
        throwFault("unbound-bitwise-result", "or");
      }

      return toBigNumber(toBN(this).or(value));
    }
  }, {
    key: "xor",
    value: function xor(other) {
      var value = toBN(other);

      if (this.isNegative() || value.isNeg()) {
        throwFault("unbound-bitwise-result", "xor");
      }

      return toBigNumber(toBN(this).xor(value));
    }
  }, {
    key: "mask",
    value: function mask(value) {
      if (this.isNegative() || value < 0) {
        throwFault("negative-width", "mask");
      }

      return toBigNumber(toBN(this).maskn(value));
    }
  }, {
    key: "shl",
    value: function shl(value) {
      if (this.isNegative() || value < 0) {
        throwFault("negative-width", "shl");
      }

      return toBigNumber(toBN(this).shln(value));
    }
  }, {
    key: "shr",
    value: function shr(value) {
      if (this.isNegative() || value < 0) {
        throwFault("negative-width", "shr");
      }

      return toBigNumber(toBN(this).shrn(value));
    }
  }, {
    key: "eq",
    value: function eq(other) {
      return toBN(this).eq(toBN(other));
    }
  }, {
    key: "lt",
    value: function lt(other) {
      return toBN(this).lt(toBN(other));
    }
  }, {
    key: "lte",
    value: function lte(other) {
      return toBN(this).lte(toBN(other));
    }
  }, {
    key: "gt",
    value: function gt(other) {
      return toBN(this).gt(toBN(other));
    }
  }, {
    key: "gte",
    value: function gte(other) {
      return toBN(this).gte(toBN(other));
    }
  }, {
    key: "isNegative",
    value: function isNegative() {
      return this._hex[0] === "-";
    }
  }, {
    key: "isZero",
    value: function isZero() {
      return toBN(this).isZero();
    }
  }, {
    key: "toNumber",
    value: function toNumber() {
      try {
        return toBN(this).toNumber();
      } catch (error) {
        throwFault("overflow", "toNumber", this.toString());
      }

      return null;
    }
  }, {
    key: "toBigInt",
    value: function toBigInt() {
      try {
        return BigInt(this.toString());
      } catch (e) {}

      return logger.throwError("this platform does not support BigInt", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.UNSUPPORTED_OPERATION, {
        value: this.toString()
      });
    }
  }, {
    key: "toString",
    value: function toString() {
      // Lots of people expect this, which we do not support, so check (See: #889)
      if (arguments.length > 0) {
        if (arguments[0] === 10) {
          if (!_warnedToStringRadix) {
            _warnedToStringRadix = true;
            logger.warn("BigNumber.toString does not accept any parameters; base-10 is assumed");
          }
        } else if (arguments[0] === 16) {
          logger.throwError("BigNumber.toString does not accept any parameters; use bigNumber.toHexString()", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.UNEXPECTED_ARGUMENT, {});
        } else {
          logger.throwError("BigNumber.toString does not accept parameters", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.UNEXPECTED_ARGUMENT, {});
        }
      }

      return toBN(this).toString(10);
    }
  }, {
    key: "toHexString",
    value: function toHexString() {
      return this._hex;
    }
  }, {
    key: "toJSON",
    value: function toJSON(key) {
      return {
        type: "BigNumber",
        hex: this.toHexString()
      };
    }
  }], [{
    key: "from",
    value: function from(value) {
      if (value instanceof BigNumber) {
        return value;
      }

      if (typeof value === "string") {
        if (value.match(/^-?0x[0-9a-f]+$/i)) {
          return new BigNumber(_constructorGuard, toHex(value));
        }

        if (value.match(/^-?[0-9]+$/)) {
          return new BigNumber(_constructorGuard, toHex(new BN(value)));
        }

        return logger.throwArgumentError("invalid BigNumber string", "value", value);
      }

      if (typeof value === "number") {
        if (value % 1) {
          throwFault("underflow", "BigNumber.from", value);
        }

        if (value >= MAX_SAFE || value <= -MAX_SAFE) {
          throwFault("overflow", "BigNumber.from", value);
        }

        return BigNumber.from(String(value));
      }

      var anyValue = value;

      if (typeof anyValue === "bigint") {
        return BigNumber.from(anyValue.toString());
      }

      if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isBytes)(anyValue)) {
        return BigNumber.from((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexlify)(anyValue));
      }

      if (anyValue) {
        // Hexable interface (takes priority)
        if (anyValue.toHexString) {
          var hex = anyValue.toHexString();

          if (typeof hex === "string") {
            return BigNumber.from(hex);
          }
        } else {
          // For now, handle legacy JSON-ified values (goes away in v6)
          var _hex = anyValue._hex; // New-form JSON

          if (_hex == null && anyValue.type === "BigNumber") {
            _hex = anyValue.hex;
          }

          if (typeof _hex === "string") {
            if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isHexString)(_hex) || _hex[0] === "-" && (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isHexString)(_hex.substring(1))) {
              return BigNumber.from(_hex);
            }
          }
        }
      }

      return logger.throwArgumentError("invalid BigNumber value", "value", value);
    }
  }, {
    key: "isBigNumber",
    value: function isBigNumber(value) {
      return !!(value && value._isBigNumber);
    }
  }]);

  return BigNumber;
}(); // Normalize the hex string

function toHex(value) {
  // For BN, call on the hex string
  if (typeof value !== "string") {
    return toHex(value.toString(16));
  } // If negative, prepend the negative sign to the normalized positive value


  if (value[0] === "-") {
    // Strip off the negative sign
    value = value.substring(1); // Cannot have multiple negative signs (e.g. "--0x04")

    if (value[0] === "-") {
      logger.throwArgumentError("invalid hex", "value", value);
    } // Call toHex on the positive component


    value = toHex(value); // Do not allow "-0x00"

    if (value === "0x00") {
      return value;
    } // Negate the value


    return "-" + value;
  } // Add a "0x" prefix if missing


  if (value.substring(0, 2) !== "0x") {
    value = "0x" + value;
  } // Normalize zero


  if (value === "0x") {
    return "0x00";
  } // Make the string even length


  if (value.length % 2) {
    value = "0x0" + value.substring(2);
  } // Trim to smallest even-length string


  while (value.length > 4 && value.substring(0, 4) === "0x00") {
    value = "0x" + value.substring(4);
  }

  return value;
}

function toBigNumber(value) {
  return BigNumber.from(toHex(value));
}

function toBN(value) {
  var hex = BigNumber.from(value).toHexString();

  if (hex[0] === "-") {
    return new BN("-" + hex.substring(3), 16);
  }

  return new BN(hex.substring(2), 16);
}

function throwFault(fault, operation, value) {
  var params = {
    fault: fault,
    operation: operation
  };

  if (value != null) {
    params.value = value;
  }

  return logger.throwError(fault, _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.NUMERIC_FAULT, params);
} // value should have no prefix


function _base36To16(value) {
  return new BN(value, 36).toString(16);
} // value should have no prefix

function _base16To36(value) {
  return new BN(value, 16).toString(36);
}

/***/ }),

/***/ "./node_modules/@ethersproject/bignumber/lib.esm/fixednumber.js":
/*!**********************************************************************!*\
  !*** ./node_modules/@ethersproject/bignumber/lib.esm/fixednumber.js ***!
  \**********************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "formatFixed": function() { return /* binding */ formatFixed; },
/* harmony export */   "parseFixed": function() { return /* binding */ parseFixed; },
/* harmony export */   "FixedFormat": function() { return /* binding */ FixedFormat; },
/* harmony export */   "FixedNumber": function() { return /* binding */ FixedNumber; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/bignumber/lib.esm/_version.js");
/* harmony import */ var _bignumber__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }




var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);

var _constructorGuard = {};
var Zero = _bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(0);
var NegativeOne = _bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(-1);

function throwFault(message, fault, operation, value) {
  var params = {
    fault: fault,
    operation: operation
  };

  if (value !== undefined) {
    params.value = value;
  }

  return logger.throwError(message, _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.NUMERIC_FAULT, params);
} // Constant to pull zeros from for multipliers


var zeros = "0";

while (zeros.length < 256) {
  zeros += zeros;
} // Returns a string "1" followed by decimal "0"s


function getMultiplier(decimals) {
  if (typeof decimals !== "number") {
    try {
      decimals = _bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(decimals).toNumber();
    } catch (e) {}
  }

  if (typeof decimals === "number" && decimals >= 0 && decimals <= 256 && !(decimals % 1)) {
    return "1" + zeros.substring(0, decimals);
  }

  return logger.throwArgumentError("invalid decimal size", "decimals", decimals);
}

function formatFixed(value, decimals) {
  if (decimals == null) {
    decimals = 0;
  }

  var multiplier = getMultiplier(decimals); // Make sure wei is a big number (convert as necessary)

  value = _bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(value);
  var negative = value.lt(Zero);

  if (negative) {
    value = value.mul(NegativeOne);
  }

  var fraction = value.mod(multiplier).toString();

  while (fraction.length < multiplier.length - 1) {
    fraction = "0" + fraction;
  } // Strip training 0


  fraction = fraction.match(/^([0-9]*[1-9]|0)(0*)/)[1];
  var whole = value.div(multiplier).toString();

  if (multiplier.length === 1) {
    value = whole;
  } else {
    value = whole + "." + fraction;
  }

  if (negative) {
    value = "-" + value;
  }

  return value;
}
function parseFixed(value, decimals) {
  if (decimals == null) {
    decimals = 0;
  }

  var multiplier = getMultiplier(decimals);

  if (typeof value !== "string" || !value.match(/^-?[0-9.]+$/)) {
    logger.throwArgumentError("invalid decimal value", "value", value);
  } // Is it negative?


  var negative = value.substring(0, 1) === "-";

  if (negative) {
    value = value.substring(1);
  }

  if (value === ".") {
    logger.throwArgumentError("missing value", "value", value);
  } // Split it into a whole and fractional part


  var comps = value.split(".");

  if (comps.length > 2) {
    logger.throwArgumentError("too many decimal points", "value", value);
  }

  var whole = comps[0],
      fraction = comps[1];

  if (!whole) {
    whole = "0";
  }

  if (!fraction) {
    fraction = "0";
  } // Trim trailing zeros


  while (fraction[fraction.length - 1] === "0") {
    fraction = fraction.substring(0, fraction.length - 1);
  } // Check the fraction doesn't exceed our decimals size


  if (fraction.length > multiplier.length - 1) {
    throwFault("fractional component exceeds decimals", "underflow", "parseFixed");
  } // If decimals is 0, we have an empty string for fraction


  if (fraction === "") {
    fraction = "0";
  } // Fully pad the string with zeros to get to wei


  while (fraction.length < multiplier.length - 1) {
    fraction += "0";
  }

  var wholeValue = _bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(whole);
  var fractionValue = _bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(fraction);
  var wei = wholeValue.mul(multiplier).add(fractionValue);

  if (negative) {
    wei = wei.mul(NegativeOne);
  }

  return wei;
}
var FixedFormat = /*#__PURE__*/function () {
  function FixedFormat(constructorGuard, signed, width, decimals) {
    _classCallCheck(this, FixedFormat);

    if (constructorGuard !== _constructorGuard) {
      logger.throwError("cannot use FixedFormat constructor; use FixedFormat.from", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
        operation: "new FixedFormat"
      });
    }

    this.signed = signed;
    this.width = width;
    this.decimals = decimals;
    this.name = (signed ? "" : "u") + "fixed" + String(width) + "x" + String(decimals);
    this._multiplier = getMultiplier(decimals);
    Object.freeze(this);
  }

  _createClass(FixedFormat, null, [{
    key: "from",
    value: function from(value) {
      if (value instanceof FixedFormat) {
        return value;
      }

      if (typeof value === "number") {
        value = "fixed128x".concat(value);
      }

      var signed = true;
      var width = 128;
      var decimals = 18;

      if (typeof value === "string") {
        if (value === "fixed") {// defaults...
        } else if (value === "ufixed") {
          signed = false;
        } else {
          var match = value.match(/^(u?)fixed([0-9]+)x([0-9]+)$/);

          if (!match) {
            logger.throwArgumentError("invalid fixed format", "format", value);
          }

          signed = match[1] !== "u";
          width = parseInt(match[2]);
          decimals = parseInt(match[3]);
        }
      } else if (value) {
        var check = function check(key, type, defaultValue) {
          if (value[key] == null) {
            return defaultValue;
          }

          if (_typeof(value[key]) !== type) {
            logger.throwArgumentError("invalid fixed format (" + key + " not " + type + ")", "format." + key, value[key]);
          }

          return value[key];
        };

        signed = check("signed", "boolean", signed);
        width = check("width", "number", width);
        decimals = check("decimals", "number", decimals);
      }

      if (width % 8) {
        logger.throwArgumentError("invalid fixed format width (not byte aligned)", "format.width", width);
      }

      if (decimals > 80) {
        logger.throwArgumentError("invalid fixed format (decimals too large)", "format.decimals", decimals);
      }

      return new FixedFormat(_constructorGuard, signed, width, decimals);
    }
  }]);

  return FixedFormat;
}();
var FixedNumber = /*#__PURE__*/function () {
  function FixedNumber(constructorGuard, hex, value, format) {
    _classCallCheck(this, FixedNumber);

    logger.checkNew(this instanceof FixedNumber ? this.constructor : void 0, FixedNumber);

    if (constructorGuard !== _constructorGuard) {
      logger.throwError("cannot use FixedNumber constructor; use FixedNumber.from", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
        operation: "new FixedFormat"
      });
    }

    this.format = format;
    this._hex = hex;
    this._value = value;
    this._isFixedNumber = true;
    Object.freeze(this);
  }

  _createClass(FixedNumber, [{
    key: "_checkFormat",
    value: function _checkFormat(other) {
      if (this.format.name !== other.format.name) {
        logger.throwArgumentError("incompatible format; use fixedNumber.toFormat", "other", other);
      }
    }
  }, {
    key: "addUnsafe",
    value: function addUnsafe(other) {
      this._checkFormat(other);

      var a = parseFixed(this._value, this.format.decimals);
      var b = parseFixed(other._value, other.format.decimals);
      return FixedNumber.fromValue(a.add(b), this.format.decimals, this.format);
    }
  }, {
    key: "subUnsafe",
    value: function subUnsafe(other) {
      this._checkFormat(other);

      var a = parseFixed(this._value, this.format.decimals);
      var b = parseFixed(other._value, other.format.decimals);
      return FixedNumber.fromValue(a.sub(b), this.format.decimals, this.format);
    }
  }, {
    key: "mulUnsafe",
    value: function mulUnsafe(other) {
      this._checkFormat(other);

      var a = parseFixed(this._value, this.format.decimals);
      var b = parseFixed(other._value, other.format.decimals);
      return FixedNumber.fromValue(a.mul(b).div(this.format._multiplier), this.format.decimals, this.format);
    }
  }, {
    key: "divUnsafe",
    value: function divUnsafe(other) {
      this._checkFormat(other);

      var a = parseFixed(this._value, this.format.decimals);
      var b = parseFixed(other._value, other.format.decimals);
      return FixedNumber.fromValue(a.mul(this.format._multiplier).div(b), this.format.decimals, this.format);
    }
  }, {
    key: "floor",
    value: function floor() {
      var comps = this.toString().split(".");

      if (comps.length === 1) {
        comps.push("0");
      }

      var result = FixedNumber.from(comps[0], this.format);
      var hasFraction = !comps[1].match(/^(0*)$/);

      if (this.isNegative() && hasFraction) {
        result = result.subUnsafe(ONE.toFormat(result.format));
      }

      return result;
    }
  }, {
    key: "ceiling",
    value: function ceiling() {
      var comps = this.toString().split(".");

      if (comps.length === 1) {
        comps.push("0");
      }

      var result = FixedNumber.from(comps[0], this.format);
      var hasFraction = !comps[1].match(/^(0*)$/);

      if (!this.isNegative() && hasFraction) {
        result = result.addUnsafe(ONE.toFormat(result.format));
      }

      return result;
    } // @TODO: Support other rounding algorithms

  }, {
    key: "round",
    value: function round(decimals) {
      if (decimals == null) {
        decimals = 0;
      } // If we are already in range, we're done


      var comps = this.toString().split(".");

      if (comps.length === 1) {
        comps.push("0");
      }

      if (decimals < 0 || decimals > 80 || decimals % 1) {
        logger.throwArgumentError("invalid decimal count", "decimals", decimals);
      }

      if (comps[1].length <= decimals) {
        return this;
      }

      var factor = FixedNumber.from("1" + zeros.substring(0, decimals), this.format);
      var bump = BUMP.toFormat(this.format);
      return this.mulUnsafe(factor).addUnsafe(bump).floor().divUnsafe(factor);
    }
  }, {
    key: "isZero",
    value: function isZero() {
      return this._value === "0.0" || this._value === "0";
    }
  }, {
    key: "isNegative",
    value: function isNegative() {
      return this._value[0] === "-";
    }
  }, {
    key: "toString",
    value: function toString() {
      return this._value;
    }
  }, {
    key: "toHexString",
    value: function toHexString(width) {
      if (width == null) {
        return this._hex;
      }

      if (width % 8) {
        logger.throwArgumentError("invalid byte width", "width", width);
      }

      var hex = _bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(this._hex).fromTwos(this.format.width).toTwos(width).toHexString();
      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexZeroPad)(hex, width / 8);
    }
  }, {
    key: "toUnsafeFloat",
    value: function toUnsafeFloat() {
      return parseFloat(this.toString());
    }
  }, {
    key: "toFormat",
    value: function toFormat(format) {
      return FixedNumber.fromString(this._value, format);
    }
  }], [{
    key: "fromValue",
    value: function fromValue(value, decimals, format) {
      // If decimals looks more like a format, and there is no format, shift the parameters
      if (format == null && decimals != null && !(0,_bignumber__WEBPACK_IMPORTED_MODULE_2__.isBigNumberish)(decimals)) {
        format = decimals;
        decimals = null;
      }

      if (decimals == null) {
        decimals = 0;
      }

      if (format == null) {
        format = "fixed";
      }

      return FixedNumber.fromString(formatFixed(value, decimals), FixedFormat.from(format));
    }
  }, {
    key: "fromString",
    value: function fromString(value, format) {
      if (format == null) {
        format = "fixed";
      }

      var fixedFormat = FixedFormat.from(format);
      var numeric = parseFixed(value, fixedFormat.decimals);

      if (!fixedFormat.signed && numeric.lt(Zero)) {
        throwFault("unsigned value cannot be negative", "overflow", "value", value);
      }

      var hex = null;

      if (fixedFormat.signed) {
        hex = numeric.toTwos(fixedFormat.width).toHexString();
      } else {
        hex = numeric.toHexString();
        hex = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexZeroPad)(hex, fixedFormat.width / 8);
      }

      var decimal = formatFixed(numeric, fixedFormat.decimals);
      return new FixedNumber(_constructorGuard, hex, decimal, fixedFormat);
    }
  }, {
    key: "fromBytes",
    value: function fromBytes(value, format) {
      if (format == null) {
        format = "fixed";
      }

      var fixedFormat = FixedFormat.from(format);

      if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(value).length > fixedFormat.width / 8) {
        throw new Error("overflow");
      }

      var numeric = _bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(value);

      if (fixedFormat.signed) {
        numeric = numeric.fromTwos(fixedFormat.width);
      }

      var hex = numeric.toTwos((fixedFormat.signed ? 0 : 1) + fixedFormat.width).toHexString();
      var decimal = formatFixed(numeric, fixedFormat.decimals);
      return new FixedNumber(_constructorGuard, hex, decimal, fixedFormat);
    }
  }, {
    key: "from",
    value: function from(value, format) {
      if (typeof value === "string") {
        return FixedNumber.fromString(value, format);
      }

      if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isBytes)(value)) {
        return FixedNumber.fromBytes(value, format);
      }

      try {
        return FixedNumber.fromValue(value, 0, format);
      } catch (error) {
        // Allow NUMERIC_FAULT to bubble up
        if (error.code !== _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INVALID_ARGUMENT) {
          throw error;
        }
      }

      return logger.throwArgumentError("invalid FixedNumber value", "value", value);
    }
  }, {
    key: "isFixedNumber",
    value: function isFixedNumber(value) {
      return !!(value && value._isFixedNumber);
    }
  }]);

  return FixedNumber;
}();
var ONE = FixedNumber.from(1);
var BUMP = FixedNumber.from("0.5");

/***/ }),

/***/ "./node_modules/@ethersproject/bytes/lib.esm/_version.js":
/*!***************************************************************!*\
  !*** ./node_modules/@ethersproject/bytes/lib.esm/_version.js ***!
  \***************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "bytes/5.6.1";

/***/ }),

/***/ "./node_modules/@ethersproject/bytes/lib.esm/index.js":
/*!************************************************************!*\
  !*** ./node_modules/@ethersproject/bytes/lib.esm/index.js ***!
  \************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "isBytesLike": function() { return /* binding */ isBytesLike; },
/* harmony export */   "isBytes": function() { return /* binding */ isBytes; },
/* harmony export */   "arrayify": function() { return /* binding */ arrayify; },
/* harmony export */   "concat": function() { return /* binding */ concat; },
/* harmony export */   "stripZeros": function() { return /* binding */ stripZeros; },
/* harmony export */   "zeroPad": function() { return /* binding */ zeroPad; },
/* harmony export */   "isHexString": function() { return /* binding */ isHexString; },
/* harmony export */   "hexlify": function() { return /* binding */ hexlify; },
/* harmony export */   "hexDataLength": function() { return /* binding */ hexDataLength; },
/* harmony export */   "hexDataSlice": function() { return /* binding */ hexDataSlice; },
/* harmony export */   "hexConcat": function() { return /* binding */ hexConcat; },
/* harmony export */   "hexValue": function() { return /* binding */ hexValue; },
/* harmony export */   "hexStripZeros": function() { return /* binding */ hexStripZeros; },
/* harmony export */   "hexZeroPad": function() { return /* binding */ hexZeroPad; },
/* harmony export */   "splitSignature": function() { return /* binding */ splitSignature; },
/* harmony export */   "joinSignature": function() { return /* binding */ joinSignature; }
/* harmony export */ });
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/bytes/lib.esm/_version.js");




var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version); ///////////////////////////////

function isHexable(value) {
  return !!value.toHexString;
}

function addSlice(array) {
  if (array.slice) {
    return array;
  }

  array.slice = function () {
    var args = Array.prototype.slice.call(arguments);
    return addSlice(new Uint8Array(Array.prototype.slice.apply(array, args)));
  };

  return array;
}

function isBytesLike(value) {
  return isHexString(value) && !(value.length % 2) || isBytes(value);
}

function isInteger(value) {
  return typeof value === "number" && value == value && value % 1 === 0;
}

function isBytes(value) {
  if (value == null) {
    return false;
  }

  if (value.constructor === Uint8Array) {
    return true;
  }

  if (typeof value === "string") {
    return false;
  }

  if (!isInteger(value.length) || value.length < 0) {
    return false;
  }

  for (var i = 0; i < value.length; i++) {
    var v = value[i];

    if (!isInteger(v) || v < 0 || v >= 256) {
      return false;
    }
  }

  return true;
}
function arrayify(value, options) {
  if (!options) {
    options = {};
  }

  if (typeof value === "number") {
    logger.checkSafeUint53(value, "invalid arrayify value");
    var result = [];

    while (value) {
      result.unshift(value & 0xff);
      value = parseInt(String(value / 256));
    }

    if (result.length === 0) {
      result.push(0);
    }

    return addSlice(new Uint8Array(result));
  }

  if (options.allowMissingPrefix && typeof value === "string" && value.substring(0, 2) !== "0x") {
    value = "0x" + value;
  }

  if (isHexable(value)) {
    value = value.toHexString();
  }

  if (isHexString(value)) {
    var hex = value.substring(2);

    if (hex.length % 2) {
      if (options.hexPad === "left") {
        hex = "0" + hex;
      } else if (options.hexPad === "right") {
        hex += "0";
      } else {
        logger.throwArgumentError("hex data is odd-length", "value", value);
      }
    }

    var _result = [];

    for (var i = 0; i < hex.length; i += 2) {
      _result.push(parseInt(hex.substring(i, i + 2), 16));
    }

    return addSlice(new Uint8Array(_result));
  }

  if (isBytes(value)) {
    return addSlice(new Uint8Array(value));
  }

  return logger.throwArgumentError("invalid arrayify value", "value", value);
}
function concat(items) {
  var objects = items.map(function (item) {
    return arrayify(item);
  });
  var length = objects.reduce(function (accum, item) {
    return accum + item.length;
  }, 0);
  var result = new Uint8Array(length);
  objects.reduce(function (offset, object) {
    result.set(object, offset);
    return offset + object.length;
  }, 0);
  return addSlice(result);
}
function stripZeros(value) {
  var result = arrayify(value);

  if (result.length === 0) {
    return result;
  } // Find the first non-zero entry


  var start = 0;

  while (start < result.length && result[start] === 0) {
    start++;
  } // If we started with zeros, strip them


  if (start) {
    result = result.slice(start);
  }

  return result;
}
function zeroPad(value, length) {
  value = arrayify(value);

  if (value.length > length) {
    logger.throwArgumentError("value out of range", "value", arguments[0]);
  }

  var result = new Uint8Array(length);
  result.set(value, length - value.length);
  return addSlice(result);
}
function isHexString(value, length) {
  if (typeof value !== "string" || !value.match(/^0x[0-9A-Fa-f]*$/)) {
    return false;
  }

  if (length && value.length !== 2 + 2 * length) {
    return false;
  }

  return true;
}
var HexCharacters = "0123456789abcdef";
function hexlify(value, options) {
  if (!options) {
    options = {};
  }

  if (typeof value === "number") {
    logger.checkSafeUint53(value, "invalid hexlify value");
    var hex = "";

    while (value) {
      hex = HexCharacters[value & 0xf] + hex;
      value = Math.floor(value / 16);
    }

    if (hex.length) {
      if (hex.length % 2) {
        hex = "0" + hex;
      }

      return "0x" + hex;
    }

    return "0x00";
  }

  if (typeof value === "bigint") {
    value = value.toString(16);

    if (value.length % 2) {
      return "0x0" + value;
    }

    return "0x" + value;
  }

  if (options.allowMissingPrefix && typeof value === "string" && value.substring(0, 2) !== "0x") {
    value = "0x" + value;
  }

  if (isHexable(value)) {
    return value.toHexString();
  }

  if (isHexString(value)) {
    if (value.length % 2) {
      if (options.hexPad === "left") {
        value = "0x0" + value.substring(2);
      } else if (options.hexPad === "right") {
        value += "0";
      } else {
        logger.throwArgumentError("hex data is odd-length", "value", value);
      }
    }

    return value.toLowerCase();
  }

  if (isBytes(value)) {
    var result = "0x";

    for (var i = 0; i < value.length; i++) {
      var v = value[i];
      result += HexCharacters[(v & 0xf0) >> 4] + HexCharacters[v & 0x0f];
    }

    return result;
  }

  return logger.throwArgumentError("invalid hexlify value", "value", value);
}
/*
function unoddify(value: BytesLike | Hexable | number): BytesLike | Hexable | number {
    if (typeof(value) === "string" && value.length % 2 && value.substring(0, 2) === "0x") {
        return "0x0" + value.substring(2);
    }
    return value;
}
*/

function hexDataLength(data) {
  if (typeof data !== "string") {
    data = hexlify(data);
  } else if (!isHexString(data) || data.length % 2) {
    return null;
  }

  return (data.length - 2) / 2;
}
function hexDataSlice(data, offset, endOffset) {
  if (typeof data !== "string") {
    data = hexlify(data);
  } else if (!isHexString(data) || data.length % 2) {
    logger.throwArgumentError("invalid hexData", "value", data);
  }

  offset = 2 + 2 * offset;

  if (endOffset != null) {
    return "0x" + data.substring(offset, 2 + 2 * endOffset);
  }

  return "0x" + data.substring(offset);
}
function hexConcat(items) {
  var result = "0x";
  items.forEach(function (item) {
    result += hexlify(item).substring(2);
  });
  return result;
}
function hexValue(value) {
  var trimmed = hexStripZeros(hexlify(value, {
    hexPad: "left"
  }));

  if (trimmed === "0x") {
    return "0x0";
  }

  return trimmed;
}
function hexStripZeros(value) {
  if (typeof value !== "string") {
    value = hexlify(value);
  }

  if (!isHexString(value)) {
    logger.throwArgumentError("invalid hex string", "value", value);
  }

  value = value.substring(2);
  var offset = 0;

  while (offset < value.length && value[offset] === "0") {
    offset++;
  }

  return "0x" + value.substring(offset);
}
function hexZeroPad(value, length) {
  if (typeof value !== "string") {
    value = hexlify(value);
  } else if (!isHexString(value)) {
    logger.throwArgumentError("invalid hex string", "value", value);
  }

  if (value.length > 2 * length + 2) {
    logger.throwArgumentError("value out of range", "value", arguments[1]);
  }

  while (value.length < 2 * length + 2) {
    value = "0x0" + value.substring(2);
  }

  return value;
}
function splitSignature(signature) {
  var result = {
    r: "0x",
    s: "0x",
    _vs: "0x",
    recoveryParam: 0,
    v: 0,
    yParityAndS: "0x",
    compact: "0x"
  };

  if (isBytesLike(signature)) {
    var bytes = arrayify(signature); // Get the r, s and v

    if (bytes.length === 64) {
      // EIP-2098; pull the v from the top bit of s and clear it
      result.v = 27 + (bytes[32] >> 7);
      bytes[32] &= 0x7f;
      result.r = hexlify(bytes.slice(0, 32));
      result.s = hexlify(bytes.slice(32, 64));
    } else if (bytes.length === 65) {
      result.r = hexlify(bytes.slice(0, 32));
      result.s = hexlify(bytes.slice(32, 64));
      result.v = bytes[64];
    } else {
      logger.throwArgumentError("invalid signature string", "signature", signature);
    } // Allow a recid to be used as the v


    if (result.v < 27) {
      if (result.v === 0 || result.v === 1) {
        result.v += 27;
      } else {
        logger.throwArgumentError("signature invalid v byte", "signature", signature);
      }
    } // Compute recoveryParam from v


    result.recoveryParam = 1 - result.v % 2; // Compute _vs from recoveryParam and s

    if (result.recoveryParam) {
      bytes[32] |= 0x80;
    }

    result._vs = hexlify(bytes.slice(32, 64));
  } else {
    result.r = signature.r;
    result.s = signature.s;
    result.v = signature.v;
    result.recoveryParam = signature.recoveryParam;
    result._vs = signature._vs; // If the _vs is available, use it to populate missing s, v and recoveryParam
    // and verify non-missing s, v and recoveryParam

    if (result._vs != null) {
      var _vs2 = zeroPad(arrayify(result._vs), 32);

      result._vs = hexlify(_vs2); // Set or check the recid

      var recoveryParam = _vs2[0] >= 128 ? 1 : 0;

      if (result.recoveryParam == null) {
        result.recoveryParam = recoveryParam;
      } else if (result.recoveryParam !== recoveryParam) {
        logger.throwArgumentError("signature recoveryParam mismatch _vs", "signature", signature);
      } // Set or check the s


      _vs2[0] &= 0x7f;
      var s = hexlify(_vs2);

      if (result.s == null) {
        result.s = s;
      } else if (result.s !== s) {
        logger.throwArgumentError("signature v mismatch _vs", "signature", signature);
      }
    } // Use recid and v to populate each other


    if (result.recoveryParam == null) {
      if (result.v == null) {
        logger.throwArgumentError("signature missing v and recoveryParam", "signature", signature);
      } else if (result.v === 0 || result.v === 1) {
        result.recoveryParam = result.v;
      } else {
        result.recoveryParam = 1 - result.v % 2;
      }
    } else {
      if (result.v == null) {
        result.v = 27 + result.recoveryParam;
      } else {
        var recId = result.v === 0 || result.v === 1 ? result.v : 1 - result.v % 2;

        if (result.recoveryParam !== recId) {
          logger.throwArgumentError("signature recoveryParam mismatch v", "signature", signature);
        }
      }
    }

    if (result.r == null || !isHexString(result.r)) {
      logger.throwArgumentError("signature missing or invalid r", "signature", signature);
    } else {
      result.r = hexZeroPad(result.r, 32);
    }

    if (result.s == null || !isHexString(result.s)) {
      logger.throwArgumentError("signature missing or invalid s", "signature", signature);
    } else {
      result.s = hexZeroPad(result.s, 32);
    }

    var vs = arrayify(result.s);

    if (vs[0] >= 128) {
      logger.throwArgumentError("signature s out of range", "signature", signature);
    }

    if (result.recoveryParam) {
      vs[0] |= 0x80;
    }

    var _vs = hexlify(vs);

    if (result._vs) {
      if (!isHexString(result._vs)) {
        logger.throwArgumentError("signature invalid _vs", "signature", signature);
      }

      result._vs = hexZeroPad(result._vs, 32);
    } // Set or check the _vs


    if (result._vs == null) {
      result._vs = _vs;
    } else if (result._vs !== _vs) {
      logger.throwArgumentError("signature _vs mismatch v and s", "signature", signature);
    }
  }

  result.yParityAndS = result._vs;
  result.compact = result.r + result.yParityAndS.substring(2);
  return result;
}
function joinSignature(signature) {
  signature = splitSignature(signature);
  return hexlify(concat([signature.r, signature.s, signature.recoveryParam ? "0x1c" : "0x1b"]));
}

/***/ }),

/***/ "./node_modules/@ethersproject/constants/lib.esm/addresses.js":
/*!********************************************************************!*\
  !*** ./node_modules/@ethersproject/constants/lib.esm/addresses.js ***!
  \********************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "AddressZero": function() { return /* binding */ AddressZero; }
/* harmony export */ });
var AddressZero = "0x0000000000000000000000000000000000000000";

/***/ }),

/***/ "./node_modules/@ethersproject/constants/lib.esm/bignumbers.js":
/*!*********************************************************************!*\
  !*** ./node_modules/@ethersproject/constants/lib.esm/bignumbers.js ***!
  \*********************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "NegativeOne": function() { return /* binding */ NegativeOne; },
/* harmony export */   "Zero": function() { return /* binding */ Zero; },
/* harmony export */   "One": function() { return /* binding */ One; },
/* harmony export */   "Two": function() { return /* binding */ Two; },
/* harmony export */   "WeiPerEther": function() { return /* binding */ WeiPerEther; },
/* harmony export */   "MaxUint256": function() { return /* binding */ MaxUint256; },
/* harmony export */   "MinInt256": function() { return /* binding */ MinInt256; },
/* harmony export */   "MaxInt256": function() { return /* binding */ MaxInt256; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");

var NegativeOne = /*#__PURE__*/_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_0__.BigNumber.from(-1);
var Zero = /*#__PURE__*/_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_0__.BigNumber.from(0);
var One = /*#__PURE__*/_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_0__.BigNumber.from(1);
var Two = /*#__PURE__*/_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_0__.BigNumber.from(2);
var WeiPerEther = /*#__PURE__*/_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_0__.BigNumber.from("1000000000000000000");
var MaxUint256 = /*#__PURE__*/_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_0__.BigNumber.from("0xffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff");
var MinInt256 = /*#__PURE__*/_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_0__.BigNumber.from("-0x8000000000000000000000000000000000000000000000000000000000000000");
var MaxInt256 = /*#__PURE__*/_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_0__.BigNumber.from("0x7fffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff");


/***/ }),

/***/ "./node_modules/@ethersproject/constants/lib.esm/hashes.js":
/*!*****************************************************************!*\
  !*** ./node_modules/@ethersproject/constants/lib.esm/hashes.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "HashZero": function() { return /* binding */ HashZero; }
/* harmony export */ });
var HashZero = "0x0000000000000000000000000000000000000000000000000000000000000000";

/***/ }),

/***/ "./node_modules/@ethersproject/contracts/lib.esm/_version.js":
/*!*******************************************************************!*\
  !*** ./node_modules/@ethersproject/contracts/lib.esm/_version.js ***!
  \*******************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "contracts/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/contracts/lib.esm/index.js":
/*!****************************************************************!*\
  !*** ./node_modules/@ethersproject/contracts/lib.esm/index.js ***!
  \****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "BaseContract": function() { return /* binding */ BaseContract; },
/* harmony export */   "Contract": function() { return /* binding */ Contract; },
/* harmony export */   "ContractFactory": function() { return /* binding */ ContractFactory; }
/* harmony export */ });
/* harmony import */ var _ethersproject_abi__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @ethersproject/abi */ "./node_modules/@ethersproject/abi/lib.esm/coders/abstract-coder.js");
/* harmony import */ var _ethersproject_abi__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @ethersproject/abi */ "./node_modules/@ethersproject/abi/lib.esm/interface.js");
/* harmony import */ var _ethersproject_abstract_provider__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @ethersproject/abstract-provider */ "./node_modules/@ethersproject/abstract-provider/lib.esm/index.js");
/* harmony import */ var _ethersproject_abstract_signer__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @ethersproject/abstract-signer */ "./node_modules/@ethersproject/abstract-signer/lib.esm/index.js");
/* harmony import */ var _ethersproject_address__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/address */ "./node_modules/@ethersproject/address/lib.esm/index.js");
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_transactions__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @ethersproject/transactions */ "./node_modules/@ethersproject/transactions/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/contracts/lib.esm/_version.js");


function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};











var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
;
; ///////////////////////////////

var allowedTransactionKeys = {
  chainId: true,
  data: true,
  from: true,
  gasLimit: true,
  gasPrice: true,
  nonce: true,
  to: true,
  value: true,
  type: true,
  accessList: true,
  maxFeePerGas: true,
  maxPriorityFeePerGas: true,
  customData: true,
  ccipReadEnabled: true
};

function resolveName(resolver, nameOrPromise) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var name, address;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return nameOrPromise;

          case 2:
            name = _context.sent;

            if (typeof name !== "string") {
              logger.throwArgumentError("invalid address or ENS name", "name", name);
            } // If it is already an address, just use it (after adding checksum)


            _context.prev = 4;
            return _context.abrupt("return", (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_2__.getAddress)(name));

          case 8:
            _context.prev = 8;
            _context.t0 = _context["catch"](4);

          case 10:
            if (!resolver) {
              logger.throwError("a provider or signer is needed to resolve ENS names", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
                operation: "resolveName"
              });
            }

            _context.next = 13;
            return resolver.resolveName(name);

          case 13:
            address = _context.sent;

            if (address == null) {
              logger.throwArgumentError("resolver or addr is not configured for ENS name", "name", name);
            }

            return _context.abrupt("return", address);

          case 16:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[4, 8]]);
  }));
} // Recursively replaces ENS names with promises to resolve the name and resolves all properties


function resolveAddresses(resolver, value, paramType) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!Array.isArray(paramType)) {
              _context2.next = 4;
              break;
            }

            _context2.next = 3;
            return Promise.all(paramType.map(function (paramType, index) {
              return resolveAddresses(resolver, Array.isArray(value) ? value[index] : value[paramType.name], paramType);
            }));

          case 3:
            return _context2.abrupt("return", _context2.sent);

          case 4:
            if (!(paramType.type === "address")) {
              _context2.next = 8;
              break;
            }

            _context2.next = 7;
            return resolveName(resolver, value);

          case 7:
            return _context2.abrupt("return", _context2.sent);

          case 8:
            if (!(paramType.type === "tuple")) {
              _context2.next = 12;
              break;
            }

            _context2.next = 11;
            return resolveAddresses(resolver, value, paramType.components);

          case 11:
            return _context2.abrupt("return", _context2.sent);

          case 12:
            if (!(paramType.baseType === "array")) {
              _context2.next = 18;
              break;
            }

            if (Array.isArray(value)) {
              _context2.next = 15;
              break;
            }

            return _context2.abrupt("return", Promise.reject(logger.makeError("invalid value for array", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INVALID_ARGUMENT, {
              argument: "value",
              value: value
            })));

          case 15:
            _context2.next = 17;
            return Promise.all(value.map(function (v) {
              return resolveAddresses(resolver, v, paramType.arrayChildren);
            }));

          case 17:
            return _context2.abrupt("return", _context2.sent);

          case 18:
            return _context2.abrupt("return", value);

          case 19:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
}

function populateTransaction(contract, fragment, args) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
    var _this = this;

    var overrides, resolved, data, tx, ro, intrinsic, bytes, i, roValue, leftovers;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            // If an extra argument is given, it is overrides
            overrides = {};

            if (args.length === fragment.inputs.length + 1 && _typeof(args[args.length - 1]) === "object") {
              overrides = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(args.pop());
            } // Make sure the parameter count matches


            logger.checkArgumentCount(args.length, fragment.inputs.length, "passed to contract"); // Populate "from" override (allow promises)

            if (contract.signer) {
              if (overrides.from) {
                // Contracts with a Signer are from the Signer's frame-of-reference;
                // but we allow overriding "from" if it matches the signer
                overrides.from = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.resolveProperties)({
                  override: resolveName(contract.signer, overrides.from),
                  signer: contract.signer.getAddress()
                }).then(function (check) {
                  return __awaiter(_this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
                    return regeneratorRuntime.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            if ((0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_2__.getAddress)(check.signer) !== check.override) {
                              logger.throwError("Contract with a Signer cannot override from", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
                                operation: "overrides.from"
                              });
                            }

                            return _context3.abrupt("return", check.override);

                          case 2:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));
                });
              } else {
                overrides.from = contract.signer.getAddress();
              }
            } else if (overrides.from) {
              overrides.from = resolveName(contract.provider, overrides.from); //} else {
              // Contracts without a signer can override "from", and if
              // unspecified the zero address is used
              //overrides.from = AddressZero;
            } // Wait for all dependencies to be resolved (prefer the signer over the provider)


            _context4.next = 6;
            return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.resolveProperties)({
              args: resolveAddresses(contract.signer || contract.provider, args, fragment.inputs),
              address: contract.resolvedAddress,
              overrides: (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.resolveProperties)(overrides) || {}
            });

          case 6:
            resolved = _context4.sent;
            // The ABI coded transaction
            data = contract["interface"].encodeFunctionData(fragment, resolved.args);
            tx = {
              data: data,
              to: resolved.address
            }; // Resolved Overrides

            ro = resolved.overrides; // Populate simple overrides

            if (ro.nonce != null) {
              tx.nonce = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(ro.nonce).toNumber();
            }

            if (ro.gasLimit != null) {
              tx.gasLimit = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(ro.gasLimit);
            }

            if (ro.gasPrice != null) {
              tx.gasPrice = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(ro.gasPrice);
            }

            if (ro.maxFeePerGas != null) {
              tx.maxFeePerGas = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(ro.maxFeePerGas);
            }

            if (ro.maxPriorityFeePerGas != null) {
              tx.maxPriorityFeePerGas = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(ro.maxPriorityFeePerGas);
            }

            if (ro.from != null) {
              tx.from = ro.from;
            }

            if (ro.type != null) {
              tx.type = ro.type;
            }

            if (ro.accessList != null) {
              tx.accessList = (0,_ethersproject_transactions__WEBPACK_IMPORTED_MODULE_5__.accessListify)(ro.accessList);
            } // If there was no "gasLimit" override, but the ABI specifies a default, use it


            if (tx.gasLimit == null && fragment.gas != null) {
              // Compute the intrinsic gas cost for this transaction
              // @TODO: This is based on the yellow paper as of Petersburg; this is something
              // we may wish to parameterize in v6 as part of the Network object. Since this
              // is always a non-nil to address, we can ignore G_create, but may wish to add
              // similar logic to the ContractFactory.
              intrinsic = 21000;
              bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.arrayify)(data);

              for (i = 0; i < bytes.length; i++) {
                intrinsic += 4;

                if (bytes[i]) {
                  intrinsic += 64;
                }
              }

              tx.gasLimit = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(fragment.gas).add(intrinsic);
            } // Populate "value" override


            if (ro.value) {
              roValue = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(ro.value);

              if (!roValue.isZero() && !fragment.payable) {
                logger.throwError("non-payable method cannot override value", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
                  operation: "overrides.value",
                  value: overrides.value
                });
              }

              tx.value = roValue;
            }

            if (ro.customData) {
              tx.customData = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(ro.customData);
            }

            if (ro.ccipReadEnabled) {
              tx.ccipReadEnabled = !!ro.ccipReadEnabled;
            } // Remove the overrides


            delete overrides.nonce;
            delete overrides.gasLimit;
            delete overrides.gasPrice;
            delete overrides.from;
            delete overrides.value;
            delete overrides.type;
            delete overrides.accessList;
            delete overrides.maxFeePerGas;
            delete overrides.maxPriorityFeePerGas;
            delete overrides.customData;
            delete overrides.ccipReadEnabled; // Make sure there are no stray overrides, which may indicate a
            // typo or using an unsupported key.

            leftovers = Object.keys(overrides).filter(function (key) {
              return overrides[key] != null;
            });

            if (leftovers.length) {
              logger.throwError("cannot override ".concat(leftovers.map(function (l) {
                return JSON.stringify(l);
              }).join(",")), _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
                operation: "overrides",
                overrides: leftovers
              });
            }

            return _context4.abrupt("return", tx);

          case 36:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
}

function buildPopulate(contract, fragment) {
  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return populateTransaction(contract, fragment, args);
  };
}

function buildEstimate(contract, fragment) {
  var signerOrProvider = contract.signer || contract.provider;
  return function () {
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
      var tx;
      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              if (!signerOrProvider) {
                logger.throwError("estimate require a provider or signer", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
                  operation: "estimateGas"
                });
              }

              _context5.next = 3;
              return populateTransaction(contract, fragment, args);

            case 3:
              tx = _context5.sent;
              _context5.next = 6;
              return signerOrProvider.estimateGas(tx);

            case 6:
              return _context5.abrupt("return", _context5.sent);

            case 7:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));
  };
}

function addContractWait(contract, tx) {
  var wait = tx.wait.bind(tx);

  tx.wait = function (confirmations) {
    return wait(confirmations).then(function (receipt) {
      receipt.events = receipt.logs.map(function (log) {
        var event = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.deepCopy)(log);
        var parsed = null;

        try {
          parsed = contract["interface"].parseLog(log);
        } catch (e) {} // Successfully parsed the event log; include it


        if (parsed) {
          event.args = parsed.args;

          event.decode = function (data, topics) {
            return contract["interface"].decodeEventLog(parsed.eventFragment, data, topics);
          };

          event.event = parsed.name;
          event.eventSignature = parsed.signature;
        } // Useful operations


        event.removeListener = function () {
          return contract.provider;
        };

        event.getBlock = function () {
          return contract.provider.getBlock(receipt.blockHash);
        };

        event.getTransaction = function () {
          return contract.provider.getTransaction(receipt.transactionHash);
        };

        event.getTransactionReceipt = function () {
          return Promise.resolve(receipt);
        };

        return event;
      });
      return receipt;
    });
  };
}

function buildCall(contract, fragment, collapseSimple) {
  var signerOrProvider = contract.signer || contract.provider;
  return function () {
    for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
      var blockTag, overrides, tx, result, value;
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              // Extract the "blockTag" override if present
              blockTag = undefined;

              if (!(args.length === fragment.inputs.length + 1 && _typeof(args[args.length - 1]) === "object")) {
                _context6.next = 9;
                break;
              }

              overrides = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(args.pop());

              if (!(overrides.blockTag != null)) {
                _context6.next = 7;
                break;
              }

              _context6.next = 6;
              return overrides.blockTag;

            case 6:
              blockTag = _context6.sent;

            case 7:
              delete overrides.blockTag;
              args.push(overrides);

            case 9:
              if (!(contract.deployTransaction != null)) {
                _context6.next = 12;
                break;
              }

              _context6.next = 12;
              return contract._deployed(blockTag);

            case 12:
              _context6.next = 14;
              return populateTransaction(contract, fragment, args);

            case 14:
              tx = _context6.sent;
              _context6.next = 17;
              return signerOrProvider.call(tx, blockTag);

            case 17:
              result = _context6.sent;
              _context6.prev = 18;
              value = contract["interface"].decodeFunctionResult(fragment, result);

              if (collapseSimple && fragment.outputs.length === 1) {
                value = value[0];
              }

              return _context6.abrupt("return", value);

            case 24:
              _context6.prev = 24;
              _context6.t0 = _context6["catch"](18);

              if (_context6.t0.code === _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.CALL_EXCEPTION) {
                _context6.t0.address = contract.address;
                _context6.t0.args = args;
                _context6.t0.transaction = tx;
              }

              throw _context6.t0;

            case 28:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, null, [[18, 24]]);
    }));
  };
}

function buildSend(contract, fragment) {
  return function () {
    for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
      args[_key4] = arguments[_key4];
    }

    return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
      var txRequest, tx;
      return regeneratorRuntime.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              if (!contract.signer) {
                logger.throwError("sending a transaction requires a signer", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
                  operation: "sendTransaction"
                });
              } // If the contract was just deployed, wait until it is mined


              if (!(contract.deployTransaction != null)) {
                _context7.next = 4;
                break;
              }

              _context7.next = 4;
              return contract._deployed();

            case 4:
              _context7.next = 6;
              return populateTransaction(contract, fragment, args);

            case 6:
              txRequest = _context7.sent;
              _context7.next = 9;
              return contract.signer.sendTransaction(txRequest);

            case 9:
              tx = _context7.sent;
              // Tweak the tx.wait so the receipt has extra properties
              addContractWait(contract, tx);
              return _context7.abrupt("return", tx);

            case 12:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }));
  };
}

function buildDefault(contract, fragment, collapseSimple) {
  if (fragment.constant) {
    return buildCall(contract, fragment, collapseSimple);
  }

  return buildSend(contract, fragment);
}

function getEventTag(filter) {
  if (filter.address && (filter.topics == null || filter.topics.length === 0)) {
    return "*";
  }

  return (filter.address || "*") + "@" + (filter.topics ? filter.topics.map(function (topic) {
    if (Array.isArray(topic)) {
      return topic.join("|");
    }

    return topic;
  }).join(":") : "");
}

var RunningEvent = /*#__PURE__*/function () {
  function RunningEvent(tag, filter) {
    _classCallCheck(this, RunningEvent);

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "tag", tag);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "filter", filter);
    this._listeners = [];
  }

  _createClass(RunningEvent, [{
    key: "addListener",
    value: function addListener(listener, once) {
      this._listeners.push({
        listener: listener,
        once: once
      });
    }
  }, {
    key: "removeListener",
    value: function removeListener(listener) {
      var done = false;
      this._listeners = this._listeners.filter(function (item) {
        if (done || item.listener !== listener) {
          return true;
        }

        done = true;
        return false;
      });
    }
  }, {
    key: "removeAllListeners",
    value: function removeAllListeners() {
      this._listeners = [];
    }
  }, {
    key: "listeners",
    value: function listeners() {
      return this._listeners.map(function (i) {
        return i.listener;
      });
    }
  }, {
    key: "listenerCount",
    value: function listenerCount() {
      return this._listeners.length;
    }
  }, {
    key: "run",
    value: function run(args) {
      var _this2 = this;

      var listenerCount = this.listenerCount();
      this._listeners = this._listeners.filter(function (item) {
        var argsCopy = args.slice(); // Call the callback in the next event loop

        setTimeout(function () {
          item.listener.apply(_this2, argsCopy);
        }, 0); // Reschedule it if it not "once"

        return !item.once;
      });
      return listenerCount;
    }
  }, {
    key: "prepareEvent",
    value: function prepareEvent(event) {} // Returns the array that will be applied to an emit

  }, {
    key: "getEmit",
    value: function getEmit(event) {
      return [event];
    }
  }]);

  return RunningEvent;
}();

var ErrorRunningEvent = /*#__PURE__*/function (_RunningEvent) {
  _inherits(ErrorRunningEvent, _RunningEvent);

  var _super = _createSuper(ErrorRunningEvent);

  function ErrorRunningEvent() {
    _classCallCheck(this, ErrorRunningEvent);

    return _super.call(this, "error", null);
  }

  return ErrorRunningEvent;
}(RunningEvent); // @TODO Fragment should inherit Wildcard? and just override getEmit?
//       or have a common abstract super class, with enough constructor
//       options to configure both.
// A Fragment Event will populate all the properties that Wildcard
// will, and additionally dereference the arguments when emitting


var FragmentRunningEvent = /*#__PURE__*/function (_RunningEvent2) {
  _inherits(FragmentRunningEvent, _RunningEvent2);

  var _super2 = _createSuper(FragmentRunningEvent);

  function FragmentRunningEvent(address, contractInterface, fragment, topics) {
    var _this3;

    _classCallCheck(this, FragmentRunningEvent);

    var filter = {
      address: address
    };
    var topic = contractInterface.getEventTopic(fragment);

    if (topics) {
      if (topic !== topics[0]) {
        logger.throwArgumentError("topic mismatch", "topics", topics);
      }

      filter.topics = topics.slice();
    } else {
      filter.topics = [topic];
    }

    _this3 = _super2.call(this, getEventTag(filter), filter);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this3), "address", address);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this3), "interface", contractInterface);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this3), "fragment", fragment);
    return _this3;
  }

  _createClass(FragmentRunningEvent, [{
    key: "prepareEvent",
    value: function prepareEvent(event) {
      var _this4 = this;

      _get(_getPrototypeOf(FragmentRunningEvent.prototype), "prepareEvent", this).call(this, event);

      event.event = this.fragment.name;
      event.eventSignature = this.fragment.format();

      event.decode = function (data, topics) {
        return _this4["interface"].decodeEventLog(_this4.fragment, data, topics);
      };

      try {
        event.args = this["interface"].decodeEventLog(this.fragment, event.data, event.topics);
      } catch (error) {
        event.args = null;
        event.decodeError = error;
      }
    }
  }, {
    key: "getEmit",
    value: function getEmit(event) {
      var errors = (0,_ethersproject_abi__WEBPACK_IMPORTED_MODULE_7__.checkResultErrors)(event.args);

      if (errors.length) {
        throw errors[0].error;
      }

      var args = (event.args || []).slice();
      args.push(event);
      return args;
    }
  }]);

  return FragmentRunningEvent;
}(RunningEvent); // A Wildcard Event will attempt to populate:
//  - event            The name of the event name
//  - eventSignature   The full signature of the event
//  - decode           A function to decode data and topics
//  - args             The decoded data and topics


var WildcardRunningEvent = /*#__PURE__*/function (_RunningEvent3) {
  _inherits(WildcardRunningEvent, _RunningEvent3);

  var _super3 = _createSuper(WildcardRunningEvent);

  function WildcardRunningEvent(address, contractInterface) {
    var _this5;

    _classCallCheck(this, WildcardRunningEvent);

    _this5 = _super3.call(this, "*", {
      address: address
    });
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this5), "address", address);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this5), "interface", contractInterface);
    return _this5;
  }

  _createClass(WildcardRunningEvent, [{
    key: "prepareEvent",
    value: function prepareEvent(event) {
      var _this6 = this;

      _get(_getPrototypeOf(WildcardRunningEvent.prototype), "prepareEvent", this).call(this, event);

      try {
        var parsed = this["interface"].parseLog(event);
        event.event = parsed.name;
        event.eventSignature = parsed.signature;

        event.decode = function (data, topics) {
          return _this6["interface"].decodeEventLog(parsed.eventFragment, data, topics);
        };

        event.args = parsed.args;
      } catch (error) {// No matching event
      }
    }
  }]);

  return WildcardRunningEvent;
}(RunningEvent);

var BaseContract = /*#__PURE__*/function () {
  function BaseContract(addressOrName, contractInterface, signerOrProvider) {
    var _this7 = this;

    _classCallCheck(this, BaseContract);

    logger.checkNew(this instanceof BaseContract ? this.constructor : void 0, Contract); // @TODO: Maybe still check the addressOrName looks like a valid address or name?
    //address = getAddress(address);

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "interface", (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.getStatic)(this instanceof BaseContract ? this.constructor : void 0, "getInterface")(contractInterface));

    if (signerOrProvider == null) {
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "provider", null);
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "signer", null);
    } else if (_ethersproject_abstract_signer__WEBPACK_IMPORTED_MODULE_8__.Signer.isSigner(signerOrProvider)) {
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "provider", signerOrProvider.provider || null);
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "signer", signerOrProvider);
    } else if (_ethersproject_abstract_provider__WEBPACK_IMPORTED_MODULE_9__.Provider.isProvider(signerOrProvider)) {
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "provider", signerOrProvider);
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "signer", null);
    } else {
      logger.throwArgumentError("invalid signer or provider", "signerOrProvider", signerOrProvider);
    }

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "callStatic", {});
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "estimateGas", {});
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "functions", {});
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "populateTransaction", {});
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "filters", {});
    {
      var uniqueFilters = {};
      Object.keys(this["interface"].events).forEach(function (eventSignature) {
        var event = _this7["interface"].events[eventSignature];
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_this7.filters, eventSignature, function () {
          for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
            args[_key5] = arguments[_key5];
          }

          return {
            address: _this7.address,
            topics: _this7["interface"].encodeFilterTopics(event, args)
          };
        });

        if (!uniqueFilters[event.name]) {
          uniqueFilters[event.name] = [];
        }

        uniqueFilters[event.name].push(eventSignature);
      });
      Object.keys(uniqueFilters).forEach(function (name) {
        var filters = uniqueFilters[name];

        if (filters.length === 1) {
          (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_this7.filters, name, _this7.filters[filters[0]]);
        } else {
          logger.warn("Duplicate definition of ".concat(name, " (").concat(filters.join(", "), ")"));
        }
      });
    }
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "_runningEvents", {});
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "_wrappedEmits", {});

    if (addressOrName == null) {
      logger.throwArgumentError("invalid contract address or ENS name", "addressOrName", addressOrName);
    }

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "address", addressOrName);

    if (this.provider) {
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "resolvedAddress", resolveName(this.provider, addressOrName));
    } else {
      try {
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "resolvedAddress", Promise.resolve((0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_2__.getAddress)(addressOrName)));
      } catch (error) {
        // Without a provider, we cannot use ENS names
        logger.throwError("provider is required to use ENS name as contract address", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
          operation: "new Contract"
        });
      }
    } // Swallow bad ENS names to prevent Unhandled Exceptions


    this.resolvedAddress["catch"](function (e) {});
    var uniqueNames = {};
    var uniqueSignatures = {};
    Object.keys(this["interface"].functions).forEach(function (signature) {
      var fragment = _this7["interface"].functions[signature]; // Check that the signature is unique; if not the ABI generation has
      // not been cleaned or may be incorrectly generated

      if (uniqueSignatures[signature]) {
        logger.warn("Duplicate ABI entry for ".concat(JSON.stringify(signature)));
        return;
      }

      uniqueSignatures[signature] = true; // Track unique names; we only expose bare named functions if they
      // are ambiguous

      {
        var name = fragment.name;

        if (!uniqueNames["%".concat(name)]) {
          uniqueNames["%".concat(name)] = [];
        }

        uniqueNames["%".concat(name)].push(signature);
      }

      if (_this7[signature] == null) {
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_this7, signature, buildDefault(_this7, fragment, true));
      } // We do not collapse simple calls on this bucket, which allows
      // frameworks to safely use this without introspection as well as
      // allows decoding error recovery.


      if (_this7.functions[signature] == null) {
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_this7.functions, signature, buildDefault(_this7, fragment, false));
      }

      if (_this7.callStatic[signature] == null) {
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_this7.callStatic, signature, buildCall(_this7, fragment, true));
      }

      if (_this7.populateTransaction[signature] == null) {
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_this7.populateTransaction, signature, buildPopulate(_this7, fragment));
      }

      if (_this7.estimateGas[signature] == null) {
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_this7.estimateGas, signature, buildEstimate(_this7, fragment));
      }
    });
    Object.keys(uniqueNames).forEach(function (name) {
      // Ambiguous names to not get attached as bare names
      var signatures = uniqueNames[name];

      if (signatures.length > 1) {
        return;
      } // Strip off the leading "%" used for prototype protection


      name = name.substring(1);
      var signature = signatures[0]; // If overwriting a member property that is null, swallow the error

      try {
        if (_this7[name] == null) {
          (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_this7, name, _this7[signature]);
        }
      } catch (e) {}

      if (_this7.functions[name] == null) {
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_this7.functions, name, _this7.functions[signature]);
      }

      if (_this7.callStatic[name] == null) {
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_this7.callStatic, name, _this7.callStatic[signature]);
      }

      if (_this7.populateTransaction[name] == null) {
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_this7.populateTransaction, name, _this7.populateTransaction[signature]);
      }

      if (_this7.estimateGas[name] == null) {
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_this7.estimateGas, name, _this7.estimateGas[signature]);
      }
    });
  }

  _createClass(BaseContract, [{
    key: "deployed",
    value: // @TODO: Allow timeout?
    function deployed() {
      return this._deployed();
    }
  }, {
    key: "_deployed",
    value: function _deployed(blockTag) {
      var _this8 = this;

      if (!this._deployedPromise) {
        // If we were just deployed, we know the transaction we should occur in
        if (this.deployTransaction) {
          this._deployedPromise = this.deployTransaction.wait().then(function () {
            return _this8;
          });
        } else {
          // @TODO: Once we allow a timeout to be passed in, we will wait
          // up to that many blocks for getCode
          // Otherwise, poll for our code to be deployed
          this._deployedPromise = this.provider.getCode(this.address, blockTag).then(function (code) {
            if (code === "0x") {
              logger.throwError("contract not deployed", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
                contractAddress: _this8.address,
                operation: "getDeployed"
              });
            }

            return _this8;
          });
        }
      }

      return this._deployedPromise;
    } // @TODO:
    // estimateFallback(overrides?: TransactionRequest): Promise<BigNumber>
    // @TODO:
    // estimateDeploy(bytecode: string, ...args): Promise<BigNumber>

  }, {
    key: "fallback",
    value: function fallback(overrides) {
      var _this9 = this;

      if (!this.signer) {
        logger.throwError("sending a transactions require a signer", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
          operation: "sendTransaction(fallback)"
        });
      }

      var tx = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(overrides || {});
      ["from", "to"].forEach(function (key) {
        if (tx[key] == null) {
          return;
        }

        logger.throwError("cannot override " + key, _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
          operation: key
        });
      });
      tx.to = this.resolvedAddress;
      return this.deployed().then(function () {
        return _this9.signer.sendTransaction(tx);
      });
    } // Reconnect to a different signer or provider

  }, {
    key: "connect",
    value: function connect(signerOrProvider) {
      if (typeof signerOrProvider === "string") {
        signerOrProvider = new _ethersproject_abstract_signer__WEBPACK_IMPORTED_MODULE_8__.VoidSigner(signerOrProvider, this.provider);
      }

      var contract = new this.constructor(this.address, this["interface"], signerOrProvider);

      if (this.deployTransaction) {
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(contract, "deployTransaction", this.deployTransaction);
      }

      return contract;
    } // Re-attach to a different on-chain instance of this contract

  }, {
    key: "attach",
    value: function attach(addressOrName) {
      return new this.constructor(addressOrName, this["interface"], this.signer || this.provider);
    }
  }, {
    key: "_normalizeRunningEvent",
    value: function _normalizeRunningEvent(runningEvent) {
      // Already have an instance of this event running; we can re-use it
      if (this._runningEvents[runningEvent.tag]) {
        return this._runningEvents[runningEvent.tag];
      }

      return runningEvent;
    }
  }, {
    key: "_getRunningEvent",
    value: function _getRunningEvent(eventName) {
      if (typeof eventName === "string") {
        // Listen for "error" events (if your contract has an error event, include
        // the full signature to bypass this special event keyword)
        if (eventName === "error") {
          return this._normalizeRunningEvent(new ErrorRunningEvent());
        } // Listen for any event that is registered


        if (eventName === "event") {
          return this._normalizeRunningEvent(new RunningEvent("event", null));
        } // Listen for any event


        if (eventName === "*") {
          return this._normalizeRunningEvent(new WildcardRunningEvent(this.address, this["interface"]));
        } // Get the event Fragment (throws if ambiguous/unknown event)


        var fragment = this["interface"].getEvent(eventName);
        return this._normalizeRunningEvent(new FragmentRunningEvent(this.address, this["interface"], fragment));
      } // We have topics to filter by...


      if (eventName.topics && eventName.topics.length > 0) {
        // Is it a known topichash? (throws if no matching topichash)
        try {
          var topic = eventName.topics[0];

          if (typeof topic !== "string") {
            throw new Error("invalid topic"); // @TODO: May happen for anonymous events
          }

          var _fragment = this["interface"].getEvent(topic);

          return this._normalizeRunningEvent(new FragmentRunningEvent(this.address, this["interface"], _fragment, eventName.topics));
        } catch (error) {} // Filter by the unknown topichash


        var filter = {
          address: this.address,
          topics: eventName.topics
        };
        return this._normalizeRunningEvent(new RunningEvent(getEventTag(filter), filter));
      }

      return this._normalizeRunningEvent(new WildcardRunningEvent(this.address, this["interface"]));
    }
  }, {
    key: "_checkRunningEvents",
    value: function _checkRunningEvents(runningEvent) {
      if (runningEvent.listenerCount() === 0) {
        delete this._runningEvents[runningEvent.tag]; // If we have a poller for this, remove it

        var emit = this._wrappedEmits[runningEvent.tag];

        if (emit && runningEvent.filter) {
          this.provider.off(runningEvent.filter, emit);
          delete this._wrappedEmits[runningEvent.tag];
        }
      }
    } // Subclasses can override this to gracefully recover
    // from parse errors if they wish

  }, {
    key: "_wrapEvent",
    value: function _wrapEvent(runningEvent, log, listener) {
      var _this10 = this;

      var event = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.deepCopy)(log);

      event.removeListener = function () {
        if (!listener) {
          return;
        }

        runningEvent.removeListener(listener);

        _this10._checkRunningEvents(runningEvent);
      };

      event.getBlock = function () {
        return _this10.provider.getBlock(log.blockHash);
      };

      event.getTransaction = function () {
        return _this10.provider.getTransaction(log.transactionHash);
      };

      event.getTransactionReceipt = function () {
        return _this10.provider.getTransactionReceipt(log.transactionHash);
      }; // This may throw if the topics and data mismatch the signature


      runningEvent.prepareEvent(event);
      return event;
    }
  }, {
    key: "_addEventListener",
    value: function _addEventListener(runningEvent, listener, once) {
      var _this11 = this;

      if (!this.provider) {
        logger.throwError("events require a provider or a signer with a provider", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
          operation: "once"
        });
      }

      runningEvent.addListener(listener, once); // Track this running event and its listeners (may already be there; but no hard in updating)

      this._runningEvents[runningEvent.tag] = runningEvent; // If we are not polling the provider, start polling

      if (!this._wrappedEmits[runningEvent.tag]) {
        var wrappedEmit = function wrappedEmit(log) {
          var event = _this11._wrapEvent(runningEvent, log, listener); // Try to emit the result for the parameterized event...


          if (event.decodeError == null) {
            try {
              var args = runningEvent.getEmit(event);

              _this11.emit.apply(_this11, [runningEvent.filter].concat(_toConsumableArray(args)));
            } catch (error) {
              event.decodeError = error.error;
            }
          } // Always emit "event" for fragment-base events


          if (runningEvent.filter != null) {
            _this11.emit("event", event);
          } // Emit "error" if there was an error


          if (event.decodeError != null) {
            _this11.emit("error", event.decodeError, event);
          }
        };

        this._wrappedEmits[runningEvent.tag] = wrappedEmit; // Special events, like "error" do not have a filter

        if (runningEvent.filter != null) {
          this.provider.on(runningEvent.filter, wrappedEmit);
        }
      }
    }
  }, {
    key: "queryFilter",
    value: function queryFilter(event, fromBlockOrBlockhash, toBlock) {
      var _this12 = this;

      var runningEvent = this._getRunningEvent(event);

      var filter = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(runningEvent.filter);

      if (typeof fromBlockOrBlockhash === "string" && (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.isHexString)(fromBlockOrBlockhash, 32)) {
        if (toBlock != null) {
          logger.throwArgumentError("cannot specify toBlock with blockhash", "toBlock", toBlock);
        }

        filter.blockHash = fromBlockOrBlockhash;
      } else {
        filter.fromBlock = fromBlockOrBlockhash != null ? fromBlockOrBlockhash : 0;
        filter.toBlock = toBlock != null ? toBlock : "latest";
      }

      return this.provider.getLogs(filter).then(function (logs) {
        return logs.map(function (log) {
          return _this12._wrapEvent(runningEvent, log, null);
        });
      });
    }
  }, {
    key: "on",
    value: function on(event, listener) {
      this._addEventListener(this._getRunningEvent(event), listener, false);

      return this;
    }
  }, {
    key: "once",
    value: function once(event, listener) {
      this._addEventListener(this._getRunningEvent(event), listener, true);

      return this;
    }
  }, {
    key: "emit",
    value: function emit(eventName) {
      if (!this.provider) {
        return false;
      }

      var runningEvent = this._getRunningEvent(eventName);

      for (var _len6 = arguments.length, args = new Array(_len6 > 1 ? _len6 - 1 : 0), _key6 = 1; _key6 < _len6; _key6++) {
        args[_key6 - 1] = arguments[_key6];
      }

      var result = runningEvent.run(args) > 0; // May have drained all the "once" events; check for living events

      this._checkRunningEvents(runningEvent);

      return result;
    }
  }, {
    key: "listenerCount",
    value: function listenerCount(eventName) {
      var _this13 = this;

      if (!this.provider) {
        return 0;
      }

      if (eventName == null) {
        return Object.keys(this._runningEvents).reduce(function (accum, key) {
          return accum + _this13._runningEvents[key].listenerCount();
        }, 0);
      }

      return this._getRunningEvent(eventName).listenerCount();
    }
  }, {
    key: "listeners",
    value: function listeners(eventName) {
      var _this14 = this;

      if (!this.provider) {
        return [];
      }

      if (eventName == null) {
        var _ret = function () {
          var result = [];

          for (var tag in _this14._runningEvents) {
            _this14._runningEvents[tag].listeners().forEach(function (listener) {
              result.push(listener);
            });
          }

          return {
            v: result
          };
        }();

        if (_typeof(_ret) === "object") return _ret.v;
      }

      return this._getRunningEvent(eventName).listeners();
    }
  }, {
    key: "removeAllListeners",
    value: function removeAllListeners(eventName) {
      if (!this.provider) {
        return this;
      }

      if (eventName == null) {
        for (var tag in this._runningEvents) {
          var _runningEvent = this._runningEvents[tag];

          _runningEvent.removeAllListeners();

          this._checkRunningEvents(_runningEvent);
        }

        return this;
      } // Delete any listeners


      var runningEvent = this._getRunningEvent(eventName);

      runningEvent.removeAllListeners();

      this._checkRunningEvents(runningEvent);

      return this;
    }
  }, {
    key: "off",
    value: function off(eventName, listener) {
      if (!this.provider) {
        return this;
      }

      var runningEvent = this._getRunningEvent(eventName);

      runningEvent.removeListener(listener);

      this._checkRunningEvents(runningEvent);

      return this;
    }
  }, {
    key: "removeListener",
    value: function removeListener(eventName, listener) {
      return this.off(eventName, listener);
    }
  }], [{
    key: "getContractAddress",
    value: function getContractAddress(transaction) {
      return (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_2__.getContractAddress)(transaction);
    }
  }, {
    key: "getInterface",
    value: function getInterface(contractInterface) {
      if (_ethersproject_abi__WEBPACK_IMPORTED_MODULE_10__.Interface.isInterface(contractInterface)) {
        return contractInterface;
      }

      return new _ethersproject_abi__WEBPACK_IMPORTED_MODULE_10__.Interface(contractInterface);
    }
  }, {
    key: "isIndexed",
    value: function isIndexed(value) {
      return _ethersproject_abi__WEBPACK_IMPORTED_MODULE_10__.Indexed.isIndexed(value);
    }
  }]);

  return BaseContract;
}();
var Contract = /*#__PURE__*/function (_BaseContract) {
  _inherits(Contract, _BaseContract);

  var _super4 = _createSuper(Contract);

  function Contract() {
    _classCallCheck(this, Contract);

    return _super4.apply(this, arguments);
  }

  return Contract;
}(BaseContract);
var ContractFactory = /*#__PURE__*/function () {
  function ContractFactory(contractInterface, bytecode, signer) {
    _classCallCheck(this, ContractFactory);

    var bytecodeHex = null;

    if (typeof bytecode === "string") {
      bytecodeHex = bytecode;
    } else if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.isBytes)(bytecode)) {
      bytecodeHex = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexlify)(bytecode);
    } else if (bytecode && typeof bytecode.object === "string") {
      // Allow the bytecode object from the Solidity compiler
      bytecodeHex = bytecode.object;
    } else {
      // Crash in the next verification step
      bytecodeHex = "!";
    } // Make sure it is 0x prefixed


    if (bytecodeHex.substring(0, 2) !== "0x") {
      bytecodeHex = "0x" + bytecodeHex;
    } // Make sure the final result is valid bytecode


    if (!(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.isHexString)(bytecodeHex) || bytecodeHex.length % 2) {
      logger.throwArgumentError("invalid bytecode", "bytecode", bytecode);
    } // If we have a signer, make sure it is valid


    if (signer && !_ethersproject_abstract_signer__WEBPACK_IMPORTED_MODULE_8__.Signer.isSigner(signer)) {
      logger.throwArgumentError("invalid signer", "signer", signer);
    }

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "bytecode", bytecodeHex);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "interface", (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.getStatic)(this instanceof ContractFactory ? this.constructor : void 0, "getInterface")(contractInterface));
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "signer", signer || null);
  } // @TODO: Future; rename to populateTransaction?


  _createClass(ContractFactory, [{
    key: "getDeployTransaction",
    value: function getDeployTransaction() {
      var tx = {}; // If we have 1 additional argument, we allow transaction overrides

      for (var _len7 = arguments.length, args = new Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
        args[_key7] = arguments[_key7];
      }

      if (args.length === this["interface"].deploy.inputs.length + 1 && _typeof(args[args.length - 1]) === "object") {
        tx = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(args.pop());

        for (var key in tx) {
          if (!allowedTransactionKeys[key]) {
            throw new Error("unknown transaction override " + key);
          }
        }
      } // Do not allow these to be overridden in a deployment transaction


      ["data", "from", "to"].forEach(function (key) {
        if (tx[key] == null) {
          return;
        }

        logger.throwError("cannot override " + key, _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
          operation: key
        });
      });

      if (tx.value) {
        var value = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(tx.value);

        if (!value.isZero() && !this["interface"].deploy.payable) {
          logger.throwError("non-payable constructor cannot override value", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
            operation: "overrides.value",
            value: tx.value
          });
        }
      } // Make sure the call matches the constructor signature


      logger.checkArgumentCount(args.length, this["interface"].deploy.inputs.length, " in Contract constructor"); // Set the data to the bytecode + the encoded constructor arguments

      tx.data = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexlify)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.concat)([this.bytecode, this["interface"].encodeDeploy(args)]));
      return tx;
    }
  }, {
    key: "deploy",
    value: function deploy() {
      for (var _len8 = arguments.length, args = new Array(_len8), _key8 = 0; _key8 < _len8; _key8++) {
        args[_key8] = arguments[_key8];
      }

      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
        var overrides, params, unsignedTx, tx, address, contract;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                overrides = {}; // If 1 extra parameter was passed in, it contains overrides

                if (args.length === this["interface"].deploy.inputs.length + 1) {
                  overrides = args.pop();
                } // Make sure the call matches the constructor signature


                logger.checkArgumentCount(args.length, this["interface"].deploy.inputs.length, " in Contract constructor"); // Resolve ENS names and promises in the arguments

                _context8.next = 5;
                return resolveAddresses(this.signer, args, this["interface"].deploy.inputs);

              case 5:
                params = _context8.sent;
                params.push(overrides); // Get the deployment transaction (with optional overrides)

                unsignedTx = this.getDeployTransaction.apply(this, _toConsumableArray(params)); // Send the deployment transaction

                _context8.next = 10;
                return this.signer.sendTransaction(unsignedTx);

              case 10:
                tx = _context8.sent;
                address = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.getStatic)(this.constructor, "getContractAddress")(tx);
                contract = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.getStatic)(this.constructor, "getContract")(address, this["interface"], this.signer); // Add the modified wait that wraps events

                addContractWait(contract, tx);
                (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(contract, "deployTransaction", tx);
                return _context8.abrupt("return", contract);

              case 16:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));
    }
  }, {
    key: "attach",
    value: function attach(address) {
      return this.constructor.getContract(address, this["interface"], this.signer);
    }
  }, {
    key: "connect",
    value: function connect(signer) {
      return new this.constructor(this["interface"], this.bytecode, signer);
    }
  }], [{
    key: "fromSolidity",
    value: function fromSolidity(compilerOutput, signer) {
      if (compilerOutput == null) {
        logger.throwError("missing compiler output", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.MISSING_ARGUMENT, {
          argument: "compilerOutput"
        });
      }

      if (typeof compilerOutput === "string") {
        compilerOutput = JSON.parse(compilerOutput);
      }

      var abi = compilerOutput.abi;
      var bytecode = null;

      if (compilerOutput.bytecode) {
        bytecode = compilerOutput.bytecode;
      } else if (compilerOutput.evm && compilerOutput.evm.bytecode) {
        bytecode = compilerOutput.evm.bytecode;
      }

      return new this(abi, bytecode, signer);
    }
  }, {
    key: "getInterface",
    value: function getInterface(contractInterface) {
      return Contract.getInterface(contractInterface);
    }
  }, {
    key: "getContractAddress",
    value: function getContractAddress(tx) {
      return (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_2__.getContractAddress)(tx);
    }
  }, {
    key: "getContract",
    value: function getContract(address, contractInterface, signer) {
      return new Contract(address, contractInterface, signer);
    }
  }]);

  return ContractFactory;
}();

/***/ }),

/***/ "./node_modules/@ethersproject/hash/lib.esm/_version.js":
/*!**************************************************************!*\
  !*** ./node_modules/@ethersproject/hash/lib.esm/_version.js ***!
  \**************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "hash/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/hash/lib.esm/id.js":
/*!********************************************************!*\
  !*** ./node_modules/@ethersproject/hash/lib.esm/id.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "id": function() { return /* binding */ id; }
/* harmony export */ });
/* harmony import */ var _ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/keccak256 */ "./node_modules/@ethersproject/keccak256/lib.esm/index.js");
/* harmony import */ var _ethersproject_strings__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @ethersproject/strings */ "./node_modules/@ethersproject/strings/lib.esm/utf8.js");


function id(text) {
  return (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_0__.keccak256)((0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_1__.toUtf8Bytes)(text));
}

/***/ }),

/***/ "./node_modules/@ethersproject/hash/lib.esm/namehash.js":
/*!**************************************************************!*\
  !*** ./node_modules/@ethersproject/hash/lib.esm/namehash.js ***!
  \**************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "isValidName": function() { return /* binding */ isValidName; },
/* harmony export */   "namehash": function() { return /* binding */ namehash; },
/* harmony export */   "dnsEncode": function() { return /* binding */ dnsEncode; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_strings__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/strings */ "./node_modules/@ethersproject/strings/lib.esm/idna.js");
/* harmony import */ var _ethersproject_strings__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/strings */ "./node_modules/@ethersproject/strings/lib.esm/utf8.js");
/* harmony import */ var _ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/keccak256 */ "./node_modules/@ethersproject/keccak256/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/hash/lib.esm/_version.js");





var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
var Zeros = new Uint8Array(32);
Zeros.fill(0);
var Partition = new RegExp("^((.*)\\.)?([^.]+)$");
function isValidName(name) {
  try {
    var comps = name.split(".");

    for (var i = 0; i < comps.length; i++) {
      if ((0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_2__.nameprep)(comps[i]).length === 0) {
        throw new Error("empty");
      }
    }

    return true;
  } catch (error) {}

  return false;
}
function namehash(name) {
  /* istanbul ignore if */
  if (typeof name !== "string") {
    logger.throwArgumentError("invalid ENS name; not a string", "name", name);
  }

  var current = name;
  var result = Zeros;

  while (current.length) {
    var partition = current.match(Partition);

    if (partition == null || partition[2] === "") {
      logger.throwArgumentError("invalid ENS address; missing component", "name", name);
    }

    var label = (0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_3__.toUtf8Bytes)((0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_2__.nameprep)(partition[3]));
    result = (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_4__.keccak256)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.concat)([result, (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_4__.keccak256)(label)]));
    current = partition[2] || "";
  }

  return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexlify)(result);
}
function dnsEncode(name) {
  return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexlify)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.concat)(name.split(".").map(function (comp) {
    // We jam in an _ prefix to fill in with the length later
    // Note: Nameprep throws if the component is over 63 bytes
    var bytes = (0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_3__.toUtf8Bytes)("_" + (0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_2__.nameprep)(comp));
    bytes[0] = bytes.length - 1;
    return bytes;
  }))) + "00";
}

/***/ }),

/***/ "./node_modules/@ethersproject/hash/lib.esm/typed-data.js":
/*!****************************************************************!*\
  !*** ./node_modules/@ethersproject/hash/lib.esm/typed-data.js ***!
  \****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "TypedDataEncoder": function() { return /* binding */ TypedDataEncoder; }
/* harmony export */ });
/* harmony import */ var _ethersproject_address__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/address */ "./node_modules/@ethersproject/address/lib.esm/index.js");
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @ethersproject/keccak256 */ "./node_modules/@ethersproject/keccak256/lib.esm/index.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/hash/lib.esm/_version.js");
/* harmony import */ var _id__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./id */ "./node_modules/@ethersproject/hash/lib.esm/id.js");
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};








var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);

var padding = new Uint8Array(32);
padding.fill(0);
var NegativeOne = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(-1);
var Zero = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(0);
var One = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(1);
var MaxUint256 = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from("0xffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff");

function hexPadRight(value) {
  var bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(value);
  var padOffset = bytes.length % 32;

  if (padOffset) {
    return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexConcat)([bytes, padding.slice(padOffset)]);
  }

  return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexlify)(bytes);
}

var hexTrue = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexZeroPad)(One.toHexString(), 32);
var hexFalse = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexZeroPad)(Zero.toHexString(), 32);
var domainFieldTypes = {
  name: "string",
  version: "string",
  chainId: "uint256",
  verifyingContract: "address",
  salt: "bytes32"
};
var domainFieldNames = ["name", "version", "chainId", "verifyingContract", "salt"];

function checkString(key) {
  return function (value) {
    if (typeof value !== "string") {
      logger.throwArgumentError("invalid domain value for ".concat(JSON.stringify(key)), "domain.".concat(key), value);
    }

    return value;
  };
}

var domainChecks = {
  name: checkString("name"),
  version: checkString("version"),
  chainId: function chainId(value) {
    try {
      return _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(value).toString();
    } catch (error) {}

    return logger.throwArgumentError("invalid domain value for \"chainId\"", "domain.chainId", value);
  },
  verifyingContract: function verifyingContract(value) {
    try {
      return (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_4__.getAddress)(value).toLowerCase();
    } catch (error) {}

    return logger.throwArgumentError("invalid domain value \"verifyingContract\"", "domain.verifyingContract", value);
  },
  salt: function salt(value) {
    try {
      var bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(value);

      if (bytes.length !== 32) {
        throw new Error("bad length");
      }

      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexlify)(bytes);
    } catch (error) {}

    return logger.throwArgumentError("invalid domain value \"salt\"", "domain.salt", value);
  }
};

function getBaseEncoder(type) {
  // intXX and uintXX
  {
    var match = type.match(/^(u?)int(\d*)$/);

    if (match) {
      var signed = match[1] === "";
      var width = parseInt(match[2] || "256");

      if (width % 8 !== 0 || width > 256 || match[2] && match[2] !== String(width)) {
        logger.throwArgumentError("invalid numeric width", "type", type);
      }

      var boundsUpper = MaxUint256.mask(signed ? width - 1 : width);
      var boundsLower = signed ? boundsUpper.add(One).mul(NegativeOne) : Zero;
      return function (value) {
        var v = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(value);

        if (v.lt(boundsLower) || v.gt(boundsUpper)) {
          logger.throwArgumentError("value out-of-bounds for ".concat(type), "value", value);
        }

        return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexZeroPad)(v.toTwos(256).toHexString(), 32);
      };
    }
  } // bytesXX

  {
    var _match = type.match(/^bytes(\d+)$/);

    if (_match) {
      var _width = parseInt(_match[1]);

      if (_width === 0 || _width > 32 || _match[1] !== String(_width)) {
        logger.throwArgumentError("invalid bytes width", "type", type);
      }

      return function (value) {
        var bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(value);

        if (bytes.length !== _width) {
          logger.throwArgumentError("invalid length for ".concat(type), "value", value);
        }

        return hexPadRight(value);
      };
    }
  }

  switch (type) {
    case "address":
      return function (value) {
        return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexZeroPad)((0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_4__.getAddress)(value), 32);
      };

    case "bool":
      return function (value) {
        return !value ? hexFalse : hexTrue;
      };

    case "bytes":
      return function (value) {
        return (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_5__.keccak256)(value);
      };

    case "string":
      return function (value) {
        return (0,_id__WEBPACK_IMPORTED_MODULE_6__.id)(value);
      };
  }

  return null;
}

function encodeType(name, fields) {
  return "".concat(name, "(").concat(fields.map(function (_ref) {
    var name = _ref.name,
        type = _ref.type;
    return type + " " + name;
  }).join(","), ")");
}

var TypedDataEncoder = /*#__PURE__*/function () {
  function TypedDataEncoder(types) {
    _classCallCheck(this, TypedDataEncoder);

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_7__.defineReadOnly)(this, "types", Object.freeze((0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_7__.deepCopy)(types)));
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_7__.defineReadOnly)(this, "_encoderCache", {});
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_7__.defineReadOnly)(this, "_types", {}); // Link struct types to their direct child structs

    var links = {}; // Link structs to structs which contain them as a child

    var parents = {}; // Link all subtypes within a given struct

    var subtypes = {};
    Object.keys(types).forEach(function (type) {
      links[type] = {};
      parents[type] = [];
      subtypes[type] = {};
    });

    var _loop = function _loop(name) {
      var uniqueNames = {};
      types[name].forEach(function (field) {
        // Check each field has a unique name
        if (uniqueNames[field.name]) {
          logger.throwArgumentError("duplicate variable name ".concat(JSON.stringify(field.name), " in ").concat(JSON.stringify(name)), "types", types);
        }

        uniqueNames[field.name] = true; // Get the base type (drop any array specifiers)

        var baseType = field.type.match(/^([^\x5b]*)(\x5b|$)/)[1];

        if (baseType === name) {
          logger.throwArgumentError("circular type reference to ".concat(JSON.stringify(baseType)), "types", types);
        } // Is this a base encoding type?


        var encoder = getBaseEncoder(baseType);

        if (encoder) {
          return;
        }

        if (!parents[baseType]) {
          logger.throwArgumentError("unknown type ".concat(JSON.stringify(baseType)), "types", types);
        } // Add linkage


        parents[baseType].push(name);
        links[name][baseType] = true;
      });
    };

    for (var name in types) {
      _loop(name);
    } // Deduce the primary type


    var primaryTypes = Object.keys(parents).filter(function (n) {
      return parents[n].length === 0;
    });

    if (primaryTypes.length === 0) {
      logger.throwArgumentError("missing primary type", "types", types);
    } else if (primaryTypes.length > 1) {
      logger.throwArgumentError("ambiguous primary types or unused types: ".concat(primaryTypes.map(function (t) {
        return JSON.stringify(t);
      }).join(", ")), "types", types);
    }

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_7__.defineReadOnly)(this, "primaryType", primaryTypes[0]); // Check for circular type references

    function checkCircular(type, found) {
      if (found[type]) {
        logger.throwArgumentError("circular type reference to ".concat(JSON.stringify(type)), "types", types);
      }

      found[type] = true;
      Object.keys(links[type]).forEach(function (child) {
        if (!parents[child]) {
          return;
        } // Recursively check children


        checkCircular(child, found); // Mark all ancestors as having this decendant

        Object.keys(found).forEach(function (subtype) {
          subtypes[subtype][child] = true;
        });
      });
      delete found[type];
    }

    checkCircular(this.primaryType, {}); // Compute each fully describe type

    for (var _name in subtypes) {
      var st = Object.keys(subtypes[_name]);
      st.sort();
      this._types[_name] = encodeType(_name, types[_name]) + st.map(function (t) {
        return encodeType(t, types[t]);
      }).join("");
    }
  }

  _createClass(TypedDataEncoder, [{
    key: "getEncoder",
    value: function getEncoder(type) {
      var encoder = this._encoderCache[type];

      if (!encoder) {
        encoder = this._encoderCache[type] = this._getEncoder(type);
      }

      return encoder;
    }
  }, {
    key: "_getEncoder",
    value: function _getEncoder(type) {
      var _this = this;

      // Basic encoder type (address, bool, uint256, etc)
      {
        var encoder = getBaseEncoder(type);

        if (encoder) {
          return encoder;
        }
      } // Array

      var match = type.match(/^(.*)(\x5b(\d*)\x5d)$/);

      if (match) {
        var subtype = match[1];
        var subEncoder = this.getEncoder(subtype);
        var length = parseInt(match[3]);
        return function (value) {
          if (length >= 0 && value.length !== length) {
            logger.throwArgumentError("array length mismatch; expected length ${ arrayLength }", "value", value);
          }

          var result = value.map(subEncoder);

          if (_this._types[subtype]) {
            result = result.map(_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_5__.keccak256);
          }

          return (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_5__.keccak256)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexConcat)(result));
        };
      } // Struct


      var fields = this.types[type];

      if (fields) {
        var encodedType = (0,_id__WEBPACK_IMPORTED_MODULE_6__.id)(this._types[type]);
        return function (value) {
          var values = fields.map(function (_ref2) {
            var name = _ref2.name,
                type = _ref2.type;

            var result = _this.getEncoder(type)(value[name]);

            if (_this._types[type]) {
              return (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_5__.keccak256)(result);
            }

            return result;
          });
          values.unshift(encodedType);
          return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexConcat)(values);
        };
      }

      return logger.throwArgumentError("unknown type: ".concat(type), "type", type);
    }
  }, {
    key: "encodeType",
    value: function encodeType(name) {
      var result = this._types[name];

      if (!result) {
        logger.throwArgumentError("unknown type: ".concat(JSON.stringify(name)), "name", name);
      }

      return result;
    }
  }, {
    key: "encodeData",
    value: function encodeData(type, value) {
      return this.getEncoder(type)(value);
    }
  }, {
    key: "hashStruct",
    value: function hashStruct(name, value) {
      return (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_5__.keccak256)(this.encodeData(name, value));
    }
  }, {
    key: "encode",
    value: function encode(value) {
      return this.encodeData(this.primaryType, value);
    }
  }, {
    key: "hash",
    value: function hash(value) {
      return this.hashStruct(this.primaryType, value);
    }
  }, {
    key: "_visit",
    value: function _visit(type, value, callback) {
      var _this2 = this;

      // Basic encoder type (address, bool, uint256, etc)
      {
        var encoder = getBaseEncoder(type);

        if (encoder) {
          return callback(type, value);
        }
      } // Array

      var match = type.match(/^(.*)(\x5b(\d*)\x5d)$/);

      if (match) {
        var subtype = match[1];
        var length = parseInt(match[3]);

        if (length >= 0 && value.length !== length) {
          logger.throwArgumentError("array length mismatch; expected length ${ arrayLength }", "value", value);
        }

        return value.map(function (v) {
          return _this2._visit(subtype, v, callback);
        });
      } // Struct


      var fields = this.types[type];

      if (fields) {
        return fields.reduce(function (accum, _ref3) {
          var name = _ref3.name,
              type = _ref3.type;
          accum[name] = _this2._visit(type, value[name], callback);
          return accum;
        }, {});
      }

      return logger.throwArgumentError("unknown type: ".concat(type), "type", type);
    }
  }, {
    key: "visit",
    value: function visit(value, callback) {
      return this._visit(this.primaryType, value, callback);
    }
  }], [{
    key: "from",
    value: function from(types) {
      return new TypedDataEncoder(types);
    }
  }, {
    key: "getPrimaryType",
    value: function getPrimaryType(types) {
      return TypedDataEncoder.from(types).primaryType;
    }
  }, {
    key: "hashStruct",
    value: function hashStruct(name, types, value) {
      return TypedDataEncoder.from(types).hashStruct(name, value);
    }
  }, {
    key: "hashDomain",
    value: function hashDomain(domain) {
      var domainFields = [];

      for (var name in domain) {
        var type = domainFieldTypes[name];

        if (!type) {
          logger.throwArgumentError("invalid typed-data domain key: ".concat(JSON.stringify(name)), "domain", domain);
        }

        domainFields.push({
          name: name,
          type: type
        });
      }

      domainFields.sort(function (a, b) {
        return domainFieldNames.indexOf(a.name) - domainFieldNames.indexOf(b.name);
      });
      return TypedDataEncoder.hashStruct("EIP712Domain", {
        EIP712Domain: domainFields
      }, domain);
    }
  }, {
    key: "encode",
    value: function encode(domain, types, value) {
      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexConcat)(["0x1901", TypedDataEncoder.hashDomain(domain), TypedDataEncoder.from(types).hash(value)]);
    }
  }, {
    key: "hash",
    value: function hash(domain, types, value) {
      return (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_5__.keccak256)(TypedDataEncoder.encode(domain, types, value));
    } // Replaces all address types with ENS names with their looked up address

  }, {
    key: "resolveNames",
    value: function resolveNames(domain, types, value, resolveName) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var ensCache, encoder, name;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // Make a copy to isolate it from the object passed in
                domain = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_7__.shallowCopy)(domain); // Look up all ENS names

                ensCache = {}; // Do we need to look up the domain's verifyingContract?

                if (domain.verifyingContract && !(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isHexString)(domain.verifyingContract, 20)) {
                  ensCache[domain.verifyingContract] = "0x";
                } // We are going to use the encoder to visit all the base values


                encoder = TypedDataEncoder.from(types); // Get a list of all the addresses

                encoder.visit(value, function (type, value) {
                  if (type === "address" && !(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isHexString)(value, 20)) {
                    ensCache[value] = "0x";
                  }

                  return value;
                }); // Lookup each name

                _context.t0 = regeneratorRuntime.keys(ensCache);

              case 6:
                if ((_context.t1 = _context.t0()).done) {
                  _context.next = 13;
                  break;
                }

                name = _context.t1.value;
                _context.next = 10;
                return resolveName(name);

              case 10:
                ensCache[name] = _context.sent;
                _context.next = 6;
                break;

              case 13:
                // Replace the domain verifyingContract if needed
                if (domain.verifyingContract && ensCache[domain.verifyingContract]) {
                  domain.verifyingContract = ensCache[domain.verifyingContract];
                } // Replace all ENS names with their address


                value = encoder.visit(value, function (type, value) {
                  if (type === "address" && ensCache[value]) {
                    return ensCache[value];
                  }

                  return value;
                });
                return _context.abrupt("return", {
                  domain: domain,
                  value: value
                });

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
    }
  }, {
    key: "getPayload",
    value: function getPayload(domain, types, value) {
      // Validate the domain fields
      TypedDataEncoder.hashDomain(domain); // Derive the EIP712Domain Struct reference type

      var domainValues = {};
      var domainTypes = [];
      domainFieldNames.forEach(function (name) {
        var value = domain[name];

        if (value == null) {
          return;
        }

        domainValues[name] = domainChecks[name](value);
        domainTypes.push({
          name: name,
          type: domainFieldTypes[name]
        });
      });
      var encoder = TypedDataEncoder.from(types);
      var typesWithDomain = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_7__.shallowCopy)(types);

      if (typesWithDomain.EIP712Domain) {
        logger.throwArgumentError("types must not contain EIP712Domain type", "types.EIP712Domain", types);
      } else {
        typesWithDomain.EIP712Domain = domainTypes;
      } // Validate the data structures and types


      encoder.encode(value);
      return {
        types: typesWithDomain,
        domain: domainValues,
        primaryType: encoder.primaryType,
        message: encoder.visit(value, function (type, value) {
          // bytes
          if (type.match(/^bytes(\d*)/)) {
            return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexlify)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(value));
          } // uint or int


          if (type.match(/^u?int/)) {
            return _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.from(value).toString();
          }

          switch (type) {
            case "address":
              return value.toLowerCase();

            case "bool":
              return !!value;

            case "string":
              if (typeof value !== "string") {
                logger.throwArgumentError("invalid string", "value", value);
              }

              return value;
          }

          return logger.throwArgumentError("unsupported type", "type", type);
        })
      };
    }
  }]);

  return TypedDataEncoder;
}();

/***/ }),

/***/ "./node_modules/@ethersproject/keccak256/lib.esm/index.js":
/*!****************************************************************!*\
  !*** ./node_modules/@ethersproject/keccak256/lib.esm/index.js ***!
  \****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "keccak256": function() { return /* binding */ keccak256; }
/* harmony export */ });
/* harmony import */ var js_sha3__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! js-sha3 */ "./node_modules/js-sha3/src/sha3.js");
/* harmony import */ var js_sha3__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(js_sha3__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");




function keccak256(data) {
  return '0x' + js_sha3__WEBPACK_IMPORTED_MODULE_0___default().keccak_256((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_1__.arrayify)(data));
}

/***/ }),

/***/ "./node_modules/@ethersproject/logger/lib.esm/_version.js":
/*!****************************************************************!*\
  !*** ./node_modules/@ethersproject/logger/lib.esm/_version.js ***!
  \****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "logger/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/logger/lib.esm/index.js":
/*!*************************************************************!*\
  !*** ./node_modules/@ethersproject/logger/lib.esm/index.js ***!
  \*************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "LogLevel": function() { return /* binding */ LogLevel; },
/* harmony export */   "ErrorCode": function() { return /* binding */ ErrorCode; },
/* harmony export */   "Logger": function() { return /* binding */ Logger; }
/* harmony export */ });
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/logger/lib.esm/_version.js");


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var _permanentCensorErrors = false;
var _censorErrors = false;
var LogLevels = {
  debug: 1,
  "default": 2,
  info: 2,
  warning: 3,
  error: 4,
  off: 5
};
var _logLevel = LogLevels["default"];

var _globalLogger = null;

function _checkNormalize() {
  try {
    var missing = []; // Make sure all forms of normalization are supported

    ["NFD", "NFC", "NFKD", "NFKC"].forEach(function (form) {
      try {
        if ("test".normalize(form) !== "test") {
          throw new Error("bad normalize");
        }

        ;
      } catch (error) {
        missing.push(form);
      }
    });

    if (missing.length) {
      throw new Error("missing " + missing.join(", "));
    }

    if (String.fromCharCode(0xe9).normalize("NFD") !== String.fromCharCode(0x65, 0x0301)) {
      throw new Error("broken implementation");
    }
  } catch (error) {
    return error.message;
  }

  return null;
}

var _normalizeError = _checkNormalize();

var LogLevel;

(function (LogLevel) {
  LogLevel["DEBUG"] = "DEBUG";
  LogLevel["INFO"] = "INFO";
  LogLevel["WARNING"] = "WARNING";
  LogLevel["ERROR"] = "ERROR";
  LogLevel["OFF"] = "OFF";
})(LogLevel || (LogLevel = {}));

var ErrorCode;

(function (ErrorCode) {
  ///////////////////
  // Generic Errors
  // Unknown Error
  ErrorCode["UNKNOWN_ERROR"] = "UNKNOWN_ERROR"; // Not Implemented

  ErrorCode["NOT_IMPLEMENTED"] = "NOT_IMPLEMENTED"; // Unsupported Operation
  //   - operation

  ErrorCode["UNSUPPORTED_OPERATION"] = "UNSUPPORTED_OPERATION"; // Network Error (i.e. Ethereum Network, such as an invalid chain ID)
  //   - event ("noNetwork" is not re-thrown in provider.ready; otherwise thrown)

  ErrorCode["NETWORK_ERROR"] = "NETWORK_ERROR"; // Some sort of bad response from the server

  ErrorCode["SERVER_ERROR"] = "SERVER_ERROR"; // Timeout

  ErrorCode["TIMEOUT"] = "TIMEOUT"; ///////////////////
  // Operational  Errors
  // Buffer Overrun

  ErrorCode["BUFFER_OVERRUN"] = "BUFFER_OVERRUN"; // Numeric Fault
  //   - operation: the operation being executed
  //   - fault: the reason this faulted

  ErrorCode["NUMERIC_FAULT"] = "NUMERIC_FAULT"; ///////////////////
  // Argument Errors
  // Missing new operator to an object
  //  - name: The name of the class

  ErrorCode["MISSING_NEW"] = "MISSING_NEW"; // Invalid argument (e.g. value is incompatible with type) to a function:
  //   - argument: The argument name that was invalid
  //   - value: The value of the argument

  ErrorCode["INVALID_ARGUMENT"] = "INVALID_ARGUMENT"; // Missing argument to a function:
  //   - count: The number of arguments received
  //   - expectedCount: The number of arguments expected

  ErrorCode["MISSING_ARGUMENT"] = "MISSING_ARGUMENT"; // Too many arguments
  //   - count: The number of arguments received
  //   - expectedCount: The number of arguments expected

  ErrorCode["UNEXPECTED_ARGUMENT"] = "UNEXPECTED_ARGUMENT"; ///////////////////
  // Blockchain Errors
  // Call exception
  //  - transaction: the transaction
  //  - address?: the contract address
  //  - args?: The arguments passed into the function
  //  - method?: The Solidity method signature
  //  - errorSignature?: The EIP848 error signature
  //  - errorArgs?: The EIP848 error parameters
  //  - reason: The reason (only for EIP848 "Error(string)")

  ErrorCode["CALL_EXCEPTION"] = "CALL_EXCEPTION"; // Insufficient funds (< value + gasLimit * gasPrice)
  //   - transaction: the transaction attempted

  ErrorCode["INSUFFICIENT_FUNDS"] = "INSUFFICIENT_FUNDS"; // Nonce has already been used
  //   - transaction: the transaction attempted

  ErrorCode["NONCE_EXPIRED"] = "NONCE_EXPIRED"; // The replacement fee for the transaction is too low
  //   - transaction: the transaction attempted

  ErrorCode["REPLACEMENT_UNDERPRICED"] = "REPLACEMENT_UNDERPRICED"; // The gas limit could not be estimated
  //   - transaction: the transaction passed to estimateGas

  ErrorCode["UNPREDICTABLE_GAS_LIMIT"] = "UNPREDICTABLE_GAS_LIMIT"; // The transaction was replaced by one with a higher gas price
  //   - reason: "cancelled", "replaced" or "repriced"
  //   - cancelled: true if reason == "cancelled" or reason == "replaced")
  //   - hash: original transaction hash
  //   - replacement: the full TransactionsResponse for the replacement
  //   - receipt: the receipt of the replacement

  ErrorCode["TRANSACTION_REPLACED"] = "TRANSACTION_REPLACED";
})(ErrorCode || (ErrorCode = {}));

;
var HEX = "0123456789abcdef";
var Logger = /*#__PURE__*/function () {
  function Logger(version) {
    _classCallCheck(this, Logger);

    Object.defineProperty(this, "version", {
      enumerable: true,
      value: version,
      writable: false
    });
  }

  _createClass(Logger, [{
    key: "_log",
    value: function _log(logLevel, args) {
      var level = logLevel.toLowerCase();

      if (LogLevels[level] == null) {
        this.throwArgumentError("invalid log level name", "logLevel", logLevel);
      }

      if (_logLevel > LogLevels[level]) {
        return;
      }

      console.log.apply(console, args);
    }
  }, {
    key: "debug",
    value: function debug() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      this._log(Logger.levels.DEBUG, args);
    }
  }, {
    key: "info",
    value: function info() {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      this._log(Logger.levels.INFO, args);
    }
  }, {
    key: "warn",
    value: function warn() {
      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      this._log(Logger.levels.WARNING, args);
    }
  }, {
    key: "makeError",
    value: function makeError(message, code, params) {
      // Errors are being censored
      if (_censorErrors) {
        return this.makeError("censored error", code, {});
      }

      if (!code) {
        code = Logger.errors.UNKNOWN_ERROR;
      }

      if (!params) {
        params = {};
      }

      var messageDetails = [];
      Object.keys(params).forEach(function (key) {
        var value = params[key];

        try {
          if (value instanceof Uint8Array) {
            var hex = "";

            for (var i = 0; i < value.length; i++) {
              hex += HEX[value[i] >> 4];
              hex += HEX[value[i] & 0x0f];
            }

            messageDetails.push(key + "=Uint8Array(0x" + hex + ")");
          } else {
            messageDetails.push(key + "=" + JSON.stringify(value));
          }
        } catch (error) {
          messageDetails.push(key + "=" + JSON.stringify(params[key].toString()));
        }
      });
      messageDetails.push("code=".concat(code));
      messageDetails.push("version=".concat(this.version));
      var reason = message;
      var url = "";

      switch (code) {
        case ErrorCode.NUMERIC_FAULT:
          {
            url = "NUMERIC_FAULT";
            var fault = message;

            switch (fault) {
              case "overflow":
              case "underflow":
              case "division-by-zero":
                url += "-" + fault;
                break;

              case "negative-power":
              case "negative-width":
                url += "-unsupported";
                break;

              case "unbound-bitwise-result":
                url += "-unbound-result";
                break;
            }

            break;
          }

        case ErrorCode.CALL_EXCEPTION:
        case ErrorCode.INSUFFICIENT_FUNDS:
        case ErrorCode.MISSING_NEW:
        case ErrorCode.NONCE_EXPIRED:
        case ErrorCode.REPLACEMENT_UNDERPRICED:
        case ErrorCode.TRANSACTION_REPLACED:
        case ErrorCode.UNPREDICTABLE_GAS_LIMIT:
          url = code;
          break;
      }

      if (url) {
        message += " [ See: https:/\/links.ethers.org/v5-errors-" + url + " ]";
      }

      if (messageDetails.length) {
        message += " (" + messageDetails.join(", ") + ")";
      } // @TODO: Any??


      var error = new Error(message);
      error.reason = reason;
      error.code = code;
      Object.keys(params).forEach(function (key) {
        error[key] = params[key];
      });
      return error;
    }
  }, {
    key: "throwError",
    value: function throwError(message, code, params) {
      throw this.makeError(message, code, params);
    }
  }, {
    key: "throwArgumentError",
    value: function throwArgumentError(message, name, value) {
      return this.throwError(message, Logger.errors.INVALID_ARGUMENT, {
        argument: name,
        value: value
      });
    }
  }, {
    key: "assert",
    value: function assert(condition, message, code, params) {
      if (!!condition) {
        return;
      }

      this.throwError(message, code, params);
    }
  }, {
    key: "assertArgument",
    value: function assertArgument(condition, message, name, value) {
      if (!!condition) {
        return;
      }

      this.throwArgumentError(message, name, value);
    }
  }, {
    key: "checkNormalize",
    value: function checkNormalize(message) {
      if (message == null) {
        message = "platform missing String.prototype.normalize";
      }

      if (_normalizeError) {
        this.throwError("platform missing String.prototype.normalize", Logger.errors.UNSUPPORTED_OPERATION, {
          operation: "String.prototype.normalize",
          form: _normalizeError
        });
      }
    }
  }, {
    key: "checkSafeUint53",
    value: function checkSafeUint53(value, message) {
      if (typeof value !== "number") {
        return;
      }

      if (message == null) {
        message = "value not safe";
      }

      if (value < 0 || value >= 0x1fffffffffffff) {
        this.throwError(message, Logger.errors.NUMERIC_FAULT, {
          operation: "checkSafeInteger",
          fault: "out-of-safe-range",
          value: value
        });
      }

      if (value % 1) {
        this.throwError(message, Logger.errors.NUMERIC_FAULT, {
          operation: "checkSafeInteger",
          fault: "non-integer",
          value: value
        });
      }
    }
  }, {
    key: "checkArgumentCount",
    value: function checkArgumentCount(count, expectedCount, message) {
      if (message) {
        message = ": " + message;
      } else {
        message = "";
      }

      if (count < expectedCount) {
        this.throwError("missing argument" + message, Logger.errors.MISSING_ARGUMENT, {
          count: count,
          expectedCount: expectedCount
        });
      }

      if (count > expectedCount) {
        this.throwError("too many arguments" + message, Logger.errors.UNEXPECTED_ARGUMENT, {
          count: count,
          expectedCount: expectedCount
        });
      }
    }
  }, {
    key: "checkNew",
    value: function checkNew(target, kind) {
      if (target === Object || target == null) {
        this.throwError("missing new", Logger.errors.MISSING_NEW, {
          name: kind.name
        });
      }
    }
  }, {
    key: "checkAbstract",
    value: function checkAbstract(target, kind) {
      if (target === kind) {
        this.throwError("cannot instantiate abstract class " + JSON.stringify(kind.name) + " directly; use a sub-class", Logger.errors.UNSUPPORTED_OPERATION, {
          name: target.name,
          operation: "new"
        });
      } else if (target === Object || target == null) {
        this.throwError("missing new", Logger.errors.MISSING_NEW, {
          name: kind.name
        });
      }
    }
  }], [{
    key: "globalLogger",
    value: function globalLogger() {
      if (!_globalLogger) {
        _globalLogger = new Logger(_version__WEBPACK_IMPORTED_MODULE_0__.version);
      }

      return _globalLogger;
    }
  }, {
    key: "setCensorship",
    value: function setCensorship(censorship, permanent) {
      if (!censorship && permanent) {
        this.globalLogger().throwError("cannot permanently disable censorship", Logger.errors.UNSUPPORTED_OPERATION, {
          operation: "setCensorship"
        });
      }

      if (_permanentCensorErrors) {
        if (!censorship) {
          return;
        }

        this.globalLogger().throwError("error censorship permanent", Logger.errors.UNSUPPORTED_OPERATION, {
          operation: "setCensorship"
        });
      }

      _censorErrors = !!censorship;
      _permanentCensorErrors = !!permanent;
    }
  }, {
    key: "setLogLevel",
    value: function setLogLevel(logLevel) {
      var level = LogLevels[logLevel.toLowerCase()];

      if (level == null) {
        Logger.globalLogger().warn("invalid log level - " + logLevel);
        return;
      }

      _logLevel = level;
    }
  }, {
    key: "from",
    value: function from(version) {
      return new Logger(version);
    }
  }]);

  return Logger;
}();
Logger.errors = ErrorCode;
Logger.levels = LogLevel;

/***/ }),

/***/ "./node_modules/@ethersproject/networks/lib.esm/_version.js":
/*!******************************************************************!*\
  !*** ./node_modules/@ethersproject/networks/lib.esm/_version.js ***!
  \******************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "networks/5.6.1";

/***/ }),

/***/ "./node_modules/@ethersproject/networks/lib.esm/index.js":
/*!***************************************************************!*\
  !*** ./node_modules/@ethersproject/networks/lib.esm/index.js ***!
  \***************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getNetwork": function() { return /* binding */ getNetwork; }
/* harmony export */ });
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/networks/lib.esm/_version.js");




var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
;

function isRenetworkable(value) {
  return value && typeof value.renetwork === "function";
}

function ethDefaultProvider(network) {
  var func = function func(providers, options) {
    if (options == null) {
      options = {};
    }

    var providerList = [];

    if (providers.InfuraProvider && options.infura !== "-") {
      try {
        providerList.push(new providers.InfuraProvider(network, options.infura));
      } catch (error) {}
    }

    if (providers.EtherscanProvider && options.etherscan !== "-") {
      try {
        providerList.push(new providers.EtherscanProvider(network, options.etherscan));
      } catch (error) {}
    }

    if (providers.AlchemyProvider && options.alchemy !== "-") {
      try {
        providerList.push(new providers.AlchemyProvider(network, options.alchemy));
      } catch (error) {}
    }

    if (providers.PocketProvider && options.pocket !== "-") {
      // These networks are currently faulty on Pocket as their
      // network does not handle the Berlin hardfork, which is
      // live on these ones.
      // @TODO: This goes away once Pocket has upgraded their nodes
      var skip = ["goerli", "ropsten", "rinkeby"];

      try {
        var provider = new providers.PocketProvider(network);

        if (provider.network && skip.indexOf(provider.network.name) === -1) {
          providerList.push(provider);
        }
      } catch (error) {}
    }

    if (providers.CloudflareProvider && options.cloudflare !== "-") {
      try {
        providerList.push(new providers.CloudflareProvider(network));
      } catch (error) {}
    }

    if (providers.AnkrProvider && options.ankr !== "-") {
      try {
        providerList.push(new providers.AnkrProvider(network, options.ankr));
      } catch (error) {}
    }

    if (providerList.length === 0) {
      return null;
    }

    if (providers.FallbackProvider) {
      var quorum = 1;

      if (options.quorum != null) {
        quorum = options.quorum;
      } else if (network === "homestead") {
        quorum = 2;
      }

      return new providers.FallbackProvider(providerList, quorum);
    }

    return providerList[0];
  };

  func.renetwork = function (network) {
    return ethDefaultProvider(network);
  };

  return func;
}

function etcDefaultProvider(url, network) {
  var func = function func(providers, options) {
    if (providers.JsonRpcProvider) {
      return new providers.JsonRpcProvider(url, network);
    }

    return null;
  };

  func.renetwork = function (network) {
    return etcDefaultProvider(url, network);
  };

  return func;
}

var homestead = {
  chainId: 1,
  ensAddress: "0x00000000000C2E074eC69A0dFb2997BA6C7d2e1e",
  name: "homestead",
  _defaultProvider: ethDefaultProvider("homestead")
};
var ropsten = {
  chainId: 3,
  ensAddress: "0x00000000000C2E074eC69A0dFb2997BA6C7d2e1e",
  name: "ropsten",
  _defaultProvider: ethDefaultProvider("ropsten")
};
var classicMordor = {
  chainId: 63,
  name: "classicMordor",
  _defaultProvider: etcDefaultProvider("https://www.ethercluster.com/mordor", "classicMordor")
}; // See: https://chainlist.org

var networks = {
  unspecified: {
    chainId: 0,
    name: "unspecified"
  },
  homestead: homestead,
  mainnet: homestead,
  morden: {
    chainId: 2,
    name: "morden"
  },
  ropsten: ropsten,
  testnet: ropsten,
  rinkeby: {
    chainId: 4,
    ensAddress: "0x00000000000C2E074eC69A0dFb2997BA6C7d2e1e",
    name: "rinkeby",
    _defaultProvider: ethDefaultProvider("rinkeby")
  },
  kovan: {
    chainId: 42,
    name: "kovan",
    _defaultProvider: ethDefaultProvider("kovan")
  },
  goerli: {
    chainId: 5,
    ensAddress: "0x00000000000C2E074eC69A0dFb2997BA6C7d2e1e",
    name: "goerli",
    _defaultProvider: ethDefaultProvider("goerli")
  },
  kintsugi: {
    chainId: 1337702,
    name: "kintsugi"
  },
  // ETC (See: #351)
  classic: {
    chainId: 61,
    name: "classic",
    _defaultProvider: etcDefaultProvider("https:/\/www.ethercluster.com/etc", "classic")
  },
  classicMorden: {
    chainId: 62,
    name: "classicMorden"
  },
  classicMordor: classicMordor,
  classicTestnet: classicMordor,
  classicKotti: {
    chainId: 6,
    name: "classicKotti",
    _defaultProvider: etcDefaultProvider("https:/\/www.ethercluster.com/kotti", "classicKotti")
  },
  xdai: {
    chainId: 100,
    name: "xdai"
  },
  matic: {
    chainId: 137,
    name: "matic"
  },
  maticmum: {
    chainId: 80001,
    name: "maticmum"
  },
  optimism: {
    chainId: 10,
    name: "optimism"
  },
  "optimism-kovan": {
    chainId: 69,
    name: "optimism-kovan"
  },
  "optimism-goerli": {
    chainId: 420,
    name: "optimism-goerli"
  },
  arbitrum: {
    chainId: 42161,
    name: "arbitrum"
  },
  "arbitrum-rinkeby": {
    chainId: 421611,
    name: "arbitrum-rinkeby"
  },
  bnb: {
    chainId: 56,
    name: "bnb"
  },
  bnbt: {
    chainId: 97,
    name: "bnbt"
  }
};
/**
 *  getNetwork
 *
 *  Converts a named common networks or chain ID (network ID) to a Network
 *  and verifies a network is a valid Network..
 */

function getNetwork(network) {
  // No network (null)
  if (network == null) {
    return null;
  }

  if (typeof network === "number") {
    for (var name in networks) {
      var _standard = networks[name];

      if (_standard.chainId === network) {
        return {
          name: _standard.name,
          chainId: _standard.chainId,
          ensAddress: _standard.ensAddress || null,
          _defaultProvider: _standard._defaultProvider || null
        };
      }
    }

    return {
      chainId: network,
      name: "unknown"
    };
  }

  if (typeof network === "string") {
    var _standard2 = networks[network];

    if (_standard2 == null) {
      return null;
    }

    return {
      name: _standard2.name,
      chainId: _standard2.chainId,
      ensAddress: _standard2.ensAddress,
      _defaultProvider: _standard2._defaultProvider || null
    };
  }

  var standard = networks[network.name]; // Not a standard network; check that it is a valid network in general

  if (!standard) {
    if (typeof network.chainId !== "number") {
      logger.throwArgumentError("invalid network chainId", "network", network);
    }

    return network;
  } // Make sure the chainId matches the expected network chainId (or is 0; disable EIP-155)


  if (network.chainId !== 0 && network.chainId !== standard.chainId) {
    logger.throwArgumentError("network chainId mismatch", "network", network);
  } // @TODO: In the next major version add an attach function to a defaultProvider
  // class and move the _defaultProvider internal to this file (extend Network)


  var defaultProvider = network._defaultProvider || null;

  if (defaultProvider == null && standard._defaultProvider) {
    if (isRenetworkable(standard._defaultProvider)) {
      defaultProvider = standard._defaultProvider.renetwork(network);
    } else {
      defaultProvider = standard._defaultProvider;
    }
  } // Standard Network (allow overriding the ENS address)


  return {
    name: network.name,
    chainId: standard.chainId,
    ensAddress: network.ensAddress || standard.ensAddress || null,
    _defaultProvider: defaultProvider
  };
}

/***/ }),

/***/ "./node_modules/@ethersproject/properties/lib.esm/_version.js":
/*!********************************************************************!*\
  !*** ./node_modules/@ethersproject/properties/lib.esm/_version.js ***!
  \********************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "properties/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/properties/lib.esm/index.js":
/*!*****************************************************************!*\
  !*** ./node_modules/@ethersproject/properties/lib.esm/index.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "defineReadOnly": function() { return /* binding */ defineReadOnly; },
/* harmony export */   "getStatic": function() { return /* binding */ getStatic; },
/* harmony export */   "resolveProperties": function() { return /* binding */ resolveProperties; },
/* harmony export */   "checkProperties": function() { return /* binding */ checkProperties; },
/* harmony export */   "shallowCopy": function() { return /* binding */ shallowCopy; },
/* harmony export */   "deepCopy": function() { return /* binding */ deepCopy; },
/* harmony export */   "Description": function() { return /* binding */ Description; }
/* harmony export */ });
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/properties/lib.esm/_version.js");


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};



var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
function defineReadOnly(object, name, value) {
  Object.defineProperty(object, name, {
    enumerable: true,
    value: value,
    writable: false
  });
} // Crawl up the constructor chain to find a static method

function getStatic(ctor, key) {
  for (var i = 0; i < 32; i++) {
    if (ctor[key]) {
      return ctor[key];
    }

    if (!ctor.prototype || _typeof(ctor.prototype) !== "object") {
      break;
    }

    ctor = Object.getPrototypeOf(ctor.prototype).constructor;
  }

  return null;
}
function resolveProperties(object) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var promises, results;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            promises = Object.keys(object).map(function (key) {
              var value = object[key];
              return Promise.resolve(value).then(function (v) {
                return {
                  key: key,
                  value: v
                };
              });
            });
            _context.next = 3;
            return Promise.all(promises);

          case 3:
            results = _context.sent;
            return _context.abrupt("return", results.reduce(function (accum, result) {
              accum[result.key] = result.value;
              return accum;
            }, {}));

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
}
function checkProperties(object, properties) {
  if (!object || _typeof(object) !== "object") {
    logger.throwArgumentError("invalid object", "object", object);
  }

  Object.keys(object).forEach(function (key) {
    if (!properties[key]) {
      logger.throwArgumentError("invalid object key - " + key, "transaction:" + key, object);
    }
  });
}
function shallowCopy(object) {
  var result = {};

  for (var key in object) {
    result[key] = object[key];
  }

  return result;
}
var opaque = {
  bigint: true,
  "boolean": true,
  "function": true,
  number: true,
  string: true
};

function _isFrozen(object) {
  // Opaque objects are not mutable, so safe to copy by assignment
  if (object === undefined || object === null || opaque[_typeof(object)]) {
    return true;
  }

  if (Array.isArray(object) || _typeof(object) === "object") {
    if (!Object.isFrozen(object)) {
      return false;
    }

    var keys = Object.keys(object);

    for (var i = 0; i < keys.length; i++) {
      var value = null;

      try {
        value = object[keys[i]];
      } catch (error) {
        // If accessing a value triggers an error, it is a getter
        // designed to do so (e.g. Result) and is therefore "frozen"
        continue;
      }

      if (!_isFrozen(value)) {
        return false;
      }
    }

    return true;
  }

  return logger.throwArgumentError("Cannot deepCopy ".concat(_typeof(object)), "object", object);
} // Returns a new copy of object, such that no properties may be replaced.
// New properties may be added only to objects.


function _deepCopy(object) {
  if (_isFrozen(object)) {
    return object;
  } // Arrays are mutable, so we need to create a copy


  if (Array.isArray(object)) {
    return Object.freeze(object.map(function (item) {
      return deepCopy(item);
    }));
  }

  if (_typeof(object) === "object") {
    var result = {};

    for (var key in object) {
      var value = object[key];

      if (value === undefined) {
        continue;
      }

      defineReadOnly(result, key, deepCopy(value));
    }

    return result;
  }

  return logger.throwArgumentError("Cannot deepCopy ".concat(_typeof(object)), "object", object);
}

function deepCopy(object) {
  return _deepCopy(object);
}
var Description = function Description(info) {
  _classCallCheck(this, Description);

  for (var key in info) {
    this[key] = deepCopy(info[key]);
  }
};

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/_version.js":
/*!*******************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/_version.js ***!
  \*******************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "providers/5.6.2";

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/alchemy-provider.js":
/*!***************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/alchemy-provider.js ***!
  \***************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "AlchemyWebSocketProvider": function() { return /* binding */ AlchemyWebSocketProvider; },
/* harmony export */   "AlchemyProvider": function() { return /* binding */ AlchemyProvider; }
/* harmony export */ });
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _formatter__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./formatter */ "./node_modules/@ethersproject/providers/lib.esm/formatter.js");
/* harmony import */ var _websocket_provider__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./websocket-provider */ "./node_modules/@ethersproject/providers/lib.esm/websocket-provider.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");
/* harmony import */ var _url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./url-json-rpc-provider */ "./node_modules/@ethersproject/providers/lib.esm/url-json-rpc-provider.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }






var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
 // This key was provided to ethers.js by Alchemy to be used by the
// default provider, but it is recommended that for your own
// production environments, that you acquire your own API key at:
//   https://dashboard.alchemyapi.io

var defaultApiKey = "_gg7wSSi0KMBsdKnGVfHDueq6xMB9EkC";
var AlchemyWebSocketProvider = /*#__PURE__*/function (_WebSocketProvider) {
  _inherits(AlchemyWebSocketProvider, _WebSocketProvider);

  var _super = _createSuper(AlchemyWebSocketProvider);

  function AlchemyWebSocketProvider(network, apiKey) {
    var _this;

    _classCallCheck(this, AlchemyWebSocketProvider);

    var provider = new AlchemyProvider(network, apiKey);
    var url = provider.connection.url.replace(/^http/i, "ws").replace(".alchemyapi.", ".ws.alchemyapi.");
    _this = _super.call(this, url, provider.network);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this), "apiKey", provider.apiKey);
    return _this;
  }

  _createClass(AlchemyWebSocketProvider, [{
    key: "isCommunityResource",
    value: function isCommunityResource() {
      return this.apiKey === defaultApiKey;
    }
  }]);

  return AlchemyWebSocketProvider;
}(_websocket_provider__WEBPACK_IMPORTED_MODULE_3__.WebSocketProvider);
var AlchemyProvider = /*#__PURE__*/function (_UrlJsonRpcProvider) {
  _inherits(AlchemyProvider, _UrlJsonRpcProvider);

  var _super2 = _createSuper(AlchemyProvider);

  function AlchemyProvider() {
    _classCallCheck(this, AlchemyProvider);

    return _super2.apply(this, arguments);
  }

  _createClass(AlchemyProvider, [{
    key: "isCommunityResource",
    value: function isCommunityResource() {
      return this.apiKey === defaultApiKey;
    }
  }], [{
    key: "getWebSocketProvider",
    value: function getWebSocketProvider(network, apiKey) {
      return new AlchemyWebSocketProvider(network, apiKey);
    }
  }, {
    key: "getApiKey",
    value: function getApiKey(apiKey) {
      if (apiKey == null) {
        return defaultApiKey;
      }

      if (apiKey && typeof apiKey !== "string") {
        logger.throwArgumentError("invalid apiKey", "apiKey", apiKey);
      }

      return apiKey;
    }
  }, {
    key: "getUrl",
    value: function getUrl(network, apiKey) {
      var host = null;

      switch (network.name) {
        case "homestead":
          host = "eth-mainnet.alchemyapi.io/v2/";
          break;

        case "ropsten":
          host = "eth-ropsten.alchemyapi.io/v2/";
          break;

        case "rinkeby":
          host = "eth-rinkeby.alchemyapi.io/v2/";
          break;

        case "goerli":
          host = "eth-goerli.alchemyapi.io/v2/";
          break;

        case "kovan":
          host = "eth-kovan.alchemyapi.io/v2/";
          break;

        case "matic":
          host = "polygon-mainnet.g.alchemy.com/v2/";
          break;

        case "maticmum":
          host = "polygon-mumbai.g.alchemy.com/v2/";
          break;

        case "arbitrum":
          host = "arb-mainnet.g.alchemy.com/v2/";
          break;

        case "arbitrum-rinkeby":
          host = "arb-rinkeby.g.alchemy.com/v2/";
          break;

        case "optimism":
          host = "opt-mainnet.g.alchemy.com/v2/";
          break;

        case "optimism-kovan":
          host = "opt-kovan.g.alchemy.com/v2/";
          break;

        default:
          logger.throwArgumentError("unsupported network", "network", arguments[0]);
      }

      return {
        allowGzip: true,
        url: "https:/" + "/" + host + apiKey,
        throttleCallback: function throttleCallback(attempt, url) {
          if (apiKey === defaultApiKey) {
            (0,_formatter__WEBPACK_IMPORTED_MODULE_4__.showThrottleMessage)();
          }

          return Promise.resolve(true);
        }
      };
    }
  }]);

  return AlchemyProvider;
}(_url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_5__.UrlJsonRpcProvider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/ankr-provider.js":
/*!************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/ankr-provider.js ***!
  \************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "AnkrProvider": function() { return /* binding */ AnkrProvider; }
/* harmony export */ });
/* harmony import */ var _formatter__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./formatter */ "./node_modules/@ethersproject/providers/lib.esm/formatter.js");
/* harmony import */ var _url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./url-json-rpc-provider */ "./node_modules/@ethersproject/providers/lib.esm/url-json-rpc-provider.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");
function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }





var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
var defaultApiKey = "9f7d929b018cdffb338517efa06f58359e86ff1ffd350bc889738523659e7972";

function getHost(name) {
  switch (name) {
    case "homestead":
      return "rpc.ankr.com/eth/";

    case "matic":
      return "rpc.ankr.com/polygon/";

    case "arbitrum":
      return "rpc.ankr.com/arbitrum/";
  }

  return logger.throwArgumentError("unsupported network", "name", name);
}

var AnkrProvider = /*#__PURE__*/function (_UrlJsonRpcProvider) {
  _inherits(AnkrProvider, _UrlJsonRpcProvider);

  var _super = _createSuper(AnkrProvider);

  function AnkrProvider() {
    _classCallCheck(this, AnkrProvider);

    return _super.apply(this, arguments);
  }

  _createClass(AnkrProvider, [{
    key: "isCommunityResource",
    value: function isCommunityResource() {
      return this.apiKey === defaultApiKey;
    }
  }], [{
    key: "getApiKey",
    value: function getApiKey(apiKey) {
      if (apiKey == null) {
        return defaultApiKey;
      }

      return apiKey;
    }
  }, {
    key: "getUrl",
    value: function getUrl(network, apiKey) {
      if (apiKey == null) {
        apiKey = defaultApiKey;
      }

      var connection = {
        allowGzip: true,
        url: "https:/\/" + getHost(network.name) + apiKey,
        throttleCallback: function throttleCallback(attempt, url) {
          if (apiKey.apiKey === defaultApiKey) {
            (0,_formatter__WEBPACK_IMPORTED_MODULE_2__.showThrottleMessage)();
          }

          return Promise.resolve(true);
        }
      };

      if (apiKey.projectSecret != null) {
        connection.user = "";
        connection.password = apiKey.projectSecret;
      }

      return connection;
    }
  }]);

  return AnkrProvider;
}(_url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_3__.UrlJsonRpcProvider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/base-provider.js":
/*!************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/base-provider.js ***!
  \************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Event": function() { return /* binding */ Event; },
/* harmony export */   "Resolver": function() { return /* binding */ Resolver; },
/* harmony export */   "BaseProvider": function() { return /* binding */ BaseProvider; }
/* harmony export */ });
/* harmony import */ var _ethersproject_abstract_provider__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/abstract-provider */ "./node_modules/@ethersproject/abstract-provider/lib.esm/index.js");
/* harmony import */ var _ethersproject_basex__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @ethersproject/basex */ "./node_modules/@ethersproject/basex/lib.esm/index.js");
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_constants__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @ethersproject/constants */ "./node_modules/@ethersproject/constants/lib.esm/hashes.js");
/* harmony import */ var _ethersproject_hash__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @ethersproject/hash */ "./node_modules/@ethersproject/hash/lib.esm/namehash.js");
/* harmony import */ var _ethersproject_networks__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @ethersproject/networks */ "./node_modules/@ethersproject/networks/lib.esm/index.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_sha2__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @ethersproject/sha2 */ "./node_modules/@ethersproject/sha2/lib.esm/sha2.js");
/* harmony import */ var _ethersproject_strings__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @ethersproject/strings */ "./node_modules/@ethersproject/strings/lib.esm/utf8.js");
/* harmony import */ var _ethersproject_web__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @ethersproject/web */ "./node_modules/@ethersproject/web/lib.esm/index.js");
/* harmony import */ var bech32__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! bech32 */ "./node_modules/bech32/index.js");
/* harmony import */ var bech32__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(bech32__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");
/* harmony import */ var _formatter__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./formatter */ "./node_modules/@ethersproject/providers/lib.esm/formatter.js");


function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};















var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger(_version__WEBPACK_IMPORTED_MODULE_2__.version);

var MAX_CCIP_REDIRECTS = 10; //////////////////////////////
// Event Serializeing

function checkTopic(topic) {
  if (topic == null) {
    return "null";
  }

  if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataLength)(topic) !== 32) {
    logger.throwArgumentError("invalid topic", "topic", topic);
  }

  return topic.toLowerCase();
}

function serializeTopics(topics) {
  // Remove trailing null AND-topics; they are redundant
  topics = topics.slice();

  while (topics.length > 0 && topics[topics.length - 1] == null) {
    topics.pop();
  }

  return topics.map(function (topic) {
    if (Array.isArray(topic)) {
      // Only track unique OR-topics
      var unique = {};
      topic.forEach(function (topic) {
        unique[checkTopic(topic)] = true;
      }); // The order of OR-topics does not matter

      var sorted = Object.keys(unique);
      sorted.sort();
      return sorted.join("|");
    } else {
      return checkTopic(topic);
    }
  }).join("&");
}

function deserializeTopics(data) {
  if (data === "") {
    return [];
  }

  return data.split(/&/g).map(function (topic) {
    if (topic === "") {
      return [];
    }

    var comps = topic.split("|").map(function (topic) {
      return topic === "null" ? null : topic;
    });
    return comps.length === 1 ? comps[0] : comps;
  });
}

function getEventTag(eventName) {
  if (typeof eventName === "string") {
    eventName = eventName.toLowerCase();

    if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataLength)(eventName) === 32) {
      return "tx:" + eventName;
    }

    if (eventName.indexOf(":") === -1) {
      return eventName;
    }
  } else if (Array.isArray(eventName)) {
    return "filter:*:" + serializeTopics(eventName);
  } else if (_ethersproject_abstract_provider__WEBPACK_IMPORTED_MODULE_4__.ForkEvent.isForkEvent(eventName)) {
    logger.warn("not implemented");
    throw new Error("not implemented");
  } else if (eventName && _typeof(eventName) === "object") {
    return "filter:" + (eventName.address || "*") + ":" + serializeTopics(eventName.topics || []);
  }

  throw new Error("invalid event - " + eventName);
} //////////////////////////////
// Helper Object


function getTime() {
  return new Date().getTime();
}

function stall(duration) {
  return new Promise(function (resolve) {
    setTimeout(resolve, duration);
  });
} //////////////////////////////
// Provider Object

/**
 *  EventType
 *   - "block"
 *   - "poll"
 *   - "didPoll"
 *   - "pending"
 *   - "error"
 *   - "network"
 *   - filter
 *   - topics array
 *   - transaction hash
 */


var PollableEvents = ["block", "network", "pending", "poll"];
var Event = /*#__PURE__*/function () {
  function Event(tag, listener, once) {
    _classCallCheck(this, Event);

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.defineReadOnly)(this, "tag", tag);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.defineReadOnly)(this, "listener", listener);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.defineReadOnly)(this, "once", once);
    this._lastBlockNumber = -2;
    this._inflight = false;
  }

  _createClass(Event, [{
    key: "event",
    get: function get() {
      switch (this.type) {
        case "tx":
          return this.hash;

        case "filter":
          return this.filter;
      }

      return this.tag;
    }
  }, {
    key: "type",
    get: function get() {
      return this.tag.split(":")[0];
    }
  }, {
    key: "hash",
    get: function get() {
      var comps = this.tag.split(":");

      if (comps[0] !== "tx") {
        return null;
      }

      return comps[1];
    }
  }, {
    key: "filter",
    get: function get() {
      var comps = this.tag.split(":");

      if (comps[0] !== "filter") {
        return null;
      }

      var address = comps[1];
      var topics = deserializeTopics(comps[2]);
      var filter = {};

      if (topics.length > 0) {
        filter.topics = topics;
      }

      if (address && address !== "*") {
        filter.address = address;
      }

      return filter;
    }
  }, {
    key: "pollable",
    value: function pollable() {
      return this.tag.indexOf(":") >= 0 || PollableEvents.indexOf(this.tag) >= 0;
    }
  }]);

  return Event;
}();
; // https://github.com/satoshilabs/slips/blob/master/slip-0044.md

var coinInfos = {
  "0": {
    symbol: "btc",
    p2pkh: 0x00,
    p2sh: 0x05,
    prefix: "bc"
  },
  "2": {
    symbol: "ltc",
    p2pkh: 0x30,
    p2sh: 0x32,
    prefix: "ltc"
  },
  "3": {
    symbol: "doge",
    p2pkh: 0x1e,
    p2sh: 0x16
  },
  "60": {
    symbol: "eth",
    ilk: "eth"
  },
  "61": {
    symbol: "etc",
    ilk: "eth"
  },
  "700": {
    symbol: "xdai",
    ilk: "eth"
  }
};

function bytes32ify(value) {
  return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexZeroPad)(_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from(value).toHexString(), 32);
} // Compute the Base58Check encoded data (checksum is first 4 bytes of sha256d)


function base58Encode(data) {
  return _ethersproject_basex__WEBPACK_IMPORTED_MODULE_7__.Base58.encode((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.concat)([data, (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataSlice)((0,_ethersproject_sha2__WEBPACK_IMPORTED_MODULE_8__.sha256)((0,_ethersproject_sha2__WEBPACK_IMPORTED_MODULE_8__.sha256)(data)), 0, 4)]));
}

var matcherIpfs = new RegExp("^(ipfs):/\/(.*)$", "i");
var matchers = [new RegExp("^(https):/\/(.*)$", "i"), new RegExp("^(data):(.*)$", "i"), matcherIpfs, new RegExp("^eip155:[0-9]+/(erc[0-9]+):(.*)$", "i")];

function _parseString(result, start) {
  try {
    return (0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_9__.toUtf8String)(_parseBytes(result, start));
  } catch (error) {}

  return null;
}

function _parseBytes(result, start) {
  if (result === "0x") {
    return null;
  }

  var offset = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataSlice)(result, start, start + 32)).toNumber();
  var length = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataSlice)(result, offset, offset + 32)).toNumber();
  return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataSlice)(result, offset + 32, offset + 32 + length);
} // Trim off the ipfs:// prefix and return the default gateway URL


function getIpfsLink(link) {
  if (link.match(/^ipfs:\/\/ipfs\//i)) {
    link = link.substring(12);
  } else if (link.match(/^ipfs:\/\//i)) {
    link = link.substring(7);
  } else {
    logger.throwArgumentError("unsupported IPFS format", "link", link);
  }

  return "https://gateway.ipfs.io/ipfs/".concat(link);
}

function numPad(value) {
  var result = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(value);

  if (result.length > 32) {
    throw new Error("internal; should not happen");
  }

  var padded = new Uint8Array(32);
  padded.set(result, 32 - result.length);
  return padded;
}

function bytesPad(value) {
  if (value.length % 32 === 0) {
    return value;
  }

  var result = new Uint8Array(Math.ceil(value.length / 32) * 32);
  result.set(value);
  return result;
} // ABI Encodes a series of (bytes, bytes, ...)


function encodeBytes(datas) {
  var result = [];
  var byteCount = 0; // Add place-holders for pointers as we add items

  for (var i = 0; i < datas.length; i++) {
    result.push(null);
    byteCount += 32;
  }

  for (var _i = 0; _i < datas.length; _i++) {
    var data = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(datas[_i]); // Update the bytes offset

    result[_i] = numPad(byteCount); // The length and padded value of data

    result.push(numPad(data.length));
    result.push(bytesPad(data));
    byteCount += 32 + Math.ceil(data.length / 32) * 32;
  }

  return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexConcat)(result);
}

var Resolver = /*#__PURE__*/function () {
  // The resolvedAddress is only for creating a ReverseLookup resolver
  function Resolver(provider, address, name, resolvedAddress) {
    _classCallCheck(this, Resolver);

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.defineReadOnly)(this, "provider", provider);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.defineReadOnly)(this, "name", name);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.defineReadOnly)(this, "address", provider.formatter.address(address));
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.defineReadOnly)(this, "_resolvedAddress", resolvedAddress);
  }

  _createClass(Resolver, [{
    key: "supportsWildcard",
    value: function supportsWildcard() {
      var _this = this;

      if (!this._supportsEip2544) {
        // supportsInterface(bytes4 = selector("resolve(bytes,bytes)"))
        this._supportsEip2544 = this.provider.call({
          to: this.address,
          data: "0x01ffc9a79061b92300000000000000000000000000000000000000000000000000000000"
        }).then(function (result) {
          return _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from(result).eq(1);
        })["catch"](function (error) {
          if (error.code === _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.CALL_EXCEPTION) {
            return false;
          } // Rethrow the error: link is down, etc. Let future attempts retry.


          _this._supportsEip2544 = null;
          throw error;
        });
      }

      return this._supportsEip2544;
    }
  }, {
    key: "_fetch",
    value: function _fetch(selector, parameters) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var tx, parseBytes, result;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // e.g. keccak256("addr(bytes32,uint256)")
                tx = {
                  to: this.address,
                  ccipReadEnabled: true,
                  data: (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexConcat)([selector, (0,_ethersproject_hash__WEBPACK_IMPORTED_MODULE_10__.namehash)(this.name), parameters || "0x"])
                }; // Wildcard support; use EIP-2544 to resolve the request

                parseBytes = false;
                _context.next = 4;
                return this.supportsWildcard();

              case 4:
                if (!_context.sent) {
                  _context.next = 7;
                  break;
                }

                parseBytes = true; // selector("resolve(bytes,bytes)")

                tx.data = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexConcat)(["0x9061b923", encodeBytes([(0,_ethersproject_hash__WEBPACK_IMPORTED_MODULE_10__.dnsEncode)(this.name), tx.data])]);

              case 7:
                _context.prev = 7;
                _context.next = 10;
                return this.provider.call(tx);

              case 10:
                result = _context.sent;

                if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(result).length % 32 === 4) {
                  logger.throwError("resolver threw error", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.CALL_EXCEPTION, {
                    transaction: tx,
                    data: result
                  });
                }

                if (parseBytes) {
                  result = _parseBytes(result, 0);
                }

                return _context.abrupt("return", result);

              case 16:
                _context.prev = 16;
                _context.t0 = _context["catch"](7);

                if (!(_context.t0.code === _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.CALL_EXCEPTION)) {
                  _context.next = 20;
                  break;
                }

                return _context.abrupt("return", null);

              case 20:
                throw _context.t0;

              case 21:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[7, 16]]);
      }));
    }
  }, {
    key: "_fetchBytes",
    value: function _fetchBytes(selector, parameters) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var result;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this._fetch(selector, parameters);

              case 2:
                result = _context2.sent;

                if (!(result != null)) {
                  _context2.next = 5;
                  break;
                }

                return _context2.abrupt("return", _parseBytes(result, 0));

              case 5:
                return _context2.abrupt("return", null);

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));
    }
  }, {
    key: "_getAddress",
    value: function _getAddress(coinType, hexBytes) {
      var coinInfo = coinInfos[String(coinType)];

      if (coinInfo == null) {
        logger.throwError("unsupported coin type: ".concat(coinType), _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.UNSUPPORTED_OPERATION, {
          operation: "getAddress(".concat(coinType, ")")
        });
      }

      if (coinInfo.ilk === "eth") {
        return this.provider.formatter.address(hexBytes);
      }

      var bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(hexBytes); // P2PKH: OP_DUP OP_HASH160 <pubKeyHash> OP_EQUALVERIFY OP_CHECKSIG

      if (coinInfo.p2pkh != null) {
        var p2pkh = hexBytes.match(/^0x76a9([0-9a-f][0-9a-f])([0-9a-f]*)88ac$/);

        if (p2pkh) {
          var length = parseInt(p2pkh[1], 16);

          if (p2pkh[2].length === length * 2 && length >= 1 && length <= 75) {
            return base58Encode((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.concat)([[coinInfo.p2pkh], "0x" + p2pkh[2]]));
          }
        }
      } // P2SH: OP_HASH160 <scriptHash> OP_EQUAL


      if (coinInfo.p2sh != null) {
        var p2sh = hexBytes.match(/^0xa9([0-9a-f][0-9a-f])([0-9a-f]*)87$/);

        if (p2sh) {
          var _length = parseInt(p2sh[1], 16);

          if (p2sh[2].length === _length * 2 && _length >= 1 && _length <= 75) {
            return base58Encode((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.concat)([[coinInfo.p2sh], "0x" + p2sh[2]]));
          }
        }
      } // Bech32


      if (coinInfo.prefix != null) {
        var _length2 = bytes[1]; // https://github.com/bitcoin/bips/blob/master/bip-0141.mediawiki#witness-program

        var _version = bytes[0];

        if (_version === 0x00) {
          if (_length2 !== 20 && _length2 !== 32) {
            _version = -1;
          }
        } else {
          _version = -1;
        }

        if (_version >= 0 && bytes.length === 2 + _length2 && _length2 >= 1 && _length2 <= 75) {
          var words = bech32__WEBPACK_IMPORTED_MODULE_0___default().toWords(bytes.slice(2));
          words.unshift(_version);
          return bech32__WEBPACK_IMPORTED_MODULE_0___default().encode(coinInfo.prefix, words);
        }
      }

      return null;
    }
  }, {
    key: "getAddress",
    value: function getAddress(coinType) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var result, hexBytes, address;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (coinType == null) {
                  coinType = 60;
                } // If Ethereum, use the standard `addr(bytes32)`


                if (!(coinType === 60)) {
                  _context3.next = 16;
                  break;
                }

                _context3.prev = 2;
                _context3.next = 5;
                return this._fetch("0x3b3b57de");

              case 5:
                result = _context3.sent;

                if (!(result === "0x" || result === _ethersproject_constants__WEBPACK_IMPORTED_MODULE_11__.HashZero)) {
                  _context3.next = 8;
                  break;
                }

                return _context3.abrupt("return", null);

              case 8:
                return _context3.abrupt("return", this.provider.formatter.callAddress(result));

              case 11:
                _context3.prev = 11;
                _context3.t0 = _context3["catch"](2);

                if (!(_context3.t0.code === _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.CALL_EXCEPTION)) {
                  _context3.next = 15;
                  break;
                }

                return _context3.abrupt("return", null);

              case 15:
                throw _context3.t0;

              case 16:
                _context3.next = 18;
                return this._fetchBytes("0xf1cb7e06", bytes32ify(coinType));

              case 18:
                hexBytes = _context3.sent;

                if (!(hexBytes == null || hexBytes === "0x")) {
                  _context3.next = 21;
                  break;
                }

                return _context3.abrupt("return", null);

              case 21:
                // Compute the address
                address = this._getAddress(coinType, hexBytes);

                if (address == null) {
                  logger.throwError("invalid or unsupported coin data", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.UNSUPPORTED_OPERATION, {
                    operation: "getAddress(".concat(coinType, ")"),
                    coinType: coinType,
                    data: hexBytes
                  });
                }

                return _context3.abrupt("return", address);

              case 24:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[2, 11]]);
      }));
    }
  }, {
    key: "getAvatar",
    value: function getAvatar() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var linkage, avatar, i, match, scheme, selector, owner, comps, addr, tokenId, tokenOwner, balance, tx, metadataUrl, metadata, imageUrl, ipfs;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                linkage = [{
                  type: "name",
                  content: this.name
                }];
                _context4.prev = 1;
                _context4.next = 4;
                return this.getText("avatar");

              case 4:
                avatar = _context4.sent;

                if (!(avatar == null)) {
                  _context4.next = 7;
                  break;
                }

                return _context4.abrupt("return", null);

              case 7:
                i = 0;

              case 8:
                if (!(i < matchers.length)) {
                  _context4.next = 91;
                  break;
                }

                match = avatar.match(matchers[i]);

                if (!(match == null)) {
                  _context4.next = 12;
                  break;
                }

                return _context4.abrupt("continue", 88);

              case 12:
                scheme = match[1].toLowerCase();
                _context4.t0 = scheme;
                _context4.next = _context4.t0 === "https" ? 16 : _context4.t0 === "data" ? 18 : _context4.t0 === "ipfs" ? 20 : _context4.t0 === "erc721" ? 22 : _context4.t0 === "erc1155" ? 22 : 88;
                break;

              case 16:
                linkage.push({
                  type: "url",
                  content: avatar
                });
                return _context4.abrupt("return", {
                  linkage: linkage,
                  url: avatar
                });

              case 18:
                linkage.push({
                  type: "data",
                  content: avatar
                });
                return _context4.abrupt("return", {
                  linkage: linkage,
                  url: avatar
                });

              case 20:
                linkage.push({
                  type: "ipfs",
                  content: avatar
                });
                return _context4.abrupt("return", {
                  linkage: linkage,
                  url: getIpfsLink(avatar)
                });

              case 22:
                // Depending on the ERC type, use tokenURI(uint256) or url(uint256)
                selector = scheme === "erc721" ? "0xc87b56dd" : "0x0e89341c";
                linkage.push({
                  type: scheme,
                  content: avatar
                }); // The owner of this name

                _context4.t1 = this._resolvedAddress;

                if (_context4.t1) {
                  _context4.next = 29;
                  break;
                }

                _context4.next = 28;
                return this.getAddress();

              case 28:
                _context4.t1 = _context4.sent;

              case 29:
                owner = _context4.t1;
                comps = (match[2] || "").split("/");

                if (!(comps.length !== 2)) {
                  _context4.next = 33;
                  break;
                }

                return _context4.abrupt("return", null);

              case 33:
                _context4.next = 35;
                return this.provider.formatter.address(comps[0]);

              case 35:
                addr = _context4.sent;
                tokenId = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexZeroPad)(_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from(comps[1]).toHexString(), 32); // Check that this account owns the token

                if (!(scheme === "erc721")) {
                  _context4.next = 48;
                  break;
                }

                _context4.t2 = this.provider.formatter;
                _context4.next = 41;
                return this.provider.call({
                  to: addr,
                  data: (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexConcat)(["0x6352211e", tokenId])
                });

              case 41:
                _context4.t3 = _context4.sent;
                tokenOwner = _context4.t2.callAddress.call(_context4.t2, _context4.t3);

                if (!(owner !== tokenOwner)) {
                  _context4.next = 45;
                  break;
                }

                return _context4.abrupt("return", null);

              case 45:
                linkage.push({
                  type: "owner",
                  content: tokenOwner
                });
                _context4.next = 57;
                break;

              case 48:
                if (!(scheme === "erc1155")) {
                  _context4.next = 57;
                  break;
                }

                _context4.t4 = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber;
                _context4.next = 52;
                return this.provider.call({
                  to: addr,
                  data: (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexConcat)(["0x00fdd58e", (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexZeroPad)(owner, 32), tokenId])
                });

              case 52:
                _context4.t5 = _context4.sent;
                balance = _context4.t4.from.call(_context4.t4, _context4.t5);

                if (!balance.isZero()) {
                  _context4.next = 56;
                  break;
                }

                return _context4.abrupt("return", null);

              case 56:
                linkage.push({
                  type: "balance",
                  content: balance.toString()
                });

              case 57:
                // Call the token contract for the metadata URL
                tx = {
                  to: this.provider.formatter.address(comps[0]),
                  data: (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexConcat)([selector, tokenId])
                };
                _context4.t6 = _parseString;
                _context4.next = 61;
                return this.provider.call(tx);

              case 61:
                _context4.t7 = _context4.sent;
                metadataUrl = (0, _context4.t6)(_context4.t7, 0);

                if (!(metadataUrl == null)) {
                  _context4.next = 65;
                  break;
                }

                return _context4.abrupt("return", null);

              case 65:
                linkage.push({
                  type: "metadata-url-base",
                  content: metadataUrl
                }); // ERC-1155 allows a generic {id} in the URL

                if (scheme === "erc1155") {
                  metadataUrl = metadataUrl.replace("{id}", tokenId.substring(2));
                  linkage.push({
                    type: "metadata-url-expanded",
                    content: metadataUrl
                  });
                } // Transform IPFS metadata links


                if (metadataUrl.match(/^ipfs:/i)) {
                  metadataUrl = getIpfsLink(metadataUrl);
                }

                linkage.push({
                  type: "metadata-url",
                  content: metadataUrl
                }); // Get the token metadata

                _context4.next = 71;
                return (0,_ethersproject_web__WEBPACK_IMPORTED_MODULE_12__.fetchJson)(metadataUrl);

              case 71:
                metadata = _context4.sent;

                if (metadata) {
                  _context4.next = 74;
                  break;
                }

                return _context4.abrupt("return", null);

              case 74:
                linkage.push({
                  type: "metadata",
                  content: JSON.stringify(metadata)
                }); // Pull the image URL out

                imageUrl = metadata.image;

                if (!(typeof imageUrl !== "string")) {
                  _context4.next = 78;
                  break;
                }

                return _context4.abrupt("return", null);

              case 78:
                if (!imageUrl.match(/^(https:\/\/|data:)/i)) {
                  _context4.next = 81;
                  break;
                }

                _context4.next = 86;
                break;

              case 81:
                // Transform IPFS link to gateway
                ipfs = imageUrl.match(matcherIpfs);

                if (!(ipfs == null)) {
                  _context4.next = 84;
                  break;
                }

                return _context4.abrupt("return", null);

              case 84:
                linkage.push({
                  type: "url-ipfs",
                  content: imageUrl
                });
                imageUrl = getIpfsLink(imageUrl);

              case 86:
                linkage.push({
                  type: "url",
                  content: imageUrl
                });
                return _context4.abrupt("return", {
                  linkage: linkage,
                  url: imageUrl
                });

              case 88:
                i++;
                _context4.next = 8;
                break;

              case 91:
                _context4.next = 95;
                break;

              case 93:
                _context4.prev = 93;
                _context4.t8 = _context4["catch"](1);

              case 95:
                return _context4.abrupt("return", null);

              case 96:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this, [[1, 93]]);
      }));
    }
  }, {
    key: "getContentHash",
    value: function getContentHash() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
        var hexBytes, ipfs, length, ipns, _length3, swarm;

        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this._fetchBytes("0xbc1c58d1");

              case 2:
                hexBytes = _context5.sent;

                if (!(hexBytes == null || hexBytes === "0x")) {
                  _context5.next = 5;
                  break;
                }

                return _context5.abrupt("return", null);

              case 5:
                // IPFS (CID: 1, Type: DAG-PB)
                ipfs = hexBytes.match(/^0xe3010170(([0-9a-f][0-9a-f])([0-9a-f][0-9a-f])([0-9a-f]*))$/);

                if (!ipfs) {
                  _context5.next = 10;
                  break;
                }

                length = parseInt(ipfs[3], 16);

                if (!(ipfs[4].length === length * 2)) {
                  _context5.next = 10;
                  break;
                }

                return _context5.abrupt("return", "ipfs:/\/" + _ethersproject_basex__WEBPACK_IMPORTED_MODULE_7__.Base58.encode("0x" + ipfs[1]));

              case 10:
                // IPNS (CID: 1, Type: libp2p-key)
                ipns = hexBytes.match(/^0xe5010172(([0-9a-f][0-9a-f])([0-9a-f][0-9a-f])([0-9a-f]*))$/);

                if (!ipns) {
                  _context5.next = 15;
                  break;
                }

                _length3 = parseInt(ipns[3], 16);

                if (!(ipns[4].length === _length3 * 2)) {
                  _context5.next = 15;
                  break;
                }

                return _context5.abrupt("return", "ipns:/\/" + _ethersproject_basex__WEBPACK_IMPORTED_MODULE_7__.Base58.encode("0x" + ipns[1]));

              case 15:
                // Swarm (CID: 1, Type: swarm-manifest; hash/length hard-coded to keccak256/32)
                swarm = hexBytes.match(/^0xe40101fa011b20([0-9a-f]*)$/);

                if (!swarm) {
                  _context5.next = 19;
                  break;
                }

                if (!(swarm[1].length === 32 * 2)) {
                  _context5.next = 19;
                  break;
                }

                return _context5.abrupt("return", "bzz:/\/" + swarm[1]);

              case 19:
                return _context5.abrupt("return", logger.throwError("invalid or unsupported content hash data", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.UNSUPPORTED_OPERATION, {
                  operation: "getContentHash()",
                  data: hexBytes
                }));

              case 20:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));
    }
  }, {
    key: "getText",
    value: function getText(key) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
        var keyBytes, hexBytes;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                // The key encoded as parameter to fetchBytes
                keyBytes = (0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_9__.toUtf8Bytes)(key); // The nodehash consumes the first slot, so the string pointer targets
                // offset 64, with the length at offset 64 and data starting at offset 96

                keyBytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.concat)([bytes32ify(64), bytes32ify(keyBytes.length), keyBytes]); // Pad to word-size (32 bytes)

                if (keyBytes.length % 32 !== 0) {
                  keyBytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.concat)([keyBytes, (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexZeroPad)("0x", 32 - key.length % 32)]);
                }

                _context6.next = 5;
                return this._fetchBytes("0x59d1d43c", (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexlify)(keyBytes));

              case 5:
                hexBytes = _context6.sent;

                if (!(hexBytes == null || hexBytes === "0x")) {
                  _context6.next = 8;
                  break;
                }

                return _context6.abrupt("return", null);

              case 8:
                return _context6.abrupt("return", (0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_9__.toUtf8String)(hexBytes));

              case 9:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));
    }
  }]);

  return Resolver;
}();
var defaultFormatter = null;
var nextPollId = 1;
var BaseProvider = /*#__PURE__*/function (_Provider) {
  _inherits(BaseProvider, _Provider);

  var _super = _createSuper(BaseProvider);

  /**
   *  ready
   *
   *  A Promise<Network> that resolves only once the provider is ready.
   *
   *  Sub-classes that call the super with a network without a chainId
   *  MUST set this. Standard named networks have a known chainId.
   *
   */
  function BaseProvider(network) {
    var _this2;

    _classCallCheck(this, BaseProvider);

    logger.checkNew(this instanceof BaseProvider ? this.constructor : void 0, _ethersproject_abstract_provider__WEBPACK_IMPORTED_MODULE_4__.Provider);
    _this2 = _super.call(this); // Events being listened to

    _this2._events = [];
    _this2._emitted = {
      block: -2
    };
    _this2.disableCcipRead = false;
    _this2.formatter = (this instanceof BaseProvider ? this.constructor : void 0).getFormatter(); // If network is any, this Provider allows the underlying
    // network to change dynamically, and we auto-detect the
    // current network

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.defineReadOnly)(_assertThisInitialized(_this2), "anyNetwork", network === "any");

    if (_this2.anyNetwork) {
      network = _this2.detectNetwork();
    }

    if (network instanceof Promise) {
      _this2._networkPromise = network; // Squash any "unhandled promise" errors; that do not need to be handled

      network["catch"](function (error) {}); // Trigger initial network setting (async)

      _this2._ready()["catch"](function (error) {});
    } else {
      var knownNetwork = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.getStatic)(this instanceof BaseProvider ? this.constructor : void 0, "getNetwork")(network);

      if (knownNetwork) {
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.defineReadOnly)(_assertThisInitialized(_this2), "_network", knownNetwork);

        _this2.emit("network", knownNetwork, null);
      } else {
        logger.throwArgumentError("invalid network", "network", network);
      }
    }

    _this2._maxInternalBlockNumber = -1024;
    _this2._lastBlockNumber = -2;
    _this2._maxFilterBlockRange = 10;
    _this2._pollingInterval = 4000;
    _this2._fastQueryDate = 0;
    return _this2;
  }

  _createClass(BaseProvider, [{
    key: "_ready",
    value: function _ready() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
        var network;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                if (!(this._network == null)) {
                  _context7.next = 17;
                  break;
                }

                network = null;

                if (!this._networkPromise) {
                  _context7.next = 11;
                  break;
                }

                _context7.prev = 3;
                _context7.next = 6;
                return this._networkPromise;

              case 6:
                network = _context7.sent;
                _context7.next = 11;
                break;

              case 9:
                _context7.prev = 9;
                _context7.t0 = _context7["catch"](3);

              case 11:
                if (!(network == null)) {
                  _context7.next = 15;
                  break;
                }

                _context7.next = 14;
                return this.detectNetwork();

              case 14:
                network = _context7.sent;

              case 15:
                // This should never happen; every Provider sub-class should have
                // suggested a network by here (or have thrown).
                if (!network) {
                  logger.throwError("no network detected", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.UNKNOWN_ERROR, {});
                } // Possible this call stacked so do not call defineReadOnly again


                if (this._network == null) {
                  if (this.anyNetwork) {
                    this._network = network;
                  } else {
                    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.defineReadOnly)(this, "_network", network);
                  }

                  this.emit("network", network, null);
                }

              case 17:
                return _context7.abrupt("return", this._network);

              case 18:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this, [[3, 9]]);
      }));
    } // This will always return the most recently established network.
    // For "any", this can change (a "network" event is emitted before
    // any change is reflected); otherwise this cannot change

  }, {
    key: "ready",
    get: function get() {
      var _this3 = this;

      return (0,_ethersproject_web__WEBPACK_IMPORTED_MODULE_12__.poll)(function () {
        return _this3._ready().then(function (network) {
          return network;
        }, function (error) {
          // If the network isn't running yet, we will wait
          if (error.code === _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.NETWORK_ERROR && error.event === "noNetwork") {
            return undefined;
          }

          throw error;
        });
      });
    } // @TODO: Remove this and just create a singleton formatter

  }, {
    key: "ccipReadFetch",
    value: function ccipReadFetch(tx, calldata, urls) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
        var sender, data, errorMessages, i, url, href, json, result, errorMessage;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                if (!(this.disableCcipRead || urls.length === 0)) {
                  _context8.next = 2;
                  break;
                }

                return _context8.abrupt("return", null);

              case 2:
                sender = tx.to.toLowerCase();
                data = calldata.toLowerCase();
                errorMessages = [];
                i = 0;

              case 6:
                if (!(i < urls.length)) {
                  _context8.next = 22;
                  break;
                }

                url = urls[i]; // URL expansion

                href = url.replace("{sender}", sender).replace("{data}", data); // If no {data} is present, use POST; otherwise GET

                json = url.indexOf("{data}") >= 0 ? null : JSON.stringify({
                  data: data,
                  sender: sender
                });
                _context8.next = 12;
                return (0,_ethersproject_web__WEBPACK_IMPORTED_MODULE_12__.fetchJson)({
                  url: href,
                  errorPassThrough: true
                }, json, function (value, response) {
                  value.status = response.statusCode;
                  return value;
                });

              case 12:
                result = _context8.sent;

                if (!result.data) {
                  _context8.next = 15;
                  break;
                }

                return _context8.abrupt("return", result.data);

              case 15:
                errorMessage = result.message || "unknown error"; // 4xx indicates the result is not present; stop

                if (!(result.status >= 400 && result.status < 500)) {
                  _context8.next = 18;
                  break;
                }

                return _context8.abrupt("return", logger.throwError("response not found during CCIP fetch: ".concat(errorMessage), _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.SERVER_ERROR, {
                  url: url,
                  errorMessage: errorMessage
                }));

              case 18:
                // 5xx indicates server issue; try the next url
                errorMessages.push(errorMessage);

              case 19:
                i++;
                _context8.next = 6;
                break;

              case 22:
                return _context8.abrupt("return", logger.throwError("error encountered during CCIP fetch: ".concat(errorMessages.map(function (m) {
                  return JSON.stringify(m);
                }).join(", ")), _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.SERVER_ERROR, {
                  urls: urls,
                  errorMessages: errorMessages
                }));

              case 23:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));
    } // Fetches the blockNumber, but will reuse any result that is less
    // than maxAge old or has been requested since the last request

  }, {
    key: "_getInternalBlockNumber",
    value: function _getInternalBlockNumber(maxAge) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
        var _this4 = this;

        var internalBlockNumber, result, reqTime, checkInternalBlockNumber;
        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this._ready();

              case 2:
                if (!(maxAge > 0)) {
                  _context9.next = 20;
                  break;
                }

              case 3:
                if (!this._internalBlockNumber) {
                  _context9.next = 20;
                  break;
                }

                // ..."remember" which fetch we started with
                internalBlockNumber = this._internalBlockNumber;
                _context9.prev = 5;
                _context9.next = 8;
                return internalBlockNumber;

              case 8:
                result = _context9.sent;

                if (!(getTime() - result.respTime <= maxAge)) {
                  _context9.next = 11;
                  break;
                }

                return _context9.abrupt("return", result.blockNumber);

              case 11:
                return _context9.abrupt("break", 20);

              case 14:
                _context9.prev = 14;
                _context9.t0 = _context9["catch"](5);

                if (!(this._internalBlockNumber === internalBlockNumber)) {
                  _context9.next = 18;
                  break;
                }

                return _context9.abrupt("break", 20);

              case 18:
                _context9.next = 3;
                break;

              case 20:
                reqTime = getTime();
                checkInternalBlockNumber = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.resolveProperties)({
                  blockNumber: this.perform("getBlockNumber", {}),
                  networkError: this.getNetwork().then(function (network) {
                    return null;
                  }, function (error) {
                    return error;
                  })
                }).then(function (_ref) {
                  var blockNumber = _ref.blockNumber,
                      networkError = _ref.networkError;

                  if (networkError) {
                    // Unremember this bad internal block number
                    if (_this4._internalBlockNumber === checkInternalBlockNumber) {
                      _this4._internalBlockNumber = null;
                    }

                    throw networkError;
                  }

                  var respTime = getTime();
                  blockNumber = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from(blockNumber).toNumber();

                  if (blockNumber < _this4._maxInternalBlockNumber) {
                    blockNumber = _this4._maxInternalBlockNumber;
                  }

                  _this4._maxInternalBlockNumber = blockNumber;

                  _this4._setFastBlockNumber(blockNumber); // @TODO: Still need this?


                  return {
                    blockNumber: blockNumber,
                    reqTime: reqTime,
                    respTime: respTime
                  };
                });
                this._internalBlockNumber = checkInternalBlockNumber; // Swallow unhandled exceptions; if needed they are handled else where

                checkInternalBlockNumber["catch"](function (error) {
                  // Don't null the dead (rejected) fetch, if it has already been updated
                  if (_this4._internalBlockNumber === checkInternalBlockNumber) {
                    _this4._internalBlockNumber = null;
                  }
                });
                _context9.next = 26;
                return checkInternalBlockNumber;

              case 26:
                return _context9.abrupt("return", _context9.sent.blockNumber);

              case 27:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this, [[5, 14]]);
      }));
    }
  }, {
    key: "poll",
    value: function poll() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
        var _this5 = this;

        var pollId, runners, blockNumber, i;
        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                pollId = nextPollId++; // Track all running promises, so we can trigger a post-poll once they are complete

                runners = [];
                blockNumber = null;
                _context10.prev = 3;
                _context10.next = 6;
                return this._getInternalBlockNumber(100 + this.pollingInterval / 2);

              case 6:
                blockNumber = _context10.sent;
                _context10.next = 13;
                break;

              case 9:
                _context10.prev = 9;
                _context10.t0 = _context10["catch"](3);
                this.emit("error", _context10.t0);
                return _context10.abrupt("return");

              case 13:
                this._setFastBlockNumber(blockNumber); // Emit a poll event after we have the latest (fast) block number


                this.emit("poll", pollId, blockNumber); // If the block has not changed, meh.

                if (!(blockNumber === this._lastBlockNumber)) {
                  _context10.next = 18;
                  break;
                }

                this.emit("didPoll", pollId);
                return _context10.abrupt("return");

              case 18:
                // First polling cycle, trigger a "block" events
                if (this._emitted.block === -2) {
                  this._emitted.block = blockNumber - 1;
                }

                if (Math.abs(this._emitted.block - blockNumber) > 1000) {
                  logger.warn("network block skew detected; skipping block events (emitted=".concat(this._emitted.block, " blockNumber").concat(blockNumber, ")"));
                  this.emit("error", logger.makeError("network block skew detected", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.NETWORK_ERROR, {
                    blockNumber: blockNumber,
                    event: "blockSkew",
                    previousBlockNumber: this._emitted.block
                  }));
                  this.emit("block", blockNumber);
                } else {
                  // Notify all listener for each block that has passed
                  for (i = this._emitted.block + 1; i <= blockNumber; i++) {
                    this.emit("block", i);
                  }
                } // The emitted block was updated, check for obsolete events


                if (this._emitted.block !== blockNumber) {
                  this._emitted.block = blockNumber;
                  Object.keys(this._emitted).forEach(function (key) {
                    // The block event does not expire
                    if (key === "block") {
                      return;
                    } // The block we were at when we emitted this event


                    var eventBlockNumber = _this5._emitted[key]; // We cannot garbage collect pending transactions or blocks here
                    // They should be garbage collected by the Provider when setting
                    // "pending" events

                    if (eventBlockNumber === "pending") {
                      return;
                    } // Evict any transaction hashes or block hashes over 12 blocks
                    // old, since they should not return null anyways


                    if (blockNumber - eventBlockNumber > 12) {
                      delete _this5._emitted[key];
                    }
                  });
                } // First polling cycle


                if (this._lastBlockNumber === -2) {
                  this._lastBlockNumber = blockNumber - 1;
                } // Find all transaction hashes we are waiting on


                this._events.forEach(function (event) {
                  switch (event.type) {
                    case "tx":
                      {
                        var hash = event.hash;

                        var runner = _this5.getTransactionReceipt(hash).then(function (receipt) {
                          if (!receipt || receipt.blockNumber == null) {
                            return null;
                          }

                          _this5._emitted["t:" + hash] = receipt.blockNumber;

                          _this5.emit(hash, receipt);

                          return null;
                        })["catch"](function (error) {
                          _this5.emit("error", error);
                        });

                        runners.push(runner);
                        break;
                      }

                    case "filter":
                      {
                        // We only allow a single getLogs to be in-flight at a time
                        if (!event._inflight) {
                          event._inflight = true; // Filter from the last known event; due to load-balancing
                          // and some nodes returning updated block numbers before
                          // indexing events, a logs result with 0 entries cannot be
                          // trusted and we must retry a range which includes it again

                          var filter = event.filter;
                          filter.fromBlock = event._lastBlockNumber + 1;
                          filter.toBlock = blockNumber; // Prevent fitler ranges from growing too wild

                          if (filter.toBlock - _this5._maxFilterBlockRange > filter.fromBlock) {
                            filter.fromBlock = filter.toBlock - _this5._maxFilterBlockRange;
                          }

                          var _runner = _this5.getLogs(filter).then(function (logs) {
                            // Allow the next getLogs
                            event._inflight = false;

                            if (logs.length === 0) {
                              return;
                            }

                            logs.forEach(function (log) {
                              // Only when we get an event for a given block number
                              // can we trust the events are indexed
                              if (log.blockNumber > event._lastBlockNumber) {
                                event._lastBlockNumber = log.blockNumber;
                              } // Make sure we stall requests to fetch blocks and txs


                              _this5._emitted["b:" + log.blockHash] = log.blockNumber;
                              _this5._emitted["t:" + log.transactionHash] = log.blockNumber;

                              _this5.emit(filter, log);
                            });
                          })["catch"](function (error) {
                            _this5.emit("error", error); // Allow another getLogs (the range was not updated)


                            event._inflight = false;
                          });

                          runners.push(_runner);
                        }

                        break;
                      }
                  }
                });

                this._lastBlockNumber = blockNumber; // Once all events for this loop have been processed, emit "didPoll"

                Promise.all(runners).then(function () {
                  _this5.emit("didPoll", pollId);
                })["catch"](function (error) {
                  _this5.emit("error", error);
                });
                return _context10.abrupt("return");

              case 26:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this, [[3, 9]]);
      }));
    } // Deprecated; do not use this

  }, {
    key: "resetEventsBlock",
    value: function resetEventsBlock(blockNumber) {
      this._lastBlockNumber = blockNumber - 1;

      if (this.polling) {
        this.poll();
      }
    }
  }, {
    key: "network",
    get: function get() {
      return this._network;
    } // This method should query the network if the underlying network
    // can change, such as when connected to a JSON-RPC backend

  }, {
    key: "detectNetwork",
    value: function detectNetwork() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee11() {
        return regeneratorRuntime.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                return _context11.abrupt("return", logger.throwError("provider does not support network detection", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.UNSUPPORTED_OPERATION, {
                  operation: "provider.detectNetwork"
                }));

              case 1:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11);
      }));
    }
  }, {
    key: "getNetwork",
    value: function getNetwork() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee12() {
        var network, currentNetwork, error;
        return regeneratorRuntime.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.next = 2;
                return this._ready();

              case 2:
                network = _context12.sent;
                _context12.next = 5;
                return this.detectNetwork();

              case 5:
                currentNetwork = _context12.sent;

                if (!(network.chainId !== currentNetwork.chainId)) {
                  _context12.next = 23;
                  break;
                }

                if (!this.anyNetwork) {
                  _context12.next = 20;
                  break;
                }

                this._network = currentNetwork; // Reset all internal block number guards and caches

                this._lastBlockNumber = -2;
                this._fastBlockNumber = null;
                this._fastBlockNumberPromise = null;
                this._fastQueryDate = 0;
                this._emitted.block = -2;
                this._maxInternalBlockNumber = -1024;
                this._internalBlockNumber = null; // The "network" event MUST happen before this method resolves
                // so any events have a chance to unregister, so we stall an
                // additional event loop before returning from /this/ call

                this.emit("network", currentNetwork, network);
                _context12.next = 19;
                return stall(0);

              case 19:
                return _context12.abrupt("return", this._network);

              case 20:
                error = logger.makeError("underlying network changed", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.NETWORK_ERROR, {
                  event: "changed",
                  network: network,
                  detectedNetwork: currentNetwork
                });
                this.emit("error", error);
                throw error;

              case 23:
                return _context12.abrupt("return", network);

              case 24:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));
    }
  }, {
    key: "blockNumber",
    get: function get() {
      var _this6 = this;

      this._getInternalBlockNumber(100 + this.pollingInterval / 2).then(function (blockNumber) {
        _this6._setFastBlockNumber(blockNumber);
      }, function (error) {});

      return this._fastBlockNumber != null ? this._fastBlockNumber : -1;
    }
  }, {
    key: "polling",
    get: function get() {
      return this._poller != null;
    },
    set: function set(value) {
      var _this7 = this;

      if (value && !this._poller) {
        this._poller = setInterval(function () {
          _this7.poll();
        }, this.pollingInterval);

        if (!this._bootstrapPoll) {
          this._bootstrapPoll = setTimeout(function () {
            _this7.poll(); // We block additional polls until the polling interval
            // is done, to prevent overwhelming the poll function


            _this7._bootstrapPoll = setTimeout(function () {
              // If polling was disabled, something may require a poke
              // since starting the bootstrap poll and it was disabled
              if (!_this7._poller) {
                _this7.poll();
              } // Clear out the bootstrap so we can do another


              _this7._bootstrapPoll = null;
            }, _this7.pollingInterval);
          }, 0);
        }
      } else if (!value && this._poller) {
        clearInterval(this._poller);
        this._poller = null;
      }
    }
  }, {
    key: "pollingInterval",
    get: function get() {
      return this._pollingInterval;
    },
    set: function set(value) {
      var _this8 = this;

      if (typeof value !== "number" || value <= 0 || parseInt(String(value)) != value) {
        throw new Error("invalid polling interval");
      }

      this._pollingInterval = value;

      if (this._poller) {
        clearInterval(this._poller);
        this._poller = setInterval(function () {
          _this8.poll();
        }, this._pollingInterval);
      }
    }
  }, {
    key: "_getFastBlockNumber",
    value: function _getFastBlockNumber() {
      var _this9 = this;

      var now = getTime(); // Stale block number, request a newer value

      if (now - this._fastQueryDate > 2 * this._pollingInterval) {
        this._fastQueryDate = now;
        this._fastBlockNumberPromise = this.getBlockNumber().then(function (blockNumber) {
          if (_this9._fastBlockNumber == null || blockNumber > _this9._fastBlockNumber) {
            _this9._fastBlockNumber = blockNumber;
          }

          return _this9._fastBlockNumber;
        });
      }

      return this._fastBlockNumberPromise;
    }
  }, {
    key: "_setFastBlockNumber",
    value: function _setFastBlockNumber(blockNumber) {
      // Older block, maybe a stale request
      if (this._fastBlockNumber != null && blockNumber < this._fastBlockNumber) {
        return;
      } // Update the time we updated the blocknumber


      this._fastQueryDate = getTime(); // Newer block number, use  it

      if (this._fastBlockNumber == null || blockNumber > this._fastBlockNumber) {
        this._fastBlockNumber = blockNumber;
        this._fastBlockNumberPromise = Promise.resolve(blockNumber);
      }
    }
  }, {
    key: "waitForTransaction",
    value: function waitForTransaction(transactionHash, confirmations, timeout) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee13() {
        return regeneratorRuntime.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                return _context13.abrupt("return", this._waitForTransaction(transactionHash, confirmations == null ? 1 : confirmations, timeout || 0, null));

              case 1:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));
    }
  }, {
    key: "_waitForTransaction",
    value: function _waitForTransaction(transactionHash, confirmations, timeout, replaceable) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee16() {
        var _this10 = this;

        var receipt;
        return regeneratorRuntime.wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                _context16.next = 2;
                return this.getTransactionReceipt(transactionHash);

              case 2:
                receipt = _context16.sent;

                if (!((receipt ? receipt.confirmations : 0) >= confirmations)) {
                  _context16.next = 5;
                  break;
                }

                return _context16.abrupt("return", receipt);

              case 5:
                return _context16.abrupt("return", new Promise(function (resolve, reject) {
                  var cancelFuncs = [];
                  var done = false;

                  var alreadyDone = function alreadyDone() {
                    if (done) {
                      return true;
                    }

                    done = true;
                    cancelFuncs.forEach(function (func) {
                      func();
                    });
                    return false;
                  };

                  var minedHandler = function minedHandler(receipt) {
                    if (receipt.confirmations < confirmations) {
                      return;
                    }

                    if (alreadyDone()) {
                      return;
                    }

                    resolve(receipt);
                  };

                  _this10.on(transactionHash, minedHandler);

                  cancelFuncs.push(function () {
                    _this10.removeListener(transactionHash, minedHandler);
                  });

                  if (replaceable) {
                    var lastBlockNumber = replaceable.startBlock;
                    var scannedBlock = null;

                    var replaceHandler = function replaceHandler(blockNumber) {
                      return __awaiter(_this10, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee15() {
                        var _this11 = this;

                        return regeneratorRuntime.wrap(function _callee15$(_context15) {
                          while (1) {
                            switch (_context15.prev = _context15.next) {
                              case 0:
                                if (!done) {
                                  _context15.next = 2;
                                  break;
                                }

                                return _context15.abrupt("return");

                              case 2:
                                _context15.next = 4;
                                return stall(1000);

                              case 4:
                                this.getTransactionCount(replaceable.from).then(function (nonce) {
                                  return __awaiter(_this11, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee14() {
                                    var mined, block, ti, tx, _receipt, reason;

                                    return regeneratorRuntime.wrap(function _callee14$(_context14) {
                                      while (1) {
                                        switch (_context14.prev = _context14.next) {
                                          case 0:
                                            if (!done) {
                                              _context14.next = 2;
                                              break;
                                            }

                                            return _context14.abrupt("return");

                                          case 2:
                                            if (!(nonce <= replaceable.nonce)) {
                                              _context14.next = 6;
                                              break;
                                            }

                                            lastBlockNumber = blockNumber;
                                            _context14.next = 41;
                                            break;

                                          case 6:
                                            _context14.next = 8;
                                            return this.getTransaction(transactionHash);

                                          case 8:
                                            mined = _context14.sent;

                                            if (!(mined && mined.blockNumber != null)) {
                                              _context14.next = 11;
                                              break;
                                            }

                                            return _context14.abrupt("return");

                                          case 11:
                                            // First time scanning. We start a little earlier for some
                                            // wiggle room here to handle the eventually consistent nature
                                            // of blockchain (e.g. the getTransactionCount was for a
                                            // different block)
                                            if (scannedBlock == null) {
                                              scannedBlock = lastBlockNumber - 3;

                                              if (scannedBlock < replaceable.startBlock) {
                                                scannedBlock = replaceable.startBlock;
                                              }
                                            }

                                          case 12:
                                            if (!(scannedBlock <= blockNumber)) {
                                              _context14.next = 41;
                                              break;
                                            }

                                            if (!done) {
                                              _context14.next = 15;
                                              break;
                                            }

                                            return _context14.abrupt("return");

                                          case 15:
                                            _context14.next = 17;
                                            return this.getBlockWithTransactions(scannedBlock);

                                          case 17:
                                            block = _context14.sent;
                                            ti = 0;

                                          case 19:
                                            if (!(ti < block.transactions.length)) {
                                              _context14.next = 38;
                                              break;
                                            }

                                            tx = block.transactions[ti]; // Successfully mined!

                                            if (!(tx.hash === transactionHash)) {
                                              _context14.next = 23;
                                              break;
                                            }

                                            return _context14.abrupt("return");

                                          case 23:
                                            if (!(tx.from === replaceable.from && tx.nonce === replaceable.nonce)) {
                                              _context14.next = 35;
                                              break;
                                            }

                                            if (!done) {
                                              _context14.next = 26;
                                              break;
                                            }

                                            return _context14.abrupt("return");

                                          case 26:
                                            _context14.next = 28;
                                            return this.waitForTransaction(tx.hash, confirmations);

                                          case 28:
                                            _receipt = _context14.sent;

                                            if (!alreadyDone()) {
                                              _context14.next = 31;
                                              break;
                                            }

                                            return _context14.abrupt("return");

                                          case 31:
                                            // The reason we were replaced
                                            reason = "replaced";

                                            if (tx.data === replaceable.data && tx.to === replaceable.to && tx.value.eq(replaceable.value)) {
                                              reason = "repriced";
                                            } else if (tx.data === "0x" && tx.from === tx.to && tx.value.isZero()) {
                                              reason = "cancelled";
                                            } // Explain why we were replaced


                                            reject(logger.makeError("transaction was replaced", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.TRANSACTION_REPLACED, {
                                              cancelled: reason === "replaced" || reason === "cancelled",
                                              reason: reason,
                                              replacement: this._wrapTransaction(tx),
                                              hash: transactionHash,
                                              receipt: _receipt
                                            }));
                                            return _context14.abrupt("return");

                                          case 35:
                                            ti++;
                                            _context14.next = 19;
                                            break;

                                          case 38:
                                            scannedBlock++;
                                            _context14.next = 12;
                                            break;

                                          case 41:
                                            if (!done) {
                                              _context14.next = 43;
                                              break;
                                            }

                                            return _context14.abrupt("return");

                                          case 43:
                                            this.once("block", replaceHandler);

                                          case 44:
                                          case "end":
                                            return _context14.stop();
                                        }
                                      }
                                    }, _callee14, this);
                                  }));
                                }, function (error) {
                                  if (done) {
                                    return;
                                  }

                                  _this11.once("block", replaceHandler);
                                });

                              case 5:
                              case "end":
                                return _context15.stop();
                            }
                          }
                        }, _callee15, this);
                      }));
                    };

                    if (done) {
                      return;
                    }

                    _this10.once("block", replaceHandler);

                    cancelFuncs.push(function () {
                      _this10.removeListener("block", replaceHandler);
                    });
                  }

                  if (typeof timeout === "number" && timeout > 0) {
                    var timer = setTimeout(function () {
                      if (alreadyDone()) {
                        return;
                      }

                      reject(logger.makeError("timeout exceeded", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.TIMEOUT, {
                        timeout: timeout
                      }));
                    }, timeout);

                    if (timer.unref) {
                      timer.unref();
                    }

                    cancelFuncs.push(function () {
                      clearTimeout(timer);
                    });
                  }
                }));

              case 6:
              case "end":
                return _context16.stop();
            }
          }
        }, _callee16, this);
      }));
    }
  }, {
    key: "getBlockNumber",
    value: function getBlockNumber() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee17() {
        return regeneratorRuntime.wrap(function _callee17$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                return _context17.abrupt("return", this._getInternalBlockNumber(0));

              case 1:
              case "end":
                return _context17.stop();
            }
          }
        }, _callee17, this);
      }));
    }
  }, {
    key: "getGasPrice",
    value: function getGasPrice() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee18() {
        var result;
        return regeneratorRuntime.wrap(function _callee18$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                _context18.next = 2;
                return this.getNetwork();

              case 2:
                _context18.next = 4;
                return this.perform("getGasPrice", {});

              case 4:
                result = _context18.sent;
                _context18.prev = 5;
                return _context18.abrupt("return", _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from(result));

              case 9:
                _context18.prev = 9;
                _context18.t0 = _context18["catch"](5);
                return _context18.abrupt("return", logger.throwError("bad result from backend", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.SERVER_ERROR, {
                  method: "getGasPrice",
                  result: result,
                  error: _context18.t0
                }));

              case 12:
              case "end":
                return _context18.stop();
            }
          }
        }, _callee18, this, [[5, 9]]);
      }));
    }
  }, {
    key: "getBalance",
    value: function getBalance(addressOrName, blockTag) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee19() {
        var params, result;
        return regeneratorRuntime.wrap(function _callee19$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                _context19.next = 2;
                return this.getNetwork();

              case 2:
                _context19.next = 4;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.resolveProperties)({
                  address: this._getAddress(addressOrName),
                  blockTag: this._getBlockTag(blockTag)
                });

              case 4:
                params = _context19.sent;
                _context19.next = 7;
                return this.perform("getBalance", params);

              case 7:
                result = _context19.sent;
                _context19.prev = 8;
                return _context19.abrupt("return", _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from(result));

              case 12:
                _context19.prev = 12;
                _context19.t0 = _context19["catch"](8);
                return _context19.abrupt("return", logger.throwError("bad result from backend", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.SERVER_ERROR, {
                  method: "getBalance",
                  params: params,
                  result: result,
                  error: _context19.t0
                }));

              case 15:
              case "end":
                return _context19.stop();
            }
          }
        }, _callee19, this, [[8, 12]]);
      }));
    }
  }, {
    key: "getTransactionCount",
    value: function getTransactionCount(addressOrName, blockTag) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee20() {
        var params, result;
        return regeneratorRuntime.wrap(function _callee20$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                _context20.next = 2;
                return this.getNetwork();

              case 2:
                _context20.next = 4;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.resolveProperties)({
                  address: this._getAddress(addressOrName),
                  blockTag: this._getBlockTag(blockTag)
                });

              case 4:
                params = _context20.sent;
                _context20.next = 7;
                return this.perform("getTransactionCount", params);

              case 7:
                result = _context20.sent;
                _context20.prev = 8;
                return _context20.abrupt("return", _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from(result).toNumber());

              case 12:
                _context20.prev = 12;
                _context20.t0 = _context20["catch"](8);
                return _context20.abrupt("return", logger.throwError("bad result from backend", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.SERVER_ERROR, {
                  method: "getTransactionCount",
                  params: params,
                  result: result,
                  error: _context20.t0
                }));

              case 15:
              case "end":
                return _context20.stop();
            }
          }
        }, _callee20, this, [[8, 12]]);
      }));
    }
  }, {
    key: "getCode",
    value: function getCode(addressOrName, blockTag) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee21() {
        var params, result;
        return regeneratorRuntime.wrap(function _callee21$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                _context21.next = 2;
                return this.getNetwork();

              case 2:
                _context21.next = 4;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.resolveProperties)({
                  address: this._getAddress(addressOrName),
                  blockTag: this._getBlockTag(blockTag)
                });

              case 4:
                params = _context21.sent;
                _context21.next = 7;
                return this.perform("getCode", params);

              case 7:
                result = _context21.sent;
                _context21.prev = 8;
                return _context21.abrupt("return", (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexlify)(result));

              case 12:
                _context21.prev = 12;
                _context21.t0 = _context21["catch"](8);
                return _context21.abrupt("return", logger.throwError("bad result from backend", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.SERVER_ERROR, {
                  method: "getCode",
                  params: params,
                  result: result,
                  error: _context21.t0
                }));

              case 15:
              case "end":
                return _context21.stop();
            }
          }
        }, _callee21, this, [[8, 12]]);
      }));
    }
  }, {
    key: "getStorageAt",
    value: function getStorageAt(addressOrName, position, blockTag) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee22() {
        var params, result;
        return regeneratorRuntime.wrap(function _callee22$(_context22) {
          while (1) {
            switch (_context22.prev = _context22.next) {
              case 0:
                _context22.next = 2;
                return this.getNetwork();

              case 2:
                _context22.next = 4;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.resolveProperties)({
                  address: this._getAddress(addressOrName),
                  blockTag: this._getBlockTag(blockTag),
                  position: Promise.resolve(position).then(function (p) {
                    return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexValue)(p);
                  })
                });

              case 4:
                params = _context22.sent;
                _context22.next = 7;
                return this.perform("getStorageAt", params);

              case 7:
                result = _context22.sent;
                _context22.prev = 8;
                return _context22.abrupt("return", (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexlify)(result));

              case 12:
                _context22.prev = 12;
                _context22.t0 = _context22["catch"](8);
                return _context22.abrupt("return", logger.throwError("bad result from backend", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.SERVER_ERROR, {
                  method: "getStorageAt",
                  params: params,
                  result: result,
                  error: _context22.t0
                }));

              case 15:
              case "end":
                return _context22.stop();
            }
          }
        }, _callee22, this, [[8, 12]]);
      }));
    } // This should be called by any subclass wrapping a TransactionResponse

  }, {
    key: "_wrapTransaction",
    value: function _wrapTransaction(tx, hash, startBlock) {
      var _this12 = this;

      if (hash != null && (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataLength)(hash) !== 32) {
        throw new Error("invalid response - sendTransaction");
      }

      var result = tx; // Check the hash we expect is the same as the hash the server reported

      if (hash != null && tx.hash !== hash) {
        logger.throwError("Transaction hash mismatch from Provider.sendTransaction.", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.UNKNOWN_ERROR, {
          expectedHash: tx.hash,
          returnedHash: hash
        });
      }

      result.wait = function (confirms, timeout) {
        return __awaiter(_this12, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee23() {
          var replacement, receipt;
          return regeneratorRuntime.wrap(function _callee23$(_context23) {
            while (1) {
              switch (_context23.prev = _context23.next) {
                case 0:
                  if (confirms == null) {
                    confirms = 1;
                  }

                  if (timeout == null) {
                    timeout = 0;
                  } // Get the details to detect replacement


                  replacement = undefined;

                  if (confirms !== 0 && startBlock != null) {
                    replacement = {
                      data: tx.data,
                      from: tx.from,
                      nonce: tx.nonce,
                      to: tx.to,
                      value: tx.value,
                      startBlock: startBlock
                    };
                  }

                  _context23.next = 6;
                  return this._waitForTransaction(tx.hash, confirms, timeout, replacement);

                case 6:
                  receipt = _context23.sent;

                  if (!(receipt == null && confirms === 0)) {
                    _context23.next = 9;
                    break;
                  }

                  return _context23.abrupt("return", null);

                case 9:
                  // No longer pending, allow the polling loop to garbage collect this
                  this._emitted["t:" + tx.hash] = receipt.blockNumber;

                  if (receipt.status === 0) {
                    logger.throwError("transaction failed", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.CALL_EXCEPTION, {
                      transactionHash: tx.hash,
                      transaction: tx,
                      receipt: receipt
                    });
                  }

                  return _context23.abrupt("return", receipt);

                case 12:
                case "end":
                  return _context23.stop();
              }
            }
          }, _callee23, this);
        }));
      };

      return result;
    }
  }, {
    key: "sendTransaction",
    value: function sendTransaction(signedTransaction) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee24() {
        var hexTx, tx, blockNumber, hash;
        return regeneratorRuntime.wrap(function _callee24$(_context24) {
          while (1) {
            switch (_context24.prev = _context24.next) {
              case 0:
                _context24.next = 2;
                return this.getNetwork();

              case 2:
                _context24.next = 4;
                return Promise.resolve(signedTransaction).then(function (t) {
                  return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexlify)(t);
                });

              case 4:
                hexTx = _context24.sent;
                tx = this.formatter.transaction(signedTransaction);

                if (tx.confirmations == null) {
                  tx.confirmations = 0;
                }

                _context24.next = 9;
                return this._getInternalBlockNumber(100 + 2 * this.pollingInterval);

              case 9:
                blockNumber = _context24.sent;
                _context24.prev = 10;
                _context24.next = 13;
                return this.perform("sendTransaction", {
                  signedTransaction: hexTx
                });

              case 13:
                hash = _context24.sent;
                return _context24.abrupt("return", this._wrapTransaction(tx, hash, blockNumber));

              case 17:
                _context24.prev = 17;
                _context24.t0 = _context24["catch"](10);
                _context24.t0.transaction = tx;
                _context24.t0.transactionHash = tx.hash;
                throw _context24.t0;

              case 22:
              case "end":
                return _context24.stop();
            }
          }
        }, _callee24, this, [[10, 17]]);
      }));
    }
  }, {
    key: "_getTransactionRequest",
    value: function _getTransactionRequest(transaction) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee25() {
        var _this13 = this;

        var values, tx;
        return regeneratorRuntime.wrap(function _callee25$(_context25) {
          while (1) {
            switch (_context25.prev = _context25.next) {
              case 0:
                _context25.next = 2;
                return transaction;

              case 2:
                values = _context25.sent;
                tx = {};
                ["from", "to"].forEach(function (key) {
                  if (values[key] == null) {
                    return;
                  }

                  tx[key] = Promise.resolve(values[key]).then(function (v) {
                    return v ? _this13._getAddress(v) : null;
                  });
                });
                ["gasLimit", "gasPrice", "maxFeePerGas", "maxPriorityFeePerGas", "value"].forEach(function (key) {
                  if (values[key] == null) {
                    return;
                  }

                  tx[key] = Promise.resolve(values[key]).then(function (v) {
                    return v ? _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from(v) : null;
                  });
                });
                ["type"].forEach(function (key) {
                  if (values[key] == null) {
                    return;
                  }

                  tx[key] = Promise.resolve(values[key]).then(function (v) {
                    return v != null ? v : null;
                  });
                });

                if (values.accessList) {
                  tx.accessList = this.formatter.accessList(values.accessList);
                }

                ["data"].forEach(function (key) {
                  if (values[key] == null) {
                    return;
                  }

                  tx[key] = Promise.resolve(values[key]).then(function (v) {
                    return v ? (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexlify)(v) : null;
                  });
                });
                _context25.t0 = this.formatter;
                _context25.next = 12;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.resolveProperties)(tx);

              case 12:
                _context25.t1 = _context25.sent;
                return _context25.abrupt("return", _context25.t0.transactionRequest.call(_context25.t0, _context25.t1));

              case 14:
              case "end":
                return _context25.stop();
            }
          }
        }, _callee25, this);
      }));
    }
  }, {
    key: "_getFilter",
    value: function _getFilter(filter) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee26() {
        var _this14 = this;

        var result;
        return regeneratorRuntime.wrap(function _callee26$(_context26) {
          while (1) {
            switch (_context26.prev = _context26.next) {
              case 0:
                _context26.next = 2;
                return filter;

              case 2:
                filter = _context26.sent;
                result = {};

                if (filter.address != null) {
                  result.address = this._getAddress(filter.address);
                }

                ["blockHash", "topics"].forEach(function (key) {
                  if (filter[key] == null) {
                    return;
                  }

                  result[key] = filter[key];
                });
                ["fromBlock", "toBlock"].forEach(function (key) {
                  if (filter[key] == null) {
                    return;
                  }

                  result[key] = _this14._getBlockTag(filter[key]);
                });
                _context26.t0 = this.formatter;
                _context26.next = 10;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.resolveProperties)(result);

              case 10:
                _context26.t1 = _context26.sent;
                return _context26.abrupt("return", _context26.t0.filter.call(_context26.t0, _context26.t1));

              case 12:
              case "end":
                return _context26.stop();
            }
          }
        }, _callee26, this);
      }));
    }
  }, {
    key: "_call",
    value: function _call(transaction, blockTag, attempt) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee27() {
        var txSender, result, data, sender, urls, urlsOffset, urlsLength, urlsData, u, url, calldata, callbackSelector, extraData, ccipResult, tx;
        return regeneratorRuntime.wrap(function _callee27$(_context27) {
          while (1) {
            switch (_context27.prev = _context27.next) {
              case 0:
                if (attempt >= MAX_CCIP_REDIRECTS) {
                  logger.throwError("CCIP read exceeded maximum redirections", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.SERVER_ERROR, {
                    redirects: attempt,
                    transaction: transaction
                  });
                }

                txSender = transaction.to;
                _context27.next = 4;
                return this.perform("call", {
                  transaction: transaction,
                  blockTag: blockTag
                });

              case 4:
                result = _context27.sent;

                if (!(attempt >= 0 && blockTag === "latest" && txSender != null && result.substring(0, 10) === "0x556f1830" && (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataLength)(result) % 32 === 4)) {
                  _context27.next = 31;
                  break;
                }

                _context27.prev = 6;
                data = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataSlice)(result, 4); // Check the sender of the OffchainLookup matches the transaction

                sender = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataSlice)(data, 0, 32);

                if (!_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from(sender).eq(txSender)) {
                  logger.throwError("CCIP Read sender did not match", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.CALL_EXCEPTION, {
                    name: "OffchainLookup",
                    signature: "OffchainLookup(address,string[],bytes,bytes4,bytes)",
                    transaction: transaction,
                    data: result
                  });
                } // Read the URLs from the response


                urls = [];
                urlsOffset = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataSlice)(data, 32, 64)).toNumber();
                urlsLength = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataSlice)(data, urlsOffset, urlsOffset + 32)).toNumber();
                urlsData = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataSlice)(data, urlsOffset + 32);

                for (u = 0; u < urlsLength; u++) {
                  url = _parseString(urlsData, u * 32);

                  if (url == null) {
                    logger.throwError("CCIP Read contained corrupt URL string", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.CALL_EXCEPTION, {
                      name: "OffchainLookup",
                      signature: "OffchainLookup(address,string[],bytes,bytes4,bytes)",
                      transaction: transaction,
                      data: result
                    });
                  }

                  urls.push(url);
                } // Get the CCIP calldata to forward


                calldata = _parseBytes(data, 64); // Get the callbackSelector (bytes4)

                if (!_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataSlice)(data, 100, 128)).isZero()) {
                  logger.throwError("CCIP Read callback selector included junk", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.CALL_EXCEPTION, {
                    name: "OffchainLookup",
                    signature: "OffchainLookup(address,string[],bytes,bytes4,bytes)",
                    transaction: transaction,
                    data: result
                  });
                }

                callbackSelector = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexDataSlice)(data, 96, 100); // Get the extra data to send back to the contract as context

                extraData = _parseBytes(data, 128);
                _context27.next = 21;
                return this.ccipReadFetch(transaction, calldata, urls);

              case 21:
                ccipResult = _context27.sent;

                if (ccipResult == null) {
                  logger.throwError("CCIP Read disabled or provided no URLs", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.CALL_EXCEPTION, {
                    name: "OffchainLookup",
                    signature: "OffchainLookup(address,string[],bytes,bytes4,bytes)",
                    transaction: transaction,
                    data: result
                  });
                }

                tx = {
                  to: txSender,
                  data: (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexConcat)([callbackSelector, encodeBytes([ccipResult, extraData])])
                };
                return _context27.abrupt("return", this._call(tx, blockTag, attempt + 1));

              case 27:
                _context27.prev = 27;
                _context27.t0 = _context27["catch"](6);

                if (!(_context27.t0.code === _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.SERVER_ERROR)) {
                  _context27.next = 31;
                  break;
                }

                throw _context27.t0;

              case 31:
                _context27.prev = 31;
                return _context27.abrupt("return", (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.hexlify)(result));

              case 35:
                _context27.prev = 35;
                _context27.t1 = _context27["catch"](31);
                return _context27.abrupt("return", logger.throwError("bad result from backend", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.SERVER_ERROR, {
                  method: "call",
                  params: {
                    transaction: transaction,
                    blockTag: blockTag
                  },
                  result: result,
                  error: _context27.t1
                }));

              case 38:
              case "end":
                return _context27.stop();
            }
          }
        }, _callee27, this, [[6, 27], [31, 35]]);
      }));
    }
  }, {
    key: "call",
    value: function call(transaction, blockTag) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee28() {
        var resolved;
        return regeneratorRuntime.wrap(function _callee28$(_context28) {
          while (1) {
            switch (_context28.prev = _context28.next) {
              case 0:
                _context28.next = 2;
                return this.getNetwork();

              case 2:
                _context28.next = 4;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.resolveProperties)({
                  transaction: this._getTransactionRequest(transaction),
                  blockTag: this._getBlockTag(blockTag),
                  ccipReadEnabled: Promise.resolve(transaction.ccipReadEnabled)
                });

              case 4:
                resolved = _context28.sent;
                return _context28.abrupt("return", this._call(resolved.transaction, resolved.blockTag, resolved.ccipReadEnabled ? 0 : -1));

              case 6:
              case "end":
                return _context28.stop();
            }
          }
        }, _callee28, this);
      }));
    }
  }, {
    key: "estimateGas",
    value: function estimateGas(transaction) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee29() {
        var params, result;
        return regeneratorRuntime.wrap(function _callee29$(_context29) {
          while (1) {
            switch (_context29.prev = _context29.next) {
              case 0:
                _context29.next = 2;
                return this.getNetwork();

              case 2:
                _context29.next = 4;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.resolveProperties)({
                  transaction: this._getTransactionRequest(transaction)
                });

              case 4:
                params = _context29.sent;
                _context29.next = 7;
                return this.perform("estimateGas", params);

              case 7:
                result = _context29.sent;
                _context29.prev = 8;
                return _context29.abrupt("return", _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_6__.BigNumber.from(result));

              case 12:
                _context29.prev = 12;
                _context29.t0 = _context29["catch"](8);
                return _context29.abrupt("return", logger.throwError("bad result from backend", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.SERVER_ERROR, {
                  method: "estimateGas",
                  params: params,
                  result: result,
                  error: _context29.t0
                }));

              case 15:
              case "end":
                return _context29.stop();
            }
          }
        }, _callee29, this, [[8, 12]]);
      }));
    }
  }, {
    key: "_getAddress",
    value: function _getAddress(addressOrName) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee30() {
        var address;
        return regeneratorRuntime.wrap(function _callee30$(_context30) {
          while (1) {
            switch (_context30.prev = _context30.next) {
              case 0:
                _context30.next = 2;
                return addressOrName;

              case 2:
                addressOrName = _context30.sent;

                if (typeof addressOrName !== "string") {
                  logger.throwArgumentError("invalid address or ENS name", "name", addressOrName);
                }

                _context30.next = 6;
                return this.resolveName(addressOrName);

              case 6:
                address = _context30.sent;

                if (address == null) {
                  logger.throwError("ENS name not configured", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.UNSUPPORTED_OPERATION, {
                    operation: "resolveName(".concat(JSON.stringify(addressOrName), ")")
                  });
                }

                return _context30.abrupt("return", address);

              case 9:
              case "end":
                return _context30.stop();
            }
          }
        }, _callee30, this);
      }));
    }
  }, {
    key: "_getBlock",
    value: function _getBlock(blockHashOrBlockTag, includeTransactions) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee32() {
        var _this15 = this;

        var blockNumber, params;
        return regeneratorRuntime.wrap(function _callee32$(_context32) {
          while (1) {
            switch (_context32.prev = _context32.next) {
              case 0:
                _context32.next = 2;
                return this.getNetwork();

              case 2:
                _context32.next = 4;
                return blockHashOrBlockTag;

              case 4:
                blockHashOrBlockTag = _context32.sent;
                // If blockTag is a number (not "latest", etc), this is the block number
                blockNumber = -128;
                params = {
                  includeTransactions: !!includeTransactions
                };

                if (!(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isHexString)(blockHashOrBlockTag, 32)) {
                  _context32.next = 11;
                  break;
                }

                params.blockHash = blockHashOrBlockTag;
                _context32.next = 21;
                break;

              case 11:
                _context32.prev = 11;
                _context32.next = 14;
                return this._getBlockTag(blockHashOrBlockTag);

              case 14:
                params.blockTag = _context32.sent;

                if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isHexString)(params.blockTag)) {
                  blockNumber = parseInt(params.blockTag.substring(2), 16);
                }

                _context32.next = 21;
                break;

              case 18:
                _context32.prev = 18;
                _context32.t0 = _context32["catch"](11);
                logger.throwArgumentError("invalid block hash or block tag", "blockHashOrBlockTag", blockHashOrBlockTag);

              case 21:
                return _context32.abrupt("return", (0,_ethersproject_web__WEBPACK_IMPORTED_MODULE_12__.poll)(function () {
                  return __awaiter(_this15, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee31() {
                    var _this16 = this;

                    var block, _blockNumber, i, tx, confirmations, blockWithTxs;

                    return regeneratorRuntime.wrap(function _callee31$(_context31) {
                      while (1) {
                        switch (_context31.prev = _context31.next) {
                          case 0:
                            _context31.next = 2;
                            return this.perform("getBlock", params);

                          case 2:
                            block = _context31.sent;

                            if (!(block == null)) {
                              _context31.next = 11;
                              break;
                            }

                            if (!(params.blockHash != null)) {
                              _context31.next = 7;
                              break;
                            }

                            if (!(this._emitted["b:" + params.blockHash] == null)) {
                              _context31.next = 7;
                              break;
                            }

                            return _context31.abrupt("return", null);

                          case 7:
                            if (!(params.blockTag != null)) {
                              _context31.next = 10;
                              break;
                            }

                            if (!(blockNumber > this._emitted.block)) {
                              _context31.next = 10;
                              break;
                            }

                            return _context31.abrupt("return", null);

                          case 10:
                            return _context31.abrupt("return", undefined);

                          case 11:
                            if (!includeTransactions) {
                              _context31.next = 34;
                              break;
                            }

                            _blockNumber = null;
                            i = 0;

                          case 14:
                            if (!(i < block.transactions.length)) {
                              _context31.next = 31;
                              break;
                            }

                            tx = block.transactions[i];

                            if (!(tx.blockNumber == null)) {
                              _context31.next = 20;
                              break;
                            }

                            tx.confirmations = 0;
                            _context31.next = 28;
                            break;

                          case 20:
                            if (!(tx.confirmations == null)) {
                              _context31.next = 28;
                              break;
                            }

                            if (!(_blockNumber == null)) {
                              _context31.next = 25;
                              break;
                            }

                            _context31.next = 24;
                            return this._getInternalBlockNumber(100 + 2 * this.pollingInterval);

                          case 24:
                            _blockNumber = _context31.sent;

                          case 25:
                            // Add the confirmations using the fast block number (pessimistic)
                            confirmations = _blockNumber - tx.blockNumber + 1;

                            if (confirmations <= 0) {
                              confirmations = 1;
                            }

                            tx.confirmations = confirmations;

                          case 28:
                            i++;
                            _context31.next = 14;
                            break;

                          case 31:
                            blockWithTxs = this.formatter.blockWithTransactions(block);
                            blockWithTxs.transactions = blockWithTxs.transactions.map(function (tx) {
                              return _this16._wrapTransaction(tx);
                            });
                            return _context31.abrupt("return", blockWithTxs);

                          case 34:
                            return _context31.abrupt("return", this.formatter.block(block));

                          case 35:
                          case "end":
                            return _context31.stop();
                        }
                      }
                    }, _callee31, this);
                  }));
                }, {
                  oncePoll: this
                }));

              case 22:
              case "end":
                return _context32.stop();
            }
          }
        }, _callee32, this, [[11, 18]]);
      }));
    }
  }, {
    key: "getBlock",
    value: function getBlock(blockHashOrBlockTag) {
      return this._getBlock(blockHashOrBlockTag, false);
    }
  }, {
    key: "getBlockWithTransactions",
    value: function getBlockWithTransactions(blockHashOrBlockTag) {
      return this._getBlock(blockHashOrBlockTag, true);
    }
  }, {
    key: "getTransaction",
    value: function getTransaction(transactionHash) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee34() {
        var _this17 = this;

        var params;
        return regeneratorRuntime.wrap(function _callee34$(_context34) {
          while (1) {
            switch (_context34.prev = _context34.next) {
              case 0:
                _context34.next = 2;
                return this.getNetwork();

              case 2:
                _context34.next = 4;
                return transactionHash;

              case 4:
                transactionHash = _context34.sent;
                params = {
                  transactionHash: this.formatter.hash(transactionHash, true)
                };
                return _context34.abrupt("return", (0,_ethersproject_web__WEBPACK_IMPORTED_MODULE_12__.poll)(function () {
                  return __awaiter(_this17, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee33() {
                    var result, tx, blockNumber, confirmations;
                    return regeneratorRuntime.wrap(function _callee33$(_context33) {
                      while (1) {
                        switch (_context33.prev = _context33.next) {
                          case 0:
                            _context33.next = 2;
                            return this.perform("getTransaction", params);

                          case 2:
                            result = _context33.sent;

                            if (!(result == null)) {
                              _context33.next = 7;
                              break;
                            }

                            if (!(this._emitted["t:" + transactionHash] == null)) {
                              _context33.next = 6;
                              break;
                            }

                            return _context33.abrupt("return", null);

                          case 6:
                            return _context33.abrupt("return", undefined);

                          case 7:
                            tx = this.formatter.transactionResponse(result);

                            if (!(tx.blockNumber == null)) {
                              _context33.next = 12;
                              break;
                            }

                            tx.confirmations = 0;
                            _context33.next = 19;
                            break;

                          case 12:
                            if (!(tx.confirmations == null)) {
                              _context33.next = 19;
                              break;
                            }

                            _context33.next = 15;
                            return this._getInternalBlockNumber(100 + 2 * this.pollingInterval);

                          case 15:
                            blockNumber = _context33.sent;
                            // Add the confirmations using the fast block number (pessimistic)
                            confirmations = blockNumber - tx.blockNumber + 1;

                            if (confirmations <= 0) {
                              confirmations = 1;
                            }

                            tx.confirmations = confirmations;

                          case 19:
                            return _context33.abrupt("return", this._wrapTransaction(tx));

                          case 20:
                          case "end":
                            return _context33.stop();
                        }
                      }
                    }, _callee33, this);
                  }));
                }, {
                  oncePoll: this
                }));

              case 7:
              case "end":
                return _context34.stop();
            }
          }
        }, _callee34, this);
      }));
    }
  }, {
    key: "getTransactionReceipt",
    value: function getTransactionReceipt(transactionHash) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee36() {
        var _this18 = this;

        var params;
        return regeneratorRuntime.wrap(function _callee36$(_context36) {
          while (1) {
            switch (_context36.prev = _context36.next) {
              case 0:
                _context36.next = 2;
                return this.getNetwork();

              case 2:
                _context36.next = 4;
                return transactionHash;

              case 4:
                transactionHash = _context36.sent;
                params = {
                  transactionHash: this.formatter.hash(transactionHash, true)
                };
                return _context36.abrupt("return", (0,_ethersproject_web__WEBPACK_IMPORTED_MODULE_12__.poll)(function () {
                  return __awaiter(_this18, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee35() {
                    var result, receipt, blockNumber, confirmations;
                    return regeneratorRuntime.wrap(function _callee35$(_context35) {
                      while (1) {
                        switch (_context35.prev = _context35.next) {
                          case 0:
                            _context35.next = 2;
                            return this.perform("getTransactionReceipt", params);

                          case 2:
                            result = _context35.sent;

                            if (!(result == null)) {
                              _context35.next = 7;
                              break;
                            }

                            if (!(this._emitted["t:" + transactionHash] == null)) {
                              _context35.next = 6;
                              break;
                            }

                            return _context35.abrupt("return", null);

                          case 6:
                            return _context35.abrupt("return", undefined);

                          case 7:
                            if (!(result.blockHash == null)) {
                              _context35.next = 9;
                              break;
                            }

                            return _context35.abrupt("return", undefined);

                          case 9:
                            receipt = this.formatter.receipt(result);

                            if (!(receipt.blockNumber == null)) {
                              _context35.next = 14;
                              break;
                            }

                            receipt.confirmations = 0;
                            _context35.next = 21;
                            break;

                          case 14:
                            if (!(receipt.confirmations == null)) {
                              _context35.next = 21;
                              break;
                            }

                            _context35.next = 17;
                            return this._getInternalBlockNumber(100 + 2 * this.pollingInterval);

                          case 17:
                            blockNumber = _context35.sent;
                            // Add the confirmations using the fast block number (pessimistic)
                            confirmations = blockNumber - receipt.blockNumber + 1;

                            if (confirmations <= 0) {
                              confirmations = 1;
                            }

                            receipt.confirmations = confirmations;

                          case 21:
                            return _context35.abrupt("return", receipt);

                          case 22:
                          case "end":
                            return _context35.stop();
                        }
                      }
                    }, _callee35, this);
                  }));
                }, {
                  oncePoll: this
                }));

              case 7:
              case "end":
                return _context36.stop();
            }
          }
        }, _callee36, this);
      }));
    }
  }, {
    key: "getLogs",
    value: function getLogs(filter) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee37() {
        var params, logs;
        return regeneratorRuntime.wrap(function _callee37$(_context37) {
          while (1) {
            switch (_context37.prev = _context37.next) {
              case 0:
                _context37.next = 2;
                return this.getNetwork();

              case 2:
                _context37.next = 4;
                return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_5__.resolveProperties)({
                  filter: this._getFilter(filter)
                });

              case 4:
                params = _context37.sent;
                _context37.next = 7;
                return this.perform("getLogs", params);

              case 7:
                logs = _context37.sent;
                logs.forEach(function (log) {
                  if (log.removed == null) {
                    log.removed = false;
                  }
                });
                return _context37.abrupt("return", _formatter__WEBPACK_IMPORTED_MODULE_13__.Formatter.arrayOf(this.formatter.filterLog.bind(this.formatter))(logs));

              case 10:
              case "end":
                return _context37.stop();
            }
          }
        }, _callee37, this);
      }));
    }
  }, {
    key: "getEtherPrice",
    value: function getEtherPrice() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee38() {
        return regeneratorRuntime.wrap(function _callee38$(_context38) {
          while (1) {
            switch (_context38.prev = _context38.next) {
              case 0:
                _context38.next = 2;
                return this.getNetwork();

              case 2:
                return _context38.abrupt("return", this.perform("getEtherPrice", {}));

              case 3:
              case "end":
                return _context38.stop();
            }
          }
        }, _callee38, this);
      }));
    }
  }, {
    key: "_getBlockTag",
    value: function _getBlockTag(blockTag) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee39() {
        var blockNumber;
        return regeneratorRuntime.wrap(function _callee39$(_context39) {
          while (1) {
            switch (_context39.prev = _context39.next) {
              case 0:
                _context39.next = 2;
                return blockTag;

              case 2:
                blockTag = _context39.sent;

                if (!(typeof blockTag === "number" && blockTag < 0)) {
                  _context39.next = 11;
                  break;
                }

                if (blockTag % 1) {
                  logger.throwArgumentError("invalid BlockTag", "blockTag", blockTag);
                }

                _context39.next = 7;
                return this._getInternalBlockNumber(100 + 2 * this.pollingInterval);

              case 7:
                blockNumber = _context39.sent;
                blockNumber += blockTag;

                if (blockNumber < 0) {
                  blockNumber = 0;
                }

                return _context39.abrupt("return", this.formatter.blockTag(blockNumber));

              case 11:
                return _context39.abrupt("return", this.formatter.blockTag(blockTag));

              case 12:
              case "end":
                return _context39.stop();
            }
          }
        }, _callee39, this);
      }));
    }
  }, {
    key: "getResolver",
    value: function getResolver(name) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee40() {
        var currentName, addr, resolver;
        return regeneratorRuntime.wrap(function _callee40$(_context40) {
          while (1) {
            switch (_context40.prev = _context40.next) {
              case 0:
                currentName = name;

              case 1:
                if (false) {}

                if (!(currentName === "" || currentName === ".")) {
                  _context40.next = 4;
                  break;
                }

                return _context40.abrupt("return", null);

              case 4:
                if (!(name !== "eth" && currentName === "eth")) {
                  _context40.next = 6;
                  break;
                }

                return _context40.abrupt("return", null);

              case 6:
                _context40.next = 8;
                return this._getResolver(currentName, "getResolver");

              case 8:
                addr = _context40.sent;

                if (!(addr != null)) {
                  _context40.next = 19;
                  break;
                }

                resolver = new Resolver(this, addr, name); // Legacy resolver found, using EIP-2544 so it isn't safe to use

                _context40.t0 = currentName !== name;

                if (!_context40.t0) {
                  _context40.next = 16;
                  break;
                }

                _context40.next = 15;
                return resolver.supportsWildcard();

              case 15:
                _context40.t0 = !_context40.sent;

              case 16:
                if (!_context40.t0) {
                  _context40.next = 18;
                  break;
                }

                return _context40.abrupt("return", null);

              case 18:
                return _context40.abrupt("return", resolver);

              case 19:
                // Get the parent node
                currentName = currentName.split(".").slice(1).join(".");
                _context40.next = 1;
                break;

              case 22:
              case "end":
                return _context40.stop();
            }
          }
        }, _callee40, this);
      }));
    }
  }, {
    key: "_getResolver",
    value: function _getResolver(name, operation) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee41() {
        var network, addrData;
        return regeneratorRuntime.wrap(function _callee41$(_context41) {
          while (1) {
            switch (_context41.prev = _context41.next) {
              case 0:
                if (operation == null) {
                  operation = "ENS";
                }

                _context41.next = 3;
                return this.getNetwork();

              case 3:
                network = _context41.sent;

                // No ENS...
                if (!network.ensAddress) {
                  logger.throwError("network does not support ENS", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.UNSUPPORTED_OPERATION, {
                    operation: operation,
                    network: network.name
                  });
                }

                _context41.prev = 5;
                _context41.next = 8;
                return this.call({
                  to: network.ensAddress,
                  data: "0x0178b8bf" + (0,_ethersproject_hash__WEBPACK_IMPORTED_MODULE_10__.namehash)(name).substring(2)
                });

              case 8:
                addrData = _context41.sent;
                return _context41.abrupt("return", this.formatter.callAddress(addrData));

              case 12:
                _context41.prev = 12;
                _context41.t0 = _context41["catch"](5);

              case 14:
                return _context41.abrupt("return", null);

              case 15:
              case "end":
                return _context41.stop();
            }
          }
        }, _callee41, this, [[5, 12]]);
      }));
    }
  }, {
    key: "resolveName",
    value: function resolveName(name) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee42() {
        var resolver;
        return regeneratorRuntime.wrap(function _callee42$(_context42) {
          while (1) {
            switch (_context42.prev = _context42.next) {
              case 0:
                _context42.next = 2;
                return name;

              case 2:
                name = _context42.sent;
                _context42.prev = 3;
                return _context42.abrupt("return", Promise.resolve(this.formatter.address(name)));

              case 7:
                _context42.prev = 7;
                _context42.t0 = _context42["catch"](3);

                if (!(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isHexString)(name)) {
                  _context42.next = 11;
                  break;
                }

                throw _context42.t0;

              case 11:
                if (typeof name !== "string") {
                  logger.throwArgumentError("invalid ENS name", "name", name);
                } // Get the addr from the resovler


                _context42.next = 14;
                return this.getResolver(name);

              case 14:
                resolver = _context42.sent;

                if (resolver) {
                  _context42.next = 17;
                  break;
                }

                return _context42.abrupt("return", null);

              case 17:
                _context42.next = 19;
                return resolver.getAddress();

              case 19:
                return _context42.abrupt("return", _context42.sent);

              case 20:
              case "end":
                return _context42.stop();
            }
          }
        }, _callee42, this, [[3, 7]]);
      }));
    }
  }, {
    key: "lookupAddress",
    value: function lookupAddress(address) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee43() {
        var node, resolverAddr, name, addr;
        return regeneratorRuntime.wrap(function _callee43$(_context43) {
          while (1) {
            switch (_context43.prev = _context43.next) {
              case 0:
                _context43.next = 2;
                return address;

              case 2:
                address = _context43.sent;
                address = this.formatter.address(address);
                node = address.substring(2).toLowerCase() + ".addr.reverse";
                _context43.next = 7;
                return this._getResolver(node, "lookupAddress");

              case 7:
                resolverAddr = _context43.sent;

                if (!(resolverAddr == null)) {
                  _context43.next = 10;
                  break;
                }

                return _context43.abrupt("return", null);

              case 10:
                _context43.t0 = _parseString;
                _context43.next = 13;
                return this.call({
                  to: resolverAddr,
                  data: "0x691f3431" + (0,_ethersproject_hash__WEBPACK_IMPORTED_MODULE_10__.namehash)(node).substring(2)
                });

              case 13:
                _context43.t1 = _context43.sent;
                name = (0, _context43.t0)(_context43.t1, 0);
                _context43.next = 17;
                return this.resolveName(name);

              case 17:
                addr = _context43.sent;

                if (!(addr != address)) {
                  _context43.next = 20;
                  break;
                }

                return _context43.abrupt("return", null);

              case 20:
                return _context43.abrupt("return", name);

              case 21:
              case "end":
                return _context43.stop();
            }
          }
        }, _callee43, this);
      }));
    }
  }, {
    key: "getAvatar",
    value: function getAvatar(nameOrAddress) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee44() {
        var resolver, address, node, resolverAddress, _avatar, name, avatar;

        return regeneratorRuntime.wrap(function _callee44$(_context44) {
          while (1) {
            switch (_context44.prev = _context44.next) {
              case 0:
                resolver = null;

                if (!(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.isHexString)(nameOrAddress)) {
                  _context44.next = 40;
                  break;
                }

                // Address; reverse lookup
                address = this.formatter.address(nameOrAddress);
                node = address.substring(2).toLowerCase() + ".addr.reverse";
                _context44.next = 6;
                return this._getResolver(node, "getAvatar");

              case 6:
                resolverAddress = _context44.sent;

                if (resolverAddress) {
                  _context44.next = 9;
                  break;
                }

                return _context44.abrupt("return", null);

              case 9:
                // Try resolving the avatar against the addr.reverse resolver
                resolver = new Resolver(this, resolverAddress, node);
                _context44.prev = 10;
                _context44.next = 13;
                return resolver.getAvatar();

              case 13:
                _avatar = _context44.sent;

                if (!_avatar) {
                  _context44.next = 16;
                  break;
                }

                return _context44.abrupt("return", _avatar.url);

              case 16:
                _context44.next = 22;
                break;

              case 18:
                _context44.prev = 18;
                _context44.t0 = _context44["catch"](10);

                if (!(_context44.t0.code !== _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.CALL_EXCEPTION)) {
                  _context44.next = 22;
                  break;
                }

                throw _context44.t0;

              case 22:
                _context44.prev = 22;
                _context44.t1 = _parseString;
                _context44.next = 26;
                return this.call({
                  to: resolverAddress,
                  data: "0x691f3431" + (0,_ethersproject_hash__WEBPACK_IMPORTED_MODULE_10__.namehash)(node).substring(2)
                });

              case 26:
                _context44.t2 = _context44.sent;
                name = (0, _context44.t1)(_context44.t2, 0);
                _context44.next = 30;
                return this.getResolver(name);

              case 30:
                resolver = _context44.sent;
                _context44.next = 38;
                break;

              case 33:
                _context44.prev = 33;
                _context44.t3 = _context44["catch"](22);

                if (!(_context44.t3.code !== _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.CALL_EXCEPTION)) {
                  _context44.next = 37;
                  break;
                }

                throw _context44.t3;

              case 37:
                return _context44.abrupt("return", null);

              case 38:
                _context44.next = 45;
                break;

              case 40:
                _context44.next = 42;
                return this.getResolver(nameOrAddress);

              case 42:
                resolver = _context44.sent;

                if (resolver) {
                  _context44.next = 45;
                  break;
                }

                return _context44.abrupt("return", null);

              case 45:
                _context44.next = 47;
                return resolver.getAvatar();

              case 47:
                avatar = _context44.sent;

                if (!(avatar == null)) {
                  _context44.next = 50;
                  break;
                }

                return _context44.abrupt("return", null);

              case 50:
                return _context44.abrupt("return", avatar.url);

              case 51:
              case "end":
                return _context44.stop();
            }
          }
        }, _callee44, this, [[10, 18], [22, 33]]);
      }));
    }
  }, {
    key: "perform",
    value: function perform(method, params) {
      return logger.throwError(method + " not implemented", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.NOT_IMPLEMENTED, {
        operation: method
      });
    }
  }, {
    key: "_startEvent",
    value: function _startEvent(event) {
      this.polling = this._events.filter(function (e) {
        return e.pollable();
      }).length > 0;
    }
  }, {
    key: "_stopEvent",
    value: function _stopEvent(event) {
      this.polling = this._events.filter(function (e) {
        return e.pollable();
      }).length > 0;
    }
  }, {
    key: "_addEventListener",
    value: function _addEventListener(eventName, listener, once) {
      var event = new Event(getEventTag(eventName), listener, once);

      this._events.push(event);

      this._startEvent(event);

      return this;
    }
  }, {
    key: "on",
    value: function on(eventName, listener) {
      return this._addEventListener(eventName, listener, false);
    }
  }, {
    key: "once",
    value: function once(eventName, listener) {
      return this._addEventListener(eventName, listener, true);
    }
  }, {
    key: "emit",
    value: function emit(eventName) {
      var _this19 = this;

      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      var result = false;
      var stopped = [];
      var eventTag = getEventTag(eventName);
      this._events = this._events.filter(function (event) {
        if (event.tag !== eventTag) {
          return true;
        }

        setTimeout(function () {
          event.listener.apply(_this19, args);
        }, 0);
        result = true;

        if (event.once) {
          stopped.push(event);
          return false;
        }

        return true;
      });
      stopped.forEach(function (event) {
        _this19._stopEvent(event);
      });
      return result;
    }
  }, {
    key: "listenerCount",
    value: function listenerCount(eventName) {
      if (!eventName) {
        return this._events.length;
      }

      var eventTag = getEventTag(eventName);
      return this._events.filter(function (event) {
        return event.tag === eventTag;
      }).length;
    }
  }, {
    key: "listeners",
    value: function listeners(eventName) {
      if (eventName == null) {
        return this._events.map(function (event) {
          return event.listener;
        });
      }

      var eventTag = getEventTag(eventName);
      return this._events.filter(function (event) {
        return event.tag === eventTag;
      }).map(function (event) {
        return event.listener;
      });
    }
  }, {
    key: "off",
    value: function off(eventName, listener) {
      var _this20 = this;

      if (listener == null) {
        return this.removeAllListeners(eventName);
      }

      var stopped = [];
      var found = false;
      var eventTag = getEventTag(eventName);
      this._events = this._events.filter(function (event) {
        if (event.tag !== eventTag || event.listener != listener) {
          return true;
        }

        if (found) {
          return true;
        }

        found = true;
        stopped.push(event);
        return false;
      });
      stopped.forEach(function (event) {
        _this20._stopEvent(event);
      });
      return this;
    }
  }, {
    key: "removeAllListeners",
    value: function removeAllListeners(eventName) {
      var _this21 = this;

      var stopped = [];

      if (eventName == null) {
        stopped = this._events;
        this._events = [];
      } else {
        var eventTag = getEventTag(eventName);
        this._events = this._events.filter(function (event) {
          if (event.tag !== eventTag) {
            return true;
          }

          stopped.push(event);
          return false;
        });
      }

      stopped.forEach(function (event) {
        _this21._stopEvent(event);
      });
      return this;
    }
  }], [{
    key: "getFormatter",
    value: function getFormatter() {
      if (defaultFormatter == null) {
        defaultFormatter = new _formatter__WEBPACK_IMPORTED_MODULE_13__.Formatter();
      }

      return defaultFormatter;
    } // @TODO: Remove this and just use getNetwork

  }, {
    key: "getNetwork",
    value: function getNetwork(network) {
      return (0,_ethersproject_networks__WEBPACK_IMPORTED_MODULE_14__.getNetwork)(network == null ? "homestead" : network);
    }
  }]);

  return BaseProvider;
}(_ethersproject_abstract_provider__WEBPACK_IMPORTED_MODULE_4__.Provider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/cloudflare-provider.js":
/*!******************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/cloudflare-provider.js ***!
  \******************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CloudflareProvider": function() { return /* binding */ CloudflareProvider; }
/* harmony export */ });
/* harmony import */ var _url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./url-json-rpc-provider */ "./node_modules/@ethersproject/providers/lib.esm/url-json-rpc-provider.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};




var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
var CloudflareProvider = /*#__PURE__*/function (_UrlJsonRpcProvider) {
  _inherits(CloudflareProvider, _UrlJsonRpcProvider);

  var _super2 = _createSuper(CloudflareProvider);

  function CloudflareProvider() {
    _classCallCheck(this, CloudflareProvider);

    return _super2.apply(this, arguments);
  }

  _createClass(CloudflareProvider, [{
    key: "perform",
    value: function perform(method, params) {
      var _this = this;

      var _super = Object.create(null, {
        perform: {
          get: function get() {
            return _get(_getPrototypeOf(CloudflareProvider.prototype), "perform", _this);
          }
        }
      });

      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var block;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(method === "getBlockNumber")) {
                  _context.next = 5;
                  break;
                }

                _context.next = 3;
                return _super.perform.call(this, "getBlock", {
                  blockTag: "latest"
                });

              case 3:
                block = _context.sent;
                return _context.abrupt("return", block.number);

              case 5:
                return _context.abrupt("return", _super.perform.call(this, method, params));

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
    }
  }], [{
    key: "getApiKey",
    value: function getApiKey(apiKey) {
      if (apiKey != null) {
        logger.throwArgumentError("apiKey not supported for cloudflare", "apiKey", apiKey);
      }

      return null;
    }
  }, {
    key: "getUrl",
    value: function getUrl(network, apiKey) {
      var host = null;

      switch (network.name) {
        case "homestead":
          host = "https://cloudflare-eth.com/";
          break;

        default:
          logger.throwArgumentError("unsupported network", "network", arguments[0]);
      }

      return host;
    }
  }]);

  return CloudflareProvider;
}(_url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_2__.UrlJsonRpcProvider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/etherscan-provider.js":
/*!*****************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/etherscan-provider.js ***!
  \*****************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "EtherscanProvider": function() { return /* binding */ EtherscanProvider; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_transactions__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/transactions */ "./node_modules/@ethersproject/transactions/lib.esm/index.js");
/* harmony import */ var _ethersproject_web__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @ethersproject/web */ "./node_modules/@ethersproject/web/lib.esm/index.js");
/* harmony import */ var _formatter__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./formatter */ "./node_modules/@ethersproject/providers/lib.esm/formatter.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");
/* harmony import */ var _base_provider__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./base-provider */ "./node_modules/@ethersproject/providers/lib.esm/base-provider.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};








var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
 // The transaction has already been sanitized by the calls in Provider

function getTransactionPostData(transaction) {
  var result = {};

  for (var key in transaction) {
    if (transaction[key] == null) {
      continue;
    }

    var value = transaction[key];

    if (key === "type" && value === 0) {
      continue;
    } // Quantity-types require no leading zero, unless 0


    if ({
      type: true,
      gasLimit: true,
      gasPrice: true,
      maxFeePerGs: true,
      maxPriorityFeePerGas: true,
      nonce: true,
      value: true
    }[key]) {
      value = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexValue)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexlify)(value));
    } else if (key === "accessList") {
      value = "[" + (0,_ethersproject_transactions__WEBPACK_IMPORTED_MODULE_3__.accessListify)(value).map(function (set) {
        return "{address:\"".concat(set.address, "\",storageKeys:[\"").concat(set.storageKeys.join('","'), "\"]}");
      }).join(",") + "]";
    } else {
      value = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexlify)(value);
    }

    result[key] = value;
  }

  return result;
}

function getResult(result) {
  // getLogs, getHistory have weird success responses
  if (result.status == 0 && (result.message === "No records found" || result.message === "No transactions found")) {
    return result.result;
  }

  if (result.status != 1 || result.message != "OK") {
    var error = new Error("invalid response");
    error.result = JSON.stringify(result);

    if ((result.result || "").toLowerCase().indexOf("rate limit") >= 0) {
      error.throttleRetry = true;
    }

    throw error;
  }

  return result.result;
}

function getJsonResult(result) {
  // This response indicates we are being throttled
  if (result && result.status == 0 && result.message == "NOTOK" && (result.result || "").toLowerCase().indexOf("rate limit") >= 0) {
    var error = new Error("throttled response");
    error.result = JSON.stringify(result);
    error.throttleRetry = true;
    throw error;
  }

  if (result.jsonrpc != "2.0") {
    // @TODO: not any
    var _error = new Error("invalid response");

    _error.result = JSON.stringify(result);
    throw _error;
  }

  if (result.error) {
    // @TODO: not any
    var _error2 = new Error(result.error.message || "unknown error");

    if (result.error.code) {
      _error2.code = result.error.code;
    }

    if (result.error.data) {
      _error2.data = result.error.data;
    }

    throw _error2;
  }

  return result.result;
} // The blockTag was normalized as a string by the Provider pre-perform operations


function checkLogTag(blockTag) {
  if (blockTag === "pending") {
    throw new Error("pending not supported");
  }

  if (blockTag === "latest") {
    return blockTag;
  }

  return parseInt(blockTag.substring(2), 16);
}

var defaultApiKey = "9D13ZE7XSBTJ94N9BNJ2MA33VMAY2YPIRB";

function checkError(method, error, transaction) {
  // Undo the "convenience" some nodes are attempting to prevent backwards
  // incompatibility; maybe for v6 consider forwarding reverts as errors
  if (method === "call" && error.code === _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.SERVER_ERROR) {
    var e = error.error; // Etherscan keeps changing their string

    if (e && (e.message.match(/reverted/i) || e.message.match(/VM execution error/i))) {
      // Etherscan prefixes the data like "Reverted 0x1234"
      var data = e.data;

      if (data) {
        data = "0x" + data.replace(/^.*0x/i, "");
      }

      if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.isHexString)(data)) {
        return data;
      }

      logger.throwError("missing revert data in call exception", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.CALL_EXCEPTION, {
        error: error,
        data: "0x"
      });
    }
  } // Get the message from any nested error structure


  var message = error.message;

  if (error.code === _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.SERVER_ERROR) {
    if (error.error && typeof error.error.message === "string") {
      message = error.error.message;
    } else if (typeof error.body === "string") {
      message = error.body;
    } else if (typeof error.responseText === "string") {
      message = error.responseText;
    }
  }

  message = (message || "").toLowerCase(); // "Insufficient funds. The account you tried to send transaction from does not have enough funds. Required 21464000000000 and got: 0"

  if (message.match(/insufficient funds/)) {
    logger.throwError("insufficient funds for intrinsic transaction cost", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INSUFFICIENT_FUNDS, {
      error: error,
      method: method,
      transaction: transaction
    });
  } // "Transaction with the same hash was already imported."


  if (message.match(/same hash was already imported|transaction nonce is too low|nonce too low/)) {
    logger.throwError("nonce has already been used", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.NONCE_EXPIRED, {
      error: error,
      method: method,
      transaction: transaction
    });
  } // "Transaction gas price is too low. There is another transaction with same nonce in the queue. Try increasing the gas price or incrementing the nonce."


  if (message.match(/another transaction with same nonce/)) {
    logger.throwError("replacement fee too low", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.REPLACEMENT_UNDERPRICED, {
      error: error,
      method: method,
      transaction: transaction
    });
  }

  if (message.match(/execution failed due to an exception|execution reverted/)) {
    logger.throwError("cannot estimate gas; transaction may fail or may require manual gas limit", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNPREDICTABLE_GAS_LIMIT, {
      error: error,
      method: method,
      transaction: transaction
    });
  }

  throw error;
}

var EtherscanProvider = /*#__PURE__*/function (_BaseProvider) {
  _inherits(EtherscanProvider, _BaseProvider);

  var _super2 = _createSuper(EtherscanProvider);

  function EtherscanProvider(network, apiKey) {
    var _this;

    _classCallCheck(this, EtherscanProvider);

    logger.checkNew(this instanceof EtherscanProvider ? this.constructor : void 0, EtherscanProvider);
    _this = _super2.call(this, network);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_4__.defineReadOnly)(_assertThisInitialized(_this), "baseUrl", _this.getBaseUrl());
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_4__.defineReadOnly)(_assertThisInitialized(_this), "apiKey", apiKey || defaultApiKey);
    return _this;
  }

  _createClass(EtherscanProvider, [{
    key: "getBaseUrl",
    value: function getBaseUrl() {
      switch (this.network ? this.network.name : "invalid") {
        case "homestead":
          return "https:/\/api.etherscan.io";

        case "ropsten":
          return "https:/\/api-ropsten.etherscan.io";

        case "rinkeby":
          return "https:/\/api-rinkeby.etherscan.io";

        case "kovan":
          return "https:/\/api-kovan.etherscan.io";

        case "goerli":
          return "https:/\/api-goerli.etherscan.io";

        default:
      }

      return logger.throwArgumentError("unsupported network", "network", name);
    }
  }, {
    key: "getUrl",
    value: function getUrl(module, params) {
      var query = Object.keys(params).reduce(function (accum, key) {
        var value = params[key];

        if (value != null) {
          accum += "&".concat(key, "=").concat(value);
        }

        return accum;
      }, "");
      var apiKey = this.apiKey ? "&apikey=".concat(this.apiKey) : "";
      return "".concat(this.baseUrl, "/api?module=").concat(module).concat(query).concat(apiKey);
    }
  }, {
    key: "getPostUrl",
    value: function getPostUrl() {
      return "".concat(this.baseUrl, "/api");
    }
  }, {
    key: "getPostData",
    value: function getPostData(module, params) {
      params.module = module;
      params.apikey = this.apiKey;
      return params;
    }
  }, {
    key: "fetch",
    value: function fetch(module, params, post) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _this2 = this;

        var url, payload, procFunc, connection, payloadStr, result;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                url = post ? this.getPostUrl() : this.getUrl(module, params);
                payload = post ? this.getPostData(module, params) : null;
                procFunc = module === "proxy" ? getJsonResult : getResult;
                this.emit("debug", {
                  action: "request",
                  request: url,
                  provider: this
                });
                connection = {
                  url: url,
                  throttleSlotInterval: 1000,
                  throttleCallback: function throttleCallback(attempt, url) {
                    if (_this2.isCommunityResource()) {
                      (0,_formatter__WEBPACK_IMPORTED_MODULE_5__.showThrottleMessage)();
                    }

                    return Promise.resolve(true);
                  }
                };
                payloadStr = null;

                if (payload) {
                  connection.headers = {
                    "content-type": "application/x-www-form-urlencoded; charset=UTF-8"
                  };
                  payloadStr = Object.keys(payload).map(function (key) {
                    return "".concat(key, "=").concat(payload[key]);
                  }).join("&");
                }

                _context.next = 9;
                return (0,_ethersproject_web__WEBPACK_IMPORTED_MODULE_6__.fetchJson)(connection, payloadStr, procFunc || getJsonResult);

              case 9:
                result = _context.sent;
                this.emit("debug", {
                  action: "response",
                  request: url,
                  response: (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_4__.deepCopy)(result),
                  provider: this
                });
                return _context.abrupt("return", result);

              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
    }
  }, {
    key: "detectNetwork",
    value: function detectNetwork() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", this.network);

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));
    }
  }, {
    key: "perform",
    value: function perform(method, params) {
      var _this3 = this;

      var _super = Object.create(null, {
        perform: {
          get: function get() {
            return _get(_getPrototypeOf(EtherscanProvider.prototype), "perform", _this3);
          }
        }
      });

      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var postData, _postData, args, topic0, logs, blocks, i, log, block;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.t0 = method;
                _context3.next = _context3.t0 === "getBlockNumber" ? 3 : _context3.t0 === "getGasPrice" ? 4 : _context3.t0 === "getBalance" ? 5 : _context3.t0 === "getTransactionCount" ? 6 : _context3.t0 === "getCode" ? 7 : _context3.t0 === "getStorageAt" ? 8 : _context3.t0 === "sendTransaction" ? 9 : _context3.t0 === "getBlock" ? 10 : _context3.t0 === "getTransaction" ? 13 : _context3.t0 === "getTransactionReceipt" ? 14 : _context3.t0 === "call" ? 15 : _context3.t0 === "estimateGas" ? 29 : _context3.t0 === "getLogs" ? 41 : _context3.t0 === "getEtherPrice" ? 65 : 72;
                break;

              case 3:
                return _context3.abrupt("return", this.fetch("proxy", {
                  action: "eth_blockNumber"
                }));

              case 4:
                return _context3.abrupt("return", this.fetch("proxy", {
                  action: "eth_gasPrice"
                }));

              case 5:
                return _context3.abrupt("return", this.fetch("account", {
                  action: "balance",
                  address: params.address,
                  tag: params.blockTag
                }));

              case 6:
                return _context3.abrupt("return", this.fetch("proxy", {
                  action: "eth_getTransactionCount",
                  address: params.address,
                  tag: params.blockTag
                }));

              case 7:
                return _context3.abrupt("return", this.fetch("proxy", {
                  action: "eth_getCode",
                  address: params.address,
                  tag: params.blockTag
                }));

              case 8:
                return _context3.abrupt("return", this.fetch("proxy", {
                  action: "eth_getStorageAt",
                  address: params.address,
                  position: params.position,
                  tag: params.blockTag
                }));

              case 9:
                return _context3.abrupt("return", this.fetch("proxy", {
                  action: "eth_sendRawTransaction",
                  hex: params.signedTransaction
                }, true)["catch"](function (error) {
                  return checkError("sendTransaction", error, params.signedTransaction);
                }));

              case 10:
                if (!params.blockTag) {
                  _context3.next = 12;
                  break;
                }

                return _context3.abrupt("return", this.fetch("proxy", {
                  action: "eth_getBlockByNumber",
                  tag: params.blockTag,
                  "boolean": params.includeTransactions ? "true" : "false"
                }));

              case 12:
                throw new Error("getBlock by blockHash not implemented");

              case 13:
                return _context3.abrupt("return", this.fetch("proxy", {
                  action: "eth_getTransactionByHash",
                  txhash: params.transactionHash
                }));

              case 14:
                return _context3.abrupt("return", this.fetch("proxy", {
                  action: "eth_getTransactionReceipt",
                  txhash: params.transactionHash
                }));

              case 15:
                if (!(params.blockTag !== "latest")) {
                  _context3.next = 17;
                  break;
                }

                throw new Error("EtherscanProvider does not support blockTag for call");

              case 17:
                postData = getTransactionPostData(params.transaction);
                postData.module = "proxy";
                postData.action = "eth_call";
                _context3.prev = 20;
                _context3.next = 23;
                return this.fetch("proxy", postData, true);

              case 23:
                return _context3.abrupt("return", _context3.sent);

              case 26:
                _context3.prev = 26;
                _context3.t1 = _context3["catch"](20);
                return _context3.abrupt("return", checkError("call", _context3.t1, params.transaction));

              case 29:
                _postData = getTransactionPostData(params.transaction);
                _postData.module = "proxy";
                _postData.action = "eth_estimateGas";
                _context3.prev = 32;
                _context3.next = 35;
                return this.fetch("proxy", _postData, true);

              case 35:
                return _context3.abrupt("return", _context3.sent);

              case 38:
                _context3.prev = 38;
                _context3.t2 = _context3["catch"](32);
                return _context3.abrupt("return", checkError("estimateGas", _context3.t2, params.transaction));

              case 41:
                args = {
                  action: "getLogs"
                };

                if (params.filter.fromBlock) {
                  args.fromBlock = checkLogTag(params.filter.fromBlock);
                }

                if (params.filter.toBlock) {
                  args.toBlock = checkLogTag(params.filter.toBlock);
                }

                if (params.filter.address) {
                  args.address = params.filter.address;
                } // @TODO: We can handle slightly more complicated logs using the logs API


                if (params.filter.topics && params.filter.topics.length > 0) {
                  if (params.filter.topics.length > 1) {
                    logger.throwError("unsupported topic count", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
                      topics: params.filter.topics
                    });
                  }

                  if (params.filter.topics.length === 1) {
                    topic0 = params.filter.topics[0];

                    if (typeof topic0 !== "string" || topic0.length !== 66) {
                      logger.throwError("unsupported topic format", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
                        topic0: topic0
                      });
                    }

                    args.topic0 = topic0;
                  }
                }

                _context3.next = 48;
                return this.fetch("logs", args);

              case 48:
                logs = _context3.sent;
                // Cache txHash => blockHash
                blocks = {}; // Add any missing blockHash to the logs

                i = 0;

              case 51:
                if (!(i < logs.length)) {
                  _context3.next = 64;
                  break;
                }

                log = logs[i];

                if (!(log.blockHash != null)) {
                  _context3.next = 55;
                  break;
                }

                return _context3.abrupt("continue", 61);

              case 55:
                if (!(blocks[log.blockNumber] == null)) {
                  _context3.next = 60;
                  break;
                }

                _context3.next = 58;
                return this.getBlock(log.blockNumber);

              case 58:
                block = _context3.sent;

                if (block) {
                  blocks[log.blockNumber] = block.hash;
                }

              case 60:
                log.blockHash = blocks[log.blockNumber];

              case 61:
                i++;
                _context3.next = 51;
                break;

              case 64:
                return _context3.abrupt("return", logs);

              case 65:
                if (!(this.network.name !== "homestead")) {
                  _context3.next = 67;
                  break;
                }

                return _context3.abrupt("return", 0.0);

              case 67:
                _context3.t3 = parseFloat;
                _context3.next = 70;
                return this.fetch("stats", {
                  action: "ethprice"
                });

              case 70:
                _context3.t4 = _context3.sent.ethusd;
                return _context3.abrupt("return", (0, _context3.t3)(_context3.t4));

              case 72:
                return _context3.abrupt("break", 73);

              case 73:
                return _context3.abrupt("return", _super.perform.call(this, method, params));

              case 74:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[20, 26], [32, 38]]);
      }));
    } // Note: The `page` page parameter only allows pagination within the
    //       10,000 window available without a page and offset parameter
    //       Error: Result window is too large, PageNo x Offset size must
    //              be less than or equal to 10000

  }, {
    key: "getHistory",
    value: function getHistory(addressOrName, startBlock, endBlock) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var _this4 = this;

        var params, result;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.resolveName(addressOrName);

              case 2:
                _context4.t0 = _context4.sent;
                _context4.t1 = startBlock == null ? 0 : startBlock;
                _context4.t2 = endBlock == null ? 99999999 : endBlock;
                params = {
                  action: "txlist",
                  address: _context4.t0,
                  startblock: _context4.t1,
                  endblock: _context4.t2,
                  sort: "asc"
                };
                _context4.next = 8;
                return this.fetch("account", params);

              case 8:
                result = _context4.sent;
                return _context4.abrupt("return", result.map(function (tx) {
                  ["contractAddress", "to"].forEach(function (key) {
                    if (tx[key] == "") {
                      delete tx[key];
                    }
                  });

                  if (tx.creates == null && tx.contractAddress != null) {
                    tx.creates = tx.contractAddress;
                  }

                  var item = _this4.formatter.transactionResponse(tx);

                  if (tx.timeStamp) {
                    item.timestamp = parseInt(tx.timeStamp);
                  }

                  return item;
                }));

              case 10:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));
    }
  }, {
    key: "isCommunityResource",
    value: function isCommunityResource() {
      return this.apiKey === defaultApiKey;
    }
  }]);

  return EtherscanProvider;
}(_base_provider__WEBPACK_IMPORTED_MODULE_7__.BaseProvider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/fallback-provider.js":
/*!****************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/fallback-provider.js ***!
  \****************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "FallbackProvider": function() { return /* binding */ FallbackProvider; }
/* harmony export */ });
/* harmony import */ var _ethersproject_abstract_provider__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @ethersproject/abstract-provider */ "./node_modules/@ethersproject/abstract-provider/lib.esm/index.js");
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_random__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @ethersproject/random */ "./node_modules/@ethersproject/random/lib.esm/shuffle.js");
/* harmony import */ var _ethersproject_web__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/web */ "./node_modules/@ethersproject/web/lib.esm/index.js");
/* harmony import */ var _base_provider__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./base-provider */ "./node_modules/@ethersproject/providers/lib.esm/base-provider.js");
/* harmony import */ var _formatter__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./formatter */ "./node_modules/@ethersproject/providers/lib.esm/formatter.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};











var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);

function now() {
  return new Date().getTime();
} // Returns to network as long as all agree, or null if any is null.
// Throws an error if any two networks do not match.


function checkNetworks(networks) {
  var result = null;

  for (var i = 0; i < networks.length; i++) {
    var network = networks[i]; // Null! We do not know our network; bail.

    if (network == null) {
      return null;
    }

    if (result) {
      // Make sure the network matches the previous networks
      if (!(result.name === network.name && result.chainId === network.chainId && (result.ensAddress === network.ensAddress || result.ensAddress == null && network.ensAddress == null))) {
        logger.throwArgumentError("provider mismatch", "networks", networks);
      }
    } else {
      result = network;
    }
  }

  return result;
}

function median(values, maxDelta) {
  values = values.slice().sort();
  var middle = Math.floor(values.length / 2); // Odd length; take the middle

  if (values.length % 2) {
    return values[middle];
  } // Even length; take the average of the two middle


  var a = values[middle - 1],
      b = values[middle];

  if (maxDelta != null && Math.abs(a - b) > maxDelta) {
    return null;
  }

  return (a + b) / 2;
}

function serialize(value) {
  if (value === null) {
    return "null";
  } else if (typeof value === "number" || typeof value === "boolean") {
    return JSON.stringify(value);
  } else if (typeof value === "string") {
    return value;
  } else if (_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_2__.BigNumber.isBigNumber(value)) {
    return value.toString();
  } else if (Array.isArray(value)) {
    return JSON.stringify(value.map(function (i) {
      return serialize(i);
    }));
  } else if (_typeof(value) === "object") {
    var keys = Object.keys(value);
    keys.sort();
    return "{" + keys.map(function (key) {
      var v = value[key];

      if (typeof v === "function") {
        v = "[function]";
      } else {
        v = serialize(v);
      }

      return JSON.stringify(key) + ":" + v;
    }).join(",") + "}";
  }

  throw new Error("unknown value type: " + _typeof(value));
} // Next request ID to use for emitting debug info


var nextRid = 1;
;

function stall(duration) {
  var cancel = null;
  var timer = null;
  var promise = new Promise(function (resolve) {
    cancel = function cancel() {
      if (timer) {
        clearTimeout(timer);
        timer = null;
      }

      resolve();
    };

    timer = setTimeout(cancel, duration);
  });

  var wait = function wait(func) {
    promise = promise.then(func);
    return promise;
  };

  function getPromise() {
    return promise;
  }

  return {
    cancel: cancel,
    getPromise: getPromise,
    wait: wait
  };
}

var ForwardErrors = [_ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.CALL_EXCEPTION, _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INSUFFICIENT_FUNDS, _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.NONCE_EXPIRED, _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.REPLACEMENT_UNDERPRICED, _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNPREDICTABLE_GAS_LIMIT];
var ForwardProperties = ["address", "args", "errorArgs", "errorSignature", "method", "transaction"];
;

function exposeDebugConfig(config, now) {
  var result = {
    weight: config.weight
  };
  Object.defineProperty(result, "provider", {
    get: function get() {
      return config.provider;
    }
  });

  if (config.start) {
    result.start = config.start;
  }

  if (now) {
    result.duration = now - config.start;
  }

  if (config.done) {
    if (config.error) {
      result.error = config.error;
    } else {
      result.result = config.result || null;
    }
  }

  return result;
}

function normalizedTally(normalize, quorum) {
  return function (configs) {
    // Count the votes for each result
    var tally = {};
    configs.forEach(function (c) {
      var value = normalize(c.result);

      if (!tally[value]) {
        tally[value] = {
          count: 0,
          result: c.result
        };
      }

      tally[value].count++;
    }); // Check for a quorum on any given result

    var keys = Object.keys(tally);

    for (var i = 0; i < keys.length; i++) {
      var check = tally[keys[i]];

      if (check.count >= quorum) {
        return check.result;
      }
    } // No quroum


    return undefined;
  };
}

function getProcessFunc(provider, method, params) {
  var normalize = serialize;

  switch (method) {
    case "getBlockNumber":
      // Return the median value, unless there is (median + 1) is also
      // present, in which case that is probably true and the median
      // is going to be stale soon. In the event of a malicious node,
      // the lie will be true soon enough.
      return function (configs) {
        var values = configs.map(function (c) {
          return c.result;
        }); // Get the median block number

        var blockNumber = median(configs.map(function (c) {
          return c.result;
        }), 2);

        if (blockNumber == null) {
          return undefined;
        }

        blockNumber = Math.ceil(blockNumber); // If the next block height is present, its prolly safe to use

        if (values.indexOf(blockNumber + 1) >= 0) {
          blockNumber++;
        } // Don't ever roll back the blockNumber


        if (blockNumber >= provider._highestBlockNumber) {
          provider._highestBlockNumber = blockNumber;
        }

        return provider._highestBlockNumber;
      };

    case "getGasPrice":
      // Return the middle (round index up) value, similar to median
      // but do not average even entries and choose the higher.
      // Malicious actors must compromise 50% of the nodes to lie.
      return function (configs) {
        var values = configs.map(function (c) {
          return c.result;
        });
        values.sort();
        return values[Math.floor(values.length / 2)];
      };

    case "getEtherPrice":
      // Returns the median price. Malicious actors must compromise at
      // least 50% of the nodes to lie (in a meaningful way).
      return function (configs) {
        return median(configs.map(function (c) {
          return c.result;
        }));
      };
    // No additional normalizing required; serialize is enough

    case "getBalance":
    case "getTransactionCount":
    case "getCode":
    case "getStorageAt":
    case "call":
    case "estimateGas":
    case "getLogs":
      break;
    // We drop the confirmations from transactions as it is approximate

    case "getTransaction":
    case "getTransactionReceipt":
      normalize = function normalize(tx) {
        if (tx == null) {
          return null;
        }

        tx = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(tx);
        tx.confirmations = -1;
        return serialize(tx);
      };

      break;
    // We drop the confirmations from transactions as it is approximate

    case "getBlock":
      // We drop the confirmations from transactions as it is approximate
      if (params.includeTransactions) {
        normalize = function normalize(block) {
          if (block == null) {
            return null;
          }

          block = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(block);
          block.transactions = block.transactions.map(function (tx) {
            tx = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(tx);
            tx.confirmations = -1;
            return tx;
          });
          return serialize(block);
        };
      } else {
        normalize = function normalize(block) {
          if (block == null) {
            return null;
          }

          return serialize(block);
        };
      }

      break;

    default:
      throw new Error("unknown method: " + method);
  } // Return the result if and only if the expected quorum is
  // satisfied and agreed upon for the final result.


  return normalizedTally(normalize, provider.quorum);
} // If we are doing a blockTag query, we need to make sure the backend is
// caught up to the FallbackProvider, before sending a request to it.


function waitForSync(config, blockNumber) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var provider;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            provider = config.provider;

            if (!(provider.blockNumber != null && provider.blockNumber >= blockNumber || blockNumber === -1)) {
              _context.next = 3;
              break;
            }

            return _context.abrupt("return", provider);

          case 3:
            return _context.abrupt("return", (0,_ethersproject_web__WEBPACK_IMPORTED_MODULE_4__.poll)(function () {
              return new Promise(function (resolve, reject) {
                setTimeout(function () {
                  // We are synced
                  if (provider.blockNumber >= blockNumber) {
                    return resolve(provider);
                  } // We're done; just quit


                  if (config.cancelled) {
                    return resolve(null);
                  } // Try again, next block


                  return resolve(undefined);
                }, 0);
              });
            }, {
              oncePoll: provider
            }));

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
}

function getRunner(config, currentBlockNumber, method, params) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var provider, filter;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            provider = config.provider;
            _context2.t0 = method;
            _context2.next = _context2.t0 === "getBlockNumber" ? 4 : _context2.t0 === "getGasPrice" ? 4 : _context2.t0 === "getEtherPrice" ? 5 : _context2.t0 === "getBalance" ? 8 : _context2.t0 === "getTransactionCount" ? 8 : _context2.t0 === "getCode" ? 8 : _context2.t0 === "getStorageAt" ? 13 : _context2.t0 === "getBlock" ? 18 : _context2.t0 === "call" ? 23 : _context2.t0 === "estimateGas" ? 23 : _context2.t0 === "getTransaction" ? 28 : _context2.t0 === "getTransactionReceipt" ? 28 : _context2.t0 === "getLogs" ? 29 : 35;
            break;

          case 4:
            return _context2.abrupt("return", provider[method]());

          case 5:
            if (!provider.getEtherPrice) {
              _context2.next = 7;
              break;
            }

            return _context2.abrupt("return", provider.getEtherPrice());

          case 7:
            return _context2.abrupt("break", 35);

          case 8:
            if (!(params.blockTag && (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(params.blockTag))) {
              _context2.next = 12;
              break;
            }

            _context2.next = 11;
            return waitForSync(config, currentBlockNumber);

          case 11:
            provider = _context2.sent;

          case 12:
            return _context2.abrupt("return", provider[method](params.address, params.blockTag || "latest"));

          case 13:
            if (!(params.blockTag && (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(params.blockTag))) {
              _context2.next = 17;
              break;
            }

            _context2.next = 16;
            return waitForSync(config, currentBlockNumber);

          case 16:
            provider = _context2.sent;

          case 17:
            return _context2.abrupt("return", provider.getStorageAt(params.address, params.position, params.blockTag || "latest"));

          case 18:
            if (!(params.blockTag && (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(params.blockTag))) {
              _context2.next = 22;
              break;
            }

            _context2.next = 21;
            return waitForSync(config, currentBlockNumber);

          case 21:
            provider = _context2.sent;

          case 22:
            return _context2.abrupt("return", provider[params.includeTransactions ? "getBlockWithTransactions" : "getBlock"](params.blockTag || params.blockHash));

          case 23:
            if (!(params.blockTag && (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(params.blockTag))) {
              _context2.next = 27;
              break;
            }

            _context2.next = 26;
            return waitForSync(config, currentBlockNumber);

          case 26:
            provider = _context2.sent;

          case 27:
            return _context2.abrupt("return", provider[method](params.transaction));

          case 28:
            return _context2.abrupt("return", provider[method](params.transactionHash));

          case 29:
            filter = params.filter;

            if (!(filter.fromBlock && (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(filter.fromBlock) || filter.toBlock && (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(filter.toBlock))) {
              _context2.next = 34;
              break;
            }

            _context2.next = 33;
            return waitForSync(config, currentBlockNumber);

          case 33:
            provider = _context2.sent;

          case 34:
            return _context2.abrupt("return", provider.getLogs(filter));

          case 35:
            return _context2.abrupt("return", logger.throwError("unknown method error", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNKNOWN_ERROR, {
              method: method,
              params: params
            }));

          case 36:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
}

var FallbackProvider = /*#__PURE__*/function (_BaseProvider) {
  _inherits(FallbackProvider, _BaseProvider);

  var _super = _createSuper(FallbackProvider);

  function FallbackProvider(providers, quorum) {
    var _this;

    _classCallCheck(this, FallbackProvider);

    logger.checkNew(this instanceof FallbackProvider ? this.constructor : void 0, FallbackProvider);

    if (providers.length === 0) {
      logger.throwArgumentError("missing providers", "providers", providers);
    }

    var providerConfigs = providers.map(function (configOrProvider, index) {
      if (_ethersproject_abstract_provider__WEBPACK_IMPORTED_MODULE_6__.Provider.isProvider(configOrProvider)) {
        var stallTimeout = (0,_formatter__WEBPACK_IMPORTED_MODULE_7__.isCommunityResource)(configOrProvider) ? 2000 : 750;
        var priority = 1;
        return Object.freeze({
          provider: configOrProvider,
          weight: 1,
          stallTimeout: stallTimeout,
          priority: priority
        });
      }

      var config = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(configOrProvider);

      if (config.priority == null) {
        config.priority = 1;
      }

      if (config.stallTimeout == null) {
        config.stallTimeout = (0,_formatter__WEBPACK_IMPORTED_MODULE_7__.isCommunityResource)(configOrProvider) ? 2000 : 750;
      }

      if (config.weight == null) {
        config.weight = 1;
      }

      var weight = config.weight;

      if (weight % 1 || weight > 512 || weight < 1) {
        logger.throwArgumentError("invalid weight; must be integer in [1, 512]", "providers[".concat(index, "].weight"), weight);
      }

      return Object.freeze(config);
    });
    var total = providerConfigs.reduce(function (accum, c) {
      return accum + c.weight;
    }, 0);

    if (quorum == null) {
      quorum = total / 2;
    } else if (quorum > total) {
      logger.throwArgumentError("quorum will always fail; larger than total weight", "quorum", quorum);
    } // Are all providers' networks are known


    var networkOrReady = checkNetworks(providerConfigs.map(function (c) {
      return c.provider.network;
    })); // Not all networks are known; we must stall

    if (networkOrReady == null) {
      networkOrReady = new Promise(function (resolve, reject) {
        setTimeout(function () {
          _this.detectNetwork().then(resolve, reject);
        }, 0);
      });
    }

    _this = _super.call(this, networkOrReady); // Preserve a copy, so we do not get mutated

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this), "providerConfigs", Object.freeze(providerConfigs));
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this), "quorum", quorum);
    _this._highestBlockNumber = -1;
    return _this;
  }

  _createClass(FallbackProvider, [{
    key: "detectNetwork",
    value: function detectNetwork() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var networks;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return Promise.all(this.providerConfigs.map(function (c) {
                  return c.provider.getNetwork();
                }));

              case 2:
                networks = _context3.sent;
                return _context3.abrupt("return", checkNetworks(networks));

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));
    }
  }, {
    key: "perform",
    value: function perform(method, params) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var _this2 = this;

        var results, _i, result, processFunc, configs, currentBlockNumber, i, first, _loop, _ret;

        return regeneratorRuntime.wrap(function _callee4$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (!(method === "sendTransaction")) {
                  _context5.next = 13;
                  break;
                }

                _context5.next = 3;
                return Promise.all(this.providerConfigs.map(function (c) {
                  return c.provider.sendTransaction(params.signedTransaction).then(function (result) {
                    return result.hash;
                  }, function (error) {
                    return error;
                  });
                }));

              case 3:
                results = _context5.sent;
                _i = 0;

              case 5:
                if (!(_i < results.length)) {
                  _context5.next = 12;
                  break;
                }

                result = results[_i];

                if (!(typeof result === "string")) {
                  _context5.next = 9;
                  break;
                }

                return _context5.abrupt("return", result);

              case 9:
                _i++;
                _context5.next = 5;
                break;

              case 12:
                throw results[0];

              case 13:
                if (!(this._highestBlockNumber === -1 && method !== "getBlockNumber")) {
                  _context5.next = 16;
                  break;
                }

                _context5.next = 16;
                return this.getBlockNumber();

              case 16:
                processFunc = getProcessFunc(this, method, params); // Shuffle the providers and then sort them by their priority; we
                // shallowCopy them since we will store the result in them too

                configs = (0,_ethersproject_random__WEBPACK_IMPORTED_MODULE_8__.shuffled)(this.providerConfigs.map(_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy));
                configs.sort(function (a, b) {
                  return a.priority - b.priority;
                });
                currentBlockNumber = this._highestBlockNumber;
                i = 0;
                first = true;
                _loop = /*#__PURE__*/regeneratorRuntime.mark(function _loop() {
                  var t0, inflightWeight, _loop2, waiting, results, _result, errors;

                  return regeneratorRuntime.wrap(function _loop$(_context4) {
                    while (1) {
                      switch (_context4.prev = _context4.next) {
                        case 0:
                          t0 = now(); // Compute the inflight weight (exclude anything past)

                          inflightWeight = configs.filter(function (c) {
                            return c.runner && t0 - c.start < c.stallTimeout;
                          }).reduce(function (accum, c) {
                            return accum + c.weight;
                          }, 0); // Start running enough to meet quorum

                          _loop2 = function _loop2() {
                            var config = configs[i++];
                            var rid = nextRid++;
                            config.start = now();
                            config.staller = stall(config.stallTimeout);
                            config.staller.wait(function () {
                              config.staller = null;
                            });
                            config.runner = getRunner(config, currentBlockNumber, method, params).then(function (result) {
                              config.done = true;
                              config.result = result;

                              if (_this2.listenerCount("debug")) {
                                _this2.emit("debug", {
                                  action: "request",
                                  rid: rid,
                                  backend: exposeDebugConfig(config, now()),
                                  request: {
                                    method: method,
                                    params: (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.deepCopy)(params)
                                  },
                                  provider: _this2
                                });
                              }
                            }, function (error) {
                              config.done = true;
                              config.error = error;

                              if (_this2.listenerCount("debug")) {
                                _this2.emit("debug", {
                                  action: "request",
                                  rid: rid,
                                  backend: exposeDebugConfig(config, now()),
                                  request: {
                                    method: method,
                                    params: (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.deepCopy)(params)
                                  },
                                  provider: _this2
                                });
                              }
                            });

                            if (_this2.listenerCount("debug")) {
                              _this2.emit("debug", {
                                action: "request",
                                rid: rid,
                                backend: exposeDebugConfig(config, null),
                                request: {
                                  method: method,
                                  params: (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.deepCopy)(params)
                                },
                                provider: _this2
                              });
                            }

                            inflightWeight += config.weight;
                          };

                          while (inflightWeight < _this2.quorum && i < configs.length) {
                            _loop2();
                          } // Wait for anything meaningful to finish or stall out


                          waiting = [];
                          configs.forEach(function (c) {
                            if (c.done || !c.runner) {
                              return;
                            }

                            waiting.push(c.runner);

                            if (c.staller) {
                              waiting.push(c.staller.getPromise());
                            }
                          });

                          if (!waiting.length) {
                            _context4.next = 9;
                            break;
                          }

                          _context4.next = 9;
                          return Promise.race(waiting);

                        case 9:
                          // Check the quorum and process the results; the process function
                          // may additionally decide the quorum is not met
                          results = configs.filter(function (c) {
                            return c.done && c.error == null;
                          });

                          if (!(results.length >= _this2.quorum)) {
                            _context4.next = 19;
                            break;
                          }

                          _result = processFunc(results);

                          if (!(_result !== undefined)) {
                            _context4.next = 15;
                            break;
                          }

                          // Shut down any stallers
                          configs.forEach(function (c) {
                            if (c.staller) {
                              c.staller.cancel();
                            }

                            c.cancelled = true;
                          });
                          return _context4.abrupt("return", {
                            v: _result
                          });

                        case 15:
                          if (first) {
                            _context4.next = 18;
                            break;
                          }

                          _context4.next = 18;
                          return stall(100).getPromise();

                        case 18:
                          first = false;

                        case 19:
                          // No result, check for errors that should be forwarded
                          errors = configs.reduce(function (accum, c) {
                            if (!c.done || c.error == null) {
                              return accum;
                            }

                            var code = c.error.code;

                            if (ForwardErrors.indexOf(code) >= 0) {
                              if (!accum[code]) {
                                accum[code] = {
                                  error: c.error,
                                  weight: 0
                                };
                              }

                              accum[code].weight += c.weight;
                            }

                            return accum;
                          }, {});
                          Object.keys(errors).forEach(function (errorCode) {
                            var tally = errors[errorCode];

                            if (tally.weight < _this2.quorum) {
                              return;
                            } // Shut down any stallers


                            configs.forEach(function (c) {
                              if (c.staller) {
                                c.staller.cancel();
                              }

                              c.cancelled = true;
                            });
                            var e = tally.error;
                            var props = {};
                            ForwardProperties.forEach(function (name) {
                              if (e[name] == null) {
                                return;
                              }

                              props[name] = e[name];
                            });
                            logger.throwError(e.reason || e.message, errorCode, props);
                          }); // All configs have run to completion; we will never get more data

                          if (!(configs.filter(function (c) {
                            return !c.done;
                          }).length === 0)) {
                            _context4.next = 23;
                            break;
                          }

                          return _context4.abrupt("return", "break");

                        case 23:
                        case "end":
                          return _context4.stop();
                      }
                    }
                  }, _loop);
                });

              case 23:
                if (false) {}

                return _context5.delegateYield(_loop(), "t0", 25);

              case 25:
                _ret = _context5.t0;

                if (!(_ret === "break")) {
                  _context5.next = 28;
                  break;
                }

                return _context5.abrupt("break", 32);

              case 28:
                if (!(_typeof(_ret) === "object")) {
                  _context5.next = 30;
                  break;
                }

                return _context5.abrupt("return", _ret.v);

              case 30:
                _context5.next = 23;
                break;

              case 32:
                // Shut down any stallers; shouldn't be any
                configs.forEach(function (c) {
                  if (c.staller) {
                    c.staller.cancel();
                  }

                  c.cancelled = true;
                });
                return _context5.abrupt("return", logger.throwError("failed to meet quorum", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.SERVER_ERROR, {
                  method: method,
                  params: params,
                  //results: configs.map((c) => c.result),
                  //errors: configs.map((c) => c.error),
                  results: configs.map(function (c) {
                    return exposeDebugConfig(c);
                  }),
                  provider: this
                }));

              case 34:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee4, this);
      }));
    }
  }]);

  return FallbackProvider;
}(_base_provider__WEBPACK_IMPORTED_MODULE_9__.BaseProvider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/formatter.js":
/*!********************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/formatter.js ***!
  \********************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Formatter": function() { return /* binding */ Formatter; },
/* harmony export */   "isCommunityResourcable": function() { return /* binding */ isCommunityResourcable; },
/* harmony export */   "isCommunityResource": function() { return /* binding */ isCommunityResource; },
/* harmony export */   "showThrottleMessage": function() { return /* binding */ showThrottleMessage; }
/* harmony export */ });
/* harmony import */ var _ethersproject_address__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @ethersproject/address */ "./node_modules/@ethersproject/address/lib.esm/index.js");
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_constants__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @ethersproject/constants */ "./node_modules/@ethersproject/constants/lib.esm/addresses.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_transactions__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/transactions */ "./node_modules/@ethersproject/transactions/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }









var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
var Formatter = /*#__PURE__*/function () {
  function Formatter() {
    _classCallCheck(this, Formatter);

    logger.checkNew(this instanceof Formatter ? this.constructor : void 0, Formatter);
    this.formats = this.getDefaultFormats();
  }

  _createClass(Formatter, [{
    key: "getDefaultFormats",
    value: function getDefaultFormats() {
      var _this = this;

      var formats = {};
      var address = this.address.bind(this);
      var bigNumber = this.bigNumber.bind(this);
      var blockTag = this.blockTag.bind(this);
      var data = this.data.bind(this);
      var hash = this.hash.bind(this);
      var hex = this.hex.bind(this);
      var number = this.number.bind(this);
      var type = this.type.bind(this);

      var strictData = function strictData(v) {
        return _this.data(v, true);
      };

      formats.transaction = {
        hash: hash,
        type: type,
        accessList: Formatter.allowNull(this.accessList.bind(this), null),
        blockHash: Formatter.allowNull(hash, null),
        blockNumber: Formatter.allowNull(number, null),
        transactionIndex: Formatter.allowNull(number, null),
        confirmations: Formatter.allowNull(number, null),
        from: address,
        // either (gasPrice) or (maxPriorityFeePerGas + maxFeePerGas)
        // must be set
        gasPrice: Formatter.allowNull(bigNumber),
        maxPriorityFeePerGas: Formatter.allowNull(bigNumber),
        maxFeePerGas: Formatter.allowNull(bigNumber),
        gasLimit: bigNumber,
        to: Formatter.allowNull(address, null),
        value: bigNumber,
        nonce: number,
        data: data,
        r: Formatter.allowNull(this.uint256),
        s: Formatter.allowNull(this.uint256),
        v: Formatter.allowNull(number),
        creates: Formatter.allowNull(address, null),
        raw: Formatter.allowNull(data)
      };
      formats.transactionRequest = {
        from: Formatter.allowNull(address),
        nonce: Formatter.allowNull(number),
        gasLimit: Formatter.allowNull(bigNumber),
        gasPrice: Formatter.allowNull(bigNumber),
        maxPriorityFeePerGas: Formatter.allowNull(bigNumber),
        maxFeePerGas: Formatter.allowNull(bigNumber),
        to: Formatter.allowNull(address),
        value: Formatter.allowNull(bigNumber),
        data: Formatter.allowNull(strictData),
        type: Formatter.allowNull(number),
        accessList: Formatter.allowNull(this.accessList.bind(this), null)
      };
      formats.receiptLog = {
        transactionIndex: number,
        blockNumber: number,
        transactionHash: hash,
        address: address,
        topics: Formatter.arrayOf(hash),
        data: data,
        logIndex: number,
        blockHash: hash
      };
      formats.receipt = {
        to: Formatter.allowNull(this.address, null),
        from: Formatter.allowNull(this.address, null),
        contractAddress: Formatter.allowNull(address, null),
        transactionIndex: number,
        // should be allowNull(hash), but broken-EIP-658 support is handled in receipt
        root: Formatter.allowNull(hex),
        gasUsed: bigNumber,
        logsBloom: Formatter.allowNull(data),
        blockHash: hash,
        transactionHash: hash,
        logs: Formatter.arrayOf(this.receiptLog.bind(this)),
        blockNumber: number,
        confirmations: Formatter.allowNull(number, null),
        cumulativeGasUsed: bigNumber,
        effectiveGasPrice: Formatter.allowNull(bigNumber),
        status: Formatter.allowNull(number),
        type: type
      };
      formats.block = {
        hash: Formatter.allowNull(hash),
        parentHash: hash,
        number: number,
        timestamp: number,
        nonce: Formatter.allowNull(hex),
        difficulty: this.difficulty.bind(this),
        gasLimit: bigNumber,
        gasUsed: bigNumber,
        miner: Formatter.allowNull(address),
        extraData: data,
        transactions: Formatter.allowNull(Formatter.arrayOf(hash)),
        baseFeePerGas: Formatter.allowNull(bigNumber)
      };
      formats.blockWithTransactions = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.shallowCopy)(formats.block);
      formats.blockWithTransactions.transactions = Formatter.allowNull(Formatter.arrayOf(this.transactionResponse.bind(this)));
      formats.filter = {
        fromBlock: Formatter.allowNull(blockTag, undefined),
        toBlock: Formatter.allowNull(blockTag, undefined),
        blockHash: Formatter.allowNull(hash, undefined),
        address: Formatter.allowNull(address, undefined),
        topics: Formatter.allowNull(this.topics.bind(this), undefined)
      };
      formats.filterLog = {
        blockNumber: Formatter.allowNull(number),
        blockHash: Formatter.allowNull(hash),
        transactionIndex: number,
        removed: Formatter.allowNull(this["boolean"].bind(this)),
        address: address,
        data: Formatter.allowFalsish(data, "0x"),
        topics: Formatter.arrayOf(hash),
        transactionHash: hash,
        logIndex: number
      };
      return formats;
    }
  }, {
    key: "accessList",
    value: function accessList(_accessList) {
      return (0,_ethersproject_transactions__WEBPACK_IMPORTED_MODULE_3__.accessListify)(_accessList || []);
    } // Requires a BigNumberish that is within the IEEE754 safe integer range; returns a number
    // Strict! Used on input.

  }, {
    key: "number",
    value: function number(_number) {
      if (_number === "0x") {
        return 0;
      }

      return _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(_number).toNumber();
    }
  }, {
    key: "type",
    value: function type(number) {
      if (number === "0x" || number == null) {
        return 0;
      }

      return _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(number).toNumber();
    } // Strict! Used on input.

  }, {
    key: "bigNumber",
    value: function bigNumber(value) {
      return _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(value);
    } // Requires a boolean, "true" or  "false"; returns a boolean

  }, {
    key: "boolean",
    value: function boolean(value) {
      if (typeof value === "boolean") {
        return value;
      }

      if (typeof value === "string") {
        value = value.toLowerCase();

        if (value === "true") {
          return true;
        }

        if (value === "false") {
          return false;
        }
      }

      throw new Error("invalid boolean - " + value);
    }
  }, {
    key: "hex",
    value: function hex(value, strict) {
      if (typeof value === "string") {
        if (!strict && value.substring(0, 2) !== "0x") {
          value = "0x" + value;
        }

        if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(value)) {
          return value.toLowerCase();
        }
      }

      return logger.throwArgumentError("invalid hash", "value", value);
    }
  }, {
    key: "data",
    value: function data(value, strict) {
      var result = this.hex(value, strict);

      if (result.length % 2 !== 0) {
        throw new Error("invalid data; odd-length - " + value);
      }

      return result;
    } // Requires an address
    // Strict! Used on input.

  }, {
    key: "address",
    value: function address(value) {
      return (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_6__.getAddress)(value);
    }
  }, {
    key: "callAddress",
    value: function callAddress(value) {
      if (!(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(value, 32)) {
        return null;
      }

      var address = (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_6__.getAddress)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexDataSlice)(value, 12));
      return address === _ethersproject_constants__WEBPACK_IMPORTED_MODULE_7__.AddressZero ? null : address;
    }
  }, {
    key: "contractAddress",
    value: function contractAddress(value) {
      return (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_6__.getContractAddress)(value);
    } // Strict! Used on input.

  }, {
    key: "blockTag",
    value: function blockTag(_blockTag) {
      if (_blockTag == null) {
        return "latest";
      }

      if (_blockTag === "earliest") {
        return "0x0";
      }

      if (_blockTag === "latest" || _blockTag === "pending") {
        return _blockTag;
      }

      if (typeof _blockTag === "number" || (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(_blockTag)) {
        return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexValue)(_blockTag);
      }

      throw new Error("invalid blockTag");
    } // Requires a hash, optionally requires 0x prefix; returns prefixed lowercase hash.

  }, {
    key: "hash",
    value: function hash(value, strict) {
      var result = this.hex(value, strict);

      if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexDataLength)(result) !== 32) {
        return logger.throwArgumentError("invalid hash", "value", value);
      }

      return result;
    } // Returns the difficulty as a number, or if too large (i.e. PoA network) null

  }, {
    key: "difficulty",
    value: function difficulty(value) {
      if (value == null) {
        return null;
      }

      var v = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(value);

      try {
        return v.toNumber();
      } catch (error) {}

      return null;
    }
  }, {
    key: "uint256",
    value: function uint256(value) {
      if (!(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(value)) {
        throw new Error("invalid uint256");
      }

      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.hexZeroPad)(value, 32);
    }
  }, {
    key: "_block",
    value: function _block(value, format) {
      if (value.author != null && value.miner == null) {
        value.miner = value.author;
      } // The difficulty may need to come from _difficulty in recursed blocks


      var difficulty = value._difficulty != null ? value._difficulty : value.difficulty;
      var result = Formatter.check(format, value);
      result._difficulty = difficulty == null ? null : _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(difficulty);
      return result;
    }
  }, {
    key: "block",
    value: function block(value) {
      return this._block(value, this.formats.block);
    }
  }, {
    key: "blockWithTransactions",
    value: function blockWithTransactions(value) {
      return this._block(value, this.formats.blockWithTransactions);
    } // Strict! Used on input.

  }, {
    key: "transactionRequest",
    value: function transactionRequest(value) {
      return Formatter.check(this.formats.transactionRequest, value);
    }
  }, {
    key: "transactionResponse",
    value: function transactionResponse(transaction) {
      // Rename gas to gasLimit
      if (transaction.gas != null && transaction.gasLimit == null) {
        transaction.gasLimit = transaction.gas;
      } // Some clients (TestRPC) do strange things like return 0x0 for the
      // 0 address; correct this to be a real address


      if (transaction.to && _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(transaction.to).isZero()) {
        transaction.to = "0x0000000000000000000000000000000000000000";
      } // Rename input to data


      if (transaction.input != null && transaction.data == null) {
        transaction.data = transaction.input;
      } // If to and creates are empty, populate the creates from the transaction


      if (transaction.to == null && transaction.creates == null) {
        transaction.creates = this.contractAddress(transaction);
      }

      if ((transaction.type === 1 || transaction.type === 2) && transaction.accessList == null) {
        transaction.accessList = [];
      }

      var result = Formatter.check(this.formats.transaction, transaction);

      if (transaction.chainId != null) {
        var chainId = transaction.chainId;

        if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(chainId)) {
          chainId = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(chainId).toNumber();
        }

        result.chainId = chainId;
      } else {
        var _chainId = transaction.networkId; // geth-etc returns chainId

        if (_chainId == null && result.v == null) {
          _chainId = transaction.chainId;
        }

        if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_5__.isHexString)(_chainId)) {
          _chainId = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(_chainId).toNumber();
        }

        if (typeof _chainId !== "number" && result.v != null) {
          _chainId = (result.v - 35) / 2;

          if (_chainId < 0) {
            _chainId = 0;
          }

          _chainId = parseInt(_chainId);
        }

        if (typeof _chainId !== "number") {
          _chainId = 0;
        }

        result.chainId = _chainId;
      } // 0x0000... should actually be null


      if (result.blockHash && result.blockHash.replace(/0/g, "") === "x") {
        result.blockHash = null;
      }

      return result;
    }
  }, {
    key: "transaction",
    value: function transaction(value) {
      return (0,_ethersproject_transactions__WEBPACK_IMPORTED_MODULE_3__.parse)(value);
    }
  }, {
    key: "receiptLog",
    value: function receiptLog(value) {
      return Formatter.check(this.formats.receiptLog, value);
    }
  }, {
    key: "receipt",
    value: function receipt(value) {
      var result = Formatter.check(this.formats.receipt, value); // RSK incorrectly implemented EIP-658, so we munge things a bit here for it

      if (result.root != null) {
        if (result.root.length <= 4) {
          // Could be 0x00, 0x0, 0x01 or 0x1
          var _value = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(result.root).toNumber();

          if (_value === 0 || _value === 1) {
            // Make sure if both are specified, they match
            if (result.status != null && result.status !== _value) {
              logger.throwArgumentError("alt-root-status/status mismatch", "value", {
                root: result.root,
                status: result.status
              });
            }

            result.status = _value;
            delete result.root;
          } else {
            logger.throwArgumentError("invalid alt-root-status", "value.root", result.root);
          }
        } else if (result.root.length !== 66) {
          // Must be a valid bytes32
          logger.throwArgumentError("invalid root hash", "value.root", result.root);
        }
      }

      if (result.status != null) {
        result.byzantium = true;
      }

      return result;
    }
  }, {
    key: "topics",
    value: function topics(value) {
      var _this2 = this;

      if (Array.isArray(value)) {
        return value.map(function (v) {
          return _this2.topics(v);
        });
      } else if (value != null) {
        return this.hash(value, true);
      }

      return null;
    }
  }, {
    key: "filter",
    value: function filter(value) {
      return Formatter.check(this.formats.filter, value);
    }
  }, {
    key: "filterLog",
    value: function filterLog(value) {
      return Formatter.check(this.formats.filterLog, value);
    }
  }], [{
    key: "check",
    value: function check(format, object) {
      var result = {};

      for (var key in format) {
        try {
          var value = format[key](object[key]);

          if (value !== undefined) {
            result[key] = value;
          }
        } catch (error) {
          error.checkKey = key;
          error.checkValue = object[key];
          throw error;
        }
      }

      return result;
    } // if value is null-ish, nullValue is returned

  }, {
    key: "allowNull",
    value: function allowNull(format, nullValue) {
      return function (value) {
        if (value == null) {
          return nullValue;
        }

        return format(value);
      };
    } // If value is false-ish, replaceValue is returned

  }, {
    key: "allowFalsish",
    value: function allowFalsish(format, replaceValue) {
      return function (value) {
        if (!value) {
          return replaceValue;
        }

        return format(value);
      };
    } // Requires an Array satisfying check

  }, {
    key: "arrayOf",
    value: function arrayOf(format) {
      return function (array) {
        if (!Array.isArray(array)) {
          throw new Error("not an array");
        }

        var result = [];
        array.forEach(function (value) {
          result.push(format(value));
        });
        return result;
      };
    }
  }]);

  return Formatter;
}();
function isCommunityResourcable(value) {
  return value && typeof value.isCommunityResource === "function";
}
function isCommunityResource(value) {
  return isCommunityResourcable(value) && value.isCommunityResource();
} // Show the throttle message only once

var throttleMessage = false;
function showThrottleMessage() {
  if (throttleMessage) {
    return;
  }

  throttleMessage = true;
  console.log("========= NOTICE =========");
  console.log("Request-Rate Exceeded  (this message will not be repeated)");
  console.log("");
  console.log("The default API keys for each service are provided as a highly-throttled,");
  console.log("community resource for low-traffic projects and early prototyping.");
  console.log("");
  console.log("While your application will continue to function, we highly recommended");
  console.log("signing up for your own API keys to improve performance, increase your");
  console.log("request rate/limit and enable other perks, such as metrics and advanced APIs.");
  console.log("");
  console.log("For more details: https:/\/docs.ethers.io/api-keys/");
  console.log("==========================");
}

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/index.js":
/*!****************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/index.js ***!
  \****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Provider": function() { return /* reexport safe */ _ethersproject_abstract_provider__WEBPACK_IMPORTED_MODULE_15__.Provider; },
/* harmony export */   "BaseProvider": function() { return /* reexport safe */ _base_provider__WEBPACK_IMPORTED_MODULE_16__.BaseProvider; },
/* harmony export */   "Resolver": function() { return /* reexport safe */ _base_provider__WEBPACK_IMPORTED_MODULE_16__.Resolver; },
/* harmony export */   "UrlJsonRpcProvider": function() { return /* reexport safe */ _url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_17__.UrlJsonRpcProvider; },
/* harmony export */   "FallbackProvider": function() { return /* reexport safe */ _fallback_provider__WEBPACK_IMPORTED_MODULE_5__.FallbackProvider; },
/* harmony export */   "AlchemyProvider": function() { return /* reexport safe */ _alchemy_provider__WEBPACK_IMPORTED_MODULE_6__.AlchemyProvider; },
/* harmony export */   "AlchemyWebSocketProvider": function() { return /* reexport safe */ _alchemy_provider__WEBPACK_IMPORTED_MODULE_6__.AlchemyWebSocketProvider; },
/* harmony export */   "AnkrProvider": function() { return /* reexport safe */ _ankr_provider__WEBPACK_IMPORTED_MODULE_7__.AnkrProvider; },
/* harmony export */   "CloudflareProvider": function() { return /* reexport safe */ _cloudflare_provider__WEBPACK_IMPORTED_MODULE_8__.CloudflareProvider; },
/* harmony export */   "EtherscanProvider": function() { return /* reexport safe */ _etherscan_provider__WEBPACK_IMPORTED_MODULE_9__.EtherscanProvider; },
/* harmony export */   "InfuraProvider": function() { return /* reexport safe */ _infura_provider__WEBPACK_IMPORTED_MODULE_10__.InfuraProvider; },
/* harmony export */   "InfuraWebSocketProvider": function() { return /* reexport safe */ _infura_provider__WEBPACK_IMPORTED_MODULE_10__.InfuraWebSocketProvider; },
/* harmony export */   "JsonRpcProvider": function() { return /* reexport safe */ _json_rpc_provider__WEBPACK_IMPORTED_MODULE_2__.JsonRpcProvider; },
/* harmony export */   "JsonRpcBatchProvider": function() { return /* reexport safe */ _json_rpc_batch_provider__WEBPACK_IMPORTED_MODULE_18__.JsonRpcBatchProvider; },
/* harmony export */   "NodesmithProvider": function() { return /* reexport safe */ _nodesmith_provider__WEBPACK_IMPORTED_MODULE_11__.NodesmithProvider; },
/* harmony export */   "PocketProvider": function() { return /* reexport safe */ _pocket_provider__WEBPACK_IMPORTED_MODULE_12__.PocketProvider; },
/* harmony export */   "StaticJsonRpcProvider": function() { return /* reexport safe */ _url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_17__.StaticJsonRpcProvider; },
/* harmony export */   "Web3Provider": function() { return /* reexport safe */ _web3_provider__WEBPACK_IMPORTED_MODULE_13__.Web3Provider; },
/* harmony export */   "WebSocketProvider": function() { return /* reexport safe */ _websocket_provider__WEBPACK_IMPORTED_MODULE_3__.WebSocketProvider; },
/* harmony export */   "IpcProvider": function() { return /* reexport safe */ _ipc_provider__WEBPACK_IMPORTED_MODULE_14__.IpcProvider; },
/* harmony export */   "JsonRpcSigner": function() { return /* reexport safe */ _json_rpc_provider__WEBPACK_IMPORTED_MODULE_2__.JsonRpcSigner; },
/* harmony export */   "getDefaultProvider": function() { return /* binding */ getDefaultProvider; },
/* harmony export */   "getNetwork": function() { return /* reexport safe */ _ethersproject_networks__WEBPACK_IMPORTED_MODULE_4__.getNetwork; },
/* harmony export */   "isCommunityResource": function() { return /* reexport safe */ _formatter__WEBPACK_IMPORTED_MODULE_19__.isCommunityResource; },
/* harmony export */   "isCommunityResourcable": function() { return /* reexport safe */ _formatter__WEBPACK_IMPORTED_MODULE_19__.isCommunityResourcable; },
/* harmony export */   "showThrottleMessage": function() { return /* reexport safe */ _formatter__WEBPACK_IMPORTED_MODULE_19__.showThrottleMessage; },
/* harmony export */   "Formatter": function() { return /* reexport safe */ _formatter__WEBPACK_IMPORTED_MODULE_19__.Formatter; }
/* harmony export */ });
/* harmony import */ var _ethersproject_abstract_provider__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @ethersproject/abstract-provider */ "./node_modules/@ethersproject/abstract-provider/lib.esm/index.js");
/* harmony import */ var _ethersproject_networks__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/networks */ "./node_modules/@ethersproject/networks/lib.esm/index.js");
/* harmony import */ var _base_provider__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./base-provider */ "./node_modules/@ethersproject/providers/lib.esm/base-provider.js");
/* harmony import */ var _alchemy_provider__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./alchemy-provider */ "./node_modules/@ethersproject/providers/lib.esm/alchemy-provider.js");
/* harmony import */ var _ankr_provider__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./ankr-provider */ "./node_modules/@ethersproject/providers/lib.esm/ankr-provider.js");
/* harmony import */ var _cloudflare_provider__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./cloudflare-provider */ "./node_modules/@ethersproject/providers/lib.esm/cloudflare-provider.js");
/* harmony import */ var _etherscan_provider__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./etherscan-provider */ "./node_modules/@ethersproject/providers/lib.esm/etherscan-provider.js");
/* harmony import */ var _fallback_provider__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./fallback-provider */ "./node_modules/@ethersproject/providers/lib.esm/fallback-provider.js");
/* harmony import */ var _ipc_provider__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./ipc-provider */ "./node_modules/@ethersproject/providers/lib.esm/ipc-provider.js");
/* harmony import */ var _infura_provider__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./infura-provider */ "./node_modules/@ethersproject/providers/lib.esm/infura-provider.js");
/* harmony import */ var _json_rpc_provider__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./json-rpc-provider */ "./node_modules/@ethersproject/providers/lib.esm/json-rpc-provider.js");
/* harmony import */ var _json_rpc_batch_provider__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ./json-rpc-batch-provider */ "./node_modules/@ethersproject/providers/lib.esm/json-rpc-batch-provider.js");
/* harmony import */ var _nodesmith_provider__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./nodesmith-provider */ "./node_modules/@ethersproject/providers/lib.esm/nodesmith-provider.js");
/* harmony import */ var _pocket_provider__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./pocket-provider */ "./node_modules/@ethersproject/providers/lib.esm/pocket-provider.js");
/* harmony import */ var _url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ./url-json-rpc-provider */ "./node_modules/@ethersproject/providers/lib.esm/url-json-rpc-provider.js");
/* harmony import */ var _web3_provider__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./web3-provider */ "./node_modules/@ethersproject/providers/lib.esm/web3-provider.js");
/* harmony import */ var _websocket_provider__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./websocket-provider */ "./node_modules/@ethersproject/providers/lib.esm/websocket-provider.js");
/* harmony import */ var _formatter__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! ./formatter */ "./node_modules/@ethersproject/providers/lib.esm/formatter.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");






















var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version); ////////////////////////
// Helper Functions

function getDefaultProvider(network, options) {
  if (network == null) {
    network = "homestead";
  } // If passed a URL, figure out the right type of provider based on the scheme


  if (typeof network === "string") {
    // @TODO: Add support for IpcProvider; maybe if it ends in ".ipc"?
    // Handle http and ws (and their secure variants)
    var match = network.match(/^(ws|http)s?:/i);

    if (match) {
      switch (match[1]) {
        case "http":
          return new _json_rpc_provider__WEBPACK_IMPORTED_MODULE_2__.JsonRpcProvider(network);

        case "ws":
          return new _websocket_provider__WEBPACK_IMPORTED_MODULE_3__.WebSocketProvider(network);

        default:
          logger.throwArgumentError("unsupported URL scheme", "network", network);
      }
    }
  }

  var n = (0,_ethersproject_networks__WEBPACK_IMPORTED_MODULE_4__.getNetwork)(network);

  if (!n || !n._defaultProvider) {
    logger.throwError("unsupported getDefaultProvider network", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.NETWORK_ERROR, {
      operation: "getDefaultProvider",
      network: network
    });
  }

  return n._defaultProvider({
    FallbackProvider: _fallback_provider__WEBPACK_IMPORTED_MODULE_5__.FallbackProvider,
    AlchemyProvider: _alchemy_provider__WEBPACK_IMPORTED_MODULE_6__.AlchemyProvider,
    AnkrProvider: _ankr_provider__WEBPACK_IMPORTED_MODULE_7__.AnkrProvider,
    CloudflareProvider: _cloudflare_provider__WEBPACK_IMPORTED_MODULE_8__.CloudflareProvider,
    EtherscanProvider: _etherscan_provider__WEBPACK_IMPORTED_MODULE_9__.EtherscanProvider,
    InfuraProvider: _infura_provider__WEBPACK_IMPORTED_MODULE_10__.InfuraProvider,
    JsonRpcProvider: _json_rpc_provider__WEBPACK_IMPORTED_MODULE_2__.JsonRpcProvider,
    NodesmithProvider: _nodesmith_provider__WEBPACK_IMPORTED_MODULE_11__.NodesmithProvider,
    PocketProvider: _pocket_provider__WEBPACK_IMPORTED_MODULE_12__.PocketProvider,
    Web3Provider: _web3_provider__WEBPACK_IMPORTED_MODULE_13__.Web3Provider,
    IpcProvider: _ipc_provider__WEBPACK_IMPORTED_MODULE_14__.IpcProvider
  }, options);
} ////////////////////////
// Exports




/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/infura-provider.js":
/*!**************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/infura-provider.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "InfuraWebSocketProvider": function() { return /* binding */ InfuraWebSocketProvider; },
/* harmony export */   "InfuraProvider": function() { return /* binding */ InfuraProvider; }
/* harmony export */ });
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _websocket_provider__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./websocket-provider */ "./node_modules/@ethersproject/providers/lib.esm/websocket-provider.js");
/* harmony import */ var _formatter__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./formatter */ "./node_modules/@ethersproject/providers/lib.esm/formatter.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");
/* harmony import */ var _url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./url-json-rpc-provider */ "./node_modules/@ethersproject/providers/lib.esm/url-json-rpc-provider.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }






var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);

var defaultProjectId = "84842078b09946638c03157f83405213";
var InfuraWebSocketProvider = /*#__PURE__*/function (_WebSocketProvider) {
  _inherits(InfuraWebSocketProvider, _WebSocketProvider);

  var _super = _createSuper(InfuraWebSocketProvider);

  function InfuraWebSocketProvider(network, apiKey) {
    var _this;

    _classCallCheck(this, InfuraWebSocketProvider);

    var provider = new InfuraProvider(network, apiKey);
    var connection = provider.connection;

    if (connection.password) {
      logger.throwError("INFURA WebSocket project secrets unsupported", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
        operation: "InfuraProvider.getWebSocketProvider()"
      });
    }

    var url = connection.url.replace(/^http/i, "ws").replace("/v3/", "/ws/v3/");
    _this = _super.call(this, url, network);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this), "apiKey", provider.projectId);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this), "projectId", provider.projectId);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this), "projectSecret", provider.projectSecret);
    return _this;
  }

  _createClass(InfuraWebSocketProvider, [{
    key: "isCommunityResource",
    value: function isCommunityResource() {
      return this.projectId === defaultProjectId;
    }
  }]);

  return InfuraWebSocketProvider;
}(_websocket_provider__WEBPACK_IMPORTED_MODULE_3__.WebSocketProvider);
var InfuraProvider = /*#__PURE__*/function (_UrlJsonRpcProvider) {
  _inherits(InfuraProvider, _UrlJsonRpcProvider);

  var _super2 = _createSuper(InfuraProvider);

  function InfuraProvider() {
    _classCallCheck(this, InfuraProvider);

    return _super2.apply(this, arguments);
  }

  _createClass(InfuraProvider, [{
    key: "isCommunityResource",
    value: function isCommunityResource() {
      return this.projectId === defaultProjectId;
    }
  }], [{
    key: "getWebSocketProvider",
    value: function getWebSocketProvider(network, apiKey) {
      return new InfuraWebSocketProvider(network, apiKey);
    }
  }, {
    key: "getApiKey",
    value: function getApiKey(apiKey) {
      var apiKeyObj = {
        apiKey: defaultProjectId,
        projectId: defaultProjectId,
        projectSecret: null
      };

      if (apiKey == null) {
        return apiKeyObj;
      }

      if (typeof apiKey === "string") {
        apiKeyObj.projectId = apiKey;
      } else if (apiKey.projectSecret != null) {
        logger.assertArgument(typeof apiKey.projectId === "string", "projectSecret requires a projectId", "projectId", apiKey.projectId);
        logger.assertArgument(typeof apiKey.projectSecret === "string", "invalid projectSecret", "projectSecret", "[REDACTED]");
        apiKeyObj.projectId = apiKey.projectId;
        apiKeyObj.projectSecret = apiKey.projectSecret;
      } else if (apiKey.projectId) {
        apiKeyObj.projectId = apiKey.projectId;
      }

      apiKeyObj.apiKey = apiKeyObj.projectId;
      return apiKeyObj;
    }
  }, {
    key: "getUrl",
    value: function getUrl(network, apiKey) {
      var host = null;

      switch (network ? network.name : "unknown") {
        case "homestead":
          host = "mainnet.infura.io";
          break;

        case "ropsten":
          host = "ropsten.infura.io";
          break;

        case "rinkeby":
          host = "rinkeby.infura.io";
          break;

        case "kovan":
          host = "kovan.infura.io";
          break;

        case "goerli":
          host = "goerli.infura.io";
          break;

        case "matic":
          host = "polygon-mainnet.infura.io";
          break;

        case "maticmum":
          host = "polygon-mumbai.infura.io";
          break;

        case "optimism":
          host = "optimism-mainnet.infura.io";
          break;

        case "optimism-kovan":
          host = "optimism-kovan.infura.io";
          break;

        case "arbitrum":
          host = "arbitrum-mainnet.infura.io";
          break;

        case "arbitrum-rinkeby":
          host = "arbitrum-rinkeby.infura.io";
          break;

        default:
          logger.throwError("unsupported network", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INVALID_ARGUMENT, {
            argument: "network",
            value: network
          });
      }

      var connection = {
        allowGzip: true,
        url: "https:/" + "/" + host + "/v3/" + apiKey.projectId,
        throttleCallback: function throttleCallback(attempt, url) {
          if (apiKey.projectId === defaultProjectId) {
            (0,_formatter__WEBPACK_IMPORTED_MODULE_4__.showThrottleMessage)();
          }

          return Promise.resolve(true);
        }
      };

      if (apiKey.projectSecret != null) {
        connection.user = "";
        connection.password = apiKey.projectSecret;
      }

      return connection;
    }
  }]);

  return InfuraProvider;
}(_url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_5__.UrlJsonRpcProvider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/ipc-provider.js":
/*!***********************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/ipc-provider.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "IpcProvider": function() { return /* binding */ IpcProvider; }
/* harmony export */ });


var IpcProvider = null;


/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/json-rpc-batch-provider.js":
/*!**********************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/json-rpc-batch-provider.js ***!
  \**********************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "JsonRpcBatchProvider": function() { return /* binding */ JsonRpcBatchProvider; }
/* harmony export */ });
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_web__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @ethersproject/web */ "./node_modules/@ethersproject/web/lib.esm/index.js");
/* harmony import */ var _json_rpc_provider__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./json-rpc-provider */ "./node_modules/@ethersproject/providers/lib.esm/json-rpc-provider.js");
function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }



 // Experimental

var JsonRpcBatchProvider = /*#__PURE__*/function (_JsonRpcProvider) {
  _inherits(JsonRpcBatchProvider, _JsonRpcProvider);

  var _super = _createSuper(JsonRpcBatchProvider);

  function JsonRpcBatchProvider() {
    _classCallCheck(this, JsonRpcBatchProvider);

    return _super.apply(this, arguments);
  }

  _createClass(JsonRpcBatchProvider, [{
    key: "send",
    value: function send(method, params) {
      var _this = this;

      var request = {
        method: method,
        params: params,
        id: this._nextId++,
        jsonrpc: "2.0"
      };

      if (this._pendingBatch == null) {
        this._pendingBatch = [];
      }

      var inflightRequest = {
        request: request,
        resolve: null,
        reject: null
      };
      var promise = new Promise(function (resolve, reject) {
        inflightRequest.resolve = resolve;
        inflightRequest.reject = reject;
      });

      this._pendingBatch.push(inflightRequest);

      if (!this._pendingBatchAggregator) {
        // Schedule batch for next event loop + short duration
        this._pendingBatchAggregator = setTimeout(function () {
          // Get teh current batch and clear it, so new requests
          // go into the next batch
          var batch = _this._pendingBatch;
          _this._pendingBatch = null;
          _this._pendingBatchAggregator = null; // Get the request as an array of requests

          var request = batch.map(function (inflight) {
            return inflight.request;
          });

          _this.emit("debug", {
            action: "requestBatch",
            request: (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_0__.deepCopy)(request),
            provider: _this
          });

          return (0,_ethersproject_web__WEBPACK_IMPORTED_MODULE_1__.fetchJson)(_this.connection, JSON.stringify(request)).then(function (result) {
            _this.emit("debug", {
              action: "response",
              request: request,
              response: result,
              provider: _this
            }); // For each result, feed it to the correct Promise, depending
            // on whether it was a success or error


            batch.forEach(function (inflightRequest, index) {
              var payload = result[index];

              if (payload.error) {
                var error = new Error(payload.error.message);
                error.code = payload.error.code;
                error.data = payload.error.data;
                inflightRequest.reject(error);
              } else {
                inflightRequest.resolve(payload.result);
              }
            });
          }, function (error) {
            _this.emit("debug", {
              action: "response",
              error: error,
              request: request,
              provider: _this
            });

            batch.forEach(function (inflightRequest) {
              inflightRequest.reject(error);
            });
          });
        }, 10);
      }

      return promise;
    }
  }]);

  return JsonRpcBatchProvider;
}(_json_rpc_provider__WEBPACK_IMPORTED_MODULE_2__.JsonRpcProvider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/json-rpc-provider.js":
/*!****************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/json-rpc-provider.js ***!
  \****************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "JsonRpcSigner": function() { return /* binding */ JsonRpcSigner; },
/* harmony export */   "JsonRpcProvider": function() { return /* binding */ JsonRpcProvider; }
/* harmony export */ });
/* harmony import */ var _ethersproject_abstract_signer__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @ethersproject/abstract-signer */ "./node_modules/@ethersproject/abstract-signer/lib.esm/index.js");
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_hash__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @ethersproject/hash */ "./node_modules/@ethersproject/hash/lib.esm/typed-data.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_strings__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @ethersproject/strings */ "./node_modules/@ethersproject/strings/lib.esm/utf8.js");
/* harmony import */ var _ethersproject_transactions__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @ethersproject/transactions */ "./node_modules/@ethersproject/transactions/lib.esm/index.js");
/* harmony import */ var _ethersproject_web__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/web */ "./node_modules/@ethersproject/web/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");
/* harmony import */ var _base_provider__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./base-provider */ "./node_modules/@ethersproject/providers/lib.esm/base-provider.js");


function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};











var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);

var errorGas = ["call", "estimateGas"];

function spelunk(value) {
  if (value == null) {
    return null;
  } // These *are* the droids we're looking for.


  if (typeof value.message === "string" && value.message.match("reverted") && (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.isHexString)(value.data)) {
    return {
      message: value.message,
      data: value.data
    };
  } // Spelunk further...


  if (_typeof(value) === "object") {
    for (var key in value) {
      var result = spelunk(value[key]);

      if (result) {
        return result;
      }
    }

    return null;
  } // Might be a JSON string we can further descend...


  if (typeof value === "string") {
    try {
      return spelunk(JSON.parse(value));
    } catch (error) {}
  }

  return null;
}

function checkError(method, error, params) {
  // Undo the "convenience" some nodes are attempting to prevent backwards
  // incompatibility; maybe for v6 consider forwarding reverts as errors
  if (method === "call") {
    var result = spelunk(error);

    if (result) {
      return result.data;
    }

    logger.throwError("missing revert data in call exception", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.CALL_EXCEPTION, {
      error: error,
      data: "0x"
    });
  } // @TODO: Should we spelunk for message too?


  var message = error.message;

  if (error.code === _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.SERVER_ERROR && error.error && typeof error.error.message === "string") {
    message = error.error.message;
  } else if (typeof error.body === "string") {
    message = error.body;
  } else if (typeof error.responseText === "string") {
    message = error.responseText;
  }

  message = (message || "").toLowerCase();
  var transaction = params.transaction || params.signedTransaction; // "insufficient funds for gas * price + value + cost(data)"

  if (message.match(/insufficient funds|base fee exceeds gas limit/)) {
    logger.throwError("insufficient funds for intrinsic transaction cost", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INSUFFICIENT_FUNDS, {
      error: error,
      method: method,
      transaction: transaction
    });
  } // "nonce too low"


  if (message.match(/nonce too low/)) {
    logger.throwError("nonce has already been used", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.NONCE_EXPIRED, {
      error: error,
      method: method,
      transaction: transaction
    });
  } // "replacement transaction underpriced"


  if (message.match(/replacement transaction underpriced/)) {
    logger.throwError("replacement fee too low", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.REPLACEMENT_UNDERPRICED, {
      error: error,
      method: method,
      transaction: transaction
    });
  } // "replacement transaction underpriced"


  if (message.match(/only replay-protected/)) {
    logger.throwError("legacy pre-eip-155 transactions not supported", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
      error: error,
      method: method,
      transaction: transaction
    });
  }

  if (errorGas.indexOf(method) >= 0 && message.match(/gas required exceeds allowance|always failing transaction|execution reverted/)) {
    logger.throwError("cannot estimate gas; transaction may fail or may require manual gas limit", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNPREDICTABLE_GAS_LIMIT, {
      error: error,
      method: method,
      transaction: transaction
    });
  }

  throw error;
}

function timer(timeout) {
  return new Promise(function (resolve) {
    setTimeout(resolve, timeout);
  });
}

function getResult(payload) {
  if (payload.error) {
    // @TODO: not any
    var error = new Error(payload.error.message);
    error.code = payload.error.code;
    error.data = payload.error.data;
    throw error;
  }

  return payload.result;
}

function getLowerCase(value) {
  if (value) {
    return value.toLowerCase();
  }

  return value;
}

var _constructorGuard = {};
var JsonRpcSigner = /*#__PURE__*/function (_Signer) {
  _inherits(JsonRpcSigner, _Signer);

  var _super = _createSuper(JsonRpcSigner);

  function JsonRpcSigner(constructorGuard, provider, addressOrIndex) {
    var _this;

    _classCallCheck(this, JsonRpcSigner);

    logger.checkNew(this instanceof JsonRpcSigner ? this.constructor : void 0, JsonRpcSigner);
    _this = _super.call(this);

    if (constructorGuard !== _constructorGuard) {
      throw new Error("do not call the JsonRpcSigner constructor directly; use provider.getSigner");
    }

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this), "provider", provider);

    if (addressOrIndex == null) {
      addressOrIndex = 0;
    }

    if (typeof addressOrIndex === "string") {
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this), "_address", _this.provider.formatter.address(addressOrIndex));
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this), "_index", null);
    } else if (typeof addressOrIndex === "number") {
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this), "_index", addressOrIndex);
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this), "_address", null);
    } else {
      logger.throwArgumentError("invalid address or index", "addressOrIndex", addressOrIndex);
    }

    return _this;
  }

  _createClass(JsonRpcSigner, [{
    key: "connect",
    value: function connect(provider) {
      return logger.throwError("cannot alter JSON-RPC Signer connection", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
        operation: "connect"
      });
    }
  }, {
    key: "connectUnchecked",
    value: function connectUnchecked() {
      return new UncheckedJsonRpcSigner(_constructorGuard, this.provider, this._address || this._index);
    }
  }, {
    key: "getAddress",
    value: function getAddress() {
      var _this2 = this;

      if (this._address) {
        return Promise.resolve(this._address);
      }

      return this.provider.send("eth_accounts", []).then(function (accounts) {
        if (accounts.length <= _this2._index) {
          logger.throwError("unknown account #" + _this2._index, _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
            operation: "getAddress"
          });
        }

        return _this2.provider.formatter.address(accounts[_this2._index]);
      });
    }
  }, {
    key: "sendUncheckedTransaction",
    value: function sendUncheckedTransaction(transaction) {
      var _this3 = this;

      transaction = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(transaction);
      var fromAddress = this.getAddress().then(function (address) {
        if (address) {
          address = address.toLowerCase();
        }

        return address;
      }); // The JSON-RPC for eth_sendTransaction uses 90000 gas; if the user
      // wishes to use this, it is easy to specify explicitly, otherwise
      // we look it up for them.

      if (transaction.gasLimit == null) {
        var estimate = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(transaction);
        estimate.from = fromAddress;
        transaction.gasLimit = this.provider.estimateGas(estimate);
      }

      if (transaction.to != null) {
        transaction.to = Promise.resolve(transaction.to).then(function (to) {
          return __awaiter(_this3, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
            var address;
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    if (!(to == null)) {
                      _context.next = 2;
                      break;
                    }

                    return _context.abrupt("return", null);

                  case 2:
                    _context.next = 4;
                    return this.provider.resolveName(to);

                  case 4:
                    address = _context.sent;

                    if (address == null) {
                      logger.throwArgumentError("provided ENS name resolves to null", "tx.to", to);
                    }

                    return _context.abrupt("return", address);

                  case 7:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));
        });
      }

      return (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.resolveProperties)({
        tx: (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.resolveProperties)(transaction),
        sender: fromAddress
      }).then(function (_ref) {
        var tx = _ref.tx,
            sender = _ref.sender;

        if (tx.from != null) {
          if (tx.from.toLowerCase() !== sender) {
            logger.throwArgumentError("from address mismatch", "transaction", transaction);
          }
        } else {
          tx.from = sender;
        }

        var hexTx = _this3.provider.constructor.hexlifyTransaction(tx, {
          from: true
        });

        return _this3.provider.send("eth_sendTransaction", [hexTx]).then(function (hash) {
          return hash;
        }, function (error) {
          return checkError("sendTransaction", error, hexTx);
        });
      });
    }
  }, {
    key: "signTransaction",
    value: function signTransaction(transaction) {
      return logger.throwError("signing transactions is unsupported", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
        operation: "signTransaction"
      });
    }
  }, {
    key: "sendTransaction",
    value: function sendTransaction(transaction) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var _this4 = this;

        var blockNumber, hash;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.provider._getInternalBlockNumber(100 + 2 * this.provider.pollingInterval);

              case 2:
                blockNumber = _context3.sent;
                _context3.next = 5;
                return this.sendUncheckedTransaction(transaction);

              case 5:
                hash = _context3.sent;
                _context3.prev = 6;
                _context3.next = 9;
                return (0,_ethersproject_web__WEBPACK_IMPORTED_MODULE_4__.poll)(function () {
                  return __awaiter(_this4, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
                    var tx;
                    return regeneratorRuntime.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            _context2.next = 2;
                            return this.provider.getTransaction(hash);

                          case 2:
                            tx = _context2.sent;

                            if (!(tx === null)) {
                              _context2.next = 5;
                              break;
                            }

                            return _context2.abrupt("return", undefined);

                          case 5:
                            return _context2.abrupt("return", this.provider._wrapTransaction(tx, hash, blockNumber));

                          case 6:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2, this);
                  }));
                }, {
                  oncePoll: this.provider
                });

              case 9:
                return _context3.abrupt("return", _context3.sent);

              case 12:
                _context3.prev = 12;
                _context3.t0 = _context3["catch"](6);
                _context3.t0.transactionHash = hash;
                throw _context3.t0;

              case 16:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[6, 12]]);
      }));
    }
  }, {
    key: "signMessage",
    value: function signMessage(message) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var data, address;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                data = typeof message === "string" ? (0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_5__.toUtf8Bytes)(message) : message;
                _context4.next = 3;
                return this.getAddress();

              case 3:
                address = _context4.sent;
                _context4.next = 6;
                return this.provider.send("personal_sign", [(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexlify)(data), address.toLowerCase()]);

              case 6:
                return _context4.abrupt("return", _context4.sent);

              case 7:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));
    }
  }, {
    key: "_legacySignMessage",
    value: function _legacySignMessage(message) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
        var data, address;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                data = typeof message === "string" ? (0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_5__.toUtf8Bytes)(message) : message;
                _context5.next = 3;
                return this.getAddress();

              case 3:
                address = _context5.sent;
                _context5.next = 6;
                return this.provider.send("eth_sign", [address.toLowerCase(), (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexlify)(data)]);

              case 6:
                return _context5.abrupt("return", _context5.sent);

              case 7:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));
    }
  }, {
    key: "_signTypedData",
    value: function _signTypedData(domain, types, value) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
        var _this5 = this;

        var populated, address;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return _ethersproject_hash__WEBPACK_IMPORTED_MODULE_6__.TypedDataEncoder.resolveNames(domain, types, value, function (name) {
                  return _this5.provider.resolveName(name);
                });

              case 2:
                populated = _context6.sent;
                _context6.next = 5;
                return this.getAddress();

              case 5:
                address = _context6.sent;
                _context6.next = 8;
                return this.provider.send("eth_signTypedData_v4", [address.toLowerCase(), JSON.stringify(_ethersproject_hash__WEBPACK_IMPORTED_MODULE_6__.TypedDataEncoder.getPayload(populated.domain, types, populated.value))]);

              case 8:
                return _context6.abrupt("return", _context6.sent);

              case 9:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));
    }
  }, {
    key: "unlock",
    value: function unlock(password) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
        var provider, address;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                provider = this.provider;
                _context7.next = 3;
                return this.getAddress();

              case 3:
                address = _context7.sent;
                return _context7.abrupt("return", provider.send("personal_unlockAccount", [address.toLowerCase(), password, null]));

              case 5:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));
    }
  }]);

  return JsonRpcSigner;
}(_ethersproject_abstract_signer__WEBPACK_IMPORTED_MODULE_7__.Signer);

var UncheckedJsonRpcSigner = /*#__PURE__*/function (_JsonRpcSigner) {
  _inherits(UncheckedJsonRpcSigner, _JsonRpcSigner);

  var _super2 = _createSuper(UncheckedJsonRpcSigner);

  function UncheckedJsonRpcSigner() {
    _classCallCheck(this, UncheckedJsonRpcSigner);

    return _super2.apply(this, arguments);
  }

  _createClass(UncheckedJsonRpcSigner, [{
    key: "sendTransaction",
    value: function sendTransaction(transaction) {
      var _this6 = this;

      return this.sendUncheckedTransaction(transaction).then(function (hash) {
        return {
          hash: hash,
          nonce: null,
          gasLimit: null,
          gasPrice: null,
          data: null,
          value: null,
          chainId: null,
          confirmations: 0,
          from: null,
          wait: function wait(confirmations) {
            return _this6.provider.waitForTransaction(hash, confirmations);
          }
        };
      });
    }
  }]);

  return UncheckedJsonRpcSigner;
}(JsonRpcSigner);

var allowedTransactionKeys = {
  chainId: true,
  data: true,
  gasLimit: true,
  gasPrice: true,
  nonce: true,
  to: true,
  value: true,
  type: true,
  accessList: true,
  maxFeePerGas: true,
  maxPriorityFeePerGas: true
};
var JsonRpcProvider = /*#__PURE__*/function (_BaseProvider) {
  _inherits(JsonRpcProvider, _BaseProvider);

  var _super3 = _createSuper(JsonRpcProvider);

  function JsonRpcProvider(url, network) {
    var _this7;

    _classCallCheck(this, JsonRpcProvider);

    logger.checkNew(this instanceof JsonRpcProvider ? this.constructor : void 0, JsonRpcProvider);
    var networkOrReady = network; // The network is unknown, query the JSON-RPC for it

    if (networkOrReady == null) {
      networkOrReady = new Promise(function (resolve, reject) {
        setTimeout(function () {
          _this7.detectNetwork().then(function (network) {
            resolve(network);
          }, function (error) {
            reject(error);
          });
        }, 0);
      });
    }

    _this7 = _super3.call(this, networkOrReady); // Default URL

    if (!url) {
      url = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.getStatic)(_this7.constructor, "defaultUrl")();
    }

    if (typeof url === "string") {
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this7), "connection", Object.freeze({
        url: url
      }));
    } else {
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(_assertThisInitialized(_this7), "connection", Object.freeze((0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(url)));
    }

    _this7._nextId = 42;
    return _this7;
  }

  _createClass(JsonRpcProvider, [{
    key: "_cache",
    get: function get() {
      if (this._eventLoopCache == null) {
        this._eventLoopCache = {};
      }

      return this._eventLoopCache;
    }
  }, {
    key: "detectNetwork",
    value: function detectNetwork() {
      var _this8 = this;

      if (!this._cache["detectNetwork"]) {
        this._cache["detectNetwork"] = this._uncachedDetectNetwork(); // Clear this cache at the beginning of the next event loop

        setTimeout(function () {
          _this8._cache["detectNetwork"] = null;
        }, 0);
      }

      return this._cache["detectNetwork"];
    }
  }, {
    key: "_uncachedDetectNetwork",
    value: function _uncachedDetectNetwork() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
        var chainId, getNetwork;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return timer(0);

              case 2:
                chainId = null;
                _context8.prev = 3;
                _context8.next = 6;
                return this.send("eth_chainId", []);

              case 6:
                chainId = _context8.sent;
                _context8.next = 19;
                break;

              case 9:
                _context8.prev = 9;
                _context8.t0 = _context8["catch"](3);
                _context8.prev = 11;
                _context8.next = 14;
                return this.send("net_version", []);

              case 14:
                chainId = _context8.sent;
                _context8.next = 19;
                break;

              case 17:
                _context8.prev = 17;
                _context8.t1 = _context8["catch"](11);

              case 19:
                if (!(chainId != null)) {
                  _context8.next = 28;
                  break;
                }

                getNetwork = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.getStatic)(this.constructor, "getNetwork");
                _context8.prev = 21;
                return _context8.abrupt("return", getNetwork(_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_8__.BigNumber.from(chainId).toNumber()));

              case 25:
                _context8.prev = 25;
                _context8.t2 = _context8["catch"](21);
                return _context8.abrupt("return", logger.throwError("could not detect network", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.NETWORK_ERROR, {
                  chainId: chainId,
                  event: "invalidNetwork",
                  serverError: _context8.t2
                }));

              case 28:
                return _context8.abrupt("return", logger.throwError("could not detect network", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.NETWORK_ERROR, {
                  event: "noNetwork"
                }));

              case 29:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this, [[3, 9], [11, 17], [21, 25]]);
      }));
    }
  }, {
    key: "getSigner",
    value: function getSigner(addressOrIndex) {
      return new JsonRpcSigner(_constructorGuard, this, addressOrIndex);
    }
  }, {
    key: "getUncheckedSigner",
    value: function getUncheckedSigner(addressOrIndex) {
      return this.getSigner(addressOrIndex).connectUnchecked();
    }
  }, {
    key: "listAccounts",
    value: function listAccounts() {
      var _this9 = this;

      return this.send("eth_accounts", []).then(function (accounts) {
        return accounts.map(function (a) {
          return _this9.formatter.address(a);
        });
      });
    }
  }, {
    key: "send",
    value: function send(method, params) {
      var _this10 = this;

      var request = {
        method: method,
        params: params,
        id: this._nextId++,
        jsonrpc: "2.0"
      };
      this.emit("debug", {
        action: "request",
        request: (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.deepCopy)(request),
        provider: this
      }); // We can expand this in the future to any call, but for now these
      // are the biggest wins and do not require any serializing parameters.

      var cache = ["eth_chainId", "eth_blockNumber"].indexOf(method) >= 0;

      if (cache && this._cache[method]) {
        return this._cache[method];
      }

      var result = (0,_ethersproject_web__WEBPACK_IMPORTED_MODULE_4__.fetchJson)(this.connection, JSON.stringify(request), getResult).then(function (result) {
        _this10.emit("debug", {
          action: "response",
          request: request,
          response: result,
          provider: _this10
        });

        return result;
      }, function (error) {
        _this10.emit("debug", {
          action: "response",
          error: error,
          request: request,
          provider: _this10
        });

        throw error;
      }); // Cache the fetch, but clear it on the next event loop

      if (cache) {
        this._cache[method] = result;
        setTimeout(function () {
          _this10._cache[method] = null;
        }, 0);
      }

      return result;
    }
  }, {
    key: "prepareRequest",
    value: function prepareRequest(method, params) {
      switch (method) {
        case "getBlockNumber":
          return ["eth_blockNumber", []];

        case "getGasPrice":
          return ["eth_gasPrice", []];

        case "getBalance":
          return ["eth_getBalance", [getLowerCase(params.address), params.blockTag]];

        case "getTransactionCount":
          return ["eth_getTransactionCount", [getLowerCase(params.address), params.blockTag]];

        case "getCode":
          return ["eth_getCode", [getLowerCase(params.address), params.blockTag]];

        case "getStorageAt":
          return ["eth_getStorageAt", [getLowerCase(params.address), params.position, params.blockTag]];

        case "sendTransaction":
          return ["eth_sendRawTransaction", [params.signedTransaction]];

        case "getBlock":
          if (params.blockTag) {
            return ["eth_getBlockByNumber", [params.blockTag, !!params.includeTransactions]];
          } else if (params.blockHash) {
            return ["eth_getBlockByHash", [params.blockHash, !!params.includeTransactions]];
          }

          return null;

        case "getTransaction":
          return ["eth_getTransactionByHash", [params.transactionHash]];

        case "getTransactionReceipt":
          return ["eth_getTransactionReceipt", [params.transactionHash]];

        case "call":
          {
            var hexlifyTransaction = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.getStatic)(this.constructor, "hexlifyTransaction");
            return ["eth_call", [hexlifyTransaction(params.transaction, {
              from: true
            }), params.blockTag]];
          }

        case "estimateGas":
          {
            var _hexlifyTransaction = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.getStatic)(this.constructor, "hexlifyTransaction");

            return ["eth_estimateGas", [_hexlifyTransaction(params.transaction, {
              from: true
            })]];
          }

        case "getLogs":
          if (params.filter && params.filter.address != null) {
            params.filter.address = getLowerCase(params.filter.address);
          }

          return ["eth_getLogs", [params.filter]];

        default:
          break;
      }

      return null;
    }
  }, {
    key: "perform",
    value: function perform(method, params) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
        var tx, feeData, args;
        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                if (!(method === "call" || method === "estimateGas")) {
                  _context9.next = 8;
                  break;
                }

                tx = params.transaction;

                if (!(tx && tx.type != null && _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_8__.BigNumber.from(tx.type).isZero())) {
                  _context9.next = 8;
                  break;
                }

                if (!(tx.maxFeePerGas == null && tx.maxPriorityFeePerGas == null)) {
                  _context9.next = 8;
                  break;
                }

                _context9.next = 6;
                return this.getFeeData();

              case 6:
                feeData = _context9.sent;

                if (feeData.maxFeePerGas == null && feeData.maxPriorityFeePerGas == null) {
                  // Network doesn't know about EIP-1559 (and hence type)
                  params = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(params);
                  params.transaction = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(tx);
                  delete params.transaction.type;
                }

              case 8:
                args = this.prepareRequest(method, params);

                if (args == null) {
                  logger.throwError(method + " not implemented", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.NOT_IMPLEMENTED, {
                    operation: method
                  });
                }

                _context9.prev = 10;
                _context9.next = 13;
                return this.send(args[0], args[1]);

              case 13:
                return _context9.abrupt("return", _context9.sent);

              case 16:
                _context9.prev = 16;
                _context9.t0 = _context9["catch"](10);
                return _context9.abrupt("return", checkError(method, _context9.t0, params));

              case 19:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this, [[10, 16]]);
      }));
    }
  }, {
    key: "_startEvent",
    value: function _startEvent(event) {
      if (event.tag === "pending") {
        this._startPending();
      }

      _get(_getPrototypeOf(JsonRpcProvider.prototype), "_startEvent", this).call(this, event);
    }
  }, {
    key: "_startPending",
    value: function _startPending() {
      if (this._pendingFilter != null) {
        return;
      }

      var self = this;
      var pendingFilter = this.send("eth_newPendingTransactionFilter", []);
      this._pendingFilter = pendingFilter;
      pendingFilter.then(function (filterId) {
        function poll() {
          self.send("eth_getFilterChanges", [filterId]).then(function (hashes) {
            if (self._pendingFilter != pendingFilter) {
              return null;
            }

            var seq = Promise.resolve();
            hashes.forEach(function (hash) {
              // @TODO: This should be garbage collected at some point... How? When?
              self._emitted["t:" + hash.toLowerCase()] = "pending";
              seq = seq.then(function () {
                return self.getTransaction(hash).then(function (tx) {
                  self.emit("pending", tx);
                  return null;
                });
              });
            });
            return seq.then(function () {
              return timer(1000);
            });
          }).then(function () {
            if (self._pendingFilter != pendingFilter) {
              self.send("eth_uninstallFilter", [filterId]);
              return;
            }

            setTimeout(function () {
              poll();
            }, 0);
            return null;
          })["catch"](function (error) {});
        }

        poll();
        return filterId;
      })["catch"](function (error) {});
    }
  }, {
    key: "_stopEvent",
    value: function _stopEvent(event) {
      if (event.tag === "pending" && this.listenerCount("pending") === 0) {
        this._pendingFilter = null;
      }

      _get(_getPrototypeOf(JsonRpcProvider.prototype), "_stopEvent", this).call(this, event);
    } // Convert an ethers.js transaction into a JSON-RPC transaction
    //  - gasLimit => gas
    //  - All values hexlified
    //  - All numeric values zero-striped
    //  - All addresses are lowercased
    // NOTE: This allows a TransactionRequest, but all values should be resolved
    //       before this is called
    // @TODO: This will likely be removed in future versions and prepareRequest
    //        will be the preferred method for this.

  }], [{
    key: "defaultUrl",
    value: function defaultUrl() {
      return "http:/\/localhost:8545";
    }
  }, {
    key: "hexlifyTransaction",
    value: function hexlifyTransaction(transaction, allowExtra) {
      // Check only allowed properties are given
      var allowed = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.shallowCopy)(allowedTransactionKeys);

      if (allowExtra) {
        for (var key in allowExtra) {
          if (allowExtra[key]) {
            allowed[key] = true;
          }
        }
      }

      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.checkProperties)(transaction, allowed);
      var result = {}; // JSON-RPC now requires numeric values to be "quantity" values

      ["chainId", "gasLimit", "gasPrice", "type", "maxFeePerGas", "maxPriorityFeePerGas", "nonce", "value"].forEach(function (key) {
        if (transaction[key] == null) {
          return;
        }

        var value = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexValue)(transaction[key]);

        if (key === "gasLimit") {
          key = "gas";
        }

        result[key] = value;
      });
      ["from", "to", "data"].forEach(function (key) {
        if (transaction[key] == null) {
          return;
        }

        result[key] = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexlify)(transaction[key]);
      });

      if (transaction.accessList) {
        result["accessList"] = (0,_ethersproject_transactions__WEBPACK_IMPORTED_MODULE_9__.accessListify)(transaction.accessList);
      }

      return result;
    }
  }]);

  return JsonRpcProvider;
}(_base_provider__WEBPACK_IMPORTED_MODULE_10__.BaseProvider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/nodesmith-provider.js":
/*!*****************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/nodesmith-provider.js ***!
  \*****************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "NodesmithProvider": function() { return /* binding */ NodesmithProvider; }
/* harmony export */ });
/* harmony import */ var _url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./url-json-rpc-provider */ "./node_modules/@ethersproject/providers/lib.esm/url-json-rpc-provider.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");
/* istanbul ignore file */


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }




var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version); // Special API key provided by Nodesmith for ethers.js

var defaultApiKey = "ETHERS_JS_SHARED";
var NodesmithProvider = /*#__PURE__*/function (_UrlJsonRpcProvider) {
  _inherits(NodesmithProvider, _UrlJsonRpcProvider);

  var _super = _createSuper(NodesmithProvider);

  function NodesmithProvider() {
    _classCallCheck(this, NodesmithProvider);

    return _super.apply(this, arguments);
  }

  _createClass(NodesmithProvider, null, [{
    key: "getApiKey",
    value: function getApiKey(apiKey) {
      if (apiKey && typeof apiKey !== "string") {
        logger.throwArgumentError("invalid apiKey", "apiKey", apiKey);
      }

      return apiKey || defaultApiKey;
    }
  }, {
    key: "getUrl",
    value: function getUrl(network, apiKey) {
      logger.warn("NodeSmith will be discontinued on 2019-12-20; please migrate to another platform.");
      var host = null;

      switch (network.name) {
        case "homestead":
          host = "https://ethereum.api.nodesmith.io/v1/mainnet/jsonrpc";
          break;

        case "ropsten":
          host = "https://ethereum.api.nodesmith.io/v1/ropsten/jsonrpc";
          break;

        case "rinkeby":
          host = "https://ethereum.api.nodesmith.io/v1/rinkeby/jsonrpc";
          break;

        case "goerli":
          host = "https://ethereum.api.nodesmith.io/v1/goerli/jsonrpc";
          break;

        case "kovan":
          host = "https://ethereum.api.nodesmith.io/v1/kovan/jsonrpc";
          break;

        default:
          logger.throwArgumentError("unsupported network", "network", arguments[0]);
      }

      return host + "?apiKey=" + apiKey;
    }
  }]);

  return NodesmithProvider;
}(_url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_2__.UrlJsonRpcProvider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/pocket-provider.js":
/*!**************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/pocket-provider.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "PocketProvider": function() { return /* binding */ PocketProvider; }
/* harmony export */ });
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");
/* harmony import */ var _url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./url-json-rpc-provider */ "./node_modules/@ethersproject/providers/lib.esm/url-json-rpc-provider.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }




var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
 // These are load-balancer-based application IDs

var defaultApplicationIds = {
  homestead: "6004bcd10040261633ade990",
  ropsten: "6004bd4d0040261633ade991",
  rinkeby: "6004bda20040261633ade994",
  goerli: "6004bd860040261633ade992"
};
var PocketProvider = /*#__PURE__*/function (_UrlJsonRpcProvider) {
  _inherits(PocketProvider, _UrlJsonRpcProvider);

  var _super = _createSuper(PocketProvider);

  function PocketProvider(network, apiKey) {
    _classCallCheck(this, PocketProvider);

    // We need a bit of creativity in the constructor because
    // Pocket uses different default API keys based on the network
    if (apiKey == null) {
      var n = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.getStatic)(this instanceof PocketProvider ? this.constructor : void 0, "getNetwork")(network);

      if (n) {
        var applicationId = defaultApplicationIds[n.name];

        if (applicationId) {
          apiKey = {
            applicationId: applicationId,
            loadBalancer: true
          };
        }
      } // If there was any issue above, we don't know this network


      if (apiKey == null) {
        logger.throwError("unsupported network", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INVALID_ARGUMENT, {
          argument: "network",
          value: network
        });
      }
    }

    return _super.call(this, network, apiKey);
  }

  _createClass(PocketProvider, [{
    key: "isCommunityResource",
    value: function isCommunityResource() {
      return this.applicationId === defaultApplicationIds[this.network.name];
    }
  }], [{
    key: "getApiKey",
    value: function getApiKey(apiKey) {
      // Most API Providers allow null to get the default configuration, but
      // Pocket requires the network to decide the default provider, so we
      // rely on hijacking the constructor to add a sensible default for us
      if (apiKey == null) {
        logger.throwArgumentError("PocketProvider.getApiKey does not support null apiKey", "apiKey", apiKey);
      }

      var apiKeyObj = {
        applicationId: null,
        loadBalancer: false,
        applicationSecretKey: null
      }; // Parse applicationId and applicationSecretKey

      if (typeof apiKey === "string") {
        apiKeyObj.applicationId = apiKey;
      } else if (apiKey.applicationSecretKey != null) {
        logger.assertArgument(typeof apiKey.applicationId === "string", "applicationSecretKey requires an applicationId", "applicationId", apiKey.applicationId);
        logger.assertArgument(typeof apiKey.applicationSecretKey === "string", "invalid applicationSecretKey", "applicationSecretKey", "[REDACTED]");
        apiKeyObj.applicationId = apiKey.applicationId;
        apiKeyObj.applicationSecretKey = apiKey.applicationSecretKey;
        apiKeyObj.loadBalancer = !!apiKey.loadBalancer;
      } else if (apiKey.applicationId) {
        logger.assertArgument(typeof apiKey.applicationId === "string", "apiKey.applicationId must be a string", "apiKey.applicationId", apiKey.applicationId);
        apiKeyObj.applicationId = apiKey.applicationId;
        apiKeyObj.loadBalancer = !!apiKey.loadBalancer;
      } else {
        logger.throwArgumentError("unsupported PocketProvider apiKey", "apiKey", apiKey);
      }

      return apiKeyObj;
    }
  }, {
    key: "getUrl",
    value: function getUrl(network, apiKey) {
      var host = null;

      switch (network ? network.name : "unknown") {
        case "homestead":
          host = "eth-mainnet.gateway.pokt.network";
          break;

        case "ropsten":
          host = "eth-ropsten.gateway.pokt.network";
          break;

        case "rinkeby":
          host = "eth-rinkeby.gateway.pokt.network";
          break;

        case "goerli":
          host = "eth-goerli.gateway.pokt.network";
          break;

        default:
          logger.throwError("unsupported network", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INVALID_ARGUMENT, {
            argument: "network",
            value: network
          });
      }

      var url = null;

      if (apiKey.loadBalancer) {
        url = "https://".concat(host, "/v1/lb/").concat(apiKey.applicationId);
      } else {
        url = "https://".concat(host, "/v1/").concat(apiKey.applicationId);
      }

      var connection = {
        url: url
      }; // Initialize empty headers

      connection.headers = {}; // Apply application secret key

      if (apiKey.applicationSecretKey != null) {
        connection.user = "";
        connection.password = apiKey.applicationSecretKey;
      }

      return connection;
    }
  }]);

  return PocketProvider;
}(_url_json_rpc_provider__WEBPACK_IMPORTED_MODULE_3__.UrlJsonRpcProvider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/url-json-rpc-provider.js":
/*!********************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/url-json-rpc-provider.js ***!
  \********************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "StaticJsonRpcProvider": function() { return /* binding */ StaticJsonRpcProvider; },
/* harmony export */   "UrlJsonRpcProvider": function() { return /* binding */ UrlJsonRpcProvider; }
/* harmony export */ });
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");
/* harmony import */ var _json_rpc_provider__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./json-rpc-provider */ "./node_modules/@ethersproject/providers/lib.esm/json-rpc-provider.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};




var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
 // A StaticJsonRpcProvider is useful when you *know* for certain that
// the backend will never change, as it never calls eth_chainId to
// verify its backend. However, if the backend does change, the effects
// are undefined and may include:
// - inconsistent results
// - locking up the UI
// - block skew warnings
// - wrong results
// If the network is not explicit (i.e. auto-detection is expected), the
// node MUST be running and available to respond to requests BEFORE this
// is instantiated.

var StaticJsonRpcProvider = /*#__PURE__*/function (_JsonRpcProvider) {
  _inherits(StaticJsonRpcProvider, _JsonRpcProvider);

  var _super2 = _createSuper(StaticJsonRpcProvider);

  function StaticJsonRpcProvider() {
    _classCallCheck(this, StaticJsonRpcProvider);

    return _super2.apply(this, arguments);
  }

  _createClass(StaticJsonRpcProvider, [{
    key: "detectNetwork",
    value: function detectNetwork() {
      var _this = this;

      var _super = Object.create(null, {
        detectNetwork: {
          get: function get() {
            return _get(_getPrototypeOf(StaticJsonRpcProvider.prototype), "detectNetwork", _this);
          }
        }
      });

      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var network;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                network = this.network;

                if (!(network == null)) {
                  _context.next = 7;
                  break;
                }

                _context.next = 4;
                return _super.detectNetwork.call(this);

              case 4:
                network = _context.sent;

                if (!network) {
                  logger.throwError("no network detected", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNKNOWN_ERROR, {});
                } // If still not set, set it


                if (this._network == null) {
                  // A static network does not support "any"
                  (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(this, "_network", network);
                  this.emit("network", network, null);
                }

              case 7:
                return _context.abrupt("return", network);

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
    }
  }]);

  return StaticJsonRpcProvider;
}(_json_rpc_provider__WEBPACK_IMPORTED_MODULE_3__.JsonRpcProvider);
var UrlJsonRpcProvider = /*#__PURE__*/function (_StaticJsonRpcProvide) {
  _inherits(UrlJsonRpcProvider, _StaticJsonRpcProvide);

  var _super3 = _createSuper(UrlJsonRpcProvider);

  function UrlJsonRpcProvider(network, apiKey) {
    var _this2;

    _classCallCheck(this, UrlJsonRpcProvider);

    logger.checkAbstract(this instanceof UrlJsonRpcProvider ? this.constructor : void 0, UrlJsonRpcProvider); // Normalize the Network and API Key

    network = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.getStatic)(this instanceof UrlJsonRpcProvider ? this.constructor : void 0, "getNetwork")(network);
    apiKey = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.getStatic)(this instanceof UrlJsonRpcProvider ? this.constructor : void 0, "getApiKey")(apiKey);
    var connection = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.getStatic)(this instanceof UrlJsonRpcProvider ? this.constructor : void 0, "getUrl")(network, apiKey);
    _this2 = _super3.call(this, connection, network);

    if (typeof apiKey === "string") {
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this2), "apiKey", apiKey);
    } else if (apiKey != null) {
      Object.keys(apiKey).forEach(function (key) {
        (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this2), key, apiKey[key]);
      });
    }

    return _this2;
  }

  _createClass(UrlJsonRpcProvider, [{
    key: "_startPending",
    value: function _startPending() {
      logger.warn("WARNING: API provider does not support pending filters");
    }
  }, {
    key: "isCommunityResource",
    value: function isCommunityResource() {
      return false;
    }
  }, {
    key: "getSigner",
    value: function getSigner(address) {
      return logger.throwError("API provider does not support signing", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
        operation: "getSigner"
      });
    }
  }, {
    key: "listAccounts",
    value: function listAccounts() {
      return Promise.resolve([]);
    } // Return a defaultApiKey if null, otherwise validate the API key

  }], [{
    key: "getApiKey",
    value: function getApiKey(apiKey) {
      return apiKey;
    } // Returns the url or connection for the given network and API key. The
    // API key will have been sanitized by the getApiKey first, so any validation
    // or transformations can be done there.

  }, {
    key: "getUrl",
    value: function getUrl(network, apiKey) {
      return logger.throwError("not implemented; sub-classes must override getUrl", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.NOT_IMPLEMENTED, {
        operation: "getUrl"
      });
    }
  }]);

  return UrlJsonRpcProvider;
}(StaticJsonRpcProvider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/web3-provider.js":
/*!************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/web3-provider.js ***!
  \************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Web3Provider": function() { return /* binding */ Web3Provider; }
/* harmony export */ });
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");
/* harmony import */ var _json_rpc_provider__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./json-rpc-provider */ "./node_modules/@ethersproject/providers/lib.esm/json-rpc-provider.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }




var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);

var _nextId = 1;

function buildWeb3LegacyFetcher(provider, sendFunc) {
  var fetcher = "Web3LegacyFetcher";
  return function (method, params) {
    var _this = this;

    var request = {
      method: method,
      params: params,
      id: _nextId++,
      jsonrpc: "2.0"
    };
    return new Promise(function (resolve, reject) {
      _this.emit("debug", {
        action: "request",
        fetcher: fetcher,
        request: (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.deepCopy)(request),
        provider: _this
      });

      sendFunc(request, function (error, response) {
        if (error) {
          _this.emit("debug", {
            action: "response",
            fetcher: fetcher,
            error: error,
            request: request,
            provider: _this
          });

          return reject(error);
        }

        _this.emit("debug", {
          action: "response",
          fetcher: fetcher,
          request: request,
          response: response,
          provider: _this
        });

        if (response.error) {
          var _error = new Error(response.error.message);

          _error.code = response.error.code;
          _error.data = response.error.data;
          return reject(_error);
        }

        resolve(response.result);
      });
    });
  };
}

function buildEip1193Fetcher(provider) {
  return function (method, params) {
    var _this2 = this;

    if (params == null) {
      params = [];
    }

    var request = {
      method: method,
      params: params
    };
    this.emit("debug", {
      action: "request",
      fetcher: "Eip1193Fetcher",
      request: (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.deepCopy)(request),
      provider: this
    });
    return provider.request(request).then(function (response) {
      _this2.emit("debug", {
        action: "response",
        fetcher: "Eip1193Fetcher",
        request: request,
        response: response,
        provider: _this2
      });

      return response;
    }, function (error) {
      _this2.emit("debug", {
        action: "response",
        fetcher: "Eip1193Fetcher",
        request: request,
        error: error,
        provider: _this2
      });

      throw error;
    });
  };
}

var Web3Provider = /*#__PURE__*/function (_JsonRpcProvider) {
  _inherits(Web3Provider, _JsonRpcProvider);

  var _super = _createSuper(Web3Provider);

  function Web3Provider(provider, network) {
    var _this3;

    _classCallCheck(this, Web3Provider);

    logger.checkNew(this instanceof Web3Provider ? this.constructor : void 0, Web3Provider);

    if (provider == null) {
      logger.throwArgumentError("missing provider", "provider", provider);
    }

    var path = null;
    var jsonRpcFetchFunc = null;
    var subprovider = null;

    if (typeof provider === "function") {
      path = "unknown:";
      jsonRpcFetchFunc = provider;
    } else {
      path = provider.host || provider.path || "";

      if (!path && provider.isMetaMask) {
        path = "metamask";
      }

      subprovider = provider;

      if (provider.request) {
        if (path === "") {
          path = "eip-1193:";
        }

        jsonRpcFetchFunc = buildEip1193Fetcher(provider);
      } else if (provider.sendAsync) {
        jsonRpcFetchFunc = buildWeb3LegacyFetcher(provider, provider.sendAsync.bind(provider));
      } else if (provider.send) {
        jsonRpcFetchFunc = buildWeb3LegacyFetcher(provider, provider.send.bind(provider));
      } else {
        logger.throwArgumentError("unsupported provider", "provider", provider);
      }

      if (!path) {
        path = "unknown:";
      }
    }

    _this3 = _super.call(this, path, network);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this3), "jsonRpcFetchFunc", jsonRpcFetchFunc);
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this3), "provider", subprovider);
    return _this3;
  }

  _createClass(Web3Provider, [{
    key: "send",
    value: function send(method, params) {
      return this.jsonRpcFetchFunc(method, params);
    }
  }]);

  return Web3Provider;
}(_json_rpc_provider__WEBPACK_IMPORTED_MODULE_3__.JsonRpcProvider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/websocket-provider.js":
/*!*****************************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/websocket-provider.js ***!
  \*****************************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "WebSocketProvider": function() { return /* binding */ WebSocketProvider; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _json_rpc_provider__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./json-rpc-provider */ "./node_modules/@ethersproject/providers/lib.esm/json-rpc-provider.js");
/* harmony import */ var _ws__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./ws */ "./node_modules/@ethersproject/providers/lib.esm/ws.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};







var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
/**
 *  Notes:
 *
 *  This provider differs a bit from the polling providers. One main
 *  difference is how it handles consistency. The polling providers
 *  will stall responses to ensure a consistent state, while this
 *  WebSocket provider assumes the connected backend will manage this.
 *
 *  For example, if a polling provider emits an event which indicates
 *  the event occurred in blockhash XXX, a call to fetch that block by
 *  its hash XXX, if not present will retry until it is present. This
 *  can occur when querying a pool of nodes that are mildly out of sync
 *  with each other.
 */

var NextId = 1; // For more info about the Real-time Event API see:
//   https://geth.ethereum.org/docs/rpc/pubsub

var WebSocketProvider = /*#__PURE__*/function (_JsonRpcProvider) {
  _inherits(WebSocketProvider, _JsonRpcProvider);

  var _super = _createSuper(WebSocketProvider);

  function WebSocketProvider(url, network) {
    var _thisSuper, _this;

    _classCallCheck(this, WebSocketProvider);

    // This will be added in the future; please open an issue to expedite
    if (network === "any") {
      logger.throwError("WebSocketProvider does not support 'any' network yet", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
        operation: "network:any"
      });
    }

    if (typeof url === "string") {
      _this = _super.call(this, url, network);
    } else {
      _this = _super.call(this, "_websocket", network);
    }

    _this._pollingInterval = -1;
    _this._wsReady = false;

    if (typeof url === "string") {
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this), "_websocket", new _ws__WEBPACK_IMPORTED_MODULE_3__.WebSocket(_this.connection.url));
    } else {
      (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this), "_websocket", url);
    }

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this), "_requests", {});
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this), "_subs", {});
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this), "_subIds", {});
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(_assertThisInitialized(_this), "_detectNetwork", _get((_thisSuper = _assertThisInitialized(_this), _getPrototypeOf(WebSocketProvider.prototype)), "detectNetwork", _thisSuper).call(_thisSuper)); // Stall sending requests until the socket is open...

    _this.websocket.onopen = function () {
      _this._wsReady = true;
      Object.keys(_this._requests).forEach(function (id) {
        _this.websocket.send(_this._requests[id].payload);
      });
    };

    _this.websocket.onmessage = function (messageEvent) {
      var data = messageEvent.data;
      var result = JSON.parse(data);

      if (result.id != null) {
        var id = String(result.id);
        var request = _this._requests[id];
        delete _this._requests[id];

        if (result.result !== undefined) {
          request.callback(null, result.result);

          _this.emit("debug", {
            action: "response",
            request: JSON.parse(request.payload),
            response: result.result,
            provider: _assertThisInitialized(_this)
          });
        } else {
          var error = null;

          if (result.error) {
            error = new Error(result.error.message || "unknown error");
            (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(error, "code", result.error.code || null);
            (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_2__.defineReadOnly)(error, "response", data);
          } else {
            error = new Error("unknown error");
          }

          request.callback(error, undefined);

          _this.emit("debug", {
            action: "response",
            error: error,
            request: JSON.parse(request.payload),
            provider: _assertThisInitialized(_this)
          });
        }
      } else if (result.method === "eth_subscription") {
        // Subscription...
        var sub = _this._subs[result.params.subscription];

        if (sub) {
          //this.emit.apply(this,                  );
          sub.processFunc(result.params.result);
        }
      } else {
        console.warn("this should not happen");
      }
    }; // This Provider does not actually poll, but we want to trigger
    // poll events for things that depend on them (like stalling for
    // block and transaction lookups)


    var fauxPoll = setInterval(function () {
      _this.emit("poll");
    }, 1000);

    if (fauxPoll.unref) {
      fauxPoll.unref();
    }

    return _possibleConstructorReturn(_this);
  } // Cannot narrow the type of _websocket, as that is not backwards compatible
  // so we add a getter and let the WebSocket be a public API.


  _createClass(WebSocketProvider, [{
    key: "websocket",
    get: function get() {
      return this._websocket;
    }
  }, {
    key: "detectNetwork",
    value: function detectNetwork() {
      return this._detectNetwork;
    }
  }, {
    key: "pollingInterval",
    get: function get() {
      return 0;
    },
    set: function set(value) {
      logger.throwError("cannot set polling interval on WebSocketProvider", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
        operation: "setPollingInterval"
      });
    }
  }, {
    key: "resetEventsBlock",
    value: function resetEventsBlock(blockNumber) {
      logger.throwError("cannot reset events block on WebSocketProvider", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
        operation: "resetEventBlock"
      });
    }
  }, {
    key: "poll",
    value: function poll() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", null);

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
    }
  }, {
    key: "polling",
    set: function set(value) {
      if (!value) {
        return;
      }

      logger.throwError("cannot set polling on WebSocketProvider", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
        operation: "setPolling"
      });
    }
  }, {
    key: "send",
    value: function send(method, params) {
      var _this2 = this;

      var rid = NextId++;
      return new Promise(function (resolve, reject) {
        function callback(error, result) {
          if (error) {
            return reject(error);
          }

          return resolve(result);
        }

        var payload = JSON.stringify({
          method: method,
          params: params,
          id: rid,
          jsonrpc: "2.0"
        });

        _this2.emit("debug", {
          action: "request",
          request: JSON.parse(payload),
          provider: _this2
        });

        _this2._requests[String(rid)] = {
          callback: callback,
          payload: payload
        };

        if (_this2._wsReady) {
          _this2.websocket.send(payload);
        }
      });
    }
  }, {
    key: "_subscribe",
    value: function _subscribe(tag, param, processFunc) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var _this3 = this;

        var subIdPromise, subId;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                subIdPromise = this._subIds[tag];

                if (subIdPromise == null) {
                  subIdPromise = Promise.all(param).then(function (param) {
                    return _this3.send("eth_subscribe", param);
                  });
                  this._subIds[tag] = subIdPromise;
                }

                _context2.next = 4;
                return subIdPromise;

              case 4:
                subId = _context2.sent;
                this._subs[subId] = {
                  tag: tag,
                  processFunc: processFunc
                };

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));
    }
  }, {
    key: "_startEvent",
    value: function _startEvent(event) {
      var _this4 = this;

      switch (event.type) {
        case "block":
          this._subscribe("block", ["newHeads"], function (result) {
            var blockNumber = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(result.number).toNumber();
            _this4._emitted.block = blockNumber;

            _this4.emit("block", blockNumber);
          });

          break;

        case "pending":
          this._subscribe("pending", ["newPendingTransactions"], function (result) {
            _this4.emit("pending", result);
          });

          break;

        case "filter":
          this._subscribe(event.tag, ["logs", this._getFilter(event.filter)], function (result) {
            if (result.removed == null) {
              result.removed = false;
            }

            _this4.emit(event.filter, _this4.formatter.filterLog(result));
          });

          break;

        case "tx":
          {
            var emitReceipt = function emitReceipt(event) {
              var hash = event.hash;

              _this4.getTransactionReceipt(hash).then(function (receipt) {
                if (!receipt) {
                  return;
                }

                _this4.emit(hash, receipt);
              });
            }; // In case it is already mined


            emitReceipt(event); // To keep things simple, we start up a single newHeads subscription
            // to keep an eye out for transactions we are watching for.
            // Starting a subscription for an event (i.e. "tx") that is already
            // running is (basically) a nop.

            this._subscribe("tx", ["newHeads"], function (result) {
              _this4._events.filter(function (e) {
                return e.type === "tx";
              }).forEach(emitReceipt);
            });

            break;
          }
        // Nothing is needed

        case "debug":
        case "poll":
        case "willPoll":
        case "didPoll":
        case "error":
          break;

        default:
          console.log("unhandled:", event);
          break;
      }
    }
  }, {
    key: "_stopEvent",
    value: function _stopEvent(event) {
      var _this5 = this;

      var tag = event.tag;

      if (event.type === "tx") {
        // There are remaining transaction event listeners
        if (this._events.filter(function (e) {
          return e.type === "tx";
        }).length) {
          return;
        }

        tag = "tx";
      } else if (this.listenerCount(event.event)) {
        // There are remaining event listeners
        return;
      }

      var subId = this._subIds[tag];

      if (!subId) {
        return;
      }

      delete this._subIds[tag];
      subId.then(function (subId) {
        if (!_this5._subs[subId]) {
          return;
        }

        delete _this5._subs[subId];

        _this5.send("eth_unsubscribe", [subId]);
      });
    }
  }, {
    key: "destroy",
    value: function destroy() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var _this6 = this;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!(this.websocket.readyState === _ws__WEBPACK_IMPORTED_MODULE_3__.WebSocket.CONNECTING)) {
                  _context3.next = 3;
                  break;
                }

                _context3.next = 3;
                return new Promise(function (resolve) {
                  _this6.websocket.onopen = function () {
                    resolve(true);
                  };

                  _this6.websocket.onerror = function () {
                    resolve(false);
                  };
                });

              case 3:
                // Hangup
                // See: https://developer.mozilla.org/en-US/docs/Web/API/CloseEvent#Status_codes
                this.websocket.close(1000);

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));
    }
  }], [{
    key: "defaultUrl",
    value: function defaultUrl() {
      return "ws:/\/localhost:8546";
    }
  }]);

  return WebSocketProvider;
}(_json_rpc_provider__WEBPACK_IMPORTED_MODULE_5__.JsonRpcProvider);

/***/ }),

/***/ "./node_modules/@ethersproject/providers/lib.esm/ws.js":
/*!*************************************************************!*\
  !*** ./node_modules/@ethersproject/providers/lib.esm/ws.js ***!
  \*************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "WebSocket": function() { return /* binding */ WS; }
/* harmony export */ });
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/providers/lib.esm/_version.js");




var WS = null;

try {
  WS = WebSocket;

  if (WS == null) {
    throw new Error("inject please");
  }
} catch (error) {
  var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);

  WS = function WS() {
    logger.throwError("WebSockets not supported in this environment", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
      operation: "new WebSocket()"
    });
  };
} //export default WS;
//module.exports = WS;




/***/ }),

/***/ "./node_modules/@ethersproject/random/lib.esm/shuffle.js":
/*!***************************************************************!*\
  !*** ./node_modules/@ethersproject/random/lib.esm/shuffle.js ***!
  \***************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "shuffled": function() { return /* binding */ shuffled; }
/* harmony export */ });


function shuffled(array) {
  array = array.slice();

  for (var i = array.length - 1; i > 0; i--) {
    var j = Math.floor(Math.random() * (i + 1));
    var tmp = array[i];
    array[i] = array[j];
    array[j] = tmp;
  }

  return array;
}

/***/ }),

/***/ "./node_modules/@ethersproject/rlp/lib.esm/_version.js":
/*!*************************************************************!*\
  !*** ./node_modules/@ethersproject/rlp/lib.esm/_version.js ***!
  \*************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "rlp/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/rlp/lib.esm/index.js":
/*!**********************************************************!*\
  !*** ./node_modules/@ethersproject/rlp/lib.esm/index.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "encode": function() { return /* binding */ encode; },
/* harmony export */   "decode": function() { return /* binding */ decode; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/rlp/lib.esm/_version.js");
 //See: https://github.com/ethereum/wiki/wiki/RLP




var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);

function arrayifyInteger(value) {
  var result = [];

  while (value) {
    result.unshift(value & 0xff);
    value >>= 8;
  }

  return result;
}

function unarrayifyInteger(data, offset, length) {
  var result = 0;

  for (var i = 0; i < length; i++) {
    result = result * 256 + data[offset + i];
  }

  return result;
}

function _encode(object) {
  if (Array.isArray(object)) {
    var payload = [];
    object.forEach(function (child) {
      payload = payload.concat(_encode(child));
    });

    if (payload.length <= 55) {
      payload.unshift(0xc0 + payload.length);
      return payload;
    }

    var _length = arrayifyInteger(payload.length);

    _length.unshift(0xf7 + _length.length);

    return _length.concat(payload);
  }

  if (!(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.isBytesLike)(object)) {
    logger.throwArgumentError("RLP object must be BytesLike", "object", object);
  }

  var data = Array.prototype.slice.call((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.arrayify)(object));

  if (data.length === 1 && data[0] <= 0x7f) {
    return data;
  } else if (data.length <= 55) {
    data.unshift(0x80 + data.length);
    return data;
  }

  var length = arrayifyInteger(data.length);
  length.unshift(0xb7 + length.length);
  return length.concat(data);
}

function encode(object) {
  return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexlify)(_encode(object));
}

function _decodeChildren(data, offset, childOffset, length) {
  var result = [];

  while (childOffset < offset + 1 + length) {
    var decoded = _decode(data, childOffset);

    result.push(decoded.result);
    childOffset += decoded.consumed;

    if (childOffset > offset + 1 + length) {
      logger.throwError("child data too short", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.BUFFER_OVERRUN, {});
    }
  }

  return {
    consumed: 1 + length,
    result: result
  };
} // returns { consumed: number, result: Object }


function _decode(data, offset) {
  if (data.length === 0) {
    logger.throwError("data too short", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.BUFFER_OVERRUN, {});
  } // Array with extra length prefix


  if (data[offset] >= 0xf8) {
    var lengthLength = data[offset] - 0xf7;

    if (offset + 1 + lengthLength > data.length) {
      logger.throwError("data short segment too short", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.BUFFER_OVERRUN, {});
    }

    var length = unarrayifyInteger(data, offset + 1, lengthLength);

    if (offset + 1 + lengthLength + length > data.length) {
      logger.throwError("data long segment too short", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.BUFFER_OVERRUN, {});
    }

    return _decodeChildren(data, offset, offset + 1 + lengthLength, lengthLength + length);
  } else if (data[offset] >= 0xc0) {
    var _length2 = data[offset] - 0xc0;

    if (offset + 1 + _length2 > data.length) {
      logger.throwError("data array too short", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.BUFFER_OVERRUN, {});
    }

    return _decodeChildren(data, offset, offset + 1, _length2);
  } else if (data[offset] >= 0xb8) {
    var _lengthLength = data[offset] - 0xb7;

    if (offset + 1 + _lengthLength > data.length) {
      logger.throwError("data array too short", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.BUFFER_OVERRUN, {});
    }

    var _length3 = unarrayifyInteger(data, offset + 1, _lengthLength);

    if (offset + 1 + _lengthLength + _length3 > data.length) {
      logger.throwError("data array too short", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.BUFFER_OVERRUN, {});
    }

    var result = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexlify)(data.slice(offset + 1 + _lengthLength, offset + 1 + _lengthLength + _length3));
    return {
      consumed: 1 + _lengthLength + _length3,
      result: result
    };
  } else if (data[offset] >= 0x80) {
    var _length4 = data[offset] - 0x80;

    if (offset + 1 + _length4 > data.length) {
      logger.throwError("data too short", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.BUFFER_OVERRUN, {});
    }

    var _result = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexlify)(data.slice(offset + 1, offset + 1 + _length4));

    return {
      consumed: 1 + _length4,
      result: _result
    };
  }

  return {
    consumed: 1,
    result: (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexlify)(data[offset])
  };
}

function decode(data) {
  var bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.arrayify)(data);

  var decoded = _decode(bytes, 0);

  if (decoded.consumed !== bytes.length) {
    logger.throwArgumentError("invalid rlp data", "data", data);
  }

  return decoded.result;
}

/***/ }),

/***/ "./node_modules/@ethersproject/sha2/lib.esm/_version.js":
/*!**************************************************************!*\
  !*** ./node_modules/@ethersproject/sha2/lib.esm/_version.js ***!
  \**************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "sha2/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/sha2/lib.esm/sha2.js":
/*!**********************************************************!*\
  !*** ./node_modules/@ethersproject/sha2/lib.esm/sha2.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ripemd160": function() { return /* binding */ ripemd160; },
/* harmony export */   "sha256": function() { return /* binding */ sha256; },
/* harmony export */   "sha512": function() { return /* binding */ sha512; },
/* harmony export */   "computeHmac": function() { return /* binding */ computeHmac; }
/* harmony export */ });
/* harmony import */ var hash_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! hash.js */ "./node_modules/hash.js/lib/hash.js");
/* harmony import */ var hash_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(hash_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _types__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./types */ "./node_modules/@ethersproject/sha2/lib.esm/types.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/sha2/lib.esm/_version.js");


 //const _ripemd160 = _hash.ripemd160;





var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger(_version__WEBPACK_IMPORTED_MODULE_2__.version);
function ripemd160(data) {
  return "0x" + hash_js__WEBPACK_IMPORTED_MODULE_0___default().ripemd160().update((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(data)).digest("hex");
}
function sha256(data) {
  return "0x" + hash_js__WEBPACK_IMPORTED_MODULE_0___default().sha256().update((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(data)).digest("hex");
}
function sha512(data) {
  return "0x" + hash_js__WEBPACK_IMPORTED_MODULE_0___default().sha512().update((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(data)).digest("hex");
}
function computeHmac(algorithm, key, data) {
  if (!_types__WEBPACK_IMPORTED_MODULE_4__.SupportedAlgorithm[algorithm]) {
    logger.throwError("unsupported algorithm " + algorithm, _ethersproject_logger__WEBPACK_IMPORTED_MODULE_1__.Logger.errors.UNSUPPORTED_OPERATION, {
      operation: "hmac",
      algorithm: algorithm
    });
  }

  return "0x" + hash_js__WEBPACK_IMPORTED_MODULE_0___default().hmac((hash_js__WEBPACK_IMPORTED_MODULE_0___default())[algorithm], (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(key)).update((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_3__.arrayify)(data)).digest("hex");
}

/***/ }),

/***/ "./node_modules/@ethersproject/sha2/lib.esm/types.js":
/*!***********************************************************!*\
  !*** ./node_modules/@ethersproject/sha2/lib.esm/types.js ***!
  \***********************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "SupportedAlgorithm": function() { return /* binding */ SupportedAlgorithm; }
/* harmony export */ });
var SupportedAlgorithm;

(function (SupportedAlgorithm) {
  SupportedAlgorithm["sha256"] = "sha256";
  SupportedAlgorithm["sha512"] = "sha512";
})(SupportedAlgorithm || (SupportedAlgorithm = {}));

;

/***/ }),

/***/ "./node_modules/@ethersproject/signing-key/lib.esm/_version.js":
/*!*********************************************************************!*\
  !*** ./node_modules/@ethersproject/signing-key/lib.esm/_version.js ***!
  \*********************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "signing-key/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/signing-key/lib.esm/elliptic.js":
/*!*********************************************************************!*\
  !*** ./node_modules/@ethersproject/signing-key/lib.esm/elliptic.js ***!
  \*********************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "EC": function() { return /* binding */ EC$1; }
/* harmony export */ });
/* harmony import */ var bn_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! bn.js */ "./node_modules/bn.js/lib/bn.js");
/* harmony import */ var bn_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(bn_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var hash_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! hash.js */ "./node_modules/hash.js/lib/hash.js");
/* harmony import */ var hash_js__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(hash_js__WEBPACK_IMPORTED_MODULE_1__);
function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }



var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof __webpack_require__.g !== 'undefined' ? __webpack_require__.g : typeof self !== 'undefined' ? self : {};

function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, basedir, module) {
  return module = {
    path: basedir,
    exports: {},
    require: function require(path, base) {
      return commonjsRequire(path, base === undefined || base === null ? module.path : base);
    }
  }, fn(module, module.exports), module.exports;
}

function getDefaultExportFromNamespaceIfPresent(n) {
  return n && Object.prototype.hasOwnProperty.call(n, 'default') ? n['default'] : n;
}

function getDefaultExportFromNamespaceIfNotNamed(n) {
  return n && Object.prototype.hasOwnProperty.call(n, 'default') && Object.keys(n).length === 1 ? n['default'] : n;
}

function getAugmentedNamespace(n) {
  if (n.__esModule) return n;
  var a = Object.defineProperty({}, '__esModule', {
    value: true
  });
  Object.keys(n).forEach(function (k) {
    var d = Object.getOwnPropertyDescriptor(n, k);
    Object.defineProperty(a, k, d.get ? d : {
      enumerable: true,
      get: function get() {
        return n[k];
      }
    });
  });
  return a;
}

function commonjsRequire() {
  throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
}

var minimalisticAssert = assert;

function assert(val, msg) {
  if (!val) throw new Error(msg || 'Assertion failed');
}

assert.equal = function assertEqual(l, r, msg) {
  if (l != r) throw new Error(msg || 'Assertion failed: ' + l + ' != ' + r);
};

var utils_1 = createCommonjsModule(function (module, exports) {
  'use strict';

  var utils = exports;

  function toArray(msg, enc) {
    if (Array.isArray(msg)) return msg.slice();
    if (!msg) return [];
    var res = [];

    if (typeof msg !== 'string') {
      for (var i = 0; i < msg.length; i++) {
        res[i] = msg[i] | 0;
      }

      return res;
    }

    if (enc === 'hex') {
      msg = msg.replace(/[^a-z0-9]+/ig, '');
      if (msg.length % 2 !== 0) msg = '0' + msg;

      for (var i = 0; i < msg.length; i += 2) {
        res.push(parseInt(msg[i] + msg[i + 1], 16));
      }
    } else {
      for (var i = 0; i < msg.length; i++) {
        var c = msg.charCodeAt(i);
        var hi = c >> 8;
        var lo = c & 0xff;
        if (hi) res.push(hi, lo);else res.push(lo);
      }
    }

    return res;
  }

  utils.toArray = toArray;

  function zero2(word) {
    if (word.length === 1) return '0' + word;else return word;
  }

  utils.zero2 = zero2;

  function toHex(msg) {
    var res = '';

    for (var i = 0; i < msg.length; i++) {
      res += zero2(msg[i].toString(16));
    }

    return res;
  }

  utils.toHex = toHex;

  utils.encode = function encode(arr, enc) {
    if (enc === 'hex') return toHex(arr);else return arr;
  };
});
var utils_1$1 = createCommonjsModule(function (module, exports) {
  'use strict';

  var utils = exports;
  utils.assert = minimalisticAssert;
  utils.toArray = utils_1.toArray;
  utils.zero2 = utils_1.zero2;
  utils.toHex = utils_1.toHex;
  utils.encode = utils_1.encode; // Represent num in a w-NAF form

  function getNAF(num, w, bits) {
    var naf = new Array(Math.max(num.bitLength(), bits) + 1);
    naf.fill(0);
    var ws = 1 << w + 1;
    var k = num.clone();

    for (var i = 0; i < naf.length; i++) {
      var z;
      var mod = k.andln(ws - 1);

      if (k.isOdd()) {
        if (mod > (ws >> 1) - 1) z = (ws >> 1) - mod;else z = mod;
        k.isubn(z);
      } else {
        z = 0;
      }

      naf[i] = z;
      k.iushrn(1);
    }

    return naf;
  }

  utils.getNAF = getNAF; // Represent k1, k2 in a Joint Sparse Form

  function getJSF(k1, k2) {
    var jsf = [[], []];
    k1 = k1.clone();
    k2 = k2.clone();
    var d1 = 0;
    var d2 = 0;
    var m8;

    while (k1.cmpn(-d1) > 0 || k2.cmpn(-d2) > 0) {
      // First phase
      var m14 = k1.andln(3) + d1 & 3;
      var m24 = k2.andln(3) + d2 & 3;
      if (m14 === 3) m14 = -1;
      if (m24 === 3) m24 = -1;
      var u1;

      if ((m14 & 1) === 0) {
        u1 = 0;
      } else {
        m8 = k1.andln(7) + d1 & 7;
        if ((m8 === 3 || m8 === 5) && m24 === 2) u1 = -m14;else u1 = m14;
      }

      jsf[0].push(u1);
      var u2;

      if ((m24 & 1) === 0) {
        u2 = 0;
      } else {
        m8 = k2.andln(7) + d2 & 7;
        if ((m8 === 3 || m8 === 5) && m14 === 2) u2 = -m24;else u2 = m24;
      }

      jsf[1].push(u2); // Second phase

      if (2 * d1 === u1 + 1) d1 = 1 - d1;
      if (2 * d2 === u2 + 1) d2 = 1 - d2;
      k1.iushrn(1);
      k2.iushrn(1);
    }

    return jsf;
  }

  utils.getJSF = getJSF;

  function cachedProperty(obj, name, computer) {
    var key = '_' + name;

    obj.prototype[name] = function cachedProperty() {
      return this[key] !== undefined ? this[key] : this[key] = computer.call(this);
    };
  }

  utils.cachedProperty = cachedProperty;

  function parseBytes(bytes) {
    return typeof bytes === 'string' ? utils.toArray(bytes, 'hex') : bytes;
  }

  utils.parseBytes = parseBytes;

  function intFromLE(bytes) {
    return new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(bytes, 'hex', 'le');
  }

  utils.intFromLE = intFromLE;
});
'use strict';

var getNAF = utils_1$1.getNAF;
var getJSF = utils_1$1.getJSF;
var assert$1 = utils_1$1.assert;

function BaseCurve(type, conf) {
  this.type = type;
  this.p = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(conf.p, 16); // Use Montgomery, when there is no fast reduction for the prime

  this.red = conf.prime ? bn_js__WEBPACK_IMPORTED_MODULE_0___default().red(conf.prime) : bn_js__WEBPACK_IMPORTED_MODULE_0___default().mont(this.p); // Useful for many curves

  this.zero = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(0).toRed(this.red);
  this.one = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(1).toRed(this.red);
  this.two = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(2).toRed(this.red); // Curve configuration, optional

  this.n = conf.n && new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(conf.n, 16);
  this.g = conf.g && this.pointFromJSON(conf.g, conf.gRed); // Temporary arrays

  this._wnafT1 = new Array(4);
  this._wnafT2 = new Array(4);
  this._wnafT3 = new Array(4);
  this._wnafT4 = new Array(4);
  this._bitLength = this.n ? this.n.bitLength() : 0; // Generalized Greg Maxwell's trick

  var adjustCount = this.n && this.p.div(this.n);

  if (!adjustCount || adjustCount.cmpn(100) > 0) {
    this.redN = null;
  } else {
    this._maxwellTrick = true;
    this.redN = this.n.toRed(this.red);
  }
}

var base = BaseCurve;

BaseCurve.prototype.point = function point() {
  throw new Error('Not implemented');
};

BaseCurve.prototype.validate = function validate() {
  throw new Error('Not implemented');
};

BaseCurve.prototype._fixedNafMul = function _fixedNafMul(p, k) {
  assert$1(p.precomputed);

  var doubles = p._getDoubles();

  var naf = getNAF(k, 1, this._bitLength);
  var I = (1 << doubles.step + 1) - (doubles.step % 2 === 0 ? 2 : 1);
  I /= 3; // Translate into more windowed form

  var repr = [];
  var j;
  var nafW;

  for (j = 0; j < naf.length; j += doubles.step) {
    nafW = 0;

    for (var l = j + doubles.step - 1; l >= j; l--) {
      nafW = (nafW << 1) + naf[l];
    }

    repr.push(nafW);
  }

  var a = this.jpoint(null, null, null);
  var b = this.jpoint(null, null, null);

  for (var i = I; i > 0; i--) {
    for (j = 0; j < repr.length; j++) {
      nafW = repr[j];
      if (nafW === i) b = b.mixedAdd(doubles.points[j]);else if (nafW === -i) b = b.mixedAdd(doubles.points[j].neg());
    }

    a = a.add(b);
  }

  return a.toP();
};

BaseCurve.prototype._wnafMul = function _wnafMul(p, k) {
  var w = 4; // Precompute window

  var nafPoints = p._getNAFPoints(w);

  w = nafPoints.wnd;
  var wnd = nafPoints.points; // Get NAF form

  var naf = getNAF(k, w, this._bitLength); // Add `this`*(N+1) for every w-NAF index

  var acc = this.jpoint(null, null, null);

  for (var i = naf.length - 1; i >= 0; i--) {
    // Count zeroes
    for (var l = 0; i >= 0 && naf[i] === 0; i--) {
      l++;
    }

    if (i >= 0) l++;
    acc = acc.dblp(l);
    if (i < 0) break;
    var z = naf[i];
    assert$1(z !== 0);

    if (p.type === 'affine') {
      // J +- P
      if (z > 0) acc = acc.mixedAdd(wnd[z - 1 >> 1]);else acc = acc.mixedAdd(wnd[-z - 1 >> 1].neg());
    } else {
      // J +- J
      if (z > 0) acc = acc.add(wnd[z - 1 >> 1]);else acc = acc.add(wnd[-z - 1 >> 1].neg());
    }
  }

  return p.type === 'affine' ? acc.toP() : acc;
};

BaseCurve.prototype._wnafMulAdd = function _wnafMulAdd(defW, points, coeffs, len, jacobianResult) {
  var wndWidth = this._wnafT1;
  var wnd = this._wnafT2;
  var naf = this._wnafT3; // Fill all arrays

  var max = 0;
  var i;
  var j;
  var p;

  for (i = 0; i < len; i++) {
    p = points[i];

    var nafPoints = p._getNAFPoints(defW);

    wndWidth[i] = nafPoints.wnd;
    wnd[i] = nafPoints.points;
  } // Comb small window NAFs


  for (i = len - 1; i >= 1; i -= 2) {
    var a = i - 1;
    var b = i;

    if (wndWidth[a] !== 1 || wndWidth[b] !== 1) {
      naf[a] = getNAF(coeffs[a], wndWidth[a], this._bitLength);
      naf[b] = getNAF(coeffs[b], wndWidth[b], this._bitLength);
      max = Math.max(naf[a].length, max);
      max = Math.max(naf[b].length, max);
      continue;
    }

    var comb = [points[a],
    /* 1 */
    null,
    /* 3 */
    null,
    /* 5 */
    points[b]
    /* 7 */
    ]; // Try to avoid Projective points, if possible

    if (points[a].y.cmp(points[b].y) === 0) {
      comb[1] = points[a].add(points[b]);
      comb[2] = points[a].toJ().mixedAdd(points[b].neg());
    } else if (points[a].y.cmp(points[b].y.redNeg()) === 0) {
      comb[1] = points[a].toJ().mixedAdd(points[b]);
      comb[2] = points[a].add(points[b].neg());
    } else {
      comb[1] = points[a].toJ().mixedAdd(points[b]);
      comb[2] = points[a].toJ().mixedAdd(points[b].neg());
    }

    var index = [-3,
    /* -1 -1 */
    -1,
    /* -1 0 */
    -5,
    /* -1 1 */
    -7,
    /* 0 -1 */
    0,
    /* 0 0 */
    7,
    /* 0 1 */
    5,
    /* 1 -1 */
    1,
    /* 1 0 */
    3
    /* 1 1 */
    ];
    var jsf = getJSF(coeffs[a], coeffs[b]);
    max = Math.max(jsf[0].length, max);
    naf[a] = new Array(max);
    naf[b] = new Array(max);

    for (j = 0; j < max; j++) {
      var ja = jsf[0][j] | 0;
      var jb = jsf[1][j] | 0;
      naf[a][j] = index[(ja + 1) * 3 + (jb + 1)];
      naf[b][j] = 0;
      wnd[a] = comb;
    }
  }

  var acc = this.jpoint(null, null, null);
  var tmp = this._wnafT4;

  for (i = max; i >= 0; i--) {
    var k = 0;

    while (i >= 0) {
      var zero = true;

      for (j = 0; j < len; j++) {
        tmp[j] = naf[j][i] | 0;
        if (tmp[j] !== 0) zero = false;
      }

      if (!zero) break;
      k++;
      i--;
    }

    if (i >= 0) k++;
    acc = acc.dblp(k);
    if (i < 0) break;

    for (j = 0; j < len; j++) {
      var z = tmp[j];
      p;
      if (z === 0) continue;else if (z > 0) p = wnd[j][z - 1 >> 1];else if (z < 0) p = wnd[j][-z - 1 >> 1].neg();
      if (p.type === 'affine') acc = acc.mixedAdd(p);else acc = acc.add(p);
    }
  } // Zeroify references


  for (i = 0; i < len; i++) {
    wnd[i] = null;
  }

  if (jacobianResult) return acc;else return acc.toP();
};

function BasePoint(curve, type) {
  this.curve = curve;
  this.type = type;
  this.precomputed = null;
}

BaseCurve.BasePoint = BasePoint;

BasePoint.prototype.eq = function eq()
/*other*/
{
  throw new Error('Not implemented');
};

BasePoint.prototype.validate = function validate() {
  return this.curve.validate(this);
};

BaseCurve.prototype.decodePoint = function decodePoint(bytes, enc) {
  bytes = utils_1$1.toArray(bytes, enc);
  var len = this.p.byteLength(); // uncompressed, hybrid-odd, hybrid-even

  if ((bytes[0] === 0x04 || bytes[0] === 0x06 || bytes[0] === 0x07) && bytes.length - 1 === 2 * len) {
    if (bytes[0] === 0x06) assert$1(bytes[bytes.length - 1] % 2 === 0);else if (bytes[0] === 0x07) assert$1(bytes[bytes.length - 1] % 2 === 1);
    var res = this.point(bytes.slice(1, 1 + len), bytes.slice(1 + len, 1 + 2 * len));
    return res;
  } else if ((bytes[0] === 0x02 || bytes[0] === 0x03) && bytes.length - 1 === len) {
    return this.pointFromX(bytes.slice(1, 1 + len), bytes[0] === 0x03);
  }

  throw new Error('Unknown point format');
};

BasePoint.prototype.encodeCompressed = function encodeCompressed(enc) {
  return this.encode(enc, true);
};

BasePoint.prototype._encode = function _encode(compact) {
  var len = this.curve.p.byteLength();
  var x = this.getX().toArray('be', len);
  if (compact) return [this.getY().isEven() ? 0x02 : 0x03].concat(x);
  return [0x04].concat(x, this.getY().toArray('be', len));
};

BasePoint.prototype.encode = function encode(enc, compact) {
  return utils_1$1.encode(this._encode(compact), enc);
};

BasePoint.prototype.precompute = function precompute(power) {
  if (this.precomputed) return this;
  var precomputed = {
    doubles: null,
    naf: null,
    beta: null
  };
  precomputed.naf = this._getNAFPoints(8);
  precomputed.doubles = this._getDoubles(4, power);
  precomputed.beta = this._getBeta();
  this.precomputed = precomputed;
  return this;
};

BasePoint.prototype._hasDoubles = function _hasDoubles(k) {
  if (!this.precomputed) return false;
  var doubles = this.precomputed.doubles;
  if (!doubles) return false;
  return doubles.points.length >= Math.ceil((k.bitLength() + 1) / doubles.step);
};

BasePoint.prototype._getDoubles = function _getDoubles(step, power) {
  if (this.precomputed && this.precomputed.doubles) return this.precomputed.doubles;
  var doubles = [this];
  var acc = this;

  for (var i = 0; i < power; i += step) {
    for (var j = 0; j < step; j++) {
      acc = acc.dbl();
    }

    doubles.push(acc);
  }

  return {
    step: step,
    points: doubles
  };
};

BasePoint.prototype._getNAFPoints = function _getNAFPoints(wnd) {
  if (this.precomputed && this.precomputed.naf) return this.precomputed.naf;
  var res = [this];
  var max = (1 << wnd) - 1;
  var dbl = max === 1 ? null : this.dbl();

  for (var i = 1; i < max; i++) {
    res[i] = res[i - 1].add(dbl);
  }

  return {
    wnd: wnd,
    points: res
  };
};

BasePoint.prototype._getBeta = function _getBeta() {
  return null;
};

BasePoint.prototype.dblp = function dblp(k) {
  var r = this;

  for (var i = 0; i < k; i++) {
    r = r.dbl();
  }

  return r;
};

var inherits_browser = createCommonjsModule(function (module) {
  if (typeof Object.create === 'function') {
    // implementation from standard node.js 'util' module
    module.exports = function inherits(ctor, superCtor) {
      if (superCtor) {
        ctor.super_ = superCtor;
        ctor.prototype = Object.create(superCtor.prototype, {
          constructor: {
            value: ctor,
            enumerable: false,
            writable: true,
            configurable: true
          }
        });
      }
    };
  } else {
    // old school shim for old browsers
    module.exports = function inherits(ctor, superCtor) {
      if (superCtor) {
        ctor.super_ = superCtor;

        var TempCtor = function TempCtor() {};

        TempCtor.prototype = superCtor.prototype;
        ctor.prototype = new TempCtor();
        ctor.prototype.constructor = ctor;
      }
    };
  }
});
'use strict';

var assert$2 = utils_1$1.assert;

function ShortCurve(conf) {
  base.call(this, 'short', conf);
  this.a = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(conf.a, 16).toRed(this.red);
  this.b = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(conf.b, 16).toRed(this.red);
  this.tinv = this.two.redInvm();
  this.zeroA = this.a.fromRed().cmpn(0) === 0;
  this.threeA = this.a.fromRed().sub(this.p).cmpn(-3) === 0; // If the curve is endomorphic, precalculate beta and lambda

  this.endo = this._getEndomorphism(conf);
  this._endoWnafT1 = new Array(4);
  this._endoWnafT2 = new Array(4);
}

inherits_browser(ShortCurve, base);
var short_1 = ShortCurve;

ShortCurve.prototype._getEndomorphism = function _getEndomorphism(conf) {
  // No efficient endomorphism
  if (!this.zeroA || !this.g || !this.n || this.p.modn(3) !== 1) return; // Compute beta and lambda, that lambda * P = (beta * Px; Py)

  var beta;
  var lambda;

  if (conf.beta) {
    beta = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(conf.beta, 16).toRed(this.red);
  } else {
    var betas = this._getEndoRoots(this.p); // Choose the smallest beta


    beta = betas[0].cmp(betas[1]) < 0 ? betas[0] : betas[1];
    beta = beta.toRed(this.red);
  }

  if (conf.lambda) {
    lambda = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(conf.lambda, 16);
  } else {
    // Choose the lambda that is matching selected beta
    var lambdas = this._getEndoRoots(this.n);

    if (this.g.mul(lambdas[0]).x.cmp(this.g.x.redMul(beta)) === 0) {
      lambda = lambdas[0];
    } else {
      lambda = lambdas[1];
      assert$2(this.g.mul(lambda).x.cmp(this.g.x.redMul(beta)) === 0);
    }
  } // Get basis vectors, used for balanced length-two representation


  var basis;

  if (conf.basis) {
    basis = conf.basis.map(function (vec) {
      return {
        a: new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(vec.a, 16),
        b: new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(vec.b, 16)
      };
    });
  } else {
    basis = this._getEndoBasis(lambda);
  }

  return {
    beta: beta,
    lambda: lambda,
    basis: basis
  };
};

ShortCurve.prototype._getEndoRoots = function _getEndoRoots(num) {
  // Find roots of for x^2 + x + 1 in F
  // Root = (-1 +- Sqrt(-3)) / 2
  //
  var red = num === this.p ? this.red : bn_js__WEBPACK_IMPORTED_MODULE_0___default().mont(num);
  var tinv = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(2).toRed(red).redInvm();
  var ntinv = tinv.redNeg();
  var s = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(3).toRed(red).redNeg().redSqrt().redMul(tinv);
  var l1 = ntinv.redAdd(s).fromRed();
  var l2 = ntinv.redSub(s).fromRed();
  return [l1, l2];
};

ShortCurve.prototype._getEndoBasis = function _getEndoBasis(lambda) {
  // aprxSqrt >= sqrt(this.n)
  var aprxSqrt = this.n.ushrn(Math.floor(this.n.bitLength() / 2)); // 3.74
  // Run EGCD, until r(L + 1) < aprxSqrt

  var u = lambda;
  var v = this.n.clone();
  var x1 = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(1);
  var y1 = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(0);
  var x2 = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(0);
  var y2 = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(1); // NOTE: all vectors are roots of: a + b * lambda = 0 (mod n)

  var a0;
  var b0; // First vector

  var a1;
  var b1; // Second vector

  var a2;
  var b2;
  var prevR;
  var i = 0;
  var r;
  var x;

  while (u.cmpn(0) !== 0) {
    var q = v.div(u);
    r = v.sub(q.mul(u));
    x = x2.sub(q.mul(x1));
    var y = y2.sub(q.mul(y1));

    if (!a1 && r.cmp(aprxSqrt) < 0) {
      a0 = prevR.neg();
      b0 = x1;
      a1 = r.neg();
      b1 = x;
    } else if (a1 && ++i === 2) {
      break;
    }

    prevR = r;
    v = u;
    u = r;
    x2 = x1;
    x1 = x;
    y2 = y1;
    y1 = y;
  }

  a2 = r.neg();
  b2 = x;
  var len1 = a1.sqr().add(b1.sqr());
  var len2 = a2.sqr().add(b2.sqr());

  if (len2.cmp(len1) >= 0) {
    a2 = a0;
    b2 = b0;
  } // Normalize signs


  if (a1.negative) {
    a1 = a1.neg();
    b1 = b1.neg();
  }

  if (a2.negative) {
    a2 = a2.neg();
    b2 = b2.neg();
  }

  return [{
    a: a1,
    b: b1
  }, {
    a: a2,
    b: b2
  }];
};

ShortCurve.prototype._endoSplit = function _endoSplit(k) {
  var basis = this.endo.basis;
  var v1 = basis[0];
  var v2 = basis[1];
  var c1 = v2.b.mul(k).divRound(this.n);
  var c2 = v1.b.neg().mul(k).divRound(this.n);
  var p1 = c1.mul(v1.a);
  var p2 = c2.mul(v2.a);
  var q1 = c1.mul(v1.b);
  var q2 = c2.mul(v2.b); // Calculate answer

  var k1 = k.sub(p1).sub(p2);
  var k2 = q1.add(q2).neg();
  return {
    k1: k1,
    k2: k2
  };
};

ShortCurve.prototype.pointFromX = function pointFromX(x, odd) {
  x = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(x, 16);
  if (!x.red) x = x.toRed(this.red);
  var y2 = x.redSqr().redMul(x).redIAdd(x.redMul(this.a)).redIAdd(this.b);
  var y = y2.redSqrt();
  if (y.redSqr().redSub(y2).cmp(this.zero) !== 0) throw new Error('invalid point'); // XXX Is there any way to tell if the number is odd without converting it
  // to non-red form?

  var isOdd = y.fromRed().isOdd();
  if (odd && !isOdd || !odd && isOdd) y = y.redNeg();
  return this.point(x, y);
};

ShortCurve.prototype.validate = function validate(point) {
  if (point.inf) return true;
  var x = point.x;
  var y = point.y;
  var ax = this.a.redMul(x);
  var rhs = x.redSqr().redMul(x).redIAdd(ax).redIAdd(this.b);
  return y.redSqr().redISub(rhs).cmpn(0) === 0;
};

ShortCurve.prototype._endoWnafMulAdd = function _endoWnafMulAdd(points, coeffs, jacobianResult) {
  var npoints = this._endoWnafT1;
  var ncoeffs = this._endoWnafT2;

  for (var i = 0; i < points.length; i++) {
    var split = this._endoSplit(coeffs[i]);

    var p = points[i];

    var beta = p._getBeta();

    if (split.k1.negative) {
      split.k1.ineg();
      p = p.neg(true);
    }

    if (split.k2.negative) {
      split.k2.ineg();
      beta = beta.neg(true);
    }

    npoints[i * 2] = p;
    npoints[i * 2 + 1] = beta;
    ncoeffs[i * 2] = split.k1;
    ncoeffs[i * 2 + 1] = split.k2;
  }

  var res = this._wnafMulAdd(1, npoints, ncoeffs, i * 2, jacobianResult); // Clean-up references to points and coefficients


  for (var j = 0; j < i * 2; j++) {
    npoints[j] = null;
    ncoeffs[j] = null;
  }

  return res;
};

function Point(curve, x, y, isRed) {
  base.BasePoint.call(this, curve, 'affine');

  if (x === null && y === null) {
    this.x = null;
    this.y = null;
    this.inf = true;
  } else {
    this.x = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(x, 16);
    this.y = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(y, 16); // Force redgomery representation when loading from JSON

    if (isRed) {
      this.x.forceRed(this.curve.red);
      this.y.forceRed(this.curve.red);
    }

    if (!this.x.red) this.x = this.x.toRed(this.curve.red);
    if (!this.y.red) this.y = this.y.toRed(this.curve.red);
    this.inf = false;
  }
}

inherits_browser(Point, base.BasePoint);

ShortCurve.prototype.point = function point(x, y, isRed) {
  return new Point(this, x, y, isRed);
};

ShortCurve.prototype.pointFromJSON = function pointFromJSON(obj, red) {
  return Point.fromJSON(this, obj, red);
};

Point.prototype._getBeta = function _getBeta() {
  if (!this.curve.endo) return;
  var pre = this.precomputed;
  if (pre && pre.beta) return pre.beta;
  var beta = this.curve.point(this.x.redMul(this.curve.endo.beta), this.y);

  if (pre) {
    var curve = this.curve;

    var endoMul = function endoMul(p) {
      return curve.point(p.x.redMul(curve.endo.beta), p.y);
    };

    pre.beta = beta;
    beta.precomputed = {
      beta: null,
      naf: pre.naf && {
        wnd: pre.naf.wnd,
        points: pre.naf.points.map(endoMul)
      },
      doubles: pre.doubles && {
        step: pre.doubles.step,
        points: pre.doubles.points.map(endoMul)
      }
    };
  }

  return beta;
};

Point.prototype.toJSON = function toJSON() {
  if (!this.precomputed) return [this.x, this.y];
  return [this.x, this.y, this.precomputed && {
    doubles: this.precomputed.doubles && {
      step: this.precomputed.doubles.step,
      points: this.precomputed.doubles.points.slice(1)
    },
    naf: this.precomputed.naf && {
      wnd: this.precomputed.naf.wnd,
      points: this.precomputed.naf.points.slice(1)
    }
  }];
};

Point.fromJSON = function fromJSON(curve, obj, red) {
  if (typeof obj === 'string') obj = JSON.parse(obj);
  var res = curve.point(obj[0], obj[1], red);
  if (!obj[2]) return res;

  function obj2point(obj) {
    return curve.point(obj[0], obj[1], red);
  }

  var pre = obj[2];
  res.precomputed = {
    beta: null,
    doubles: pre.doubles && {
      step: pre.doubles.step,
      points: [res].concat(pre.doubles.points.map(obj2point))
    },
    naf: pre.naf && {
      wnd: pre.naf.wnd,
      points: [res].concat(pre.naf.points.map(obj2point))
    }
  };
  return res;
};

Point.prototype.inspect = function inspect() {
  if (this.isInfinity()) return '<EC Point Infinity>';
  return '<EC Point x: ' + this.x.fromRed().toString(16, 2) + ' y: ' + this.y.fromRed().toString(16, 2) + '>';
};

Point.prototype.isInfinity = function isInfinity() {
  return this.inf;
};

Point.prototype.add = function add(p) {
  // O + P = P
  if (this.inf) return p; // P + O = P

  if (p.inf) return this; // P + P = 2P

  if (this.eq(p)) return this.dbl(); // P + (-P) = O

  if (this.neg().eq(p)) return this.curve.point(null, null); // P + Q = O

  if (this.x.cmp(p.x) === 0) return this.curve.point(null, null);
  var c = this.y.redSub(p.y);
  if (c.cmpn(0) !== 0) c = c.redMul(this.x.redSub(p.x).redInvm());
  var nx = c.redSqr().redISub(this.x).redISub(p.x);
  var ny = c.redMul(this.x.redSub(nx)).redISub(this.y);
  return this.curve.point(nx, ny);
};

Point.prototype.dbl = function dbl() {
  if (this.inf) return this; // 2P = O

  var ys1 = this.y.redAdd(this.y);
  if (ys1.cmpn(0) === 0) return this.curve.point(null, null);
  var a = this.curve.a;
  var x2 = this.x.redSqr();
  var dyinv = ys1.redInvm();
  var c = x2.redAdd(x2).redIAdd(x2).redIAdd(a).redMul(dyinv);
  var nx = c.redSqr().redISub(this.x.redAdd(this.x));
  var ny = c.redMul(this.x.redSub(nx)).redISub(this.y);
  return this.curve.point(nx, ny);
};

Point.prototype.getX = function getX() {
  return this.x.fromRed();
};

Point.prototype.getY = function getY() {
  return this.y.fromRed();
};

Point.prototype.mul = function mul(k) {
  k = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(k, 16);
  if (this.isInfinity()) return this;else if (this._hasDoubles(k)) return this.curve._fixedNafMul(this, k);else if (this.curve.endo) return this.curve._endoWnafMulAdd([this], [k]);else return this.curve._wnafMul(this, k);
};

Point.prototype.mulAdd = function mulAdd(k1, p2, k2) {
  var points = [this, p2];
  var coeffs = [k1, k2];
  if (this.curve.endo) return this.curve._endoWnafMulAdd(points, coeffs);else return this.curve._wnafMulAdd(1, points, coeffs, 2);
};

Point.prototype.jmulAdd = function jmulAdd(k1, p2, k2) {
  var points = [this, p2];
  var coeffs = [k1, k2];
  if (this.curve.endo) return this.curve._endoWnafMulAdd(points, coeffs, true);else return this.curve._wnafMulAdd(1, points, coeffs, 2, true);
};

Point.prototype.eq = function eq(p) {
  return this === p || this.inf === p.inf && (this.inf || this.x.cmp(p.x) === 0 && this.y.cmp(p.y) === 0);
};

Point.prototype.neg = function neg(_precompute) {
  if (this.inf) return this;
  var res = this.curve.point(this.x, this.y.redNeg());

  if (_precompute && this.precomputed) {
    var pre = this.precomputed;

    var negate = function negate(p) {
      return p.neg();
    };

    res.precomputed = {
      naf: pre.naf && {
        wnd: pre.naf.wnd,
        points: pre.naf.points.map(negate)
      },
      doubles: pre.doubles && {
        step: pre.doubles.step,
        points: pre.doubles.points.map(negate)
      }
    };
  }

  return res;
};

Point.prototype.toJ = function toJ() {
  if (this.inf) return this.curve.jpoint(null, null, null);
  var res = this.curve.jpoint(this.x, this.y, this.curve.one);
  return res;
};

function JPoint(curve, x, y, z) {
  base.BasePoint.call(this, curve, 'jacobian');

  if (x === null && y === null && z === null) {
    this.x = this.curve.one;
    this.y = this.curve.one;
    this.z = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(0);
  } else {
    this.x = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(x, 16);
    this.y = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(y, 16);
    this.z = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(z, 16);
  }

  if (!this.x.red) this.x = this.x.toRed(this.curve.red);
  if (!this.y.red) this.y = this.y.toRed(this.curve.red);
  if (!this.z.red) this.z = this.z.toRed(this.curve.red);
  this.zOne = this.z === this.curve.one;
}

inherits_browser(JPoint, base.BasePoint);

ShortCurve.prototype.jpoint = function jpoint(x, y, z) {
  return new JPoint(this, x, y, z);
};

JPoint.prototype.toP = function toP() {
  if (this.isInfinity()) return this.curve.point(null, null);
  var zinv = this.z.redInvm();
  var zinv2 = zinv.redSqr();
  var ax = this.x.redMul(zinv2);
  var ay = this.y.redMul(zinv2).redMul(zinv);
  return this.curve.point(ax, ay);
};

JPoint.prototype.neg = function neg() {
  return this.curve.jpoint(this.x, this.y.redNeg(), this.z);
};

JPoint.prototype.add = function add(p) {
  // O + P = P
  if (this.isInfinity()) return p; // P + O = P

  if (p.isInfinity()) return this; // 12M + 4S + 7A

  var pz2 = p.z.redSqr();
  var z2 = this.z.redSqr();
  var u1 = this.x.redMul(pz2);
  var u2 = p.x.redMul(z2);
  var s1 = this.y.redMul(pz2.redMul(p.z));
  var s2 = p.y.redMul(z2.redMul(this.z));
  var h = u1.redSub(u2);
  var r = s1.redSub(s2);

  if (h.cmpn(0) === 0) {
    if (r.cmpn(0) !== 0) return this.curve.jpoint(null, null, null);else return this.dbl();
  }

  var h2 = h.redSqr();
  var h3 = h2.redMul(h);
  var v = u1.redMul(h2);
  var nx = r.redSqr().redIAdd(h3).redISub(v).redISub(v);
  var ny = r.redMul(v.redISub(nx)).redISub(s1.redMul(h3));
  var nz = this.z.redMul(p.z).redMul(h);
  return this.curve.jpoint(nx, ny, nz);
};

JPoint.prototype.mixedAdd = function mixedAdd(p) {
  // O + P = P
  if (this.isInfinity()) return p.toJ(); // P + O = P

  if (p.isInfinity()) return this; // 8M + 3S + 7A

  var z2 = this.z.redSqr();
  var u1 = this.x;
  var u2 = p.x.redMul(z2);
  var s1 = this.y;
  var s2 = p.y.redMul(z2).redMul(this.z);
  var h = u1.redSub(u2);
  var r = s1.redSub(s2);

  if (h.cmpn(0) === 0) {
    if (r.cmpn(0) !== 0) return this.curve.jpoint(null, null, null);else return this.dbl();
  }

  var h2 = h.redSqr();
  var h3 = h2.redMul(h);
  var v = u1.redMul(h2);
  var nx = r.redSqr().redIAdd(h3).redISub(v).redISub(v);
  var ny = r.redMul(v.redISub(nx)).redISub(s1.redMul(h3));
  var nz = this.z.redMul(h);
  return this.curve.jpoint(nx, ny, nz);
};

JPoint.prototype.dblp = function dblp(pow) {
  if (pow === 0) return this;
  if (this.isInfinity()) return this;
  if (!pow) return this.dbl();
  var i;

  if (this.curve.zeroA || this.curve.threeA) {
    var r = this;

    for (i = 0; i < pow; i++) {
      r = r.dbl();
    }

    return r;
  } // 1M + 2S + 1A + N * (4S + 5M + 8A)
  // N = 1 => 6M + 6S + 9A


  var a = this.curve.a;
  var tinv = this.curve.tinv;
  var jx = this.x;
  var jy = this.y;
  var jz = this.z;
  var jz4 = jz.redSqr().redSqr(); // Reuse results

  var jyd = jy.redAdd(jy);

  for (i = 0; i < pow; i++) {
    var jx2 = jx.redSqr();
    var jyd2 = jyd.redSqr();
    var jyd4 = jyd2.redSqr();
    var c = jx2.redAdd(jx2).redIAdd(jx2).redIAdd(a.redMul(jz4));
    var t1 = jx.redMul(jyd2);
    var nx = c.redSqr().redISub(t1.redAdd(t1));
    var t2 = t1.redISub(nx);
    var dny = c.redMul(t2);
    dny = dny.redIAdd(dny).redISub(jyd4);
    var nz = jyd.redMul(jz);
    if (i + 1 < pow) jz4 = jz4.redMul(jyd4);
    jx = nx;
    jz = nz;
    jyd = dny;
  }

  return this.curve.jpoint(jx, jyd.redMul(tinv), jz);
};

JPoint.prototype.dbl = function dbl() {
  if (this.isInfinity()) return this;
  if (this.curve.zeroA) return this._zeroDbl();else if (this.curve.threeA) return this._threeDbl();else return this._dbl();
};

JPoint.prototype._zeroDbl = function _zeroDbl() {
  var nx;
  var ny;
  var nz; // Z = 1

  if (this.zOne) {
    // hyperelliptic.org/EFD/g1p/auto-shortw-jacobian-0.html
    //     #doubling-mdbl-2007-bl
    // 1M + 5S + 14A
    // XX = X1^2
    var xx = this.x.redSqr(); // YY = Y1^2

    var yy = this.y.redSqr(); // YYYY = YY^2

    var yyyy = yy.redSqr(); // S = 2 * ((X1 + YY)^2 - XX - YYYY)

    var s = this.x.redAdd(yy).redSqr().redISub(xx).redISub(yyyy);
    s = s.redIAdd(s); // M = 3 * XX + a; a = 0

    var m = xx.redAdd(xx).redIAdd(xx); // T = M ^ 2 - 2*S

    var t = m.redSqr().redISub(s).redISub(s); // 8 * YYYY

    var yyyy8 = yyyy.redIAdd(yyyy);
    yyyy8 = yyyy8.redIAdd(yyyy8);
    yyyy8 = yyyy8.redIAdd(yyyy8); // X3 = T

    nx = t; // Y3 = M * (S - T) - 8 * YYYY

    ny = m.redMul(s.redISub(t)).redISub(yyyy8); // Z3 = 2*Y1

    nz = this.y.redAdd(this.y);
  } else {
    // hyperelliptic.org/EFD/g1p/auto-shortw-jacobian-0.html
    //     #doubling-dbl-2009-l
    // 2M + 5S + 13A
    // A = X1^2
    var a = this.x.redSqr(); // B = Y1^2

    var b = this.y.redSqr(); // C = B^2

    var c = b.redSqr(); // D = 2 * ((X1 + B)^2 - A - C)

    var d = this.x.redAdd(b).redSqr().redISub(a).redISub(c);
    d = d.redIAdd(d); // E = 3 * A

    var e = a.redAdd(a).redIAdd(a); // F = E^2

    var f = e.redSqr(); // 8 * C

    var c8 = c.redIAdd(c);
    c8 = c8.redIAdd(c8);
    c8 = c8.redIAdd(c8); // X3 = F - 2 * D

    nx = f.redISub(d).redISub(d); // Y3 = E * (D - X3) - 8 * C

    ny = e.redMul(d.redISub(nx)).redISub(c8); // Z3 = 2 * Y1 * Z1

    nz = this.y.redMul(this.z);
    nz = nz.redIAdd(nz);
  }

  return this.curve.jpoint(nx, ny, nz);
};

JPoint.prototype._threeDbl = function _threeDbl() {
  var nx;
  var ny;
  var nz; // Z = 1

  if (this.zOne) {
    // hyperelliptic.org/EFD/g1p/auto-shortw-jacobian-3.html
    //     #doubling-mdbl-2007-bl
    // 1M + 5S + 15A
    // XX = X1^2
    var xx = this.x.redSqr(); // YY = Y1^2

    var yy = this.y.redSqr(); // YYYY = YY^2

    var yyyy = yy.redSqr(); // S = 2 * ((X1 + YY)^2 - XX - YYYY)

    var s = this.x.redAdd(yy).redSqr().redISub(xx).redISub(yyyy);
    s = s.redIAdd(s); // M = 3 * XX + a

    var m = xx.redAdd(xx).redIAdd(xx).redIAdd(this.curve.a); // T = M^2 - 2 * S

    var t = m.redSqr().redISub(s).redISub(s); // X3 = T

    nx = t; // Y3 = M * (S - T) - 8 * YYYY

    var yyyy8 = yyyy.redIAdd(yyyy);
    yyyy8 = yyyy8.redIAdd(yyyy8);
    yyyy8 = yyyy8.redIAdd(yyyy8);
    ny = m.redMul(s.redISub(t)).redISub(yyyy8); // Z3 = 2 * Y1

    nz = this.y.redAdd(this.y);
  } else {
    // hyperelliptic.org/EFD/g1p/auto-shortw-jacobian-3.html#doubling-dbl-2001-b
    // 3M + 5S
    // delta = Z1^2
    var delta = this.z.redSqr(); // gamma = Y1^2

    var gamma = this.y.redSqr(); // beta = X1 * gamma

    var beta = this.x.redMul(gamma); // alpha = 3 * (X1 - delta) * (X1 + delta)

    var alpha = this.x.redSub(delta).redMul(this.x.redAdd(delta));
    alpha = alpha.redAdd(alpha).redIAdd(alpha); // X3 = alpha^2 - 8 * beta

    var beta4 = beta.redIAdd(beta);
    beta4 = beta4.redIAdd(beta4);
    var beta8 = beta4.redAdd(beta4);
    nx = alpha.redSqr().redISub(beta8); // Z3 = (Y1 + Z1)^2 - gamma - delta

    nz = this.y.redAdd(this.z).redSqr().redISub(gamma).redISub(delta); // Y3 = alpha * (4 * beta - X3) - 8 * gamma^2

    var ggamma8 = gamma.redSqr();
    ggamma8 = ggamma8.redIAdd(ggamma8);
    ggamma8 = ggamma8.redIAdd(ggamma8);
    ggamma8 = ggamma8.redIAdd(ggamma8);
    ny = alpha.redMul(beta4.redISub(nx)).redISub(ggamma8);
  }

  return this.curve.jpoint(nx, ny, nz);
};

JPoint.prototype._dbl = function _dbl() {
  var a = this.curve.a; // 4M + 6S + 10A

  var jx = this.x;
  var jy = this.y;
  var jz = this.z;
  var jz4 = jz.redSqr().redSqr();
  var jx2 = jx.redSqr();
  var jy2 = jy.redSqr();
  var c = jx2.redAdd(jx2).redIAdd(jx2).redIAdd(a.redMul(jz4));
  var jxd4 = jx.redAdd(jx);
  jxd4 = jxd4.redIAdd(jxd4);
  var t1 = jxd4.redMul(jy2);
  var nx = c.redSqr().redISub(t1.redAdd(t1));
  var t2 = t1.redISub(nx);
  var jyd8 = jy2.redSqr();
  jyd8 = jyd8.redIAdd(jyd8);
  jyd8 = jyd8.redIAdd(jyd8);
  jyd8 = jyd8.redIAdd(jyd8);
  var ny = c.redMul(t2).redISub(jyd8);
  var nz = jy.redAdd(jy).redMul(jz);
  return this.curve.jpoint(nx, ny, nz);
};

JPoint.prototype.trpl = function trpl() {
  if (!this.curve.zeroA) return this.dbl().add(this); // hyperelliptic.org/EFD/g1p/auto-shortw-jacobian-0.html#tripling-tpl-2007-bl
  // 5M + 10S + ...
  // XX = X1^2

  var xx = this.x.redSqr(); // YY = Y1^2

  var yy = this.y.redSqr(); // ZZ = Z1^2

  var zz = this.z.redSqr(); // YYYY = YY^2

  var yyyy = yy.redSqr(); // M = 3 * XX + a * ZZ2; a = 0

  var m = xx.redAdd(xx).redIAdd(xx); // MM = M^2

  var mm = m.redSqr(); // E = 6 * ((X1 + YY)^2 - XX - YYYY) - MM

  var e = this.x.redAdd(yy).redSqr().redISub(xx).redISub(yyyy);
  e = e.redIAdd(e);
  e = e.redAdd(e).redIAdd(e);
  e = e.redISub(mm); // EE = E^2

  var ee = e.redSqr(); // T = 16*YYYY

  var t = yyyy.redIAdd(yyyy);
  t = t.redIAdd(t);
  t = t.redIAdd(t);
  t = t.redIAdd(t); // U = (M + E)^2 - MM - EE - T

  var u = m.redIAdd(e).redSqr().redISub(mm).redISub(ee).redISub(t); // X3 = 4 * (X1 * EE - 4 * YY * U)

  var yyu4 = yy.redMul(u);
  yyu4 = yyu4.redIAdd(yyu4);
  yyu4 = yyu4.redIAdd(yyu4);
  var nx = this.x.redMul(ee).redISub(yyu4);
  nx = nx.redIAdd(nx);
  nx = nx.redIAdd(nx); // Y3 = 8 * Y1 * (U * (T - U) - E * EE)

  var ny = this.y.redMul(u.redMul(t.redISub(u)).redISub(e.redMul(ee)));
  ny = ny.redIAdd(ny);
  ny = ny.redIAdd(ny);
  ny = ny.redIAdd(ny); // Z3 = (Z1 + E)^2 - ZZ - EE

  var nz = this.z.redAdd(e).redSqr().redISub(zz).redISub(ee);
  return this.curve.jpoint(nx, ny, nz);
};

JPoint.prototype.mul = function mul(k, kbase) {
  k = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(k, kbase);
  return this.curve._wnafMul(this, k);
};

JPoint.prototype.eq = function eq(p) {
  if (p.type === 'affine') return this.eq(p.toJ());
  if (this === p) return true; // x1 * z2^2 == x2 * z1^2

  var z2 = this.z.redSqr();
  var pz2 = p.z.redSqr();
  if (this.x.redMul(pz2).redISub(p.x.redMul(z2)).cmpn(0) !== 0) return false; // y1 * z2^3 == y2 * z1^3

  var z3 = z2.redMul(this.z);
  var pz3 = pz2.redMul(p.z);
  return this.y.redMul(pz3).redISub(p.y.redMul(z3)).cmpn(0) === 0;
};

JPoint.prototype.eqXToP = function eqXToP(x) {
  var zs = this.z.redSqr();
  var rx = x.toRed(this.curve.red).redMul(zs);
  if (this.x.cmp(rx) === 0) return true;
  var xc = x.clone();
  var t = this.curve.redN.redMul(zs);

  for (;;) {
    xc.iadd(this.curve.n);
    if (xc.cmp(this.curve.p) >= 0) return false;
    rx.redIAdd(t);
    if (this.x.cmp(rx) === 0) return true;
  }
};

JPoint.prototype.inspect = function inspect() {
  if (this.isInfinity()) return '<EC JPoint Infinity>';
  return '<EC JPoint x: ' + this.x.toString(16, 2) + ' y: ' + this.y.toString(16, 2) + ' z: ' + this.z.toString(16, 2) + '>';
};

JPoint.prototype.isInfinity = function isInfinity() {
  // XXX This code assumes that zero is always zero in red
  return this.z.cmpn(0) === 0;
};

var curve_1 = createCommonjsModule(function (module, exports) {
  'use strict';

  var curve = exports;
  curve.base = base;
  curve["short"] = short_1;
  curve.mont =
  /*RicMoo:ethers:require(./mont)*/
  null;
  curve.edwards =
  /*RicMoo:ethers:require(./edwards)*/
  null;
});
var curves_1 = createCommonjsModule(function (module, exports) {
  'use strict';

  var curves = exports;
  var assert = utils_1$1.assert;

  function PresetCurve(options) {
    if (options.type === 'short') this.curve = new curve_1["short"](options);else if (options.type === 'edwards') this.curve = new curve_1.edwards(options);else this.curve = new curve_1.mont(options);
    this.g = this.curve.g;
    this.n = this.curve.n;
    this.hash = options.hash;
    assert(this.g.validate(), 'Invalid curve');
    assert(this.g.mul(this.n).isInfinity(), 'Invalid curve, G*N != O');
  }

  curves.PresetCurve = PresetCurve;

  function defineCurve(name, options) {
    Object.defineProperty(curves, name, {
      configurable: true,
      enumerable: true,
      get: function get() {
        var curve = new PresetCurve(options);
        Object.defineProperty(curves, name, {
          configurable: true,
          enumerable: true,
          value: curve
        });
        return curve;
      }
    });
  }

  defineCurve('p192', {
    type: 'short',
    prime: 'p192',
    p: 'ffffffff ffffffff ffffffff fffffffe ffffffff ffffffff',
    a: 'ffffffff ffffffff ffffffff fffffffe ffffffff fffffffc',
    b: '64210519 e59c80e7 0fa7e9ab 72243049 feb8deec c146b9b1',
    n: 'ffffffff ffffffff ffffffff 99def836 146bc9b1 b4d22831',
    hash: (hash_js__WEBPACK_IMPORTED_MODULE_1___default().sha256),
    gRed: false,
    g: ['188da80e b03090f6 7cbf20eb 43a18800 f4ff0afd 82ff1012', '07192b95 ffc8da78 631011ed 6b24cdd5 73f977a1 1e794811']
  });
  defineCurve('p224', {
    type: 'short',
    prime: 'p224',
    p: 'ffffffff ffffffff ffffffff ffffffff 00000000 00000000 00000001',
    a: 'ffffffff ffffffff ffffffff fffffffe ffffffff ffffffff fffffffe',
    b: 'b4050a85 0c04b3ab f5413256 5044b0b7 d7bfd8ba 270b3943 2355ffb4',
    n: 'ffffffff ffffffff ffffffff ffff16a2 e0b8f03e 13dd2945 5c5c2a3d',
    hash: (hash_js__WEBPACK_IMPORTED_MODULE_1___default().sha256),
    gRed: false,
    g: ['b70e0cbd 6bb4bf7f 321390b9 4a03c1d3 56c21122 343280d6 115c1d21', 'bd376388 b5f723fb 4c22dfe6 cd4375a0 5a074764 44d58199 85007e34']
  });
  defineCurve('p256', {
    type: 'short',
    prime: null,
    p: 'ffffffff 00000001 00000000 00000000 00000000 ffffffff ffffffff ffffffff',
    a: 'ffffffff 00000001 00000000 00000000 00000000 ffffffff ffffffff fffffffc',
    b: '5ac635d8 aa3a93e7 b3ebbd55 769886bc 651d06b0 cc53b0f6 3bce3c3e 27d2604b',
    n: 'ffffffff 00000000 ffffffff ffffffff bce6faad a7179e84 f3b9cac2 fc632551',
    hash: (hash_js__WEBPACK_IMPORTED_MODULE_1___default().sha256),
    gRed: false,
    g: ['6b17d1f2 e12c4247 f8bce6e5 63a440f2 77037d81 2deb33a0 f4a13945 d898c296', '4fe342e2 fe1a7f9b 8ee7eb4a 7c0f9e16 2bce3357 6b315ece cbb64068 37bf51f5']
  });
  defineCurve('p384', {
    type: 'short',
    prime: null,
    p: 'ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ' + 'fffffffe ffffffff 00000000 00000000 ffffffff',
    a: 'ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ' + 'fffffffe ffffffff 00000000 00000000 fffffffc',
    b: 'b3312fa7 e23ee7e4 988e056b e3f82d19 181d9c6e fe814112 0314088f ' + '5013875a c656398d 8a2ed19d 2a85c8ed d3ec2aef',
    n: 'ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff c7634d81 ' + 'f4372ddf 581a0db2 48b0a77a ecec196a ccc52973',
    hash: (hash_js__WEBPACK_IMPORTED_MODULE_1___default().sha384),
    gRed: false,
    g: ['aa87ca22 be8b0537 8eb1c71e f320ad74 6e1d3b62 8ba79b98 59f741e0 82542a38 ' + '5502f25d bf55296c 3a545e38 72760ab7', '3617de4a 96262c6f 5d9e98bf 9292dc29 f8f41dbd 289a147c e9da3113 b5f0b8c0 ' + '0a60b1ce 1d7e819d 7a431d7c 90ea0e5f']
  });
  defineCurve('p521', {
    type: 'short',
    prime: null,
    p: '000001ff ffffffff ffffffff ffffffff ffffffff ffffffff ' + 'ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ' + 'ffffffff ffffffff ffffffff ffffffff ffffffff',
    a: '000001ff ffffffff ffffffff ffffffff ffffffff ffffffff ' + 'ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff ' + 'ffffffff ffffffff ffffffff ffffffff fffffffc',
    b: '00000051 953eb961 8e1c9a1f 929a21a0 b68540ee a2da725b ' + '99b315f3 b8b48991 8ef109e1 56193951 ec7e937b 1652c0bd ' + '3bb1bf07 3573df88 3d2c34f1 ef451fd4 6b503f00',
    n: '000001ff ffffffff ffffffff ffffffff ffffffff ffffffff ' + 'ffffffff ffffffff fffffffa 51868783 bf2f966b 7fcc0148 ' + 'f709a5d0 3bb5c9b8 899c47ae bb6fb71e 91386409',
    hash: (hash_js__WEBPACK_IMPORTED_MODULE_1___default().sha512),
    gRed: false,
    g: ['000000c6 858e06b7 0404e9cd 9e3ecb66 2395b442 9c648139 ' + '053fb521 f828af60 6b4d3dba a14b5e77 efe75928 fe1dc127 ' + 'a2ffa8de 3348b3c1 856a429b f97e7e31 c2e5bd66', '00000118 39296a78 9a3bc004 5c8a5fb4 2c7d1bd9 98f54449 ' + '579b4468 17afbd17 273e662c 97ee7299 5ef42640 c550b901 ' + '3fad0761 353c7086 a272c240 88be9476 9fd16650']
  });
  defineCurve('curve25519', {
    type: 'mont',
    prime: 'p25519',
    p: '7fffffffffffffff ffffffffffffffff ffffffffffffffff ffffffffffffffed',
    a: '76d06',
    b: '1',
    n: '1000000000000000 0000000000000000 14def9dea2f79cd6 5812631a5cf5d3ed',
    hash: (hash_js__WEBPACK_IMPORTED_MODULE_1___default().sha256),
    gRed: false,
    g: ['9']
  });
  defineCurve('ed25519', {
    type: 'edwards',
    prime: 'p25519',
    p: '7fffffffffffffff ffffffffffffffff ffffffffffffffff ffffffffffffffed',
    a: '-1',
    c: '1',
    // -121665 * (121666^(-1)) (mod P)
    d: '52036cee2b6ffe73 8cc740797779e898 00700a4d4141d8ab 75eb4dca135978a3',
    n: '1000000000000000 0000000000000000 14def9dea2f79cd6 5812631a5cf5d3ed',
    hash: (hash_js__WEBPACK_IMPORTED_MODULE_1___default().sha256),
    gRed: false,
    g: ['216936d3cd6e53fec0a4e231fdd6dc5c692cc7609525a7b2c9562d608f25d51a', // 4/5
    '6666666666666666666666666666666666666666666666666666666666666658']
  });
  var pre;

  try {
    pre =
    /*RicMoo:ethers:require(./precomputed/secp256k1)*/
    null.crash();
  } catch (e) {
    pre = undefined;
  }

  defineCurve('secp256k1', {
    type: 'short',
    prime: 'k256',
    p: 'ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff fffffffe fffffc2f',
    a: '0',
    b: '7',
    n: 'ffffffff ffffffff ffffffff fffffffe baaedce6 af48a03b bfd25e8c d0364141',
    h: '1',
    hash: (hash_js__WEBPACK_IMPORTED_MODULE_1___default().sha256),
    // Precomputed endomorphism
    beta: '7ae96a2b657c07106e64479eac3434e99cf0497512f58995c1396c28719501ee',
    lambda: '5363ad4cc05c30e0a5261c028812645a122e22ea20816678df02967c1b23bd72',
    basis: [{
      a: '3086d221a7d46bcde86c90e49284eb15',
      b: '-e4437ed6010e88286f547fa90abfe4c3'
    }, {
      a: '114ca50f7a8e2f3f657c1108d9d44cfd8',
      b: '3086d221a7d46bcde86c90e49284eb15'
    }],
    gRed: false,
    g: ['79be667ef9dcbbac55a06295ce870b07029bfcdb2dce28d959f2815b16f81798', '483ada7726a3c4655da4fbfc0e1108a8fd17b448a68554199c47d08ffb10d4b8', pre]
  });
});
'use strict';

function HmacDRBG(options) {
  if (!(this instanceof HmacDRBG)) return new HmacDRBG(options);
  this.hash = options.hash;
  this.predResist = !!options.predResist;
  this.outLen = this.hash.outSize;
  this.minEntropy = options.minEntropy || this.hash.hmacStrength;
  this._reseed = null;
  this.reseedInterval = null;
  this.K = null;
  this.V = null;
  var entropy = utils_1.toArray(options.entropy, options.entropyEnc || 'hex');
  var nonce = utils_1.toArray(options.nonce, options.nonceEnc || 'hex');
  var pers = utils_1.toArray(options.pers, options.persEnc || 'hex');
  minimalisticAssert(entropy.length >= this.minEntropy / 8, 'Not enough entropy. Minimum is: ' + this.minEntropy + ' bits');

  this._init(entropy, nonce, pers);
}

var hmacDrbg = HmacDRBG;

HmacDRBG.prototype._init = function init(entropy, nonce, pers) {
  var seed = entropy.concat(nonce).concat(pers);
  this.K = new Array(this.outLen / 8);
  this.V = new Array(this.outLen / 8);

  for (var i = 0; i < this.V.length; i++) {
    this.K[i] = 0x00;
    this.V[i] = 0x01;
  }

  this._update(seed);

  this._reseed = 1;
  this.reseedInterval = 0x1000000000000; // 2^48
};

HmacDRBG.prototype._hmac = function hmac() {
  return new (hash_js__WEBPACK_IMPORTED_MODULE_1___default().hmac)(this.hash, this.K);
};

HmacDRBG.prototype._update = function update(seed) {
  var kmac = this._hmac().update(this.V).update([0x00]);

  if (seed) kmac = kmac.update(seed);
  this.K = kmac.digest();
  this.V = this._hmac().update(this.V).digest();
  if (!seed) return;
  this.K = this._hmac().update(this.V).update([0x01]).update(seed).digest();
  this.V = this._hmac().update(this.V).digest();
};

HmacDRBG.prototype.reseed = function reseed(entropy, entropyEnc, add, addEnc) {
  // Optional entropy enc
  if (typeof entropyEnc !== 'string') {
    addEnc = add;
    add = entropyEnc;
    entropyEnc = null;
  }

  entropy = utils_1.toArray(entropy, entropyEnc);
  add = utils_1.toArray(add, addEnc);
  minimalisticAssert(entropy.length >= this.minEntropy / 8, 'Not enough entropy. Minimum is: ' + this.minEntropy + ' bits');

  this._update(entropy.concat(add || []));

  this._reseed = 1;
};

HmacDRBG.prototype.generate = function generate(len, enc, add, addEnc) {
  if (this._reseed > this.reseedInterval) throw new Error('Reseed is required'); // Optional encoding

  if (typeof enc !== 'string') {
    addEnc = add;
    add = enc;
    enc = null;
  } // Optional additional data


  if (add) {
    add = utils_1.toArray(add, addEnc || 'hex');

    this._update(add);
  }

  var temp = [];

  while (temp.length < len) {
    this.V = this._hmac().update(this.V).digest();
    temp = temp.concat(this.V);
  }

  var res = temp.slice(0, len);

  this._update(add);

  this._reseed++;
  return utils_1.encode(res, enc);
};

'use strict';

var assert$3 = utils_1$1.assert;

function KeyPair(ec, options) {
  this.ec = ec;
  this.priv = null;
  this.pub = null; // KeyPair(ec, { priv: ..., pub: ... })

  if (options.priv) this._importPrivate(options.priv, options.privEnc);
  if (options.pub) this._importPublic(options.pub, options.pubEnc);
}

var key = KeyPair;

KeyPair.fromPublic = function fromPublic(ec, pub, enc) {
  if (pub instanceof KeyPair) return pub;
  return new KeyPair(ec, {
    pub: pub,
    pubEnc: enc
  });
};

KeyPair.fromPrivate = function fromPrivate(ec, priv, enc) {
  if (priv instanceof KeyPair) return priv;
  return new KeyPair(ec, {
    priv: priv,
    privEnc: enc
  });
};

KeyPair.prototype.validate = function validate() {
  var pub = this.getPublic();
  if (pub.isInfinity()) return {
    result: false,
    reason: 'Invalid public key'
  };
  if (!pub.validate()) return {
    result: false,
    reason: 'Public key is not a point'
  };
  if (!pub.mul(this.ec.curve.n).isInfinity()) return {
    result: false,
    reason: 'Public key * N != O'
  };
  return {
    result: true,
    reason: null
  };
};

KeyPair.prototype.getPublic = function getPublic(compact, enc) {
  // compact is optional argument
  if (typeof compact === 'string') {
    enc = compact;
    compact = null;
  }

  if (!this.pub) this.pub = this.ec.g.mul(this.priv);
  if (!enc) return this.pub;
  return this.pub.encode(enc, compact);
};

KeyPair.prototype.getPrivate = function getPrivate(enc) {
  if (enc === 'hex') return this.priv.toString(16, 2);else return this.priv;
};

KeyPair.prototype._importPrivate = function _importPrivate(key, enc) {
  this.priv = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(key, enc || 16); // Ensure that the priv won't be bigger than n, otherwise we may fail
  // in fixed multiplication method

  this.priv = this.priv.umod(this.ec.curve.n);
};

KeyPair.prototype._importPublic = function _importPublic(key, enc) {
  if (key.x || key.y) {
    // Montgomery points only have an `x` coordinate.
    // Weierstrass/Edwards points on the other hand have both `x` and
    // `y` coordinates.
    if (this.ec.curve.type === 'mont') {
      assert$3(key.x, 'Need x coordinate');
    } else if (this.ec.curve.type === 'short' || this.ec.curve.type === 'edwards') {
      assert$3(key.x && key.y, 'Need both x and y coordinate');
    }

    this.pub = this.ec.curve.point(key.x, key.y);
    return;
  }

  this.pub = this.ec.curve.decodePoint(key, enc);
}; // ECDH


KeyPair.prototype.derive = function derive(pub) {
  if (!pub.validate()) {
    assert$3(pub.validate(), 'public point not validated');
  }

  return pub.mul(this.priv).getX();
}; // ECDSA


KeyPair.prototype.sign = function sign(msg, enc, options) {
  return this.ec.sign(msg, this, enc, options);
};

KeyPair.prototype.verify = function verify(msg, signature) {
  return this.ec.verify(msg, signature, this);
};

KeyPair.prototype.inspect = function inspect() {
  return '<Key priv: ' + (this.priv && this.priv.toString(16, 2)) + ' pub: ' + (this.pub && this.pub.inspect()) + ' >';
};

'use strict';

var assert$4 = utils_1$1.assert;

function Signature(options, enc) {
  if (options instanceof Signature) return options;
  if (this._importDER(options, enc)) return;
  assert$4(options.r && options.s, 'Signature without r or s');
  this.r = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(options.r, 16);
  this.s = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(options.s, 16);
  if (options.recoveryParam === undefined) this.recoveryParam = null;else this.recoveryParam = options.recoveryParam;
}

var signature = Signature;

function Position() {
  this.place = 0;
}

function getLength(buf, p) {
  var initial = buf[p.place++];

  if (!(initial & 0x80)) {
    return initial;
  }

  var octetLen = initial & 0xf; // Indefinite length or overflow

  if (octetLen === 0 || octetLen > 4) {
    return false;
  }

  var val = 0;

  for (var i = 0, off = p.place; i < octetLen; i++, off++) {
    val <<= 8;
    val |= buf[off];
    val >>>= 0;
  } // Leading zeroes


  if (val <= 0x7f) {
    return false;
  }

  p.place = off;
  return val;
}

function rmPadding(buf) {
  var i = 0;
  var len = buf.length - 1;

  while (!buf[i] && !(buf[i + 1] & 0x80) && i < len) {
    i++;
  }

  if (i === 0) {
    return buf;
  }

  return buf.slice(i);
}

Signature.prototype._importDER = function _importDER(data, enc) {
  data = utils_1$1.toArray(data, enc);
  var p = new Position();

  if (data[p.place++] !== 0x30) {
    return false;
  }

  var len = getLength(data, p);

  if (len === false) {
    return false;
  }

  if (len + p.place !== data.length) {
    return false;
  }

  if (data[p.place++] !== 0x02) {
    return false;
  }

  var rlen = getLength(data, p);

  if (rlen === false) {
    return false;
  }

  var r = data.slice(p.place, rlen + p.place);
  p.place += rlen;

  if (data[p.place++] !== 0x02) {
    return false;
  }

  var slen = getLength(data, p);

  if (slen === false) {
    return false;
  }

  if (data.length !== slen + p.place) {
    return false;
  }

  var s = data.slice(p.place, slen + p.place);

  if (r[0] === 0) {
    if (r[1] & 0x80) {
      r = r.slice(1);
    } else {
      // Leading zeroes
      return false;
    }
  }

  if (s[0] === 0) {
    if (s[1] & 0x80) {
      s = s.slice(1);
    } else {
      // Leading zeroes
      return false;
    }
  }

  this.r = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(r);
  this.s = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(s);
  this.recoveryParam = null;
  return true;
};

function constructLength(arr, len) {
  if (len < 0x80) {
    arr.push(len);
    return;
  }

  var octets = 1 + (Math.log(len) / Math.LN2 >>> 3);
  arr.push(octets | 0x80);

  while (--octets) {
    arr.push(len >>> (octets << 3) & 0xff);
  }

  arr.push(len);
}

Signature.prototype.toDER = function toDER(enc) {
  var r = this.r.toArray();
  var s = this.s.toArray(); // Pad values

  if (r[0] & 0x80) r = [0].concat(r); // Pad values

  if (s[0] & 0x80) s = [0].concat(s);
  r = rmPadding(r);
  s = rmPadding(s);

  while (!s[0] && !(s[1] & 0x80)) {
    s = s.slice(1);
  }

  var arr = [0x02];
  constructLength(arr, r.length);
  arr = arr.concat(r);
  arr.push(0x02);
  constructLength(arr, s.length);
  var backHalf = arr.concat(s);
  var res = [0x30];
  constructLength(res, backHalf.length);
  res = res.concat(backHalf);
  return utils_1$1.encode(res, enc);
};

'use strict';

var rand =
/*RicMoo:ethers:require(brorand)*/
function rand() {
  throw new Error('unsupported');
};

var assert$5 = utils_1$1.assert;

function EC(options) {
  if (!(this instanceof EC)) return new EC(options); // Shortcut `elliptic.ec(curve-name)`

  if (typeof options === 'string') {
    assert$5(Object.prototype.hasOwnProperty.call(curves_1, options), 'Unknown curve ' + options);
    options = curves_1[options];
  } // Shortcut for `elliptic.ec(elliptic.curves.curveName)`


  if (options instanceof curves_1.PresetCurve) options = {
    curve: options
  };
  this.curve = options.curve.curve;
  this.n = this.curve.n;
  this.nh = this.n.ushrn(1);
  this.g = this.curve.g; // Point on curve

  this.g = options.curve.g;
  this.g.precompute(options.curve.n.bitLength() + 1); // Hash for function for DRBG

  this.hash = options.hash || options.curve.hash;
}

var ec = EC;

EC.prototype.keyPair = function keyPair(options) {
  return new key(this, options);
};

EC.prototype.keyFromPrivate = function keyFromPrivate(priv, enc) {
  return key.fromPrivate(this, priv, enc);
};

EC.prototype.keyFromPublic = function keyFromPublic(pub, enc) {
  return key.fromPublic(this, pub, enc);
};

EC.prototype.genKeyPair = function genKeyPair(options) {
  if (!options) options = {}; // Instantiate Hmac_DRBG

  var drbg = new hmacDrbg({
    hash: this.hash,
    pers: options.pers,
    persEnc: options.persEnc || 'utf8',
    entropy: options.entropy || rand(this.hash.hmacStrength),
    entropyEnc: options.entropy && options.entropyEnc || 'utf8',
    nonce: this.n.toArray()
  });
  var bytes = this.n.byteLength();
  var ns2 = this.n.sub(new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(2));

  for (;;) {
    var priv = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(drbg.generate(bytes));
    if (priv.cmp(ns2) > 0) continue;
    priv.iaddn(1);
    return this.keyFromPrivate(priv);
  }
};

EC.prototype._truncateToN = function _truncateToN(msg, truncOnly) {
  var delta = msg.byteLength() * 8 - this.n.bitLength();
  if (delta > 0) msg = msg.ushrn(delta);
  if (!truncOnly && msg.cmp(this.n) >= 0) return msg.sub(this.n);else return msg;
};

EC.prototype.sign = function sign(msg, key, enc, options) {
  if (_typeof(enc) === 'object') {
    options = enc;
    enc = null;
  }

  if (!options) options = {};
  key = this.keyFromPrivate(key, enc);
  msg = this._truncateToN(new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(msg, 16)); // Zero-extend key to provide enough entropy

  var bytes = this.n.byteLength();
  var bkey = key.getPrivate().toArray('be', bytes); // Zero-extend nonce to have the same byte size as N

  var nonce = msg.toArray('be', bytes); // Instantiate Hmac_DRBG

  var drbg = new hmacDrbg({
    hash: this.hash,
    entropy: bkey,
    nonce: nonce,
    pers: options.pers,
    persEnc: options.persEnc || 'utf8'
  }); // Number of bytes to generate

  var ns1 = this.n.sub(new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(1));

  for (var iter = 0;; iter++) {
    var k = options.k ? options.k(iter) : new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(drbg.generate(this.n.byteLength()));
    k = this._truncateToN(k, true);
    if (k.cmpn(1) <= 0 || k.cmp(ns1) >= 0) continue;
    var kp = this.g.mul(k);
    if (kp.isInfinity()) continue;
    var kpX = kp.getX();
    var r = kpX.umod(this.n);
    if (r.cmpn(0) === 0) continue;
    var s = k.invm(this.n).mul(r.mul(key.getPrivate()).iadd(msg));
    s = s.umod(this.n);
    if (s.cmpn(0) === 0) continue;
    var recoveryParam = (kp.getY().isOdd() ? 1 : 0) | (kpX.cmp(r) !== 0 ? 2 : 0); // Use complement of `s`, if it is > `n / 2`

    if (options.canonical && s.cmp(this.nh) > 0) {
      s = this.n.sub(s);
      recoveryParam ^= 1;
    }

    return new signature({
      r: r,
      s: s,
      recoveryParam: recoveryParam
    });
  }
};

EC.prototype.verify = function verify(msg, signature$1, key, enc) {
  msg = this._truncateToN(new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(msg, 16));
  key = this.keyFromPublic(key, enc);
  signature$1 = new signature(signature$1, 'hex'); // Perform primitive values validation

  var r = signature$1.r;
  var s = signature$1.s;
  if (r.cmpn(1) < 0 || r.cmp(this.n) >= 0) return false;
  if (s.cmpn(1) < 0 || s.cmp(this.n) >= 0) return false; // Validate signature

  var sinv = s.invm(this.n);
  var u1 = sinv.mul(msg).umod(this.n);
  var u2 = sinv.mul(r).umod(this.n);
  var p;

  if (!this.curve._maxwellTrick) {
    p = this.g.mulAdd(u1, key.getPublic(), u2);
    if (p.isInfinity()) return false;
    return p.getX().umod(this.n).cmp(r) === 0;
  } // NOTE: Greg Maxwell's trick, inspired by:
  // https://git.io/vad3K


  p = this.g.jmulAdd(u1, key.getPublic(), u2);
  if (p.isInfinity()) return false; // Compare `p.x` of Jacobian point with `r`,
  // this will do `p.x == r * p.z^2` instead of multiplying `p.x` by the
  // inverse of `p.z^2`

  return p.eqXToP(r);
};

EC.prototype.recoverPubKey = function (msg, signature$1, j, enc) {
  assert$5((3 & j) === j, 'The recovery param is more than two bits');
  signature$1 = new signature(signature$1, enc);
  var n = this.n;
  var e = new (bn_js__WEBPACK_IMPORTED_MODULE_0___default())(msg);
  var r = signature$1.r;
  var s = signature$1.s; // A set LSB signifies that the y-coordinate is odd

  var isYOdd = j & 1;
  var isSecondKey = j >> 1;
  if (r.cmp(this.curve.p.umod(this.curve.n)) >= 0 && isSecondKey) throw new Error('Unable to find sencond key candinate'); // 1.1. Let x = r + jn.

  if (isSecondKey) r = this.curve.pointFromX(r.add(this.curve.n), isYOdd);else r = this.curve.pointFromX(r, isYOdd);
  var rInv = signature$1.r.invm(n);
  var s1 = n.sub(e).mul(rInv).umod(n);
  var s2 = s.mul(rInv).umod(n); // 1.6.1 Compute Q = r^-1 (sR -  eG)
  //               Q = r^-1 (sR + -eG)

  return this.g.mulAdd(s1, r, s2);
};

EC.prototype.getKeyRecoveryParam = function (e, signature$1, Q, enc) {
  signature$1 = new signature(signature$1, enc);
  if (signature$1.recoveryParam !== null) return signature$1.recoveryParam;

  for (var i = 0; i < 4; i++) {
    var Qprime;

    try {
      Qprime = this.recoverPubKey(e, signature$1, i);
    } catch (e) {
      continue;
    }

    if (Qprime.eq(Q)) return i;
  }

  throw new Error('Unable to find valid recovery factor');
};

var elliptic_1 = createCommonjsModule(function (module, exports) {
  'use strict';

  var elliptic = exports;
  elliptic.version =
  /*RicMoo:ethers*/
  {
    version: "6.5.4"
  }.version;
  elliptic.utils = utils_1$1;

  elliptic.rand =
  /*RicMoo:ethers:require(brorand)*/
  function () {
    throw new Error('unsupported');
  };

  elliptic.curve = curve_1;
  elliptic.curves = curves_1; // Protocols

  elliptic.ec = ec;
  elliptic.eddsa =
  /*RicMoo:ethers:require(./elliptic/eddsa)*/
  null;
});
var EC$1 = elliptic_1.ec;


/***/ }),

/***/ "./node_modules/@ethersproject/signing-key/lib.esm/index.js":
/*!******************************************************************!*\
  !*** ./node_modules/@ethersproject/signing-key/lib.esm/index.js ***!
  \******************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "SigningKey": function() { return /* binding */ SigningKey; },
/* harmony export */   "recoverPublicKey": function() { return /* binding */ recoverPublicKey; },
/* harmony export */   "computePublicKey": function() { return /* binding */ computePublicKey; }
/* harmony export */ });
/* harmony import */ var _elliptic__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./elliptic */ "./node_modules/@ethersproject/signing-key/lib.esm/elliptic.js");
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/signing-key/lib.esm/_version.js");


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }






var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
var _curve = null;

function getCurve() {
  if (!_curve) {
    _curve = new _elliptic__WEBPACK_IMPORTED_MODULE_2__.EC("secp256k1");
  }

  return _curve;
}

var SigningKey = /*#__PURE__*/function () {
  function SigningKey(privateKey) {
    _classCallCheck(this, SigningKey);

    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "curve", "secp256k1");
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "privateKey", (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.hexlify)(privateKey));
    var keyPair = getCurve().keyFromPrivate((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.arrayify)(this.privateKey));
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "publicKey", "0x" + keyPair.getPublic(false, "hex"));
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "compressedPublicKey", "0x" + keyPair.getPublic(true, "hex"));
    (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_3__.defineReadOnly)(this, "_isSigningKey", true);
  }

  _createClass(SigningKey, [{
    key: "_addPoint",
    value: function _addPoint(other) {
      var p0 = getCurve().keyFromPublic((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.arrayify)(this.publicKey));
      var p1 = getCurve().keyFromPublic((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.arrayify)(other));
      return "0x" + p0.pub.add(p1.pub).encodeCompressed("hex");
    }
  }, {
    key: "signDigest",
    value: function signDigest(digest) {
      var keyPair = getCurve().keyFromPrivate((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.arrayify)(this.privateKey));
      var digestBytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.arrayify)(digest);

      if (digestBytes.length !== 32) {
        logger.throwArgumentError("bad digest length", "digest", digest);
      }

      var signature = keyPair.sign(digestBytes, {
        canonical: true
      });
      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.splitSignature)({
        recoveryParam: signature.recoveryParam,
        r: (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.hexZeroPad)("0x" + signature.r.toString(16), 32),
        s: (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.hexZeroPad)("0x" + signature.s.toString(16), 32)
      });
    }
  }, {
    key: "computeSharedSecret",
    value: function computeSharedSecret(otherKey) {
      var keyPair = getCurve().keyFromPrivate((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.arrayify)(this.privateKey));
      var otherKeyPair = getCurve().keyFromPublic((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.arrayify)(computePublicKey(otherKey)));
      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.hexZeroPad)("0x" + keyPair.derive(otherKeyPair.getPublic()).toString(16), 32);
    }
  }], [{
    key: "isSigningKey",
    value: function isSigningKey(value) {
      return !!(value && value._isSigningKey);
    }
  }]);

  return SigningKey;
}();
function recoverPublicKey(digest, signature) {
  var sig = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.splitSignature)(signature);
  var rs = {
    r: (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.arrayify)(sig.r),
    s: (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.arrayify)(sig.s)
  };
  return "0x" + getCurve().recoverPubKey((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.arrayify)(digest), rs, sig.recoveryParam).encode("hex", false);
}
function computePublicKey(key, compressed) {
  var bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.arrayify)(key);

  if (bytes.length === 32) {
    var signingKey = new SigningKey(bytes);

    if (compressed) {
      return "0x" + getCurve().keyFromPrivate(bytes).getPublic(true, "hex");
    }

    return signingKey.publicKey;
  } else if (bytes.length === 33) {
    if (compressed) {
      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.hexlify)(bytes);
    }

    return "0x" + getCurve().keyFromPublic(bytes).getPublic(false, "hex");
  } else if (bytes.length === 65) {
    if (!compressed) {
      return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_4__.hexlify)(bytes);
    }

    return "0x" + getCurve().keyFromPublic(bytes).getPublic(true, "hex");
  }

  return logger.throwArgumentError("invalid public or private key", "key", "[REDACTED]");
}

/***/ }),

/***/ "./node_modules/@ethersproject/strings/lib.esm/_version.js":
/*!*****************************************************************!*\
  !*** ./node_modules/@ethersproject/strings/lib.esm/_version.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "strings/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/strings/lib.esm/idna.js":
/*!*************************************************************!*\
  !*** ./node_modules/@ethersproject/strings/lib.esm/idna.js ***!
  \*************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "_nameprepTableA1": function() { return /* binding */ _nameprepTableA1; },
/* harmony export */   "_nameprepTableB2": function() { return /* binding */ _nameprepTableB2; },
/* harmony export */   "_nameprepTableC": function() { return /* binding */ _nameprepTableC; },
/* harmony export */   "nameprep": function() { return /* binding */ nameprep; }
/* harmony export */ });
/* harmony import */ var _utf8__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./utf8 */ "./node_modules/@ethersproject/strings/lib.esm/utf8.js");




function bytes2(data) {
  if (data.length % 4 !== 0) {
    throw new Error("bad data");
  }

  var result = [];

  for (var i = 0; i < data.length; i += 4) {
    result.push(parseInt(data.substring(i, i + 4), 16));
  }

  return result;
}

function createTable(data, func) {
  if (!func) {
    func = function func(value) {
      return [parseInt(value, 16)];
    };
  }

  var lo = 0;
  var result = {};
  data.split(",").forEach(function (pair) {
    var comps = pair.split(":");
    lo += parseInt(comps[0], 16);
    result[lo] = func(comps[1]);
  });
  return result;
}

function createRangeTable(data) {
  var hi = 0;
  return data.split(",").map(function (v) {
    var comps = v.split("-");

    if (comps.length === 1) {
      comps[1] = "0";
    } else if (comps[1] === "") {
      comps[1] = "1";
    }

    var lo = hi + parseInt(comps[0], 16);
    hi = parseInt(comps[1], 16);
    return {
      l: lo,
      h: hi
    };
  });
}

function matchMap(value, ranges) {
  var lo = 0;

  for (var i = 0; i < ranges.length; i++) {
    var range = ranges[i];
    lo += range.l;

    if (value >= lo && value <= lo + range.h && (value - lo) % (range.d || 1) === 0) {
      if (range.e && range.e.indexOf(value - lo) !== -1) {
        continue;
      }

      return range;
    }
  }

  return null;
}

var Table_A_1_ranges = createRangeTable("221,13-1b,5f-,40-10,51-f,11-3,3-3,2-2,2-4,8,2,15,2d,28-8,88,48,27-,3-5,11-20,27-,8,28,3-5,12,18,b-a,1c-4,6-16,2-d,2-2,2,1b-4,17-9,8f-,10,f,1f-2,1c-34,33-14e,4,36-,13-,6-2,1a-f,4,9-,3-,17,8,2-2,5-,2,8-,3-,4-8,2-3,3,6-,16-6,2-,7-3,3-,17,8,3,3,3-,2,6-3,3-,4-a,5,2-6,10-b,4,8,2,4,17,8,3,6-,b,4,4-,2-e,2-4,b-10,4,9-,3-,17,8,3-,5-,9-2,3-,4-7,3-3,3,4-3,c-10,3,7-2,4,5-2,3,2,3-2,3-2,4-2,9,4-3,6-2,4,5-8,2-e,d-d,4,9,4,18,b,6-3,8,4,5-6,3-8,3-3,b-11,3,9,4,18,b,6-3,8,4,5-6,3-6,2,3-3,b-11,3,9,4,18,11-3,7-,4,5-8,2-7,3-3,b-11,3,13-2,19,a,2-,8-2,2-3,7,2,9-11,4-b,3b-3,1e-24,3,2-,3,2-,2-5,5,8,4,2,2-,3,e,4-,6,2,7-,b-,3-21,49,23-5,1c-3,9,25,10-,2-2f,23,6,3,8-2,5-5,1b-45,27-9,2a-,2-3,5b-4,45-4,53-5,8,40,2,5-,8,2,5-,28,2,5-,20,2,5-,8,2,5-,8,8,18,20,2,5-,8,28,14-5,1d-22,56-b,277-8,1e-2,52-e,e,8-a,18-8,15-b,e,4,3-b,5e-2,b-15,10,b-5,59-7,2b-555,9d-3,5b-5,17-,7-,27-,7-,9,2,2,2,20-,36,10,f-,7,14-,4,a,54-3,2-6,6-5,9-,1c-10,13-1d,1c-14,3c-,10-6,32-b,240-30,28-18,c-14,a0,115-,3,66-,b-76,5,5-,1d,24,2,5-2,2,8-,35-2,19,f-10,1d-3,311-37f,1b,5a-b,d7-19,d-3,41,57-,68-4,29-3,5f,29-37,2e-2,25-c,2c-2,4e-3,30,78-3,64-,20,19b7-49,51a7-59,48e-2,38-738,2ba5-5b,222f-,3c-94,8-b,6-4,1b,6,2,3,3,6d-20,16e-f,41-,37-7,2e-2,11-f,5-b,18-,b,14,5-3,6,88-,2,bf-2,7-,7-,7-,4-2,8,8-9,8-2ff,20,5-b,1c-b4,27-,27-cbb1,f7-9,28-2,b5-221,56,48,3-,2-,3-,5,d,2,5,3,42,5-,9,8,1d,5,6,2-2,8,153-3,123-3,33-27fd,a6da-5128,21f-5df,3-fffd,3-fffd,3-fffd,3-fffd,3-fffd,3-fffd,3-fffd,3-fffd,3-fffd,3-fffd,3-fffd,3,2-1d,61-ff7d"); // @TODO: Make this relative...

var Table_B_1_flags = "ad,34f,1806,180b,180c,180d,200b,200c,200d,2060,feff".split(",").map(function (v) {
  return parseInt(v, 16);
});
var Table_B_2_ranges = [{
  h: 25,
  s: 32,
  l: 65
}, {
  h: 30,
  s: 32,
  e: [23],
  l: 127
}, {
  h: 54,
  s: 1,
  e: [48],
  l: 64,
  d: 2
}, {
  h: 14,
  s: 1,
  l: 57,
  d: 2
}, {
  h: 44,
  s: 1,
  l: 17,
  d: 2
}, {
  h: 10,
  s: 1,
  e: [2, 6, 8],
  l: 61,
  d: 2
}, {
  h: 16,
  s: 1,
  l: 68,
  d: 2
}, {
  h: 84,
  s: 1,
  e: [18, 24, 66],
  l: 19,
  d: 2
}, {
  h: 26,
  s: 32,
  e: [17],
  l: 435
}, {
  h: 22,
  s: 1,
  l: 71,
  d: 2
}, {
  h: 15,
  s: 80,
  l: 40
}, {
  h: 31,
  s: 32,
  l: 16
}, {
  h: 32,
  s: 1,
  l: 80,
  d: 2
}, {
  h: 52,
  s: 1,
  l: 42,
  d: 2
}, {
  h: 12,
  s: 1,
  l: 55,
  d: 2
}, {
  h: 40,
  s: 1,
  e: [38],
  l: 15,
  d: 2
}, {
  h: 14,
  s: 1,
  l: 48,
  d: 2
}, {
  h: 37,
  s: 48,
  l: 49
}, {
  h: 148,
  s: 1,
  l: 6351,
  d: 2
}, {
  h: 88,
  s: 1,
  l: 160,
  d: 2
}, {
  h: 15,
  s: 16,
  l: 704
}, {
  h: 25,
  s: 26,
  l: 854
}, {
  h: 25,
  s: 32,
  l: 55915
}, {
  h: 37,
  s: 40,
  l: 1247
}, {
  h: 25,
  s: -119711,
  l: 53248
}, {
  h: 25,
  s: -119763,
  l: 52
}, {
  h: 25,
  s: -119815,
  l: 52
}, {
  h: 25,
  s: -119867,
  e: [1, 4, 5, 7, 8, 11, 12, 17],
  l: 52
}, {
  h: 25,
  s: -119919,
  l: 52
}, {
  h: 24,
  s: -119971,
  e: [2, 7, 8, 17],
  l: 52
}, {
  h: 24,
  s: -120023,
  e: [2, 7, 13, 15, 16, 17],
  l: 52
}, {
  h: 25,
  s: -120075,
  l: 52
}, {
  h: 25,
  s: -120127,
  l: 52
}, {
  h: 25,
  s: -120179,
  l: 52
}, {
  h: 25,
  s: -120231,
  l: 52
}, {
  h: 25,
  s: -120283,
  l: 52
}, {
  h: 25,
  s: -120335,
  l: 52
}, {
  h: 24,
  s: -119543,
  e: [17],
  l: 56
}, {
  h: 24,
  s: -119601,
  e: [17],
  l: 58
}, {
  h: 24,
  s: -119659,
  e: [17],
  l: 58
}, {
  h: 24,
  s: -119717,
  e: [17],
  l: 58
}, {
  h: 24,
  s: -119775,
  e: [17],
  l: 58
}];
var Table_B_2_lut_abs = createTable("b5:3bc,c3:ff,7:73,2:253,5:254,3:256,1:257,5:259,1:25b,3:260,1:263,2:269,1:268,5:26f,1:272,2:275,7:280,3:283,5:288,3:28a,1:28b,5:292,3f:195,1:1bf,29:19e,125:3b9,8b:3b2,1:3b8,1:3c5,3:3c6,1:3c0,1a:3ba,1:3c1,1:3c3,2:3b8,1:3b5,1bc9:3b9,1c:1f76,1:1f77,f:1f7a,1:1f7b,d:1f78,1:1f79,1:1f7c,1:1f7d,107:63,5:25b,4:68,1:68,1:68,3:69,1:69,1:6c,3:6e,4:70,1:71,1:72,1:72,1:72,7:7a,2:3c9,2:7a,2:6b,1:e5,1:62,1:63,3:65,1:66,2:6d,b:3b3,1:3c0,6:64,1b574:3b8,1a:3c3,20:3b8,1a:3c3,20:3b8,1a:3c3,20:3b8,1a:3c3,20:3b8,1a:3c3");
var Table_B_2_lut_rel = createTable("179:1,2:1,2:1,5:1,2:1,a:4f,a:1,8:1,2:1,2:1,3:1,5:1,3:1,4:1,2:1,3:1,4:1,8:2,1:1,2:2,1:1,2:2,27:2,195:26,2:25,1:25,1:25,2:40,2:3f,1:3f,33:1,11:-6,1:-9,1ac7:-3a,6d:-8,1:-8,1:-8,1:-8,1:-8,1:-8,1:-8,1:-8,9:-8,1:-8,1:-8,1:-8,1:-8,1:-8,b:-8,1:-8,1:-8,1:-8,1:-8,1:-8,1:-8,1:-8,9:-8,1:-8,1:-8,1:-8,1:-8,1:-8,1:-8,1:-8,9:-8,1:-8,1:-8,1:-8,1:-8,1:-8,c:-8,2:-8,2:-8,2:-8,9:-8,1:-8,1:-8,1:-8,1:-8,1:-8,1:-8,1:-8,49:-8,1:-8,1:-4a,1:-4a,d:-56,1:-56,1:-56,1:-56,d:-8,1:-8,f:-8,1:-8,3:-7");
var Table_B_2_complex = createTable("df:00730073,51:00690307,19:02BC006E,a7:006A030C,18a:002003B9,16:03B903080301,20:03C503080301,1d7:05650582,190f:00680331,1:00740308,1:0077030A,1:0079030A,1:006102BE,b6:03C50313,2:03C503130300,2:03C503130301,2:03C503130342,2a:1F0003B9,1:1F0103B9,1:1F0203B9,1:1F0303B9,1:1F0403B9,1:1F0503B9,1:1F0603B9,1:1F0703B9,1:1F0003B9,1:1F0103B9,1:1F0203B9,1:1F0303B9,1:1F0403B9,1:1F0503B9,1:1F0603B9,1:1F0703B9,1:1F2003B9,1:1F2103B9,1:1F2203B9,1:1F2303B9,1:1F2403B9,1:1F2503B9,1:1F2603B9,1:1F2703B9,1:1F2003B9,1:1F2103B9,1:1F2203B9,1:1F2303B9,1:1F2403B9,1:1F2503B9,1:1F2603B9,1:1F2703B9,1:1F6003B9,1:1F6103B9,1:1F6203B9,1:1F6303B9,1:1F6403B9,1:1F6503B9,1:1F6603B9,1:1F6703B9,1:1F6003B9,1:1F6103B9,1:1F6203B9,1:1F6303B9,1:1F6403B9,1:1F6503B9,1:1F6603B9,1:1F6703B9,3:1F7003B9,1:03B103B9,1:03AC03B9,2:03B10342,1:03B1034203B9,5:03B103B9,6:1F7403B9,1:03B703B9,1:03AE03B9,2:03B70342,1:03B7034203B9,5:03B703B9,6:03B903080300,1:03B903080301,3:03B90342,1:03B903080342,b:03C503080300,1:03C503080301,1:03C10313,2:03C50342,1:03C503080342,b:1F7C03B9,1:03C903B9,1:03CE03B9,2:03C90342,1:03C9034203B9,5:03C903B9,ac:00720073,5b:00B00063,6:00B00066,d:006E006F,a:0073006D,1:00740065006C,1:0074006D,124f:006800700061,2:00610075,2:006F0076,b:00700061,1:006E0061,1:03BC0061,1:006D0061,1:006B0061,1:006B0062,1:006D0062,1:00670062,3:00700066,1:006E0066,1:03BC0066,4:0068007A,1:006B0068007A,1:006D0068007A,1:00670068007A,1:00740068007A,15:00700061,1:006B00700061,1:006D00700061,1:006700700061,8:00700076,1:006E0076,1:03BC0076,1:006D0076,1:006B0076,1:006D0076,1:00700077,1:006E0077,1:03BC0077,1:006D0077,1:006B0077,1:006D0077,1:006B03C9,1:006D03C9,2:00620071,3:00632215006B0067,1:0063006F002E,1:00640062,1:00670079,2:00680070,2:006B006B,1:006B006D,9:00700068,2:00700070006D,1:00700072,2:00730076,1:00770062,c723:00660066,1:00660069,1:0066006C,1:006600660069,1:00660066006C,1:00730074,1:00730074,d:05740576,1:05740565,1:0574056B,1:057E0576,1:0574056D", bytes2);
var Table_C_ranges = createRangeTable("80-20,2a0-,39c,32,f71,18e,7f2-f,19-7,30-4,7-5,f81-b,5,a800-20ff,4d1-1f,110,fa-6,d174-7,2e84-,ffff-,ffff-,ffff-,ffff-,ffff-,ffff-,ffff-,ffff-,ffff-,ffff-,ffff-,ffff-,2,1f-5f,ff7f-20001");

function flatten(values) {
  return values.reduce(function (accum, value) {
    value.forEach(function (value) {
      accum.push(value);
    });
    return accum;
  }, []);
}

function _nameprepTableA1(codepoint) {
  return !!matchMap(codepoint, Table_A_1_ranges);
}
function _nameprepTableB2(codepoint) {
  var range = matchMap(codepoint, Table_B_2_ranges);

  if (range) {
    return [codepoint + range.s];
  }

  var codes = Table_B_2_lut_abs[codepoint];

  if (codes) {
    return codes;
  }

  var shift = Table_B_2_lut_rel[codepoint];

  if (shift) {
    return [codepoint + shift[0]];
  }

  var complex = Table_B_2_complex[codepoint];

  if (complex) {
    return complex;
  }

  return null;
}
function _nameprepTableC(codepoint) {
  return !!matchMap(codepoint, Table_C_ranges);
}
function nameprep(value) {
  // This allows platforms with incomplete normalize to bypass
  // it for very basic names which the built-in toLowerCase
  // will certainly handle correctly
  if (value.match(/^[a-z0-9-]*$/i) && value.length <= 59) {
    return value.toLowerCase();
  } // Get the code points (keeping the current normalization)


  var codes = (0,_utf8__WEBPACK_IMPORTED_MODULE_0__.toUtf8CodePoints)(value);
  codes = flatten(codes.map(function (code) {
    // Substitute Table B.1 (Maps to Nothing)
    if (Table_B_1_flags.indexOf(code) >= 0) {
      return [];
    }

    if (code >= 0xfe00 && code <= 0xfe0f) {
      return [];
    } // Substitute Table B.2 (Case Folding)


    var codesTableB2 = _nameprepTableB2(code);

    if (codesTableB2) {
      return codesTableB2;
    } // No Substitution


    return [code];
  })); // Normalize using form KC

  codes = (0,_utf8__WEBPACK_IMPORTED_MODULE_0__.toUtf8CodePoints)((0,_utf8__WEBPACK_IMPORTED_MODULE_0__._toUtf8String)(codes), _utf8__WEBPACK_IMPORTED_MODULE_0__.UnicodeNormalizationForm.NFKC); // Prohibit Tables C.1.2, C.2.2, C.3, C.4, C.5, C.6, C.7, C.8, C.9

  codes.forEach(function (code) {
    if (_nameprepTableC(code)) {
      throw new Error("STRINGPREP_CONTAINS_PROHIBITED");
    }
  }); // Prohibit Unassigned Code Points (Table A.1)

  codes.forEach(function (code) {
    if (_nameprepTableA1(code)) {
      throw new Error("STRINGPREP_CONTAINS_UNASSIGNED");
    }
  }); // IDNA extras

  var name = (0,_utf8__WEBPACK_IMPORTED_MODULE_0__._toUtf8String)(codes); // IDNA: 4.2.3.1


  if (name.substring(0, 1) === "-" || name.substring(2, 4) === "--" || name.substring(name.length - 1) === "-") {
    throw new Error("invalid hyphen");
  } // IDNA: 4.2.4


  if (name.length > 63) {
    throw new Error("too long");
  }

  return name;
}

/***/ }),

/***/ "./node_modules/@ethersproject/strings/lib.esm/utf8.js":
/*!*************************************************************!*\
  !*** ./node_modules/@ethersproject/strings/lib.esm/utf8.js ***!
  \*************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "UnicodeNormalizationForm": function() { return /* binding */ UnicodeNormalizationForm; },
/* harmony export */   "Utf8ErrorReason": function() { return /* binding */ Utf8ErrorReason; },
/* harmony export */   "Utf8ErrorFuncs": function() { return /* binding */ Utf8ErrorFuncs; },
/* harmony export */   "toUtf8Bytes": function() { return /* binding */ toUtf8Bytes; },
/* harmony export */   "_toEscapedUtf8String": function() { return /* binding */ _toEscapedUtf8String; },
/* harmony export */   "_toUtf8String": function() { return /* binding */ _toUtf8String; },
/* harmony export */   "toUtf8String": function() { return /* binding */ toUtf8String; },
/* harmony export */   "toUtf8CodePoints": function() { return /* binding */ toUtf8CodePoints; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/strings/lib.esm/_version.js");





var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version); ///////////////////////////////

var UnicodeNormalizationForm;

(function (UnicodeNormalizationForm) {
  UnicodeNormalizationForm["current"] = "";
  UnicodeNormalizationForm["NFC"] = "NFC";
  UnicodeNormalizationForm["NFD"] = "NFD";
  UnicodeNormalizationForm["NFKC"] = "NFKC";
  UnicodeNormalizationForm["NFKD"] = "NFKD";
})(UnicodeNormalizationForm || (UnicodeNormalizationForm = {}));

;
var Utf8ErrorReason;

(function (Utf8ErrorReason) {
  // A continuation byte was present where there was nothing to continue
  // - offset = the index the codepoint began in
  Utf8ErrorReason["UNEXPECTED_CONTINUE"] = "unexpected continuation byte"; // An invalid (non-continuation) byte to start a UTF-8 codepoint was found
  // - offset = the index the codepoint began in

  Utf8ErrorReason["BAD_PREFIX"] = "bad codepoint prefix"; // The string is too short to process the expected codepoint
  // - offset = the index the codepoint began in

  Utf8ErrorReason["OVERRUN"] = "string overrun"; // A missing continuation byte was expected but not found
  // - offset = the index the continuation byte was expected at

  Utf8ErrorReason["MISSING_CONTINUE"] = "missing continuation byte"; // The computed code point is outside the range for UTF-8
  // - offset       = start of this codepoint
  // - badCodepoint = the computed codepoint; outside the UTF-8 range

  Utf8ErrorReason["OUT_OF_RANGE"] = "out of UTF-8 range"; // UTF-8 strings may not contain UTF-16 surrogate pairs
  // - offset       = start of this codepoint
  // - badCodepoint = the computed codepoint; inside the UTF-16 surrogate range

  Utf8ErrorReason["UTF16_SURROGATE"] = "UTF-16 surrogate"; // The string is an overlong representation
  // - offset       = start of this codepoint
  // - badCodepoint = the computed codepoint; already bounds checked

  Utf8ErrorReason["OVERLONG"] = "overlong representation";
})(Utf8ErrorReason || (Utf8ErrorReason = {}));

;

function errorFunc(reason, offset, bytes, output, badCodepoint) {
  return logger.throwArgumentError("invalid codepoint at offset ".concat(offset, "; ").concat(reason), "bytes", bytes);
}

function ignoreFunc(reason, offset, bytes, output, badCodepoint) {
  // If there is an invalid prefix (including stray continuation), skip any additional continuation bytes
  if (reason === Utf8ErrorReason.BAD_PREFIX || reason === Utf8ErrorReason.UNEXPECTED_CONTINUE) {
    var i = 0;

    for (var o = offset + 1; o < bytes.length; o++) {
      if (bytes[o] >> 6 !== 0x02) {
        break;
      }

      i++;
    }

    return i;
  } // This byte runs us past the end of the string, so just jump to the end
  // (but the first byte was read already read and therefore skipped)


  if (reason === Utf8ErrorReason.OVERRUN) {
    return bytes.length - offset - 1;
  } // Nothing to skip


  return 0;
}

function replaceFunc(reason, offset, bytes, output, badCodepoint) {
  // Overlong representations are otherwise "valid" code points; just non-deistingtished
  if (reason === Utf8ErrorReason.OVERLONG) {
    output.push(badCodepoint);
    return 0;
  } // Put the replacement character into the output


  output.push(0xfffd); // Otherwise, process as if ignoring errors

  return ignoreFunc(reason, offset, bytes, output, badCodepoint);
} // Common error handing strategies


var Utf8ErrorFuncs = Object.freeze({
  error: errorFunc,
  ignore: ignoreFunc,
  replace: replaceFunc
}); // http://stackoverflow.com/questions/13356493/decode-utf-8-with-javascript#13691499

function getUtf8CodePoints(bytes, onError) {
  if (onError == null) {
    onError = Utf8ErrorFuncs.error;
  }

  bytes = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.arrayify)(bytes);
  var result = [];
  var i = 0; // Invalid bytes are ignored

  while (i < bytes.length) {
    var c = bytes[i++]; // 0xxx xxxx

    if (c >> 7 === 0) {
      result.push(c);
      continue;
    } // Multibyte; how many bytes left for this character?


    var extraLength = null;
    var overlongMask = null; // 110x xxxx 10xx xxxx

    if ((c & 0xe0) === 0xc0) {
      extraLength = 1;
      overlongMask = 0x7f; // 1110 xxxx 10xx xxxx 10xx xxxx
    } else if ((c & 0xf0) === 0xe0) {
      extraLength = 2;
      overlongMask = 0x7ff; // 1111 0xxx 10xx xxxx 10xx xxxx 10xx xxxx
    } else if ((c & 0xf8) === 0xf0) {
      extraLength = 3;
      overlongMask = 0xffff;
    } else {
      if ((c & 0xc0) === 0x80) {
        i += onError(Utf8ErrorReason.UNEXPECTED_CONTINUE, i - 1, bytes, result);
      } else {
        i += onError(Utf8ErrorReason.BAD_PREFIX, i - 1, bytes, result);
      }

      continue;
    } // Do we have enough bytes in our data?


    if (i - 1 + extraLength >= bytes.length) {
      i += onError(Utf8ErrorReason.OVERRUN, i - 1, bytes, result);
      continue;
    } // Remove the length prefix from the char


    var res = c & (1 << 8 - extraLength - 1) - 1;

    for (var j = 0; j < extraLength; j++) {
      var nextChar = bytes[i]; // Invalid continuation byte

      if ((nextChar & 0xc0) != 0x80) {
        i += onError(Utf8ErrorReason.MISSING_CONTINUE, i, bytes, result);
        res = null;
        break;
      }

      ;
      res = res << 6 | nextChar & 0x3f;
      i++;
    } // See above loop for invalid continuation byte


    if (res === null) {
      continue;
    } // Maximum code point


    if (res > 0x10ffff) {
      i += onError(Utf8ErrorReason.OUT_OF_RANGE, i - 1 - extraLength, bytes, result, res);
      continue;
    } // Reserved for UTF-16 surrogate halves


    if (res >= 0xd800 && res <= 0xdfff) {
      i += onError(Utf8ErrorReason.UTF16_SURROGATE, i - 1 - extraLength, bytes, result, res);
      continue;
    } // Check for overlong sequences (more bytes than needed)


    if (res <= overlongMask) {
      i += onError(Utf8ErrorReason.OVERLONG, i - 1 - extraLength, bytes, result, res);
      continue;
    }

    result.push(res);
  }

  return result;
} // http://stackoverflow.com/questions/18729405/how-to-convert-utf8-string-to-byte-array


function toUtf8Bytes(str) {
  var form = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : UnicodeNormalizationForm.current;

  if (form != UnicodeNormalizationForm.current) {
    logger.checkNormalize();
    str = str.normalize(form);
  }

  var result = [];

  for (var i = 0; i < str.length; i++) {
    var c = str.charCodeAt(i);

    if (c < 0x80) {
      result.push(c);
    } else if (c < 0x800) {
      result.push(c >> 6 | 0xc0);
      result.push(c & 0x3f | 0x80);
    } else if ((c & 0xfc00) == 0xd800) {
      i++;
      var c2 = str.charCodeAt(i);

      if (i >= str.length || (c2 & 0xfc00) !== 0xdc00) {
        throw new Error("invalid utf-8 string");
      } // Surrogate Pair


      var pair = 0x10000 + ((c & 0x03ff) << 10) + (c2 & 0x03ff);
      result.push(pair >> 18 | 0xf0);
      result.push(pair >> 12 & 0x3f | 0x80);
      result.push(pair >> 6 & 0x3f | 0x80);
      result.push(pair & 0x3f | 0x80);
    } else {
      result.push(c >> 12 | 0xe0);
      result.push(c >> 6 & 0x3f | 0x80);
      result.push(c & 0x3f | 0x80);
    }
  }

  return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.arrayify)(result);
}
;

function escapeChar(value) {
  var hex = "0000" + value.toString(16);
  return "\\u" + hex.substring(hex.length - 4);
}

function _toEscapedUtf8String(bytes, onError) {
  return '"' + getUtf8CodePoints(bytes, onError).map(function (codePoint) {
    if (codePoint < 256) {
      switch (codePoint) {
        case 8:
          return "\\b";

        case 9:
          return "\\t";

        case 10:
          return "\\n";

        case 13:
          return "\\r";

        case 34:
          return "\\\"";

        case 92:
          return "\\\\";
      }

      if (codePoint >= 32 && codePoint < 127) {
        return String.fromCharCode(codePoint);
      }
    }

    if (codePoint <= 0xffff) {
      return escapeChar(codePoint);
    }

    codePoint -= 0x10000;
    return escapeChar((codePoint >> 10 & 0x3ff) + 0xd800) + escapeChar((codePoint & 0x3ff) + 0xdc00);
  }).join("") + '"';
}
function _toUtf8String(codePoints) {
  return codePoints.map(function (codePoint) {
    if (codePoint <= 0xffff) {
      return String.fromCharCode(codePoint);
    }

    codePoint -= 0x10000;
    return String.fromCharCode((codePoint >> 10 & 0x3ff) + 0xd800, (codePoint & 0x3ff) + 0xdc00);
  }).join("");
}
function toUtf8String(bytes, onError) {
  return _toUtf8String(getUtf8CodePoints(bytes, onError));
}
function toUtf8CodePoints(str) {
  var form = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : UnicodeNormalizationForm.current;
  return getUtf8CodePoints(toUtf8Bytes(str, form));
}

/***/ }),

/***/ "./node_modules/@ethersproject/transactions/lib.esm/_version.js":
/*!**********************************************************************!*\
  !*** ./node_modules/@ethersproject/transactions/lib.esm/_version.js ***!
  \**********************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "transactions/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/transactions/lib.esm/index.js":
/*!*******************************************************************!*\
  !*** ./node_modules/@ethersproject/transactions/lib.esm/index.js ***!
  \*******************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "TransactionTypes": function() { return /* binding */ TransactionTypes; },
/* harmony export */   "computeAddress": function() { return /* binding */ computeAddress; },
/* harmony export */   "recoverAddress": function() { return /* binding */ recoverAddress; },
/* harmony export */   "accessListify": function() { return /* binding */ accessListify; },
/* harmony export */   "serialize": function() { return /* binding */ serialize; },
/* harmony export */   "parse": function() { return /* binding */ parse; }
/* harmony export */ });
/* harmony import */ var _ethersproject_address__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/address */ "./node_modules/@ethersproject/address/lib.esm/index.js");
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/bignumber.js");
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_constants__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/constants */ "./node_modules/@ethersproject/constants/lib.esm/bignumbers.js");
/* harmony import */ var _ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @ethersproject/keccak256 */ "./node_modules/@ethersproject/keccak256/lib.esm/index.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_rlp__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @ethersproject/rlp */ "./node_modules/@ethersproject/rlp/lib.esm/index.js");
/* harmony import */ var _ethersproject_signing_key__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @ethersproject/signing-key */ "./node_modules/@ethersproject/signing-key/lib.esm/index.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/transactions/lib.esm/_version.js");












var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
var TransactionTypes;

(function (TransactionTypes) {
  TransactionTypes[TransactionTypes["legacy"] = 0] = "legacy";
  TransactionTypes[TransactionTypes["eip2930"] = 1] = "eip2930";
  TransactionTypes[TransactionTypes["eip1559"] = 2] = "eip1559";
})(TransactionTypes || (TransactionTypes = {}));

; ///////////////////////////////

function handleAddress(value) {
  if (value === "0x") {
    return null;
  }

  return (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_2__.getAddress)(value);
}

function handleNumber(value) {
  if (value === "0x") {
    return _ethersproject_constants__WEBPACK_IMPORTED_MODULE_3__.Zero;
  }

  return _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(value);
} // Legacy Transaction Fields


var transactionFields = [{
  name: "nonce",
  maxLength: 32,
  numeric: true
}, {
  name: "gasPrice",
  maxLength: 32,
  numeric: true
}, {
  name: "gasLimit",
  maxLength: 32,
  numeric: true
}, {
  name: "to",
  length: 20
}, {
  name: "value",
  maxLength: 32,
  numeric: true
}, {
  name: "data"
}];
var allowedTransactionKeys = {
  chainId: true,
  data: true,
  gasLimit: true,
  gasPrice: true,
  nonce: true,
  to: true,
  type: true,
  value: true
};
function computeAddress(key) {
  var publicKey = (0,_ethersproject_signing_key__WEBPACK_IMPORTED_MODULE_5__.computePublicKey)(key);
  return (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_2__.getAddress)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexDataSlice)((0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_7__.keccak256)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexDataSlice)(publicKey, 1)), 12));
}
function recoverAddress(digest, signature) {
  return computeAddress((0,_ethersproject_signing_key__WEBPACK_IMPORTED_MODULE_5__.recoverPublicKey)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.arrayify)(digest), signature));
}

function formatNumber(value, name) {
  var result = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.stripZeros)(_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(value).toHexString());

  if (result.length > 32) {
    logger.throwArgumentError("invalid length for " + name, "transaction:" + name, value);
  }

  return result;
}

function accessSetify(addr, storageKeys) {
  return {
    address: (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_2__.getAddress)(addr),
    storageKeys: (storageKeys || []).map(function (storageKey, index) {
      if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexDataLength)(storageKey) !== 32) {
        logger.throwArgumentError("invalid access list storageKey", "accessList[".concat(addr, ":").concat(index, "]"), storageKey);
      }

      return storageKey.toLowerCase();
    })
  };
}

function accessListify(value) {
  if (Array.isArray(value)) {
    return value.map(function (set, index) {
      if (Array.isArray(set)) {
        if (set.length > 2) {
          logger.throwArgumentError("access list expected to be [ address, storageKeys[] ]", "value[".concat(index, "]"), set);
        }

        return accessSetify(set[0], set[1]);
      }

      return accessSetify(set.address, set.storageKeys);
    });
  }

  var result = Object.keys(value).map(function (addr) {
    var storageKeys = value[addr].reduce(function (accum, storageKey) {
      accum[storageKey] = true;
      return accum;
    }, {});
    return accessSetify(addr, Object.keys(storageKeys).sort());
  });
  result.sort(function (a, b) {
    return a.address.localeCompare(b.address);
  });
  return result;
}

function formatAccessList(value) {
  return accessListify(value).map(function (set) {
    return [set.address, set.storageKeys];
  });
}

function _serializeEip1559(transaction, signature) {
  // If there is an explicit gasPrice, make sure it matches the
  // EIP-1559 fees; otherwise they may not understand what they
  // think they are setting in terms of fee.
  if (transaction.gasPrice != null) {
    var gasPrice = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(transaction.gasPrice);
    var maxFeePerGas = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(transaction.maxFeePerGas || 0);

    if (!gasPrice.eq(maxFeePerGas)) {
      logger.throwArgumentError("mismatch EIP-1559 gasPrice != maxFeePerGas", "tx", {
        gasPrice: gasPrice,
        maxFeePerGas: maxFeePerGas
      });
    }
  }

  var fields = [formatNumber(transaction.chainId || 0, "chainId"), formatNumber(transaction.nonce || 0, "nonce"), formatNumber(transaction.maxPriorityFeePerGas || 0, "maxPriorityFeePerGas"), formatNumber(transaction.maxFeePerGas || 0, "maxFeePerGas"), formatNumber(transaction.gasLimit || 0, "gasLimit"), transaction.to != null ? (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_2__.getAddress)(transaction.to) : "0x", formatNumber(transaction.value || 0, "value"), transaction.data || "0x", formatAccessList(transaction.accessList || [])];

  if (signature) {
    var sig = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.splitSignature)(signature);
    fields.push(formatNumber(sig.recoveryParam, "recoveryParam"));
    fields.push((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.stripZeros)(sig.r));
    fields.push((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.stripZeros)(sig.s));
  }

  return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexConcat)(["0x02", _ethersproject_rlp__WEBPACK_IMPORTED_MODULE_8__.encode(fields)]);
}

function _serializeEip2930(transaction, signature) {
  var fields = [formatNumber(transaction.chainId || 0, "chainId"), formatNumber(transaction.nonce || 0, "nonce"), formatNumber(transaction.gasPrice || 0, "gasPrice"), formatNumber(transaction.gasLimit || 0, "gasLimit"), transaction.to != null ? (0,_ethersproject_address__WEBPACK_IMPORTED_MODULE_2__.getAddress)(transaction.to) : "0x", formatNumber(transaction.value || 0, "value"), transaction.data || "0x", formatAccessList(transaction.accessList || [])];

  if (signature) {
    var sig = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.splitSignature)(signature);
    fields.push(formatNumber(sig.recoveryParam, "recoveryParam"));
    fields.push((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.stripZeros)(sig.r));
    fields.push((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.stripZeros)(sig.s));
  }

  return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexConcat)(["0x01", _ethersproject_rlp__WEBPACK_IMPORTED_MODULE_8__.encode(fields)]);
} // Legacy Transactions and EIP-155


function _serialize(transaction, signature) {
  (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_9__.checkProperties)(transaction, allowedTransactionKeys);
  var raw = [];
  transactionFields.forEach(function (fieldInfo) {
    var value = transaction[fieldInfo.name] || [];
    var options = {};

    if (fieldInfo.numeric) {
      options.hexPad = "left";
    }

    value = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.arrayify)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexlify)(value, options)); // Fixed-width field

    if (fieldInfo.length && value.length !== fieldInfo.length && value.length > 0) {
      logger.throwArgumentError("invalid length for " + fieldInfo.name, "transaction:" + fieldInfo.name, value);
    } // Variable-width (with a maximum)


    if (fieldInfo.maxLength) {
      value = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.stripZeros)(value);

      if (value.length > fieldInfo.maxLength) {
        logger.throwArgumentError("invalid length for " + fieldInfo.name, "transaction:" + fieldInfo.name, value);
      }
    }

    raw.push((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexlify)(value));
  });
  var chainId = 0;

  if (transaction.chainId != null) {
    // A chainId was provided; if non-zero we'll use EIP-155
    chainId = transaction.chainId;

    if (typeof chainId !== "number") {
      logger.throwArgumentError("invalid transaction.chainId", "transaction", transaction);
    }
  } else if (signature && !(0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.isBytesLike)(signature) && signature.v > 28) {
    // No chainId provided, but the signature is signing with EIP-155; derive chainId
    chainId = Math.floor((signature.v - 35) / 2);
  } // We have an EIP-155 transaction (chainId was specified and non-zero)


  if (chainId !== 0) {
    raw.push((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexlify)(chainId)); // @TODO: hexValue?

    raw.push("0x");
    raw.push("0x");
  } // Requesting an unsigned transaction


  if (!signature) {
    return _ethersproject_rlp__WEBPACK_IMPORTED_MODULE_8__.encode(raw);
  } // The splitSignature will ensure the transaction has a recoveryParam in the
  // case that the signTransaction function only adds a v.


  var sig = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.splitSignature)(signature); // We pushed a chainId and null r, s on for hashing only; remove those

  var v = 27 + sig.recoveryParam;

  if (chainId !== 0) {
    raw.pop();
    raw.pop();
    raw.pop();
    v += chainId * 2 + 8; // If an EIP-155 v (directly or indirectly; maybe _vs) was provided, check it!

    if (sig.v > 28 && sig.v !== v) {
      logger.throwArgumentError("transaction.chainId/signature.v mismatch", "signature", signature);
    }
  } else if (sig.v !== v) {
    logger.throwArgumentError("transaction.chainId/signature.v mismatch", "signature", signature);
  }

  raw.push((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexlify)(v));
  raw.push((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.stripZeros)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.arrayify)(sig.r)));
  raw.push((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.stripZeros)((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.arrayify)(sig.s)));
  return _ethersproject_rlp__WEBPACK_IMPORTED_MODULE_8__.encode(raw);
}

function serialize(transaction, signature) {
  // Legacy and EIP-155 Transactions
  if (transaction.type == null || transaction.type === 0) {
    if (transaction.accessList != null) {
      logger.throwArgumentError("untyped transactions do not support accessList; include type: 1", "transaction", transaction);
    }

    return _serialize(transaction, signature);
  } // Typed Transactions (EIP-2718)


  switch (transaction.type) {
    case 1:
      return _serializeEip2930(transaction, signature);

    case 2:
      return _serializeEip1559(transaction, signature);

    default:
      break;
  }

  return logger.throwError("unsupported transaction type: ".concat(transaction.type), _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
    operation: "serializeTransaction",
    transactionType: transaction.type
  });
}

function _parseEipSignature(tx, fields, serialize) {
  try {
    var recid = handleNumber(fields[0]).toNumber();

    if (recid !== 0 && recid !== 1) {
      throw new Error("bad recid");
    }

    tx.v = recid;
  } catch (error) {
    logger.throwArgumentError("invalid v for transaction type: 1", "v", fields[0]);
  }

  tx.r = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexZeroPad)(fields[1], 32);
  tx.s = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexZeroPad)(fields[2], 32);

  try {
    var digest = (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_7__.keccak256)(serialize(tx));
    tx.from = recoverAddress(digest, {
      r: tx.r,
      s: tx.s,
      recoveryParam: tx.v
    });
  } catch (error) {
    console.log(error);
  }
}

function _parseEip1559(payload) {
  var transaction = _ethersproject_rlp__WEBPACK_IMPORTED_MODULE_8__.decode(payload.slice(1));

  if (transaction.length !== 9 && transaction.length !== 12) {
    logger.throwArgumentError("invalid component count for transaction type: 2", "payload", (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexlify)(payload));
  }

  var maxPriorityFeePerGas = handleNumber(transaction[2]);
  var maxFeePerGas = handleNumber(transaction[3]);
  var tx = {
    type: 2,
    chainId: handleNumber(transaction[0]).toNumber(),
    nonce: handleNumber(transaction[1]).toNumber(),
    maxPriorityFeePerGas: maxPriorityFeePerGas,
    maxFeePerGas: maxFeePerGas,
    gasPrice: null,
    gasLimit: handleNumber(transaction[4]),
    to: handleAddress(transaction[5]),
    value: handleNumber(transaction[6]),
    data: transaction[7],
    accessList: accessListify(transaction[8])
  }; // Unsigned EIP-1559 Transaction

  if (transaction.length === 9) {
    return tx;
  }

  tx.hash = (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_7__.keccak256)(payload);

  _parseEipSignature(tx, transaction.slice(9), _serializeEip1559);

  return tx;
}

function _parseEip2930(payload) {
  var transaction = _ethersproject_rlp__WEBPACK_IMPORTED_MODULE_8__.decode(payload.slice(1));

  if (transaction.length !== 8 && transaction.length !== 11) {
    logger.throwArgumentError("invalid component count for transaction type: 1", "payload", (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexlify)(payload));
  }

  var tx = {
    type: 1,
    chainId: handleNumber(transaction[0]).toNumber(),
    nonce: handleNumber(transaction[1]).toNumber(),
    gasPrice: handleNumber(transaction[2]),
    gasLimit: handleNumber(transaction[3]),
    to: handleAddress(transaction[4]),
    value: handleNumber(transaction[5]),
    data: transaction[6],
    accessList: accessListify(transaction[7])
  }; // Unsigned EIP-2930 Transaction

  if (transaction.length === 8) {
    return tx;
  }

  tx.hash = (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_7__.keccak256)(payload);

  _parseEipSignature(tx, transaction.slice(8), _serializeEip2930);

  return tx;
} // Legacy Transactions and EIP-155


function _parse(rawTransaction) {
  var transaction = _ethersproject_rlp__WEBPACK_IMPORTED_MODULE_8__.decode(rawTransaction);

  if (transaction.length !== 9 && transaction.length !== 6) {
    logger.throwArgumentError("invalid raw transaction", "rawTransaction", rawTransaction);
  }

  var tx = {
    nonce: handleNumber(transaction[0]).toNumber(),
    gasPrice: handleNumber(transaction[1]),
    gasLimit: handleNumber(transaction[2]),
    to: handleAddress(transaction[3]),
    value: handleNumber(transaction[4]),
    data: transaction[5],
    chainId: 0
  }; // Legacy unsigned transaction

  if (transaction.length === 6) {
    return tx;
  }

  try {
    tx.v = _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(transaction[6]).toNumber();
  } catch (error) {
    console.log(error);
    return tx;
  }

  tx.r = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexZeroPad)(transaction[7], 32);
  tx.s = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexZeroPad)(transaction[8], 32);

  if (_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(tx.r).isZero() && _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_4__.BigNumber.from(tx.s).isZero()) {
    // EIP-155 unsigned transaction
    tx.chainId = tx.v;
    tx.v = 0;
  } else {
    // Signed Transaction
    tx.chainId = Math.floor((tx.v - 35) / 2);

    if (tx.chainId < 0) {
      tx.chainId = 0;
    }

    var recoveryParam = tx.v - 27;
    var raw = transaction.slice(0, 6);

    if (tx.chainId !== 0) {
      raw.push((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexlify)(tx.chainId));
      raw.push("0x");
      raw.push("0x");
      recoveryParam -= tx.chainId * 2 + 8;
    }

    var digest = (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_7__.keccak256)(_ethersproject_rlp__WEBPACK_IMPORTED_MODULE_8__.encode(raw));

    try {
      tx.from = recoverAddress(digest, {
        r: (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexlify)(tx.r),
        s: (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.hexlify)(tx.s),
        recoveryParam: recoveryParam
      });
    } catch (error) {
      console.log(error);
    }

    tx.hash = (0,_ethersproject_keccak256__WEBPACK_IMPORTED_MODULE_7__.keccak256)(rawTransaction);
  }

  tx.type = null;
  return tx;
}

function parse(rawTransaction) {
  var payload = (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_6__.arrayify)(rawTransaction); // Legacy and EIP-155 Transactions

  if (payload[0] > 0x7f) {
    return _parse(payload);
  } // Typed Transaction (EIP-2718)


  switch (payload[0]) {
    case 1:
      return _parseEip2930(payload);

    case 2:
      return _parseEip1559(payload);

    default:
      break;
  }

  return logger.throwError("unsupported transaction type: ".concat(payload[0]), _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.UNSUPPORTED_OPERATION, {
    operation: "parseTransaction",
    transactionType: payload[0]
  });
}

/***/ }),

/***/ "./node_modules/@ethersproject/units/lib.esm/_version.js":
/*!***************************************************************!*\
  !*** ./node_modules/@ethersproject/units/lib.esm/_version.js ***!
  \***************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "units/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/units/lib.esm/index.js":
/*!************************************************************!*\
  !*** ./node_modules/@ethersproject/units/lib.esm/index.js ***!
  \************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "commify": function() { return /* binding */ commify; },
/* harmony export */   "formatUnits": function() { return /* binding */ formatUnits; },
/* harmony export */   "parseUnits": function() { return /* binding */ parseUnits; },
/* harmony export */   "formatEther": function() { return /* binding */ formatEther; },
/* harmony export */   "parseEther": function() { return /* binding */ parseEther; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/bignumber */ "./node_modules/@ethersproject/bignumber/lib.esm/fixednumber.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/units/lib.esm/_version.js");





var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);
var names = ["wei", "kwei", "mwei", "gwei", "szabo", "finney", "ether"]; // Some environments have issues with RegEx that contain back-tracking, so we cannot
// use them.

function commify(value) {
  var comps = String(value).split(".");

  if (comps.length > 2 || !comps[0].match(/^-?[0-9]*$/) || comps[1] && !comps[1].match(/^[0-9]*$/) || value === "." || value === "-.") {
    logger.throwArgumentError("invalid value", "value", value);
  } // Make sure we have at least one whole digit (0 if none)


  var whole = comps[0];
  var negative = "";

  if (whole.substring(0, 1) === "-") {
    negative = "-";
    whole = whole.substring(1);
  } // Make sure we have at least 1 whole digit with no leading zeros


  while (whole.substring(0, 1) === "0") {
    whole = whole.substring(1);
  }

  if (whole === "") {
    whole = "0";
  }

  var suffix = "";

  if (comps.length === 2) {
    suffix = "." + (comps[1] || "0");
  }

  while (suffix.length > 2 && suffix[suffix.length - 1] === "0") {
    suffix = suffix.substring(0, suffix.length - 1);
  }

  var formatted = [];

  while (whole.length) {
    if (whole.length <= 3) {
      formatted.unshift(whole);
      break;
    } else {
      var index = whole.length - 3;
      formatted.unshift(whole.substring(index));
      whole = whole.substring(0, index);
    }
  }

  return negative + formatted.join(",") + suffix;
}
function formatUnits(value, unitName) {
  if (typeof unitName === "string") {
    var index = names.indexOf(unitName);

    if (index !== -1) {
      unitName = 3 * index;
    }
  }

  return (0,_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_2__.formatFixed)(value, unitName != null ? unitName : 18);
}
function parseUnits(value, unitName) {
  if (typeof value !== "string") {
    logger.throwArgumentError("value must be a string", "value", value);
  }

  if (typeof unitName === "string") {
    var index = names.indexOf(unitName);

    if (index !== -1) {
      unitName = 3 * index;
    }
  }

  return (0,_ethersproject_bignumber__WEBPACK_IMPORTED_MODULE_2__.parseFixed)(value, unitName != null ? unitName : 18);
}
function formatEther(wei) {
  return formatUnits(wei, 18);
}
function parseEther(ether) {
  return parseUnits(ether, 18);
}

/***/ }),

/***/ "./node_modules/@ethersproject/web/lib.esm/_version.js":
/*!*************************************************************!*\
  !*** ./node_modules/@ethersproject/web/lib.esm/_version.js ***!
  \*************************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "version": function() { return /* binding */ version; }
/* harmony export */ });
var version = "web/5.6.0";

/***/ }),

/***/ "./node_modules/@ethersproject/web/lib.esm/geturl.js":
/*!***********************************************************!*\
  !*** ./node_modules/@ethersproject/web/lib.esm/geturl.js ***!
  \***********************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getUrl": function() { return /* binding */ getUrl; }
/* harmony export */ });
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");


var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};


function getUrl(href, options) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var request, response, body, headers;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (options == null) {
              options = {};
            }

            request = {
              method: options.method || "GET",
              headers: options.headers || {},
              body: options.body || undefined
            };

            if (options.skipFetchSetup !== true) {
              request.mode = "cors"; // no-cors, cors, *same-origin

              request.cache = "no-cache"; // *default, no-cache, reload, force-cache, only-if-cached

              request.credentials = "same-origin"; // include, *same-origin, omit

              request.redirect = "follow"; // manual, *follow, error

              request.referrer = "client"; // no-referrer, *client
            }

            ;
            _context.next = 6;
            return fetch(href, request);

          case 6:
            response = _context.sent;
            _context.next = 9;
            return response.arrayBuffer();

          case 9:
            body = _context.sent;
            headers = {};

            if (response.headers.forEach) {
              response.headers.forEach(function (value, key) {
                headers[key.toLowerCase()] = value;
              });
            } else {
              response.headers.keys().forEach(function (key) {
                headers[key.toLowerCase()] = response.headers.get(key);
              });
            }

            return _context.abrupt("return", {
              headers: headers,
              statusCode: response.status,
              statusMessage: response.statusText,
              body: (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_0__.arrayify)(new Uint8Array(body))
            });

          case 13:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
}

/***/ }),

/***/ "./node_modules/@ethersproject/web/lib.esm/index.js":
/*!**********************************************************!*\
  !*** ./node_modules/@ethersproject/web/lib.esm/index.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "_fetchData": function() { return /* binding */ _fetchData; },
/* harmony export */   "fetchJson": function() { return /* binding */ fetchJson; },
/* harmony export */   "poll": function() { return /* binding */ poll; }
/* harmony export */ });
/* harmony import */ var _ethersproject_base64__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @ethersproject/base64 */ "./node_modules/@ethersproject/base64/lib.esm/base64.js");
/* harmony import */ var _ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ethersproject/bytes */ "./node_modules/@ethersproject/bytes/lib.esm/index.js");
/* harmony import */ var _ethersproject_properties__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @ethersproject/properties */ "./node_modules/@ethersproject/properties/lib.esm/index.js");
/* harmony import */ var _ethersproject_strings__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ethersproject/strings */ "./node_modules/@ethersproject/strings/lib.esm/utf8.js");
/* harmony import */ var _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @ethersproject/logger */ "./node_modules/@ethersproject/logger/lib.esm/index.js");
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./_version */ "./node_modules/@ethersproject/web/lib.esm/_version.js");
/* harmony import */ var _geturl__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./geturl */ "./node_modules/@ethersproject/web/lib.esm/geturl.js");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};







var logger = new _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger(_version__WEBPACK_IMPORTED_MODULE_1__.version);


function staller(duration) {
  return new Promise(function (resolve) {
    setTimeout(resolve, duration);
  });
}

function bodyify(value, type) {
  if (value == null) {
    return null;
  }

  if (typeof value === "string") {
    return value;
  }

  if ((0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.isBytesLike)(value)) {
    if (type && (type.split("/")[0] === "text" || type.split(";")[0].trim() === "application/json")) {
      try {
        return (0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_3__.toUtf8String)(value);
      } catch (error) {}

      ;
    }

    return (0,_ethersproject_bytes__WEBPACK_IMPORTED_MODULE_2__.hexlify)(value);
  }

  return value;
} // This API is still a work in progress; the future changes will likely be:
// - ConnectionInfo => FetchDataRequest<T = any>
// - FetchDataRequest.body? = string | Uint8Array | { contentType: string, data: string | Uint8Array }
//   - If string => text/plain, Uint8Array => application/octet-stream (if content-type unspecified)
// - FetchDataRequest.processFunc = (body: Uint8Array, response: FetchDataResponse) => T
// For this reason, it should be considered internal until the API is finalized


function _fetchData(connection, body, processFunc) {
  // How many times to retry in the event of a throttle
  var attemptLimit = _typeof(connection) === "object" && connection.throttleLimit != null ? connection.throttleLimit : 12;
  logger.assertArgument(attemptLimit > 0 && attemptLimit % 1 === 0, "invalid connection throttle limit", "connection.throttleLimit", attemptLimit);
  var throttleCallback = _typeof(connection) === "object" ? connection.throttleCallback : null;
  var throttleSlotInterval = _typeof(connection) === "object" && typeof connection.throttleSlotInterval === "number" ? connection.throttleSlotInterval : 100;
  logger.assertArgument(throttleSlotInterval > 0 && throttleSlotInterval % 1 === 0, "invalid connection throttle slot interval", "connection.throttleSlotInterval", throttleSlotInterval);
  var errorPassThrough = _typeof(connection) === "object" ? !!connection.errorPassThrough : false;
  var headers = {};
  var url = null; // @TODO: Allow ConnectionInfo to override some of these values

  var options = {
    method: "GET"
  };
  var allow304 = false;
  var timeout = 2 * 60 * 1000;

  if (typeof connection === "string") {
    url = connection;
  } else if (_typeof(connection) === "object") {
    if (connection == null || connection.url == null) {
      logger.throwArgumentError("missing URL", "connection.url", connection);
    }

    url = connection.url;

    if (typeof connection.timeout === "number" && connection.timeout > 0) {
      timeout = connection.timeout;
    }

    if (connection.headers) {
      for (var key in connection.headers) {
        headers[key.toLowerCase()] = {
          key: key,
          value: String(connection.headers[key])
        };

        if (["if-none-match", "if-modified-since"].indexOf(key.toLowerCase()) >= 0) {
          allow304 = true;
        }
      }
    }

    options.allowGzip = !!connection.allowGzip;

    if (connection.user != null && connection.password != null) {
      if (url.substring(0, 6) !== "https:" && connection.allowInsecureAuthentication !== true) {
        logger.throwError("basic authentication requires a secure https url", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.INVALID_ARGUMENT, {
          argument: "url",
          url: url,
          user: connection.user,
          password: "[REDACTED]"
        });
      }

      var authorization = connection.user + ":" + connection.password;
      headers["authorization"] = {
        key: "Authorization",
        value: "Basic " + (0,_ethersproject_base64__WEBPACK_IMPORTED_MODULE_4__.encode)((0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_3__.toUtf8Bytes)(authorization))
      };
    }

    if (connection.skipFetchSetup != null) {
      options.skipFetchSetup = !!connection.skipFetchSetup;
    }
  }

  var reData = new RegExp("^data:([a-z0-9-]+/[a-z0-9-]+);base64,(.*)$", "i");
  var dataMatch = url ? url.match(reData) : null;

  if (dataMatch) {
    try {
      var response = {
        statusCode: 200,
        statusMessage: "OK",
        headers: {
          "content-type": dataMatch[1]
        },
        body: (0,_ethersproject_base64__WEBPACK_IMPORTED_MODULE_4__.decode)(dataMatch[2])
      };
      var result = response.body;

      if (processFunc) {
        result = processFunc(response.body, response);
      }

      return Promise.resolve(result);
    } catch (error) {
      logger.throwError("processing response error", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.SERVER_ERROR, {
        body: bodyify(dataMatch[1], dataMatch[2]),
        error: error,
        requestBody: null,
        requestMethod: "GET",
        url: url
      });
    }
  }

  if (body) {
    options.method = "POST";
    options.body = body;

    if (headers["content-type"] == null) {
      headers["content-type"] = {
        key: "Content-Type",
        value: "application/octet-stream"
      };
    }

    if (headers["content-length"] == null) {
      headers["content-length"] = {
        key: "Content-Length",
        value: String(body.length)
      };
    }
  }

  var flatHeaders = {};
  Object.keys(headers).forEach(function (key) {
    var header = headers[key];
    flatHeaders[header.key] = header.value;
  });
  options.headers = flatHeaders;

  var runningTimeout = function () {
    var timer = null;
    var promise = new Promise(function (resolve, reject) {
      if (timeout) {
        timer = setTimeout(function () {
          if (timer == null) {
            return;
          }

          timer = null;
          reject(logger.makeError("timeout", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.TIMEOUT, {
            requestBody: bodyify(options.body, flatHeaders["content-type"]),
            requestMethod: options.method,
            timeout: timeout,
            url: url
          }));
        }, timeout);
      }
    });

    var cancel = function cancel() {
      if (timer == null) {
        return;
      }

      clearTimeout(timer);
      timer = null;
    };

    return {
      promise: promise,
      cancel: cancel
    };
  }();

  var runningFetch = function () {
    return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var attempt, _response, location, tryAgain, stall, retryAfter, _body, _result, _tryAgain, _timeout;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              attempt = 0;

            case 1:
              if (!(attempt < attemptLimit)) {
                _context.next = 65;
                break;
              }

              _response = null;
              _context.prev = 3;
              _context.next = 6;
              return (0,_geturl__WEBPACK_IMPORTED_MODULE_5__.getUrl)(url, options);

            case 6:
              _response = _context.sent;

              if (!(attempt < attemptLimit)) {
                _context.next = 28;
                break;
              }

              if (!(_response.statusCode === 301 || _response.statusCode === 302)) {
                _context.next = 15;
                break;
              }

              // Redirection; for now we only support absolute locataions
              location = _response.headers.location || "";

              if (!(options.method === "GET" && location.match(/^https:/))) {
                _context.next = 13;
                break;
              }

              url = _response.headers.location;
              return _context.abrupt("continue", 62);

            case 13:
              _context.next = 28;
              break;

            case 15:
              if (!(_response.statusCode === 429)) {
                _context.next = 28;
                break;
              }

              // Exponential back-off throttling
              tryAgain = true;

              if (!throttleCallback) {
                _context.next = 21;
                break;
              }

              _context.next = 20;
              return throttleCallback(attempt, url);

            case 20:
              tryAgain = _context.sent;

            case 21:
              if (!tryAgain) {
                _context.next = 28;
                break;
              }

              stall = 0;
              retryAfter = _response.headers["retry-after"];

              if (typeof retryAfter === "string" && retryAfter.match(/^[1-9][0-9]*$/)) {
                stall = parseInt(retryAfter) * 1000;
              } else {
                stall = throttleSlotInterval * parseInt(String(Math.random() * Math.pow(2, attempt)));
              } //console.log("Stalling 429");


              _context.next = 27;
              return staller(stall);

            case 27:
              return _context.abrupt("continue", 62);

            case 28:
              _context.next = 34;
              break;

            case 30:
              _context.prev = 30;
              _context.t0 = _context["catch"](3);
              _response = _context.t0.response;

              if (_response == null) {
                runningTimeout.cancel();
                logger.throwError("missing response", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.SERVER_ERROR, {
                  requestBody: bodyify(options.body, flatHeaders["content-type"]),
                  requestMethod: options.method,
                  serverError: _context.t0,
                  url: url
                });
              }

            case 34:
              _body = _response.body;

              if (allow304 && _response.statusCode === 304) {
                _body = null;
              } else if (!errorPassThrough && (_response.statusCode < 200 || _response.statusCode >= 300)) {
                runningTimeout.cancel();
                logger.throwError("bad response", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.SERVER_ERROR, {
                  status: _response.statusCode,
                  headers: _response.headers,
                  body: bodyify(_body, _response.headers ? _response.headers["content-type"] : null),
                  requestBody: bodyify(options.body, flatHeaders["content-type"]),
                  requestMethod: options.method,
                  url: url
                });
              }

              if (!processFunc) {
                _context.next = 60;
                break;
              }

              _context.prev = 37;
              _context.next = 40;
              return processFunc(_body, _response);

            case 40:
              _result = _context.sent;
              runningTimeout.cancel();
              return _context.abrupt("return", _result);

            case 45:
              _context.prev = 45;
              _context.t1 = _context["catch"](37);

              if (!(_context.t1.throttleRetry && attempt < attemptLimit)) {
                _context.next = 58;
                break;
              }

              _tryAgain = true;

              if (!throttleCallback) {
                _context.next = 53;
                break;
              }

              _context.next = 52;
              return throttleCallback(attempt, url);

            case 52:
              _tryAgain = _context.sent;

            case 53:
              if (!_tryAgain) {
                _context.next = 58;
                break;
              }

              _timeout = throttleSlotInterval * parseInt(String(Math.random() * Math.pow(2, attempt))); //console.log("Stalling callback");

              _context.next = 57;
              return staller(_timeout);

            case 57:
              return _context.abrupt("continue", 62);

            case 58:
              runningTimeout.cancel();
              logger.throwError("processing response error", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.SERVER_ERROR, {
                body: bodyify(_body, _response.headers ? _response.headers["content-type"] : null),
                error: _context.t1,
                requestBody: bodyify(options.body, flatHeaders["content-type"]),
                requestMethod: options.method,
                url: url
              });

            case 60:
              runningTimeout.cancel(); // If we had a processFunc, it either returned a T or threw above.
              // The "body" is now a Uint8Array.

              return _context.abrupt("return", _body);

            case 62:
              attempt++;
              _context.next = 1;
              break;

            case 65:
              return _context.abrupt("return", logger.throwError("failed response", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.SERVER_ERROR, {
                requestBody: bodyify(options.body, flatHeaders["content-type"]),
                requestMethod: options.method,
                url: url
              }));

            case 66:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[3, 30], [37, 45]]);
    }));
  }();

  return Promise.race([runningTimeout.promise, runningFetch]);
}
function fetchJson(connection, json, processFunc) {
  var processJsonFunc = function processJsonFunc(value, response) {
    var result = null;

    if (value != null) {
      try {
        result = JSON.parse((0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_3__.toUtf8String)(value));
      } catch (error) {
        logger.throwError("invalid JSON", _ethersproject_logger__WEBPACK_IMPORTED_MODULE_0__.Logger.errors.SERVER_ERROR, {
          body: value,
          error: error
        });
      }
    }

    if (processFunc) {
      result = processFunc(result, response);
    }

    return result;
  }; // If we have json to send, we must
  // - add content-type of application/json (unless already overridden)
  // - convert the json to bytes


  var body = null;

  if (json != null) {
    body = (0,_ethersproject_strings__WEBPACK_IMPORTED_MODULE_3__.toUtf8Bytes)(json); // Create a connection with the content-type set for JSON

    var updated = typeof connection === "string" ? {
      url: connection
    } : (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_6__.shallowCopy)(connection);

    if (updated.headers) {
      var hasContentType = Object.keys(updated.headers).filter(function (k) {
        return k.toLowerCase() === "content-type";
      }).length !== 0;

      if (!hasContentType) {
        updated.headers = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_6__.shallowCopy)(updated.headers);
        updated.headers["content-type"] = "application/json";
      }
    } else {
      updated.headers = {
        "content-type": "application/json"
      };
    }

    connection = updated;
  }

  return _fetchData(connection, body, processJsonFunc);
}
function poll(func, options) {
  if (!options) {
    options = {};
  }

  options = (0,_ethersproject_properties__WEBPACK_IMPORTED_MODULE_6__.shallowCopy)(options);

  if (options.floor == null) {
    options.floor = 0;
  }

  if (options.ceiling == null) {
    options.ceiling = 10000;
  }

  if (options.interval == null) {
    options.interval = 250;
  }

  return new Promise(function (resolve, reject) {
    var timer = null;
    var done = false; // Returns true if cancel was successful. Unsuccessful cancel means we're already done.

    var cancel = function cancel() {
      if (done) {
        return false;
      }

      done = true;

      if (timer) {
        clearTimeout(timer);
      }

      return true;
    };

    if (options.timeout) {
      timer = setTimeout(function () {
        if (cancel()) {
          reject(new Error("timeout"));
        }
      }, options.timeout);
    }

    var retryLimit = options.retryLimit;
    var attempt = 0;

    function check() {
      return func().then(function (result) {
        // If we have a result, or are allowed null then we're done
        if (result !== undefined) {
          if (cancel()) {
            resolve(result);
          }
        } else if (options.oncePoll) {
          options.oncePoll.once("poll", check);
        } else if (options.onceBlock) {
          options.onceBlock.once("block", check); // Otherwise, exponential back-off (up to 10s) our next request
        } else if (!done) {
          attempt++;

          if (attempt > retryLimit) {
            if (cancel()) {
              reject(new Error("retry limit reached"));
            }

            return;
          }

          var timeout = options.interval * parseInt(String(Math.random() * Math.pow(2, attempt)));

          if (timeout < options.floor) {
            timeout = options.floor;
          }

          if (timeout > options.ceiling) {
            timeout = options.ceiling;
          }

          setTimeout(check, timeout);
        }

        return null;
      }, function (error) {
        if (cancel()) {
          reject(error);
        }
      });
    }

    check();
  });
}

/***/ }),

/***/ "./node_modules/bech32/index.js":
/*!**************************************!*\
  !*** ./node_modules/bech32/index.js ***!
  \**************************************/
/***/ (function(module) {

"use strict";


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var ALPHABET = 'qpzry9x8gf2tvdw0s3jn54khce6mua7l'; // pre-compute lookup table

var ALPHABET_MAP = {};

for (var z = 0; z < ALPHABET.length; z++) {
  var x = ALPHABET.charAt(z);
  if (ALPHABET_MAP[x] !== undefined) throw new TypeError(x + ' is ambiguous');
  ALPHABET_MAP[x] = z;
}

function polymodStep(pre) {
  var b = pre >> 25;
  return (pre & 0x1FFFFFF) << 5 ^ -(b >> 0 & 1) & 0x3b6a57b2 ^ -(b >> 1 & 1) & 0x26508e6d ^ -(b >> 2 & 1) & 0x1ea119fa ^ -(b >> 3 & 1) & 0x3d4233dd ^ -(b >> 4 & 1) & 0x2a1462b3;
}

function prefixChk(prefix) {
  var chk = 1;

  for (var i = 0; i < prefix.length; ++i) {
    var c = prefix.charCodeAt(i);
    if (c < 33 || c > 126) return 'Invalid prefix (' + prefix + ')';
    chk = polymodStep(chk) ^ c >> 5;
  }

  chk = polymodStep(chk);

  for (i = 0; i < prefix.length; ++i) {
    var v = prefix.charCodeAt(i);
    chk = polymodStep(chk) ^ v & 0x1f;
  }

  return chk;
}

function encode(prefix, words, LIMIT) {
  LIMIT = LIMIT || 90;
  if (prefix.length + 7 + words.length > LIMIT) throw new TypeError('Exceeds length limit');
  prefix = prefix.toLowerCase(); // determine chk mod

  var chk = prefixChk(prefix);
  if (typeof chk === 'string') throw new Error(chk);
  var result = prefix + '1';

  for (var i = 0; i < words.length; ++i) {
    var x = words[i];
    if (x >> 5 !== 0) throw new Error('Non 5-bit word');
    chk = polymodStep(chk) ^ x;
    result += ALPHABET.charAt(x);
  }

  for (i = 0; i < 6; ++i) {
    chk = polymodStep(chk);
  }

  chk ^= 1;

  for (i = 0; i < 6; ++i) {
    var v = chk >> (5 - i) * 5 & 0x1f;
    result += ALPHABET.charAt(v);
  }

  return result;
}

function __decode(str, LIMIT) {
  LIMIT = LIMIT || 90;
  if (str.length < 8) return str + ' too short';
  if (str.length > LIMIT) return 'Exceeds length limit'; // don't allow mixed case

  var lowered = str.toLowerCase();
  var uppered = str.toUpperCase();
  if (str !== lowered && str !== uppered) return 'Mixed-case string ' + str;
  str = lowered;
  var split = str.lastIndexOf('1');
  if (split === -1) return 'No separator character for ' + str;
  if (split === 0) return 'Missing prefix for ' + str;
  var prefix = str.slice(0, split);
  var wordChars = str.slice(split + 1);
  if (wordChars.length < 6) return 'Data too short';
  var chk = prefixChk(prefix);
  if (typeof chk === 'string') return chk;
  var words = [];

  for (var i = 0; i < wordChars.length; ++i) {
    var c = wordChars.charAt(i);
    var v = ALPHABET_MAP[c];
    if (v === undefined) return 'Unknown character ' + c;
    chk = polymodStep(chk) ^ v; // not in the checksum?

    if (i + 6 >= wordChars.length) continue;
    words.push(v);
  }

  if (chk !== 1) return 'Invalid checksum for ' + str;
  return {
    prefix: prefix,
    words: words
  };
}

function decodeUnsafe() {
  var res = __decode.apply(null, arguments);

  if (_typeof(res) === 'object') return res;
}

function decode(str) {
  var res = __decode.apply(null, arguments);

  if (_typeof(res) === 'object') return res;
  throw new Error(res);
}

function convert(data, inBits, outBits, pad) {
  var value = 0;
  var bits = 0;
  var maxV = (1 << outBits) - 1;
  var result = [];

  for (var i = 0; i < data.length; ++i) {
    value = value << inBits | data[i];
    bits += inBits;

    while (bits >= outBits) {
      bits -= outBits;
      result.push(value >> bits & maxV);
    }
  }

  if (pad) {
    if (bits > 0) {
      result.push(value << outBits - bits & maxV);
    }
  } else {
    if (bits >= inBits) return 'Excess padding';
    if (value << outBits - bits & maxV) return 'Non-zero padding';
  }

  return result;
}

function toWordsUnsafe(bytes) {
  var res = convert(bytes, 8, 5, true);
  if (Array.isArray(res)) return res;
}

function toWords(bytes) {
  var res = convert(bytes, 8, 5, true);
  if (Array.isArray(res)) return res;
  throw new Error(res);
}

function fromWordsUnsafe(words) {
  var res = convert(words, 5, 8, false);
  if (Array.isArray(res)) return res;
}

function fromWords(words) {
  var res = convert(words, 5, 8, false);
  if (Array.isArray(res)) return res;
  throw new Error(res);
}

module.exports = {
  decodeUnsafe: decodeUnsafe,
  decode: decode,
  encode: encode,
  toWordsUnsafe: toWordsUnsafe,
  toWords: toWords,
  fromWordsUnsafe: fromWordsUnsafe,
  fromWords: fromWords
};

/***/ }),

/***/ "./node_modules/biggystring/lib/index.es.js":
/*!**************************************************!*\
  !*** ./node_modules/biggystring/lib/index.es.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "add": function() { return /* binding */ add; },
/* harmony export */   "sub": function() { return /* binding */ sub; },
/* harmony export */   "mul": function() { return /* binding */ mul; },
/* harmony export */   "div": function() { return /* binding */ div; },
/* harmony export */   "gt": function() { return /* binding */ gt; },
/* harmony export */   "lt": function() { return /* binding */ lt; },
/* harmony export */   "gte": function() { return /* binding */ gte; },
/* harmony export */   "lte": function() { return /* binding */ lte; },
/* harmony export */   "eq": function() { return /* binding */ eq; },
/* harmony export */   "min": function() { return /* binding */ min; },
/* harmony export */   "max": function() { return /* binding */ max; },
/* harmony export */   "log10": function() { return /* binding */ log10; },
/* harmony export */   "toFixed": function() { return /* binding */ toFixed; },
/* harmony export */   "abs": function() { return /* binding */ abs; },
/* harmony export */   "bns": function() { return /* binding */ bns; }
/* harmony export */ });
/**
 * Created by paul on 7/25/17.
 */
var BN = __webpack_require__(/*! bn.js */ "./node_modules/biggystring/node_modules/bn.js/lib/bn.js"); // const MAX_DECIMALS = 10


function isHex(x) {
  if (x.startsWith('0x') || x.startsWith('-0x') || x.toLowerCase().includes('a') || x.toLowerCase().includes('b') || x.toLowerCase().includes('c') || x.toLowerCase().includes('d') || x.toLowerCase().includes('e') || x.toLowerCase().includes('f')) {
    return true;
  } else {
    return false;
  }
}

function cropHex(x) {
  return x.replace('0x', '');
}

function addZeros(val, numZeros) {
  var out = val;

  for (var n = 0; n < numZeros; n++) {
    out += '0';
  }

  return out;
} // Remove starting and trailing zeros and decimal


function trimEnd(val) {
  // Remove starting zeros if there are any
  var out = val.replace(/^0+/, '');
  out = out.replace(/^\.+/, '0.');

  if (out.includes('.')) {
    // Remove trailing zeros
    out = out.replace(/0+$/, ''); // Remove trailing "." if there is one

    out = out.replace(/\.+$/, '');

    if (out === '') {
      out = '0';
    }
  }

  if (out === '') {
    out = '0';
  }

  return out;
}

function addDecimal(x, shift) {
  if (shift === 0) return x;
  var isNegative = false;

  if (x.slice(0, 1) === '-') {
    isNegative = true;
    x = x.slice(1);
  }

  var out = void 0;

  if (shift > x.length) {
    out = '0.' + addZeros('', shift - x.length) + x;
  } else {
    out = x.substr(0, x.length - shift) + '.' + x.substr(x.length - shift, x.length);
  }

  out = trimEnd(out);

  if (isNegative) {
    out = '-' + out;
  }

  return out;
} // Takes two floating point (base 10) numbers and finds the multiplier needed to make them both
// operable as a integer


function floatShifts(xStart, yStart, moreShift) {
  var x = xStart;
  var y = yStart;
  validate(x, y);
  var xPos = x.indexOf('.');
  var yPos = y.indexOf('.');
  var xHex = isHex(x);
  var yHex = isHex(y);

  if (xPos !== -1) {
    // Remove trailing zeros
    x = trimEnd(x);
    xPos = x.indexOf('.');
  }

  if (yPos !== -1) {
    // Remove trailing zeros
    y = trimEnd(y);
    yPos = y.indexOf('.');
  }

  if (xPos !== -1 || yPos !== -1 || typeof moreShift === 'number') {
    if (xHex || yHex) {
      throw new Error('Cannot operate on base16 float values');
    }

    var xShift = 0;
    var yShift = 0;

    if (xPos !== -1) {
      xShift = x.length - xPos - 1;
    }

    if (yPos !== -1) {
      yShift = y.length - yPos - 1;
    }

    var _shift = xShift > yShift ? xShift : yShift;

    var moreS = 0;

    if (typeof moreShift === 'number') {
      moreS = moreShift;
    }

    x = addZeros(x.replace('.', ''), _shift + moreS - xShift);
    y = addZeros(y.replace('.', ''), _shift - yShift);
    var out = {
      x: x,
      y: y,
      shift: _shift
    };
    return out;
  } else {
    // Both x and y are int and need no float conversion
    var _out = {
      x: x,
      y: y,
      shift: 0
    };
    return _out;
  }
}

function validate() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = args[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var arg = _step.value;

      if (arg.split('.').length - 1 > 1) {
        throw new Error('Invalid number: more than one decimal point');
      }

      if (arg.split('-').length - 1 > 1) {
        throw new Error('Invalid number: more than one negative sign');
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"]) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
}

function add(x1, y1) {
  var base = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 10;
  if (base !== 10 && base !== 16) throw new Error('Unsupported base');

  var _floatShifts = floatShifts(x1, y1),
      x = _floatShifts.x,
      y = _floatShifts.y,
      shift = _floatShifts.shift;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  var out = xBN.add(yBN).toString(base);
  out = addDecimal(out, shift);
  return base === 10 ? out : '0x' + out;
}

function mul(x1, y1) {
  var base = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 10;
  if (base !== 10 && base !== 16) throw new Error('Unsupported base');

  var _floatShifts2 = floatShifts(x1, y1),
      x = _floatShifts2.x,
      y = _floatShifts2.y,
      shift = _floatShifts2.shift;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  var out = xBN.mul(yBN).toString(base);
  out = addDecimal(out, shift * 2);
  return base === 10 ? out : '0x' + out;
}

function sub(x1, y1) {
  var base = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 10;
  if (base !== 10 && base !== 16) throw new Error('Unsupported base');

  var _floatShifts3 = floatShifts(x1, y1),
      x = _floatShifts3.x,
      y = _floatShifts3.y,
      shift = _floatShifts3.shift;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  var out = xBN.sub(yBN).toString(base);
  out = addDecimal(out, shift);
  return base === 10 ? out : '0x' + out;
}

function div(x1, y1) {
  var precision = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var base = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 10;

  if (base !== 10 && precision > 0) {
    throw new Error('Cannot operate on floating point hex values');
  }

  if (base !== 10 && base !== 16) throw new Error('Unsupported base');

  var _floatShifts4 = floatShifts(x1, y1, precision),
      x = _floatShifts4.x,
      y = _floatShifts4.y;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  var out = xBN.div(yBN).toString(base);
  out = addDecimal(out, precision);
  return base === 10 ? out : '0x' + out;
}

function lt(x1, y1) {
  var _floatShifts5 = floatShifts(x1, y1),
      x = _floatShifts5.x,
      y = _floatShifts5.y;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  return xBN.lt(yBN);
}

function lte(x1, y1) {
  var _floatShifts6 = floatShifts(x1, y1),
      x = _floatShifts6.x,
      y = _floatShifts6.y;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  return xBN.lte(yBN);
}

function gt(x1, y1) {
  var _floatShifts7 = floatShifts(x1, y1),
      x = _floatShifts7.x,
      y = _floatShifts7.y;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  return xBN.gt(yBN);
}

function gte(x1, y1) {
  var _floatShifts8 = floatShifts(x1, y1),
      x = _floatShifts8.x,
      y = _floatShifts8.y;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  return xBN.gte(yBN);
}

function eq(x1, y1) {
  var _floatShifts9 = floatShifts(x1, y1),
      x = _floatShifts9.x,
      y = _floatShifts9.y;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  return xBN.eq(yBN);
}

function min(x1, y1) {
  var base = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 10;

  var _floatShifts10 = floatShifts(x1, y1),
      x = _floatShifts10.x,
      y = _floatShifts10.y,
      shift = _floatShifts10.shift;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  var out = void 0;

  if (xBN.lte(yBN)) {
    out = xBN.toString(base);
  } else {
    out = yBN.toString(base);
  }

  out = addDecimal(out, shift);
  return base === 10 ? out : '0x' + out;
}

function abs(x1) {
  var base = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 10;
  if (base !== 10 && base !== 16) throw new Error('Unsupported base');

  var _floatShifts11 = floatShifts(x1, '0'),
      x = _floatShifts11.x,
      shift = _floatShifts11.shift;

  var xBase = isHex(x1) ? 16 : 10;
  x = cropHex(x);
  var xBN = new BN(x, xBase);
  var out = xBN.abs(xBN).toString(base);
  out = addDecimal(out, shift);
  return base === 10 ? out : '0x' + out;
}

function max(x1, y1) {
  var base = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 10;

  var _floatShifts12 = floatShifts(x1, y1),
      x = _floatShifts12.x,
      y = _floatShifts12.y,
      shift = _floatShifts12.shift;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  var out = void 0;

  if (xBN.gte(yBN)) {
    out = xBN.toString(base);
  } else {
    out = yBN.toString(base);
  }

  out = addDecimal(out, shift);
  return base === 10 ? out : '0x' + out;
}

function toFixed(x1) {
  var minPrecision = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 2;
  var maxPrecision = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 8;
  validate(x1);
  var negative = false;
  var out = '';
  var x = x1;

  if (x.includes('-')) {
    negative = true; // Remove any leading '-' signs

    x = x.replace(/^-+/, '');
  }

  x = trimEnd(x); // Number of decimal places number has

  var decimalPos = x.indexOf('.');

  if (decimalPos === -1) {
    out = x + '.' + addZeros('', minPrecision);
  } else {
    var numDecimals = x.length - decimalPos - 1;

    if (numDecimals > maxPrecision) {
      out = x.substr(0, x.length - (numDecimals - maxPrecision));
    } else if (numDecimals < minPrecision) {
      out = x + addZeros('', minPrecision - numDecimals);
    } else {
      out = x;
    }
  } // Remove trailing "." if there is one


  out = out.replace(/\.+$/, '');

  if (negative) {
    out = '-' + out;
  }

  return out;
}

function log10(x) {
  if (!(x.match(/^[0-1]+$/g) !== null)) {
    throw new Error('InvalidLogInputValue: Must be a power of 10');
  }

  if (!x.startsWith('1')) {
    throw new Error('InvalidLogInputValue: Must not have leading zeros');
  }

  if ((x.match(/1/g) || []).length > 1) {
    throw new Error('InvalidLogInputValue: Must be power of 10.');
  }

  return (x.match(/0/g) || []).length;
}

var bns = {
  add: add,
  sub: sub,
  mul: mul,
  div: div,
  gt: gt,
  lt: lt,
  gte: gte,
  lte: lte,
  eq: eq,
  min: min,
  max: max,
  log10: log10,
  toFixed: toFixed,
  abs: abs
};


/***/ }),

/***/ "./node_modules/biggystring/node_modules/bn.js/lib/bn.js":
/*!***************************************************************!*\
  !*** ./node_modules/biggystring/node_modules/bn.js/lib/bn.js ***!
  \***************************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

/* module decorator */ module = __webpack_require__.nmd(module);
function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

(function (module, exports) {
  'use strict'; // Utils

  function assert(val, msg) {
    if (!val) throw new Error(msg || 'Assertion failed');
  } // Could use `inherits` module, but don't want to move from single file
  // architecture yet.


  function inherits(ctor, superCtor) {
    ctor.super_ = superCtor;

    var TempCtor = function TempCtor() {};

    TempCtor.prototype = superCtor.prototype;
    ctor.prototype = new TempCtor();
    ctor.prototype.constructor = ctor;
  } // BN


  function BN(number, base, endian) {
    if (BN.isBN(number)) {
      return number;
    }

    this.negative = 0;
    this.words = null;
    this.length = 0; // Reduction context

    this.red = null;

    if (number !== null) {
      if (base === 'le' || base === 'be') {
        endian = base;
        base = 10;
      }

      this._init(number || 0, base || 10, endian || 'be');
    }
  }

  if (_typeof(module) === 'object') {
    module.exports = BN;
  } else {
    exports.BN = BN;
  }

  BN.BN = BN;
  BN.wordSize = 26;
  var Buffer;

  try {
    Buffer = __webpack_require__(/*! buffer */ "?3521").Buffer;
  } catch (e) {}

  BN.isBN = function isBN(num) {
    if (num instanceof BN) {
      return true;
    }

    return num !== null && _typeof(num) === 'object' && num.constructor.wordSize === BN.wordSize && Array.isArray(num.words);
  };

  BN.max = function max(left, right) {
    if (left.cmp(right) > 0) return left;
    return right;
  };

  BN.min = function min(left, right) {
    if (left.cmp(right) < 0) return left;
    return right;
  };

  BN.prototype._init = function init(number, base, endian) {
    if (typeof number === 'number') {
      return this._initNumber(number, base, endian);
    }

    if (_typeof(number) === 'object') {
      return this._initArray(number, base, endian);
    }

    if (base === 'hex') {
      base = 16;
    }

    assert(base === (base | 0) && base >= 2 && base <= 36);
    number = number.toString().replace(/\s+/g, '');
    var start = 0;

    if (number[0] === '-') {
      start++;
    }

    if (base === 16) {
      this._parseHex(number, start);
    } else {
      this._parseBase(number, base, start);
    }

    if (number[0] === '-') {
      this.negative = 1;
    }

    this.strip();
    if (endian !== 'le') return;

    this._initArray(this.toArray(), base, endian);
  };

  BN.prototype._initNumber = function _initNumber(number, base, endian) {
    if (number < 0) {
      this.negative = 1;
      number = -number;
    }

    if (number < 0x4000000) {
      this.words = [number & 0x3ffffff];
      this.length = 1;
    } else if (number < 0x10000000000000) {
      this.words = [number & 0x3ffffff, number / 0x4000000 & 0x3ffffff];
      this.length = 2;
    } else {
      assert(number < 0x20000000000000); // 2 ^ 53 (unsafe)

      this.words = [number & 0x3ffffff, number / 0x4000000 & 0x3ffffff, 1];
      this.length = 3;
    }

    if (endian !== 'le') return; // Reverse the bytes

    this._initArray(this.toArray(), base, endian);
  };

  BN.prototype._initArray = function _initArray(number, base, endian) {
    // Perhaps a Uint8Array
    assert(typeof number.length === 'number');

    if (number.length <= 0) {
      this.words = [0];
      this.length = 1;
      return this;
    }

    this.length = Math.ceil(number.length / 3);
    this.words = new Array(this.length);

    for (var i = 0; i < this.length; i++) {
      this.words[i] = 0;
    }

    var j, w;
    var off = 0;

    if (endian === 'be') {
      for (i = number.length - 1, j = 0; i >= 0; i -= 3) {
        w = number[i] | number[i - 1] << 8 | number[i - 2] << 16;
        this.words[j] |= w << off & 0x3ffffff;
        this.words[j + 1] = w >>> 26 - off & 0x3ffffff;
        off += 24;

        if (off >= 26) {
          off -= 26;
          j++;
        }
      }
    } else if (endian === 'le') {
      for (i = 0, j = 0; i < number.length; i += 3) {
        w = number[i] | number[i + 1] << 8 | number[i + 2] << 16;
        this.words[j] |= w << off & 0x3ffffff;
        this.words[j + 1] = w >>> 26 - off & 0x3ffffff;
        off += 24;

        if (off >= 26) {
          off -= 26;
          j++;
        }
      }
    }

    return this.strip();
  };

  function parseHex(str, start, end) {
    var r = 0;
    var len = Math.min(str.length, end);

    for (var i = start; i < len; i++) {
      var c = str.charCodeAt(i) - 48;
      r <<= 4; // 'a' - 'f'

      if (c >= 49 && c <= 54) {
        r |= c - 49 + 0xa; // 'A' - 'F'
      } else if (c >= 17 && c <= 22) {
        r |= c - 17 + 0xa; // '0' - '9'
      } else {
        r |= c & 0xf;
      }
    }

    return r;
  }

  BN.prototype._parseHex = function _parseHex(number, start) {
    // Create possibly bigger array to ensure that it fits the number
    this.length = Math.ceil((number.length - start) / 6);
    this.words = new Array(this.length);

    for (var i = 0; i < this.length; i++) {
      this.words[i] = 0;
    }

    var j, w; // Scan 24-bit chunks and add them to the number

    var off = 0;

    for (i = number.length - 6, j = 0; i >= start; i -= 6) {
      w = parseHex(number, i, i + 6);
      this.words[j] |= w << off & 0x3ffffff; // NOTE: `0x3fffff` is intentional here, 26bits max shift + 24bit hex limb

      this.words[j + 1] |= w >>> 26 - off & 0x3fffff;
      off += 24;

      if (off >= 26) {
        off -= 26;
        j++;
      }
    }

    if (i + 6 !== start) {
      w = parseHex(number, start, i + 6);
      this.words[j] |= w << off & 0x3ffffff;
      this.words[j + 1] |= w >>> 26 - off & 0x3fffff;
    }

    this.strip();
  };

  function parseBase(str, start, end, mul) {
    var r = 0;
    var len = Math.min(str.length, end);

    for (var i = start; i < len; i++) {
      var c = str.charCodeAt(i) - 48;
      r *= mul; // 'a'

      if (c >= 49) {
        r += c - 49 + 0xa; // 'A'
      } else if (c >= 17) {
        r += c - 17 + 0xa; // '0' - '9'
      } else {
        r += c;
      }
    }

    return r;
  }

  BN.prototype._parseBase = function _parseBase(number, base, start) {
    // Initialize as zero
    this.words = [0];
    this.length = 1; // Find length of limb in base

    for (var limbLen = 0, limbPow = 1; limbPow <= 0x3ffffff; limbPow *= base) {
      limbLen++;
    }

    limbLen--;
    limbPow = limbPow / base | 0;
    var total = number.length - start;
    var mod = total % limbLen;
    var end = Math.min(total, total - mod) + start;
    var word = 0;

    for (var i = start; i < end; i += limbLen) {
      word = parseBase(number, i, i + limbLen, base);
      this.imuln(limbPow);

      if (this.words[0] + word < 0x4000000) {
        this.words[0] += word;
      } else {
        this._iaddn(word);
      }
    }

    if (mod !== 0) {
      var pow = 1;
      word = parseBase(number, i, number.length, base);

      for (i = 0; i < mod; i++) {
        pow *= base;
      }

      this.imuln(pow);

      if (this.words[0] + word < 0x4000000) {
        this.words[0] += word;
      } else {
        this._iaddn(word);
      }
    }
  };

  BN.prototype.copy = function copy(dest) {
    dest.words = new Array(this.length);

    for (var i = 0; i < this.length; i++) {
      dest.words[i] = this.words[i];
    }

    dest.length = this.length;
    dest.negative = this.negative;
    dest.red = this.red;
  };

  BN.prototype.clone = function clone() {
    var r = new BN(null);
    this.copy(r);
    return r;
  };

  BN.prototype._expand = function _expand(size) {
    while (this.length < size) {
      this.words[this.length++] = 0;
    }

    return this;
  }; // Remove leading `0` from `this`


  BN.prototype.strip = function strip() {
    while (this.length > 1 && this.words[this.length - 1] === 0) {
      this.length--;
    }

    return this._normSign();
  };

  BN.prototype._normSign = function _normSign() {
    // -0 = 0
    if (this.length === 1 && this.words[0] === 0) {
      this.negative = 0;
    }

    return this;
  };

  BN.prototype.inspect = function inspect() {
    return (this.red ? '<BN-R: ' : '<BN: ') + this.toString(16) + '>';
  };
  /*
   var zeros = [];
  var groupSizes = [];
  var groupBases = [];
   var s = '';
  var i = -1;
  while (++i < BN.wordSize) {
    zeros[i] = s;
    s += '0';
  }
  groupSizes[0] = 0;
  groupSizes[1] = 0;
  groupBases[0] = 0;
  groupBases[1] = 0;
  var base = 2 - 1;
  while (++base < 36 + 1) {
    var groupSize = 0;
    var groupBase = 1;
    while (groupBase < (1 << BN.wordSize) / base) {
      groupBase *= base;
      groupSize += 1;
    }
    groupSizes[base] = groupSize;
    groupBases[base] = groupBase;
  }
   */


  var zeros = ['', '0', '00', '000', '0000', '00000', '000000', '0000000', '00000000', '000000000', '0000000000', '00000000000', '000000000000', '0000000000000', '00000000000000', '000000000000000', '0000000000000000', '00000000000000000', '000000000000000000', '0000000000000000000', '00000000000000000000', '000000000000000000000', '0000000000000000000000', '00000000000000000000000', '000000000000000000000000', '0000000000000000000000000'];
  var groupSizes = [0, 0, 25, 16, 12, 11, 10, 9, 8, 8, 7, 7, 7, 7, 6, 6, 6, 6, 6, 6, 6, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5];
  var groupBases = [0, 0, 33554432, 43046721, 16777216, 48828125, 60466176, 40353607, 16777216, 43046721, 10000000, 19487171, 35831808, 62748517, 7529536, 11390625, 16777216, 24137569, 34012224, 47045881, 64000000, 4084101, 5153632, 6436343, 7962624, 9765625, 11881376, 14348907, 17210368, 20511149, 24300000, 28629151, 33554432, 39135393, 45435424, 52521875, 60466176];

  BN.prototype.toString = function toString(base, padding) {
    base = base || 10;
    padding = padding | 0 || 1;
    var out;

    if (base === 16 || base === 'hex') {
      out = '';
      var off = 0;
      var carry = 0;

      for (var i = 0; i < this.length; i++) {
        var w = this.words[i];
        var word = ((w << off | carry) & 0xffffff).toString(16);
        carry = w >>> 24 - off & 0xffffff;

        if (carry !== 0 || i !== this.length - 1) {
          out = zeros[6 - word.length] + word + out;
        } else {
          out = word + out;
        }

        off += 2;

        if (off >= 26) {
          off -= 26;
          i--;
        }
      }

      if (carry !== 0) {
        out = carry.toString(16) + out;
      }

      while (out.length % padding !== 0) {
        out = '0' + out;
      }

      if (this.negative !== 0) {
        out = '-' + out;
      }

      return out;
    }

    if (base === (base | 0) && base >= 2 && base <= 36) {
      // var groupSize = Math.floor(BN.wordSize * Math.LN2 / Math.log(base));
      var groupSize = groupSizes[base]; // var groupBase = Math.pow(base, groupSize);

      var groupBase = groupBases[base];
      out = '';
      var c = this.clone();
      c.negative = 0;

      while (!c.isZero()) {
        var r = c.modn(groupBase).toString(base);
        c = c.idivn(groupBase);

        if (!c.isZero()) {
          out = zeros[groupSize - r.length] + r + out;
        } else {
          out = r + out;
        }
      }

      if (this.isZero()) {
        out = '0' + out;
      }

      while (out.length % padding !== 0) {
        out = '0' + out;
      }

      if (this.negative !== 0) {
        out = '-' + out;
      }

      return out;
    }

    assert(false, 'Base should be between 2 and 36');
  };

  BN.prototype.toNumber = function toNumber() {
    var ret = this.words[0];

    if (this.length === 2) {
      ret += this.words[1] * 0x4000000;
    } else if (this.length === 3 && this.words[2] === 0x01) {
      // NOTE: at this stage it is known that the top bit is set
      ret += 0x10000000000000 + this.words[1] * 0x4000000;
    } else if (this.length > 2) {
      assert(false, 'Number can only safely store up to 53 bits');
    }

    return this.negative !== 0 ? -ret : ret;
  };

  BN.prototype.toJSON = function toJSON() {
    return this.toString(16);
  };

  BN.prototype.toBuffer = function toBuffer(endian, length) {
    assert(typeof Buffer !== 'undefined');
    return this.toArrayLike(Buffer, endian, length);
  };

  BN.prototype.toArray = function toArray(endian, length) {
    return this.toArrayLike(Array, endian, length);
  };

  BN.prototype.toArrayLike = function toArrayLike(ArrayType, endian, length) {
    var byteLength = this.byteLength();
    var reqLength = length || Math.max(1, byteLength);
    assert(byteLength <= reqLength, 'byte array longer than desired length');
    assert(reqLength > 0, 'Requested array length <= 0');
    this.strip();
    var littleEndian = endian === 'le';
    var res = new ArrayType(reqLength);
    var b, i;
    var q = this.clone();

    if (!littleEndian) {
      // Assume big-endian
      for (i = 0; i < reqLength - byteLength; i++) {
        res[i] = 0;
      }

      for (i = 0; !q.isZero(); i++) {
        b = q.andln(0xff);
        q.iushrn(8);
        res[reqLength - i - 1] = b;
      }
    } else {
      for (i = 0; !q.isZero(); i++) {
        b = q.andln(0xff);
        q.iushrn(8);
        res[i] = b;
      }

      for (; i < reqLength; i++) {
        res[i] = 0;
      }
    }

    return res;
  };

  if (Math.clz32) {
    BN.prototype._countBits = function _countBits(w) {
      return 32 - Math.clz32(w);
    };
  } else {
    BN.prototype._countBits = function _countBits(w) {
      var t = w;
      var r = 0;

      if (t >= 0x1000) {
        r += 13;
        t >>>= 13;
      }

      if (t >= 0x40) {
        r += 7;
        t >>>= 7;
      }

      if (t >= 0x8) {
        r += 4;
        t >>>= 4;
      }

      if (t >= 0x02) {
        r += 2;
        t >>>= 2;
      }

      return r + t;
    };
  }

  BN.prototype._zeroBits = function _zeroBits(w) {
    // Short-cut
    if (w === 0) return 26;
    var t = w;
    var r = 0;

    if ((t & 0x1fff) === 0) {
      r += 13;
      t >>>= 13;
    }

    if ((t & 0x7f) === 0) {
      r += 7;
      t >>>= 7;
    }

    if ((t & 0xf) === 0) {
      r += 4;
      t >>>= 4;
    }

    if ((t & 0x3) === 0) {
      r += 2;
      t >>>= 2;
    }

    if ((t & 0x1) === 0) {
      r++;
    }

    return r;
  }; // Return number of used bits in a BN


  BN.prototype.bitLength = function bitLength() {
    var w = this.words[this.length - 1];

    var hi = this._countBits(w);

    return (this.length - 1) * 26 + hi;
  };

  function toBitArray(num) {
    var w = new Array(num.bitLength());

    for (var bit = 0; bit < w.length; bit++) {
      var off = bit / 26 | 0;
      var wbit = bit % 26;
      w[bit] = (num.words[off] & 1 << wbit) >>> wbit;
    }

    return w;
  } // Number of trailing zero bits


  BN.prototype.zeroBits = function zeroBits() {
    if (this.isZero()) return 0;
    var r = 0;

    for (var i = 0; i < this.length; i++) {
      var b = this._zeroBits(this.words[i]);

      r += b;
      if (b !== 26) break;
    }

    return r;
  };

  BN.prototype.byteLength = function byteLength() {
    return Math.ceil(this.bitLength() / 8);
  };

  BN.prototype.toTwos = function toTwos(width) {
    if (this.negative !== 0) {
      return this.abs().inotn(width).iaddn(1);
    }

    return this.clone();
  };

  BN.prototype.fromTwos = function fromTwos(width) {
    if (this.testn(width - 1)) {
      return this.notn(width).iaddn(1).ineg();
    }

    return this.clone();
  };

  BN.prototype.isNeg = function isNeg() {
    return this.negative !== 0;
  }; // Return negative clone of `this`


  BN.prototype.neg = function neg() {
    return this.clone().ineg();
  };

  BN.prototype.ineg = function ineg() {
    if (!this.isZero()) {
      this.negative ^= 1;
    }

    return this;
  }; // Or `num` with `this` in-place


  BN.prototype.iuor = function iuor(num) {
    while (this.length < num.length) {
      this.words[this.length++] = 0;
    }

    for (var i = 0; i < num.length; i++) {
      this.words[i] = this.words[i] | num.words[i];
    }

    return this.strip();
  };

  BN.prototype.ior = function ior(num) {
    assert((this.negative | num.negative) === 0);
    return this.iuor(num);
  }; // Or `num` with `this`


  BN.prototype.or = function or(num) {
    if (this.length > num.length) return this.clone().ior(num);
    return num.clone().ior(this);
  };

  BN.prototype.uor = function uor(num) {
    if (this.length > num.length) return this.clone().iuor(num);
    return num.clone().iuor(this);
  }; // And `num` with `this` in-place


  BN.prototype.iuand = function iuand(num) {
    // b = min-length(num, this)
    var b;

    if (this.length > num.length) {
      b = num;
    } else {
      b = this;
    }

    for (var i = 0; i < b.length; i++) {
      this.words[i] = this.words[i] & num.words[i];
    }

    this.length = b.length;
    return this.strip();
  };

  BN.prototype.iand = function iand(num) {
    assert((this.negative | num.negative) === 0);
    return this.iuand(num);
  }; // And `num` with `this`


  BN.prototype.and = function and(num) {
    if (this.length > num.length) return this.clone().iand(num);
    return num.clone().iand(this);
  };

  BN.prototype.uand = function uand(num) {
    if (this.length > num.length) return this.clone().iuand(num);
    return num.clone().iuand(this);
  }; // Xor `num` with `this` in-place


  BN.prototype.iuxor = function iuxor(num) {
    // a.length > b.length
    var a;
    var b;

    if (this.length > num.length) {
      a = this;
      b = num;
    } else {
      a = num;
      b = this;
    }

    for (var i = 0; i < b.length; i++) {
      this.words[i] = a.words[i] ^ b.words[i];
    }

    if (this !== a) {
      for (; i < a.length; i++) {
        this.words[i] = a.words[i];
      }
    }

    this.length = a.length;
    return this.strip();
  };

  BN.prototype.ixor = function ixor(num) {
    assert((this.negative | num.negative) === 0);
    return this.iuxor(num);
  }; // Xor `num` with `this`


  BN.prototype.xor = function xor(num) {
    if (this.length > num.length) return this.clone().ixor(num);
    return num.clone().ixor(this);
  };

  BN.prototype.uxor = function uxor(num) {
    if (this.length > num.length) return this.clone().iuxor(num);
    return num.clone().iuxor(this);
  }; // Not ``this`` with ``width`` bitwidth


  BN.prototype.inotn = function inotn(width) {
    assert(typeof width === 'number' && width >= 0);
    var bytesNeeded = Math.ceil(width / 26) | 0;
    var bitsLeft = width % 26; // Extend the buffer with leading zeroes

    this._expand(bytesNeeded);

    if (bitsLeft > 0) {
      bytesNeeded--;
    } // Handle complete words


    for (var i = 0; i < bytesNeeded; i++) {
      this.words[i] = ~this.words[i] & 0x3ffffff;
    } // Handle the residue


    if (bitsLeft > 0) {
      this.words[i] = ~this.words[i] & 0x3ffffff >> 26 - bitsLeft;
    } // And remove leading zeroes


    return this.strip();
  };

  BN.prototype.notn = function notn(width) {
    return this.clone().inotn(width);
  }; // Set `bit` of `this`


  BN.prototype.setn = function setn(bit, val) {
    assert(typeof bit === 'number' && bit >= 0);
    var off = bit / 26 | 0;
    var wbit = bit % 26;

    this._expand(off + 1);

    if (val) {
      this.words[off] = this.words[off] | 1 << wbit;
    } else {
      this.words[off] = this.words[off] & ~(1 << wbit);
    }

    return this.strip();
  }; // Add `num` to `this` in-place


  BN.prototype.iadd = function iadd(num) {
    var r; // negative + positive

    if (this.negative !== 0 && num.negative === 0) {
      this.negative = 0;
      r = this.isub(num);
      this.negative ^= 1;
      return this._normSign(); // positive + negative
    } else if (this.negative === 0 && num.negative !== 0) {
      num.negative = 0;
      r = this.isub(num);
      num.negative = 1;
      return r._normSign();
    } // a.length > b.length


    var a, b;

    if (this.length > num.length) {
      a = this;
      b = num;
    } else {
      a = num;
      b = this;
    }

    var carry = 0;

    for (var i = 0; i < b.length; i++) {
      r = (a.words[i] | 0) + (b.words[i] | 0) + carry;
      this.words[i] = r & 0x3ffffff;
      carry = r >>> 26;
    }

    for (; carry !== 0 && i < a.length; i++) {
      r = (a.words[i] | 0) + carry;
      this.words[i] = r & 0x3ffffff;
      carry = r >>> 26;
    }

    this.length = a.length;

    if (carry !== 0) {
      this.words[this.length] = carry;
      this.length++; // Copy the rest of the words
    } else if (a !== this) {
      for (; i < a.length; i++) {
        this.words[i] = a.words[i];
      }
    }

    return this;
  }; // Add `num` to `this`


  BN.prototype.add = function add(num) {
    var res;

    if (num.negative !== 0 && this.negative === 0) {
      num.negative = 0;
      res = this.sub(num);
      num.negative ^= 1;
      return res;
    } else if (num.negative === 0 && this.negative !== 0) {
      this.negative = 0;
      res = num.sub(this);
      this.negative = 1;
      return res;
    }

    if (this.length > num.length) return this.clone().iadd(num);
    return num.clone().iadd(this);
  }; // Subtract `num` from `this` in-place


  BN.prototype.isub = function isub(num) {
    // this - (-num) = this + num
    if (num.negative !== 0) {
      num.negative = 0;
      var r = this.iadd(num);
      num.negative = 1;
      return r._normSign(); // -this - num = -(this + num)
    } else if (this.negative !== 0) {
      this.negative = 0;
      this.iadd(num);
      this.negative = 1;
      return this._normSign();
    } // At this point both numbers are positive


    var cmp = this.cmp(num); // Optimization - zeroify

    if (cmp === 0) {
      this.negative = 0;
      this.length = 1;
      this.words[0] = 0;
      return this;
    } // a > b


    var a, b;

    if (cmp > 0) {
      a = this;
      b = num;
    } else {
      a = num;
      b = this;
    }

    var carry = 0;

    for (var i = 0; i < b.length; i++) {
      r = (a.words[i] | 0) - (b.words[i] | 0) + carry;
      carry = r >> 26;
      this.words[i] = r & 0x3ffffff;
    }

    for (; carry !== 0 && i < a.length; i++) {
      r = (a.words[i] | 0) + carry;
      carry = r >> 26;
      this.words[i] = r & 0x3ffffff;
    } // Copy rest of the words


    if (carry === 0 && i < a.length && a !== this) {
      for (; i < a.length; i++) {
        this.words[i] = a.words[i];
      }
    }

    this.length = Math.max(this.length, i);

    if (a !== this) {
      this.negative = 1;
    }

    return this.strip();
  }; // Subtract `num` from `this`


  BN.prototype.sub = function sub(num) {
    return this.clone().isub(num);
  };

  function smallMulTo(self, num, out) {
    out.negative = num.negative ^ self.negative;
    var len = self.length + num.length | 0;
    out.length = len;
    len = len - 1 | 0; // Peel one iteration (compiler can't do it, because of code complexity)

    var a = self.words[0] | 0;
    var b = num.words[0] | 0;
    var r = a * b;
    var lo = r & 0x3ffffff;
    var carry = r / 0x4000000 | 0;
    out.words[0] = lo;

    for (var k = 1; k < len; k++) {
      // Sum all words with the same `i + j = k` and accumulate `ncarry`,
      // note that ncarry could be >= 0x3ffffff
      var ncarry = carry >>> 26;
      var rword = carry & 0x3ffffff;
      var maxJ = Math.min(k, num.length - 1);

      for (var j = Math.max(0, k - self.length + 1); j <= maxJ; j++) {
        var i = k - j | 0;
        a = self.words[i] | 0;
        b = num.words[j] | 0;
        r = a * b + rword;
        ncarry += r / 0x4000000 | 0;
        rword = r & 0x3ffffff;
      }

      out.words[k] = rword | 0;
      carry = ncarry | 0;
    }

    if (carry !== 0) {
      out.words[k] = carry | 0;
    } else {
      out.length--;
    }

    return out.strip();
  } // TODO(indutny): it may be reasonable to omit it for users who don't need
  // to work with 256-bit numbers, otherwise it gives 20% improvement for 256-bit
  // multiplication (like elliptic secp256k1).


  var comb10MulTo = function comb10MulTo(self, num, out) {
    var a = self.words;
    var b = num.words;
    var o = out.words;
    var c = 0;
    var lo;
    var mid;
    var hi;
    var a0 = a[0] | 0;
    var al0 = a0 & 0x1fff;
    var ah0 = a0 >>> 13;
    var a1 = a[1] | 0;
    var al1 = a1 & 0x1fff;
    var ah1 = a1 >>> 13;
    var a2 = a[2] | 0;
    var al2 = a2 & 0x1fff;
    var ah2 = a2 >>> 13;
    var a3 = a[3] | 0;
    var al3 = a3 & 0x1fff;
    var ah3 = a3 >>> 13;
    var a4 = a[4] | 0;
    var al4 = a4 & 0x1fff;
    var ah4 = a4 >>> 13;
    var a5 = a[5] | 0;
    var al5 = a5 & 0x1fff;
    var ah5 = a5 >>> 13;
    var a6 = a[6] | 0;
    var al6 = a6 & 0x1fff;
    var ah6 = a6 >>> 13;
    var a7 = a[7] | 0;
    var al7 = a7 & 0x1fff;
    var ah7 = a7 >>> 13;
    var a8 = a[8] | 0;
    var al8 = a8 & 0x1fff;
    var ah8 = a8 >>> 13;
    var a9 = a[9] | 0;
    var al9 = a9 & 0x1fff;
    var ah9 = a9 >>> 13;
    var b0 = b[0] | 0;
    var bl0 = b0 & 0x1fff;
    var bh0 = b0 >>> 13;
    var b1 = b[1] | 0;
    var bl1 = b1 & 0x1fff;
    var bh1 = b1 >>> 13;
    var b2 = b[2] | 0;
    var bl2 = b2 & 0x1fff;
    var bh2 = b2 >>> 13;
    var b3 = b[3] | 0;
    var bl3 = b3 & 0x1fff;
    var bh3 = b3 >>> 13;
    var b4 = b[4] | 0;
    var bl4 = b4 & 0x1fff;
    var bh4 = b4 >>> 13;
    var b5 = b[5] | 0;
    var bl5 = b5 & 0x1fff;
    var bh5 = b5 >>> 13;
    var b6 = b[6] | 0;
    var bl6 = b6 & 0x1fff;
    var bh6 = b6 >>> 13;
    var b7 = b[7] | 0;
    var bl7 = b7 & 0x1fff;
    var bh7 = b7 >>> 13;
    var b8 = b[8] | 0;
    var bl8 = b8 & 0x1fff;
    var bh8 = b8 >>> 13;
    var b9 = b[9] | 0;
    var bl9 = b9 & 0x1fff;
    var bh9 = b9 >>> 13;
    out.negative = self.negative ^ num.negative;
    out.length = 19;
    /* k = 0 */

    lo = Math.imul(al0, bl0);
    mid = Math.imul(al0, bh0);
    mid = mid + Math.imul(ah0, bl0) | 0;
    hi = Math.imul(ah0, bh0);
    var w0 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w0 >>> 26) | 0;
    w0 &= 0x3ffffff;
    /* k = 1 */

    lo = Math.imul(al1, bl0);
    mid = Math.imul(al1, bh0);
    mid = mid + Math.imul(ah1, bl0) | 0;
    hi = Math.imul(ah1, bh0);
    lo = lo + Math.imul(al0, bl1) | 0;
    mid = mid + Math.imul(al0, bh1) | 0;
    mid = mid + Math.imul(ah0, bl1) | 0;
    hi = hi + Math.imul(ah0, bh1) | 0;
    var w1 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w1 >>> 26) | 0;
    w1 &= 0x3ffffff;
    /* k = 2 */

    lo = Math.imul(al2, bl0);
    mid = Math.imul(al2, bh0);
    mid = mid + Math.imul(ah2, bl0) | 0;
    hi = Math.imul(ah2, bh0);
    lo = lo + Math.imul(al1, bl1) | 0;
    mid = mid + Math.imul(al1, bh1) | 0;
    mid = mid + Math.imul(ah1, bl1) | 0;
    hi = hi + Math.imul(ah1, bh1) | 0;
    lo = lo + Math.imul(al0, bl2) | 0;
    mid = mid + Math.imul(al0, bh2) | 0;
    mid = mid + Math.imul(ah0, bl2) | 0;
    hi = hi + Math.imul(ah0, bh2) | 0;
    var w2 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w2 >>> 26) | 0;
    w2 &= 0x3ffffff;
    /* k = 3 */

    lo = Math.imul(al3, bl0);
    mid = Math.imul(al3, bh0);
    mid = mid + Math.imul(ah3, bl0) | 0;
    hi = Math.imul(ah3, bh0);
    lo = lo + Math.imul(al2, bl1) | 0;
    mid = mid + Math.imul(al2, bh1) | 0;
    mid = mid + Math.imul(ah2, bl1) | 0;
    hi = hi + Math.imul(ah2, bh1) | 0;
    lo = lo + Math.imul(al1, bl2) | 0;
    mid = mid + Math.imul(al1, bh2) | 0;
    mid = mid + Math.imul(ah1, bl2) | 0;
    hi = hi + Math.imul(ah1, bh2) | 0;
    lo = lo + Math.imul(al0, bl3) | 0;
    mid = mid + Math.imul(al0, bh3) | 0;
    mid = mid + Math.imul(ah0, bl3) | 0;
    hi = hi + Math.imul(ah0, bh3) | 0;
    var w3 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w3 >>> 26) | 0;
    w3 &= 0x3ffffff;
    /* k = 4 */

    lo = Math.imul(al4, bl0);
    mid = Math.imul(al4, bh0);
    mid = mid + Math.imul(ah4, bl0) | 0;
    hi = Math.imul(ah4, bh0);
    lo = lo + Math.imul(al3, bl1) | 0;
    mid = mid + Math.imul(al3, bh1) | 0;
    mid = mid + Math.imul(ah3, bl1) | 0;
    hi = hi + Math.imul(ah3, bh1) | 0;
    lo = lo + Math.imul(al2, bl2) | 0;
    mid = mid + Math.imul(al2, bh2) | 0;
    mid = mid + Math.imul(ah2, bl2) | 0;
    hi = hi + Math.imul(ah2, bh2) | 0;
    lo = lo + Math.imul(al1, bl3) | 0;
    mid = mid + Math.imul(al1, bh3) | 0;
    mid = mid + Math.imul(ah1, bl3) | 0;
    hi = hi + Math.imul(ah1, bh3) | 0;
    lo = lo + Math.imul(al0, bl4) | 0;
    mid = mid + Math.imul(al0, bh4) | 0;
    mid = mid + Math.imul(ah0, bl4) | 0;
    hi = hi + Math.imul(ah0, bh4) | 0;
    var w4 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w4 >>> 26) | 0;
    w4 &= 0x3ffffff;
    /* k = 5 */

    lo = Math.imul(al5, bl0);
    mid = Math.imul(al5, bh0);
    mid = mid + Math.imul(ah5, bl0) | 0;
    hi = Math.imul(ah5, bh0);
    lo = lo + Math.imul(al4, bl1) | 0;
    mid = mid + Math.imul(al4, bh1) | 0;
    mid = mid + Math.imul(ah4, bl1) | 0;
    hi = hi + Math.imul(ah4, bh1) | 0;
    lo = lo + Math.imul(al3, bl2) | 0;
    mid = mid + Math.imul(al3, bh2) | 0;
    mid = mid + Math.imul(ah3, bl2) | 0;
    hi = hi + Math.imul(ah3, bh2) | 0;
    lo = lo + Math.imul(al2, bl3) | 0;
    mid = mid + Math.imul(al2, bh3) | 0;
    mid = mid + Math.imul(ah2, bl3) | 0;
    hi = hi + Math.imul(ah2, bh3) | 0;
    lo = lo + Math.imul(al1, bl4) | 0;
    mid = mid + Math.imul(al1, bh4) | 0;
    mid = mid + Math.imul(ah1, bl4) | 0;
    hi = hi + Math.imul(ah1, bh4) | 0;
    lo = lo + Math.imul(al0, bl5) | 0;
    mid = mid + Math.imul(al0, bh5) | 0;
    mid = mid + Math.imul(ah0, bl5) | 0;
    hi = hi + Math.imul(ah0, bh5) | 0;
    var w5 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w5 >>> 26) | 0;
    w5 &= 0x3ffffff;
    /* k = 6 */

    lo = Math.imul(al6, bl0);
    mid = Math.imul(al6, bh0);
    mid = mid + Math.imul(ah6, bl0) | 0;
    hi = Math.imul(ah6, bh0);
    lo = lo + Math.imul(al5, bl1) | 0;
    mid = mid + Math.imul(al5, bh1) | 0;
    mid = mid + Math.imul(ah5, bl1) | 0;
    hi = hi + Math.imul(ah5, bh1) | 0;
    lo = lo + Math.imul(al4, bl2) | 0;
    mid = mid + Math.imul(al4, bh2) | 0;
    mid = mid + Math.imul(ah4, bl2) | 0;
    hi = hi + Math.imul(ah4, bh2) | 0;
    lo = lo + Math.imul(al3, bl3) | 0;
    mid = mid + Math.imul(al3, bh3) | 0;
    mid = mid + Math.imul(ah3, bl3) | 0;
    hi = hi + Math.imul(ah3, bh3) | 0;
    lo = lo + Math.imul(al2, bl4) | 0;
    mid = mid + Math.imul(al2, bh4) | 0;
    mid = mid + Math.imul(ah2, bl4) | 0;
    hi = hi + Math.imul(ah2, bh4) | 0;
    lo = lo + Math.imul(al1, bl5) | 0;
    mid = mid + Math.imul(al1, bh5) | 0;
    mid = mid + Math.imul(ah1, bl5) | 0;
    hi = hi + Math.imul(ah1, bh5) | 0;
    lo = lo + Math.imul(al0, bl6) | 0;
    mid = mid + Math.imul(al0, bh6) | 0;
    mid = mid + Math.imul(ah0, bl6) | 0;
    hi = hi + Math.imul(ah0, bh6) | 0;
    var w6 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w6 >>> 26) | 0;
    w6 &= 0x3ffffff;
    /* k = 7 */

    lo = Math.imul(al7, bl0);
    mid = Math.imul(al7, bh0);
    mid = mid + Math.imul(ah7, bl0) | 0;
    hi = Math.imul(ah7, bh0);
    lo = lo + Math.imul(al6, bl1) | 0;
    mid = mid + Math.imul(al6, bh1) | 0;
    mid = mid + Math.imul(ah6, bl1) | 0;
    hi = hi + Math.imul(ah6, bh1) | 0;
    lo = lo + Math.imul(al5, bl2) | 0;
    mid = mid + Math.imul(al5, bh2) | 0;
    mid = mid + Math.imul(ah5, bl2) | 0;
    hi = hi + Math.imul(ah5, bh2) | 0;
    lo = lo + Math.imul(al4, bl3) | 0;
    mid = mid + Math.imul(al4, bh3) | 0;
    mid = mid + Math.imul(ah4, bl3) | 0;
    hi = hi + Math.imul(ah4, bh3) | 0;
    lo = lo + Math.imul(al3, bl4) | 0;
    mid = mid + Math.imul(al3, bh4) | 0;
    mid = mid + Math.imul(ah3, bl4) | 0;
    hi = hi + Math.imul(ah3, bh4) | 0;
    lo = lo + Math.imul(al2, bl5) | 0;
    mid = mid + Math.imul(al2, bh5) | 0;
    mid = mid + Math.imul(ah2, bl5) | 0;
    hi = hi + Math.imul(ah2, bh5) | 0;
    lo = lo + Math.imul(al1, bl6) | 0;
    mid = mid + Math.imul(al1, bh6) | 0;
    mid = mid + Math.imul(ah1, bl6) | 0;
    hi = hi + Math.imul(ah1, bh6) | 0;
    lo = lo + Math.imul(al0, bl7) | 0;
    mid = mid + Math.imul(al0, bh7) | 0;
    mid = mid + Math.imul(ah0, bl7) | 0;
    hi = hi + Math.imul(ah0, bh7) | 0;
    var w7 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w7 >>> 26) | 0;
    w7 &= 0x3ffffff;
    /* k = 8 */

    lo = Math.imul(al8, bl0);
    mid = Math.imul(al8, bh0);
    mid = mid + Math.imul(ah8, bl0) | 0;
    hi = Math.imul(ah8, bh0);
    lo = lo + Math.imul(al7, bl1) | 0;
    mid = mid + Math.imul(al7, bh1) | 0;
    mid = mid + Math.imul(ah7, bl1) | 0;
    hi = hi + Math.imul(ah7, bh1) | 0;
    lo = lo + Math.imul(al6, bl2) | 0;
    mid = mid + Math.imul(al6, bh2) | 0;
    mid = mid + Math.imul(ah6, bl2) | 0;
    hi = hi + Math.imul(ah6, bh2) | 0;
    lo = lo + Math.imul(al5, bl3) | 0;
    mid = mid + Math.imul(al5, bh3) | 0;
    mid = mid + Math.imul(ah5, bl3) | 0;
    hi = hi + Math.imul(ah5, bh3) | 0;
    lo = lo + Math.imul(al4, bl4) | 0;
    mid = mid + Math.imul(al4, bh4) | 0;
    mid = mid + Math.imul(ah4, bl4) | 0;
    hi = hi + Math.imul(ah4, bh4) | 0;
    lo = lo + Math.imul(al3, bl5) | 0;
    mid = mid + Math.imul(al3, bh5) | 0;
    mid = mid + Math.imul(ah3, bl5) | 0;
    hi = hi + Math.imul(ah3, bh5) | 0;
    lo = lo + Math.imul(al2, bl6) | 0;
    mid = mid + Math.imul(al2, bh6) | 0;
    mid = mid + Math.imul(ah2, bl6) | 0;
    hi = hi + Math.imul(ah2, bh6) | 0;
    lo = lo + Math.imul(al1, bl7) | 0;
    mid = mid + Math.imul(al1, bh7) | 0;
    mid = mid + Math.imul(ah1, bl7) | 0;
    hi = hi + Math.imul(ah1, bh7) | 0;
    lo = lo + Math.imul(al0, bl8) | 0;
    mid = mid + Math.imul(al0, bh8) | 0;
    mid = mid + Math.imul(ah0, bl8) | 0;
    hi = hi + Math.imul(ah0, bh8) | 0;
    var w8 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w8 >>> 26) | 0;
    w8 &= 0x3ffffff;
    /* k = 9 */

    lo = Math.imul(al9, bl0);
    mid = Math.imul(al9, bh0);
    mid = mid + Math.imul(ah9, bl0) | 0;
    hi = Math.imul(ah9, bh0);
    lo = lo + Math.imul(al8, bl1) | 0;
    mid = mid + Math.imul(al8, bh1) | 0;
    mid = mid + Math.imul(ah8, bl1) | 0;
    hi = hi + Math.imul(ah8, bh1) | 0;
    lo = lo + Math.imul(al7, bl2) | 0;
    mid = mid + Math.imul(al7, bh2) | 0;
    mid = mid + Math.imul(ah7, bl2) | 0;
    hi = hi + Math.imul(ah7, bh2) | 0;
    lo = lo + Math.imul(al6, bl3) | 0;
    mid = mid + Math.imul(al6, bh3) | 0;
    mid = mid + Math.imul(ah6, bl3) | 0;
    hi = hi + Math.imul(ah6, bh3) | 0;
    lo = lo + Math.imul(al5, bl4) | 0;
    mid = mid + Math.imul(al5, bh4) | 0;
    mid = mid + Math.imul(ah5, bl4) | 0;
    hi = hi + Math.imul(ah5, bh4) | 0;
    lo = lo + Math.imul(al4, bl5) | 0;
    mid = mid + Math.imul(al4, bh5) | 0;
    mid = mid + Math.imul(ah4, bl5) | 0;
    hi = hi + Math.imul(ah4, bh5) | 0;
    lo = lo + Math.imul(al3, bl6) | 0;
    mid = mid + Math.imul(al3, bh6) | 0;
    mid = mid + Math.imul(ah3, bl6) | 0;
    hi = hi + Math.imul(ah3, bh6) | 0;
    lo = lo + Math.imul(al2, bl7) | 0;
    mid = mid + Math.imul(al2, bh7) | 0;
    mid = mid + Math.imul(ah2, bl7) | 0;
    hi = hi + Math.imul(ah2, bh7) | 0;
    lo = lo + Math.imul(al1, bl8) | 0;
    mid = mid + Math.imul(al1, bh8) | 0;
    mid = mid + Math.imul(ah1, bl8) | 0;
    hi = hi + Math.imul(ah1, bh8) | 0;
    lo = lo + Math.imul(al0, bl9) | 0;
    mid = mid + Math.imul(al0, bh9) | 0;
    mid = mid + Math.imul(ah0, bl9) | 0;
    hi = hi + Math.imul(ah0, bh9) | 0;
    var w9 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w9 >>> 26) | 0;
    w9 &= 0x3ffffff;
    /* k = 10 */

    lo = Math.imul(al9, bl1);
    mid = Math.imul(al9, bh1);
    mid = mid + Math.imul(ah9, bl1) | 0;
    hi = Math.imul(ah9, bh1);
    lo = lo + Math.imul(al8, bl2) | 0;
    mid = mid + Math.imul(al8, bh2) | 0;
    mid = mid + Math.imul(ah8, bl2) | 0;
    hi = hi + Math.imul(ah8, bh2) | 0;
    lo = lo + Math.imul(al7, bl3) | 0;
    mid = mid + Math.imul(al7, bh3) | 0;
    mid = mid + Math.imul(ah7, bl3) | 0;
    hi = hi + Math.imul(ah7, bh3) | 0;
    lo = lo + Math.imul(al6, bl4) | 0;
    mid = mid + Math.imul(al6, bh4) | 0;
    mid = mid + Math.imul(ah6, bl4) | 0;
    hi = hi + Math.imul(ah6, bh4) | 0;
    lo = lo + Math.imul(al5, bl5) | 0;
    mid = mid + Math.imul(al5, bh5) | 0;
    mid = mid + Math.imul(ah5, bl5) | 0;
    hi = hi + Math.imul(ah5, bh5) | 0;
    lo = lo + Math.imul(al4, bl6) | 0;
    mid = mid + Math.imul(al4, bh6) | 0;
    mid = mid + Math.imul(ah4, bl6) | 0;
    hi = hi + Math.imul(ah4, bh6) | 0;
    lo = lo + Math.imul(al3, bl7) | 0;
    mid = mid + Math.imul(al3, bh7) | 0;
    mid = mid + Math.imul(ah3, bl7) | 0;
    hi = hi + Math.imul(ah3, bh7) | 0;
    lo = lo + Math.imul(al2, bl8) | 0;
    mid = mid + Math.imul(al2, bh8) | 0;
    mid = mid + Math.imul(ah2, bl8) | 0;
    hi = hi + Math.imul(ah2, bh8) | 0;
    lo = lo + Math.imul(al1, bl9) | 0;
    mid = mid + Math.imul(al1, bh9) | 0;
    mid = mid + Math.imul(ah1, bl9) | 0;
    hi = hi + Math.imul(ah1, bh9) | 0;
    var w10 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w10 >>> 26) | 0;
    w10 &= 0x3ffffff;
    /* k = 11 */

    lo = Math.imul(al9, bl2);
    mid = Math.imul(al9, bh2);
    mid = mid + Math.imul(ah9, bl2) | 0;
    hi = Math.imul(ah9, bh2);
    lo = lo + Math.imul(al8, bl3) | 0;
    mid = mid + Math.imul(al8, bh3) | 0;
    mid = mid + Math.imul(ah8, bl3) | 0;
    hi = hi + Math.imul(ah8, bh3) | 0;
    lo = lo + Math.imul(al7, bl4) | 0;
    mid = mid + Math.imul(al7, bh4) | 0;
    mid = mid + Math.imul(ah7, bl4) | 0;
    hi = hi + Math.imul(ah7, bh4) | 0;
    lo = lo + Math.imul(al6, bl5) | 0;
    mid = mid + Math.imul(al6, bh5) | 0;
    mid = mid + Math.imul(ah6, bl5) | 0;
    hi = hi + Math.imul(ah6, bh5) | 0;
    lo = lo + Math.imul(al5, bl6) | 0;
    mid = mid + Math.imul(al5, bh6) | 0;
    mid = mid + Math.imul(ah5, bl6) | 0;
    hi = hi + Math.imul(ah5, bh6) | 0;
    lo = lo + Math.imul(al4, bl7) | 0;
    mid = mid + Math.imul(al4, bh7) | 0;
    mid = mid + Math.imul(ah4, bl7) | 0;
    hi = hi + Math.imul(ah4, bh7) | 0;
    lo = lo + Math.imul(al3, bl8) | 0;
    mid = mid + Math.imul(al3, bh8) | 0;
    mid = mid + Math.imul(ah3, bl8) | 0;
    hi = hi + Math.imul(ah3, bh8) | 0;
    lo = lo + Math.imul(al2, bl9) | 0;
    mid = mid + Math.imul(al2, bh9) | 0;
    mid = mid + Math.imul(ah2, bl9) | 0;
    hi = hi + Math.imul(ah2, bh9) | 0;
    var w11 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w11 >>> 26) | 0;
    w11 &= 0x3ffffff;
    /* k = 12 */

    lo = Math.imul(al9, bl3);
    mid = Math.imul(al9, bh3);
    mid = mid + Math.imul(ah9, bl3) | 0;
    hi = Math.imul(ah9, bh3);
    lo = lo + Math.imul(al8, bl4) | 0;
    mid = mid + Math.imul(al8, bh4) | 0;
    mid = mid + Math.imul(ah8, bl4) | 0;
    hi = hi + Math.imul(ah8, bh4) | 0;
    lo = lo + Math.imul(al7, bl5) | 0;
    mid = mid + Math.imul(al7, bh5) | 0;
    mid = mid + Math.imul(ah7, bl5) | 0;
    hi = hi + Math.imul(ah7, bh5) | 0;
    lo = lo + Math.imul(al6, bl6) | 0;
    mid = mid + Math.imul(al6, bh6) | 0;
    mid = mid + Math.imul(ah6, bl6) | 0;
    hi = hi + Math.imul(ah6, bh6) | 0;
    lo = lo + Math.imul(al5, bl7) | 0;
    mid = mid + Math.imul(al5, bh7) | 0;
    mid = mid + Math.imul(ah5, bl7) | 0;
    hi = hi + Math.imul(ah5, bh7) | 0;
    lo = lo + Math.imul(al4, bl8) | 0;
    mid = mid + Math.imul(al4, bh8) | 0;
    mid = mid + Math.imul(ah4, bl8) | 0;
    hi = hi + Math.imul(ah4, bh8) | 0;
    lo = lo + Math.imul(al3, bl9) | 0;
    mid = mid + Math.imul(al3, bh9) | 0;
    mid = mid + Math.imul(ah3, bl9) | 0;
    hi = hi + Math.imul(ah3, bh9) | 0;
    var w12 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w12 >>> 26) | 0;
    w12 &= 0x3ffffff;
    /* k = 13 */

    lo = Math.imul(al9, bl4);
    mid = Math.imul(al9, bh4);
    mid = mid + Math.imul(ah9, bl4) | 0;
    hi = Math.imul(ah9, bh4);
    lo = lo + Math.imul(al8, bl5) | 0;
    mid = mid + Math.imul(al8, bh5) | 0;
    mid = mid + Math.imul(ah8, bl5) | 0;
    hi = hi + Math.imul(ah8, bh5) | 0;
    lo = lo + Math.imul(al7, bl6) | 0;
    mid = mid + Math.imul(al7, bh6) | 0;
    mid = mid + Math.imul(ah7, bl6) | 0;
    hi = hi + Math.imul(ah7, bh6) | 0;
    lo = lo + Math.imul(al6, bl7) | 0;
    mid = mid + Math.imul(al6, bh7) | 0;
    mid = mid + Math.imul(ah6, bl7) | 0;
    hi = hi + Math.imul(ah6, bh7) | 0;
    lo = lo + Math.imul(al5, bl8) | 0;
    mid = mid + Math.imul(al5, bh8) | 0;
    mid = mid + Math.imul(ah5, bl8) | 0;
    hi = hi + Math.imul(ah5, bh8) | 0;
    lo = lo + Math.imul(al4, bl9) | 0;
    mid = mid + Math.imul(al4, bh9) | 0;
    mid = mid + Math.imul(ah4, bl9) | 0;
    hi = hi + Math.imul(ah4, bh9) | 0;
    var w13 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w13 >>> 26) | 0;
    w13 &= 0x3ffffff;
    /* k = 14 */

    lo = Math.imul(al9, bl5);
    mid = Math.imul(al9, bh5);
    mid = mid + Math.imul(ah9, bl5) | 0;
    hi = Math.imul(ah9, bh5);
    lo = lo + Math.imul(al8, bl6) | 0;
    mid = mid + Math.imul(al8, bh6) | 0;
    mid = mid + Math.imul(ah8, bl6) | 0;
    hi = hi + Math.imul(ah8, bh6) | 0;
    lo = lo + Math.imul(al7, bl7) | 0;
    mid = mid + Math.imul(al7, bh7) | 0;
    mid = mid + Math.imul(ah7, bl7) | 0;
    hi = hi + Math.imul(ah7, bh7) | 0;
    lo = lo + Math.imul(al6, bl8) | 0;
    mid = mid + Math.imul(al6, bh8) | 0;
    mid = mid + Math.imul(ah6, bl8) | 0;
    hi = hi + Math.imul(ah6, bh8) | 0;
    lo = lo + Math.imul(al5, bl9) | 0;
    mid = mid + Math.imul(al5, bh9) | 0;
    mid = mid + Math.imul(ah5, bl9) | 0;
    hi = hi + Math.imul(ah5, bh9) | 0;
    var w14 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w14 >>> 26) | 0;
    w14 &= 0x3ffffff;
    /* k = 15 */

    lo = Math.imul(al9, bl6);
    mid = Math.imul(al9, bh6);
    mid = mid + Math.imul(ah9, bl6) | 0;
    hi = Math.imul(ah9, bh6);
    lo = lo + Math.imul(al8, bl7) | 0;
    mid = mid + Math.imul(al8, bh7) | 0;
    mid = mid + Math.imul(ah8, bl7) | 0;
    hi = hi + Math.imul(ah8, bh7) | 0;
    lo = lo + Math.imul(al7, bl8) | 0;
    mid = mid + Math.imul(al7, bh8) | 0;
    mid = mid + Math.imul(ah7, bl8) | 0;
    hi = hi + Math.imul(ah7, bh8) | 0;
    lo = lo + Math.imul(al6, bl9) | 0;
    mid = mid + Math.imul(al6, bh9) | 0;
    mid = mid + Math.imul(ah6, bl9) | 0;
    hi = hi + Math.imul(ah6, bh9) | 0;
    var w15 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w15 >>> 26) | 0;
    w15 &= 0x3ffffff;
    /* k = 16 */

    lo = Math.imul(al9, bl7);
    mid = Math.imul(al9, bh7);
    mid = mid + Math.imul(ah9, bl7) | 0;
    hi = Math.imul(ah9, bh7);
    lo = lo + Math.imul(al8, bl8) | 0;
    mid = mid + Math.imul(al8, bh8) | 0;
    mid = mid + Math.imul(ah8, bl8) | 0;
    hi = hi + Math.imul(ah8, bh8) | 0;
    lo = lo + Math.imul(al7, bl9) | 0;
    mid = mid + Math.imul(al7, bh9) | 0;
    mid = mid + Math.imul(ah7, bl9) | 0;
    hi = hi + Math.imul(ah7, bh9) | 0;
    var w16 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w16 >>> 26) | 0;
    w16 &= 0x3ffffff;
    /* k = 17 */

    lo = Math.imul(al9, bl8);
    mid = Math.imul(al9, bh8);
    mid = mid + Math.imul(ah9, bl8) | 0;
    hi = Math.imul(ah9, bh8);
    lo = lo + Math.imul(al8, bl9) | 0;
    mid = mid + Math.imul(al8, bh9) | 0;
    mid = mid + Math.imul(ah8, bl9) | 0;
    hi = hi + Math.imul(ah8, bh9) | 0;
    var w17 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w17 >>> 26) | 0;
    w17 &= 0x3ffffff;
    /* k = 18 */

    lo = Math.imul(al9, bl9);
    mid = Math.imul(al9, bh9);
    mid = mid + Math.imul(ah9, bl9) | 0;
    hi = Math.imul(ah9, bh9);
    var w18 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w18 >>> 26) | 0;
    w18 &= 0x3ffffff;
    o[0] = w0;
    o[1] = w1;
    o[2] = w2;
    o[3] = w3;
    o[4] = w4;
    o[5] = w5;
    o[6] = w6;
    o[7] = w7;
    o[8] = w8;
    o[9] = w9;
    o[10] = w10;
    o[11] = w11;
    o[12] = w12;
    o[13] = w13;
    o[14] = w14;
    o[15] = w15;
    o[16] = w16;
    o[17] = w17;
    o[18] = w18;

    if (c !== 0) {
      o[19] = c;
      out.length++;
    }

    return out;
  }; // Polyfill comb


  if (!Math.imul) {
    comb10MulTo = smallMulTo;
  }

  function bigMulTo(self, num, out) {
    out.negative = num.negative ^ self.negative;
    out.length = self.length + num.length;
    var carry = 0;
    var hncarry = 0;

    for (var k = 0; k < out.length - 1; k++) {
      // Sum all words with the same `i + j = k` and accumulate `ncarry`,
      // note that ncarry could be >= 0x3ffffff
      var ncarry = hncarry;
      hncarry = 0;
      var rword = carry & 0x3ffffff;
      var maxJ = Math.min(k, num.length - 1);

      for (var j = Math.max(0, k - self.length + 1); j <= maxJ; j++) {
        var i = k - j;
        var a = self.words[i] | 0;
        var b = num.words[j] | 0;
        var r = a * b;
        var lo = r & 0x3ffffff;
        ncarry = ncarry + (r / 0x4000000 | 0) | 0;
        lo = lo + rword | 0;
        rword = lo & 0x3ffffff;
        ncarry = ncarry + (lo >>> 26) | 0;
        hncarry += ncarry >>> 26;
        ncarry &= 0x3ffffff;
      }

      out.words[k] = rword;
      carry = ncarry;
      ncarry = hncarry;
    }

    if (carry !== 0) {
      out.words[k] = carry;
    } else {
      out.length--;
    }

    return out.strip();
  }

  function jumboMulTo(self, num, out) {
    var fftm = new FFTM();
    return fftm.mulp(self, num, out);
  }

  BN.prototype.mulTo = function mulTo(num, out) {
    var res;
    var len = this.length + num.length;

    if (this.length === 10 && num.length === 10) {
      res = comb10MulTo(this, num, out);
    } else if (len < 63) {
      res = smallMulTo(this, num, out);
    } else if (len < 1024) {
      res = bigMulTo(this, num, out);
    } else {
      res = jumboMulTo(this, num, out);
    }

    return res;
  }; // Cooley-Tukey algorithm for FFT
  // slightly revisited to rely on looping instead of recursion


  function FFTM(x, y) {
    this.x = x;
    this.y = y;
  }

  FFTM.prototype.makeRBT = function makeRBT(N) {
    var t = new Array(N);
    var l = BN.prototype._countBits(N) - 1;

    for (var i = 0; i < N; i++) {
      t[i] = this.revBin(i, l, N);
    }

    return t;
  }; // Returns binary-reversed representation of `x`


  FFTM.prototype.revBin = function revBin(x, l, N) {
    if (x === 0 || x === N - 1) return x;
    var rb = 0;

    for (var i = 0; i < l; i++) {
      rb |= (x & 1) << l - i - 1;
      x >>= 1;
    }

    return rb;
  }; // Performs "tweedling" phase, therefore 'emulating'
  // behaviour of the recursive algorithm


  FFTM.prototype.permute = function permute(rbt, rws, iws, rtws, itws, N) {
    for (var i = 0; i < N; i++) {
      rtws[i] = rws[rbt[i]];
      itws[i] = iws[rbt[i]];
    }
  };

  FFTM.prototype.transform = function transform(rws, iws, rtws, itws, N, rbt) {
    this.permute(rbt, rws, iws, rtws, itws, N);

    for (var s = 1; s < N; s <<= 1) {
      var l = s << 1;
      var rtwdf = Math.cos(2 * Math.PI / l);
      var itwdf = Math.sin(2 * Math.PI / l);

      for (var p = 0; p < N; p += l) {
        var rtwdf_ = rtwdf;
        var itwdf_ = itwdf;

        for (var j = 0; j < s; j++) {
          var re = rtws[p + j];
          var ie = itws[p + j];
          var ro = rtws[p + j + s];
          var io = itws[p + j + s];
          var rx = rtwdf_ * ro - itwdf_ * io;
          io = rtwdf_ * io + itwdf_ * ro;
          ro = rx;
          rtws[p + j] = re + ro;
          itws[p + j] = ie + io;
          rtws[p + j + s] = re - ro;
          itws[p + j + s] = ie - io;
          /* jshint maxdepth : false */

          if (j !== l) {
            rx = rtwdf * rtwdf_ - itwdf * itwdf_;
            itwdf_ = rtwdf * itwdf_ + itwdf * rtwdf_;
            rtwdf_ = rx;
          }
        }
      }
    }
  };

  FFTM.prototype.guessLen13b = function guessLen13b(n, m) {
    var N = Math.max(m, n) | 1;
    var odd = N & 1;
    var i = 0;

    for (N = N / 2 | 0; N; N = N >>> 1) {
      i++;
    }

    return 1 << i + 1 + odd;
  };

  FFTM.prototype.conjugate = function conjugate(rws, iws, N) {
    if (N <= 1) return;

    for (var i = 0; i < N / 2; i++) {
      var t = rws[i];
      rws[i] = rws[N - i - 1];
      rws[N - i - 1] = t;
      t = iws[i];
      iws[i] = -iws[N - i - 1];
      iws[N - i - 1] = -t;
    }
  };

  FFTM.prototype.normalize13b = function normalize13b(ws, N) {
    var carry = 0;

    for (var i = 0; i < N / 2; i++) {
      var w = Math.round(ws[2 * i + 1] / N) * 0x2000 + Math.round(ws[2 * i] / N) + carry;
      ws[i] = w & 0x3ffffff;

      if (w < 0x4000000) {
        carry = 0;
      } else {
        carry = w / 0x4000000 | 0;
      }
    }

    return ws;
  };

  FFTM.prototype.convert13b = function convert13b(ws, len, rws, N) {
    var carry = 0;

    for (var i = 0; i < len; i++) {
      carry = carry + (ws[i] | 0);
      rws[2 * i] = carry & 0x1fff;
      carry = carry >>> 13;
      rws[2 * i + 1] = carry & 0x1fff;
      carry = carry >>> 13;
    } // Pad with zeroes


    for (i = 2 * len; i < N; ++i) {
      rws[i] = 0;
    }

    assert(carry === 0);
    assert((carry & ~0x1fff) === 0);
  };

  FFTM.prototype.stub = function stub(N) {
    var ph = new Array(N);

    for (var i = 0; i < N; i++) {
      ph[i] = 0;
    }

    return ph;
  };

  FFTM.prototype.mulp = function mulp(x, y, out) {
    var N = 2 * this.guessLen13b(x.length, y.length);
    var rbt = this.makeRBT(N);

    var _ = this.stub(N);

    var rws = new Array(N);
    var rwst = new Array(N);
    var iwst = new Array(N);
    var nrws = new Array(N);
    var nrwst = new Array(N);
    var niwst = new Array(N);
    var rmws = out.words;
    rmws.length = N;
    this.convert13b(x.words, x.length, rws, N);
    this.convert13b(y.words, y.length, nrws, N);
    this.transform(rws, _, rwst, iwst, N, rbt);
    this.transform(nrws, _, nrwst, niwst, N, rbt);

    for (var i = 0; i < N; i++) {
      var rx = rwst[i] * nrwst[i] - iwst[i] * niwst[i];
      iwst[i] = rwst[i] * niwst[i] + iwst[i] * nrwst[i];
      rwst[i] = rx;
    }

    this.conjugate(rwst, iwst, N);
    this.transform(rwst, iwst, rmws, _, N, rbt);
    this.conjugate(rmws, _, N);
    this.normalize13b(rmws, N);
    out.negative = x.negative ^ y.negative;
    out.length = x.length + y.length;
    return out.strip();
  }; // Multiply `this` by `num`


  BN.prototype.mul = function mul(num) {
    var out = new BN(null);
    out.words = new Array(this.length + num.length);
    return this.mulTo(num, out);
  }; // Multiply employing FFT


  BN.prototype.mulf = function mulf(num) {
    var out = new BN(null);
    out.words = new Array(this.length + num.length);
    return jumboMulTo(this, num, out);
  }; // In-place Multiplication


  BN.prototype.imul = function imul(num) {
    return this.clone().mulTo(num, this);
  };

  BN.prototype.imuln = function imuln(num) {
    assert(typeof num === 'number');
    assert(num < 0x4000000); // Carry

    var carry = 0;

    for (var i = 0; i < this.length; i++) {
      var w = (this.words[i] | 0) * num;
      var lo = (w & 0x3ffffff) + (carry & 0x3ffffff);
      carry >>= 26;
      carry += w / 0x4000000 | 0; // NOTE: lo is 27bit maximum

      carry += lo >>> 26;
      this.words[i] = lo & 0x3ffffff;
    }

    if (carry !== 0) {
      this.words[i] = carry;
      this.length++;
    }

    return this;
  };

  BN.prototype.muln = function muln(num) {
    return this.clone().imuln(num);
  }; // `this` * `this`


  BN.prototype.sqr = function sqr() {
    return this.mul(this);
  }; // `this` * `this` in-place


  BN.prototype.isqr = function isqr() {
    return this.imul(this.clone());
  }; // Math.pow(`this`, `num`)


  BN.prototype.pow = function pow(num) {
    var w = toBitArray(num);
    if (w.length === 0) return new BN(1); // Skip leading zeroes

    var res = this;

    for (var i = 0; i < w.length; i++, res = res.sqr()) {
      if (w[i] !== 0) break;
    }

    if (++i < w.length) {
      for (var q = res.sqr(); i < w.length; i++, q = q.sqr()) {
        if (w[i] === 0) continue;
        res = res.mul(q);
      }
    }

    return res;
  }; // Shift-left in-place


  BN.prototype.iushln = function iushln(bits) {
    assert(typeof bits === 'number' && bits >= 0);
    var r = bits % 26;
    var s = (bits - r) / 26;
    var carryMask = 0x3ffffff >>> 26 - r << 26 - r;
    var i;

    if (r !== 0) {
      var carry = 0;

      for (i = 0; i < this.length; i++) {
        var newCarry = this.words[i] & carryMask;
        var c = (this.words[i] | 0) - newCarry << r;
        this.words[i] = c | carry;
        carry = newCarry >>> 26 - r;
      }

      if (carry) {
        this.words[i] = carry;
        this.length++;
      }
    }

    if (s !== 0) {
      for (i = this.length - 1; i >= 0; i--) {
        this.words[i + s] = this.words[i];
      }

      for (i = 0; i < s; i++) {
        this.words[i] = 0;
      }

      this.length += s;
    }

    return this.strip();
  };

  BN.prototype.ishln = function ishln(bits) {
    // TODO(indutny): implement me
    assert(this.negative === 0);
    return this.iushln(bits);
  }; // Shift-right in-place
  // NOTE: `hint` is a lowest bit before trailing zeroes
  // NOTE: if `extended` is present - it will be filled with destroyed bits


  BN.prototype.iushrn = function iushrn(bits, hint, extended) {
    assert(typeof bits === 'number' && bits >= 0);
    var h;

    if (hint) {
      h = (hint - hint % 26) / 26;
    } else {
      h = 0;
    }

    var r = bits % 26;
    var s = Math.min((bits - r) / 26, this.length);
    var mask = 0x3ffffff ^ 0x3ffffff >>> r << r;
    var maskedWords = extended;
    h -= s;
    h = Math.max(0, h); // Extended mode, copy masked part

    if (maskedWords) {
      for (var i = 0; i < s; i++) {
        maskedWords.words[i] = this.words[i];
      }

      maskedWords.length = s;
    }

    if (s === 0) {// No-op, we should not move anything at all
    } else if (this.length > s) {
      this.length -= s;

      for (i = 0; i < this.length; i++) {
        this.words[i] = this.words[i + s];
      }
    } else {
      this.words[0] = 0;
      this.length = 1;
    }

    var carry = 0;

    for (i = this.length - 1; i >= 0 && (carry !== 0 || i >= h); i--) {
      var word = this.words[i] | 0;
      this.words[i] = carry << 26 - r | word >>> r;
      carry = word & mask;
    } // Push carried bits as a mask


    if (maskedWords && carry !== 0) {
      maskedWords.words[maskedWords.length++] = carry;
    }

    if (this.length === 0) {
      this.words[0] = 0;
      this.length = 1;
    }

    return this.strip();
  };

  BN.prototype.ishrn = function ishrn(bits, hint, extended) {
    // TODO(indutny): implement me
    assert(this.negative === 0);
    return this.iushrn(bits, hint, extended);
  }; // Shift-left


  BN.prototype.shln = function shln(bits) {
    return this.clone().ishln(bits);
  };

  BN.prototype.ushln = function ushln(bits) {
    return this.clone().iushln(bits);
  }; // Shift-right


  BN.prototype.shrn = function shrn(bits) {
    return this.clone().ishrn(bits);
  };

  BN.prototype.ushrn = function ushrn(bits) {
    return this.clone().iushrn(bits);
  }; // Test if n bit is set


  BN.prototype.testn = function testn(bit) {
    assert(typeof bit === 'number' && bit >= 0);
    var r = bit % 26;
    var s = (bit - r) / 26;
    var q = 1 << r; // Fast case: bit is much higher than all existing words

    if (this.length <= s) return false; // Check bit and return

    var w = this.words[s];
    return !!(w & q);
  }; // Return only lowers bits of number (in-place)


  BN.prototype.imaskn = function imaskn(bits) {
    assert(typeof bits === 'number' && bits >= 0);
    var r = bits % 26;
    var s = (bits - r) / 26;
    assert(this.negative === 0, 'imaskn works only with positive numbers');

    if (this.length <= s) {
      return this;
    }

    if (r !== 0) {
      s++;
    }

    this.length = Math.min(s, this.length);

    if (r !== 0) {
      var mask = 0x3ffffff ^ 0x3ffffff >>> r << r;
      this.words[this.length - 1] &= mask;
    }

    return this.strip();
  }; // Return only lowers bits of number


  BN.prototype.maskn = function maskn(bits) {
    return this.clone().imaskn(bits);
  }; // Add plain number `num` to `this`


  BN.prototype.iaddn = function iaddn(num) {
    assert(typeof num === 'number');
    assert(num < 0x4000000);
    if (num < 0) return this.isubn(-num); // Possible sign change

    if (this.negative !== 0) {
      if (this.length === 1 && (this.words[0] | 0) < num) {
        this.words[0] = num - (this.words[0] | 0);
        this.negative = 0;
        return this;
      }

      this.negative = 0;
      this.isubn(num);
      this.negative = 1;
      return this;
    } // Add without checks


    return this._iaddn(num);
  };

  BN.prototype._iaddn = function _iaddn(num) {
    this.words[0] += num; // Carry

    for (var i = 0; i < this.length && this.words[i] >= 0x4000000; i++) {
      this.words[i] -= 0x4000000;

      if (i === this.length - 1) {
        this.words[i + 1] = 1;
      } else {
        this.words[i + 1]++;
      }
    }

    this.length = Math.max(this.length, i + 1);
    return this;
  }; // Subtract plain number `num` from `this`


  BN.prototype.isubn = function isubn(num) {
    assert(typeof num === 'number');
    assert(num < 0x4000000);
    if (num < 0) return this.iaddn(-num);

    if (this.negative !== 0) {
      this.negative = 0;
      this.iaddn(num);
      this.negative = 1;
      return this;
    }

    this.words[0] -= num;

    if (this.length === 1 && this.words[0] < 0) {
      this.words[0] = -this.words[0];
      this.negative = 1;
    } else {
      // Carry
      for (var i = 0; i < this.length && this.words[i] < 0; i++) {
        this.words[i] += 0x4000000;
        this.words[i + 1] -= 1;
      }
    }

    return this.strip();
  };

  BN.prototype.addn = function addn(num) {
    return this.clone().iaddn(num);
  };

  BN.prototype.subn = function subn(num) {
    return this.clone().isubn(num);
  };

  BN.prototype.iabs = function iabs() {
    this.negative = 0;
    return this;
  };

  BN.prototype.abs = function abs() {
    return this.clone().iabs();
  };

  BN.prototype._ishlnsubmul = function _ishlnsubmul(num, mul, shift) {
    var len = num.length + shift;
    var i;

    this._expand(len);

    var w;
    var carry = 0;

    for (i = 0; i < num.length; i++) {
      w = (this.words[i + shift] | 0) + carry;
      var right = (num.words[i] | 0) * mul;
      w -= right & 0x3ffffff;
      carry = (w >> 26) - (right / 0x4000000 | 0);
      this.words[i + shift] = w & 0x3ffffff;
    }

    for (; i < this.length - shift; i++) {
      w = (this.words[i + shift] | 0) + carry;
      carry = w >> 26;
      this.words[i + shift] = w & 0x3ffffff;
    }

    if (carry === 0) return this.strip(); // Subtraction overflow

    assert(carry === -1);
    carry = 0;

    for (i = 0; i < this.length; i++) {
      w = -(this.words[i] | 0) + carry;
      carry = w >> 26;
      this.words[i] = w & 0x3ffffff;
    }

    this.negative = 1;
    return this.strip();
  };

  BN.prototype._wordDiv = function _wordDiv(num, mode) {
    var shift = this.length - num.length;
    var a = this.clone();
    var b = num; // Normalize

    var bhi = b.words[b.length - 1] | 0;

    var bhiBits = this._countBits(bhi);

    shift = 26 - bhiBits;

    if (shift !== 0) {
      b = b.ushln(shift);
      a.iushln(shift);
      bhi = b.words[b.length - 1] | 0;
    } // Initialize quotient


    var m = a.length - b.length;
    var q;

    if (mode !== 'mod') {
      q = new BN(null);
      q.length = m + 1;
      q.words = new Array(q.length);

      for (var i = 0; i < q.length; i++) {
        q.words[i] = 0;
      }
    }

    var diff = a.clone()._ishlnsubmul(b, 1, m);

    if (diff.negative === 0) {
      a = diff;

      if (q) {
        q.words[m] = 1;
      }
    }

    for (var j = m - 1; j >= 0; j--) {
      var qj = (a.words[b.length + j] | 0) * 0x4000000 + (a.words[b.length + j - 1] | 0); // NOTE: (qj / bhi) is (0x3ffffff * 0x4000000 + 0x3ffffff) / 0x2000000 max
      // (0x7ffffff)

      qj = Math.min(qj / bhi | 0, 0x3ffffff);

      a._ishlnsubmul(b, qj, j);

      while (a.negative !== 0) {
        qj--;
        a.negative = 0;

        a._ishlnsubmul(b, 1, j);

        if (!a.isZero()) {
          a.negative ^= 1;
        }
      }

      if (q) {
        q.words[j] = qj;
      }
    }

    if (q) {
      q.strip();
    }

    a.strip(); // Denormalize

    if (mode !== 'div' && shift !== 0) {
      a.iushrn(shift);
    }

    return {
      div: q || null,
      mod: a
    };
  }; // NOTE: 1) `mode` can be set to `mod` to request mod only,
  //       to `div` to request div only, or be absent to
  //       request both div & mod
  //       2) `positive` is true if unsigned mod is requested


  BN.prototype.divmod = function divmod(num, mode, positive) {
    assert(!num.isZero());

    if (this.isZero()) {
      return {
        div: new BN(0),
        mod: new BN(0)
      };
    }

    var div, mod, res;

    if (this.negative !== 0 && num.negative === 0) {
      res = this.neg().divmod(num, mode);

      if (mode !== 'mod') {
        div = res.div.neg();
      }

      if (mode !== 'div') {
        mod = res.mod.neg();

        if (positive && mod.negative !== 0) {
          mod.iadd(num);
        }
      }

      return {
        div: div,
        mod: mod
      };
    }

    if (this.negative === 0 && num.negative !== 0) {
      res = this.divmod(num.neg(), mode);

      if (mode !== 'mod') {
        div = res.div.neg();
      }

      return {
        div: div,
        mod: res.mod
      };
    }

    if ((this.negative & num.negative) !== 0) {
      res = this.neg().divmod(num.neg(), mode);

      if (mode !== 'div') {
        mod = res.mod.neg();

        if (positive && mod.negative !== 0) {
          mod.isub(num);
        }
      }

      return {
        div: res.div,
        mod: mod
      };
    } // Both numbers are positive at this point
    // Strip both numbers to approximate shift value


    if (num.length > this.length || this.cmp(num) < 0) {
      return {
        div: new BN(0),
        mod: this
      };
    } // Very short reduction


    if (num.length === 1) {
      if (mode === 'div') {
        return {
          div: this.divn(num.words[0]),
          mod: null
        };
      }

      if (mode === 'mod') {
        return {
          div: null,
          mod: new BN(this.modn(num.words[0]))
        };
      }

      return {
        div: this.divn(num.words[0]),
        mod: new BN(this.modn(num.words[0]))
      };
    }

    return this._wordDiv(num, mode);
  }; // Find `this` / `num`


  BN.prototype.div = function div(num) {
    return this.divmod(num, 'div', false).div;
  }; // Find `this` % `num`


  BN.prototype.mod = function mod(num) {
    return this.divmod(num, 'mod', false).mod;
  };

  BN.prototype.umod = function umod(num) {
    return this.divmod(num, 'mod', true).mod;
  }; // Find Round(`this` / `num`)


  BN.prototype.divRound = function divRound(num) {
    var dm = this.divmod(num); // Fast case - exact division

    if (dm.mod.isZero()) return dm.div;
    var mod = dm.div.negative !== 0 ? dm.mod.isub(num) : dm.mod;
    var half = num.ushrn(1);
    var r2 = num.andln(1);
    var cmp = mod.cmp(half); // Round down

    if (cmp < 0 || r2 === 1 && cmp === 0) return dm.div; // Round up

    return dm.div.negative !== 0 ? dm.div.isubn(1) : dm.div.iaddn(1);
  };

  BN.prototype.modn = function modn(num) {
    assert(num <= 0x3ffffff);
    var p = (1 << 26) % num;
    var acc = 0;

    for (var i = this.length - 1; i >= 0; i--) {
      acc = (p * acc + (this.words[i] | 0)) % num;
    }

    return acc;
  }; // In-place division by number


  BN.prototype.idivn = function idivn(num) {
    assert(num <= 0x3ffffff);
    var carry = 0;

    for (var i = this.length - 1; i >= 0; i--) {
      var w = (this.words[i] | 0) + carry * 0x4000000;
      this.words[i] = w / num | 0;
      carry = w % num;
    }

    return this.strip();
  };

  BN.prototype.divn = function divn(num) {
    return this.clone().idivn(num);
  };

  BN.prototype.egcd = function egcd(p) {
    assert(p.negative === 0);
    assert(!p.isZero());
    var x = this;
    var y = p.clone();

    if (x.negative !== 0) {
      x = x.umod(p);
    } else {
      x = x.clone();
    } // A * x + B * y = x


    var A = new BN(1);
    var B = new BN(0); // C * x + D * y = y

    var C = new BN(0);
    var D = new BN(1);
    var g = 0;

    while (x.isEven() && y.isEven()) {
      x.iushrn(1);
      y.iushrn(1);
      ++g;
    }

    var yp = y.clone();
    var xp = x.clone();

    while (!x.isZero()) {
      for (var i = 0, im = 1; (x.words[0] & im) === 0 && i < 26; ++i, im <<= 1) {
        ;
      }

      if (i > 0) {
        x.iushrn(i);

        while (i-- > 0) {
          if (A.isOdd() || B.isOdd()) {
            A.iadd(yp);
            B.isub(xp);
          }

          A.iushrn(1);
          B.iushrn(1);
        }
      }

      for (var j = 0, jm = 1; (y.words[0] & jm) === 0 && j < 26; ++j, jm <<= 1) {
        ;
      }

      if (j > 0) {
        y.iushrn(j);

        while (j-- > 0) {
          if (C.isOdd() || D.isOdd()) {
            C.iadd(yp);
            D.isub(xp);
          }

          C.iushrn(1);
          D.iushrn(1);
        }
      }

      if (x.cmp(y) >= 0) {
        x.isub(y);
        A.isub(C);
        B.isub(D);
      } else {
        y.isub(x);
        C.isub(A);
        D.isub(B);
      }
    }

    return {
      a: C,
      b: D,
      gcd: y.iushln(g)
    };
  }; // This is reduced incarnation of the binary EEA
  // above, designated to invert members of the
  // _prime_ fields F(p) at a maximal speed


  BN.prototype._invmp = function _invmp(p) {
    assert(p.negative === 0);
    assert(!p.isZero());
    var a = this;
    var b = p.clone();

    if (a.negative !== 0) {
      a = a.umod(p);
    } else {
      a = a.clone();
    }

    var x1 = new BN(1);
    var x2 = new BN(0);
    var delta = b.clone();

    while (a.cmpn(1) > 0 && b.cmpn(1) > 0) {
      for (var i = 0, im = 1; (a.words[0] & im) === 0 && i < 26; ++i, im <<= 1) {
        ;
      }

      if (i > 0) {
        a.iushrn(i);

        while (i-- > 0) {
          if (x1.isOdd()) {
            x1.iadd(delta);
          }

          x1.iushrn(1);
        }
      }

      for (var j = 0, jm = 1; (b.words[0] & jm) === 0 && j < 26; ++j, jm <<= 1) {
        ;
      }

      if (j > 0) {
        b.iushrn(j);

        while (j-- > 0) {
          if (x2.isOdd()) {
            x2.iadd(delta);
          }

          x2.iushrn(1);
        }
      }

      if (a.cmp(b) >= 0) {
        a.isub(b);
        x1.isub(x2);
      } else {
        b.isub(a);
        x2.isub(x1);
      }
    }

    var res;

    if (a.cmpn(1) === 0) {
      res = x1;
    } else {
      res = x2;
    }

    if (res.cmpn(0) < 0) {
      res.iadd(p);
    }

    return res;
  };

  BN.prototype.gcd = function gcd(num) {
    if (this.isZero()) return num.abs();
    if (num.isZero()) return this.abs();
    var a = this.clone();
    var b = num.clone();
    a.negative = 0;
    b.negative = 0; // Remove common factor of two

    for (var shift = 0; a.isEven() && b.isEven(); shift++) {
      a.iushrn(1);
      b.iushrn(1);
    }

    do {
      while (a.isEven()) {
        a.iushrn(1);
      }

      while (b.isEven()) {
        b.iushrn(1);
      }

      var r = a.cmp(b);

      if (r < 0) {
        // Swap `a` and `b` to make `a` always bigger than `b`
        var t = a;
        a = b;
        b = t;
      } else if (r === 0 || b.cmpn(1) === 0) {
        break;
      }

      a.isub(b);
    } while (true);

    return b.iushln(shift);
  }; // Invert number in the field F(num)


  BN.prototype.invm = function invm(num) {
    return this.egcd(num).a.umod(num);
  };

  BN.prototype.isEven = function isEven() {
    return (this.words[0] & 1) === 0;
  };

  BN.prototype.isOdd = function isOdd() {
    return (this.words[0] & 1) === 1;
  }; // And first word and num


  BN.prototype.andln = function andln(num) {
    return this.words[0] & num;
  }; // Increment at the bit position in-line


  BN.prototype.bincn = function bincn(bit) {
    assert(typeof bit === 'number');
    var r = bit % 26;
    var s = (bit - r) / 26;
    var q = 1 << r; // Fast case: bit is much higher than all existing words

    if (this.length <= s) {
      this._expand(s + 1);

      this.words[s] |= q;
      return this;
    } // Add bit and propagate, if needed


    var carry = q;

    for (var i = s; carry !== 0 && i < this.length; i++) {
      var w = this.words[i] | 0;
      w += carry;
      carry = w >>> 26;
      w &= 0x3ffffff;
      this.words[i] = w;
    }

    if (carry !== 0) {
      this.words[i] = carry;
      this.length++;
    }

    return this;
  };

  BN.prototype.isZero = function isZero() {
    return this.length === 1 && this.words[0] === 0;
  };

  BN.prototype.cmpn = function cmpn(num) {
    var negative = num < 0;
    if (this.negative !== 0 && !negative) return -1;
    if (this.negative === 0 && negative) return 1;
    this.strip();
    var res;

    if (this.length > 1) {
      res = 1;
    } else {
      if (negative) {
        num = -num;
      }

      assert(num <= 0x3ffffff, 'Number is too big');
      var w = this.words[0] | 0;
      res = w === num ? 0 : w < num ? -1 : 1;
    }

    if (this.negative !== 0) return -res | 0;
    return res;
  }; // Compare two numbers and return:
  // 1 - if `this` > `num`
  // 0 - if `this` == `num`
  // -1 - if `this` < `num`


  BN.prototype.cmp = function cmp(num) {
    if (this.negative !== 0 && num.negative === 0) return -1;
    if (this.negative === 0 && num.negative !== 0) return 1;
    var res = this.ucmp(num);
    if (this.negative !== 0) return -res | 0;
    return res;
  }; // Unsigned comparison


  BN.prototype.ucmp = function ucmp(num) {
    // At this point both numbers have the same sign
    if (this.length > num.length) return 1;
    if (this.length < num.length) return -1;
    var res = 0;

    for (var i = this.length - 1; i >= 0; i--) {
      var a = this.words[i] | 0;
      var b = num.words[i] | 0;
      if (a === b) continue;

      if (a < b) {
        res = -1;
      } else if (a > b) {
        res = 1;
      }

      break;
    }

    return res;
  };

  BN.prototype.gtn = function gtn(num) {
    return this.cmpn(num) === 1;
  };

  BN.prototype.gt = function gt(num) {
    return this.cmp(num) === 1;
  };

  BN.prototype.gten = function gten(num) {
    return this.cmpn(num) >= 0;
  };

  BN.prototype.gte = function gte(num) {
    return this.cmp(num) >= 0;
  };

  BN.prototype.ltn = function ltn(num) {
    return this.cmpn(num) === -1;
  };

  BN.prototype.lt = function lt(num) {
    return this.cmp(num) === -1;
  };

  BN.prototype.lten = function lten(num) {
    return this.cmpn(num) <= 0;
  };

  BN.prototype.lte = function lte(num) {
    return this.cmp(num) <= 0;
  };

  BN.prototype.eqn = function eqn(num) {
    return this.cmpn(num) === 0;
  };

  BN.prototype.eq = function eq(num) {
    return this.cmp(num) === 0;
  }; //
  // A reduce context, could be using montgomery or something better, depending
  // on the `m` itself.
  //


  BN.red = function red(num) {
    return new Red(num);
  };

  BN.prototype.toRed = function toRed(ctx) {
    assert(!this.red, 'Already a number in reduction context');
    assert(this.negative === 0, 'red works only with positives');
    return ctx.convertTo(this)._forceRed(ctx);
  };

  BN.prototype.fromRed = function fromRed() {
    assert(this.red, 'fromRed works only with numbers in reduction context');
    return this.red.convertFrom(this);
  };

  BN.prototype._forceRed = function _forceRed(ctx) {
    this.red = ctx;
    return this;
  };

  BN.prototype.forceRed = function forceRed(ctx) {
    assert(!this.red, 'Already a number in reduction context');
    return this._forceRed(ctx);
  };

  BN.prototype.redAdd = function redAdd(num) {
    assert(this.red, 'redAdd works only with red numbers');
    return this.red.add(this, num);
  };

  BN.prototype.redIAdd = function redIAdd(num) {
    assert(this.red, 'redIAdd works only with red numbers');
    return this.red.iadd(this, num);
  };

  BN.prototype.redSub = function redSub(num) {
    assert(this.red, 'redSub works only with red numbers');
    return this.red.sub(this, num);
  };

  BN.prototype.redISub = function redISub(num) {
    assert(this.red, 'redISub works only with red numbers');
    return this.red.isub(this, num);
  };

  BN.prototype.redShl = function redShl(num) {
    assert(this.red, 'redShl works only with red numbers');
    return this.red.shl(this, num);
  };

  BN.prototype.redMul = function redMul(num) {
    assert(this.red, 'redMul works only with red numbers');

    this.red._verify2(this, num);

    return this.red.mul(this, num);
  };

  BN.prototype.redIMul = function redIMul(num) {
    assert(this.red, 'redMul works only with red numbers');

    this.red._verify2(this, num);

    return this.red.imul(this, num);
  };

  BN.prototype.redSqr = function redSqr() {
    assert(this.red, 'redSqr works only with red numbers');

    this.red._verify1(this);

    return this.red.sqr(this);
  };

  BN.prototype.redISqr = function redISqr() {
    assert(this.red, 'redISqr works only with red numbers');

    this.red._verify1(this);

    return this.red.isqr(this);
  }; // Square root over p


  BN.prototype.redSqrt = function redSqrt() {
    assert(this.red, 'redSqrt works only with red numbers');

    this.red._verify1(this);

    return this.red.sqrt(this);
  };

  BN.prototype.redInvm = function redInvm() {
    assert(this.red, 'redInvm works only with red numbers');

    this.red._verify1(this);

    return this.red.invm(this);
  }; // Return negative clone of `this` % `red modulo`


  BN.prototype.redNeg = function redNeg() {
    assert(this.red, 'redNeg works only with red numbers');

    this.red._verify1(this);

    return this.red.neg(this);
  };

  BN.prototype.redPow = function redPow(num) {
    assert(this.red && !num.red, 'redPow(normalNum)');

    this.red._verify1(this);

    return this.red.pow(this, num);
  }; // Prime numbers with efficient reduction


  var primes = {
    k256: null,
    p224: null,
    p192: null,
    p25519: null
  }; // Pseudo-Mersenne prime

  function MPrime(name, p) {
    // P = 2 ^ N - K
    this.name = name;
    this.p = new BN(p, 16);
    this.n = this.p.bitLength();
    this.k = new BN(1).iushln(this.n).isub(this.p);
    this.tmp = this._tmp();
  }

  MPrime.prototype._tmp = function _tmp() {
    var tmp = new BN(null);
    tmp.words = new Array(Math.ceil(this.n / 13));
    return tmp;
  };

  MPrime.prototype.ireduce = function ireduce(num) {
    // Assumes that `num` is less than `P^2`
    // num = HI * (2 ^ N - K) + HI * K + LO = HI * K + LO (mod P)
    var r = num;
    var rlen;

    do {
      this.split(r, this.tmp);
      r = this.imulK(r);
      r = r.iadd(this.tmp);
      rlen = r.bitLength();
    } while (rlen > this.n);

    var cmp = rlen < this.n ? -1 : r.ucmp(this.p);

    if (cmp === 0) {
      r.words[0] = 0;
      r.length = 1;
    } else if (cmp > 0) {
      r.isub(this.p);
    } else {
      r.strip();
    }

    return r;
  };

  MPrime.prototype.split = function split(input, out) {
    input.iushrn(this.n, 0, out);
  };

  MPrime.prototype.imulK = function imulK(num) {
    return num.imul(this.k);
  };

  function K256() {
    MPrime.call(this, 'k256', 'ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff fffffffe fffffc2f');
  }

  inherits(K256, MPrime);

  K256.prototype.split = function split(input, output) {
    // 256 = 9 * 26 + 22
    var mask = 0x3fffff;
    var outLen = Math.min(input.length, 9);

    for (var i = 0; i < outLen; i++) {
      output.words[i] = input.words[i];
    }

    output.length = outLen;

    if (input.length <= 9) {
      input.words[0] = 0;
      input.length = 1;
      return;
    } // Shift by 9 limbs


    var prev = input.words[9];
    output.words[output.length++] = prev & mask;

    for (i = 10; i < input.length; i++) {
      var next = input.words[i] | 0;
      input.words[i - 10] = (next & mask) << 4 | prev >>> 22;
      prev = next;
    }

    prev >>>= 22;
    input.words[i - 10] = prev;

    if (prev === 0 && input.length > 10) {
      input.length -= 10;
    } else {
      input.length -= 9;
    }
  };

  K256.prototype.imulK = function imulK(num) {
    // K = 0x1000003d1 = [ 0x40, 0x3d1 ]
    num.words[num.length] = 0;
    num.words[num.length + 1] = 0;
    num.length += 2; // bounded at: 0x40 * 0x3ffffff + 0x3d0 = 0x100000390

    var lo = 0;

    for (var i = 0; i < num.length; i++) {
      var w = num.words[i] | 0;
      lo += w * 0x3d1;
      num.words[i] = lo & 0x3ffffff;
      lo = w * 0x40 + (lo / 0x4000000 | 0);
    } // Fast length reduction


    if (num.words[num.length - 1] === 0) {
      num.length--;

      if (num.words[num.length - 1] === 0) {
        num.length--;
      }
    }

    return num;
  };

  function P224() {
    MPrime.call(this, 'p224', 'ffffffff ffffffff ffffffff ffffffff 00000000 00000000 00000001');
  }

  inherits(P224, MPrime);

  function P192() {
    MPrime.call(this, 'p192', 'ffffffff ffffffff ffffffff fffffffe ffffffff ffffffff');
  }

  inherits(P192, MPrime);

  function P25519() {
    // 2 ^ 255 - 19
    MPrime.call(this, '25519', '7fffffffffffffff ffffffffffffffff ffffffffffffffff ffffffffffffffed');
  }

  inherits(P25519, MPrime);

  P25519.prototype.imulK = function imulK(num) {
    // K = 0x13
    var carry = 0;

    for (var i = 0; i < num.length; i++) {
      var hi = (num.words[i] | 0) * 0x13 + carry;
      var lo = hi & 0x3ffffff;
      hi >>>= 26;
      num.words[i] = lo;
      carry = hi;
    }

    if (carry !== 0) {
      num.words[num.length++] = carry;
    }

    return num;
  }; // Exported mostly for testing purposes, use plain name instead


  BN._prime = function prime(name) {
    // Cached version of prime
    if (primes[name]) return primes[name];
    var prime;

    if (name === 'k256') {
      prime = new K256();
    } else if (name === 'p224') {
      prime = new P224();
    } else if (name === 'p192') {
      prime = new P192();
    } else if (name === 'p25519') {
      prime = new P25519();
    } else {
      throw new Error('Unknown prime ' + name);
    }

    primes[name] = prime;
    return prime;
  }; //
  // Base reduction engine
  //


  function Red(m) {
    if (typeof m === 'string') {
      var prime = BN._prime(m);

      this.m = prime.p;
      this.prime = prime;
    } else {
      assert(m.gtn(1), 'modulus must be greater than 1');
      this.m = m;
      this.prime = null;
    }
  }

  Red.prototype._verify1 = function _verify1(a) {
    assert(a.negative === 0, 'red works only with positives');
    assert(a.red, 'red works only with red numbers');
  };

  Red.prototype._verify2 = function _verify2(a, b) {
    assert((a.negative | b.negative) === 0, 'red works only with positives');
    assert(a.red && a.red === b.red, 'red works only with red numbers');
  };

  Red.prototype.imod = function imod(a) {
    if (this.prime) return this.prime.ireduce(a)._forceRed(this);
    return a.umod(this.m)._forceRed(this);
  };

  Red.prototype.neg = function neg(a) {
    if (a.isZero()) {
      return a.clone();
    }

    return this.m.sub(a)._forceRed(this);
  };

  Red.prototype.add = function add(a, b) {
    this._verify2(a, b);

    var res = a.add(b);

    if (res.cmp(this.m) >= 0) {
      res.isub(this.m);
    }

    return res._forceRed(this);
  };

  Red.prototype.iadd = function iadd(a, b) {
    this._verify2(a, b);

    var res = a.iadd(b);

    if (res.cmp(this.m) >= 0) {
      res.isub(this.m);
    }

    return res;
  };

  Red.prototype.sub = function sub(a, b) {
    this._verify2(a, b);

    var res = a.sub(b);

    if (res.cmpn(0) < 0) {
      res.iadd(this.m);
    }

    return res._forceRed(this);
  };

  Red.prototype.isub = function isub(a, b) {
    this._verify2(a, b);

    var res = a.isub(b);

    if (res.cmpn(0) < 0) {
      res.iadd(this.m);
    }

    return res;
  };

  Red.prototype.shl = function shl(a, num) {
    this._verify1(a);

    return this.imod(a.ushln(num));
  };

  Red.prototype.imul = function imul(a, b) {
    this._verify2(a, b);

    return this.imod(a.imul(b));
  };

  Red.prototype.mul = function mul(a, b) {
    this._verify2(a, b);

    return this.imod(a.mul(b));
  };

  Red.prototype.isqr = function isqr(a) {
    return this.imul(a, a.clone());
  };

  Red.prototype.sqr = function sqr(a) {
    return this.mul(a, a);
  };

  Red.prototype.sqrt = function sqrt(a) {
    if (a.isZero()) return a.clone();
    var mod3 = this.m.andln(3);
    assert(mod3 % 2 === 1); // Fast case

    if (mod3 === 3) {
      var pow = this.m.add(new BN(1)).iushrn(2);
      return this.pow(a, pow);
    } // Tonelli-Shanks algorithm (Totally unoptimized and slow)
    //
    // Find Q and S, that Q * 2 ^ S = (P - 1)


    var q = this.m.subn(1);
    var s = 0;

    while (!q.isZero() && q.andln(1) === 0) {
      s++;
      q.iushrn(1);
    }

    assert(!q.isZero());
    var one = new BN(1).toRed(this);
    var nOne = one.redNeg(); // Find quadratic non-residue
    // NOTE: Max is such because of generalized Riemann hypothesis.

    var lpow = this.m.subn(1).iushrn(1);
    var z = this.m.bitLength();
    z = new BN(2 * z * z).toRed(this);

    while (this.pow(z, lpow).cmp(nOne) !== 0) {
      z.redIAdd(nOne);
    }

    var c = this.pow(z, q);
    var r = this.pow(a, q.addn(1).iushrn(1));
    var t = this.pow(a, q);
    var m = s;

    while (t.cmp(one) !== 0) {
      var tmp = t;

      for (var i = 0; tmp.cmp(one) !== 0; i++) {
        tmp = tmp.redSqr();
      }

      assert(i < m);
      var b = this.pow(c, new BN(1).iushln(m - i - 1));
      r = r.redMul(b);
      c = b.redSqr();
      t = t.redMul(c);
      m = i;
    }

    return r;
  };

  Red.prototype.invm = function invm(a) {
    var inv = a._invmp(this.m);

    if (inv.negative !== 0) {
      inv.negative = 0;
      return this.imod(inv).redNeg();
    } else {
      return this.imod(inv);
    }
  };

  Red.prototype.pow = function pow(a, num) {
    if (num.isZero()) return new BN(1).toRed(this);
    if (num.cmpn(1) === 0) return a.clone();
    var windowSize = 4;
    var wnd = new Array(1 << windowSize);
    wnd[0] = new BN(1).toRed(this);
    wnd[1] = a;

    for (var i = 2; i < wnd.length; i++) {
      wnd[i] = this.mul(wnd[i - 1], a);
    }

    var res = wnd[0];
    var current = 0;
    var currentLen = 0;
    var start = num.bitLength() % 26;

    if (start === 0) {
      start = 26;
    }

    for (i = num.length - 1; i >= 0; i--) {
      var word = num.words[i];

      for (var j = start - 1; j >= 0; j--) {
        var bit = word >> j & 1;

        if (res !== wnd[0]) {
          res = this.sqr(res);
        }

        if (bit === 0 && current === 0) {
          currentLen = 0;
          continue;
        }

        current <<= 1;
        current |= bit;
        currentLen++;
        if (currentLen !== windowSize && (i !== 0 || j !== 0)) continue;
        res = this.mul(res, wnd[current]);
        currentLen = 0;
        current = 0;
      }

      start = 26;
    }

    return res;
  };

  Red.prototype.convertTo = function convertTo(num) {
    var r = num.umod(this.m);
    return r === num ? r.clone() : r;
  };

  Red.prototype.convertFrom = function convertFrom(num) {
    var res = num.clone();
    res.red = null;
    return res;
  }; //
  // Montgomery method engine
  //


  BN.mont = function mont(num) {
    return new Mont(num);
  };

  function Mont(m) {
    Red.call(this, m);
    this.shift = this.m.bitLength();

    if (this.shift % 26 !== 0) {
      this.shift += 26 - this.shift % 26;
    }

    this.r = new BN(1).iushln(this.shift);
    this.r2 = this.imod(this.r.sqr());
    this.rinv = this.r._invmp(this.m);
    this.minv = this.rinv.mul(this.r).isubn(1).div(this.m);
    this.minv = this.minv.umod(this.r);
    this.minv = this.r.sub(this.minv);
  }

  inherits(Mont, Red);

  Mont.prototype.convertTo = function convertTo(num) {
    return this.imod(num.ushln(this.shift));
  };

  Mont.prototype.convertFrom = function convertFrom(num) {
    var r = this.imod(num.mul(this.rinv));
    r.red = null;
    return r;
  };

  Mont.prototype.imul = function imul(a, b) {
    if (a.isZero() || b.isZero()) {
      a.words[0] = 0;
      a.length = 1;
      return a;
    }

    var t = a.imul(b);
    var c = t.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m);
    var u = t.isub(c).iushrn(this.shift);
    var res = u;

    if (u.cmp(this.m) >= 0) {
      res = u.isub(this.m);
    } else if (u.cmpn(0) < 0) {
      res = u.iadd(this.m);
    }

    return res._forceRed(this);
  };

  Mont.prototype.mul = function mul(a, b) {
    if (a.isZero() || b.isZero()) return new BN(0)._forceRed(this);
    var t = a.mul(b);
    var c = t.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m);
    var u = t.isub(c).iushrn(this.shift);
    var res = u;

    if (u.cmp(this.m) >= 0) {
      res = u.isub(this.m);
    } else if (u.cmpn(0) < 0) {
      res = u.iadd(this.m);
    }

    return res._forceRed(this);
  };

  Mont.prototype.invm = function invm(a) {
    // (AR)^-1 * R^2 = (A^-1 * R^-1) * R^2 = A^-1 * R
    var res = this.imod(a._invmp(this.m).mul(this.r2));
    return res._forceRed(this);
  };
})( false || module, this);

/***/ }),

/***/ "./node_modules/bn.js/lib/bn.js":
/*!**************************************!*\
  !*** ./node_modules/bn.js/lib/bn.js ***!
  \**************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

/* module decorator */ module = __webpack_require__.nmd(module);
function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

(function (module, exports) {
  'use strict'; // Utils

  function assert(val, msg) {
    if (!val) throw new Error(msg || 'Assertion failed');
  } // Could use `inherits` module, but don't want to move from single file
  // architecture yet.


  function inherits(ctor, superCtor) {
    ctor.super_ = superCtor;

    var TempCtor = function TempCtor() {};

    TempCtor.prototype = superCtor.prototype;
    ctor.prototype = new TempCtor();
    ctor.prototype.constructor = ctor;
  } // BN


  function BN(number, base, endian) {
    if (BN.isBN(number)) {
      return number;
    }

    this.negative = 0;
    this.words = null;
    this.length = 0; // Reduction context

    this.red = null;

    if (number !== null) {
      if (base === 'le' || base === 'be') {
        endian = base;
        base = 10;
      }

      this._init(number || 0, base || 10, endian || 'be');
    }
  }

  if (_typeof(module) === 'object') {
    module.exports = BN;
  } else {
    exports.BN = BN;
  }

  BN.BN = BN;
  BN.wordSize = 26;
  var Buffer;

  try {
    if (typeof window !== 'undefined' && typeof window.Buffer !== 'undefined') {
      Buffer = window.Buffer;
    } else {
      Buffer = __webpack_require__(/*! buffer */ "?8131").Buffer;
    }
  } catch (e) {}

  BN.isBN = function isBN(num) {
    if (num instanceof BN) {
      return true;
    }

    return num !== null && _typeof(num) === 'object' && num.constructor.wordSize === BN.wordSize && Array.isArray(num.words);
  };

  BN.max = function max(left, right) {
    if (left.cmp(right) > 0) return left;
    return right;
  };

  BN.min = function min(left, right) {
    if (left.cmp(right) < 0) return left;
    return right;
  };

  BN.prototype._init = function init(number, base, endian) {
    if (typeof number === 'number') {
      return this._initNumber(number, base, endian);
    }

    if (_typeof(number) === 'object') {
      return this._initArray(number, base, endian);
    }

    if (base === 'hex') {
      base = 16;
    }

    assert(base === (base | 0) && base >= 2 && base <= 36);
    number = number.toString().replace(/\s+/g, '');
    var start = 0;

    if (number[0] === '-') {
      start++;
      this.negative = 1;
    }

    if (start < number.length) {
      if (base === 16) {
        this._parseHex(number, start, endian);
      } else {
        this._parseBase(number, base, start);

        if (endian === 'le') {
          this._initArray(this.toArray(), base, endian);
        }
      }
    }
  };

  BN.prototype._initNumber = function _initNumber(number, base, endian) {
    if (number < 0) {
      this.negative = 1;
      number = -number;
    }

    if (number < 0x4000000) {
      this.words = [number & 0x3ffffff];
      this.length = 1;
    } else if (number < 0x10000000000000) {
      this.words = [number & 0x3ffffff, number / 0x4000000 & 0x3ffffff];
      this.length = 2;
    } else {
      assert(number < 0x20000000000000); // 2 ^ 53 (unsafe)

      this.words = [number & 0x3ffffff, number / 0x4000000 & 0x3ffffff, 1];
      this.length = 3;
    }

    if (endian !== 'le') return; // Reverse the bytes

    this._initArray(this.toArray(), base, endian);
  };

  BN.prototype._initArray = function _initArray(number, base, endian) {
    // Perhaps a Uint8Array
    assert(typeof number.length === 'number');

    if (number.length <= 0) {
      this.words = [0];
      this.length = 1;
      return this;
    }

    this.length = Math.ceil(number.length / 3);
    this.words = new Array(this.length);

    for (var i = 0; i < this.length; i++) {
      this.words[i] = 0;
    }

    var j, w;
    var off = 0;

    if (endian === 'be') {
      for (i = number.length - 1, j = 0; i >= 0; i -= 3) {
        w = number[i] | number[i - 1] << 8 | number[i - 2] << 16;
        this.words[j] |= w << off & 0x3ffffff;
        this.words[j + 1] = w >>> 26 - off & 0x3ffffff;
        off += 24;

        if (off >= 26) {
          off -= 26;
          j++;
        }
      }
    } else if (endian === 'le') {
      for (i = 0, j = 0; i < number.length; i += 3) {
        w = number[i] | number[i + 1] << 8 | number[i + 2] << 16;
        this.words[j] |= w << off & 0x3ffffff;
        this.words[j + 1] = w >>> 26 - off & 0x3ffffff;
        off += 24;

        if (off >= 26) {
          off -= 26;
          j++;
        }
      }
    }

    return this.strip();
  };

  function parseHex4Bits(string, index) {
    var c = string.charCodeAt(index); // 'A' - 'F'

    if (c >= 65 && c <= 70) {
      return c - 55; // 'a' - 'f'
    } else if (c >= 97 && c <= 102) {
      return c - 87; // '0' - '9'
    } else {
      return c - 48 & 0xf;
    }
  }

  function parseHexByte(string, lowerBound, index) {
    var r = parseHex4Bits(string, index);

    if (index - 1 >= lowerBound) {
      r |= parseHex4Bits(string, index - 1) << 4;
    }

    return r;
  }

  BN.prototype._parseHex = function _parseHex(number, start, endian) {
    // Create possibly bigger array to ensure that it fits the number
    this.length = Math.ceil((number.length - start) / 6);
    this.words = new Array(this.length);

    for (var i = 0; i < this.length; i++) {
      this.words[i] = 0;
    } // 24-bits chunks


    var off = 0;
    var j = 0;
    var w;

    if (endian === 'be') {
      for (i = number.length - 1; i >= start; i -= 2) {
        w = parseHexByte(number, start, i) << off;
        this.words[j] |= w & 0x3ffffff;

        if (off >= 18) {
          off -= 18;
          j += 1;
          this.words[j] |= w >>> 26;
        } else {
          off += 8;
        }
      }
    } else {
      var parseLength = number.length - start;

      for (i = parseLength % 2 === 0 ? start + 1 : start; i < number.length; i += 2) {
        w = parseHexByte(number, start, i) << off;
        this.words[j] |= w & 0x3ffffff;

        if (off >= 18) {
          off -= 18;
          j += 1;
          this.words[j] |= w >>> 26;
        } else {
          off += 8;
        }
      }
    }

    this.strip();
  };

  function parseBase(str, start, end, mul) {
    var r = 0;
    var len = Math.min(str.length, end);

    for (var i = start; i < len; i++) {
      var c = str.charCodeAt(i) - 48;
      r *= mul; // 'a'

      if (c >= 49) {
        r += c - 49 + 0xa; // 'A'
      } else if (c >= 17) {
        r += c - 17 + 0xa; // '0' - '9'
      } else {
        r += c;
      }
    }

    return r;
  }

  BN.prototype._parseBase = function _parseBase(number, base, start) {
    // Initialize as zero
    this.words = [0];
    this.length = 1; // Find length of limb in base

    for (var limbLen = 0, limbPow = 1; limbPow <= 0x3ffffff; limbPow *= base) {
      limbLen++;
    }

    limbLen--;
    limbPow = limbPow / base | 0;
    var total = number.length - start;
    var mod = total % limbLen;
    var end = Math.min(total, total - mod) + start;
    var word = 0;

    for (var i = start; i < end; i += limbLen) {
      word = parseBase(number, i, i + limbLen, base);
      this.imuln(limbPow);

      if (this.words[0] + word < 0x4000000) {
        this.words[0] += word;
      } else {
        this._iaddn(word);
      }
    }

    if (mod !== 0) {
      var pow = 1;
      word = parseBase(number, i, number.length, base);

      for (i = 0; i < mod; i++) {
        pow *= base;
      }

      this.imuln(pow);

      if (this.words[0] + word < 0x4000000) {
        this.words[0] += word;
      } else {
        this._iaddn(word);
      }
    }

    this.strip();
  };

  BN.prototype.copy = function copy(dest) {
    dest.words = new Array(this.length);

    for (var i = 0; i < this.length; i++) {
      dest.words[i] = this.words[i];
    }

    dest.length = this.length;
    dest.negative = this.negative;
    dest.red = this.red;
  };

  BN.prototype.clone = function clone() {
    var r = new BN(null);
    this.copy(r);
    return r;
  };

  BN.prototype._expand = function _expand(size) {
    while (this.length < size) {
      this.words[this.length++] = 0;
    }

    return this;
  }; // Remove leading `0` from `this`


  BN.prototype.strip = function strip() {
    while (this.length > 1 && this.words[this.length - 1] === 0) {
      this.length--;
    }

    return this._normSign();
  };

  BN.prototype._normSign = function _normSign() {
    // -0 = 0
    if (this.length === 1 && this.words[0] === 0) {
      this.negative = 0;
    }

    return this;
  };

  BN.prototype.inspect = function inspect() {
    return (this.red ? '<BN-R: ' : '<BN: ') + this.toString(16) + '>';
  };
  /*
   var zeros = [];
  var groupSizes = [];
  var groupBases = [];
   var s = '';
  var i = -1;
  while (++i < BN.wordSize) {
    zeros[i] = s;
    s += '0';
  }
  groupSizes[0] = 0;
  groupSizes[1] = 0;
  groupBases[0] = 0;
  groupBases[1] = 0;
  var base = 2 - 1;
  while (++base < 36 + 1) {
    var groupSize = 0;
    var groupBase = 1;
    while (groupBase < (1 << BN.wordSize) / base) {
      groupBase *= base;
      groupSize += 1;
    }
    groupSizes[base] = groupSize;
    groupBases[base] = groupBase;
  }
   */


  var zeros = ['', '0', '00', '000', '0000', '00000', '000000', '0000000', '00000000', '000000000', '0000000000', '00000000000', '000000000000', '0000000000000', '00000000000000', '000000000000000', '0000000000000000', '00000000000000000', '000000000000000000', '0000000000000000000', '00000000000000000000', '000000000000000000000', '0000000000000000000000', '00000000000000000000000', '000000000000000000000000', '0000000000000000000000000'];
  var groupSizes = [0, 0, 25, 16, 12, 11, 10, 9, 8, 8, 7, 7, 7, 7, 6, 6, 6, 6, 6, 6, 6, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5];
  var groupBases = [0, 0, 33554432, 43046721, 16777216, 48828125, 60466176, 40353607, 16777216, 43046721, 10000000, 19487171, 35831808, 62748517, 7529536, 11390625, 16777216, 24137569, 34012224, 47045881, 64000000, 4084101, 5153632, 6436343, 7962624, 9765625, 11881376, 14348907, 17210368, 20511149, 24300000, 28629151, 33554432, 39135393, 45435424, 52521875, 60466176];

  BN.prototype.toString = function toString(base, padding) {
    base = base || 10;
    padding = padding | 0 || 1;
    var out;

    if (base === 16 || base === 'hex') {
      out = '';
      var off = 0;
      var carry = 0;

      for (var i = 0; i < this.length; i++) {
        var w = this.words[i];
        var word = ((w << off | carry) & 0xffffff).toString(16);
        carry = w >>> 24 - off & 0xffffff;

        if (carry !== 0 || i !== this.length - 1) {
          out = zeros[6 - word.length] + word + out;
        } else {
          out = word + out;
        }

        off += 2;

        if (off >= 26) {
          off -= 26;
          i--;
        }
      }

      if (carry !== 0) {
        out = carry.toString(16) + out;
      }

      while (out.length % padding !== 0) {
        out = '0' + out;
      }

      if (this.negative !== 0) {
        out = '-' + out;
      }

      return out;
    }

    if (base === (base | 0) && base >= 2 && base <= 36) {
      // var groupSize = Math.floor(BN.wordSize * Math.LN2 / Math.log(base));
      var groupSize = groupSizes[base]; // var groupBase = Math.pow(base, groupSize);

      var groupBase = groupBases[base];
      out = '';
      var c = this.clone();
      c.negative = 0;

      while (!c.isZero()) {
        var r = c.modn(groupBase).toString(base);
        c = c.idivn(groupBase);

        if (!c.isZero()) {
          out = zeros[groupSize - r.length] + r + out;
        } else {
          out = r + out;
        }
      }

      if (this.isZero()) {
        out = '0' + out;
      }

      while (out.length % padding !== 0) {
        out = '0' + out;
      }

      if (this.negative !== 0) {
        out = '-' + out;
      }

      return out;
    }

    assert(false, 'Base should be between 2 and 36');
  };

  BN.prototype.toNumber = function toNumber() {
    var ret = this.words[0];

    if (this.length === 2) {
      ret += this.words[1] * 0x4000000;
    } else if (this.length === 3 && this.words[2] === 0x01) {
      // NOTE: at this stage it is known that the top bit is set
      ret += 0x10000000000000 + this.words[1] * 0x4000000;
    } else if (this.length > 2) {
      assert(false, 'Number can only safely store up to 53 bits');
    }

    return this.negative !== 0 ? -ret : ret;
  };

  BN.prototype.toJSON = function toJSON() {
    return this.toString(16);
  };

  BN.prototype.toBuffer = function toBuffer(endian, length) {
    assert(typeof Buffer !== 'undefined');
    return this.toArrayLike(Buffer, endian, length);
  };

  BN.prototype.toArray = function toArray(endian, length) {
    return this.toArrayLike(Array, endian, length);
  };

  BN.prototype.toArrayLike = function toArrayLike(ArrayType, endian, length) {
    var byteLength = this.byteLength();
    var reqLength = length || Math.max(1, byteLength);
    assert(byteLength <= reqLength, 'byte array longer than desired length');
    assert(reqLength > 0, 'Requested array length <= 0');
    this.strip();
    var littleEndian = endian === 'le';
    var res = new ArrayType(reqLength);
    var b, i;
    var q = this.clone();

    if (!littleEndian) {
      // Assume big-endian
      for (i = 0; i < reqLength - byteLength; i++) {
        res[i] = 0;
      }

      for (i = 0; !q.isZero(); i++) {
        b = q.andln(0xff);
        q.iushrn(8);
        res[reqLength - i - 1] = b;
      }
    } else {
      for (i = 0; !q.isZero(); i++) {
        b = q.andln(0xff);
        q.iushrn(8);
        res[i] = b;
      }

      for (; i < reqLength; i++) {
        res[i] = 0;
      }
    }

    return res;
  };

  if (Math.clz32) {
    BN.prototype._countBits = function _countBits(w) {
      return 32 - Math.clz32(w);
    };
  } else {
    BN.prototype._countBits = function _countBits(w) {
      var t = w;
      var r = 0;

      if (t >= 0x1000) {
        r += 13;
        t >>>= 13;
      }

      if (t >= 0x40) {
        r += 7;
        t >>>= 7;
      }

      if (t >= 0x8) {
        r += 4;
        t >>>= 4;
      }

      if (t >= 0x02) {
        r += 2;
        t >>>= 2;
      }

      return r + t;
    };
  }

  BN.prototype._zeroBits = function _zeroBits(w) {
    // Short-cut
    if (w === 0) return 26;
    var t = w;
    var r = 0;

    if ((t & 0x1fff) === 0) {
      r += 13;
      t >>>= 13;
    }

    if ((t & 0x7f) === 0) {
      r += 7;
      t >>>= 7;
    }

    if ((t & 0xf) === 0) {
      r += 4;
      t >>>= 4;
    }

    if ((t & 0x3) === 0) {
      r += 2;
      t >>>= 2;
    }

    if ((t & 0x1) === 0) {
      r++;
    }

    return r;
  }; // Return number of used bits in a BN


  BN.prototype.bitLength = function bitLength() {
    var w = this.words[this.length - 1];

    var hi = this._countBits(w);

    return (this.length - 1) * 26 + hi;
  };

  function toBitArray(num) {
    var w = new Array(num.bitLength());

    for (var bit = 0; bit < w.length; bit++) {
      var off = bit / 26 | 0;
      var wbit = bit % 26;
      w[bit] = (num.words[off] & 1 << wbit) >>> wbit;
    }

    return w;
  } // Number of trailing zero bits


  BN.prototype.zeroBits = function zeroBits() {
    if (this.isZero()) return 0;
    var r = 0;

    for (var i = 0; i < this.length; i++) {
      var b = this._zeroBits(this.words[i]);

      r += b;
      if (b !== 26) break;
    }

    return r;
  };

  BN.prototype.byteLength = function byteLength() {
    return Math.ceil(this.bitLength() / 8);
  };

  BN.prototype.toTwos = function toTwos(width) {
    if (this.negative !== 0) {
      return this.abs().inotn(width).iaddn(1);
    }

    return this.clone();
  };

  BN.prototype.fromTwos = function fromTwos(width) {
    if (this.testn(width - 1)) {
      return this.notn(width).iaddn(1).ineg();
    }

    return this.clone();
  };

  BN.prototype.isNeg = function isNeg() {
    return this.negative !== 0;
  }; // Return negative clone of `this`


  BN.prototype.neg = function neg() {
    return this.clone().ineg();
  };

  BN.prototype.ineg = function ineg() {
    if (!this.isZero()) {
      this.negative ^= 1;
    }

    return this;
  }; // Or `num` with `this` in-place


  BN.prototype.iuor = function iuor(num) {
    while (this.length < num.length) {
      this.words[this.length++] = 0;
    }

    for (var i = 0; i < num.length; i++) {
      this.words[i] = this.words[i] | num.words[i];
    }

    return this.strip();
  };

  BN.prototype.ior = function ior(num) {
    assert((this.negative | num.negative) === 0);
    return this.iuor(num);
  }; // Or `num` with `this`


  BN.prototype.or = function or(num) {
    if (this.length > num.length) return this.clone().ior(num);
    return num.clone().ior(this);
  };

  BN.prototype.uor = function uor(num) {
    if (this.length > num.length) return this.clone().iuor(num);
    return num.clone().iuor(this);
  }; // And `num` with `this` in-place


  BN.prototype.iuand = function iuand(num) {
    // b = min-length(num, this)
    var b;

    if (this.length > num.length) {
      b = num;
    } else {
      b = this;
    }

    for (var i = 0; i < b.length; i++) {
      this.words[i] = this.words[i] & num.words[i];
    }

    this.length = b.length;
    return this.strip();
  };

  BN.prototype.iand = function iand(num) {
    assert((this.negative | num.negative) === 0);
    return this.iuand(num);
  }; // And `num` with `this`


  BN.prototype.and = function and(num) {
    if (this.length > num.length) return this.clone().iand(num);
    return num.clone().iand(this);
  };

  BN.prototype.uand = function uand(num) {
    if (this.length > num.length) return this.clone().iuand(num);
    return num.clone().iuand(this);
  }; // Xor `num` with `this` in-place


  BN.prototype.iuxor = function iuxor(num) {
    // a.length > b.length
    var a;
    var b;

    if (this.length > num.length) {
      a = this;
      b = num;
    } else {
      a = num;
      b = this;
    }

    for (var i = 0; i < b.length; i++) {
      this.words[i] = a.words[i] ^ b.words[i];
    }

    if (this !== a) {
      for (; i < a.length; i++) {
        this.words[i] = a.words[i];
      }
    }

    this.length = a.length;
    return this.strip();
  };

  BN.prototype.ixor = function ixor(num) {
    assert((this.negative | num.negative) === 0);
    return this.iuxor(num);
  }; // Xor `num` with `this`


  BN.prototype.xor = function xor(num) {
    if (this.length > num.length) return this.clone().ixor(num);
    return num.clone().ixor(this);
  };

  BN.prototype.uxor = function uxor(num) {
    if (this.length > num.length) return this.clone().iuxor(num);
    return num.clone().iuxor(this);
  }; // Not ``this`` with ``width`` bitwidth


  BN.prototype.inotn = function inotn(width) {
    assert(typeof width === 'number' && width >= 0);
    var bytesNeeded = Math.ceil(width / 26) | 0;
    var bitsLeft = width % 26; // Extend the buffer with leading zeroes

    this._expand(bytesNeeded);

    if (bitsLeft > 0) {
      bytesNeeded--;
    } // Handle complete words


    for (var i = 0; i < bytesNeeded; i++) {
      this.words[i] = ~this.words[i] & 0x3ffffff;
    } // Handle the residue


    if (bitsLeft > 0) {
      this.words[i] = ~this.words[i] & 0x3ffffff >> 26 - bitsLeft;
    } // And remove leading zeroes


    return this.strip();
  };

  BN.prototype.notn = function notn(width) {
    return this.clone().inotn(width);
  }; // Set `bit` of `this`


  BN.prototype.setn = function setn(bit, val) {
    assert(typeof bit === 'number' && bit >= 0);
    var off = bit / 26 | 0;
    var wbit = bit % 26;

    this._expand(off + 1);

    if (val) {
      this.words[off] = this.words[off] | 1 << wbit;
    } else {
      this.words[off] = this.words[off] & ~(1 << wbit);
    }

    return this.strip();
  }; // Add `num` to `this` in-place


  BN.prototype.iadd = function iadd(num) {
    var r; // negative + positive

    if (this.negative !== 0 && num.negative === 0) {
      this.negative = 0;
      r = this.isub(num);
      this.negative ^= 1;
      return this._normSign(); // positive + negative
    } else if (this.negative === 0 && num.negative !== 0) {
      num.negative = 0;
      r = this.isub(num);
      num.negative = 1;
      return r._normSign();
    } // a.length > b.length


    var a, b;

    if (this.length > num.length) {
      a = this;
      b = num;
    } else {
      a = num;
      b = this;
    }

    var carry = 0;

    for (var i = 0; i < b.length; i++) {
      r = (a.words[i] | 0) + (b.words[i] | 0) + carry;
      this.words[i] = r & 0x3ffffff;
      carry = r >>> 26;
    }

    for (; carry !== 0 && i < a.length; i++) {
      r = (a.words[i] | 0) + carry;
      this.words[i] = r & 0x3ffffff;
      carry = r >>> 26;
    }

    this.length = a.length;

    if (carry !== 0) {
      this.words[this.length] = carry;
      this.length++; // Copy the rest of the words
    } else if (a !== this) {
      for (; i < a.length; i++) {
        this.words[i] = a.words[i];
      }
    }

    return this;
  }; // Add `num` to `this`


  BN.prototype.add = function add(num) {
    var res;

    if (num.negative !== 0 && this.negative === 0) {
      num.negative = 0;
      res = this.sub(num);
      num.negative ^= 1;
      return res;
    } else if (num.negative === 0 && this.negative !== 0) {
      this.negative = 0;
      res = num.sub(this);
      this.negative = 1;
      return res;
    }

    if (this.length > num.length) return this.clone().iadd(num);
    return num.clone().iadd(this);
  }; // Subtract `num` from `this` in-place


  BN.prototype.isub = function isub(num) {
    // this - (-num) = this + num
    if (num.negative !== 0) {
      num.negative = 0;
      var r = this.iadd(num);
      num.negative = 1;
      return r._normSign(); // -this - num = -(this + num)
    } else if (this.negative !== 0) {
      this.negative = 0;
      this.iadd(num);
      this.negative = 1;
      return this._normSign();
    } // At this point both numbers are positive


    var cmp = this.cmp(num); // Optimization - zeroify

    if (cmp === 0) {
      this.negative = 0;
      this.length = 1;
      this.words[0] = 0;
      return this;
    } // a > b


    var a, b;

    if (cmp > 0) {
      a = this;
      b = num;
    } else {
      a = num;
      b = this;
    }

    var carry = 0;

    for (var i = 0; i < b.length; i++) {
      r = (a.words[i] | 0) - (b.words[i] | 0) + carry;
      carry = r >> 26;
      this.words[i] = r & 0x3ffffff;
    }

    for (; carry !== 0 && i < a.length; i++) {
      r = (a.words[i] | 0) + carry;
      carry = r >> 26;
      this.words[i] = r & 0x3ffffff;
    } // Copy rest of the words


    if (carry === 0 && i < a.length && a !== this) {
      for (; i < a.length; i++) {
        this.words[i] = a.words[i];
      }
    }

    this.length = Math.max(this.length, i);

    if (a !== this) {
      this.negative = 1;
    }

    return this.strip();
  }; // Subtract `num` from `this`


  BN.prototype.sub = function sub(num) {
    return this.clone().isub(num);
  };

  function smallMulTo(self, num, out) {
    out.negative = num.negative ^ self.negative;
    var len = self.length + num.length | 0;
    out.length = len;
    len = len - 1 | 0; // Peel one iteration (compiler can't do it, because of code complexity)

    var a = self.words[0] | 0;
    var b = num.words[0] | 0;
    var r = a * b;
    var lo = r & 0x3ffffff;
    var carry = r / 0x4000000 | 0;
    out.words[0] = lo;

    for (var k = 1; k < len; k++) {
      // Sum all words with the same `i + j = k` and accumulate `ncarry`,
      // note that ncarry could be >= 0x3ffffff
      var ncarry = carry >>> 26;
      var rword = carry & 0x3ffffff;
      var maxJ = Math.min(k, num.length - 1);

      for (var j = Math.max(0, k - self.length + 1); j <= maxJ; j++) {
        var i = k - j | 0;
        a = self.words[i] | 0;
        b = num.words[j] | 0;
        r = a * b + rword;
        ncarry += r / 0x4000000 | 0;
        rword = r & 0x3ffffff;
      }

      out.words[k] = rword | 0;
      carry = ncarry | 0;
    }

    if (carry !== 0) {
      out.words[k] = carry | 0;
    } else {
      out.length--;
    }

    return out.strip();
  } // TODO(indutny): it may be reasonable to omit it for users who don't need
  // to work with 256-bit numbers, otherwise it gives 20% improvement for 256-bit
  // multiplication (like elliptic secp256k1).


  var comb10MulTo = function comb10MulTo(self, num, out) {
    var a = self.words;
    var b = num.words;
    var o = out.words;
    var c = 0;
    var lo;
    var mid;
    var hi;
    var a0 = a[0] | 0;
    var al0 = a0 & 0x1fff;
    var ah0 = a0 >>> 13;
    var a1 = a[1] | 0;
    var al1 = a1 & 0x1fff;
    var ah1 = a1 >>> 13;
    var a2 = a[2] | 0;
    var al2 = a2 & 0x1fff;
    var ah2 = a2 >>> 13;
    var a3 = a[3] | 0;
    var al3 = a3 & 0x1fff;
    var ah3 = a3 >>> 13;
    var a4 = a[4] | 0;
    var al4 = a4 & 0x1fff;
    var ah4 = a4 >>> 13;
    var a5 = a[5] | 0;
    var al5 = a5 & 0x1fff;
    var ah5 = a5 >>> 13;
    var a6 = a[6] | 0;
    var al6 = a6 & 0x1fff;
    var ah6 = a6 >>> 13;
    var a7 = a[7] | 0;
    var al7 = a7 & 0x1fff;
    var ah7 = a7 >>> 13;
    var a8 = a[8] | 0;
    var al8 = a8 & 0x1fff;
    var ah8 = a8 >>> 13;
    var a9 = a[9] | 0;
    var al9 = a9 & 0x1fff;
    var ah9 = a9 >>> 13;
    var b0 = b[0] | 0;
    var bl0 = b0 & 0x1fff;
    var bh0 = b0 >>> 13;
    var b1 = b[1] | 0;
    var bl1 = b1 & 0x1fff;
    var bh1 = b1 >>> 13;
    var b2 = b[2] | 0;
    var bl2 = b2 & 0x1fff;
    var bh2 = b2 >>> 13;
    var b3 = b[3] | 0;
    var bl3 = b3 & 0x1fff;
    var bh3 = b3 >>> 13;
    var b4 = b[4] | 0;
    var bl4 = b4 & 0x1fff;
    var bh4 = b4 >>> 13;
    var b5 = b[5] | 0;
    var bl5 = b5 & 0x1fff;
    var bh5 = b5 >>> 13;
    var b6 = b[6] | 0;
    var bl6 = b6 & 0x1fff;
    var bh6 = b6 >>> 13;
    var b7 = b[7] | 0;
    var bl7 = b7 & 0x1fff;
    var bh7 = b7 >>> 13;
    var b8 = b[8] | 0;
    var bl8 = b8 & 0x1fff;
    var bh8 = b8 >>> 13;
    var b9 = b[9] | 0;
    var bl9 = b9 & 0x1fff;
    var bh9 = b9 >>> 13;
    out.negative = self.negative ^ num.negative;
    out.length = 19;
    /* k = 0 */

    lo = Math.imul(al0, bl0);
    mid = Math.imul(al0, bh0);
    mid = mid + Math.imul(ah0, bl0) | 0;
    hi = Math.imul(ah0, bh0);
    var w0 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w0 >>> 26) | 0;
    w0 &= 0x3ffffff;
    /* k = 1 */

    lo = Math.imul(al1, bl0);
    mid = Math.imul(al1, bh0);
    mid = mid + Math.imul(ah1, bl0) | 0;
    hi = Math.imul(ah1, bh0);
    lo = lo + Math.imul(al0, bl1) | 0;
    mid = mid + Math.imul(al0, bh1) | 0;
    mid = mid + Math.imul(ah0, bl1) | 0;
    hi = hi + Math.imul(ah0, bh1) | 0;
    var w1 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w1 >>> 26) | 0;
    w1 &= 0x3ffffff;
    /* k = 2 */

    lo = Math.imul(al2, bl0);
    mid = Math.imul(al2, bh0);
    mid = mid + Math.imul(ah2, bl0) | 0;
    hi = Math.imul(ah2, bh0);
    lo = lo + Math.imul(al1, bl1) | 0;
    mid = mid + Math.imul(al1, bh1) | 0;
    mid = mid + Math.imul(ah1, bl1) | 0;
    hi = hi + Math.imul(ah1, bh1) | 0;
    lo = lo + Math.imul(al0, bl2) | 0;
    mid = mid + Math.imul(al0, bh2) | 0;
    mid = mid + Math.imul(ah0, bl2) | 0;
    hi = hi + Math.imul(ah0, bh2) | 0;
    var w2 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w2 >>> 26) | 0;
    w2 &= 0x3ffffff;
    /* k = 3 */

    lo = Math.imul(al3, bl0);
    mid = Math.imul(al3, bh0);
    mid = mid + Math.imul(ah3, bl0) | 0;
    hi = Math.imul(ah3, bh0);
    lo = lo + Math.imul(al2, bl1) | 0;
    mid = mid + Math.imul(al2, bh1) | 0;
    mid = mid + Math.imul(ah2, bl1) | 0;
    hi = hi + Math.imul(ah2, bh1) | 0;
    lo = lo + Math.imul(al1, bl2) | 0;
    mid = mid + Math.imul(al1, bh2) | 0;
    mid = mid + Math.imul(ah1, bl2) | 0;
    hi = hi + Math.imul(ah1, bh2) | 0;
    lo = lo + Math.imul(al0, bl3) | 0;
    mid = mid + Math.imul(al0, bh3) | 0;
    mid = mid + Math.imul(ah0, bl3) | 0;
    hi = hi + Math.imul(ah0, bh3) | 0;
    var w3 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w3 >>> 26) | 0;
    w3 &= 0x3ffffff;
    /* k = 4 */

    lo = Math.imul(al4, bl0);
    mid = Math.imul(al4, bh0);
    mid = mid + Math.imul(ah4, bl0) | 0;
    hi = Math.imul(ah4, bh0);
    lo = lo + Math.imul(al3, bl1) | 0;
    mid = mid + Math.imul(al3, bh1) | 0;
    mid = mid + Math.imul(ah3, bl1) | 0;
    hi = hi + Math.imul(ah3, bh1) | 0;
    lo = lo + Math.imul(al2, bl2) | 0;
    mid = mid + Math.imul(al2, bh2) | 0;
    mid = mid + Math.imul(ah2, bl2) | 0;
    hi = hi + Math.imul(ah2, bh2) | 0;
    lo = lo + Math.imul(al1, bl3) | 0;
    mid = mid + Math.imul(al1, bh3) | 0;
    mid = mid + Math.imul(ah1, bl3) | 0;
    hi = hi + Math.imul(ah1, bh3) | 0;
    lo = lo + Math.imul(al0, bl4) | 0;
    mid = mid + Math.imul(al0, bh4) | 0;
    mid = mid + Math.imul(ah0, bl4) | 0;
    hi = hi + Math.imul(ah0, bh4) | 0;
    var w4 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w4 >>> 26) | 0;
    w4 &= 0x3ffffff;
    /* k = 5 */

    lo = Math.imul(al5, bl0);
    mid = Math.imul(al5, bh0);
    mid = mid + Math.imul(ah5, bl0) | 0;
    hi = Math.imul(ah5, bh0);
    lo = lo + Math.imul(al4, bl1) | 0;
    mid = mid + Math.imul(al4, bh1) | 0;
    mid = mid + Math.imul(ah4, bl1) | 0;
    hi = hi + Math.imul(ah4, bh1) | 0;
    lo = lo + Math.imul(al3, bl2) | 0;
    mid = mid + Math.imul(al3, bh2) | 0;
    mid = mid + Math.imul(ah3, bl2) | 0;
    hi = hi + Math.imul(ah3, bh2) | 0;
    lo = lo + Math.imul(al2, bl3) | 0;
    mid = mid + Math.imul(al2, bh3) | 0;
    mid = mid + Math.imul(ah2, bl3) | 0;
    hi = hi + Math.imul(ah2, bh3) | 0;
    lo = lo + Math.imul(al1, bl4) | 0;
    mid = mid + Math.imul(al1, bh4) | 0;
    mid = mid + Math.imul(ah1, bl4) | 0;
    hi = hi + Math.imul(ah1, bh4) | 0;
    lo = lo + Math.imul(al0, bl5) | 0;
    mid = mid + Math.imul(al0, bh5) | 0;
    mid = mid + Math.imul(ah0, bl5) | 0;
    hi = hi + Math.imul(ah0, bh5) | 0;
    var w5 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w5 >>> 26) | 0;
    w5 &= 0x3ffffff;
    /* k = 6 */

    lo = Math.imul(al6, bl0);
    mid = Math.imul(al6, bh0);
    mid = mid + Math.imul(ah6, bl0) | 0;
    hi = Math.imul(ah6, bh0);
    lo = lo + Math.imul(al5, bl1) | 0;
    mid = mid + Math.imul(al5, bh1) | 0;
    mid = mid + Math.imul(ah5, bl1) | 0;
    hi = hi + Math.imul(ah5, bh1) | 0;
    lo = lo + Math.imul(al4, bl2) | 0;
    mid = mid + Math.imul(al4, bh2) | 0;
    mid = mid + Math.imul(ah4, bl2) | 0;
    hi = hi + Math.imul(ah4, bh2) | 0;
    lo = lo + Math.imul(al3, bl3) | 0;
    mid = mid + Math.imul(al3, bh3) | 0;
    mid = mid + Math.imul(ah3, bl3) | 0;
    hi = hi + Math.imul(ah3, bh3) | 0;
    lo = lo + Math.imul(al2, bl4) | 0;
    mid = mid + Math.imul(al2, bh4) | 0;
    mid = mid + Math.imul(ah2, bl4) | 0;
    hi = hi + Math.imul(ah2, bh4) | 0;
    lo = lo + Math.imul(al1, bl5) | 0;
    mid = mid + Math.imul(al1, bh5) | 0;
    mid = mid + Math.imul(ah1, bl5) | 0;
    hi = hi + Math.imul(ah1, bh5) | 0;
    lo = lo + Math.imul(al0, bl6) | 0;
    mid = mid + Math.imul(al0, bh6) | 0;
    mid = mid + Math.imul(ah0, bl6) | 0;
    hi = hi + Math.imul(ah0, bh6) | 0;
    var w6 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w6 >>> 26) | 0;
    w6 &= 0x3ffffff;
    /* k = 7 */

    lo = Math.imul(al7, bl0);
    mid = Math.imul(al7, bh0);
    mid = mid + Math.imul(ah7, bl0) | 0;
    hi = Math.imul(ah7, bh0);
    lo = lo + Math.imul(al6, bl1) | 0;
    mid = mid + Math.imul(al6, bh1) | 0;
    mid = mid + Math.imul(ah6, bl1) | 0;
    hi = hi + Math.imul(ah6, bh1) | 0;
    lo = lo + Math.imul(al5, bl2) | 0;
    mid = mid + Math.imul(al5, bh2) | 0;
    mid = mid + Math.imul(ah5, bl2) | 0;
    hi = hi + Math.imul(ah5, bh2) | 0;
    lo = lo + Math.imul(al4, bl3) | 0;
    mid = mid + Math.imul(al4, bh3) | 0;
    mid = mid + Math.imul(ah4, bl3) | 0;
    hi = hi + Math.imul(ah4, bh3) | 0;
    lo = lo + Math.imul(al3, bl4) | 0;
    mid = mid + Math.imul(al3, bh4) | 0;
    mid = mid + Math.imul(ah3, bl4) | 0;
    hi = hi + Math.imul(ah3, bh4) | 0;
    lo = lo + Math.imul(al2, bl5) | 0;
    mid = mid + Math.imul(al2, bh5) | 0;
    mid = mid + Math.imul(ah2, bl5) | 0;
    hi = hi + Math.imul(ah2, bh5) | 0;
    lo = lo + Math.imul(al1, bl6) | 0;
    mid = mid + Math.imul(al1, bh6) | 0;
    mid = mid + Math.imul(ah1, bl6) | 0;
    hi = hi + Math.imul(ah1, bh6) | 0;
    lo = lo + Math.imul(al0, bl7) | 0;
    mid = mid + Math.imul(al0, bh7) | 0;
    mid = mid + Math.imul(ah0, bl7) | 0;
    hi = hi + Math.imul(ah0, bh7) | 0;
    var w7 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w7 >>> 26) | 0;
    w7 &= 0x3ffffff;
    /* k = 8 */

    lo = Math.imul(al8, bl0);
    mid = Math.imul(al8, bh0);
    mid = mid + Math.imul(ah8, bl0) | 0;
    hi = Math.imul(ah8, bh0);
    lo = lo + Math.imul(al7, bl1) | 0;
    mid = mid + Math.imul(al7, bh1) | 0;
    mid = mid + Math.imul(ah7, bl1) | 0;
    hi = hi + Math.imul(ah7, bh1) | 0;
    lo = lo + Math.imul(al6, bl2) | 0;
    mid = mid + Math.imul(al6, bh2) | 0;
    mid = mid + Math.imul(ah6, bl2) | 0;
    hi = hi + Math.imul(ah6, bh2) | 0;
    lo = lo + Math.imul(al5, bl3) | 0;
    mid = mid + Math.imul(al5, bh3) | 0;
    mid = mid + Math.imul(ah5, bl3) | 0;
    hi = hi + Math.imul(ah5, bh3) | 0;
    lo = lo + Math.imul(al4, bl4) | 0;
    mid = mid + Math.imul(al4, bh4) | 0;
    mid = mid + Math.imul(ah4, bl4) | 0;
    hi = hi + Math.imul(ah4, bh4) | 0;
    lo = lo + Math.imul(al3, bl5) | 0;
    mid = mid + Math.imul(al3, bh5) | 0;
    mid = mid + Math.imul(ah3, bl5) | 0;
    hi = hi + Math.imul(ah3, bh5) | 0;
    lo = lo + Math.imul(al2, bl6) | 0;
    mid = mid + Math.imul(al2, bh6) | 0;
    mid = mid + Math.imul(ah2, bl6) | 0;
    hi = hi + Math.imul(ah2, bh6) | 0;
    lo = lo + Math.imul(al1, bl7) | 0;
    mid = mid + Math.imul(al1, bh7) | 0;
    mid = mid + Math.imul(ah1, bl7) | 0;
    hi = hi + Math.imul(ah1, bh7) | 0;
    lo = lo + Math.imul(al0, bl8) | 0;
    mid = mid + Math.imul(al0, bh8) | 0;
    mid = mid + Math.imul(ah0, bl8) | 0;
    hi = hi + Math.imul(ah0, bh8) | 0;
    var w8 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w8 >>> 26) | 0;
    w8 &= 0x3ffffff;
    /* k = 9 */

    lo = Math.imul(al9, bl0);
    mid = Math.imul(al9, bh0);
    mid = mid + Math.imul(ah9, bl0) | 0;
    hi = Math.imul(ah9, bh0);
    lo = lo + Math.imul(al8, bl1) | 0;
    mid = mid + Math.imul(al8, bh1) | 0;
    mid = mid + Math.imul(ah8, bl1) | 0;
    hi = hi + Math.imul(ah8, bh1) | 0;
    lo = lo + Math.imul(al7, bl2) | 0;
    mid = mid + Math.imul(al7, bh2) | 0;
    mid = mid + Math.imul(ah7, bl2) | 0;
    hi = hi + Math.imul(ah7, bh2) | 0;
    lo = lo + Math.imul(al6, bl3) | 0;
    mid = mid + Math.imul(al6, bh3) | 0;
    mid = mid + Math.imul(ah6, bl3) | 0;
    hi = hi + Math.imul(ah6, bh3) | 0;
    lo = lo + Math.imul(al5, bl4) | 0;
    mid = mid + Math.imul(al5, bh4) | 0;
    mid = mid + Math.imul(ah5, bl4) | 0;
    hi = hi + Math.imul(ah5, bh4) | 0;
    lo = lo + Math.imul(al4, bl5) | 0;
    mid = mid + Math.imul(al4, bh5) | 0;
    mid = mid + Math.imul(ah4, bl5) | 0;
    hi = hi + Math.imul(ah4, bh5) | 0;
    lo = lo + Math.imul(al3, bl6) | 0;
    mid = mid + Math.imul(al3, bh6) | 0;
    mid = mid + Math.imul(ah3, bl6) | 0;
    hi = hi + Math.imul(ah3, bh6) | 0;
    lo = lo + Math.imul(al2, bl7) | 0;
    mid = mid + Math.imul(al2, bh7) | 0;
    mid = mid + Math.imul(ah2, bl7) | 0;
    hi = hi + Math.imul(ah2, bh7) | 0;
    lo = lo + Math.imul(al1, bl8) | 0;
    mid = mid + Math.imul(al1, bh8) | 0;
    mid = mid + Math.imul(ah1, bl8) | 0;
    hi = hi + Math.imul(ah1, bh8) | 0;
    lo = lo + Math.imul(al0, bl9) | 0;
    mid = mid + Math.imul(al0, bh9) | 0;
    mid = mid + Math.imul(ah0, bl9) | 0;
    hi = hi + Math.imul(ah0, bh9) | 0;
    var w9 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w9 >>> 26) | 0;
    w9 &= 0x3ffffff;
    /* k = 10 */

    lo = Math.imul(al9, bl1);
    mid = Math.imul(al9, bh1);
    mid = mid + Math.imul(ah9, bl1) | 0;
    hi = Math.imul(ah9, bh1);
    lo = lo + Math.imul(al8, bl2) | 0;
    mid = mid + Math.imul(al8, bh2) | 0;
    mid = mid + Math.imul(ah8, bl2) | 0;
    hi = hi + Math.imul(ah8, bh2) | 0;
    lo = lo + Math.imul(al7, bl3) | 0;
    mid = mid + Math.imul(al7, bh3) | 0;
    mid = mid + Math.imul(ah7, bl3) | 0;
    hi = hi + Math.imul(ah7, bh3) | 0;
    lo = lo + Math.imul(al6, bl4) | 0;
    mid = mid + Math.imul(al6, bh4) | 0;
    mid = mid + Math.imul(ah6, bl4) | 0;
    hi = hi + Math.imul(ah6, bh4) | 0;
    lo = lo + Math.imul(al5, bl5) | 0;
    mid = mid + Math.imul(al5, bh5) | 0;
    mid = mid + Math.imul(ah5, bl5) | 0;
    hi = hi + Math.imul(ah5, bh5) | 0;
    lo = lo + Math.imul(al4, bl6) | 0;
    mid = mid + Math.imul(al4, bh6) | 0;
    mid = mid + Math.imul(ah4, bl6) | 0;
    hi = hi + Math.imul(ah4, bh6) | 0;
    lo = lo + Math.imul(al3, bl7) | 0;
    mid = mid + Math.imul(al3, bh7) | 0;
    mid = mid + Math.imul(ah3, bl7) | 0;
    hi = hi + Math.imul(ah3, bh7) | 0;
    lo = lo + Math.imul(al2, bl8) | 0;
    mid = mid + Math.imul(al2, bh8) | 0;
    mid = mid + Math.imul(ah2, bl8) | 0;
    hi = hi + Math.imul(ah2, bh8) | 0;
    lo = lo + Math.imul(al1, bl9) | 0;
    mid = mid + Math.imul(al1, bh9) | 0;
    mid = mid + Math.imul(ah1, bl9) | 0;
    hi = hi + Math.imul(ah1, bh9) | 0;
    var w10 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w10 >>> 26) | 0;
    w10 &= 0x3ffffff;
    /* k = 11 */

    lo = Math.imul(al9, bl2);
    mid = Math.imul(al9, bh2);
    mid = mid + Math.imul(ah9, bl2) | 0;
    hi = Math.imul(ah9, bh2);
    lo = lo + Math.imul(al8, bl3) | 0;
    mid = mid + Math.imul(al8, bh3) | 0;
    mid = mid + Math.imul(ah8, bl3) | 0;
    hi = hi + Math.imul(ah8, bh3) | 0;
    lo = lo + Math.imul(al7, bl4) | 0;
    mid = mid + Math.imul(al7, bh4) | 0;
    mid = mid + Math.imul(ah7, bl4) | 0;
    hi = hi + Math.imul(ah7, bh4) | 0;
    lo = lo + Math.imul(al6, bl5) | 0;
    mid = mid + Math.imul(al6, bh5) | 0;
    mid = mid + Math.imul(ah6, bl5) | 0;
    hi = hi + Math.imul(ah6, bh5) | 0;
    lo = lo + Math.imul(al5, bl6) | 0;
    mid = mid + Math.imul(al5, bh6) | 0;
    mid = mid + Math.imul(ah5, bl6) | 0;
    hi = hi + Math.imul(ah5, bh6) | 0;
    lo = lo + Math.imul(al4, bl7) | 0;
    mid = mid + Math.imul(al4, bh7) | 0;
    mid = mid + Math.imul(ah4, bl7) | 0;
    hi = hi + Math.imul(ah4, bh7) | 0;
    lo = lo + Math.imul(al3, bl8) | 0;
    mid = mid + Math.imul(al3, bh8) | 0;
    mid = mid + Math.imul(ah3, bl8) | 0;
    hi = hi + Math.imul(ah3, bh8) | 0;
    lo = lo + Math.imul(al2, bl9) | 0;
    mid = mid + Math.imul(al2, bh9) | 0;
    mid = mid + Math.imul(ah2, bl9) | 0;
    hi = hi + Math.imul(ah2, bh9) | 0;
    var w11 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w11 >>> 26) | 0;
    w11 &= 0x3ffffff;
    /* k = 12 */

    lo = Math.imul(al9, bl3);
    mid = Math.imul(al9, bh3);
    mid = mid + Math.imul(ah9, bl3) | 0;
    hi = Math.imul(ah9, bh3);
    lo = lo + Math.imul(al8, bl4) | 0;
    mid = mid + Math.imul(al8, bh4) | 0;
    mid = mid + Math.imul(ah8, bl4) | 0;
    hi = hi + Math.imul(ah8, bh4) | 0;
    lo = lo + Math.imul(al7, bl5) | 0;
    mid = mid + Math.imul(al7, bh5) | 0;
    mid = mid + Math.imul(ah7, bl5) | 0;
    hi = hi + Math.imul(ah7, bh5) | 0;
    lo = lo + Math.imul(al6, bl6) | 0;
    mid = mid + Math.imul(al6, bh6) | 0;
    mid = mid + Math.imul(ah6, bl6) | 0;
    hi = hi + Math.imul(ah6, bh6) | 0;
    lo = lo + Math.imul(al5, bl7) | 0;
    mid = mid + Math.imul(al5, bh7) | 0;
    mid = mid + Math.imul(ah5, bl7) | 0;
    hi = hi + Math.imul(ah5, bh7) | 0;
    lo = lo + Math.imul(al4, bl8) | 0;
    mid = mid + Math.imul(al4, bh8) | 0;
    mid = mid + Math.imul(ah4, bl8) | 0;
    hi = hi + Math.imul(ah4, bh8) | 0;
    lo = lo + Math.imul(al3, bl9) | 0;
    mid = mid + Math.imul(al3, bh9) | 0;
    mid = mid + Math.imul(ah3, bl9) | 0;
    hi = hi + Math.imul(ah3, bh9) | 0;
    var w12 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w12 >>> 26) | 0;
    w12 &= 0x3ffffff;
    /* k = 13 */

    lo = Math.imul(al9, bl4);
    mid = Math.imul(al9, bh4);
    mid = mid + Math.imul(ah9, bl4) | 0;
    hi = Math.imul(ah9, bh4);
    lo = lo + Math.imul(al8, bl5) | 0;
    mid = mid + Math.imul(al8, bh5) | 0;
    mid = mid + Math.imul(ah8, bl5) | 0;
    hi = hi + Math.imul(ah8, bh5) | 0;
    lo = lo + Math.imul(al7, bl6) | 0;
    mid = mid + Math.imul(al7, bh6) | 0;
    mid = mid + Math.imul(ah7, bl6) | 0;
    hi = hi + Math.imul(ah7, bh6) | 0;
    lo = lo + Math.imul(al6, bl7) | 0;
    mid = mid + Math.imul(al6, bh7) | 0;
    mid = mid + Math.imul(ah6, bl7) | 0;
    hi = hi + Math.imul(ah6, bh7) | 0;
    lo = lo + Math.imul(al5, bl8) | 0;
    mid = mid + Math.imul(al5, bh8) | 0;
    mid = mid + Math.imul(ah5, bl8) | 0;
    hi = hi + Math.imul(ah5, bh8) | 0;
    lo = lo + Math.imul(al4, bl9) | 0;
    mid = mid + Math.imul(al4, bh9) | 0;
    mid = mid + Math.imul(ah4, bl9) | 0;
    hi = hi + Math.imul(ah4, bh9) | 0;
    var w13 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w13 >>> 26) | 0;
    w13 &= 0x3ffffff;
    /* k = 14 */

    lo = Math.imul(al9, bl5);
    mid = Math.imul(al9, bh5);
    mid = mid + Math.imul(ah9, bl5) | 0;
    hi = Math.imul(ah9, bh5);
    lo = lo + Math.imul(al8, bl6) | 0;
    mid = mid + Math.imul(al8, bh6) | 0;
    mid = mid + Math.imul(ah8, bl6) | 0;
    hi = hi + Math.imul(ah8, bh6) | 0;
    lo = lo + Math.imul(al7, bl7) | 0;
    mid = mid + Math.imul(al7, bh7) | 0;
    mid = mid + Math.imul(ah7, bl7) | 0;
    hi = hi + Math.imul(ah7, bh7) | 0;
    lo = lo + Math.imul(al6, bl8) | 0;
    mid = mid + Math.imul(al6, bh8) | 0;
    mid = mid + Math.imul(ah6, bl8) | 0;
    hi = hi + Math.imul(ah6, bh8) | 0;
    lo = lo + Math.imul(al5, bl9) | 0;
    mid = mid + Math.imul(al5, bh9) | 0;
    mid = mid + Math.imul(ah5, bl9) | 0;
    hi = hi + Math.imul(ah5, bh9) | 0;
    var w14 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w14 >>> 26) | 0;
    w14 &= 0x3ffffff;
    /* k = 15 */

    lo = Math.imul(al9, bl6);
    mid = Math.imul(al9, bh6);
    mid = mid + Math.imul(ah9, bl6) | 0;
    hi = Math.imul(ah9, bh6);
    lo = lo + Math.imul(al8, bl7) | 0;
    mid = mid + Math.imul(al8, bh7) | 0;
    mid = mid + Math.imul(ah8, bl7) | 0;
    hi = hi + Math.imul(ah8, bh7) | 0;
    lo = lo + Math.imul(al7, bl8) | 0;
    mid = mid + Math.imul(al7, bh8) | 0;
    mid = mid + Math.imul(ah7, bl8) | 0;
    hi = hi + Math.imul(ah7, bh8) | 0;
    lo = lo + Math.imul(al6, bl9) | 0;
    mid = mid + Math.imul(al6, bh9) | 0;
    mid = mid + Math.imul(ah6, bl9) | 0;
    hi = hi + Math.imul(ah6, bh9) | 0;
    var w15 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w15 >>> 26) | 0;
    w15 &= 0x3ffffff;
    /* k = 16 */

    lo = Math.imul(al9, bl7);
    mid = Math.imul(al9, bh7);
    mid = mid + Math.imul(ah9, bl7) | 0;
    hi = Math.imul(ah9, bh7);
    lo = lo + Math.imul(al8, bl8) | 0;
    mid = mid + Math.imul(al8, bh8) | 0;
    mid = mid + Math.imul(ah8, bl8) | 0;
    hi = hi + Math.imul(ah8, bh8) | 0;
    lo = lo + Math.imul(al7, bl9) | 0;
    mid = mid + Math.imul(al7, bh9) | 0;
    mid = mid + Math.imul(ah7, bl9) | 0;
    hi = hi + Math.imul(ah7, bh9) | 0;
    var w16 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w16 >>> 26) | 0;
    w16 &= 0x3ffffff;
    /* k = 17 */

    lo = Math.imul(al9, bl8);
    mid = Math.imul(al9, bh8);
    mid = mid + Math.imul(ah9, bl8) | 0;
    hi = Math.imul(ah9, bh8);
    lo = lo + Math.imul(al8, bl9) | 0;
    mid = mid + Math.imul(al8, bh9) | 0;
    mid = mid + Math.imul(ah8, bl9) | 0;
    hi = hi + Math.imul(ah8, bh9) | 0;
    var w17 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w17 >>> 26) | 0;
    w17 &= 0x3ffffff;
    /* k = 18 */

    lo = Math.imul(al9, bl9);
    mid = Math.imul(al9, bh9);
    mid = mid + Math.imul(ah9, bl9) | 0;
    hi = Math.imul(ah9, bh9);
    var w18 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w18 >>> 26) | 0;
    w18 &= 0x3ffffff;
    o[0] = w0;
    o[1] = w1;
    o[2] = w2;
    o[3] = w3;
    o[4] = w4;
    o[5] = w5;
    o[6] = w6;
    o[7] = w7;
    o[8] = w8;
    o[9] = w9;
    o[10] = w10;
    o[11] = w11;
    o[12] = w12;
    o[13] = w13;
    o[14] = w14;
    o[15] = w15;
    o[16] = w16;
    o[17] = w17;
    o[18] = w18;

    if (c !== 0) {
      o[19] = c;
      out.length++;
    }

    return out;
  }; // Polyfill comb


  if (!Math.imul) {
    comb10MulTo = smallMulTo;
  }

  function bigMulTo(self, num, out) {
    out.negative = num.negative ^ self.negative;
    out.length = self.length + num.length;
    var carry = 0;
    var hncarry = 0;

    for (var k = 0; k < out.length - 1; k++) {
      // Sum all words with the same `i + j = k` and accumulate `ncarry`,
      // note that ncarry could be >= 0x3ffffff
      var ncarry = hncarry;
      hncarry = 0;
      var rword = carry & 0x3ffffff;
      var maxJ = Math.min(k, num.length - 1);

      for (var j = Math.max(0, k - self.length + 1); j <= maxJ; j++) {
        var i = k - j;
        var a = self.words[i] | 0;
        var b = num.words[j] | 0;
        var r = a * b;
        var lo = r & 0x3ffffff;
        ncarry = ncarry + (r / 0x4000000 | 0) | 0;
        lo = lo + rword | 0;
        rword = lo & 0x3ffffff;
        ncarry = ncarry + (lo >>> 26) | 0;
        hncarry += ncarry >>> 26;
        ncarry &= 0x3ffffff;
      }

      out.words[k] = rword;
      carry = ncarry;
      ncarry = hncarry;
    }

    if (carry !== 0) {
      out.words[k] = carry;
    } else {
      out.length--;
    }

    return out.strip();
  }

  function jumboMulTo(self, num, out) {
    var fftm = new FFTM();
    return fftm.mulp(self, num, out);
  }

  BN.prototype.mulTo = function mulTo(num, out) {
    var res;
    var len = this.length + num.length;

    if (this.length === 10 && num.length === 10) {
      res = comb10MulTo(this, num, out);
    } else if (len < 63) {
      res = smallMulTo(this, num, out);
    } else if (len < 1024) {
      res = bigMulTo(this, num, out);
    } else {
      res = jumboMulTo(this, num, out);
    }

    return res;
  }; // Cooley-Tukey algorithm for FFT
  // slightly revisited to rely on looping instead of recursion


  function FFTM(x, y) {
    this.x = x;
    this.y = y;
  }

  FFTM.prototype.makeRBT = function makeRBT(N) {
    var t = new Array(N);
    var l = BN.prototype._countBits(N) - 1;

    for (var i = 0; i < N; i++) {
      t[i] = this.revBin(i, l, N);
    }

    return t;
  }; // Returns binary-reversed representation of `x`


  FFTM.prototype.revBin = function revBin(x, l, N) {
    if (x === 0 || x === N - 1) return x;
    var rb = 0;

    for (var i = 0; i < l; i++) {
      rb |= (x & 1) << l - i - 1;
      x >>= 1;
    }

    return rb;
  }; // Performs "tweedling" phase, therefore 'emulating'
  // behaviour of the recursive algorithm


  FFTM.prototype.permute = function permute(rbt, rws, iws, rtws, itws, N) {
    for (var i = 0; i < N; i++) {
      rtws[i] = rws[rbt[i]];
      itws[i] = iws[rbt[i]];
    }
  };

  FFTM.prototype.transform = function transform(rws, iws, rtws, itws, N, rbt) {
    this.permute(rbt, rws, iws, rtws, itws, N);

    for (var s = 1; s < N; s <<= 1) {
      var l = s << 1;
      var rtwdf = Math.cos(2 * Math.PI / l);
      var itwdf = Math.sin(2 * Math.PI / l);

      for (var p = 0; p < N; p += l) {
        var rtwdf_ = rtwdf;
        var itwdf_ = itwdf;

        for (var j = 0; j < s; j++) {
          var re = rtws[p + j];
          var ie = itws[p + j];
          var ro = rtws[p + j + s];
          var io = itws[p + j + s];
          var rx = rtwdf_ * ro - itwdf_ * io;
          io = rtwdf_ * io + itwdf_ * ro;
          ro = rx;
          rtws[p + j] = re + ro;
          itws[p + j] = ie + io;
          rtws[p + j + s] = re - ro;
          itws[p + j + s] = ie - io;
          /* jshint maxdepth : false */

          if (j !== l) {
            rx = rtwdf * rtwdf_ - itwdf * itwdf_;
            itwdf_ = rtwdf * itwdf_ + itwdf * rtwdf_;
            rtwdf_ = rx;
          }
        }
      }
    }
  };

  FFTM.prototype.guessLen13b = function guessLen13b(n, m) {
    var N = Math.max(m, n) | 1;
    var odd = N & 1;
    var i = 0;

    for (N = N / 2 | 0; N; N = N >>> 1) {
      i++;
    }

    return 1 << i + 1 + odd;
  };

  FFTM.prototype.conjugate = function conjugate(rws, iws, N) {
    if (N <= 1) return;

    for (var i = 0; i < N / 2; i++) {
      var t = rws[i];
      rws[i] = rws[N - i - 1];
      rws[N - i - 1] = t;
      t = iws[i];
      iws[i] = -iws[N - i - 1];
      iws[N - i - 1] = -t;
    }
  };

  FFTM.prototype.normalize13b = function normalize13b(ws, N) {
    var carry = 0;

    for (var i = 0; i < N / 2; i++) {
      var w = Math.round(ws[2 * i + 1] / N) * 0x2000 + Math.round(ws[2 * i] / N) + carry;
      ws[i] = w & 0x3ffffff;

      if (w < 0x4000000) {
        carry = 0;
      } else {
        carry = w / 0x4000000 | 0;
      }
    }

    return ws;
  };

  FFTM.prototype.convert13b = function convert13b(ws, len, rws, N) {
    var carry = 0;

    for (var i = 0; i < len; i++) {
      carry = carry + (ws[i] | 0);
      rws[2 * i] = carry & 0x1fff;
      carry = carry >>> 13;
      rws[2 * i + 1] = carry & 0x1fff;
      carry = carry >>> 13;
    } // Pad with zeroes


    for (i = 2 * len; i < N; ++i) {
      rws[i] = 0;
    }

    assert(carry === 0);
    assert((carry & ~0x1fff) === 0);
  };

  FFTM.prototype.stub = function stub(N) {
    var ph = new Array(N);

    for (var i = 0; i < N; i++) {
      ph[i] = 0;
    }

    return ph;
  };

  FFTM.prototype.mulp = function mulp(x, y, out) {
    var N = 2 * this.guessLen13b(x.length, y.length);
    var rbt = this.makeRBT(N);

    var _ = this.stub(N);

    var rws = new Array(N);
    var rwst = new Array(N);
    var iwst = new Array(N);
    var nrws = new Array(N);
    var nrwst = new Array(N);
    var niwst = new Array(N);
    var rmws = out.words;
    rmws.length = N;
    this.convert13b(x.words, x.length, rws, N);
    this.convert13b(y.words, y.length, nrws, N);
    this.transform(rws, _, rwst, iwst, N, rbt);
    this.transform(nrws, _, nrwst, niwst, N, rbt);

    for (var i = 0; i < N; i++) {
      var rx = rwst[i] * nrwst[i] - iwst[i] * niwst[i];
      iwst[i] = rwst[i] * niwst[i] + iwst[i] * nrwst[i];
      rwst[i] = rx;
    }

    this.conjugate(rwst, iwst, N);
    this.transform(rwst, iwst, rmws, _, N, rbt);
    this.conjugate(rmws, _, N);
    this.normalize13b(rmws, N);
    out.negative = x.negative ^ y.negative;
    out.length = x.length + y.length;
    return out.strip();
  }; // Multiply `this` by `num`


  BN.prototype.mul = function mul(num) {
    var out = new BN(null);
    out.words = new Array(this.length + num.length);
    return this.mulTo(num, out);
  }; // Multiply employing FFT


  BN.prototype.mulf = function mulf(num) {
    var out = new BN(null);
    out.words = new Array(this.length + num.length);
    return jumboMulTo(this, num, out);
  }; // In-place Multiplication


  BN.prototype.imul = function imul(num) {
    return this.clone().mulTo(num, this);
  };

  BN.prototype.imuln = function imuln(num) {
    assert(typeof num === 'number');
    assert(num < 0x4000000); // Carry

    var carry = 0;

    for (var i = 0; i < this.length; i++) {
      var w = (this.words[i] | 0) * num;
      var lo = (w & 0x3ffffff) + (carry & 0x3ffffff);
      carry >>= 26;
      carry += w / 0x4000000 | 0; // NOTE: lo is 27bit maximum

      carry += lo >>> 26;
      this.words[i] = lo & 0x3ffffff;
    }

    if (carry !== 0) {
      this.words[i] = carry;
      this.length++;
    }

    return this;
  };

  BN.prototype.muln = function muln(num) {
    return this.clone().imuln(num);
  }; // `this` * `this`


  BN.prototype.sqr = function sqr() {
    return this.mul(this);
  }; // `this` * `this` in-place


  BN.prototype.isqr = function isqr() {
    return this.imul(this.clone());
  }; // Math.pow(`this`, `num`)


  BN.prototype.pow = function pow(num) {
    var w = toBitArray(num);
    if (w.length === 0) return new BN(1); // Skip leading zeroes

    var res = this;

    for (var i = 0; i < w.length; i++, res = res.sqr()) {
      if (w[i] !== 0) break;
    }

    if (++i < w.length) {
      for (var q = res.sqr(); i < w.length; i++, q = q.sqr()) {
        if (w[i] === 0) continue;
        res = res.mul(q);
      }
    }

    return res;
  }; // Shift-left in-place


  BN.prototype.iushln = function iushln(bits) {
    assert(typeof bits === 'number' && bits >= 0);
    var r = bits % 26;
    var s = (bits - r) / 26;
    var carryMask = 0x3ffffff >>> 26 - r << 26 - r;
    var i;

    if (r !== 0) {
      var carry = 0;

      for (i = 0; i < this.length; i++) {
        var newCarry = this.words[i] & carryMask;
        var c = (this.words[i] | 0) - newCarry << r;
        this.words[i] = c | carry;
        carry = newCarry >>> 26 - r;
      }

      if (carry) {
        this.words[i] = carry;
        this.length++;
      }
    }

    if (s !== 0) {
      for (i = this.length - 1; i >= 0; i--) {
        this.words[i + s] = this.words[i];
      }

      for (i = 0; i < s; i++) {
        this.words[i] = 0;
      }

      this.length += s;
    }

    return this.strip();
  };

  BN.prototype.ishln = function ishln(bits) {
    // TODO(indutny): implement me
    assert(this.negative === 0);
    return this.iushln(bits);
  }; // Shift-right in-place
  // NOTE: `hint` is a lowest bit before trailing zeroes
  // NOTE: if `extended` is present - it will be filled with destroyed bits


  BN.prototype.iushrn = function iushrn(bits, hint, extended) {
    assert(typeof bits === 'number' && bits >= 0);
    var h;

    if (hint) {
      h = (hint - hint % 26) / 26;
    } else {
      h = 0;
    }

    var r = bits % 26;
    var s = Math.min((bits - r) / 26, this.length);
    var mask = 0x3ffffff ^ 0x3ffffff >>> r << r;
    var maskedWords = extended;
    h -= s;
    h = Math.max(0, h); // Extended mode, copy masked part

    if (maskedWords) {
      for (var i = 0; i < s; i++) {
        maskedWords.words[i] = this.words[i];
      }

      maskedWords.length = s;
    }

    if (s === 0) {// No-op, we should not move anything at all
    } else if (this.length > s) {
      this.length -= s;

      for (i = 0; i < this.length; i++) {
        this.words[i] = this.words[i + s];
      }
    } else {
      this.words[0] = 0;
      this.length = 1;
    }

    var carry = 0;

    for (i = this.length - 1; i >= 0 && (carry !== 0 || i >= h); i--) {
      var word = this.words[i] | 0;
      this.words[i] = carry << 26 - r | word >>> r;
      carry = word & mask;
    } // Push carried bits as a mask


    if (maskedWords && carry !== 0) {
      maskedWords.words[maskedWords.length++] = carry;
    }

    if (this.length === 0) {
      this.words[0] = 0;
      this.length = 1;
    }

    return this.strip();
  };

  BN.prototype.ishrn = function ishrn(bits, hint, extended) {
    // TODO(indutny): implement me
    assert(this.negative === 0);
    return this.iushrn(bits, hint, extended);
  }; // Shift-left


  BN.prototype.shln = function shln(bits) {
    return this.clone().ishln(bits);
  };

  BN.prototype.ushln = function ushln(bits) {
    return this.clone().iushln(bits);
  }; // Shift-right


  BN.prototype.shrn = function shrn(bits) {
    return this.clone().ishrn(bits);
  };

  BN.prototype.ushrn = function ushrn(bits) {
    return this.clone().iushrn(bits);
  }; // Test if n bit is set


  BN.prototype.testn = function testn(bit) {
    assert(typeof bit === 'number' && bit >= 0);
    var r = bit % 26;
    var s = (bit - r) / 26;
    var q = 1 << r; // Fast case: bit is much higher than all existing words

    if (this.length <= s) return false; // Check bit and return

    var w = this.words[s];
    return !!(w & q);
  }; // Return only lowers bits of number (in-place)


  BN.prototype.imaskn = function imaskn(bits) {
    assert(typeof bits === 'number' && bits >= 0);
    var r = bits % 26;
    var s = (bits - r) / 26;
    assert(this.negative === 0, 'imaskn works only with positive numbers');

    if (this.length <= s) {
      return this;
    }

    if (r !== 0) {
      s++;
    }

    this.length = Math.min(s, this.length);

    if (r !== 0) {
      var mask = 0x3ffffff ^ 0x3ffffff >>> r << r;
      this.words[this.length - 1] &= mask;
    }

    return this.strip();
  }; // Return only lowers bits of number


  BN.prototype.maskn = function maskn(bits) {
    return this.clone().imaskn(bits);
  }; // Add plain number `num` to `this`


  BN.prototype.iaddn = function iaddn(num) {
    assert(typeof num === 'number');
    assert(num < 0x4000000);
    if (num < 0) return this.isubn(-num); // Possible sign change

    if (this.negative !== 0) {
      if (this.length === 1 && (this.words[0] | 0) < num) {
        this.words[0] = num - (this.words[0] | 0);
        this.negative = 0;
        return this;
      }

      this.negative = 0;
      this.isubn(num);
      this.negative = 1;
      return this;
    } // Add without checks


    return this._iaddn(num);
  };

  BN.prototype._iaddn = function _iaddn(num) {
    this.words[0] += num; // Carry

    for (var i = 0; i < this.length && this.words[i] >= 0x4000000; i++) {
      this.words[i] -= 0x4000000;

      if (i === this.length - 1) {
        this.words[i + 1] = 1;
      } else {
        this.words[i + 1]++;
      }
    }

    this.length = Math.max(this.length, i + 1);
    return this;
  }; // Subtract plain number `num` from `this`


  BN.prototype.isubn = function isubn(num) {
    assert(typeof num === 'number');
    assert(num < 0x4000000);
    if (num < 0) return this.iaddn(-num);

    if (this.negative !== 0) {
      this.negative = 0;
      this.iaddn(num);
      this.negative = 1;
      return this;
    }

    this.words[0] -= num;

    if (this.length === 1 && this.words[0] < 0) {
      this.words[0] = -this.words[0];
      this.negative = 1;
    } else {
      // Carry
      for (var i = 0; i < this.length && this.words[i] < 0; i++) {
        this.words[i] += 0x4000000;
        this.words[i + 1] -= 1;
      }
    }

    return this.strip();
  };

  BN.prototype.addn = function addn(num) {
    return this.clone().iaddn(num);
  };

  BN.prototype.subn = function subn(num) {
    return this.clone().isubn(num);
  };

  BN.prototype.iabs = function iabs() {
    this.negative = 0;
    return this;
  };

  BN.prototype.abs = function abs() {
    return this.clone().iabs();
  };

  BN.prototype._ishlnsubmul = function _ishlnsubmul(num, mul, shift) {
    var len = num.length + shift;
    var i;

    this._expand(len);

    var w;
    var carry = 0;

    for (i = 0; i < num.length; i++) {
      w = (this.words[i + shift] | 0) + carry;
      var right = (num.words[i] | 0) * mul;
      w -= right & 0x3ffffff;
      carry = (w >> 26) - (right / 0x4000000 | 0);
      this.words[i + shift] = w & 0x3ffffff;
    }

    for (; i < this.length - shift; i++) {
      w = (this.words[i + shift] | 0) + carry;
      carry = w >> 26;
      this.words[i + shift] = w & 0x3ffffff;
    }

    if (carry === 0) return this.strip(); // Subtraction overflow

    assert(carry === -1);
    carry = 0;

    for (i = 0; i < this.length; i++) {
      w = -(this.words[i] | 0) + carry;
      carry = w >> 26;
      this.words[i] = w & 0x3ffffff;
    }

    this.negative = 1;
    return this.strip();
  };

  BN.prototype._wordDiv = function _wordDiv(num, mode) {
    var shift = this.length - num.length;
    var a = this.clone();
    var b = num; // Normalize

    var bhi = b.words[b.length - 1] | 0;

    var bhiBits = this._countBits(bhi);

    shift = 26 - bhiBits;

    if (shift !== 0) {
      b = b.ushln(shift);
      a.iushln(shift);
      bhi = b.words[b.length - 1] | 0;
    } // Initialize quotient


    var m = a.length - b.length;
    var q;

    if (mode !== 'mod') {
      q = new BN(null);
      q.length = m + 1;
      q.words = new Array(q.length);

      for (var i = 0; i < q.length; i++) {
        q.words[i] = 0;
      }
    }

    var diff = a.clone()._ishlnsubmul(b, 1, m);

    if (diff.negative === 0) {
      a = diff;

      if (q) {
        q.words[m] = 1;
      }
    }

    for (var j = m - 1; j >= 0; j--) {
      var qj = (a.words[b.length + j] | 0) * 0x4000000 + (a.words[b.length + j - 1] | 0); // NOTE: (qj / bhi) is (0x3ffffff * 0x4000000 + 0x3ffffff) / 0x2000000 max
      // (0x7ffffff)

      qj = Math.min(qj / bhi | 0, 0x3ffffff);

      a._ishlnsubmul(b, qj, j);

      while (a.negative !== 0) {
        qj--;
        a.negative = 0;

        a._ishlnsubmul(b, 1, j);

        if (!a.isZero()) {
          a.negative ^= 1;
        }
      }

      if (q) {
        q.words[j] = qj;
      }
    }

    if (q) {
      q.strip();
    }

    a.strip(); // Denormalize

    if (mode !== 'div' && shift !== 0) {
      a.iushrn(shift);
    }

    return {
      div: q || null,
      mod: a
    };
  }; // NOTE: 1) `mode` can be set to `mod` to request mod only,
  //       to `div` to request div only, or be absent to
  //       request both div & mod
  //       2) `positive` is true if unsigned mod is requested


  BN.prototype.divmod = function divmod(num, mode, positive) {
    assert(!num.isZero());

    if (this.isZero()) {
      return {
        div: new BN(0),
        mod: new BN(0)
      };
    }

    var div, mod, res;

    if (this.negative !== 0 && num.negative === 0) {
      res = this.neg().divmod(num, mode);

      if (mode !== 'mod') {
        div = res.div.neg();
      }

      if (mode !== 'div') {
        mod = res.mod.neg();

        if (positive && mod.negative !== 0) {
          mod.iadd(num);
        }
      }

      return {
        div: div,
        mod: mod
      };
    }

    if (this.negative === 0 && num.negative !== 0) {
      res = this.divmod(num.neg(), mode);

      if (mode !== 'mod') {
        div = res.div.neg();
      }

      return {
        div: div,
        mod: res.mod
      };
    }

    if ((this.negative & num.negative) !== 0) {
      res = this.neg().divmod(num.neg(), mode);

      if (mode !== 'div') {
        mod = res.mod.neg();

        if (positive && mod.negative !== 0) {
          mod.isub(num);
        }
      }

      return {
        div: res.div,
        mod: mod
      };
    } // Both numbers are positive at this point
    // Strip both numbers to approximate shift value


    if (num.length > this.length || this.cmp(num) < 0) {
      return {
        div: new BN(0),
        mod: this
      };
    } // Very short reduction


    if (num.length === 1) {
      if (mode === 'div') {
        return {
          div: this.divn(num.words[0]),
          mod: null
        };
      }

      if (mode === 'mod') {
        return {
          div: null,
          mod: new BN(this.modn(num.words[0]))
        };
      }

      return {
        div: this.divn(num.words[0]),
        mod: new BN(this.modn(num.words[0]))
      };
    }

    return this._wordDiv(num, mode);
  }; // Find `this` / `num`


  BN.prototype.div = function div(num) {
    return this.divmod(num, 'div', false).div;
  }; // Find `this` % `num`


  BN.prototype.mod = function mod(num) {
    return this.divmod(num, 'mod', false).mod;
  };

  BN.prototype.umod = function umod(num) {
    return this.divmod(num, 'mod', true).mod;
  }; // Find Round(`this` / `num`)


  BN.prototype.divRound = function divRound(num) {
    var dm = this.divmod(num); // Fast case - exact division

    if (dm.mod.isZero()) return dm.div;
    var mod = dm.div.negative !== 0 ? dm.mod.isub(num) : dm.mod;
    var half = num.ushrn(1);
    var r2 = num.andln(1);
    var cmp = mod.cmp(half); // Round down

    if (cmp < 0 || r2 === 1 && cmp === 0) return dm.div; // Round up

    return dm.div.negative !== 0 ? dm.div.isubn(1) : dm.div.iaddn(1);
  };

  BN.prototype.modn = function modn(num) {
    assert(num <= 0x3ffffff);
    var p = (1 << 26) % num;
    var acc = 0;

    for (var i = this.length - 1; i >= 0; i--) {
      acc = (p * acc + (this.words[i] | 0)) % num;
    }

    return acc;
  }; // In-place division by number


  BN.prototype.idivn = function idivn(num) {
    assert(num <= 0x3ffffff);
    var carry = 0;

    for (var i = this.length - 1; i >= 0; i--) {
      var w = (this.words[i] | 0) + carry * 0x4000000;
      this.words[i] = w / num | 0;
      carry = w % num;
    }

    return this.strip();
  };

  BN.prototype.divn = function divn(num) {
    return this.clone().idivn(num);
  };

  BN.prototype.egcd = function egcd(p) {
    assert(p.negative === 0);
    assert(!p.isZero());
    var x = this;
    var y = p.clone();

    if (x.negative !== 0) {
      x = x.umod(p);
    } else {
      x = x.clone();
    } // A * x + B * y = x


    var A = new BN(1);
    var B = new BN(0); // C * x + D * y = y

    var C = new BN(0);
    var D = new BN(1);
    var g = 0;

    while (x.isEven() && y.isEven()) {
      x.iushrn(1);
      y.iushrn(1);
      ++g;
    }

    var yp = y.clone();
    var xp = x.clone();

    while (!x.isZero()) {
      for (var i = 0, im = 1; (x.words[0] & im) === 0 && i < 26; ++i, im <<= 1) {
        ;
      }

      if (i > 0) {
        x.iushrn(i);

        while (i-- > 0) {
          if (A.isOdd() || B.isOdd()) {
            A.iadd(yp);
            B.isub(xp);
          }

          A.iushrn(1);
          B.iushrn(1);
        }
      }

      for (var j = 0, jm = 1; (y.words[0] & jm) === 0 && j < 26; ++j, jm <<= 1) {
        ;
      }

      if (j > 0) {
        y.iushrn(j);

        while (j-- > 0) {
          if (C.isOdd() || D.isOdd()) {
            C.iadd(yp);
            D.isub(xp);
          }

          C.iushrn(1);
          D.iushrn(1);
        }
      }

      if (x.cmp(y) >= 0) {
        x.isub(y);
        A.isub(C);
        B.isub(D);
      } else {
        y.isub(x);
        C.isub(A);
        D.isub(B);
      }
    }

    return {
      a: C,
      b: D,
      gcd: y.iushln(g)
    };
  }; // This is reduced incarnation of the binary EEA
  // above, designated to invert members of the
  // _prime_ fields F(p) at a maximal speed


  BN.prototype._invmp = function _invmp(p) {
    assert(p.negative === 0);
    assert(!p.isZero());
    var a = this;
    var b = p.clone();

    if (a.negative !== 0) {
      a = a.umod(p);
    } else {
      a = a.clone();
    }

    var x1 = new BN(1);
    var x2 = new BN(0);
    var delta = b.clone();

    while (a.cmpn(1) > 0 && b.cmpn(1) > 0) {
      for (var i = 0, im = 1; (a.words[0] & im) === 0 && i < 26; ++i, im <<= 1) {
        ;
      }

      if (i > 0) {
        a.iushrn(i);

        while (i-- > 0) {
          if (x1.isOdd()) {
            x1.iadd(delta);
          }

          x1.iushrn(1);
        }
      }

      for (var j = 0, jm = 1; (b.words[0] & jm) === 0 && j < 26; ++j, jm <<= 1) {
        ;
      }

      if (j > 0) {
        b.iushrn(j);

        while (j-- > 0) {
          if (x2.isOdd()) {
            x2.iadd(delta);
          }

          x2.iushrn(1);
        }
      }

      if (a.cmp(b) >= 0) {
        a.isub(b);
        x1.isub(x2);
      } else {
        b.isub(a);
        x2.isub(x1);
      }
    }

    var res;

    if (a.cmpn(1) === 0) {
      res = x1;
    } else {
      res = x2;
    }

    if (res.cmpn(0) < 0) {
      res.iadd(p);
    }

    return res;
  };

  BN.prototype.gcd = function gcd(num) {
    if (this.isZero()) return num.abs();
    if (num.isZero()) return this.abs();
    var a = this.clone();
    var b = num.clone();
    a.negative = 0;
    b.negative = 0; // Remove common factor of two

    for (var shift = 0; a.isEven() && b.isEven(); shift++) {
      a.iushrn(1);
      b.iushrn(1);
    }

    do {
      while (a.isEven()) {
        a.iushrn(1);
      }

      while (b.isEven()) {
        b.iushrn(1);
      }

      var r = a.cmp(b);

      if (r < 0) {
        // Swap `a` and `b` to make `a` always bigger than `b`
        var t = a;
        a = b;
        b = t;
      } else if (r === 0 || b.cmpn(1) === 0) {
        break;
      }

      a.isub(b);
    } while (true);

    return b.iushln(shift);
  }; // Invert number in the field F(num)


  BN.prototype.invm = function invm(num) {
    return this.egcd(num).a.umod(num);
  };

  BN.prototype.isEven = function isEven() {
    return (this.words[0] & 1) === 0;
  };

  BN.prototype.isOdd = function isOdd() {
    return (this.words[0] & 1) === 1;
  }; // And first word and num


  BN.prototype.andln = function andln(num) {
    return this.words[0] & num;
  }; // Increment at the bit position in-line


  BN.prototype.bincn = function bincn(bit) {
    assert(typeof bit === 'number');
    var r = bit % 26;
    var s = (bit - r) / 26;
    var q = 1 << r; // Fast case: bit is much higher than all existing words

    if (this.length <= s) {
      this._expand(s + 1);

      this.words[s] |= q;
      return this;
    } // Add bit and propagate, if needed


    var carry = q;

    for (var i = s; carry !== 0 && i < this.length; i++) {
      var w = this.words[i] | 0;
      w += carry;
      carry = w >>> 26;
      w &= 0x3ffffff;
      this.words[i] = w;
    }

    if (carry !== 0) {
      this.words[i] = carry;
      this.length++;
    }

    return this;
  };

  BN.prototype.isZero = function isZero() {
    return this.length === 1 && this.words[0] === 0;
  };

  BN.prototype.cmpn = function cmpn(num) {
    var negative = num < 0;
    if (this.negative !== 0 && !negative) return -1;
    if (this.negative === 0 && negative) return 1;
    this.strip();
    var res;

    if (this.length > 1) {
      res = 1;
    } else {
      if (negative) {
        num = -num;
      }

      assert(num <= 0x3ffffff, 'Number is too big');
      var w = this.words[0] | 0;
      res = w === num ? 0 : w < num ? -1 : 1;
    }

    if (this.negative !== 0) return -res | 0;
    return res;
  }; // Compare two numbers and return:
  // 1 - if `this` > `num`
  // 0 - if `this` == `num`
  // -1 - if `this` < `num`


  BN.prototype.cmp = function cmp(num) {
    if (this.negative !== 0 && num.negative === 0) return -1;
    if (this.negative === 0 && num.negative !== 0) return 1;
    var res = this.ucmp(num);
    if (this.negative !== 0) return -res | 0;
    return res;
  }; // Unsigned comparison


  BN.prototype.ucmp = function ucmp(num) {
    // At this point both numbers have the same sign
    if (this.length > num.length) return 1;
    if (this.length < num.length) return -1;
    var res = 0;

    for (var i = this.length - 1; i >= 0; i--) {
      var a = this.words[i] | 0;
      var b = num.words[i] | 0;
      if (a === b) continue;

      if (a < b) {
        res = -1;
      } else if (a > b) {
        res = 1;
      }

      break;
    }

    return res;
  };

  BN.prototype.gtn = function gtn(num) {
    return this.cmpn(num) === 1;
  };

  BN.prototype.gt = function gt(num) {
    return this.cmp(num) === 1;
  };

  BN.prototype.gten = function gten(num) {
    return this.cmpn(num) >= 0;
  };

  BN.prototype.gte = function gte(num) {
    return this.cmp(num) >= 0;
  };

  BN.prototype.ltn = function ltn(num) {
    return this.cmpn(num) === -1;
  };

  BN.prototype.lt = function lt(num) {
    return this.cmp(num) === -1;
  };

  BN.prototype.lten = function lten(num) {
    return this.cmpn(num) <= 0;
  };

  BN.prototype.lte = function lte(num) {
    return this.cmp(num) <= 0;
  };

  BN.prototype.eqn = function eqn(num) {
    return this.cmpn(num) === 0;
  };

  BN.prototype.eq = function eq(num) {
    return this.cmp(num) === 0;
  }; //
  // A reduce context, could be using montgomery or something better, depending
  // on the `m` itself.
  //


  BN.red = function red(num) {
    return new Red(num);
  };

  BN.prototype.toRed = function toRed(ctx) {
    assert(!this.red, 'Already a number in reduction context');
    assert(this.negative === 0, 'red works only with positives');
    return ctx.convertTo(this)._forceRed(ctx);
  };

  BN.prototype.fromRed = function fromRed() {
    assert(this.red, 'fromRed works only with numbers in reduction context');
    return this.red.convertFrom(this);
  };

  BN.prototype._forceRed = function _forceRed(ctx) {
    this.red = ctx;
    return this;
  };

  BN.prototype.forceRed = function forceRed(ctx) {
    assert(!this.red, 'Already a number in reduction context');
    return this._forceRed(ctx);
  };

  BN.prototype.redAdd = function redAdd(num) {
    assert(this.red, 'redAdd works only with red numbers');
    return this.red.add(this, num);
  };

  BN.prototype.redIAdd = function redIAdd(num) {
    assert(this.red, 'redIAdd works only with red numbers');
    return this.red.iadd(this, num);
  };

  BN.prototype.redSub = function redSub(num) {
    assert(this.red, 'redSub works only with red numbers');
    return this.red.sub(this, num);
  };

  BN.prototype.redISub = function redISub(num) {
    assert(this.red, 'redISub works only with red numbers');
    return this.red.isub(this, num);
  };

  BN.prototype.redShl = function redShl(num) {
    assert(this.red, 'redShl works only with red numbers');
    return this.red.shl(this, num);
  };

  BN.prototype.redMul = function redMul(num) {
    assert(this.red, 'redMul works only with red numbers');

    this.red._verify2(this, num);

    return this.red.mul(this, num);
  };

  BN.prototype.redIMul = function redIMul(num) {
    assert(this.red, 'redMul works only with red numbers');

    this.red._verify2(this, num);

    return this.red.imul(this, num);
  };

  BN.prototype.redSqr = function redSqr() {
    assert(this.red, 'redSqr works only with red numbers');

    this.red._verify1(this);

    return this.red.sqr(this);
  };

  BN.prototype.redISqr = function redISqr() {
    assert(this.red, 'redISqr works only with red numbers');

    this.red._verify1(this);

    return this.red.isqr(this);
  }; // Square root over p


  BN.prototype.redSqrt = function redSqrt() {
    assert(this.red, 'redSqrt works only with red numbers');

    this.red._verify1(this);

    return this.red.sqrt(this);
  };

  BN.prototype.redInvm = function redInvm() {
    assert(this.red, 'redInvm works only with red numbers');

    this.red._verify1(this);

    return this.red.invm(this);
  }; // Return negative clone of `this` % `red modulo`


  BN.prototype.redNeg = function redNeg() {
    assert(this.red, 'redNeg works only with red numbers');

    this.red._verify1(this);

    return this.red.neg(this);
  };

  BN.prototype.redPow = function redPow(num) {
    assert(this.red && !num.red, 'redPow(normalNum)');

    this.red._verify1(this);

    return this.red.pow(this, num);
  }; // Prime numbers with efficient reduction


  var primes = {
    k256: null,
    p224: null,
    p192: null,
    p25519: null
  }; // Pseudo-Mersenne prime

  function MPrime(name, p) {
    // P = 2 ^ N - K
    this.name = name;
    this.p = new BN(p, 16);
    this.n = this.p.bitLength();
    this.k = new BN(1).iushln(this.n).isub(this.p);
    this.tmp = this._tmp();
  }

  MPrime.prototype._tmp = function _tmp() {
    var tmp = new BN(null);
    tmp.words = new Array(Math.ceil(this.n / 13));
    return tmp;
  };

  MPrime.prototype.ireduce = function ireduce(num) {
    // Assumes that `num` is less than `P^2`
    // num = HI * (2 ^ N - K) + HI * K + LO = HI * K + LO (mod P)
    var r = num;
    var rlen;

    do {
      this.split(r, this.tmp);
      r = this.imulK(r);
      r = r.iadd(this.tmp);
      rlen = r.bitLength();
    } while (rlen > this.n);

    var cmp = rlen < this.n ? -1 : r.ucmp(this.p);

    if (cmp === 0) {
      r.words[0] = 0;
      r.length = 1;
    } else if (cmp > 0) {
      r.isub(this.p);
    } else {
      if (r.strip !== undefined) {
        // r is BN v4 instance
        r.strip();
      } else {
        // r is BN v5 instance
        r._strip();
      }
    }

    return r;
  };

  MPrime.prototype.split = function split(input, out) {
    input.iushrn(this.n, 0, out);
  };

  MPrime.prototype.imulK = function imulK(num) {
    return num.imul(this.k);
  };

  function K256() {
    MPrime.call(this, 'k256', 'ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff fffffffe fffffc2f');
  }

  inherits(K256, MPrime);

  K256.prototype.split = function split(input, output) {
    // 256 = 9 * 26 + 22
    var mask = 0x3fffff;
    var outLen = Math.min(input.length, 9);

    for (var i = 0; i < outLen; i++) {
      output.words[i] = input.words[i];
    }

    output.length = outLen;

    if (input.length <= 9) {
      input.words[0] = 0;
      input.length = 1;
      return;
    } // Shift by 9 limbs


    var prev = input.words[9];
    output.words[output.length++] = prev & mask;

    for (i = 10; i < input.length; i++) {
      var next = input.words[i] | 0;
      input.words[i - 10] = (next & mask) << 4 | prev >>> 22;
      prev = next;
    }

    prev >>>= 22;
    input.words[i - 10] = prev;

    if (prev === 0 && input.length > 10) {
      input.length -= 10;
    } else {
      input.length -= 9;
    }
  };

  K256.prototype.imulK = function imulK(num) {
    // K = 0x1000003d1 = [ 0x40, 0x3d1 ]
    num.words[num.length] = 0;
    num.words[num.length + 1] = 0;
    num.length += 2; // bounded at: 0x40 * 0x3ffffff + 0x3d0 = 0x100000390

    var lo = 0;

    for (var i = 0; i < num.length; i++) {
      var w = num.words[i] | 0;
      lo += w * 0x3d1;
      num.words[i] = lo & 0x3ffffff;
      lo = w * 0x40 + (lo / 0x4000000 | 0);
    } // Fast length reduction


    if (num.words[num.length - 1] === 0) {
      num.length--;

      if (num.words[num.length - 1] === 0) {
        num.length--;
      }
    }

    return num;
  };

  function P224() {
    MPrime.call(this, 'p224', 'ffffffff ffffffff ffffffff ffffffff 00000000 00000000 00000001');
  }

  inherits(P224, MPrime);

  function P192() {
    MPrime.call(this, 'p192', 'ffffffff ffffffff ffffffff fffffffe ffffffff ffffffff');
  }

  inherits(P192, MPrime);

  function P25519() {
    // 2 ^ 255 - 19
    MPrime.call(this, '25519', '7fffffffffffffff ffffffffffffffff ffffffffffffffff ffffffffffffffed');
  }

  inherits(P25519, MPrime);

  P25519.prototype.imulK = function imulK(num) {
    // K = 0x13
    var carry = 0;

    for (var i = 0; i < num.length; i++) {
      var hi = (num.words[i] | 0) * 0x13 + carry;
      var lo = hi & 0x3ffffff;
      hi >>>= 26;
      num.words[i] = lo;
      carry = hi;
    }

    if (carry !== 0) {
      num.words[num.length++] = carry;
    }

    return num;
  }; // Exported mostly for testing purposes, use plain name instead


  BN._prime = function prime(name) {
    // Cached version of prime
    if (primes[name]) return primes[name];
    var prime;

    if (name === 'k256') {
      prime = new K256();
    } else if (name === 'p224') {
      prime = new P224();
    } else if (name === 'p192') {
      prime = new P192();
    } else if (name === 'p25519') {
      prime = new P25519();
    } else {
      throw new Error('Unknown prime ' + name);
    }

    primes[name] = prime;
    return prime;
  }; //
  // Base reduction engine
  //


  function Red(m) {
    if (typeof m === 'string') {
      var prime = BN._prime(m);

      this.m = prime.p;
      this.prime = prime;
    } else {
      assert(m.gtn(1), 'modulus must be greater than 1');
      this.m = m;
      this.prime = null;
    }
  }

  Red.prototype._verify1 = function _verify1(a) {
    assert(a.negative === 0, 'red works only with positives');
    assert(a.red, 'red works only with red numbers');
  };

  Red.prototype._verify2 = function _verify2(a, b) {
    assert((a.negative | b.negative) === 0, 'red works only with positives');
    assert(a.red && a.red === b.red, 'red works only with red numbers');
  };

  Red.prototype.imod = function imod(a) {
    if (this.prime) return this.prime.ireduce(a)._forceRed(this);
    return a.umod(this.m)._forceRed(this);
  };

  Red.prototype.neg = function neg(a) {
    if (a.isZero()) {
      return a.clone();
    }

    return this.m.sub(a)._forceRed(this);
  };

  Red.prototype.add = function add(a, b) {
    this._verify2(a, b);

    var res = a.add(b);

    if (res.cmp(this.m) >= 0) {
      res.isub(this.m);
    }

    return res._forceRed(this);
  };

  Red.prototype.iadd = function iadd(a, b) {
    this._verify2(a, b);

    var res = a.iadd(b);

    if (res.cmp(this.m) >= 0) {
      res.isub(this.m);
    }

    return res;
  };

  Red.prototype.sub = function sub(a, b) {
    this._verify2(a, b);

    var res = a.sub(b);

    if (res.cmpn(0) < 0) {
      res.iadd(this.m);
    }

    return res._forceRed(this);
  };

  Red.prototype.isub = function isub(a, b) {
    this._verify2(a, b);

    var res = a.isub(b);

    if (res.cmpn(0) < 0) {
      res.iadd(this.m);
    }

    return res;
  };

  Red.prototype.shl = function shl(a, num) {
    this._verify1(a);

    return this.imod(a.ushln(num));
  };

  Red.prototype.imul = function imul(a, b) {
    this._verify2(a, b);

    return this.imod(a.imul(b));
  };

  Red.prototype.mul = function mul(a, b) {
    this._verify2(a, b);

    return this.imod(a.mul(b));
  };

  Red.prototype.isqr = function isqr(a) {
    return this.imul(a, a.clone());
  };

  Red.prototype.sqr = function sqr(a) {
    return this.mul(a, a);
  };

  Red.prototype.sqrt = function sqrt(a) {
    if (a.isZero()) return a.clone();
    var mod3 = this.m.andln(3);
    assert(mod3 % 2 === 1); // Fast case

    if (mod3 === 3) {
      var pow = this.m.add(new BN(1)).iushrn(2);
      return this.pow(a, pow);
    } // Tonelli-Shanks algorithm (Totally unoptimized and slow)
    //
    // Find Q and S, that Q * 2 ^ S = (P - 1)


    var q = this.m.subn(1);
    var s = 0;

    while (!q.isZero() && q.andln(1) === 0) {
      s++;
      q.iushrn(1);
    }

    assert(!q.isZero());
    var one = new BN(1).toRed(this);
    var nOne = one.redNeg(); // Find quadratic non-residue
    // NOTE: Max is such because of generalized Riemann hypothesis.

    var lpow = this.m.subn(1).iushrn(1);
    var z = this.m.bitLength();
    z = new BN(2 * z * z).toRed(this);

    while (this.pow(z, lpow).cmp(nOne) !== 0) {
      z.redIAdd(nOne);
    }

    var c = this.pow(z, q);
    var r = this.pow(a, q.addn(1).iushrn(1));
    var t = this.pow(a, q);
    var m = s;

    while (t.cmp(one) !== 0) {
      var tmp = t;

      for (var i = 0; tmp.cmp(one) !== 0; i++) {
        tmp = tmp.redSqr();
      }

      assert(i < m);
      var b = this.pow(c, new BN(1).iushln(m - i - 1));
      r = r.redMul(b);
      c = b.redSqr();
      t = t.redMul(c);
      m = i;
    }

    return r;
  };

  Red.prototype.invm = function invm(a) {
    var inv = a._invmp(this.m);

    if (inv.negative !== 0) {
      inv.negative = 0;
      return this.imod(inv).redNeg();
    } else {
      return this.imod(inv);
    }
  };

  Red.prototype.pow = function pow(a, num) {
    if (num.isZero()) return new BN(1).toRed(this);
    if (num.cmpn(1) === 0) return a.clone();
    var windowSize = 4;
    var wnd = new Array(1 << windowSize);
    wnd[0] = new BN(1).toRed(this);
    wnd[1] = a;

    for (var i = 2; i < wnd.length; i++) {
      wnd[i] = this.mul(wnd[i - 1], a);
    }

    var res = wnd[0];
    var current = 0;
    var currentLen = 0;
    var start = num.bitLength() % 26;

    if (start === 0) {
      start = 26;
    }

    for (i = num.length - 1; i >= 0; i--) {
      var word = num.words[i];

      for (var j = start - 1; j >= 0; j--) {
        var bit = word >> j & 1;

        if (res !== wnd[0]) {
          res = this.sqr(res);
        }

        if (bit === 0 && current === 0) {
          currentLen = 0;
          continue;
        }

        current <<= 1;
        current |= bit;
        currentLen++;
        if (currentLen !== windowSize && (i !== 0 || j !== 0)) continue;
        res = this.mul(res, wnd[current]);
        currentLen = 0;
        current = 0;
      }

      start = 26;
    }

    return res;
  };

  Red.prototype.convertTo = function convertTo(num) {
    var r = num.umod(this.m);
    return r === num ? r.clone() : r;
  };

  Red.prototype.convertFrom = function convertFrom(num) {
    var res = num.clone();
    res.red = null;
    return res;
  }; //
  // Montgomery method engine
  //


  BN.mont = function mont(num) {
    return new Mont(num);
  };

  function Mont(m) {
    Red.call(this, m);
    this.shift = this.m.bitLength();

    if (this.shift % 26 !== 0) {
      this.shift += 26 - this.shift % 26;
    }

    this.r = new BN(1).iushln(this.shift);
    this.r2 = this.imod(this.r.sqr());
    this.rinv = this.r._invmp(this.m);
    this.minv = this.rinv.mul(this.r).isubn(1).div(this.m);
    this.minv = this.minv.umod(this.r);
    this.minv = this.r.sub(this.minv);
  }

  inherits(Mont, Red);

  Mont.prototype.convertTo = function convertTo(num) {
    return this.imod(num.ushln(this.shift));
  };

  Mont.prototype.convertFrom = function convertFrom(num) {
    var r = this.imod(num.mul(this.rinv));
    r.red = null;
    return r;
  };

  Mont.prototype.imul = function imul(a, b) {
    if (a.isZero() || b.isZero()) {
      a.words[0] = 0;
      a.length = 1;
      return a;
    }

    var t = a.imul(b);
    var c = t.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m);
    var u = t.isub(c).iushrn(this.shift);
    var res = u;

    if (u.cmp(this.m) >= 0) {
      res = u.isub(this.m);
    } else if (u.cmpn(0) < 0) {
      res = u.iadd(this.m);
    }

    return res._forceRed(this);
  };

  Mont.prototype.mul = function mul(a, b) {
    if (a.isZero() || b.isZero()) return new BN(0)._forceRed(this);
    var t = a.mul(b);
    var c = t.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m);
    var u = t.isub(c).iushrn(this.shift);
    var res = u;

    if (u.cmp(this.m) >= 0) {
      res = u.isub(this.m);
    } else if (u.cmpn(0) < 0) {
      res = u.iadd(this.m);
    }

    return res._forceRed(this);
  };

  Mont.prototype.invm = function invm(a) {
    // (AR)^-1 * R^2 = (A^-1 * R^-1) * R^2 = A^-1 * R
    var res = this.imod(a._invmp(this.m).mul(this.r2));
    return res._forceRed(this);
  };
})( false || module, this);

/***/ }),

/***/ "./node_modules/cleaners/lib/index.js":
/*!********************************************!*\
  !*** ./node_modules/cleaners/lib/index.js ***!
  \********************************************/
/***/ (function(__unused_webpack_module, exports) {

"use strict";


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", ({
  value: true
})); // simple types --------------------------------------------------------------

function asBoolean(raw) {
  if (typeof raw !== 'boolean') throw new TypeError('Expected a boolean');
  return raw;
}

var asNull = asValue(null);

function asNumber(raw) {
  if (typeof raw !== 'number') throw new TypeError('Expected a number');
  return raw;
}

function asString(raw) {
  if (typeof raw !== 'string') throw new TypeError('Expected a string');
  return raw;
}

var asUndefined = asValue(undefined);
var asNone = asOptional(asNull);

function asUnknown(raw) {
  return raw;
} // data structures -----------------------------------------------------------


function asArray(cleaner) {
  return function asArray(raw) {
    if (!Array.isArray(raw)) {
      throw new TypeError('Expected an array');
    }

    var out = [];

    for (var i = 0; i < raw.length; ++i) {
      try {
        out[i] = cleaner(raw[i]);
      } catch (error) {
        throw locateError(error, '[' + i + ']', 0);
      }
    }

    return out;
  };
}

function asObject(shape) {
  // The key-value version:
  if (typeof shape === 'function') {
    return function asObject(raw) {
      if (_typeof(raw) !== 'object' || raw == null) {
        throw new TypeError('Expected an object');
      }

      var out = {};
      var keys = Object.keys(raw);

      for (var i = 0; i < keys.length; ++i) {
        var key = keys[i];
        if (key === '__proto__') continue;

        try {
          out[key] = shape(raw[key]);
        } catch (error) {
          throw locateError(error, '[' + JSON.stringify(key) + ']', 0);
        }
      }

      return out;
    };
  } // The shape-aware version:


  var keys = Object.keys(shape);

  function bindObjectShape(keepRest) {
    return function asObject(raw) {
      if (_typeof(raw) !== 'object' || raw == null) {
        throw new TypeError('Expected an object');
      }

      var i;
      var out = {};

      if (keepRest) {
        var toCopy = Object.keys(raw);

        for (i = 0; i < toCopy.length; ++i) {
          var key = toCopy[i];
          if (key === '__proto__') continue;
          out[key] = raw[key];
        }
      }

      for (i = 0; i < keys.length; ++i) {
        var _key = keys[i];

        try {
          out[_key] = shape[_key](raw[_key]);
        } catch (error) {
          throw locateError(error, '.' + _key, 0);
        }
      }

      return out;
    };
  }

  var out = bindObjectShape(false);
  out.shape = shape;
  out.withRest = bindObjectShape(true);
  return out;
} // branching -----------------------------------------------------------------


function asEither() {
  for (var _len = arguments.length, shape = new Array(_len), _key2 = 0; _key2 < _len; _key2++) {
    shape[_key2] = arguments[_key2];
  }

  return function asEither(raw) {
    for (var i = 0; i < shape.length; i++) {
      try {
        return shape[i](raw);
      } catch (error) {
        if (i + 1 >= shape.length) throw error;
      }
    }
  };
}

function asMaybe(cleaner, fallback) {
  return function asMaybe(raw) {
    try {
      return cleaner(raw);
    } catch (e) {
      return fallback;
    }
  };
}

function asOptional(cleaner, fallback) {
  return function asOptional(raw) {
    return raw != null ? cleaner(raw) : fallback;
  };
} // parsing -------------------------------------------------------------------


var uncleaning = 0;

function asCodec(cleaner, uncleaner) {
  return function asCodec(raw) {
    return uncleaning > 0 ? uncleaner(raw) : cleaner(raw);
  };
}

var asDate = asCodec(function asDate(raw) {
  if (typeof raw !== 'string' && !(raw instanceof Date)) {
    throw new TypeError('Expected a date string');
  }

  var out = new Date(raw);
  if (out.toJSON() == null) throw new TypeError('Invalid date format');
  return out;
}, function wasDate(clean) {
  return clean.toISOString();
});

function asJSON(cleaner) {
  return asCodec(function asJSON(raw) {
    var value = JSON.parse(asString(raw));

    try {
      return cleaner(value);
    } catch (error) {
      throw locateError(error, 'JSON.parse()', 11);
    }
  }, function wasJSON(clean) {
    return JSON.stringify(cleaner(clean));
  });
}

function uncleaner(cleaner) {
  return function uncleaner(raw) {
    try {
      ++uncleaning;
      return cleaner(raw);
    } finally {
      --uncleaning;
    }
  };
}

function asValue(value) {
  return function asValue(raw) {
    if (raw !== value) {
      throw new TypeError("Expected " + JSON.stringify(value));
    }

    return raw;
  };
} // deprecated ----------------------------------------------------------------


var asMap = asObject; // helpers -------------------------------------------------------------------

/**
 * Adds location information to an error message.
 *
 * Errors can occur inside deeply-nested cleaners,
 * such as "TypeError: Expected a string at .array[0].some.property".
 * To build this information, each cleaner along the path
 * should add its own location information as the stack unwinds.
 *
 * If the error has a `insertStepAt` property, that is the character offset
 * where the next step will go in the error message. Otherwise,
 * the next step just goes on the end of the string with the word "at".
 */

function locateError(error, step, offset) {
  if (error instanceof Error) {
    if (error.insertStepAt == null) {
      error.message += ' at ';
      error.insertStepAt = error.message.length;
    }

    error.message = error.message.slice(0, error.insertStepAt) + step + error.message.slice(error.insertStepAt);
    error.insertStepAt += offset;
  }

  return error;
}

exports.asArray = asArray;
exports.asBoolean = asBoolean;
exports.asCodec = asCodec;
exports.asDate = asDate;
exports.asEither = asEither;
exports.asJSON = asJSON;
exports.asMap = asMap;
exports.asMaybe = asMaybe;
exports.asNone = asNone;
exports.asNull = asNull;
exports.asNumber = asNumber;
exports.asObject = asObject;
exports.asOptional = asOptional;
exports.asString = asString;
exports.asUndefined = asUndefined;
exports.asUnknown = asUnknown;
exports.asValue = asValue;
exports.uncleaner = uncleaner;

/***/ }),

/***/ "./node_modules/edge-core-js/types.js":
/*!********************************************!*\
  !*** ./node_modules/edge-core-js/types.js ***!
  \********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

(function (e, a) {
  for (var i in a) {
    e[i] = a[i];
  }
})(exports,
/******/
function (modules) {
  // webpackBootstrap

  /******/
  // The module cache

  /******/
  var installedModules = {};
  /******/

  /******/
  // The require function

  /******/

  function __nested_webpack_require_644__(moduleId) {
    /******/

    /******/
    // Check if module is in cache

    /******/
    if (installedModules[moduleId]) {
      /******/
      return installedModules[moduleId].exports;
      /******/
    }
    /******/
    // Create a new module (and put it into the cache)

    /******/


    var module = installedModules[moduleId] = {
      /******/
      i: moduleId,

      /******/
      l: false,

      /******/
      exports: {}
      /******/

    };
    /******/

    /******/
    // Execute the module function

    /******/

    modules[moduleId].call(module.exports, module, module.exports, __nested_webpack_require_644__);
    /******/

    /******/
    // Flag the module as loaded

    /******/

    module.l = true;
    /******/

    /******/
    // Return the exports of the module

    /******/

    return module.exports;
    /******/
  }
  /******/

  /******/

  /******/
  // expose the modules object (__webpack_modules__)

  /******/


  __nested_webpack_require_644__.m = modules;
  /******/

  /******/
  // expose the module cache

  /******/

  __nested_webpack_require_644__.c = installedModules;
  /******/

  /******/
  // define getter function for harmony exports

  /******/

  __nested_webpack_require_644__.d = function (exports, name, getter) {
    /******/
    if (!__nested_webpack_require_644__.o(exports, name)) {
      /******/
      Object.defineProperty(exports, name, {
        enumerable: true,
        get: getter
      });
      /******/
    }
    /******/

  };
  /******/

  /******/
  // define __esModule on exports

  /******/


  __nested_webpack_require_644__.r = function (exports) {
    /******/
    if (typeof Symbol !== 'undefined' && Symbol.toStringTag) {
      /******/
      Object.defineProperty(exports, Symbol.toStringTag, {
        value: 'Module'
      });
      /******/
    }
    /******/


    Object.defineProperty(exports, '__esModule', {
      value: true
    });
    /******/
  };
  /******/

  /******/
  // create a fake namespace object

  /******/
  // mode & 1: value is a module id, require it

  /******/
  // mode & 2: merge all properties of value into the ns

  /******/
  // mode & 4: return value when already ns object

  /******/
  // mode & 8|1: behave like require

  /******/


  __nested_webpack_require_644__.t = function (value, mode) {
    /******/
    if (mode & 1) value = __nested_webpack_require_644__(value);
    /******/

    if (mode & 8) return value;
    /******/

    if (mode & 4 && _typeof(value) === 'object' && value && value.__esModule) return value;
    /******/

    var ns = Object.create(null);
    /******/

    __nested_webpack_require_644__.r(ns);
    /******/


    Object.defineProperty(ns, 'default', {
      enumerable: true,
      value: value
    });
    /******/

    if (mode & 2 && typeof value != 'string') for (var key in value) {
      __nested_webpack_require_644__.d(ns, key, function (key) {
        return value[key];
      }.bind(null, key));
    }
    /******/

    return ns;
    /******/
  };
  /******/

  /******/
  // getDefaultExport function for compatibility with non-harmony modules

  /******/


  __nested_webpack_require_644__.n = function (module) {
    /******/
    var getter = module && module.__esModule ?
    /******/
    function getDefault() {
      return module['default'];
    } :
    /******/
    function getModuleExports() {
      return module;
    };
    /******/

    __nested_webpack_require_644__.d(getter, 'a', getter);
    /******/


    return getter;
    /******/
  };
  /******/

  /******/
  // Object.prototype.hasOwnProperty.call

  /******/


  __nested_webpack_require_644__.o = function (object, property) {
    return Object.prototype.hasOwnProperty.call(object, property);
  };
  /******/

  /******/
  // __webpack_public_path__

  /******/


  __nested_webpack_require_644__.p = "";
  /******/

  /******/

  /******/
  // Load entry module and return exports

  /******/

  return __nested_webpack_require_644__(__nested_webpack_require_644__.s = 2);
  /******/
}(
/************************************************************************/

/******/
[
/* 0 */

/***/
function (module, exports) {
  module.exports = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.js");
  /***/
},
/* 1 */

/***/
function (module, exports) {
  module.exports = __webpack_require__(/*! rfc4648 */ "./node_modules/rfc4648/lib/index.js");
  /***/
},
/* 2 */

/***/
function (module, __webpack_exports__, __nested_webpack_require_4881__) {
  "use strict"; // ESM COMPAT FLAG

  __nested_webpack_require_4881__.r(__webpack_exports__); // EXPORTS


  __nested_webpack_require_4881__.d(__webpack_exports__, "errorNames", function () {
    return (
      /* reexport */
      errorNames
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "DustSpendError", function () {
    return (
      /* reexport */
      DustSpendError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "InsufficientFundsError", function () {
    return (
      /* reexport */
      InsufficientFundsError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "NetworkError", function () {
    return (
      /* reexport */
      NetworkError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "NoAmountSpecifiedError", function () {
    return (
      /* reexport */
      NoAmountSpecifiedError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "ObsoleteApiError", function () {
    return (
      /* reexport */
      ObsoleteApiError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "OtpError", function () {
    return (
      /* reexport */
      OtpError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "PasswordError", function () {
    return (
      /* reexport */
      PasswordError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "PendingFundsError", function () {
    return (
      /* reexport */
      PendingFundsError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "SameCurrencyError", function () {
    return (
      /* reexport */
      SameCurrencyError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "SpendToSelfError", function () {
    return (
      /* reexport */
      SpendToSelfError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "SwapAboveLimitError", function () {
    return (
      /* reexport */
      SwapAboveLimitError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "SwapBelowLimitError", function () {
    return (
      /* reexport */
      SwapBelowLimitError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "SwapCurrencyError", function () {
    return (
      /* reexport */
      SwapCurrencyError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "SwapPermissionError", function () {
    return (
      /* reexport */
      SwapPermissionError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "UsernameError", function () {
    return (
      /* reexport */
      UsernameError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeDustSpendError", function () {
    return (
      /* reexport */
      asMaybeDustSpendError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeInsufficientFundsError", function () {
    return (
      /* reexport */
      asMaybeInsufficientFundsError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeNetworkError", function () {
    return (
      /* reexport */
      asMaybeNetworkError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeNoAmountSpecifiedError", function () {
    return (
      /* reexport */
      asMaybeNoAmountSpecifiedError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeObsoleteApiError", function () {
    return (
      /* reexport */
      asMaybeObsoleteApiError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeOtpError", function () {
    return (
      /* reexport */
      asMaybeOtpError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybePasswordError", function () {
    return (
      /* reexport */
      asMaybePasswordError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybePendingFundsError", function () {
    return (
      /* reexport */
      asMaybePendingFundsError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeSameCurrencyError", function () {
    return (
      /* reexport */
      asMaybeSameCurrencyError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeSpendToSelfError", function () {
    return (
      /* reexport */
      asMaybeSpendToSelfError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeSwapAboveLimitError", function () {
    return (
      /* reexport */
      asMaybeSwapAboveLimitError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeSwapBelowLimitError", function () {
    return (
      /* reexport */
      asMaybeSwapBelowLimitError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeSwapCurrencyError", function () {
    return (
      /* reexport */
      asMaybeSwapCurrencyError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeSwapPermissionError", function () {
    return (
      /* reexport */
      asMaybeSwapPermissionError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeUsernameError", function () {
    return (
      /* reexport */
      asMaybeUsernameError
    );
  }); // EXTERNAL MODULE: external "rfc4648"


  var external_rfc4648_ = __nested_webpack_require_4881__(1); // EXTERNAL MODULE: external "cleaners"


  var external_cleaners_ = __nested_webpack_require_4881__(0); // CONCATENATED MODULE: ./src/types/server-cleaners.js

  /**
   * A string of base64-encoded binary data.
   */


  var asBase64 = Object(external_cleaners_["asCodec"])(function (raw) {
    return external_rfc4648_["base64"].parse(Object(external_cleaners_["asString"])(raw));
  }, function (clean) {
    return external_rfc4648_["base64"].stringify(clean);
  }); // ---------------------------------------------------------------------
  // public Edge types
  // ---------------------------------------------------------------------

  var asEdgePendingVoucher = Object(external_cleaners_["asObject"])({
    voucherId: external_cleaners_["asString"],
    activates: external_cleaners_["asDate"],
    created: external_cleaners_["asDate"],
    ip: external_cleaners_["asString"],
    ipDescription: external_cleaners_["asString"],
    deviceDescription: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"])
  });
  var asEdgeLoginMessage = Object(external_cleaners_["asObject"])({
    loginId: external_cleaners_["asString"],
    otpResetPending: Object(external_cleaners_["asOptional"])(external_cleaners_["asBoolean"], false),
    pendingVouchers: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(asEdgePendingVoucher), []),
    recovery2Corrupt: Object(external_cleaners_["asOptional"])(external_cleaners_["asBoolean"], false)
  });
  var asEdgeRecoveryQuestionChoice = Object(external_cleaners_["asObject"])({
    min_length: external_cleaners_["asNumber"],
    category: function category(raw) {
      var clean = Object(external_cleaners_["asString"])(raw);

      switch (clean) {
        case 'address':
        case 'must':
        case 'numeric':
        case 'recovery2':
        case 'string':
          return clean;
      }

      throw new TypeError('Invalid question category');
    },
    question: external_cleaners_["asString"]
  }); // ---------------------------------------------------------------------
  // internal Edge types
  // ---------------------------------------------------------------------

  var asEdgeBox = Object(external_cleaners_["asObject"])({
    encryptionType: external_cleaners_["asNumber"],
    data_base64: external_cleaners_["asString"],
    iv_hex: external_cleaners_["asString"]
  });
  var asEdgeSnrp = Object(external_cleaners_["asObject"])({
    salt_hex: external_cleaners_["asString"],
    n: external_cleaners_["asNumber"],
    r: external_cleaners_["asNumber"],
    p: external_cleaners_["asNumber"]
  });
  var asEdgeLobbyRequest = Object(external_cleaners_["asObject"])({
    publicKey: external_cleaners_["asString"],
    loginRequest: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asObject"])({
      appId: external_cleaners_["asString"]
    }).withRest),
    timeout: Object(external_cleaners_["asOptional"])(external_cleaners_["asNumber"])
  }).withRest;
  var asEdgeLobbyReply = Object(external_cleaners_["asObject"])({
    publicKey: external_cleaners_["asString"],
    box: asEdgeBox
  });
  /**
   * An array of base64-encoded hashed recovery answers.
   */

  var asRecovery2Auth = Object(external_cleaners_["asArray"])(asBase64); // ---------------------------------------------------------------------
  // top-level request & response bodies
  // ---------------------------------------------------------------------

  var asLoginRequestBody = Object(external_cleaners_["asObject"])({
    // The request payload:
    data: external_cleaners_["asUnknown"],
    // Common fields for all login methods:
    deviceDescription: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    otp: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    voucherId: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    voucherAuth: Object(external_cleaners_["asOptional"])(asBase64),
    // Secret-key login:
    loginId: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    loginAuth: Object(external_cleaners_["asOptional"])(asBase64),
    // Password login:
    userId: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    passwordAuth: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    // PIN login:
    pin2Id: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    pin2Auth: Object(external_cleaners_["asOptional"])(asBase64),
    // Recovery login:
    recovery2Id: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    recovery2Auth: Object(external_cleaners_["asOptional"])(asRecovery2Auth),
    // Messages:
    loginIds: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(external_cleaners_["asString"])),
    // OTP reset:
    otpResetAuth: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    // Legacy:
    did: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    l1: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    lp1: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    lpin1: Object(external_cleaners_["asOptional"])(asBase64),
    lra1: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    recoveryAuth: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]) // lra1

  });
  var asLoginResponseBody = Object(external_cleaners_["asObject"])({
    // The response payload:
    results: Object(external_cleaners_["asOptional"])(external_cleaners_["asUnknown"]),
    // What type of response is this (success or failure)?:
    status_code: external_cleaners_["asNumber"],
    message: external_cleaners_["asString"]
  }); // ---------------------------------------------------------------------
  // request payloads
  // ---------------------------------------------------------------------

  var asChangeOtpPayload = Object(external_cleaners_["asObject"])({
    otpTimeout: Object(external_cleaners_["asOptional"])(external_cleaners_["asNumber"], 7 * 24 * 60 * 60),
    // seconds
    otpKey: external_cleaners_["asString"]
  });
  var asChangePasswordPayload = Object(external_cleaners_["asObject"])({
    passwordAuth: external_cleaners_["asString"],
    passwordAuthBox: asEdgeBox,
    passwordAuthSnrp: asEdgeSnrp,
    passwordBox: asEdgeBox,
    passwordKeySnrp: asEdgeSnrp
  });
  var asChangePin2Payload = Object(external_cleaners_["asObject"])({
    pin2Id: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    pin2Auth: Object(external_cleaners_["asOptional"])(asBase64),
    pin2Box: Object(external_cleaners_["asOptional"])(asEdgeBox),
    pin2KeyBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    pin2TextBox: asEdgeBox
  });
  var asChangeRecovery2Payload = Object(external_cleaners_["asObject"])({
    recovery2Id: external_cleaners_["asString"],
    recovery2Auth: asRecovery2Auth,
    recovery2Box: asEdgeBox,
    recovery2KeyBox: asEdgeBox,
    question2Box: asEdgeBox
  });
  var asChangeSecretPayload = Object(external_cleaners_["asObject"])({
    loginAuthBox: asEdgeBox,
    loginAuth: asBase64
  });
  var asChangeVouchersPayload = Object(external_cleaners_["asObject"])({
    approvedVouchers: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(external_cleaners_["asString"])),
    rejectedVouchers: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(external_cleaners_["asString"]))
  });
  var asCreateKeysPayload = Object(external_cleaners_["asObject"])({
    keyBoxes: Object(external_cleaners_["asArray"])(asEdgeBox),
    newSyncKeys: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(external_cleaners_["asString"]), [])
  });
  var asCreateLoginPayload = Object(external_cleaners_["asObject"])({
    appId: external_cleaners_["asString"],
    loginId: external_cleaners_["asString"],
    // base64
    parentBox: Object(external_cleaners_["asOptional"])(asEdgeBox)
  }).withRest; // ---------------------------------------------------------------------
  // response payloads
  // ---------------------------------------------------------------------

  var asLobbyPayload = Object(external_cleaners_["asObject"])({
    request: asEdgeLobbyRequest,
    replies: Object(external_cleaners_["asArray"])(asEdgeLobbyReply)
  });
  var asLoginPayload = Object(external_cleaners_["asObject"])({
    // Identity:
    appId: external_cleaners_["asString"],
    created: Object(external_cleaners_["asOptional"])(external_cleaners_["asDate"]),
    loginId: external_cleaners_["asString"],
    // Nested logins:
    children: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(function (raw) {
      return asLoginPayload(raw);
    })),
    parentBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    // 2-factor login:
    otpKey: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    otpResetDate: Object(external_cleaners_["asOptional"])(external_cleaners_["asDate"]),
    otpTimeout: Object(external_cleaners_["asOptional"])(external_cleaners_["asNumber"]),
    // Password login:
    passwordAuthBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    passwordAuthSnrp: Object(external_cleaners_["asOptional"])(asEdgeSnrp),
    passwordBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    passwordKeySnrp: Object(external_cleaners_["asOptional"])(asEdgeSnrp),
    // PIN v2 login:
    pin2Box: Object(external_cleaners_["asOptional"])(asEdgeBox),
    pin2KeyBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    pin2TextBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    // Recovery v2 login:
    question2Box: Object(external_cleaners_["asOptional"])(asEdgeBox),
    recovery2Box: Object(external_cleaners_["asOptional"])(asEdgeBox),
    recovery2KeyBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    // Secret-key login:
    loginAuthBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    // Voucher login:
    pendingVouchers: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(asEdgePendingVoucher), []),
    // Resources:
    keyBoxes: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(asEdgeBox)),
    mnemonicBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    rootKeyBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    syncKeyBox: Object(external_cleaners_["asOptional"])(asEdgeBox)
  });
  var asMessagesPayload = Object(external_cleaners_["asArray"])(asEdgeLoginMessage);
  var asOtpErrorPayload = Object(external_cleaners_["asObject"])({
    login_id: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    otp_reset_auth: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    otp_timeout_date: Object(external_cleaners_["asOptional"])(external_cleaners_["asDate"]),
    reason: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    voucher_activates: Object(external_cleaners_["asOptional"])(external_cleaners_["asDate"]),
    voucher_auth: Object(external_cleaners_["asOptional"])(asBase64),
    voucher_id: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"])
  });
  var asOtpResetPayload = Object(external_cleaners_["asObject"])({
    otpResetDate: external_cleaners_["asDate"]
  });
  var asPasswordErrorPayload = Object(external_cleaners_["asObject"])({
    wait_seconds: Object(external_cleaners_["asOptional"])(external_cleaners_["asNumber"])
  });
  var asQuestionChoicesPayload = Object(external_cleaners_["asArray"])(asEdgeRecoveryQuestionChoice);
  var asRecovery2InfoPayload = Object(external_cleaners_["asObject"])({
    question2Box: asEdgeBox
  });
  var asUsernameInfoPayload = Object(external_cleaners_["asObject"])({
    // Password login:
    passwordAuthSnrp: Object(external_cleaners_["asOptional"])(asEdgeSnrp),
    // Recovery v1 login:
    questionBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    questionKeySnrp: Object(external_cleaners_["asOptional"])(asEdgeSnrp),
    recoveryAuthSnrp: Object(external_cleaners_["asOptional"])(asEdgeSnrp)
  }); // CONCATENATED MODULE: ./src/types/error.js

  /*
   * These are errors the core knows about.
   *
   * The GUI should handle these errors in an "intelligent" way, such as by
   * displaying a localized error message or asking the user for more info.
   * All these errors have a `name` field, which the GUI can use to select
   * the appropriate response.
   *
   * Other errors are possible, of course, since the Javascript language
   * itself can generate exceptions. Those errors won't have a `type` field,
   * and the GUI should just show them with a stack trace & generic message,
   * since the program has basically crashed at that point.
   */

  var errorNames = {
    DustSpendError: 'DustSpendError',
    InsufficientFundsError: 'InsufficientFundsError',
    NetworkError: 'NetworkError',
    NoAmountSpecifiedError: 'NoAmountSpecifiedError',
    ObsoleteApiError: 'ObsoleteApiError',
    OtpError: 'OtpError',
    PasswordError: 'PasswordError',
    PendingFundsError: 'PendingFundsError',
    SameCurrencyError: 'SameCurrencyError',
    SpendToSelfError: 'SpendToSelfError',
    SwapAboveLimitError: 'SwapAboveLimitError',
    SwapBelowLimitError: 'SwapBelowLimitError',
    SwapCurrencyError: 'SwapCurrencyError',
    SwapPermissionError: 'SwapPermissionError',
    UsernameError: 'UsernameError'
  };
  /**
   * Trying to spend an uneconomically small amount of money.
   */

  function DustSpendError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Please send a larger amount';
    if (!(this instanceof DustSpendError)) throw new TypeError("Class constructor DustSpendError cannot be invoked without 'new'");

    var _this;

    function _super(message) {
      _this = new Error(message);
      Object.defineProperty(_this, "constructor", {
        value: DustSpendError,
        configurable: true,
        writable: true
      });
      return _this;
    }

    _super(message);

    _this.name = 'DustSpendError';
    return _this;
  }
  /**
   * Trying to spend more money than the wallet contains.
   */


  function InsufficientFundsError(currencyCode) {
    if (!(this instanceof InsufficientFundsError)) throw new TypeError("Class constructor InsufficientFundsError cannot be invoked without 'new'");

    var _this2;

    function _super2(message) {
      _this2 = new Error(message);
      Object.defineProperty(_this2, "constructor", {
        value: InsufficientFundsError,
        configurable: true,
        writable: true
      });
      return _this2;
    }

    var message;

    if (currencyCode == null) {
      message = 'Insufficient funds';
    } else if (currencyCode.length > 5) {
      // Some plugins pass a message instead of a currency code:
      message = currencyCode;
      currencyCode = undefined;
    } else {
      message = "Insufficient ".concat(currencyCode);
    }

    _super2(message);

    _this2.name = 'InsufficientFundsError';
    if (currencyCode != null) _this2.currencyCode = currencyCode;
    return _this2;
  }
  /**
   * Could not reach the server at all.
   */


  function NetworkError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Cannot reach the network';
    if (!(this instanceof NetworkError)) throw new TypeError("Class constructor NetworkError cannot be invoked without 'new'");

    var _this3;

    function _super3(message) {
      _this3 = new Error(message);
      Object.defineProperty(_this3, "constructor", {
        value: NetworkError,
        configurable: true,
        writable: true
      });
      return _this3;
    }

    _super3(message);

    _this3.name = _this3.type = 'NetworkError';
    return _this3;
  }
  /**
   * Attempting to create a MakeSpend without specifying an amount of currency to send
   */


  function NoAmountSpecifiedError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Unable to create zero-amount transaction.';
    if (!(this instanceof NoAmountSpecifiedError)) throw new TypeError("Class constructor NoAmountSpecifiedError cannot be invoked without 'new'");

    var _this4;

    function _super4(message) {
      _this4 = new Error(message);
      Object.defineProperty(_this4, "constructor", {
        value: NoAmountSpecifiedError,
        configurable: true,
        writable: true
      });
      return _this4;
    }

    _super4(message);

    _this4.name = 'NoAmountSpecifiedError';
    return _this4;
  }
  /**
   * The endpoint on the server is obsolete, and the app needs to be upgraded.
   */


  function ObsoleteApiError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'The application is too old. Please upgrade.';
    if (!(this instanceof ObsoleteApiError)) throw new TypeError("Class constructor ObsoleteApiError cannot be invoked without 'new'");

    var _this5;

    function _super5(message) {
      _this5 = new Error(message);
      Object.defineProperty(_this5, "constructor", {
        value: ObsoleteApiError,
        configurable: true,
        writable: true
      });
      return _this5;
    }

    _super5(message);

    _this5.name = _this5.type = 'ObsoleteApiError';
    return _this5;
  }
  /**
   * The OTP token was missing / incorrect.
   *
   * The error object should include a `resetToken` member,
   * which can be used to reset OTP protection on the account.
   *
   * The error object may include a `resetDate` member,
   * which indicates that an OTP reset is already pending,
   * and when it will complete.
   */


  function OtpError(resultsJson) {
    var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Invalid OTP token';
    if (!(this instanceof OtpError)) throw new TypeError("Class constructor OtpError cannot be invoked without 'new'");

    var _this6;

    function _super6(message) {
      _this6 = new Error(message);
      Object.defineProperty(_this6, "constructor", {
        value: OtpError,
        configurable: true,
        writable: true
      });
      return _this6;
    }

    _super6(message);

    _this6.name = _this6.type = 'OtpError';
    _this6.reason = 'otp';

    try {
      var clean = asOtpErrorPayload(resultsJson); // This should usually be present:

      if (clean.login_id != null) {
        _this6.loginId = clean.login_id;
      } // Use this to request an OTP reset (if enabled):


      if (clean.otp_reset_auth != null) {
        _this6.resetToken = clean.otp_reset_auth;
      } // We might also get a different reason:


      if (clean.reason === 'ip') _this6.reason = 'ip'; // Set if an OTP reset has already been requested:

      if (clean.otp_timeout_date != null) {
        _this6.resetDate = new Date(clean.otp_timeout_date);
      } // We might also get a login voucher:


      if (clean.voucher_activates != null) {
        _this6.voucherActivates = clean.voucher_activates;
      }

      if (clean.voucher_auth != null) {
        _this6.voucherAuth = external_rfc4648_["base64"].stringify(clean.voucher_auth);
      }

      if (clean.voucher_id != null) _this6.voucherId = clean.voucher_id;
    } catch (e) {}

    return _this6;
  }
  /**
   * The provided authentication is incorrect.
   *
   * Reasons could include:
   * - Password login: wrong password
   * - PIN login: wrong PIN
   * - Recovery login: wrong answers
   *
   * The error object may include a `wait` member,
   * which is the number of seconds the user must wait before trying again.
   */


  function PasswordError(resultsJson) {
    var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Invalid password';
    if (!(this instanceof PasswordError)) throw new TypeError("Class constructor PasswordError cannot be invoked without 'new'");

    var _this7;

    function _super7(message) {
      _this7 = new Error(message);
      Object.defineProperty(_this7, "constructor", {
        value: PasswordError,
        configurable: true,
        writable: true
      });
      return _this7;
    }

    _super7(message);

    _this7.name = _this7.type = 'PasswordError';

    try {
      var clean = asPasswordErrorPayload(resultsJson);
      _this7.wait = clean.wait_seconds;
    } catch (e) {}

    return _this7;
  }
  /**
   * Trying to spend funds that are not yet confirmed.
   */


  function PendingFundsError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Not enough confirmed funds';
    if (!(this instanceof PendingFundsError)) throw new TypeError("Class constructor PendingFundsError cannot be invoked without 'new'");

    var _this8;

    function _super8(message) {
      _this8 = new Error(message);
      Object.defineProperty(_this8, "constructor", {
        value: PendingFundsError,
        configurable: true,
        writable: true
      });
      return _this8;
    }

    _super8(message);

    _this8.name = 'PendingFundsError';
    return _this8;
  }
  /**
   * Attempting to shape shift between two wallets of same currency.
   */


  function SameCurrencyError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Wallets can not be the same currency';
    if (!(this instanceof SameCurrencyError)) throw new TypeError("Class constructor SameCurrencyError cannot be invoked without 'new'");

    var _this9;

    function _super9(message) {
      _this9 = new Error(message);
      Object.defineProperty(_this9, "constructor", {
        value: SameCurrencyError,
        configurable: true,
        writable: true
      });
      return _this9;
    }

    _super9(message);

    _this9.name = 'SameCurrencyError';
    return _this9;
  }
  /**
   * Trying to spend to an address of the source wallet
   */


  function SpendToSelfError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Spending to self';
    if (!(this instanceof SpendToSelfError)) throw new TypeError("Class constructor SpendToSelfError cannot be invoked without 'new'");

    var _this10;

    function _super10(message) {
      _this10 = new Error(message);
      Object.defineProperty(_this10, "constructor", {
        value: SpendToSelfError,
        configurable: true,
        writable: true
      });
      return _this10;
    }

    _super10(message);

    _this10.name = 'SpendToSelfError';
    return _this10;
  }
  /**
   * Trying to swap an amount that is either too low or too high.
   * @param nativeMax the maximum supported amount, in the "from" currency.
   */


  function SwapAboveLimitError(swapInfo, nativeMax) {
    if (!(this instanceof SwapAboveLimitError)) throw new TypeError("Class constructor SwapAboveLimitError cannot be invoked without 'new'");

    var _this11;

    function _super11(message) {
      _this11 = new Error(message);
      Object.defineProperty(_this11, "constructor", {
        value: SwapAboveLimitError,
        configurable: true,
        writable: true
      });
      return _this11;
    }

    _super11('Amount is too high');

    _this11.name = 'SwapAboveLimitError';
    _this11.pluginId = swapInfo.pluginId;
    _this11.nativeMax = nativeMax;
    return _this11;
  }
  /**
   * Trying to swap an amount that is either too low or too high.
   * @param nativeMin the minimum supported amount, in the "from" currency.
   */


  function SwapBelowLimitError(swapInfo, nativeMin) {
    if (!(this instanceof SwapBelowLimitError)) throw new TypeError("Class constructor SwapBelowLimitError cannot be invoked without 'new'");

    var _this12;

    function _super12(message) {
      _this12 = new Error(message);
      Object.defineProperty(_this12, "constructor", {
        value: SwapBelowLimitError,
        configurable: true,
        writable: true
      });
      return _this12;
    }

    _super12('Amount is too low');

    _this12.name = 'SwapBelowLimitError';
    _this12.pluginId = swapInfo.pluginId;
    _this12.nativeMin = nativeMin;
    return _this12;
  }
  /**
   * The swap plugin does not support this currency pair.
   */


  function SwapCurrencyError(swapInfo, fromCurrency, toCurrency) {
    if (!(this instanceof SwapCurrencyError)) throw new TypeError("Class constructor SwapCurrencyError cannot be invoked without 'new'");

    var _this13;

    function _super13(message) {
      _this13 = new Error(message);
      Object.defineProperty(_this13, "constructor", {
        value: SwapCurrencyError,
        configurable: true,
        writable: true
      });
      return _this13;
    }

    _super13("".concat(swapInfo.displayName, " does not support ").concat(fromCurrency, " to ").concat(toCurrency));

    _this13.name = 'SwapCurrencyError';
    _this13.pluginId = swapInfo.pluginId;
    _this13.fromCurrency = fromCurrency;
    _this13.toCurrency = toCurrency;
    return _this13;
  }
  /**
   * The user is not allowed to swap these coins for some reason
   * (no KYC, restricted IP address, etc...).
   * @param reason A string giving the reason for the denial.
   * - 'geoRestriction': The IP address is in a restricted region
   * - 'noVerification': The user needs to provide KYC credentials
   * - 'needsActivation': The user needs to log into the service.
   */


  function SwapPermissionError(swapInfo, reason) {
    if (!(this instanceof SwapPermissionError)) throw new TypeError("Class constructor SwapPermissionError cannot be invoked without 'new'");

    var _this14;

    function _super14(message) {
      _this14 = new Error(message);
      Object.defineProperty(_this14, "constructor", {
        value: SwapPermissionError,
        configurable: true,
        writable: true
      });
      return _this14;
    }

    if (reason != null) _super14(reason);else _super14('You are not allowed to make this trade');
    _this14.name = 'SwapPermissionError';
    _this14.pluginId = swapInfo.pluginId;
    _this14.reason = reason;
    return _this14;
  }
  /**
   * Cannot find a login with that id.
   *
   * Reasons could include:
   * - Password login: wrong username
   * - PIN login: wrong PIN key
   * - Recovery login: wrong username, or wrong recovery key
   */


  function UsernameError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Invalid username';
    if (!(this instanceof UsernameError)) throw new TypeError("Class constructor UsernameError cannot be invoked without 'new'");

    var _this15;

    function _super15(message) {
      _this15 = new Error(message);
      Object.defineProperty(_this15, "constructor", {
        value: UsernameError,
        configurable: true,
        writable: true
      });
      return _this15;
    }

    _super15(message);

    _this15.name = _this15.type = 'UsernameError';
    return _this15;
  }

  function asMaybeError(name) {
    return function asError(raw) {
      if (raw instanceof Error && raw.name === name) {
        var typeHack = raw;
        return typeHack;
      }
    };
  }

  var asMaybeDustSpendError = asMaybeError('DustSpendError');
  var asMaybeInsufficientFundsError = asMaybeError('InsufficientFundsError');
  var asMaybeNetworkError = asMaybeError('NetworkError');
  var asMaybeNoAmountSpecifiedError = asMaybeError('NoAmountSpecifiedError');
  var asMaybeObsoleteApiError = asMaybeError('ObsoleteApiError');
  var asMaybeOtpError = asMaybeError('OtpError');
  var asMaybePasswordError = asMaybeError('PasswordError');
  var asMaybePendingFundsError = asMaybeError('PendingFundsError');
  var asMaybeSameCurrencyError = asMaybeError('SameCurrencyError');
  var asMaybeSpendToSelfError = asMaybeError('SpendToSelfError');
  var asMaybeSwapAboveLimitError = asMaybeError('SwapAboveLimitError');
  var asMaybeSwapBelowLimitError = asMaybeError('SwapBelowLimitError');
  var asMaybeSwapCurrencyError = asMaybeError('SwapCurrencyError');
  var asMaybeSwapPermissionError = asMaybeError('SwapPermissionError');
  var asMaybeUsernameError = asMaybeError('UsernameError'); // CONCATENATED MODULE: ./src/types/types.js
  // ---------------------------------------------------------------------
  // helper types
  // ---------------------------------------------------------------------

  /** A JSON object (as opposed to an array or primitive). */

  /***/
}
/******/
]));

/***/ }),

/***/ "./node_modules/hash.js/lib/hash.js":
/*!******************************************!*\
  !*** ./node_modules/hash.js/lib/hash.js ***!
  \******************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

var hash = exports;
hash.utils = __webpack_require__(/*! ./hash/utils */ "./node_modules/hash.js/lib/hash/utils.js");
hash.common = __webpack_require__(/*! ./hash/common */ "./node_modules/hash.js/lib/hash/common.js");
hash.sha = __webpack_require__(/*! ./hash/sha */ "./node_modules/hash.js/lib/hash/sha.js");
hash.ripemd = __webpack_require__(/*! ./hash/ripemd */ "./node_modules/hash.js/lib/hash/ripemd.js");
hash.hmac = __webpack_require__(/*! ./hash/hmac */ "./node_modules/hash.js/lib/hash/hmac.js"); // Proxy hash functions to the main object

hash.sha1 = hash.sha.sha1;
hash.sha256 = hash.sha.sha256;
hash.sha224 = hash.sha.sha224;
hash.sha384 = hash.sha.sha384;
hash.sha512 = hash.sha.sha512;
hash.ripemd160 = hash.ripemd.ripemd160;

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/common.js":
/*!*************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/common.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./utils */ "./node_modules/hash.js/lib/hash/utils.js");

var assert = __webpack_require__(/*! minimalistic-assert */ "./node_modules/minimalistic-assert/index.js");

function BlockHash() {
  this.pending = null;
  this.pendingTotal = 0;
  this.blockSize = this.constructor.blockSize;
  this.outSize = this.constructor.outSize;
  this.hmacStrength = this.constructor.hmacStrength;
  this.padLength = this.constructor.padLength / 8;
  this.endian = 'big';
  this._delta8 = this.blockSize / 8;
  this._delta32 = this.blockSize / 32;
}

exports.BlockHash = BlockHash;

BlockHash.prototype.update = function update(msg, enc) {
  // Convert message to array, pad it, and join into 32bit blocks
  msg = utils.toArray(msg, enc);
  if (!this.pending) this.pending = msg;else this.pending = this.pending.concat(msg);
  this.pendingTotal += msg.length; // Enough data, try updating

  if (this.pending.length >= this._delta8) {
    msg = this.pending; // Process pending data in blocks

    var r = msg.length % this._delta8;
    this.pending = msg.slice(msg.length - r, msg.length);
    if (this.pending.length === 0) this.pending = null;
    msg = utils.join32(msg, 0, msg.length - r, this.endian);

    for (var i = 0; i < msg.length; i += this._delta32) {
      this._update(msg, i, i + this._delta32);
    }
  }

  return this;
};

BlockHash.prototype.digest = function digest(enc) {
  this.update(this._pad());
  assert(this.pending === null);
  return this._digest(enc);
};

BlockHash.prototype._pad = function pad() {
  var len = this.pendingTotal;
  var bytes = this._delta8;
  var k = bytes - (len + this.padLength) % bytes;
  var res = new Array(k + this.padLength);
  res[0] = 0x80;

  for (var i = 1; i < k; i++) {
    res[i] = 0;
  } // Append length


  len <<= 3;

  if (this.endian === 'big') {
    for (var t = 8; t < this.padLength; t++) {
      res[i++] = 0;
    }

    res[i++] = 0;
    res[i++] = 0;
    res[i++] = 0;
    res[i++] = 0;
    res[i++] = len >>> 24 & 0xff;
    res[i++] = len >>> 16 & 0xff;
    res[i++] = len >>> 8 & 0xff;
    res[i++] = len & 0xff;
  } else {
    res[i++] = len & 0xff;
    res[i++] = len >>> 8 & 0xff;
    res[i++] = len >>> 16 & 0xff;
    res[i++] = len >>> 24 & 0xff;
    res[i++] = 0;
    res[i++] = 0;
    res[i++] = 0;
    res[i++] = 0;

    for (t = 8; t < this.padLength; t++) {
      res[i++] = 0;
    }
  }

  return res;
};

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/hmac.js":
/*!***********************************************!*\
  !*** ./node_modules/hash.js/lib/hash/hmac.js ***!
  \***********************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./utils */ "./node_modules/hash.js/lib/hash/utils.js");

var assert = __webpack_require__(/*! minimalistic-assert */ "./node_modules/minimalistic-assert/index.js");

function Hmac(hash, key, enc) {
  if (!(this instanceof Hmac)) return new Hmac(hash, key, enc);
  this.Hash = hash;
  this.blockSize = hash.blockSize / 8;
  this.outSize = hash.outSize / 8;
  this.inner = null;
  this.outer = null;

  this._init(utils.toArray(key, enc));
}

module.exports = Hmac;

Hmac.prototype._init = function init(key) {
  // Shorten key, if needed
  if (key.length > this.blockSize) key = new this.Hash().update(key).digest();
  assert(key.length <= this.blockSize); // Add padding to key

  for (var i = key.length; i < this.blockSize; i++) {
    key.push(0);
  }

  for (i = 0; i < key.length; i++) {
    key[i] ^= 0x36;
  }

  this.inner = new this.Hash().update(key); // 0x36 ^ 0x5c = 0x6a

  for (i = 0; i < key.length; i++) {
    key[i] ^= 0x6a;
  }

  this.outer = new this.Hash().update(key);
};

Hmac.prototype.update = function update(msg, enc) {
  this.inner.update(msg, enc);
  return this;
};

Hmac.prototype.digest = function digest(enc) {
  this.outer.update(this.inner.digest());
  return this.outer.digest(enc);
};

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/ripemd.js":
/*!*************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/ripemd.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./utils */ "./node_modules/hash.js/lib/hash/utils.js");

var common = __webpack_require__(/*! ./common */ "./node_modules/hash.js/lib/hash/common.js");

var rotl32 = utils.rotl32;
var sum32 = utils.sum32;
var sum32_3 = utils.sum32_3;
var sum32_4 = utils.sum32_4;
var BlockHash = common.BlockHash;

function RIPEMD160() {
  if (!(this instanceof RIPEMD160)) return new RIPEMD160();
  BlockHash.call(this);
  this.h = [0x67452301, 0xefcdab89, 0x98badcfe, 0x10325476, 0xc3d2e1f0];
  this.endian = 'little';
}

utils.inherits(RIPEMD160, BlockHash);
exports.ripemd160 = RIPEMD160;
RIPEMD160.blockSize = 512;
RIPEMD160.outSize = 160;
RIPEMD160.hmacStrength = 192;
RIPEMD160.padLength = 64;

RIPEMD160.prototype._update = function update(msg, start) {
  var A = this.h[0];
  var B = this.h[1];
  var C = this.h[2];
  var D = this.h[3];
  var E = this.h[4];
  var Ah = A;
  var Bh = B;
  var Ch = C;
  var Dh = D;
  var Eh = E;

  for (var j = 0; j < 80; j++) {
    var T = sum32(rotl32(sum32_4(A, f(j, B, C, D), msg[r[j] + start], K(j)), s[j]), E);
    A = E;
    E = D;
    D = rotl32(C, 10);
    C = B;
    B = T;
    T = sum32(rotl32(sum32_4(Ah, f(79 - j, Bh, Ch, Dh), msg[rh[j] + start], Kh(j)), sh[j]), Eh);
    Ah = Eh;
    Eh = Dh;
    Dh = rotl32(Ch, 10);
    Ch = Bh;
    Bh = T;
  }

  T = sum32_3(this.h[1], C, Dh);
  this.h[1] = sum32_3(this.h[2], D, Eh);
  this.h[2] = sum32_3(this.h[3], E, Ah);
  this.h[3] = sum32_3(this.h[4], A, Bh);
  this.h[4] = sum32_3(this.h[0], B, Ch);
  this.h[0] = T;
};

RIPEMD160.prototype._digest = function digest(enc) {
  if (enc === 'hex') return utils.toHex32(this.h, 'little');else return utils.split32(this.h, 'little');
};

function f(j, x, y, z) {
  if (j <= 15) return x ^ y ^ z;else if (j <= 31) return x & y | ~x & z;else if (j <= 47) return (x | ~y) ^ z;else if (j <= 63) return x & z | y & ~z;else return x ^ (y | ~z);
}

function K(j) {
  if (j <= 15) return 0x00000000;else if (j <= 31) return 0x5a827999;else if (j <= 47) return 0x6ed9eba1;else if (j <= 63) return 0x8f1bbcdc;else return 0xa953fd4e;
}

function Kh(j) {
  if (j <= 15) return 0x50a28be6;else if (j <= 31) return 0x5c4dd124;else if (j <= 47) return 0x6d703ef3;else if (j <= 63) return 0x7a6d76e9;else return 0x00000000;
}

var r = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 7, 4, 13, 1, 10, 6, 15, 3, 12, 0, 9, 5, 2, 14, 11, 8, 3, 10, 14, 4, 9, 15, 8, 1, 2, 7, 0, 6, 13, 11, 5, 12, 1, 9, 11, 10, 0, 8, 12, 4, 13, 3, 7, 15, 14, 5, 6, 2, 4, 0, 5, 9, 7, 12, 2, 10, 14, 1, 3, 8, 11, 6, 15, 13];
var rh = [5, 14, 7, 0, 9, 2, 11, 4, 13, 6, 15, 8, 1, 10, 3, 12, 6, 11, 3, 7, 0, 13, 5, 10, 14, 15, 8, 12, 4, 9, 1, 2, 15, 5, 1, 3, 7, 14, 6, 9, 11, 8, 12, 2, 10, 0, 4, 13, 8, 6, 4, 1, 3, 11, 15, 0, 5, 12, 2, 13, 9, 7, 10, 14, 12, 15, 10, 4, 1, 5, 8, 7, 6, 2, 13, 14, 0, 3, 9, 11];
var s = [11, 14, 15, 12, 5, 8, 7, 9, 11, 13, 14, 15, 6, 7, 9, 8, 7, 6, 8, 13, 11, 9, 7, 15, 7, 12, 15, 9, 11, 7, 13, 12, 11, 13, 6, 7, 14, 9, 13, 15, 14, 8, 13, 6, 5, 12, 7, 5, 11, 12, 14, 15, 14, 15, 9, 8, 9, 14, 5, 6, 8, 6, 5, 12, 9, 15, 5, 11, 6, 8, 13, 12, 5, 12, 13, 14, 11, 8, 5, 6];
var sh = [8, 9, 9, 11, 13, 15, 15, 5, 7, 7, 8, 11, 14, 14, 12, 6, 9, 13, 15, 7, 12, 8, 9, 11, 7, 7, 12, 7, 6, 15, 13, 11, 9, 7, 15, 11, 8, 6, 6, 14, 12, 13, 5, 14, 13, 13, 7, 5, 15, 5, 8, 11, 14, 14, 6, 14, 6, 9, 12, 9, 12, 5, 15, 8, 8, 5, 12, 9, 12, 5, 14, 6, 8, 13, 6, 5, 15, 13, 11, 11];

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha.js":
/*!**********************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";


exports.sha1 = __webpack_require__(/*! ./sha/1 */ "./node_modules/hash.js/lib/hash/sha/1.js");
exports.sha224 = __webpack_require__(/*! ./sha/224 */ "./node_modules/hash.js/lib/hash/sha/224.js");
exports.sha256 = __webpack_require__(/*! ./sha/256 */ "./node_modules/hash.js/lib/hash/sha/256.js");
exports.sha384 = __webpack_require__(/*! ./sha/384 */ "./node_modules/hash.js/lib/hash/sha/384.js");
exports.sha512 = __webpack_require__(/*! ./sha/512 */ "./node_modules/hash.js/lib/hash/sha/512.js");

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha/1.js":
/*!************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha/1.js ***!
  \************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/hash.js/lib/hash/utils.js");

var common = __webpack_require__(/*! ../common */ "./node_modules/hash.js/lib/hash/common.js");

var shaCommon = __webpack_require__(/*! ./common */ "./node_modules/hash.js/lib/hash/sha/common.js");

var rotl32 = utils.rotl32;
var sum32 = utils.sum32;
var sum32_5 = utils.sum32_5;
var ft_1 = shaCommon.ft_1;
var BlockHash = common.BlockHash;
var sha1_K = [0x5A827999, 0x6ED9EBA1, 0x8F1BBCDC, 0xCA62C1D6];

function SHA1() {
  if (!(this instanceof SHA1)) return new SHA1();
  BlockHash.call(this);
  this.h = [0x67452301, 0xefcdab89, 0x98badcfe, 0x10325476, 0xc3d2e1f0];
  this.W = new Array(80);
}

utils.inherits(SHA1, BlockHash);
module.exports = SHA1;
SHA1.blockSize = 512;
SHA1.outSize = 160;
SHA1.hmacStrength = 80;
SHA1.padLength = 64;

SHA1.prototype._update = function _update(msg, start) {
  var W = this.W;

  for (var i = 0; i < 16; i++) {
    W[i] = msg[start + i];
  }

  for (; i < W.length; i++) {
    W[i] = rotl32(W[i - 3] ^ W[i - 8] ^ W[i - 14] ^ W[i - 16], 1);
  }

  var a = this.h[0];
  var b = this.h[1];
  var c = this.h[2];
  var d = this.h[3];
  var e = this.h[4];

  for (i = 0; i < W.length; i++) {
    var s = ~~(i / 20);
    var t = sum32_5(rotl32(a, 5), ft_1(s, b, c, d), e, W[i], sha1_K[s]);
    e = d;
    d = c;
    c = rotl32(b, 30);
    b = a;
    a = t;
  }

  this.h[0] = sum32(this.h[0], a);
  this.h[1] = sum32(this.h[1], b);
  this.h[2] = sum32(this.h[2], c);
  this.h[3] = sum32(this.h[3], d);
  this.h[4] = sum32(this.h[4], e);
};

SHA1.prototype._digest = function digest(enc) {
  if (enc === 'hex') return utils.toHex32(this.h, 'big');else return utils.split32(this.h, 'big');
};

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha/224.js":
/*!**************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha/224.js ***!
  \**************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/hash.js/lib/hash/utils.js");

var SHA256 = __webpack_require__(/*! ./256 */ "./node_modules/hash.js/lib/hash/sha/256.js");

function SHA224() {
  if (!(this instanceof SHA224)) return new SHA224();
  SHA256.call(this);
  this.h = [0xc1059ed8, 0x367cd507, 0x3070dd17, 0xf70e5939, 0xffc00b31, 0x68581511, 0x64f98fa7, 0xbefa4fa4];
}

utils.inherits(SHA224, SHA256);
module.exports = SHA224;
SHA224.blockSize = 512;
SHA224.outSize = 224;
SHA224.hmacStrength = 192;
SHA224.padLength = 64;

SHA224.prototype._digest = function digest(enc) {
  // Just truncate output
  if (enc === 'hex') return utils.toHex32(this.h.slice(0, 7), 'big');else return utils.split32(this.h.slice(0, 7), 'big');
};

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha/256.js":
/*!**************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha/256.js ***!
  \**************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/hash.js/lib/hash/utils.js");

var common = __webpack_require__(/*! ../common */ "./node_modules/hash.js/lib/hash/common.js");

var shaCommon = __webpack_require__(/*! ./common */ "./node_modules/hash.js/lib/hash/sha/common.js");

var assert = __webpack_require__(/*! minimalistic-assert */ "./node_modules/minimalistic-assert/index.js");

var sum32 = utils.sum32;
var sum32_4 = utils.sum32_4;
var sum32_5 = utils.sum32_5;
var ch32 = shaCommon.ch32;
var maj32 = shaCommon.maj32;
var s0_256 = shaCommon.s0_256;
var s1_256 = shaCommon.s1_256;
var g0_256 = shaCommon.g0_256;
var g1_256 = shaCommon.g1_256;
var BlockHash = common.BlockHash;
var sha256_K = [0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5, 0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5, 0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3, 0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174, 0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc, 0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da, 0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7, 0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967, 0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13, 0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85, 0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3, 0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070, 0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5, 0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3, 0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208, 0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2];

function SHA256() {
  if (!(this instanceof SHA256)) return new SHA256();
  BlockHash.call(this);
  this.h = [0x6a09e667, 0xbb67ae85, 0x3c6ef372, 0xa54ff53a, 0x510e527f, 0x9b05688c, 0x1f83d9ab, 0x5be0cd19];
  this.k = sha256_K;
  this.W = new Array(64);
}

utils.inherits(SHA256, BlockHash);
module.exports = SHA256;
SHA256.blockSize = 512;
SHA256.outSize = 256;
SHA256.hmacStrength = 192;
SHA256.padLength = 64;

SHA256.prototype._update = function _update(msg, start) {
  var W = this.W;

  for (var i = 0; i < 16; i++) {
    W[i] = msg[start + i];
  }

  for (; i < W.length; i++) {
    W[i] = sum32_4(g1_256(W[i - 2]), W[i - 7], g0_256(W[i - 15]), W[i - 16]);
  }

  var a = this.h[0];
  var b = this.h[1];
  var c = this.h[2];
  var d = this.h[3];
  var e = this.h[4];
  var f = this.h[5];
  var g = this.h[6];
  var h = this.h[7];
  assert(this.k.length === W.length);

  for (i = 0; i < W.length; i++) {
    var T1 = sum32_5(h, s1_256(e), ch32(e, f, g), this.k[i], W[i]);
    var T2 = sum32(s0_256(a), maj32(a, b, c));
    h = g;
    g = f;
    f = e;
    e = sum32(d, T1);
    d = c;
    c = b;
    b = a;
    a = sum32(T1, T2);
  }

  this.h[0] = sum32(this.h[0], a);
  this.h[1] = sum32(this.h[1], b);
  this.h[2] = sum32(this.h[2], c);
  this.h[3] = sum32(this.h[3], d);
  this.h[4] = sum32(this.h[4], e);
  this.h[5] = sum32(this.h[5], f);
  this.h[6] = sum32(this.h[6], g);
  this.h[7] = sum32(this.h[7], h);
};

SHA256.prototype._digest = function digest(enc) {
  if (enc === 'hex') return utils.toHex32(this.h, 'big');else return utils.split32(this.h, 'big');
};

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha/384.js":
/*!**************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha/384.js ***!
  \**************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/hash.js/lib/hash/utils.js");

var SHA512 = __webpack_require__(/*! ./512 */ "./node_modules/hash.js/lib/hash/sha/512.js");

function SHA384() {
  if (!(this instanceof SHA384)) return new SHA384();
  SHA512.call(this);
  this.h = [0xcbbb9d5d, 0xc1059ed8, 0x629a292a, 0x367cd507, 0x9159015a, 0x3070dd17, 0x152fecd8, 0xf70e5939, 0x67332667, 0xffc00b31, 0x8eb44a87, 0x68581511, 0xdb0c2e0d, 0x64f98fa7, 0x47b5481d, 0xbefa4fa4];
}

utils.inherits(SHA384, SHA512);
module.exports = SHA384;
SHA384.blockSize = 1024;
SHA384.outSize = 384;
SHA384.hmacStrength = 192;
SHA384.padLength = 128;

SHA384.prototype._digest = function digest(enc) {
  if (enc === 'hex') return utils.toHex32(this.h.slice(0, 12), 'big');else return utils.split32(this.h.slice(0, 12), 'big');
};

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha/512.js":
/*!**************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha/512.js ***!
  \**************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/hash.js/lib/hash/utils.js");

var common = __webpack_require__(/*! ../common */ "./node_modules/hash.js/lib/hash/common.js");

var assert = __webpack_require__(/*! minimalistic-assert */ "./node_modules/minimalistic-assert/index.js");

var rotr64_hi = utils.rotr64_hi;
var rotr64_lo = utils.rotr64_lo;
var shr64_hi = utils.shr64_hi;
var shr64_lo = utils.shr64_lo;
var sum64 = utils.sum64;
var sum64_hi = utils.sum64_hi;
var sum64_lo = utils.sum64_lo;
var sum64_4_hi = utils.sum64_4_hi;
var sum64_4_lo = utils.sum64_4_lo;
var sum64_5_hi = utils.sum64_5_hi;
var sum64_5_lo = utils.sum64_5_lo;
var BlockHash = common.BlockHash;
var sha512_K = [0x428a2f98, 0xd728ae22, 0x71374491, 0x23ef65cd, 0xb5c0fbcf, 0xec4d3b2f, 0xe9b5dba5, 0x8189dbbc, 0x3956c25b, 0xf348b538, 0x59f111f1, 0xb605d019, 0x923f82a4, 0xaf194f9b, 0xab1c5ed5, 0xda6d8118, 0xd807aa98, 0xa3030242, 0x12835b01, 0x45706fbe, 0x243185be, 0x4ee4b28c, 0x550c7dc3, 0xd5ffb4e2, 0x72be5d74, 0xf27b896f, 0x80deb1fe, 0x3b1696b1, 0x9bdc06a7, 0x25c71235, 0xc19bf174, 0xcf692694, 0xe49b69c1, 0x9ef14ad2, 0xefbe4786, 0x384f25e3, 0x0fc19dc6, 0x8b8cd5b5, 0x240ca1cc, 0x77ac9c65, 0x2de92c6f, 0x592b0275, 0x4a7484aa, 0x6ea6e483, 0x5cb0a9dc, 0xbd41fbd4, 0x76f988da, 0x831153b5, 0x983e5152, 0xee66dfab, 0xa831c66d, 0x2db43210, 0xb00327c8, 0x98fb213f, 0xbf597fc7, 0xbeef0ee4, 0xc6e00bf3, 0x3da88fc2, 0xd5a79147, 0x930aa725, 0x06ca6351, 0xe003826f, 0x14292967, 0x0a0e6e70, 0x27b70a85, 0x46d22ffc, 0x2e1b2138, 0x5c26c926, 0x4d2c6dfc, 0x5ac42aed, 0x53380d13, 0x9d95b3df, 0x650a7354, 0x8baf63de, 0x766a0abb, 0x3c77b2a8, 0x81c2c92e, 0x47edaee6, 0x92722c85, 0x1482353b, 0xa2bfe8a1, 0x4cf10364, 0xa81a664b, 0xbc423001, 0xc24b8b70, 0xd0f89791, 0xc76c51a3, 0x0654be30, 0xd192e819, 0xd6ef5218, 0xd6990624, 0x5565a910, 0xf40e3585, 0x5771202a, 0x106aa070, 0x32bbd1b8, 0x19a4c116, 0xb8d2d0c8, 0x1e376c08, 0x5141ab53, 0x2748774c, 0xdf8eeb99, 0x34b0bcb5, 0xe19b48a8, 0x391c0cb3, 0xc5c95a63, 0x4ed8aa4a, 0xe3418acb, 0x5b9cca4f, 0x7763e373, 0x682e6ff3, 0xd6b2b8a3, 0x748f82ee, 0x5defb2fc, 0x78a5636f, 0x43172f60, 0x84c87814, 0xa1f0ab72, 0x8cc70208, 0x1a6439ec, 0x90befffa, 0x23631e28, 0xa4506ceb, 0xde82bde9, 0xbef9a3f7, 0xb2c67915, 0xc67178f2, 0xe372532b, 0xca273ece, 0xea26619c, 0xd186b8c7, 0x21c0c207, 0xeada7dd6, 0xcde0eb1e, 0xf57d4f7f, 0xee6ed178, 0x06f067aa, 0x72176fba, 0x0a637dc5, 0xa2c898a6, 0x113f9804, 0xbef90dae, 0x1b710b35, 0x131c471b, 0x28db77f5, 0x23047d84, 0x32caab7b, 0x40c72493, 0x3c9ebe0a, 0x15c9bebc, 0x431d67c4, 0x9c100d4c, 0x4cc5d4be, 0xcb3e42b6, 0x597f299c, 0xfc657e2a, 0x5fcb6fab, 0x3ad6faec, 0x6c44198c, 0x4a475817];

function SHA512() {
  if (!(this instanceof SHA512)) return new SHA512();
  BlockHash.call(this);
  this.h = [0x6a09e667, 0xf3bcc908, 0xbb67ae85, 0x84caa73b, 0x3c6ef372, 0xfe94f82b, 0xa54ff53a, 0x5f1d36f1, 0x510e527f, 0xade682d1, 0x9b05688c, 0x2b3e6c1f, 0x1f83d9ab, 0xfb41bd6b, 0x5be0cd19, 0x137e2179];
  this.k = sha512_K;
  this.W = new Array(160);
}

utils.inherits(SHA512, BlockHash);
module.exports = SHA512;
SHA512.blockSize = 1024;
SHA512.outSize = 512;
SHA512.hmacStrength = 192;
SHA512.padLength = 128;

SHA512.prototype._prepareBlock = function _prepareBlock(msg, start) {
  var W = this.W; // 32 x 32bit words

  for (var i = 0; i < 32; i++) {
    W[i] = msg[start + i];
  }

  for (; i < W.length; i += 2) {
    var c0_hi = g1_512_hi(W[i - 4], W[i - 3]); // i - 2

    var c0_lo = g1_512_lo(W[i - 4], W[i - 3]);
    var c1_hi = W[i - 14]; // i - 7

    var c1_lo = W[i - 13];
    var c2_hi = g0_512_hi(W[i - 30], W[i - 29]); // i - 15

    var c2_lo = g0_512_lo(W[i - 30], W[i - 29]);
    var c3_hi = W[i - 32]; // i - 16

    var c3_lo = W[i - 31];
    W[i] = sum64_4_hi(c0_hi, c0_lo, c1_hi, c1_lo, c2_hi, c2_lo, c3_hi, c3_lo);
    W[i + 1] = sum64_4_lo(c0_hi, c0_lo, c1_hi, c1_lo, c2_hi, c2_lo, c3_hi, c3_lo);
  }
};

SHA512.prototype._update = function _update(msg, start) {
  this._prepareBlock(msg, start);

  var W = this.W;
  var ah = this.h[0];
  var al = this.h[1];
  var bh = this.h[2];
  var bl = this.h[3];
  var ch = this.h[4];
  var cl = this.h[5];
  var dh = this.h[6];
  var dl = this.h[7];
  var eh = this.h[8];
  var el = this.h[9];
  var fh = this.h[10];
  var fl = this.h[11];
  var gh = this.h[12];
  var gl = this.h[13];
  var hh = this.h[14];
  var hl = this.h[15];
  assert(this.k.length === W.length);

  for (var i = 0; i < W.length; i += 2) {
    var c0_hi = hh;
    var c0_lo = hl;
    var c1_hi = s1_512_hi(eh, el);
    var c1_lo = s1_512_lo(eh, el);
    var c2_hi = ch64_hi(eh, el, fh, fl, gh, gl);
    var c2_lo = ch64_lo(eh, el, fh, fl, gh, gl);
    var c3_hi = this.k[i];
    var c3_lo = this.k[i + 1];
    var c4_hi = W[i];
    var c4_lo = W[i + 1];
    var T1_hi = sum64_5_hi(c0_hi, c0_lo, c1_hi, c1_lo, c2_hi, c2_lo, c3_hi, c3_lo, c4_hi, c4_lo);
    var T1_lo = sum64_5_lo(c0_hi, c0_lo, c1_hi, c1_lo, c2_hi, c2_lo, c3_hi, c3_lo, c4_hi, c4_lo);
    c0_hi = s0_512_hi(ah, al);
    c0_lo = s0_512_lo(ah, al);
    c1_hi = maj64_hi(ah, al, bh, bl, ch, cl);
    c1_lo = maj64_lo(ah, al, bh, bl, ch, cl);
    var T2_hi = sum64_hi(c0_hi, c0_lo, c1_hi, c1_lo);
    var T2_lo = sum64_lo(c0_hi, c0_lo, c1_hi, c1_lo);
    hh = gh;
    hl = gl;
    gh = fh;
    gl = fl;
    fh = eh;
    fl = el;
    eh = sum64_hi(dh, dl, T1_hi, T1_lo);
    el = sum64_lo(dl, dl, T1_hi, T1_lo);
    dh = ch;
    dl = cl;
    ch = bh;
    cl = bl;
    bh = ah;
    bl = al;
    ah = sum64_hi(T1_hi, T1_lo, T2_hi, T2_lo);
    al = sum64_lo(T1_hi, T1_lo, T2_hi, T2_lo);
  }

  sum64(this.h, 0, ah, al);
  sum64(this.h, 2, bh, bl);
  sum64(this.h, 4, ch, cl);
  sum64(this.h, 6, dh, dl);
  sum64(this.h, 8, eh, el);
  sum64(this.h, 10, fh, fl);
  sum64(this.h, 12, gh, gl);
  sum64(this.h, 14, hh, hl);
};

SHA512.prototype._digest = function digest(enc) {
  if (enc === 'hex') return utils.toHex32(this.h, 'big');else return utils.split32(this.h, 'big');
};

function ch64_hi(xh, xl, yh, yl, zh) {
  var r = xh & yh ^ ~xh & zh;
  if (r < 0) r += 0x100000000;
  return r;
}

function ch64_lo(xh, xl, yh, yl, zh, zl) {
  var r = xl & yl ^ ~xl & zl;
  if (r < 0) r += 0x100000000;
  return r;
}

function maj64_hi(xh, xl, yh, yl, zh) {
  var r = xh & yh ^ xh & zh ^ yh & zh;
  if (r < 0) r += 0x100000000;
  return r;
}

function maj64_lo(xh, xl, yh, yl, zh, zl) {
  var r = xl & yl ^ xl & zl ^ yl & zl;
  if (r < 0) r += 0x100000000;
  return r;
}

function s0_512_hi(xh, xl) {
  var c0_hi = rotr64_hi(xh, xl, 28);
  var c1_hi = rotr64_hi(xl, xh, 2); // 34

  var c2_hi = rotr64_hi(xl, xh, 7); // 39

  var r = c0_hi ^ c1_hi ^ c2_hi;
  if (r < 0) r += 0x100000000;
  return r;
}

function s0_512_lo(xh, xl) {
  var c0_lo = rotr64_lo(xh, xl, 28);
  var c1_lo = rotr64_lo(xl, xh, 2); // 34

  var c2_lo = rotr64_lo(xl, xh, 7); // 39

  var r = c0_lo ^ c1_lo ^ c2_lo;
  if (r < 0) r += 0x100000000;
  return r;
}

function s1_512_hi(xh, xl) {
  var c0_hi = rotr64_hi(xh, xl, 14);
  var c1_hi = rotr64_hi(xh, xl, 18);
  var c2_hi = rotr64_hi(xl, xh, 9); // 41

  var r = c0_hi ^ c1_hi ^ c2_hi;
  if (r < 0) r += 0x100000000;
  return r;
}

function s1_512_lo(xh, xl) {
  var c0_lo = rotr64_lo(xh, xl, 14);
  var c1_lo = rotr64_lo(xh, xl, 18);
  var c2_lo = rotr64_lo(xl, xh, 9); // 41

  var r = c0_lo ^ c1_lo ^ c2_lo;
  if (r < 0) r += 0x100000000;
  return r;
}

function g0_512_hi(xh, xl) {
  var c0_hi = rotr64_hi(xh, xl, 1);
  var c1_hi = rotr64_hi(xh, xl, 8);
  var c2_hi = shr64_hi(xh, xl, 7);
  var r = c0_hi ^ c1_hi ^ c2_hi;
  if (r < 0) r += 0x100000000;
  return r;
}

function g0_512_lo(xh, xl) {
  var c0_lo = rotr64_lo(xh, xl, 1);
  var c1_lo = rotr64_lo(xh, xl, 8);
  var c2_lo = shr64_lo(xh, xl, 7);
  var r = c0_lo ^ c1_lo ^ c2_lo;
  if (r < 0) r += 0x100000000;
  return r;
}

function g1_512_hi(xh, xl) {
  var c0_hi = rotr64_hi(xh, xl, 19);
  var c1_hi = rotr64_hi(xl, xh, 29); // 61

  var c2_hi = shr64_hi(xh, xl, 6);
  var r = c0_hi ^ c1_hi ^ c2_hi;
  if (r < 0) r += 0x100000000;
  return r;
}

function g1_512_lo(xh, xl) {
  var c0_lo = rotr64_lo(xh, xl, 19);
  var c1_lo = rotr64_lo(xl, xh, 29); // 61

  var c2_lo = shr64_lo(xh, xl, 6);
  var r = c0_lo ^ c1_lo ^ c2_lo;
  if (r < 0) r += 0x100000000;
  return r;
}

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha/common.js":
/*!*****************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha/common.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/hash.js/lib/hash/utils.js");

var rotr32 = utils.rotr32;

function ft_1(s, x, y, z) {
  if (s === 0) return ch32(x, y, z);
  if (s === 1 || s === 3) return p32(x, y, z);
  if (s === 2) return maj32(x, y, z);
}

exports.ft_1 = ft_1;

function ch32(x, y, z) {
  return x & y ^ ~x & z;
}

exports.ch32 = ch32;

function maj32(x, y, z) {
  return x & y ^ x & z ^ y & z;
}

exports.maj32 = maj32;

function p32(x, y, z) {
  return x ^ y ^ z;
}

exports.p32 = p32;

function s0_256(x) {
  return rotr32(x, 2) ^ rotr32(x, 13) ^ rotr32(x, 22);
}

exports.s0_256 = s0_256;

function s1_256(x) {
  return rotr32(x, 6) ^ rotr32(x, 11) ^ rotr32(x, 25);
}

exports.s1_256 = s1_256;

function g0_256(x) {
  return rotr32(x, 7) ^ rotr32(x, 18) ^ x >>> 3;
}

exports.g0_256 = g0_256;

function g1_256(x) {
  return rotr32(x, 17) ^ rotr32(x, 19) ^ x >>> 10;
}

exports.g1_256 = g1_256;

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/utils.js":
/*!************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/utils.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";


var assert = __webpack_require__(/*! minimalistic-assert */ "./node_modules/minimalistic-assert/index.js");

var inherits = __webpack_require__(/*! inherits */ "./node_modules/inherits/inherits_browser.js");

exports.inherits = inherits;

function isSurrogatePair(msg, i) {
  if ((msg.charCodeAt(i) & 0xFC00) !== 0xD800) {
    return false;
  }

  if (i < 0 || i + 1 >= msg.length) {
    return false;
  }

  return (msg.charCodeAt(i + 1) & 0xFC00) === 0xDC00;
}

function toArray(msg, enc) {
  if (Array.isArray(msg)) return msg.slice();
  if (!msg) return [];
  var res = [];

  if (typeof msg === 'string') {
    if (!enc) {
      // Inspired by stringToUtf8ByteArray() in closure-library by Google
      // https://github.com/google/closure-library/blob/8598d87242af59aac233270742c8984e2b2bdbe0/closure/goog/crypt/crypt.js#L117-L143
      // Apache License 2.0
      // https://github.com/google/closure-library/blob/master/LICENSE
      var p = 0;

      for (var i = 0; i < msg.length; i++) {
        var c = msg.charCodeAt(i);

        if (c < 128) {
          res[p++] = c;
        } else if (c < 2048) {
          res[p++] = c >> 6 | 192;
          res[p++] = c & 63 | 128;
        } else if (isSurrogatePair(msg, i)) {
          c = 0x10000 + ((c & 0x03FF) << 10) + (msg.charCodeAt(++i) & 0x03FF);
          res[p++] = c >> 18 | 240;
          res[p++] = c >> 12 & 63 | 128;
          res[p++] = c >> 6 & 63 | 128;
          res[p++] = c & 63 | 128;
        } else {
          res[p++] = c >> 12 | 224;
          res[p++] = c >> 6 & 63 | 128;
          res[p++] = c & 63 | 128;
        }
      }
    } else if (enc === 'hex') {
      msg = msg.replace(/[^a-z0-9]+/ig, '');
      if (msg.length % 2 !== 0) msg = '0' + msg;

      for (i = 0; i < msg.length; i += 2) {
        res.push(parseInt(msg[i] + msg[i + 1], 16));
      }
    }
  } else {
    for (i = 0; i < msg.length; i++) {
      res[i] = msg[i] | 0;
    }
  }

  return res;
}

exports.toArray = toArray;

function toHex(msg) {
  var res = '';

  for (var i = 0; i < msg.length; i++) {
    res += zero2(msg[i].toString(16));
  }

  return res;
}

exports.toHex = toHex;

function htonl(w) {
  var res = w >>> 24 | w >>> 8 & 0xff00 | w << 8 & 0xff0000 | (w & 0xff) << 24;
  return res >>> 0;
}

exports.htonl = htonl;

function toHex32(msg, endian) {
  var res = '';

  for (var i = 0; i < msg.length; i++) {
    var w = msg[i];
    if (endian === 'little') w = htonl(w);
    res += zero8(w.toString(16));
  }

  return res;
}

exports.toHex32 = toHex32;

function zero2(word) {
  if (word.length === 1) return '0' + word;else return word;
}

exports.zero2 = zero2;

function zero8(word) {
  if (word.length === 7) return '0' + word;else if (word.length === 6) return '00' + word;else if (word.length === 5) return '000' + word;else if (word.length === 4) return '0000' + word;else if (word.length === 3) return '00000' + word;else if (word.length === 2) return '000000' + word;else if (word.length === 1) return '0000000' + word;else return word;
}

exports.zero8 = zero8;

function join32(msg, start, end, endian) {
  var len = end - start;
  assert(len % 4 === 0);
  var res = new Array(len / 4);

  for (var i = 0, k = start; i < res.length; i++, k += 4) {
    var w;
    if (endian === 'big') w = msg[k] << 24 | msg[k + 1] << 16 | msg[k + 2] << 8 | msg[k + 3];else w = msg[k + 3] << 24 | msg[k + 2] << 16 | msg[k + 1] << 8 | msg[k];
    res[i] = w >>> 0;
  }

  return res;
}

exports.join32 = join32;

function split32(msg, endian) {
  var res = new Array(msg.length * 4);

  for (var i = 0, k = 0; i < msg.length; i++, k += 4) {
    var m = msg[i];

    if (endian === 'big') {
      res[k] = m >>> 24;
      res[k + 1] = m >>> 16 & 0xff;
      res[k + 2] = m >>> 8 & 0xff;
      res[k + 3] = m & 0xff;
    } else {
      res[k + 3] = m >>> 24;
      res[k + 2] = m >>> 16 & 0xff;
      res[k + 1] = m >>> 8 & 0xff;
      res[k] = m & 0xff;
    }
  }

  return res;
}

exports.split32 = split32;

function rotr32(w, b) {
  return w >>> b | w << 32 - b;
}

exports.rotr32 = rotr32;

function rotl32(w, b) {
  return w << b | w >>> 32 - b;
}

exports.rotl32 = rotl32;

function sum32(a, b) {
  return a + b >>> 0;
}

exports.sum32 = sum32;

function sum32_3(a, b, c) {
  return a + b + c >>> 0;
}

exports.sum32_3 = sum32_3;

function sum32_4(a, b, c, d) {
  return a + b + c + d >>> 0;
}

exports.sum32_4 = sum32_4;

function sum32_5(a, b, c, d, e) {
  return a + b + c + d + e >>> 0;
}

exports.sum32_5 = sum32_5;

function sum64(buf, pos, ah, al) {
  var bh = buf[pos];
  var bl = buf[pos + 1];
  var lo = al + bl >>> 0;
  var hi = (lo < al ? 1 : 0) + ah + bh;
  buf[pos] = hi >>> 0;
  buf[pos + 1] = lo;
}

exports.sum64 = sum64;

function sum64_hi(ah, al, bh, bl) {
  var lo = al + bl >>> 0;
  var hi = (lo < al ? 1 : 0) + ah + bh;
  return hi >>> 0;
}

exports.sum64_hi = sum64_hi;

function sum64_lo(ah, al, bh, bl) {
  var lo = al + bl;
  return lo >>> 0;
}

exports.sum64_lo = sum64_lo;

function sum64_4_hi(ah, al, bh, bl, ch, cl, dh, dl) {
  var carry = 0;
  var lo = al;
  lo = lo + bl >>> 0;
  carry += lo < al ? 1 : 0;
  lo = lo + cl >>> 0;
  carry += lo < cl ? 1 : 0;
  lo = lo + dl >>> 0;
  carry += lo < dl ? 1 : 0;
  var hi = ah + bh + ch + dh + carry;
  return hi >>> 0;
}

exports.sum64_4_hi = sum64_4_hi;

function sum64_4_lo(ah, al, bh, bl, ch, cl, dh, dl) {
  var lo = al + bl + cl + dl;
  return lo >>> 0;
}

exports.sum64_4_lo = sum64_4_lo;

function sum64_5_hi(ah, al, bh, bl, ch, cl, dh, dl, eh, el) {
  var carry = 0;
  var lo = al;
  lo = lo + bl >>> 0;
  carry += lo < al ? 1 : 0;
  lo = lo + cl >>> 0;
  carry += lo < cl ? 1 : 0;
  lo = lo + dl >>> 0;
  carry += lo < dl ? 1 : 0;
  lo = lo + el >>> 0;
  carry += lo < el ? 1 : 0;
  var hi = ah + bh + ch + dh + eh + carry;
  return hi >>> 0;
}

exports.sum64_5_hi = sum64_5_hi;

function sum64_5_lo(ah, al, bh, bl, ch, cl, dh, dl, eh, el) {
  var lo = al + bl + cl + dl + el;
  return lo >>> 0;
}

exports.sum64_5_lo = sum64_5_lo;

function rotr64_hi(ah, al, num) {
  var r = al << 32 - num | ah >>> num;
  return r >>> 0;
}

exports.rotr64_hi = rotr64_hi;

function rotr64_lo(ah, al, num) {
  var r = ah << 32 - num | al >>> num;
  return r >>> 0;
}

exports.rotr64_lo = rotr64_lo;

function shr64_hi(ah, al, num) {
  return ah >>> num;
}

exports.shr64_hi = shr64_hi;

function shr64_lo(ah, al, num) {
  var r = ah << 32 - num | al >>> num;
  return r >>> 0;
}

exports.shr64_lo = shr64_lo;

/***/ }),

/***/ "./node_modules/inherits/inherits_browser.js":
/*!***************************************************!*\
  !*** ./node_modules/inherits/inherits_browser.js ***!
  \***************************************************/
/***/ (function(module) {

if (typeof Object.create === 'function') {
  // implementation from standard node.js 'util' module
  module.exports = function inherits(ctor, superCtor) {
    if (superCtor) {
      ctor.super_ = superCtor;
      ctor.prototype = Object.create(superCtor.prototype, {
        constructor: {
          value: ctor,
          enumerable: false,
          writable: true,
          configurable: true
        }
      });
    }
  };
} else {
  // old school shim for old browsers
  module.exports = function inherits(ctor, superCtor) {
    if (superCtor) {
      ctor.super_ = superCtor;

      var TempCtor = function TempCtor() {};

      TempCtor.prototype = superCtor.prototype;
      ctor.prototype = new TempCtor();
      ctor.prototype.constructor = ctor;
    }
  };
}

/***/ }),

/***/ "./node_modules/js-sha3/src/sha3.js":
/*!******************************************!*\
  !*** ./node_modules/js-sha3/src/sha3.js ***!
  \******************************************/
/***/ (function(module, exports, __webpack_require__) {

/* module decorator */ module = __webpack_require__.nmd(module);
/* provided dependency */ var process = __webpack_require__(/*! process */ "./node_modules/process/browser.js");
var __WEBPACK_AMD_DEFINE_RESULT__;function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/**
 * [js-sha3]{@link https://github.com/emn178/js-sha3}
 *
 * @version 0.8.0
 * @author Chen, Yi-Cyuan [emn178@gmail.com]
 * @copyright Chen, Yi-Cyuan 2015-2018
 * @license MIT
 */

/*jslint bitwise: true */
(function () {
  'use strict';

  var INPUT_ERROR = 'input is invalid type';
  var FINALIZE_ERROR = 'finalize already called';
  var WINDOW = (typeof window === "undefined" ? "undefined" : _typeof(window)) === 'object';
  var root = WINDOW ? window : {};

  if (root.JS_SHA3_NO_WINDOW) {
    WINDOW = false;
  }

  var WEB_WORKER = !WINDOW && (typeof self === "undefined" ? "undefined" : _typeof(self)) === 'object';
  var NODE_JS = !root.JS_SHA3_NO_NODE_JS && (typeof process === "undefined" ? "undefined" : _typeof(process)) === 'object' && process.versions && process.versions.node;

  if (NODE_JS) {
    root = __webpack_require__.g;
  } else if (WEB_WORKER) {
    root = self;
  }

  var COMMON_JS = !root.JS_SHA3_NO_COMMON_JS && ( false ? 0 : _typeof(module)) === 'object' && module.exports;
  var AMD =  true && __webpack_require__.amdO;
  var ARRAY_BUFFER = !root.JS_SHA3_NO_ARRAY_BUFFER && typeof ArrayBuffer !== 'undefined';
  var HEX_CHARS = '0123456789abcdef'.split('');
  var SHAKE_PADDING = [31, 7936, 2031616, 520093696];
  var CSHAKE_PADDING = [4, 1024, 262144, 67108864];
  var KECCAK_PADDING = [1, 256, 65536, 16777216];
  var PADDING = [6, 1536, 393216, 100663296];
  var SHIFT = [0, 8, 16, 24];
  var RC = [1, 0, 32898, 0, 32906, 2147483648, 2147516416, 2147483648, 32907, 0, 2147483649, 0, 2147516545, 2147483648, 32777, 2147483648, 138, 0, 136, 0, 2147516425, 0, 2147483658, 0, 2147516555, 0, 139, 2147483648, 32905, 2147483648, 32771, 2147483648, 32770, 2147483648, 128, 2147483648, 32778, 0, 2147483658, 2147483648, 2147516545, 2147483648, 32896, 2147483648, 2147483649, 0, 2147516424, 2147483648];
  var BITS = [224, 256, 384, 512];
  var SHAKE_BITS = [128, 256];
  var OUTPUT_TYPES = ['hex', 'buffer', 'arrayBuffer', 'array', 'digest'];
  var CSHAKE_BYTEPAD = {
    '128': 168,
    '256': 136
  };

  if (root.JS_SHA3_NO_NODE_JS || !Array.isArray) {
    Array.isArray = function (obj) {
      return Object.prototype.toString.call(obj) === '[object Array]';
    };
  }

  if (ARRAY_BUFFER && (root.JS_SHA3_NO_ARRAY_BUFFER_IS_VIEW || !ArrayBuffer.isView)) {
    ArrayBuffer.isView = function (obj) {
      return _typeof(obj) === 'object' && obj.buffer && obj.buffer.constructor === ArrayBuffer;
    };
  }

  var createOutputMethod = function createOutputMethod(bits, padding, outputType) {
    return function (message) {
      return new Keccak(bits, padding, bits).update(message)[outputType]();
    };
  };

  var createShakeOutputMethod = function createShakeOutputMethod(bits, padding, outputType) {
    return function (message, outputBits) {
      return new Keccak(bits, padding, outputBits).update(message)[outputType]();
    };
  };

  var createCshakeOutputMethod = function createCshakeOutputMethod(bits, padding, outputType) {
    return function (message, outputBits, n, s) {
      return methods['cshake' + bits].update(message, outputBits, n, s)[outputType]();
    };
  };

  var createKmacOutputMethod = function createKmacOutputMethod(bits, padding, outputType) {
    return function (key, message, outputBits, s) {
      return methods['kmac' + bits].update(key, message, outputBits, s)[outputType]();
    };
  };

  var createOutputMethods = function createOutputMethods(method, createMethod, bits, padding) {
    for (var i = 0; i < OUTPUT_TYPES.length; ++i) {
      var type = OUTPUT_TYPES[i];
      method[type] = createMethod(bits, padding, type);
    }

    return method;
  };

  var createMethod = function createMethod(bits, padding) {
    var method = createOutputMethod(bits, padding, 'hex');

    method.create = function () {
      return new Keccak(bits, padding, bits);
    };

    method.update = function (message) {
      return method.create().update(message);
    };

    return createOutputMethods(method, createOutputMethod, bits, padding);
  };

  var createShakeMethod = function createShakeMethod(bits, padding) {
    var method = createShakeOutputMethod(bits, padding, 'hex');

    method.create = function (outputBits) {
      return new Keccak(bits, padding, outputBits);
    };

    method.update = function (message, outputBits) {
      return method.create(outputBits).update(message);
    };

    return createOutputMethods(method, createShakeOutputMethod, bits, padding);
  };

  var createCshakeMethod = function createCshakeMethod(bits, padding) {
    var w = CSHAKE_BYTEPAD[bits];
    var method = createCshakeOutputMethod(bits, padding, 'hex');

    method.create = function (outputBits, n, s) {
      if (!n && !s) {
        return methods['shake' + bits].create(outputBits);
      } else {
        return new Keccak(bits, padding, outputBits).bytepad([n, s], w);
      }
    };

    method.update = function (message, outputBits, n, s) {
      return method.create(outputBits, n, s).update(message);
    };

    return createOutputMethods(method, createCshakeOutputMethod, bits, padding);
  };

  var createKmacMethod = function createKmacMethod(bits, padding) {
    var w = CSHAKE_BYTEPAD[bits];
    var method = createKmacOutputMethod(bits, padding, 'hex');

    method.create = function (key, outputBits, s) {
      return new Kmac(bits, padding, outputBits).bytepad(['KMAC', s], w).bytepad([key], w);
    };

    method.update = function (key, message, outputBits, s) {
      return method.create(key, outputBits, s).update(message);
    };

    return createOutputMethods(method, createKmacOutputMethod, bits, padding);
  };

  var algorithms = [{
    name: 'keccak',
    padding: KECCAK_PADDING,
    bits: BITS,
    createMethod: createMethod
  }, {
    name: 'sha3',
    padding: PADDING,
    bits: BITS,
    createMethod: createMethod
  }, {
    name: 'shake',
    padding: SHAKE_PADDING,
    bits: SHAKE_BITS,
    createMethod: createShakeMethod
  }, {
    name: 'cshake',
    padding: CSHAKE_PADDING,
    bits: SHAKE_BITS,
    createMethod: createCshakeMethod
  }, {
    name: 'kmac',
    padding: CSHAKE_PADDING,
    bits: SHAKE_BITS,
    createMethod: createKmacMethod
  }];
  var methods = {},
      methodNames = [];

  for (var i = 0; i < algorithms.length; ++i) {
    var algorithm = algorithms[i];
    var bits = algorithm.bits;

    for (var j = 0; j < bits.length; ++j) {
      var methodName = algorithm.name + '_' + bits[j];
      methodNames.push(methodName);
      methods[methodName] = algorithm.createMethod(bits[j], algorithm.padding);

      if (algorithm.name !== 'sha3') {
        var newMethodName = algorithm.name + bits[j];
        methodNames.push(newMethodName);
        methods[newMethodName] = methods[methodName];
      }
    }
  }

  function Keccak(bits, padding, outputBits) {
    this.blocks = [];
    this.s = [];
    this.padding = padding;
    this.outputBits = outputBits;
    this.reset = true;
    this.finalized = false;
    this.block = 0;
    this.start = 0;
    this.blockCount = 1600 - (bits << 1) >> 5;
    this.byteCount = this.blockCount << 2;
    this.outputBlocks = outputBits >> 5;
    this.extraBytes = (outputBits & 31) >> 3;

    for (var i = 0; i < 50; ++i) {
      this.s[i] = 0;
    }
  }

  Keccak.prototype.update = function (message) {
    if (this.finalized) {
      throw new Error(FINALIZE_ERROR);
    }

    var notString,
        type = _typeof(message);

    if (type !== 'string') {
      if (type === 'object') {
        if (message === null) {
          throw new Error(INPUT_ERROR);
        } else if (ARRAY_BUFFER && message.constructor === ArrayBuffer) {
          message = new Uint8Array(message);
        } else if (!Array.isArray(message)) {
          if (!ARRAY_BUFFER || !ArrayBuffer.isView(message)) {
            throw new Error(INPUT_ERROR);
          }
        }
      } else {
        throw new Error(INPUT_ERROR);
      }

      notString = true;
    }

    var blocks = this.blocks,
        byteCount = this.byteCount,
        length = message.length,
        blockCount = this.blockCount,
        index = 0,
        s = this.s,
        i,
        code;

    while (index < length) {
      if (this.reset) {
        this.reset = false;
        blocks[0] = this.block;

        for (i = 1; i < blockCount + 1; ++i) {
          blocks[i] = 0;
        }
      }

      if (notString) {
        for (i = this.start; index < length && i < byteCount; ++index) {
          blocks[i >> 2] |= message[index] << SHIFT[i++ & 3];
        }
      } else {
        for (i = this.start; index < length && i < byteCount; ++index) {
          code = message.charCodeAt(index);

          if (code < 0x80) {
            blocks[i >> 2] |= code << SHIFT[i++ & 3];
          } else if (code < 0x800) {
            blocks[i >> 2] |= (0xc0 | code >> 6) << SHIFT[i++ & 3];
            blocks[i >> 2] |= (0x80 | code & 0x3f) << SHIFT[i++ & 3];
          } else if (code < 0xd800 || code >= 0xe000) {
            blocks[i >> 2] |= (0xe0 | code >> 12) << SHIFT[i++ & 3];
            blocks[i >> 2] |= (0x80 | code >> 6 & 0x3f) << SHIFT[i++ & 3];
            blocks[i >> 2] |= (0x80 | code & 0x3f) << SHIFT[i++ & 3];
          } else {
            code = 0x10000 + ((code & 0x3ff) << 10 | message.charCodeAt(++index) & 0x3ff);
            blocks[i >> 2] |= (0xf0 | code >> 18) << SHIFT[i++ & 3];
            blocks[i >> 2] |= (0x80 | code >> 12 & 0x3f) << SHIFT[i++ & 3];
            blocks[i >> 2] |= (0x80 | code >> 6 & 0x3f) << SHIFT[i++ & 3];
            blocks[i >> 2] |= (0x80 | code & 0x3f) << SHIFT[i++ & 3];
          }
        }
      }

      this.lastByteIndex = i;

      if (i >= byteCount) {
        this.start = i - byteCount;
        this.block = blocks[blockCount];

        for (i = 0; i < blockCount; ++i) {
          s[i] ^= blocks[i];
        }

        f(s);
        this.reset = true;
      } else {
        this.start = i;
      }
    }

    return this;
  };

  Keccak.prototype.encode = function (x, right) {
    var o = x & 255,
        n = 1;
    var bytes = [o];
    x = x >> 8;
    o = x & 255;

    while (o > 0) {
      bytes.unshift(o);
      x = x >> 8;
      o = x & 255;
      ++n;
    }

    if (right) {
      bytes.push(n);
    } else {
      bytes.unshift(n);
    }

    this.update(bytes);
    return bytes.length;
  };

  Keccak.prototype.encodeString = function (str) {
    var notString,
        type = _typeof(str);

    if (type !== 'string') {
      if (type === 'object') {
        if (str === null) {
          throw new Error(INPUT_ERROR);
        } else if (ARRAY_BUFFER && str.constructor === ArrayBuffer) {
          str = new Uint8Array(str);
        } else if (!Array.isArray(str)) {
          if (!ARRAY_BUFFER || !ArrayBuffer.isView(str)) {
            throw new Error(INPUT_ERROR);
          }
        }
      } else {
        throw new Error(INPUT_ERROR);
      }

      notString = true;
    }

    var bytes = 0,
        length = str.length;

    if (notString) {
      bytes = length;
    } else {
      for (var i = 0; i < str.length; ++i) {
        var code = str.charCodeAt(i);

        if (code < 0x80) {
          bytes += 1;
        } else if (code < 0x800) {
          bytes += 2;
        } else if (code < 0xd800 || code >= 0xe000) {
          bytes += 3;
        } else {
          code = 0x10000 + ((code & 0x3ff) << 10 | str.charCodeAt(++i) & 0x3ff);
          bytes += 4;
        }
      }
    }

    bytes += this.encode(bytes * 8);
    this.update(str);
    return bytes;
  };

  Keccak.prototype.bytepad = function (strs, w) {
    var bytes = this.encode(w);

    for (var i = 0; i < strs.length; ++i) {
      bytes += this.encodeString(strs[i]);
    }

    var paddingBytes = w - bytes % w;
    var zeros = [];
    zeros.length = paddingBytes;
    this.update(zeros);
    return this;
  };

  Keccak.prototype.finalize = function () {
    if (this.finalized) {
      return;
    }

    this.finalized = true;
    var blocks = this.blocks,
        i = this.lastByteIndex,
        blockCount = this.blockCount,
        s = this.s;
    blocks[i >> 2] |= this.padding[i & 3];

    if (this.lastByteIndex === this.byteCount) {
      blocks[0] = blocks[blockCount];

      for (i = 1; i < blockCount + 1; ++i) {
        blocks[i] = 0;
      }
    }

    blocks[blockCount - 1] |= 0x80000000;

    for (i = 0; i < blockCount; ++i) {
      s[i] ^= blocks[i];
    }

    f(s);
  };

  Keccak.prototype.toString = Keccak.prototype.hex = function () {
    this.finalize();
    var blockCount = this.blockCount,
        s = this.s,
        outputBlocks = this.outputBlocks,
        extraBytes = this.extraBytes,
        i = 0,
        j = 0;
    var hex = '',
        block;

    while (j < outputBlocks) {
      for (i = 0; i < blockCount && j < outputBlocks; ++i, ++j) {
        block = s[i];
        hex += HEX_CHARS[block >> 4 & 0x0F] + HEX_CHARS[block & 0x0F] + HEX_CHARS[block >> 12 & 0x0F] + HEX_CHARS[block >> 8 & 0x0F] + HEX_CHARS[block >> 20 & 0x0F] + HEX_CHARS[block >> 16 & 0x0F] + HEX_CHARS[block >> 28 & 0x0F] + HEX_CHARS[block >> 24 & 0x0F];
      }

      if (j % blockCount === 0) {
        f(s);
        i = 0;
      }
    }

    if (extraBytes) {
      block = s[i];
      hex += HEX_CHARS[block >> 4 & 0x0F] + HEX_CHARS[block & 0x0F];

      if (extraBytes > 1) {
        hex += HEX_CHARS[block >> 12 & 0x0F] + HEX_CHARS[block >> 8 & 0x0F];
      }

      if (extraBytes > 2) {
        hex += HEX_CHARS[block >> 20 & 0x0F] + HEX_CHARS[block >> 16 & 0x0F];
      }
    }

    return hex;
  };

  Keccak.prototype.arrayBuffer = function () {
    this.finalize();
    var blockCount = this.blockCount,
        s = this.s,
        outputBlocks = this.outputBlocks,
        extraBytes = this.extraBytes,
        i = 0,
        j = 0;
    var bytes = this.outputBits >> 3;
    var buffer;

    if (extraBytes) {
      buffer = new ArrayBuffer(outputBlocks + 1 << 2);
    } else {
      buffer = new ArrayBuffer(bytes);
    }

    var array = new Uint32Array(buffer);

    while (j < outputBlocks) {
      for (i = 0; i < blockCount && j < outputBlocks; ++i, ++j) {
        array[j] = s[i];
      }

      if (j % blockCount === 0) {
        f(s);
      }
    }

    if (extraBytes) {
      array[i] = s[i];
      buffer = buffer.slice(0, bytes);
    }

    return buffer;
  };

  Keccak.prototype.buffer = Keccak.prototype.arrayBuffer;

  Keccak.prototype.digest = Keccak.prototype.array = function () {
    this.finalize();
    var blockCount = this.blockCount,
        s = this.s,
        outputBlocks = this.outputBlocks,
        extraBytes = this.extraBytes,
        i = 0,
        j = 0;
    var array = [],
        offset,
        block;

    while (j < outputBlocks) {
      for (i = 0; i < blockCount && j < outputBlocks; ++i, ++j) {
        offset = j << 2;
        block = s[i];
        array[offset] = block & 0xFF;
        array[offset + 1] = block >> 8 & 0xFF;
        array[offset + 2] = block >> 16 & 0xFF;
        array[offset + 3] = block >> 24 & 0xFF;
      }

      if (j % blockCount === 0) {
        f(s);
      }
    }

    if (extraBytes) {
      offset = j << 2;
      block = s[i];
      array[offset] = block & 0xFF;

      if (extraBytes > 1) {
        array[offset + 1] = block >> 8 & 0xFF;
      }

      if (extraBytes > 2) {
        array[offset + 2] = block >> 16 & 0xFF;
      }
    }

    return array;
  };

  function Kmac(bits, padding, outputBits) {
    Keccak.call(this, bits, padding, outputBits);
  }

  Kmac.prototype = new Keccak();

  Kmac.prototype.finalize = function () {
    this.encode(this.outputBits, true);
    return Keccak.prototype.finalize.call(this);
  };

  var f = function f(s) {
    var h, l, n, c0, c1, c2, c3, c4, c5, c6, c7, c8, c9, b0, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15, b16, b17, b18, b19, b20, b21, b22, b23, b24, b25, b26, b27, b28, b29, b30, b31, b32, b33, b34, b35, b36, b37, b38, b39, b40, b41, b42, b43, b44, b45, b46, b47, b48, b49;

    for (n = 0; n < 48; n += 2) {
      c0 = s[0] ^ s[10] ^ s[20] ^ s[30] ^ s[40];
      c1 = s[1] ^ s[11] ^ s[21] ^ s[31] ^ s[41];
      c2 = s[2] ^ s[12] ^ s[22] ^ s[32] ^ s[42];
      c3 = s[3] ^ s[13] ^ s[23] ^ s[33] ^ s[43];
      c4 = s[4] ^ s[14] ^ s[24] ^ s[34] ^ s[44];
      c5 = s[5] ^ s[15] ^ s[25] ^ s[35] ^ s[45];
      c6 = s[6] ^ s[16] ^ s[26] ^ s[36] ^ s[46];
      c7 = s[7] ^ s[17] ^ s[27] ^ s[37] ^ s[47];
      c8 = s[8] ^ s[18] ^ s[28] ^ s[38] ^ s[48];
      c9 = s[9] ^ s[19] ^ s[29] ^ s[39] ^ s[49];
      h = c8 ^ (c2 << 1 | c3 >>> 31);
      l = c9 ^ (c3 << 1 | c2 >>> 31);
      s[0] ^= h;
      s[1] ^= l;
      s[10] ^= h;
      s[11] ^= l;
      s[20] ^= h;
      s[21] ^= l;
      s[30] ^= h;
      s[31] ^= l;
      s[40] ^= h;
      s[41] ^= l;
      h = c0 ^ (c4 << 1 | c5 >>> 31);
      l = c1 ^ (c5 << 1 | c4 >>> 31);
      s[2] ^= h;
      s[3] ^= l;
      s[12] ^= h;
      s[13] ^= l;
      s[22] ^= h;
      s[23] ^= l;
      s[32] ^= h;
      s[33] ^= l;
      s[42] ^= h;
      s[43] ^= l;
      h = c2 ^ (c6 << 1 | c7 >>> 31);
      l = c3 ^ (c7 << 1 | c6 >>> 31);
      s[4] ^= h;
      s[5] ^= l;
      s[14] ^= h;
      s[15] ^= l;
      s[24] ^= h;
      s[25] ^= l;
      s[34] ^= h;
      s[35] ^= l;
      s[44] ^= h;
      s[45] ^= l;
      h = c4 ^ (c8 << 1 | c9 >>> 31);
      l = c5 ^ (c9 << 1 | c8 >>> 31);
      s[6] ^= h;
      s[7] ^= l;
      s[16] ^= h;
      s[17] ^= l;
      s[26] ^= h;
      s[27] ^= l;
      s[36] ^= h;
      s[37] ^= l;
      s[46] ^= h;
      s[47] ^= l;
      h = c6 ^ (c0 << 1 | c1 >>> 31);
      l = c7 ^ (c1 << 1 | c0 >>> 31);
      s[8] ^= h;
      s[9] ^= l;
      s[18] ^= h;
      s[19] ^= l;
      s[28] ^= h;
      s[29] ^= l;
      s[38] ^= h;
      s[39] ^= l;
      s[48] ^= h;
      s[49] ^= l;
      b0 = s[0];
      b1 = s[1];
      b32 = s[11] << 4 | s[10] >>> 28;
      b33 = s[10] << 4 | s[11] >>> 28;
      b14 = s[20] << 3 | s[21] >>> 29;
      b15 = s[21] << 3 | s[20] >>> 29;
      b46 = s[31] << 9 | s[30] >>> 23;
      b47 = s[30] << 9 | s[31] >>> 23;
      b28 = s[40] << 18 | s[41] >>> 14;
      b29 = s[41] << 18 | s[40] >>> 14;
      b20 = s[2] << 1 | s[3] >>> 31;
      b21 = s[3] << 1 | s[2] >>> 31;
      b2 = s[13] << 12 | s[12] >>> 20;
      b3 = s[12] << 12 | s[13] >>> 20;
      b34 = s[22] << 10 | s[23] >>> 22;
      b35 = s[23] << 10 | s[22] >>> 22;
      b16 = s[33] << 13 | s[32] >>> 19;
      b17 = s[32] << 13 | s[33] >>> 19;
      b48 = s[42] << 2 | s[43] >>> 30;
      b49 = s[43] << 2 | s[42] >>> 30;
      b40 = s[5] << 30 | s[4] >>> 2;
      b41 = s[4] << 30 | s[5] >>> 2;
      b22 = s[14] << 6 | s[15] >>> 26;
      b23 = s[15] << 6 | s[14] >>> 26;
      b4 = s[25] << 11 | s[24] >>> 21;
      b5 = s[24] << 11 | s[25] >>> 21;
      b36 = s[34] << 15 | s[35] >>> 17;
      b37 = s[35] << 15 | s[34] >>> 17;
      b18 = s[45] << 29 | s[44] >>> 3;
      b19 = s[44] << 29 | s[45] >>> 3;
      b10 = s[6] << 28 | s[7] >>> 4;
      b11 = s[7] << 28 | s[6] >>> 4;
      b42 = s[17] << 23 | s[16] >>> 9;
      b43 = s[16] << 23 | s[17] >>> 9;
      b24 = s[26] << 25 | s[27] >>> 7;
      b25 = s[27] << 25 | s[26] >>> 7;
      b6 = s[36] << 21 | s[37] >>> 11;
      b7 = s[37] << 21 | s[36] >>> 11;
      b38 = s[47] << 24 | s[46] >>> 8;
      b39 = s[46] << 24 | s[47] >>> 8;
      b30 = s[8] << 27 | s[9] >>> 5;
      b31 = s[9] << 27 | s[8] >>> 5;
      b12 = s[18] << 20 | s[19] >>> 12;
      b13 = s[19] << 20 | s[18] >>> 12;
      b44 = s[29] << 7 | s[28] >>> 25;
      b45 = s[28] << 7 | s[29] >>> 25;
      b26 = s[38] << 8 | s[39] >>> 24;
      b27 = s[39] << 8 | s[38] >>> 24;
      b8 = s[48] << 14 | s[49] >>> 18;
      b9 = s[49] << 14 | s[48] >>> 18;
      s[0] = b0 ^ ~b2 & b4;
      s[1] = b1 ^ ~b3 & b5;
      s[10] = b10 ^ ~b12 & b14;
      s[11] = b11 ^ ~b13 & b15;
      s[20] = b20 ^ ~b22 & b24;
      s[21] = b21 ^ ~b23 & b25;
      s[30] = b30 ^ ~b32 & b34;
      s[31] = b31 ^ ~b33 & b35;
      s[40] = b40 ^ ~b42 & b44;
      s[41] = b41 ^ ~b43 & b45;
      s[2] = b2 ^ ~b4 & b6;
      s[3] = b3 ^ ~b5 & b7;
      s[12] = b12 ^ ~b14 & b16;
      s[13] = b13 ^ ~b15 & b17;
      s[22] = b22 ^ ~b24 & b26;
      s[23] = b23 ^ ~b25 & b27;
      s[32] = b32 ^ ~b34 & b36;
      s[33] = b33 ^ ~b35 & b37;
      s[42] = b42 ^ ~b44 & b46;
      s[43] = b43 ^ ~b45 & b47;
      s[4] = b4 ^ ~b6 & b8;
      s[5] = b5 ^ ~b7 & b9;
      s[14] = b14 ^ ~b16 & b18;
      s[15] = b15 ^ ~b17 & b19;
      s[24] = b24 ^ ~b26 & b28;
      s[25] = b25 ^ ~b27 & b29;
      s[34] = b34 ^ ~b36 & b38;
      s[35] = b35 ^ ~b37 & b39;
      s[44] = b44 ^ ~b46 & b48;
      s[45] = b45 ^ ~b47 & b49;
      s[6] = b6 ^ ~b8 & b0;
      s[7] = b7 ^ ~b9 & b1;
      s[16] = b16 ^ ~b18 & b10;
      s[17] = b17 ^ ~b19 & b11;
      s[26] = b26 ^ ~b28 & b20;
      s[27] = b27 ^ ~b29 & b21;
      s[36] = b36 ^ ~b38 & b30;
      s[37] = b37 ^ ~b39 & b31;
      s[46] = b46 ^ ~b48 & b40;
      s[47] = b47 ^ ~b49 & b41;
      s[8] = b8 ^ ~b0 & b2;
      s[9] = b9 ^ ~b1 & b3;
      s[18] = b18 ^ ~b10 & b12;
      s[19] = b19 ^ ~b11 & b13;
      s[28] = b28 ^ ~b20 & b22;
      s[29] = b29 ^ ~b21 & b23;
      s[38] = b38 ^ ~b30 & b32;
      s[39] = b39 ^ ~b31 & b33;
      s[48] = b48 ^ ~b40 & b42;
      s[49] = b49 ^ ~b41 & b43;
      s[0] ^= RC[n];
      s[1] ^= RC[n + 1];
    }
  };

  if (COMMON_JS) {
    module.exports = methods;
  } else {
    for (i = 0; i < methodNames.length; ++i) {
      root[methodNames[i]] = methods[methodNames[i]];
    }

    if (AMD) {
      !(__WEBPACK_AMD_DEFINE_RESULT__ = (function () {
        return methods;
      }).call(exports, __webpack_require__, exports, module),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
    }
  }
})();

/***/ }),

/***/ "./node_modules/minimalistic-assert/index.js":
/*!***************************************************!*\
  !*** ./node_modules/minimalistic-assert/index.js ***!
  \***************************************************/
/***/ (function(module) {

module.exports = assert;

function assert(val, msg) {
  if (!val) throw new Error(msg || 'Assertion failed');
}

assert.equal = function assertEqual(l, r, msg) {
  if (l != r) throw new Error(msg || 'Assertion failed: ' + l + ' != ' + r);
};

/***/ }),

/***/ "./node_modules/process/browser.js":
/*!*****************************************!*\
  !*** ./node_modules/process/browser.js ***!
  \*****************************************/
/***/ (function(module) {

// shim for using process in browser
var process = module.exports = {}; // cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
  throw new Error('setTimeout has not been defined');
}

function defaultClearTimeout() {
  throw new Error('clearTimeout has not been defined');
}

(function () {
  try {
    if (typeof setTimeout === 'function') {
      cachedSetTimeout = setTimeout;
    } else {
      cachedSetTimeout = defaultSetTimout;
    }
  } catch (e) {
    cachedSetTimeout = defaultSetTimout;
  }

  try {
    if (typeof clearTimeout === 'function') {
      cachedClearTimeout = clearTimeout;
    } else {
      cachedClearTimeout = defaultClearTimeout;
    }
  } catch (e) {
    cachedClearTimeout = defaultClearTimeout;
  }
})();

function runTimeout(fun) {
  if (cachedSetTimeout === setTimeout) {
    //normal enviroments in sane situations
    return setTimeout(fun, 0);
  } // if setTimeout wasn't available but was latter defined


  if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
    cachedSetTimeout = setTimeout;
    return setTimeout(fun, 0);
  }

  try {
    // when when somebody has screwed with setTimeout but no I.E. maddness
    return cachedSetTimeout(fun, 0);
  } catch (e) {
    try {
      // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
      return cachedSetTimeout.call(null, fun, 0);
    } catch (e) {
      // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
      return cachedSetTimeout.call(this, fun, 0);
    }
  }
}

function runClearTimeout(marker) {
  if (cachedClearTimeout === clearTimeout) {
    //normal enviroments in sane situations
    return clearTimeout(marker);
  } // if clearTimeout wasn't available but was latter defined


  if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
    cachedClearTimeout = clearTimeout;
    return clearTimeout(marker);
  }

  try {
    // when when somebody has screwed with setTimeout but no I.E. maddness
    return cachedClearTimeout(marker);
  } catch (e) {
    try {
      // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
      return cachedClearTimeout.call(null, marker);
    } catch (e) {
      // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
      // Some versions of I.E. have different rules for clearTimeout vs setTimeout
      return cachedClearTimeout.call(this, marker);
    }
  }
}

var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
  if (!draining || !currentQueue) {
    return;
  }

  draining = false;

  if (currentQueue.length) {
    queue = currentQueue.concat(queue);
  } else {
    queueIndex = -1;
  }

  if (queue.length) {
    drainQueue();
  }
}

function drainQueue() {
  if (draining) {
    return;
  }

  var timeout = runTimeout(cleanUpNextTick);
  draining = true;
  var len = queue.length;

  while (len) {
    currentQueue = queue;
    queue = [];

    while (++queueIndex < len) {
      if (currentQueue) {
        currentQueue[queueIndex].run();
      }
    }

    queueIndex = -1;
    len = queue.length;
  }

  currentQueue = null;
  draining = false;
  runClearTimeout(timeout);
}

process.nextTick = function (fun) {
  var args = new Array(arguments.length - 1);

  if (arguments.length > 1) {
    for (var i = 1; i < arguments.length; i++) {
      args[i - 1] = arguments[i];
    }
  }

  queue.push(new Item(fun, args));

  if (queue.length === 1 && !draining) {
    runTimeout(drainQueue);
  }
}; // v8 likes predictible objects


function Item(fun, array) {
  this.fun = fun;
  this.array = array;
}

Item.prototype.run = function () {
  this.fun.apply(null, this.array);
};

process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues

process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) {
  return [];
};

process.binding = function (name) {
  throw new Error('process.binding is not supported');
};

process.cwd = function () {
  return '/';
};

process.chdir = function (dir) {
  throw new Error('process.chdir is not supported');
};

process.umask = function () {
  return 0;
};

/***/ }),

/***/ "./node_modules/regenerator-runtime/runtime.js":
/*!*****************************************************!*\
  !*** ./node_modules/regenerator-runtime/runtime.js ***!
  \*****************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

/* module decorator */ module = __webpack_require__.nmd(module);
function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var runtime = function (exports) {
  "use strict";

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined; // More compressible than void 0.

  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
    return obj[key];
  }

  try {
    // IE 8 has a broken Object.defineProperty that only works on DOM objects.
    define({}, "");
  } catch (err) {
    define = function define(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []); // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.

    generator._invoke = makeInvokeMethod(innerFn, self, context);
    return generator;
  }

  exports.wrap = wrap; // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.

  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed"; // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.

  var ContinueSentinel = {}; // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.

  function Generator() {}

  function GeneratorFunction() {}

  function GeneratorFunctionPrototype() {} // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.


  var IteratorPrototype = {};

  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

  if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"); // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.

  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }

  exports.isGeneratorFunction = function (genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor ? ctor === GeneratorFunction || // For the native GeneratorFunction constructor, the best we can
    // do is to check its .name property.
    (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
  };

  exports.mark = function (genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      define(genFun, toStringTagSymbol, "GeneratorFunction");
    }

    genFun.prototype = Object.create(Gp);
    return genFun;
  }; // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.


  exports.awrap = function (arg) {
    return {
      __await: arg
    };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);

      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;

        if (value && _typeof(value) === "object" && hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function (unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function (error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function (resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise = // If enqueue has been called before, then we want to wait until
      // all previous Promises have been resolved before calling invoke,
      // so that results are always delivered in the correct order. If
      // enqueue has not been called before, then it is important to
      // call invoke immediately, without waiting on a callback to fire,
      // so that the async generator function has the opportunity to do
      // any necessary setup in a predictable way. This predictability
      // is why the Promise constructor synchronously invokes its
      // executor callback, and why async functions synchronously
      // execute code before the first await. Since we implement simple
      // async functions in terms of async generators, it is especially
      // important to get this right, even though it requires care.
      previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, // Avoid propagating failures to Promises returned by later
      // invocations of the iterator.
      callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
    } // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).


    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);

  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };

  exports.AsyncIterator = AsyncIterator; // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.

  exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter // If outerFn is a generator, return the full iterator.
    : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;
    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        } // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume


        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;

        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);

          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;
        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);
        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;
        var record = tryCatch(innerFn, self, context);

        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done ? GenStateCompleted : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };
        } else if (record.type === "throw") {
          state = GenStateCompleted; // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.

          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  } // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.


  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];

    if (method === undefined) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError("The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (!info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value; // Resume execution at the desired location (see delegateYield).

      context.next = delegate.nextLoc; // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.

      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined;
      }
    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    } // The delegate iterator is finished, so forget it and continue with
    // the outer generator.


    context.delegate = null;
    return ContinueSentinel;
  } // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.


  defineIteratorMethods(Gp);
  define(Gp, toStringTagSymbol, "Generator"); // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.

  Gp[iteratorSymbol] = function () {
    return this;
  };

  Gp.toString = function () {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{
      tryLoc: "root"
    }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function (object) {
    var keys = [];

    for (var key in object) {
      keys.push(key);
    }

    keys.reverse(); // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.

    return function next() {
      while (keys.length) {
        var key = keys.pop();

        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      } // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.


      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];

      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1,
            next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined;
          next.done = true;
          return next;
        };

        return next.next = next;
      }
    } // Return an iterator with no values.


    return {
      next: doneResult
    };
  }

  exports.values = values;

  function doneResult() {
    return {
      value: undefined,
      done: true
    };
  }

  Context.prototype = {
    constructor: Context,
    reset: function reset(skipTempReset) {
      this.prev = 0;
      this.next = 0; // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.

      this.sent = this._sent = undefined;
      this.done = false;
      this.delegate = null;
      this.method = "next";
      this.arg = undefined;
      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
            this[name] = undefined;
          }
        }
      }
    },
    stop: function stop() {
      this.done = true;
      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;

      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },
    dispatchException: function dispatchException(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;

      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined;
        }

        return !!caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }
          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }
          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },
    abrupt: function abrupt(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },
    complete: function complete(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" || record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },
    finish: function finish(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },
    "catch": function _catch(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;

          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }

          return thrown;
        }
      } // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.


      throw new Error("illegal catch attempt");
    },
    delegateYield: function delegateYield(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined;
      }

      return ContinueSentinel;
    }
  }; // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.

  return exports;
}( // If this script is executing as a CommonJS module, use module.exports
// as the regeneratorRuntime namespace. Otherwise create a new empty
// object. Either way, the resulting object will be used to initialize
// the regeneratorRuntime variable at the top of this file.
( false ? 0 : _typeof(module)) === "object" ? module.exports : {});

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  Function("r", "regeneratorRuntime = r")(runtime);
}

/***/ }),

/***/ "./node_modules/rfc4648/lib/index.js":
/*!*******************************************!*\
  !*** ./node_modules/rfc4648/lib/index.js ***!
  \*******************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "base16": function() { return /* binding */ base16; },
/* harmony export */   "base32": function() { return /* binding */ base32; },
/* harmony export */   "base32hex": function() { return /* binding */ base32hex; },
/* harmony export */   "base64": function() { return /* binding */ base64; },
/* harmony export */   "base64url": function() { return /* binding */ base64url; },
/* harmony export */   "codec": function() { return /* binding */ codec; }
/* harmony export */ });
/* eslint-disable @typescript-eslint/strict-boolean-expressions */
function parse(string, encoding, opts) {
  if (opts === void 0) {
    opts = {};
  } // Build the character lookup table:


  if (!encoding.codes) {
    encoding.codes = {};

    for (var i = 0; i < encoding.chars.length; ++i) {
      encoding.codes[encoding.chars[i]] = i;
    }
  } // The string must have a whole number of bytes:


  if (!opts.loose && string.length * encoding.bits & 7) {
    throw new SyntaxError('Invalid padding');
  } // Count the padding bytes:


  var end = string.length;

  while (string[end - 1] === '=') {
    --end; // If we get a whole number of bytes, there is too much padding:

    if (!opts.loose && !((string.length - end) * encoding.bits & 7)) {
      throw new SyntaxError('Invalid padding');
    }
  } // Allocate the output:


  var out = new (opts.out || Uint8Array)(end * encoding.bits / 8 | 0); // Parse the data:

  var bits = 0; // Number of bits currently in the buffer

  var buffer = 0; // Bits waiting to be written out, MSB first

  var written = 0; // Next byte to write

  for (var _i = 0; _i < end; ++_i) {
    // Read one character from the string:
    var value = encoding.codes[string[_i]];

    if (value === undefined) {
      throw new SyntaxError('Invalid character ' + string[_i]);
    } // Append the bits to the buffer:


    buffer = buffer << encoding.bits | value;
    bits += encoding.bits; // Write out some bits if the buffer has a byte's worth:

    if (bits >= 8) {
      bits -= 8;
      out[written++] = 0xff & buffer >> bits;
    }
  } // Verify that we have received just enough bits:


  if (bits >= encoding.bits || 0xff & buffer << 8 - bits) {
    throw new SyntaxError('Unexpected end of data');
  }

  return out;
}

function stringify(data, encoding, opts) {
  if (opts === void 0) {
    opts = {};
  }

  var _opts = opts,
      _opts$pad = _opts.pad,
      pad = _opts$pad === void 0 ? true : _opts$pad;
  var mask = (1 << encoding.bits) - 1;
  var out = '';
  var bits = 0; // Number of bits currently in the buffer

  var buffer = 0; // Bits waiting to be written out, MSB first

  for (var i = 0; i < data.length; ++i) {
    // Slurp data into the buffer:
    buffer = buffer << 8 | 0xff & data[i];
    bits += 8; // Write out as much as we can:

    while (bits > encoding.bits) {
      bits -= encoding.bits;
      out += encoding.chars[mask & buffer >> bits];
    }
  } // Partial character:


  if (bits) {
    out += encoding.chars[mask & buffer << encoding.bits - bits];
  } // Add padding characters until we hit a byte boundary:


  if (pad) {
    while (out.length * encoding.bits & 7) {
      out += '=';
    }
  }

  return out;
}
/* eslint-disable @typescript-eslint/strict-boolean-expressions */


var base16Encoding = {
  chars: '0123456789ABCDEF',
  bits: 4
};
var base32Encoding = {
  chars: 'ABCDEFGHIJKLMNOPQRSTUVWXYZ234567',
  bits: 5
};
var base32HexEncoding = {
  chars: '0123456789ABCDEFGHIJKLMNOPQRSTUV',
  bits: 5
};
var base64Encoding = {
  chars: 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/',
  bits: 6
};
var base64UrlEncoding = {
  chars: 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_',
  bits: 6
};
var base16 = {
  parse: function parse$1(string, opts) {
    return parse(string.toUpperCase(), base16Encoding, opts);
  },
  stringify: function stringify$1(data, opts) {
    return stringify(data, base16Encoding, opts);
  }
};
var base32 = {
  parse: function parse$1(string, opts) {
    if (opts === void 0) {
      opts = {};
    }

    return parse(opts.loose ? string.toUpperCase().replace(/0/g, 'O').replace(/1/g, 'L').replace(/8/g, 'B') : string, base32Encoding, opts);
  },
  stringify: function stringify$1(data, opts) {
    return stringify(data, base32Encoding, opts);
  }
};
var base32hex = {
  parse: function parse$1(string, opts) {
    return parse(string, base32HexEncoding, opts);
  },
  stringify: function stringify$1(data, opts) {
    return stringify(data, base32HexEncoding, opts);
  }
};
var base64 = {
  parse: function parse$1(string, opts) {
    return parse(string, base64Encoding, opts);
  },
  stringify: function stringify$1(data, opts) {
    return stringify(data, base64Encoding, opts);
  }
};
var base64url = {
  parse: function parse$1(string, opts) {
    return parse(string, base64UrlEncoding, opts);
  },
  stringify: function stringify$1(data, opts) {
    return stringify(data, base64UrlEncoding, opts);
  }
};
var codec = {
  parse: parse,
  stringify: stringify
};


/***/ }),

/***/ "./node_modules/utf8/utf8.js":
/*!***********************************!*\
  !*** ./node_modules/utf8/utf8.js ***!
  \***********************************/
/***/ (function(__unused_webpack_module, exports) {

/*! https://mths.be/utf8js v3.0.0 by @mathias */
;

(function (root) {
  var stringFromCharCode = String.fromCharCode; // Taken from https://mths.be/punycode

  function ucs2decode(string) {
    var output = [];
    var counter = 0;
    var length = string.length;
    var value;
    var extra;

    while (counter < length) {
      value = string.charCodeAt(counter++);

      if (value >= 0xD800 && value <= 0xDBFF && counter < length) {
        // high surrogate, and there is a next character
        extra = string.charCodeAt(counter++);

        if ((extra & 0xFC00) == 0xDC00) {
          // low surrogate
          output.push(((value & 0x3FF) << 10) + (extra & 0x3FF) + 0x10000);
        } else {
          // unmatched surrogate; only append this code unit, in case the next
          // code unit is the high surrogate of a surrogate pair
          output.push(value);
          counter--;
        }
      } else {
        output.push(value);
      }
    }

    return output;
  } // Taken from https://mths.be/punycode


  function ucs2encode(array) {
    var length = array.length;
    var index = -1;
    var value;
    var output = '';

    while (++index < length) {
      value = array[index];

      if (value > 0xFFFF) {
        value -= 0x10000;
        output += stringFromCharCode(value >>> 10 & 0x3FF | 0xD800);
        value = 0xDC00 | value & 0x3FF;
      }

      output += stringFromCharCode(value);
    }

    return output;
  }

  function checkScalarValue(codePoint) {
    if (codePoint >= 0xD800 && codePoint <= 0xDFFF) {
      throw Error('Lone surrogate U+' + codePoint.toString(16).toUpperCase() + ' is not a scalar value');
    }
  }
  /*--------------------------------------------------------------------------*/


  function createByte(codePoint, shift) {
    return stringFromCharCode(codePoint >> shift & 0x3F | 0x80);
  }

  function encodeCodePoint(codePoint) {
    if ((codePoint & 0xFFFFFF80) == 0) {
      // 1-byte sequence
      return stringFromCharCode(codePoint);
    }

    var symbol = '';

    if ((codePoint & 0xFFFFF800) == 0) {
      // 2-byte sequence
      symbol = stringFromCharCode(codePoint >> 6 & 0x1F | 0xC0);
    } else if ((codePoint & 0xFFFF0000) == 0) {
      // 3-byte sequence
      checkScalarValue(codePoint);
      symbol = stringFromCharCode(codePoint >> 12 & 0x0F | 0xE0);
      symbol += createByte(codePoint, 6);
    } else if ((codePoint & 0xFFE00000) == 0) {
      // 4-byte sequence
      symbol = stringFromCharCode(codePoint >> 18 & 0x07 | 0xF0);
      symbol += createByte(codePoint, 12);
      symbol += createByte(codePoint, 6);
    }

    symbol += stringFromCharCode(codePoint & 0x3F | 0x80);
    return symbol;
  }

  function utf8encode(string) {
    var codePoints = ucs2decode(string);
    var length = codePoints.length;
    var index = -1;
    var codePoint;
    var byteString = '';

    while (++index < length) {
      codePoint = codePoints[index];
      byteString += encodeCodePoint(codePoint);
    }

    return byteString;
  }
  /*--------------------------------------------------------------------------*/


  function readContinuationByte() {
    if (byteIndex >= byteCount) {
      throw Error('Invalid byte index');
    }

    var continuationByte = byteArray[byteIndex] & 0xFF;
    byteIndex++;

    if ((continuationByte & 0xC0) == 0x80) {
      return continuationByte & 0x3F;
    } // If we end up here, it’s not a continuation byte


    throw Error('Invalid continuation byte');
  }

  function decodeSymbol() {
    var byte1;
    var byte2;
    var byte3;
    var byte4;
    var codePoint;

    if (byteIndex > byteCount) {
      throw Error('Invalid byte index');
    }

    if (byteIndex == byteCount) {
      return false;
    } // Read first byte


    byte1 = byteArray[byteIndex] & 0xFF;
    byteIndex++; // 1-byte sequence (no continuation bytes)

    if ((byte1 & 0x80) == 0) {
      return byte1;
    } // 2-byte sequence


    if ((byte1 & 0xE0) == 0xC0) {
      byte2 = readContinuationByte();
      codePoint = (byte1 & 0x1F) << 6 | byte2;

      if (codePoint >= 0x80) {
        return codePoint;
      } else {
        throw Error('Invalid continuation byte');
      }
    } // 3-byte sequence (may include unpaired surrogates)


    if ((byte1 & 0xF0) == 0xE0) {
      byte2 = readContinuationByte();
      byte3 = readContinuationByte();
      codePoint = (byte1 & 0x0F) << 12 | byte2 << 6 | byte3;

      if (codePoint >= 0x0800) {
        checkScalarValue(codePoint);
        return codePoint;
      } else {
        throw Error('Invalid continuation byte');
      }
    } // 4-byte sequence


    if ((byte1 & 0xF8) == 0xF0) {
      byte2 = readContinuationByte();
      byte3 = readContinuationByte();
      byte4 = readContinuationByte();
      codePoint = (byte1 & 0x07) << 0x12 | byte2 << 0x0C | byte3 << 0x06 | byte4;

      if (codePoint >= 0x010000 && codePoint <= 0x10FFFF) {
        return codePoint;
      }
    }

    throw Error('Invalid UTF-8 detected');
  }

  var byteArray;
  var byteCount;
  var byteIndex;

  function utf8decode(byteString) {
    byteArray = ucs2decode(byteString);
    byteCount = byteArray.length;
    byteIndex = 0;
    var codePoints = [];
    var tmp;

    while ((tmp = decodeSymbol()) !== false) {
      codePoints.push(tmp);
    }

    return ucs2encode(codePoints);
  }
  /*--------------------------------------------------------------------------*/


  root.version = '3.0.0';
  root.encode = utf8encode;
  root.decode = utf8decode;
})( false ? 0 : exports);

/***/ }),

/***/ "./src/index.js":
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _lib_swap_letsexchange__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../lib/swap/letsexchange */ "./lib/swap/letsexchange.js");
/* harmony import */ var _rate_bitmax_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./rate/bitmax.js */ "./src/rate/bitmax.js");
/* harmony import */ var _rate_coinbase_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./rate/coinbase.js */ "./src/rate/coinbase.js");
/* harmony import */ var _rate_coincap_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./rate/coincap.js */ "./src/rate/coincap.js");
/* harmony import */ var _rate_coingecko_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./rate/coingecko.js */ "./src/rate/coingecko.js");
/* harmony import */ var _rate_coinmonitor_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./rate/coinmonitor.js */ "./src/rate/coinmonitor.js");
/* harmony import */ var _rate_compound_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./rate/compound.js */ "./src/rate/compound.js");
/* harmony import */ var _rate_constantRate_js__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./rate/constantRate.js */ "./src/rate/constantRate.js");
/* harmony import */ var _rate_currencyconverterapi_js__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./rate/currencyconverterapi.js */ "./src/rate/currencyconverterapi.js");
/* harmony import */ var _rate_edgeRates_js__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./rate/edgeRates.js */ "./src/rate/edgeRates.js");
/* harmony import */ var _rate_nomics_js__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./rate/nomics.js */ "./src/rate/nomics.js");
/* harmony import */ var _rate_wazirx__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./rate/wazirx */ "./src/rate/wazirx.js");
/* harmony import */ var _swap_changelly_js__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./swap/changelly.js */ "./src/swap/changelly.js");
/* harmony import */ var _swap_changenow_js__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./swap/changenow.js */ "./src/swap/changenow.js");
/* harmony import */ var _swap_defi_uni_v2_based_plugins_spookySwap_js__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./swap/defi/uni-v2-based/plugins/spookySwap.js */ "./src/swap/defi/uni-v2-based/plugins/spookySwap.js");
/* harmony import */ var _swap_defi_uni_v2_based_plugins_tombSwap_js__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./swap/defi/uni-v2-based/plugins/tombSwap.js */ "./src/swap/defi/uni-v2-based/plugins/tombSwap.js");
/* harmony import */ var _swap_exolix_js__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./swap/exolix.js */ "./src/swap/exolix.js");
/* harmony import */ var _swap_foxExchange_js__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ./swap/foxExchange.js */ "./src/swap/foxExchange.js");
/* harmony import */ var _swap_godex_js__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ./swap/godex.js */ "./src/swap/godex.js");
/* harmony import */ var _swap_sideshift_js__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! ./swap/sideshift.js */ "./src/swap/sideshift.js");
/* harmony import */ var _swap_switchain_js__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! ./swap/switchain.js */ "./src/swap/switchain.js");
/* harmony import */ var _swap_transfer_js__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! ./swap/transfer.js */ "./src/swap/transfer.js");






















var edgeCorePlugins = {
  // Rate plugins:
  bitmax: _rate_bitmax_js__WEBPACK_IMPORTED_MODULE_1__.makeBitMaxPlugin,
  coinbase: _rate_coinbase_js__WEBPACK_IMPORTED_MODULE_2__.makeCoinbasePlugin,
  coincap: _rate_coincap_js__WEBPACK_IMPORTED_MODULE_3__.makeCoincapPlugin,
  coingecko: _rate_coingecko_js__WEBPACK_IMPORTED_MODULE_4__.makeCoinGeckoPlugin,
  coinmonitor: _rate_coinmonitor_js__WEBPACK_IMPORTED_MODULE_5__.makeCoinmonitorPlugin,
  compound: _rate_compound_js__WEBPACK_IMPORTED_MODULE_6__.makeCompoundPlugin,
  constantRate: _rate_constantRate_js__WEBPACK_IMPORTED_MODULE_7__.makeConstantRatePlugin,
  currencyconverterapi: _rate_currencyconverterapi_js__WEBPACK_IMPORTED_MODULE_8__.makeCurrencyconverterapiPlugin,
  edgeRates: _rate_edgeRates_js__WEBPACK_IMPORTED_MODULE_9__.makeEdgeRatesPlugin,
  nomics: _rate_nomics_js__WEBPACK_IMPORTED_MODULE_10__.makeNomicsPlugin,
  wazirx: _rate_wazirx__WEBPACK_IMPORTED_MODULE_11__.makeWazirxPlugin,
  // Swap plugins:
  changelly: _swap_changelly_js__WEBPACK_IMPORTED_MODULE_12__.makeChangellyPlugin,
  changenow: _swap_changenow_js__WEBPACK_IMPORTED_MODULE_13__.makeChangeNowPlugin,
  exolix: _swap_exolix_js__WEBPACK_IMPORTED_MODULE_16__.makeExolixPlugin,
  foxExchange: _swap_foxExchange_js__WEBPACK_IMPORTED_MODULE_17__.makeFoxExchangePlugin,
  godex: _swap_godex_js__WEBPACK_IMPORTED_MODULE_18__.makeGodexPlugin,
  sideshift: _swap_sideshift_js__WEBPACK_IMPORTED_MODULE_19__.makeSideshiftPlugin,
  spookySwap: _swap_defi_uni_v2_based_plugins_spookySwap_js__WEBPACK_IMPORTED_MODULE_14__.makeSpookySwapPlugin,
  tombSwap: _swap_defi_uni_v2_based_plugins_tombSwap_js__WEBPACK_IMPORTED_MODULE_15__.makeTombSwapPlugin,
  switchain: _swap_switchain_js__WEBPACK_IMPORTED_MODULE_20__.makeSwitchainPlugin,
  transfer: _swap_transfer_js__WEBPACK_IMPORTED_MODULE_21__.makeTransferPlugin,
  letsexchange: _lib_swap_letsexchange__WEBPACK_IMPORTED_MODULE_0__.makeLetsExchangePlugin
};

if (typeof window !== 'undefined' && typeof window.addEdgeCorePlugins === 'function') {
  window.addEdgeCorePlugins(edgeCorePlugins);
}

/* harmony default export */ __webpack_exports__["default"] = (edgeCorePlugins);

/***/ }),

/***/ "./src/rate/bitmax.js":
/*!****************************!*\
  !*** ./src/rate/bitmax.js ***!
  \****************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeBitMaxPlugin": function() { return /* binding */ makeBitMaxPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asBitMaxTickerResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  data: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
    close: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
  })
});
function makeBitMaxPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;
  return {
    rateInfo: {
      pluginId: 'bitmax',
      displayName: 'BitMax'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _i2, pair, response, json, rate;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _i2 = 0;

              case 1:
                if (!(_i2 < pairsHint.length)) {
                  _context.next = 25;
                  break;
                }

                pair = pairsHint[_i2];

                if (!(pair.fromCurrency !== 'FIO')) {
                  _context.next = 5;
                  break;
                }

                return _context.abrupt("continue", 22);

              case 5:
                _context.prev = 5;
                _context.next = 8;
                return fetchCors('https://ascendex.com/api/pro/v1/ticker?symbol=FIO/USDT');

              case 8:
                response = _context.sent;
                _context.next = 11;
                return response.json();

              case 11:
                json = _context.sent;

                if (!(!response.ok || json.reason === 'DATA_NOT_AVAILABLE')) {
                  _context.next = 14;
                  break;
                }

                return _context.abrupt("break", 25);

              case 14:
                rate = Number(asBitMaxTickerResponse(json).data.close);
                return _context.abrupt("return", [{
                  fromCurrency: 'FIO',
                  toCurrency: 'USDT',
                  rate: rate
                }]);

              case 18:
                _context.prev = 18;
                _context.t0 = _context["catch"](5);
                log.warn("Issue with Bitmax rate data structure ".concat(_context.t0));
                return _context.abrupt("break", 25);

              case 22:
                _i2++;
                _context.next = 1;
                break;

              case 25:
                return _context.abrupt("return", []);

              case 26:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[5, 18]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/coinbase.js":
/*!******************************!*\
  !*** ./src/rate/coinbase.js ***!
  \******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeCoinbasePlugin": function() { return /* binding */ makeCoinbasePlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asCoinbaseResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  data: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
    rates: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asMap)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asString)
  })
});
function makeCoinbasePlugin(opts) {
  var io = opts.io,
      log = opts.log;
  return {
    rateInfo: {
      pluginId: 'coinbase',
      displayName: 'Coinbase'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, reply, json, cleanJson, _i2, pair, cc, rate;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = [];
                _context.prev = 1;
                _context.next = 4;
                return io.fetch('https://api.coinbase.com/v2/exchange-rates');

              case 4:
                reply = _context.sent;
                _context.next = 7;
                return reply.json();

              case 7:
                json = _context.sent;
                cleanJson = asCoinbaseResponse(json);
                _i2 = 0;

              case 10:
                if (!(_i2 < pairsHint.length)) {
                  _context.next = 20;
                  break;
                }

                pair = pairsHint[_i2];
                cc = pair.fromCurrency;

                if (cleanJson.data.rates[cc]) {
                  _context.next = 15;
                  break;
                }

                return _context.abrupt("continue", 17);

              case 15:
                rate = Number(cleanJson.data.rates[cc]);
                pairs.push({
                  fromCurrency: 'iso:USD',
                  toCurrency: cc,
                  rate: rate
                });

              case 17:
                _i2++;
                _context.next = 10;
                break;

              case 20:
                _context.next = 25;
                break;

              case 22:
                _context.prev = 22;
                _context.t0 = _context["catch"](1);
                log.warn("Issue with Coinbase rate data structure ".concat(_context.t0));

              case 25:
                return _context.abrupt("return", pairs);

              case 26:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[1, 22]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/coincap.js":
/*!*****************************!*\
  !*** ./src/rate/coincap.js ***!
  \*****************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeCoincapPlugin": function() { return /* binding */ makeCoincapPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asCoincapResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  data: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asArray)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
    symbol: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
    priceUsd: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
  }))
});
var asCoincapError = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  error: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asString),
  timestamp: cleaners__WEBPACK_IMPORTED_MODULE_0__.asNumber
});
var asCoincapAssets = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asArray)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  id: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  symbol: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
}));
var currencyMap = {};
function makeCoincapPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  var fetch = io.fetchCors || io.fetch;
  return {
    rateInfo: {
      pluginId: 'coincap',
      displayName: 'Coincap'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, assets, assetsJson, assetIds, queryStrings, filteredPairs, _loop, i, _ret, _i2, query, reply, json, _asCoincapError, error;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = []; // Create unique ID map

                if (!(Object.keys(currencyMap).length === 0)) {
                  _context.next = 10;
                  break;
                }

                _context.next = 4;
                return fetch("https://api.coincap.io/v2/assets/");

              case 4:
                assets = _context.sent;
                _context.next = 7;
                return assets.json();

              case 7:
                assetsJson = _context.sent;
                assetIds = asCoincapAssets(assetsJson.data);
                assetIds.forEach(function (code) {
                  return currencyMap[code.symbol] = code.id;
                });

              case 10:
                // Create query strings
                queryStrings = [];
                filteredPairs = [];

                _loop = function _loop(i) {
                  if (!currencyMap[pairsHint[i].fromCurrency]) return "continue";
                  if (pairsHint[i].fromCurrency.indexOf('iso:') >= 0) return "continue";
                  if (filteredPairs.some(function (cc) {
                    return cc === currencyMap[pairsHint[i].fromCurrency];
                  })) return "continue";
                  filteredPairs.push(currencyMap[pairsHint[i].fromCurrency]);

                  if (filteredPairs.length === 100 || i === pairsHint.length - 1) {
                    queryStrings.push(filteredPairs.join(','));
                    filteredPairs = [];
                  }
                };

                i = 0;

              case 14:
                if (!(i < pairsHint.length)) {
                  _context.next = 21;
                  break;
                }

                _ret = _loop(i);

                if (!(_ret === "continue")) {
                  _context.next = 18;
                  break;
                }

                return _context.abrupt("continue", 18);

              case 18:
                i++;
                _context.next = 14;
                break;

              case 21:
                _i2 = 0;

              case 22:
                if (!(_i2 < queryStrings.length)) {
                  _context.next = 43;
                  break;
                }

                query = queryStrings[_i2];
                _context.prev = 24;
                _context.next = 27;
                return fetch("https://api.coincap.io/v2/assets?ids=".concat(query));

              case 27:
                reply = _context.sent;
                _context.next = 30;
                return reply.json();

              case 30:
                json = _context.sent;
                _asCoincapError = asCoincapError(json), error = _asCoincapError.error;

                if (!(error != null && error !== '' || reply.ok === false)) {
                  _context.next = 34;
                  break;
                }

                throw new Error("CoincapHistorical returned code ".concat(JSON.stringify(error !== null && error !== void 0 ? error : reply.status)));

              case 34:
                asCoincapResponse(json).data.forEach(function (rate) {
                  return pairs.push({
                    fromCurrency: rate.symbol,
                    toCurrency: 'iso:USD',
                    rate: Number(rate.priceUsd)
                  });
                });
                _context.next = 40;
                break;

              case 37:
                _context.prev = 37;
                _context.t0 = _context["catch"](24);
                log.warn("Issue with Coincap rate data structure ".concat(_context.t0));

              case 40:
                _i2++;
                _context.next = 22;
                break;

              case 43:
                return _context.abrupt("return", pairs);

              case 44:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[24, 37]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/coingecko.js":
/*!*******************************!*\
  !*** ./src/rate/coingecko.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeCoinGeckoPlugin": function() { return /* binding */ makeCoinGeckoPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asGeckoBulkUsdReply = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asMap)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  usd: cleaners__WEBPACK_IMPORTED_MODULE_0__.asNumber
}));
var coinGeckoMap = {
  TLOS: 'telos',
  FIRO: 'zcoin',
  ANT: 'aragon',
  TBTC: 'tbtc',
  FIO: 'fio-protocol',
  VTC: 'vertcoin',
  SMART: 'smartcash',
  GRS: 'groestlcoin',
  FUN: 'funfair',
  BADGER: 'badger-dao',
  CREAM: 'cream-2',
  CVP: 'concentrated-voting-power',
  DOUGH: 'piedao-dough-v2',
  ETHBNT: 'ethbnt',
  SUSD: 'nusd',
  USDS: 'stableusd',
  TUSD: 'true-usd',
  GUSD: 'gemini-dollar',
  YETI: 'yearn-ecosystem-token-index',
  PAX: 'paxos-standard',
  RBTC: 'rootstock',
  RIF: 'rif-token',
  FTC: 'feathercoin',
  GLM: 'golem',
  GNO: 'gnosis',
  STORJ: 'storj',
  BTC: 'bitcoin',
  ETH: 'ethereum',
  BCH: 'bitcoin-cash',
  BNB: 'binancecoin',
  EOS: 'eos',
  ETC: 'ethereum-classic',
  XLM: 'stellar',
  XTZ: 'tezos',
  XRP: 'ripple',
  BTG: 'bitcoin-gold',
  BSV: 'bitcoin-cash-sv',
  DASH: 'dash',
  DGB: 'digibyte',
  DOGE: 'dogecoin',
  EBST: 'eboost',
  LTC: 'litecoin',
  QTUM: 'qtum',
  RVN: 'ravencoin',
  UFO: 'ufocoin',
  XMR: 'monero',
  REP: 'augur',
  DAI: 'dai',
  SAI: 'sai',
  WINGS: 'wings',
  USDT: 'tether',
  IND: 'indorse',
  HUR: 'hurify',
  BAT: 'basic-attention-token',
  BNT: 'bancor',
  KNC: 'kyber-network',
  POLY: 'polymath-network',
  USDC: 'usd-coin',
  ZRX: '0x',
  OMG: 'omisego',
  NMR: 'numeraire',
  MKR: 'maker',
  SALT: 'salt',
  MANA: 'decentraland',
  NEXO: 'nexo',
  KIN: 'kin',
  LINK: 'chainlink',
  BRZ: 'brz',
  CREP: 'compound-augur',
  CUSDC: 'compound-usd-coin',
  CETH: 'compound-ether',
  CBAT: 'compound-basic-attention-token',
  CZRX: 'compound-0x',
  CWBTC: 'compound-wrapped-btc',
  CSAI: 'compound-sai',
  CDAI: 'cdai',
  OXT: 'orchid-protocol',
  COMP: 'compound-governance-token',
  MET: 'metronome',
  SNX: 'havven',
  SBTC: 'sbtc',
  AAVE: 'aave',
  WBTC: 'wrapped-bitcoin',
  YFI: 'yearn-finance',
  CRV: 'curve-dao-token',
  BAL: 'balancer',
  SUSHI: 'sushi',
  UMA: 'uma',
  IDLE: 'idle',
  NXM: 'nxm',
  PICKLE: 'pickle-finance',
  ROOK: 'rook',
  INDEX: 'index-cooperative',
  WETH: 'weth',
  RENBTC: 'renbtc',
  RENBCH: 'renbch',
  RENZEC: 'renzec',
  DPI: 'defipulse-index',
  BAND: 'band-protocol',
  REN: 'republic-protocol',
  AMPL: 'ampleforth',
  HBAR: 'hedera-hashgraph',
  OCEAN: 'ocean-protocol',
  AVAX: 'avalanche-2',
  MATIC: 'matic-network',
  PNG: 'pangolin',
  PEFI: 'penguin-finance',
  XAVA: 'avalaunch',
  BIFI: 'beefy-finance',
  YAK: 'yield-yak',
  JOE: 'joe',
  TIME: 'wonderland',
  SPELL: 'spell-token',
  FXS: 'frax-share',
  MIM: 'magic-internet-money',
  BUSD: 'binance-usd',
  UNI: 'uniswap',
  BOO: 'spookyswap',
  FTM: 'fantom',
  TSHARE: 'tomb-shares',
  TOMB: 'tomb',
  MAI: 'mimatic',
  CELO: 'celo',
  CUSD: 'celo-dollar',
  CEUR: 'celo-euro',
  AYFI: 'aave-yfi',
  ALINK: 'aave-link',
  ADAI: 'aave-dai',
  ABAT: 'aave-bat',
  AWETH: 'aave-weth',
  AWBTC: 'aave-wbtc',
  ASNX: 'aave-snx',
  AREN: 'aave-ren',
  AUSDT: 'aave-usdt',
  AMKR: 'aave-mkr',
  AMANA: 'aave-mana',
  AZRX: 'aave-zrx',
  AKNC: 'aave-knc',
  AUSDC: 'aave-usdc',
  ASUSD: 'aave-susd',
  AUNI: 'aave-uni'
};
function makeCoinGeckoPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  return {
    rateInfo: {
      displayName: 'Coingecko',
      pluginId: 'coingecko'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, query, _i2, pair, reply, json, rates;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = [];
                query = [];

                for (_i2 = 0; _i2 < pairsHint.length; _i2++) {
                  pair = pairsHint[_i2];
                  // Coingecko is only used to query specific currencies
                  if (coinGeckoMap[pair.fromCurrency]) query.push(coinGeckoMap[pair.fromCurrency]);
                }

                _context.prev = 3;
                _context.next = 6;
                return io.fetch("https://api.coingecko.com/api/v3/simple/price?ids=".concat(query.join(','), "&vs_currencies=usd"));

              case 6:
                reply = _context.sent;
                _context.next = 9;
                return reply.json();

              case 9:
                json = _context.sent;
                rates = asGeckoBulkUsdReply(json);
                Object.keys(rates).forEach(function (rate) {
                  var fromCurrency = Object.keys(coinGeckoMap).find(function (key) {
                    return typeof key === 'string' && coinGeckoMap[key] === rate;
                  });
                  if (fromCurrency) pairs.push({
                    fromCurrency: fromCurrency,
                    toCurrency: 'iso:USD',
                    rate: rates[rate].usd
                  });
                });
                _context.next = 17;
                break;

              case 14:
                _context.prev = 14;
                _context.t0 = _context["catch"](3);
                log.warn("Issue with Coingecko rate data structure ".concat(_context.t0));

              case 17:
                return _context.abrupt("return", pairs);

              case 18:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[3, 14]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/coinmonitor.js":
/*!*********************************!*\
  !*** ./src/rate/coinmonitor.js ***!
  \*********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeCoinmonitorPlugin": function() { return /* binding */ makeCoinmonitorPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asCoinmonitorTickerResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  mediana_prom: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
});
function makeCoinmonitorPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;
  return {
    rateInfo: {
      pluginId: 'coinmonitor',
      displayName: 'coinmonitor'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, _i2, pair, response, json, rate;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = [];
                _i2 = 0;

              case 2:
                if (!(_i2 < pairsHint.length)) {
                  _context.next = 23;
                  break;
                }

                pair = pairsHint[_i2];

                if (!(pair.fromCurrency === 'BTC' && pair.toCurrency === 'iso:ARS')) {
                  _context.next = 20;
                  break;
                }

                _context.prev = 5;
                _context.next = 8;
                return fetchCors('https://ar.coinmonitor.info/api/v3/btc_ars');

              case 8:
                response = _context.sent;
                _context.next = 11;
                return response.json();

              case 11:
                json = _context.sent;
                rate = Number(asCoinmonitorTickerResponse(json).mediana_prom);
                pairs.push({
                  fromCurrency: 'BTC',
                  toCurrency: 'iso:ARS',
                  rate: rate
                });
                _context.next = 19;
                break;

              case 16:
                _context.prev = 16;
                _context.t0 = _context["catch"](5);
                log.warn("Issue with Coinmonitor rate data structure ".concat(_context.t0));

              case 19:
                return _context.abrupt("break", 23);

              case 20:
                _i2++;
                _context.next = 2;
                break;

              case 23:
                return _context.abrupt("return", pairs);

              case 24:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[5, 16]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/compound.js":
/*!******************************!*\
  !*** ./src/rate/compound.js ***!
  \******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeCompoundPlugin": function() { return /* binding */ makeCompoundPlugin; }
/* harmony export */ });
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function fixCurrency(currencyCode) {
  return currencyCode.toUpperCase();
}

function makeCompoundPlugin(opts) {
  var io = opts.io;
  return {
    rateInfo: {
      pluginId: 'compound',
      displayName: 'Compound'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var reply, json, pairs, _i2, _json$cToken2, rateInfo, rate, toCurrency, fromCurrency;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return io.fetch('https://api.compound.finance/api/v2/ctoken');

              case 2:
                reply = _context.sent;
                _context.next = 5;
                return reply.json();

              case 5:
                json = _context.sent;

                if (!(!json || !json.cToken)) {
                  _context.next = 8;
                  break;
                }

                return _context.abrupt("return", []);

              case 8:
                pairs = [];

                for (_i2 = 0, _json$cToken2 = json.cToken; _i2 < _json$cToken2.length; _i2++) {
                  rateInfo = _json$cToken2[_i2];
                  rate = Number(rateInfo.exchange_rate.value);
                  toCurrency = fixCurrency(rateInfo.underlying_symbol);
                  fromCurrency = fixCurrency(rateInfo.symbol);
                  pairs.push({
                    fromCurrency: fromCurrency,
                    toCurrency: toCurrency,
                    rate: rate
                  });
                }

                return _context.abrupt("return", pairs);

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/constantRate.js":
/*!**********************************!*\
  !*** ./src/rate/constantRate.js ***!
  \**********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeConstantRatePlugin": function() { return /* binding */ makeConstantRatePlugin; }
/* harmony export */ });
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function makeConstantRatePlugin(opts) {
  return {
    rateInfo: {
      pluginId: 'constantRate',
      displayName: 'ConstantRate'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // Grab all the pairs which are in USD:
                pairs = [{
                  fromCurrency: 'TESTBTC',
                  toCurrency: 'iso:USD',
                  rate: 0.01
                }, {
                  fromCurrency: 'WETH',
                  toCurrency: 'ETH',
                  rate: 1
                }, {
                  fromCurrency: 'iso:BRL',
                  toCurrency: 'BRZ',
                  rate: 1
                }, {
                  fromCurrency: 'WBTC',
                  toCurrency: 'BTC',
                  rate: 1
                }, // AAVE tokens
                {
                  fromCurrency: 'AYFI',
                  toCurrency: 'YFI',
                  rate: 1
                }, {
                  fromCurrency: 'ALINK',
                  toCurrency: 'LINK',
                  rate: 1
                }, {
                  fromCurrency: 'ADAI',
                  toCurrency: 'DAI',
                  rate: 1
                }, {
                  fromCurrency: 'ABAT',
                  toCurrency: 'BAT',
                  rate: 1
                }, {
                  fromCurrency: 'AWETH',
                  toCurrency: 'WETH',
                  rate: 1
                }, {
                  fromCurrency: 'AWBTC',
                  toCurrency: 'WBTC',
                  rate: 1
                }, {
                  fromCurrency: 'ASNX',
                  toCurrency: 'SNX',
                  rate: 1
                }, {
                  fromCurrency: 'AREN',
                  toCurrency: 'REN',
                  rate: 1
                }, {
                  fromCurrency: 'AUSDT',
                  toCurrency: 'USDT',
                  rate: 1
                }, {
                  fromCurrency: 'AMKR',
                  toCurrency: 'MKR',
                  rate: 1
                }, {
                  fromCurrency: 'AMANA',
                  toCurrency: 'MANA',
                  rate: 1
                }, {
                  fromCurrency: 'AZRX',
                  toCurrency: 'ZRX',
                  rate: 1
                }, {
                  fromCurrency: 'AKNC',
                  toCurrency: 'KNC',
                  rate: 1
                }, {
                  fromCurrency: 'AUSDC',
                  toCurrency: 'USDC',
                  rate: 1
                }, {
                  fromCurrency: 'ASUSD',
                  toCurrency: 'SUSD',
                  rate: 1
                }, {
                  fromCurrency: 'AUNI',
                  toCurrency: 'UNI',
                  rate: 1
                }, // Deprecated tokens
                {
                  fromCurrency: 'ANT',
                  toCurrency: 'ANTV1',
                  rate: 1
                }, {
                  fromCurrency: 'REPV2',
                  toCurrency: 'REP',
                  rate: 1
                }, // FTM Frapped tokens
                {
                  fromCurrency: 'FUSDT',
                  toCurrency: 'USDT',
                  rate: 1
                }, {
                  fromCurrency: 'FBTC',
                  toCurrency: 'BTC',
                  rate: 1
                }, {
                  fromCurrency: 'FETH',
                  toCurrency: 'ETH',
                  rate: 1
                }, // MAI Finance
                {
                  fromCurrency: 'MAI',
                  toCurrency: 'iso:USD',
                  rate: 1
                }, // AVAX wrapped tokens:
                {
                  fromCurrency: 'BUSD.e',
                  toCurrency: 'BUSD',
                  rate: 1
                }, {
                  fromCurrency: 'DAI.e',
                  toCurrency: 'DAI',
                  rate: 1
                }, {
                  fromCurrency: 'LINK.e',
                  toCurrency: 'LINK',
                  rate: 1
                }, {
                  fromCurrency: 'UNI.e',
                  toCurrency: 'UNI',
                  rate: 1
                }, {
                  fromCurrency: 'USDC.e',
                  toCurrency: 'USDC',
                  rate: 1
                }, {
                  fromCurrency: 'USDT.e',
                  toCurrency: 'USDT',
                  rate: 1
                }, {
                  fromCurrency: 'WBTC.e',
                  toCurrency: 'WBTC',
                  rate: 1
                }];
                return _context.abrupt("return", pairs);

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/currencyconverterapi.js":
/*!******************************************!*\
  !*** ./src/rate/currencyconverterapi.js ***!
  \******************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeCurrencyconverterapiPlugin": function() { return /* binding */ makeCurrencyconverterapiPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asRates = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asNumber);
var asCurrencyConverterResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  status: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asNumber),
  error: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asString)
}).withRest;

var checkAndPush = function checkAndPush(isoCc, ccArray) {
  if (isoCc !== 'iso:USD' && isoCc.slice(0, 4) === 'iso:') {
    var cc = isoCc.slice(4).toUpperCase();

    if (!ccArray.includes("USD_".concat(cc))) {
      ccArray.push("USD_".concat(cc));
    }
  }
};

function makeCurrencyconverterapiPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;
  var apiKey = opts.initOptions.apiKey;

  if (apiKey == null) {
    throw new Error('No currencyconverterapi apiKey provided');
  }

  return {
    rateInfo: {
      pluginId: 'currencyconverterapi',
      displayName: 'CurrencyConverterAPI'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var isoCodesWanted, _i2, _pairsHint2, pair, pairs, query, response, _asCurrencyConverterR, status, error, rates, _i4, _Object$keys2, rate;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairsHint = pairsHint.concat([{
                  fromCurrency: 'iso:USD',
                  toCurrency: 'iso:IMP'
                }, {
                  fromCurrency: 'iso:USD',
                  toCurrency: 'iso:IRR'
                }]);
                isoCodesWanted = [];

                for (_i2 = 0, _pairsHint2 = pairsHint; _i2 < _pairsHint2.length; _i2++) {
                  pair = _pairsHint2[_i2];
                  checkAndPush(pair.fromCurrency, isoCodesWanted);
                  checkAndPush(pair.toCurrency, isoCodesWanted);
                }

                pairs = [];
                query = isoCodesWanted.join(',');
                _context.prev = 5;
                _context.next = 8;
                return fetchCors("https://api.currconv.com/api/v7/convert?q=".concat(query, "&compact=ultra&apiKey=").concat(apiKey));

              case 8:
                response = _context.sent;
                _context.t0 = asCurrencyConverterResponse;
                _context.next = 12;
                return response.json();

              case 12:
                _context.t1 = _context.sent;
                _asCurrencyConverterR = (0, _context.t0)(_context.t1);
                status = _asCurrencyConverterR.status;
                error = _asCurrencyConverterR.error;
                rates = _objectWithoutProperties(_asCurrencyConverterR, ["status", "error"]);

                if (!(status != null && status !== 200 || error != null && error !== '' || response.ok === false)) {
                  _context.next = 19;
                  break;
                }

                throw new Error("CurrencyConvertor returned with status: ".concat(JSON.stringify(status !== null && status !== void 0 ? status : response.status), " and error: ").concat(JSON.stringify(error)));

              case 19:
                for (_i4 = 0, _Object$keys2 = Object.keys(asRates(rates)); _i4 < _Object$keys2.length; _i4++) {
                  rate = _Object$keys2[_i4];
                  pairs.push({
                    fromCurrency: 'iso:USD',
                    toCurrency: "iso:".concat(rate.split('_')[1]),
                    rate: rates[rate]
                  });
                }

                _context.next = 25;
                break;

              case 22:
                _context.prev = 22;
                _context.t2 = _context["catch"](5);
                log.warn("Failed to get ".concat(query, " from currencyconverterapi.com"), _context.t2.message);

              case 25:
                return _context.abrupt("return", pairs);

              case 26:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[5, 22]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/edgeRates.js":
/*!*******************************!*\
  !*** ./src/rate/edgeRates.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeEdgeRatesPlugin": function() { return /* binding */ makeEdgeRatesPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asEdgeRatesResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  exchangeRate: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
});

function checkIfFiat(code) {
  if (code.indexOf('iso:') >= 0) return true;
  return false;
}

function makeEdgeRatesPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  var fetch = io.fetch;
  return {
    rateInfo: {
      pluginId: 'edgeRates',
      displayName: 'EdgeRates'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, _i2, pair, fiatFrom, fiatTo, reply, jsonData, rate;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = [];
                _i2 = 0;

              case 2:
                if (!(_i2 < pairsHint.length)) {
                  _context.next = 25;
                  break;
                }

                pair = pairsHint[_i2];

                if (!(!checkIfFiat(pair.fromCurrency) || !checkIfFiat(pair.toCurrency))) {
                  _context.next = 6;
                  break;
                }

                return _context.abrupt("continue", 22);

              case 6:
                fiatFrom = pair.fromCurrency.split(':');
                fiatTo = pair.toCurrency.split(':');
                _context.prev = 8;
                _context.next = 11;
                return fetch("https://rates1.edge.app/v1/exchangeRate?currency_pair=".concat(fiatFrom[1], "_").concat(fiatTo[1]));

              case 11:
                reply = _context.sent;
                _context.next = 14;
                return reply.json();

              case 14:
                jsonData = _context.sent;
                rate = Number(asEdgeRatesResponse(jsonData).exchangeRate);
                pairs.push({
                  fromCurrency: pair.fromCurrency,
                  toCurrency: pair.toCurrency,
                  rate: rate
                });
                _context.next = 22;
                break;

              case 19:
                _context.prev = 19;
                _context.t0 = _context["catch"](8);
                log.warn("Issue with EdgeRates rate data structure for ".concat(pair.fromCurrency, "/").concat(pair.toCurrency, " pair. Error: ").concat(_context.t0));

              case 22:
                _i2++;
                _context.next = 2;
                break;

              case 25:
                return _context.abrupt("return", pairs);

              case 26:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[8, 19]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/nomics.js":
/*!****************************!*\
  !*** ./src/rate/nomics.js ***!
  \****************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeNomicsPlugin": function() { return /* binding */ makeNomicsPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asNomicsResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asArray)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  price: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asString),
  symbol: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
}));
var UNIQUE_ID_MAP = {
  BOO: 'BOO4'
};
function makeNomicsPlugin(opts) {
  var io = opts.io,
      initOptions = opts.initOptions,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;
  var apiKey = initOptions.apiKey;

  if (apiKey == null) {
    throw new Error('No Nomics exchange rates API key provided');
  }

  return {
    rateInfo: {
      pluginId: 'nomics',
      displayName: 'Nomics'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, queryStrings, filteredPairs, _loop, i, _ret, _i2, query, reply, _e$message;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = []; // Create query strings

                queryStrings = [];
                filteredPairs = [];

                _loop = function _loop(i) {
                  var _UNIQUE_ID_MAP$pairsH;

                  if (pairsHint[i].fromCurrency.indexOf('iso:') >= 0) return "continue";
                  if (filteredPairs.some(function (cc) {
                    return cc === pairsHint[i].fromCurrency;
                  })) return "continue";
                  filteredPairs.push((_UNIQUE_ID_MAP$pairsH = UNIQUE_ID_MAP[pairsHint[i].fromCurrency]) !== null && _UNIQUE_ID_MAP$pairsH !== void 0 ? _UNIQUE_ID_MAP$pairsH : pairsHint[i].fromCurrency);

                  if (filteredPairs.length === 100 || i === pairsHint.length - 1) {
                    queryStrings.push(filteredPairs.join(','));
                    filteredPairs = [];
                  }
                };

                i = 0;

              case 5:
                if (!(i < pairsHint.length)) {
                  _context.next = 12;
                  break;
                }

                _ret = _loop(i);

                if (!(_ret === "continue")) {
                  _context.next = 9;
                  break;
                }

                return _context.abrupt("continue", 9);

              case 9:
                i++;
                _context.next = 5;
                break;

              case 12:
                _i2 = 0;

              case 13:
                if (!(_i2 < queryStrings.length)) {
                  _context.next = 34;
                  break;
                }

                query = queryStrings[_i2];
                _context.prev = 15;
                _context.next = 18;
                return fetchCors("https://api.nomics.com/v1/currencies/ticker?key=".concat(apiKey, "&ids=").concat(query, "&convert=USD"));

              case 18:
                reply = _context.sent;

                if (!(reply.status === 429 || reply.status === 401 || reply.ok === false)) {
                  _context.next = 21;
                  break;
                }

                throw new Error("Nomics returned with status: ".concat(reply.status));

              case 21:
                _context.t0 = asNomicsResponse;
                _context.next = 24;
                return reply.json();

              case 24:
                _context.t1 = _context.sent;
                (0, _context.t0)(_context.t1).forEach(function (rate) {
                  // When Nomics considers a coin "dead" they don't return a price
                  if (rate.price) pairs.push({
                    fromCurrency: rate.symbol,
                    toCurrency: 'iso:USD',
                    rate: Number(rate.price)
                  });
                });
                _context.next = 31;
                break;

              case 28:
                _context.prev = 28;
                _context.t2 = _context["catch"](15);
                log.warn("Issue with Nomics rate data structure. Error: ".concat((_e$message = _context.t2.message) !== null && _e$message !== void 0 ? _e$message : ''));

              case 31:
                _i2++;
                _context.next = 13;
                break;

              case 34:
                return _context.abrupt("return", pairs);

              case 35:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[15, 28]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/wazirx.js":
/*!****************************!*\
  !*** ./src/rate/wazirx.js ***!
  \****************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeWazirxPlugin": function() { return /* binding */ makeWazirxPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asWazirxResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asMap)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  last: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
}));

function fixCurrency(currencyCode) {
  currencyCode = currencyCode.toUpperCase();
  if (currencyCode === 'BCHABC') currencyCode = 'BCH';
  return currencyCode;
}

function makeWazirxPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;
  return {
    rateInfo: {
      pluginId: 'wazirx',
      displayName: 'WazirX'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, rates, _i2, pair, reply, json, cc, currencyPair;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = [];
                _i2 = 0;

              case 2:
                if (!(_i2 < pairsHint.length)) {
                  _context.next = 26;
                  break;
                }

                pair = pairsHint[_i2];

                if (!(pair.toCurrency !== 'iso:INR')) {
                  _context.next = 6;
                  break;
                }

                return _context.abrupt("continue", 23);

              case 6:
                _context.prev = 6;

                if (!(rates === undefined)) {
                  _context.next = 15;
                  break;
                }

                _context.next = 10;
                return fetchCors('https://api.wazirx.com/api/v2/tickers');

              case 10:
                reply = _context.sent;
                _context.next = 13;
                return reply.json();

              case 13:
                json = _context.sent;
                rates = asWazirxResponse(json);

              case 15:
                cc = fixCurrency(pair.fromCurrency).toLowerCase();
                currencyPair = "".concat(cc, "inr");

                if (rates && rates[currencyPair]) {
                  pairs.push({
                    fromCurrency: pair.fromCurrency,
                    toCurrency: 'iso:INR',
                    rate: Number(rates[currencyPair].last)
                  });
                }

                _context.next = 23;
                break;

              case 20:
                _context.prev = 20;
                _context.t0 = _context["catch"](6);
                log.warn("Issue with Wazirx rate data structure ".concat(_context.t0));

              case 23:
                _i2++;
                _context.next = 2;
                break;

              case 26:
                return _context.abrupt("return", pairs);

              case 27:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[6, 20]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/swap-helpers.js":
/*!*****************************!*\
  !*** ./src/swap-helpers.js ***!
  \*****************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ensureInFuture": function() { return /* binding */ ensureInFuture; },
/* harmony export */   "makeSwapPluginQuote": function() { return /* binding */ makeSwapPluginQuote; },
/* harmony export */   "getCodes": function() { return /* binding */ getCodes; },
/* harmony export */   "checkInvalidCodes": function() { return /* binding */ checkInvalidCodes; },
/* harmony export */   "safeCurrencyCodes": function() { return /* binding */ safeCurrencyCodes; },
/* harmony export */   "getCodesWithMainnetTranscription": function() { return /* binding */ getCodesWithMainnetTranscription; }
/* harmony export */ });
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__);
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


/**
 * Ensures that a date is in the future by at least the given amount.
 */

function ensureInFuture(date) {
  var marginSeconds = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 30;
  if (date == null) return;
  var target = Date.now() + marginSeconds * 1000;
  return target < date.valueOf() ? date : new Date(target);
}
function makeSwapPluginQuote(request, fromNativeAmount, toNativeAmount, tx, destinationAddress, pluginId) {
  var isEstimate = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : false;
  var expirationDate = arguments.length > 7 ? arguments[7] : undefined;
  var quoteId = arguments.length > 8 ? arguments[8] : undefined;
  var fromWallet = request.fromWallet;
  var out = {
    fromNativeAmount: fromNativeAmount,
    toNativeAmount: toNativeAmount,
    networkFee: {
      currencyCode: fromWallet.currencyInfo.currencyCode,
      nativeAmount: tx.parentNetworkFee != null ? tx.parentNetworkFee : tx.networkFee
    },
    destinationAddress: destinationAddress,
    pluginId: pluginId,
    expirationDate: expirationDate,
    quoteId: quoteId,
    isEstimate: isEstimate,
    approve: function approve() {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var signedTransaction, broadcastedTransaction;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return fromWallet.signTx(tx);

              case 2:
                signedTransaction = _context.sent;
                _context.next = 5;
                return fromWallet.broadcastTx(signedTransaction);

              case 5:
                broadcastedTransaction = _context.sent;
                _context.next = 8;
                return fromWallet.saveTx(signedTransaction);

              case 8:
                return _context.abrupt("return", {
                  transaction: broadcastedTransaction,
                  orderId: quoteId,
                  destinationAddress: destinationAddress
                });

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },
    close: function close() {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }))();
    }
  };
  return out;
}
var getCodes = function getCodes(request) {
  return {
    fromMainnetCode: request.fromWallet.currencyInfo.currencyCode,
    toMainnetCode: request.toWallet.currencyInfo.currencyCode,
    fromCurrencyCode: request.fromCurrencyCode,
    toCurrencyCode: request.toCurrencyCode
  };
};

var getPluginIds = function getPluginIds(request) {
  return {
    fromPluginId: request.fromWallet.currencyInfo.pluginId,
    toPluginId: request.toWallet.currencyInfo.pluginId
  };
};

/**
 * Throws if either currency code has been disabled by the plugin
 */
function checkInvalidCodes(invalidCodes, request, swapInfo) {
  var _getPluginIds = getPluginIds(request),
      fromPluginId = _getPluginIds.fromPluginId,
      toPluginId = _getPluginIds.toPluginId;

  var _getCodes = getCodes(request),
      fromMainnetCode = _getCodes.fromMainnetCode,
      toMainnetCode = _getCodes.toMainnetCode,
      fromCurrencyCode = _getCodes.fromCurrencyCode,
      toCurrencyCode = _getCodes.toCurrencyCode;

  function check(direction, pluginId, main, token) {
    switch (invalidCodes[direction][pluginId]) {
      case undefined:
        return false;

      case 'allCodes':
        return true;

      case 'allTokens':
        return main !== token;

      default:
        return invalidCodes[direction][pluginId].some(function (code) {
          return code === token;
        });
    }
  }

  if (check('from', fromPluginId, fromMainnetCode, fromCurrencyCode) || check('to', toPluginId, toMainnetCode, toCurrencyCode)) throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);
}

/**
 * Transcribes requested currency codes into plugin compatible unique IDs
 */
function safeCurrencyCodes(transcriptionMap, request) {
  var _transcriptionMap$fro, _transcriptionMap$toP;

  var toLowerCase = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  var _getPluginIds2 = getPluginIds(request),
      fromPluginId = _getPluginIds2.fromPluginId,
      toPluginId = _getPluginIds2.toPluginId;

  var _getCodes2 = getCodes(request),
      fromCurrencyCode = _getCodes2.fromCurrencyCode,
      toCurrencyCode = _getCodes2.toCurrencyCode;

  var out = {
    safeFromCurrencyCode: fromCurrencyCode,
    safeToCurrencyCode: toCurrencyCode
  };

  if ((_transcriptionMap$fro = transcriptionMap[fromPluginId]) !== null && _transcriptionMap$fro !== void 0 && _transcriptionMap$fro[request.fromCurrencyCode]) {
    out.safeFromCurrencyCode = transcriptionMap[fromPluginId][request.fromCurrencyCode];
  }

  if ((_transcriptionMap$toP = transcriptionMap[toPluginId]) !== null && _transcriptionMap$toP !== void 0 && _transcriptionMap$toP[request.toCurrencyCode]) {
    out.safeToCurrencyCode = transcriptionMap[toPluginId][request.toCurrencyCode];
  }

  if (toLowerCase) Object.keys(out).forEach(function (key) {
    out[key] = out[key].toLowerCase();
  });
  return out;
}

/**
 * Returns all four codes with mainnet transcription
 */
var getCodesWithMainnetTranscription = function getCodesWithMainnetTranscription(request, transcriptionMap) {
  var _transcriptionMap$req, _transcriptionMap$req2;

  var _getCodes3 = getCodes(request),
      fromCurrencyCode = _getCodes3.fromCurrencyCode,
      toCurrencyCode = _getCodes3.toCurrencyCode,
      fromMainnetCode = _getCodes3.fromMainnetCode,
      toMainnetCode = _getCodes3.toMainnetCode;

  return {
    fromMainnetCode: (_transcriptionMap$req = transcriptionMap[request.fromWallet.currencyInfo.pluginId]) !== null && _transcriptionMap$req !== void 0 ? _transcriptionMap$req : fromMainnetCode,
    toMainnetCode: (_transcriptionMap$req2 = transcriptionMap[request.toWallet.currencyInfo.pluginId]) !== null && _transcriptionMap$req2 !== void 0 ? _transcriptionMap$req2 : toMainnetCode,
    fromCurrencyCode: fromCurrencyCode,
    toCurrencyCode: toCurrencyCode
  };
};

/***/ }),

/***/ "./src/swap/changelly.js":
/*!*******************************!*\
  !*** ./src/swap/changelly.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeChangellyPlugin": function() { return /* binding */ makeChangellyPlugin; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var hash_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! hash.js */ "./node_modules/hash.js/lib/hash.js");
/* harmony import */ var hash_js__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(hash_js__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var rfc4648__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! rfc4648 */ "./node_modules/rfc4648/lib/index.js");
/* harmony import */ var utf8__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! utf8 */ "./node_modules/utf8/utf8.js");
/* harmony import */ var utf8__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(utf8__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../swap-helpers.js */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }








var INVALID_CURRENCY_CODES = {
  from: {
    ethereum: ['BNB', 'FTM', 'MATIC'],
    avalanche: 'allTokens',
    binancesmartchain: 'allTokens',
    polygon: 'allCodes',
    celo: 'allTokens',
    fantom: 'allCodes'
  },
  to: {
    ethereum: ['BNB', 'FTM', 'MATIC'],
    avalanche: 'allTokens',
    binancesmartchain: 'allTokens',
    polygon: 'allCodes',
    celo: 'allTokens',
    fantom: 'allCodes',
    zcash: ['ZEC']
  }
}; // Invalid currency codes should *not* have transcribed codes
// because currency codes with transcribed versions are NOT invalid

var CURRENCY_CODE_TRANSCRIPTION = {
  ethereum: {
    USDT: 'USDT20'
  },
  binancesmartchain: {
    BNB: 'BNBBSC'
  }
};

function hmacSha512(data, key) {
  var hmac = hash_js__WEBPACK_IMPORTED_MODULE_3___default().hmac((hash_js__WEBPACK_IMPORTED_MODULE_3___default().sha512), key);
  return hmac.update(data).digest();
}

function parseUtf8(text) {
  var byteString = utf8__WEBPACK_IMPORTED_MODULE_5___default().encode(text);
  var out = new Uint8Array(byteString.length);

  for (var i = 0; i < byteString.length; ++i) {
    out[i] = byteString.charCodeAt(i);
  }

  return out;
}

var pluginId = 'changelly';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Changelly',
  supportEmail: 'support@changelly.com'
};
var orderUri = 'https://changelly.com/transaction/';
var uri = 'https://api.changelly.com';
var expirationMs = 1000 * 60 * 20;
var expirationFixedMs = 1000 * 60 * 5;
var asFixedRateQuote = (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asObject)({
  result: (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asObject)({
    id: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString
  })
});
var dontUseLegacy = {
  DGB: true
};

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(wallet, currencyCode) {
    var addressInfo;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context5.sent;
            return _context5.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _getAddress.apply(this, arguments);
}

function checkReply(reply, request) {
  if (reply.error != null) {
    if (reply.error.code === -32602 || /Invalid currency:/.test(reply.error.message)) {
      throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);
    }

    throw new Error('Changelly error: ' + JSON.stringify(reply.error));
  }
}

function makeChangellyPlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;

  if (initOptions.apiKey == null || initOptions.secret == null) {
    throw new Error('No Changelly apiKey or secret provided.');
  }

  var apiKey = initOptions.apiKey;
  var secret = parseUtf8(initOptions.secret);

  function call(_x3, _x4) {
    return _call.apply(this, arguments);
  }

  function _call() {
    _call = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(json, promoCode) {
      var body, sign, headers, response;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              body = JSON.stringify(json);
              sign = rfc4648__WEBPACK_IMPORTED_MODULE_4__.base16.stringify(hmacSha512(parseUtf8(body), secret)).toLowerCase();
              headers = {
                'Content-Type': 'application/json',
                'api-key': apiKey,
                sign: sign
              };
              if (promoCode != null) headers['X-Promo-Code'] = promoCode;
              _context4.next = 6;
              return fetchCors(uri, {
                method: 'POST',
                body: body,
                headers: headers
              });

            case 6:
              response = _context4.sent;

              if (response.ok) {
                _context4.next = 9;
                break;
              }

              throw new Error("Changelly returned error code ".concat(response.status));

            case 9:
              return _context4.abrupt("return", response.json());

            case 10:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));
    return _call.apply(this, arguments);
  }

  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings, opts) {
      var _this = this;

      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var fixedPromise, fixedResult;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_6__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo);
                fixedPromise = _this.getFixedQuote(request, userSettings, opts); // FIXME: Estimated swaps are temporarily disabled

                _context.next = 4;
                return fixedPromise;

              case 4:
                fixedResult = _context.sent;
                return _context.abrupt("return", fixedResult);

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },
    getFixedQuote: function getFixedQuote(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var promoCode, _yield$Promise$all, _yield$Promise$all2, fromAddress, toAddress, quoteAmount, _safeCurrencyCodes, safeFromCurrencyCode, safeToCurrencyCode, fixedRateQuoteResponse, fixedRateQuote, params, sendReply, quoteInfo, spendInfoAmount, amountExpectedFromNative, amountExpectedToTo, spendInfo, tx;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                promoCode = opts.promoCode;
                _context2.next = 3;
                return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

              case 3:
                _yield$Promise$all = _context2.sent;
                _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
                fromAddress = _yield$Promise$all2[0];
                toAddress = _yield$Promise$all2[1];

                if (!(request.quoteFor === 'from')) {
                  _context2.next = 13;
                  break;
                }

                _context2.next = 10;
                return request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode);

              case 10:
                _context2.t0 = _context2.sent;
                _context2.next = 16;
                break;

              case 13:
                _context2.next = 15;
                return request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

              case 15:
                _context2.t0 = _context2.sent;

              case 16:
                quoteAmount = _context2.t0;
                _safeCurrencyCodes = (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_6__.safeCurrencyCodes)(CURRENCY_CODE_TRANSCRIPTION, request), safeFromCurrencyCode = _safeCurrencyCodes.safeFromCurrencyCode, safeToCurrencyCode = _safeCurrencyCodes.safeToCurrencyCode;
                _context2.next = 20;
                return call({
                  jsonrpc: '2.0',
                  id: 'one',
                  method: 'getFixRateForAmount',
                  params: {
                    from: safeFromCurrencyCode,
                    to: safeToCurrencyCode,
                    amountFrom: quoteAmount
                  }
                });

              case 20:
                fixedRateQuoteResponse = _context2.sent;
                fixedRateQuote = asFixedRateQuote(fixedRateQuoteResponse);
                params = request.quoteFor === 'from' ? {
                  amount: quoteAmount,
                  from: safeFromCurrencyCode,
                  to: safeToCurrencyCode,
                  address: toAddress,
                  extraId: null,
                  refundAddress: fromAddress,
                  refundExtraId: null,
                  rateId: fixedRateQuote.result.id
                } : {
                  amountTo: quoteAmount,
                  from: safeFromCurrencyCode,
                  to: safeToCurrencyCode,
                  address: toAddress,
                  extraId: null,
                  refundAddress: fromAddress,
                  refundExtraId: null,
                  rateId: fixedRateQuote.result.id
                };
                _context2.next = 25;
                return call({
                  jsonrpc: '2.0',
                  id: 2,
                  method: 'createFixTransaction',
                  params: params
                }, promoCode);

              case 25:
                sendReply = _context2.sent;
                checkReply(sendReply, request);
                quoteInfo = sendReply.result;
                _context2.next = 30;
                return request.fromWallet.denominationToNative(quoteInfo.amountExpectedFrom, // need to verify that this is okay
                // why use currencyCode from quoteInfo in the first place?
                request.fromCurrencyCode.toUpperCase());

              case 30:
                spendInfoAmount = _context2.sent;
                _context2.next = 33;
                return request.fromWallet.denominationToNative(sendReply.result.amountExpectedFrom, request.fromCurrencyCode);

              case 33:
                amountExpectedFromNative = _context2.sent;
                _context2.next = 36;
                return request.toWallet.denominationToNative(sendReply.result.amountExpectedTo, request.toCurrencyCode);

              case 36:
                amountExpectedToTo = _context2.sent;
                spendInfo = {
                  currencyCode: request.fromCurrencyCode,
                  spendTargets: [{
                    nativeAmount: spendInfoAmount,
                    publicAddress: quoteInfo.payinAddress,
                    uniqueIdentifier: quoteInfo.payinExtraId || undefined
                  }],
                  networkFeeOption: request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                  swapData: {
                    orderId: quoteInfo.id,
                    orderUri: orderUri + quoteInfo.id,
                    isEstimate: false,
                    payoutAddress: toAddress,
                    payoutCurrencyCode: request.toCurrencyCode,
                    payoutNativeAmount: amountExpectedToTo,
                    payoutWalletId: request.toWallet.id,
                    plugin: _objectSpread({}, swapInfo),
                    refundAddress: fromAddress
                  }
                };
                _context2.next = 40;
                return request.fromWallet.makeSpend(spendInfo);

              case 40:
                tx = _context2.sent;
                return _context2.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_6__.makeSwapPluginQuote)(request, amountExpectedFromNative, amountExpectedToTo, tx, toAddress, 'changelly', false, new Date(Date.now() + expirationFixedMs), quoteInfo.id));

              case 42:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }))();
    },
    getEstimate: function getEstimate(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var promoCode, _yield$Promise$all3, _yield$Promise$all4, fromAddress, toAddress, quoteAmount, safeFromCurrencyCode, safeToCurrencyCode, quoteParams, quoteReplies, nativeMin, fromAmount, fromNativeAmount, toNativeAmount, sendReply, quoteInfo, spendInfo, tx;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                promoCode = opts.promoCode; // Grab addresses:

                _context3.next = 3;
                return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

              case 3:
                _yield$Promise$all3 = _context3.sent;
                _yield$Promise$all4 = _slicedToArray(_yield$Promise$all3, 2);
                fromAddress = _yield$Promise$all4[0];
                toAddress = _yield$Promise$all4[1];

                if (!(request.quoteFor === 'from')) {
                  _context3.next = 13;
                  break;
                }

                _context3.next = 10;
                return request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode);

              case 10:
                _context3.t0 = _context3.sent;
                _context3.next = 16;
                break;

              case 13:
                _context3.next = 15;
                return request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

              case 15:
                _context3.t0 = _context3.sent;

              case 16:
                quoteAmount = _context3.t0;
                safeFromCurrencyCode = request.fromCurrencyCode;
                safeToCurrencyCode = request.toCurrencyCode;

                if (CURRENCY_CODE_TRANSCRIPTION[request.fromCurrencyCode]) {
                  safeFromCurrencyCode = CURRENCY_CODE_TRANSCRIPTION[request.fromCurrencyCode];
                }

                if (CURRENCY_CODE_TRANSCRIPTION[request.toCurrencyCode]) {
                  safeToCurrencyCode = CURRENCY_CODE_TRANSCRIPTION[request.toCurrencyCode];
                } // Swap the currencies if we need a reverse quote:


                quoteParams = request.quoteFor === 'from' ? {
                  from: safeFromCurrencyCode,
                  to: safeToCurrencyCode,
                  amount: quoteAmount
                } : {
                  from: safeToCurrencyCode,
                  to: safeFromCurrencyCode,
                  amount: quoteAmount
                }; // Get the estimate from the server:

                _context3.next = 24;
                return Promise.all([call({
                  jsonrpc: '2.0',
                  id: 'one',
                  method: 'getMinAmount',
                  params: {
                    from: safeFromCurrencyCode,
                    to: safeToCurrencyCode
                  }
                }), call({
                  jsonrpc: '2.0',
                  id: 'two',
                  method: 'getExchangeAmount',
                  params: quoteParams
                })]);

              case 24:
                quoteReplies = _context3.sent;
                checkReply(quoteReplies[0], request); // Check the minimum:

                _context3.next = 28;
                return request.fromWallet.denominationToNative(quoteReplies[0].result, request.fromCurrencyCode);

              case 28:
                nativeMin = _context3.sent;

                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(request.nativeAmount, nativeMin)) {
                  _context3.next = 31;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapBelowLimitError(swapInfo, nativeMin);

              case 31:
                checkReply(quoteReplies[1], request); // Calculate the amounts:

                if (!(request.quoteFor === 'from')) {
                  _context3.next = 40;
                  break;
                }

                fromAmount = quoteAmount;
                fromNativeAmount = request.nativeAmount;
                _context3.next = 37;
                return request.toWallet.denominationToNative(quoteReplies[1].result, request.toCurrencyCode);

              case 37:
                toNativeAmount = _context3.sent;
                _context3.next = 45;
                break;

              case 40:
                fromAmount = (0,biggystring__WEBPACK_IMPORTED_MODULE_0__.mul)(quoteReplies[1].result, '1.02');
                _context3.next = 43;
                return request.fromWallet.denominationToNative(fromAmount, request.fromCurrencyCode);

              case 43:
                fromNativeAmount = _context3.sent;
                toNativeAmount = request.nativeAmount;

              case 45:
                _context3.next = 47;
                return call({
                  jsonrpc: '2.0',
                  id: 3,
                  method: 'createTransaction',
                  params: {
                    amount: fromAmount,
                    from: safeFromCurrencyCode,
                    to: safeToCurrencyCode,
                    address: toAddress,
                    extraId: null,
                    // TODO: Do we need this for Monero?
                    refundAddress: fromAddress,
                    refundExtraId: null
                  }
                }, promoCode);

              case 47:
                sendReply = _context3.sent;
                checkReply(sendReply, request);
                quoteInfo = sendReply.result; // Make the transaction:

                spendInfo = {
                  currencyCode: request.fromCurrencyCode,
                  spendTargets: [{
                    nativeAmount: fromNativeAmount,
                    publicAddress: quoteInfo.payinAddress,
                    uniqueIdentifier: quoteInfo.payinExtraId || undefined
                  }],
                  swapData: {
                    orderId: quoteInfo.id,
                    orderUri: orderUri + quoteInfo.id,
                    isEstimate: true,
                    payoutAddress: toAddress,
                    payoutCurrencyCode: request.toCurrencyCode,
                    payoutNativeAmount: toNativeAmount,
                    payoutWalletId: request.toWallet.id,
                    plugin: _objectSpread({}, swapInfo),
                    refundAddress: fromAddress
                  }
                };
                log('spendInfo', spendInfo);
                _context3.next = 54;
                return request.fromWallet.makeSpend(spendInfo);

              case 54:
                tx = _context3.sent;
                return _context3.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_6__.makeSwapPluginQuote)(request, fromNativeAmount, toNativeAmount, tx, toAddress, 'changelly', true, new Date(Date.now() + expirationMs), quoteInfo.id));

              case 56:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/swap/changenow.js":
/*!*******************************!*\
  !*** ./src/swap/changenow.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeChangeNowPlugin": function() { return /* binding */ makeChangeNowPlugin; },
/* harmony export */   "asOptionalBlank": function() { return /* binding */ asOptionalBlank; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../swap-helpers.js */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }





var pluginId = 'changenow';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Change NOW',
  supportEmail: 'support@changenow.io'
};
var orderUri = 'https://changenow.io/exchange/txs/';
var uri = 'https://api.changenow.io/v2/';
var dontUseLegacy = {
  DGB: true
};
var INVALID_CURRENCY_CODES = {
  from: {},
  to: {
    zcash: ['ZEC']
  }
}; // Network names that don't match parent network currency code

var MAINNET_CODE_TRANSCRIPTION = {
  binancesmartchain: 'BSC'
};

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(wallet, currencyCode) {
    var addressInfo;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context5.sent;
            return _context5.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _getAddress.apply(this, arguments);
}

function makeChangeNowPlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io;
  var fetch = io.fetch;

  if (initOptions.apiKey == null) {
    throw new Error('No ChangeNow apiKey provided.');
  }

  var apiKey = initOptions.apiKey;
  var headers = {
    'Content-Type': 'application/json',
    'x-changenow-api-key': apiKey
  };
  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var promoCode, _yield$Promise$all, _yield$Promise$all2, fromAddress, toAddress, _getCodesWithMainnetT, fromCurrencyCode, toCurrencyCode, fromMainnetCode, toMainnetCode, currencyString, nativeAmount, quoteFor, createOrder, _createOrder, swapSell, _swapSell, swapBuy, _swapBuy;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _swapBuy = function _swapBuy3() {
                  _swapBuy = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(flow) {
                    var largeDenomAmount, _yield$createOrder2, fromAmount, payinAddress, payinExtraId, id, validUntil, fromNativeAmount, spendInfo, tx;

                    return regeneratorRuntime.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            _context3.next = 2;
                            return request.toWallet.nativeToDenomination(nativeAmount, toCurrencyCode);

                          case 2:
                            largeDenomAmount = _context3.sent;
                            _context3.next = 5;
                            return createOrder(flow, false, largeDenomAmount);

                          case 5:
                            _yield$createOrder2 = _context3.sent;
                            fromAmount = _yield$createOrder2.fromAmount;
                            payinAddress = _yield$createOrder2.payinAddress;
                            payinExtraId = _yield$createOrder2.payinExtraId;
                            id = _yield$createOrder2.id;
                            validUntil = _yield$createOrder2.validUntil;
                            _context3.next = 13;
                            return request.fromWallet.denominationToNative(fromAmount.toString(), fromCurrencyCode);

                          case 13:
                            fromNativeAmount = _context3.sent;
                            spendInfo = {
                              currencyCode: fromCurrencyCode,
                              spendTargets: [{
                                nativeAmount: fromNativeAmount,
                                publicAddress: payinAddress,
                                uniqueIdentifier: payinExtraId
                              }],
                              networkFeeOption: fromCurrencyCode === 'BTC' ? 'high' : 'standard',
                              swapData: {
                                orderId: id,
                                orderUri: orderUri + id,
                                isEstimate: false,
                                payoutAddress: toAddress,
                                payoutCurrencyCode: toCurrencyCode,
                                payoutNativeAmount: nativeAmount,
                                payoutWalletId: request.toWallet.id,
                                plugin: _objectSpread({}, swapInfo),
                                refundAddress: fromAddress
                              }
                            };
                            _context3.next = 17;
                            return request.fromWallet.makeSpend(spendInfo);

                          case 17:
                            tx = _context3.sent;
                            return _context3.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.makeSwapPluginQuote)(request, fromNativeAmount, nativeAmount, tx, toAddress, pluginId, false, validUntil != null ? (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.ensureInFuture)(validUntil) : new Date(Date.now() + 1000 * 60 * 20), id));

                          case 19:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));
                  return _swapBuy.apply(this, arguments);
                };

                swapBuy = function _swapBuy2(_x7) {
                  return _swapBuy.apply(this, arguments);
                };

                _swapSell = function _swapSell3() {
                  _swapSell = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(flow) {
                    var largeDenomAmount, marketRangeResponse, marketRangeResponseJson, _asMarketRange, minAmount, maxAmount, minNativeAmount, maxNativeAmount, _yield$createOrder, toAmount, payinAddress, payinExtraId, id, validUntil, toNativeAmount, spendInfo, tx;

                    return regeneratorRuntime.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            _context2.next = 2;
                            return request.fromWallet.nativeToDenomination(nativeAmount, fromCurrencyCode);

                          case 2:
                            largeDenomAmount = _context2.sent;
                            _context2.next = 5;
                            return fetch(uri + "exchange/range?flow=".concat(flow, "&").concat(currencyString), {
                              headers: headers
                            });

                          case 5:
                            marketRangeResponse = _context2.sent;
                            _context2.next = 8;
                            return marketRangeResponse.json();

                          case 8:
                            marketRangeResponseJson = _context2.sent;

                            if (!(marketRangeResponseJson.error != null)) {
                              _context2.next = 11;
                              break;
                            }

                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapCurrencyError(swapInfo, fromCurrencyCode, toCurrencyCode);

                          case 11:
                            _asMarketRange = asMarketRange(marketRangeResponseJson), minAmount = _asMarketRange.minAmount, maxAmount = _asMarketRange.maxAmount;

                            if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(largeDenomAmount, minAmount.toString())) {
                              _context2.next = 17;
                              break;
                            }

                            _context2.next = 15;
                            return request.fromWallet.denominationToNative(minAmount.toString(), fromCurrencyCode);

                          case 15:
                            minNativeAmount = _context2.sent;
                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapBelowLimitError(swapInfo, minNativeAmount);

                          case 17:
                            if (!(maxAmount != null && (0,biggystring__WEBPACK_IMPORTED_MODULE_0__.gt)(largeDenomAmount, maxAmount.toString()))) {
                              _context2.next = 22;
                              break;
                            }

                            _context2.next = 20;
                            return request.fromWallet.denominationToNative(maxAmount.toString(), fromCurrencyCode);

                          case 20:
                            maxNativeAmount = _context2.sent;
                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapAboveLimitError(swapInfo, maxNativeAmount);

                          case 22:
                            _context2.next = 24;
                            return createOrder(flow, true, largeDenomAmount);

                          case 24:
                            _yield$createOrder = _context2.sent;
                            toAmount = _yield$createOrder.toAmount;
                            payinAddress = _yield$createOrder.payinAddress;
                            payinExtraId = _yield$createOrder.payinExtraId;
                            id = _yield$createOrder.id;
                            validUntil = _yield$createOrder.validUntil;
                            _context2.next = 32;
                            return request.toWallet.denominationToNative(toAmount.toString(), toCurrencyCode);

                          case 32:
                            toNativeAmount = _context2.sent;
                            spendInfo = {
                              currencyCode: fromCurrencyCode,
                              spendTargets: [{
                                nativeAmount: nativeAmount,
                                publicAddress: payinAddress,
                                uniqueIdentifier: payinExtraId
                              }],
                              networkFeeOption: fromCurrencyCode === 'BTC' ? 'high' : 'standard',
                              swapData: {
                                orderId: id,
                                orderUri: orderUri + id,
                                isEstimate: flow === 'standard',
                                payoutAddress: toAddress,
                                payoutCurrencyCode: toCurrencyCode,
                                payoutNativeAmount: toNativeAmount,
                                payoutWalletId: request.toWallet.id,
                                plugin: _objectSpread({}, swapInfo),
                                refundAddress: fromAddress
                              }
                            };
                            _context2.next = 36;
                            return request.fromWallet.makeSpend(spendInfo);

                          case 36:
                            tx = _context2.sent;
                            return _context2.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.makeSwapPluginQuote)(request, nativeAmount, toNativeAmount, tx, toAddress, pluginId, flow === 'standard', validUntil != null ? (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.ensureInFuture)(validUntil) : new Date(Date.now() + 1000 * 60 * 20), id));

                          case 38:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2);
                  }));
                  return _swapSell.apply(this, arguments);
                };

                swapSell = function _swapSell2(_x6) {
                  return _swapSell.apply(this, arguments);
                };

                _createOrder = function _createOrder3() {
                  _createOrder = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(flow, isSelling, largeDenomAmount) {
                    var type, exchangeAmountResponse, exchangeAmountResponseJson, _asExchange, rateId, validUntil, orderBody, orderResponse, orderResponseJson;

                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            type = isSelling ? 'direct' : 'reverse'; // Get rateId and Date

                            _context.next = 3;
                            return fetch(uri + "exchange/estimated-amount?flow=".concat(flow, "&useRateId=").concat(String(flow === 'fixed-rate'), "&").concat(isSelling ? 'fromAmount' : 'toAmount', "=").concat(largeDenomAmount, "&type=").concat(type, "&").concat(currencyString), {
                              headers: headers
                            });

                          case 3:
                            exchangeAmountResponse = _context.sent;
                            _context.next = 6;
                            return exchangeAmountResponse.json();

                          case 6:
                            exchangeAmountResponseJson = _context.sent;

                            if (!(exchangeAmountResponseJson.error != null)) {
                              _context.next = 9;
                              break;
                            }

                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapCurrencyError(swapInfo, fromCurrencyCode, toCurrencyCode);

                          case 9:
                            _asExchange = asExchange(exchangeAmountResponseJson), rateId = _asExchange.rateId, validUntil = _asExchange.validUntil; // Create order

                            orderBody = {
                              fromCurrency: fromCurrencyCode,
                              toCurrency: toCurrencyCode,
                              fromNetwork: fromMainnetCode,
                              toNetwork: toMainnetCode,
                              fromAmount: isSelling ? largeDenomAmount : '',
                              toAmount: isSelling ? '' : largeDenomAmount,
                              type: type,
                              address: toAddress,
                              refundAddress: fromAddress,
                              flow: flow,
                              rateId: rateId,
                              payload: {
                                promoCode: promoCode
                              }
                            };
                            _context.next = 13;
                            return fetch(uri + 'exchange', {
                              method: 'POST',
                              body: JSON.stringify(orderBody),
                              headers: headers
                            });

                          case 13:
                            orderResponse = _context.sent;

                            if (orderResponse.ok) {
                              _context.next = 16;
                              break;
                            }

                            throw new Error("ChangeNow call returned error code ".concat(orderResponse.status));

                          case 16:
                            _context.next = 18;
                            return orderResponse.json();

                          case 18:
                            orderResponseJson = _context.sent;
                            return _context.abrupt("return", _objectSpread(_objectSpread({}, asOrder(orderResponseJson)), {}, {
                              validUntil: validUntil
                            }));

                          case 20:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));
                  return _createOrder.apply(this, arguments);
                };

                createOrder = function _createOrder2(_x3, _x4, _x5) {
                  return _createOrder.apply(this, arguments);
                };

                promoCode = opts.promoCode;
                (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo); // Grab addresses:

                _context4.next = 10;
                return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

              case 10:
                _yield$Promise$all = _context4.sent;
                _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
                fromAddress = _yield$Promise$all2[0];
                toAddress = _yield$Promise$all2[1];
                _getCodesWithMainnetT = (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.getCodesWithMainnetTranscription)(request, MAINNET_CODE_TRANSCRIPTION), fromCurrencyCode = _getCodesWithMainnetT.fromCurrencyCode, toCurrencyCode = _getCodesWithMainnetT.toCurrencyCode, fromMainnetCode = _getCodesWithMainnetT.fromMainnetCode, toMainnetCode = _getCodesWithMainnetT.toMainnetCode;
                currencyString = "fromCurrency=".concat(fromCurrencyCode, "&toCurrency=").concat(toCurrencyCode, "&fromNetwork=").concat(fromMainnetCode, "&toNetwork=").concat(toMainnetCode);
                nativeAmount = request.nativeAmount, quoteFor = request.quoteFor;

                if (!(quoteFor === 'from')) {
                  _context4.next = 37;
                  break;
                }

                _context4.prev = 18;
                _context4.next = 21;
                return swapSell('fixed-rate');

              case 21:
                return _context4.abrupt("return", _context4.sent);

              case 24:
                _context4.prev = 24;
                _context4.t0 = _context4["catch"](18);
                _context4.prev = 26;
                _context4.next = 29;
                return swapSell('standard');

              case 29:
                return _context4.abrupt("return", _context4.sent);

              case 32:
                _context4.prev = 32;
                _context4.t1 = _context4["catch"](26);
                throw _context4.t0;

              case 35:
                _context4.next = 38;
                break;

              case 37:
                return _context4.abrupt("return", swapBuy('fixed-rate'));

              case 38:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, null, [[18, 24], [26, 32]]);
      }))();
    }
  };
  return out;
}
/**
 * An optional value, where a blank string means undefined.
 */

function asOptionalBlank(cleaner) {
  return function asIgnoredBlank(raw) {
    if (raw == null || raw === '') return;
    return cleaner(raw);
  };
}
var asMarketRange = (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asObject)({
  maxAmount: (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asMaybe)(cleaners__WEBPACK_IMPORTED_MODULE_1__.asNumber),
  minAmount: cleaners__WEBPACK_IMPORTED_MODULE_1__.asNumber
});
var asExchange = (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asObject)({
  rateId: (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_1__.asString),
  validUntil: (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_1__.asDate)
});
var asOrder = (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asObject)({
  fromAmount: cleaners__WEBPACK_IMPORTED_MODULE_1__.asNumber,
  toAmount: cleaners__WEBPACK_IMPORTED_MODULE_1__.asNumber,
  payinAddress: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  payinExtraId: asOptionalBlank(cleaners__WEBPACK_IMPORTED_MODULE_1__.asString),
  id: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString
});

/***/ }),

/***/ "./src/swap/defi/abi/UNISWAP_V2_ERC20_ABI.js":
/*!***************************************************!*\
  !*** ./src/swap/defi/abi/UNISWAP_V2_ERC20_ABI.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
// Source: https://ftmscan.com/address/0x6c021ae822bea943b2e66552bde1d2696a53fbb7#code
/* harmony default export */ __webpack_exports__["default"] = ([{
  anonymous: false,
  inputs: [{
    indexed: true,
    internalType: 'address',
    name: 'owner',
    type: 'address'
  }, {
    indexed: true,
    internalType: 'address',
    name: 'spender',
    type: 'address'
  }, {
    indexed: false,
    internalType: 'uint256',
    name: 'value',
    type: 'uint256'
  }],
  name: 'Approval',
  type: 'event'
}, {
  anonymous: false,
  inputs: [{
    indexed: true,
    internalType: 'address',
    name: 'from',
    type: 'address'
  }, {
    indexed: true,
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    indexed: false,
    internalType: 'uint256',
    name: 'value',
    type: 'uint256'
  }],
  name: 'Transfer',
  type: 'event'
}, {
  constant: true,
  inputs: [],
  name: 'DOMAIN_SEPARATOR',
  outputs: [{
    internalType: 'bytes32',
    name: '',
    type: 'bytes32'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: true,
  inputs: [],
  name: 'PERMIT_TYPEHASH',
  outputs: [{
    internalType: 'bytes32',
    name: '',
    type: 'bytes32'
  }],
  payable: false,
  stateMutability: 'pure',
  type: 'function'
}, {
  constant: true,
  inputs: [{
    internalType: 'address',
    name: 'owner',
    type: 'address'
  }, {
    internalType: 'address',
    name: 'spender',
    type: 'address'
  }],
  name: 'allowance',
  outputs: [{
    internalType: 'uint256',
    name: '',
    type: 'uint256'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: false,
  inputs: [{
    internalType: 'address',
    name: 'spender',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'value',
    type: 'uint256'
  }],
  name: 'approve',
  outputs: [{
    internalType: 'bool',
    name: '',
    type: 'bool'
  }],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  constant: true,
  inputs: [{
    internalType: 'address',
    name: 'owner',
    type: 'address'
  }],
  name: 'balanceOf',
  outputs: [{
    internalType: 'uint256',
    name: '',
    type: 'uint256'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: true,
  inputs: [],
  name: 'decimals',
  outputs: [{
    internalType: 'uint8',
    name: '',
    type: 'uint8'
  }],
  payable: false,
  stateMutability: 'pure',
  type: 'function'
}, {
  constant: true,
  inputs: [],
  name: 'name',
  outputs: [{
    internalType: 'string',
    name: '',
    type: 'string'
  }],
  payable: false,
  stateMutability: 'pure',
  type: 'function'
}, {
  constant: true,
  inputs: [{
    internalType: 'address',
    name: 'owner',
    type: 'address'
  }],
  name: 'nonces',
  outputs: [{
    internalType: 'uint256',
    name: '',
    type: 'uint256'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: false,
  inputs: [{
    internalType: 'address',
    name: 'owner',
    type: 'address'
  }, {
    internalType: 'address',
    name: 'spender',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'value',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }, {
    internalType: 'uint8',
    name: 'v',
    type: 'uint8'
  }, {
    internalType: 'bytes32',
    name: 'r',
    type: 'bytes32'
  }, {
    internalType: 'bytes32',
    name: 's',
    type: 'bytes32'
  }],
  name: 'permit',
  outputs: [],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  constant: true,
  inputs: [],
  name: 'symbol',
  outputs: [{
    internalType: 'string',
    name: '',
    type: 'string'
  }],
  payable: false,
  stateMutability: 'pure',
  type: 'function'
}, {
  constant: true,
  inputs: [],
  name: 'totalSupply',
  outputs: [{
    internalType: 'uint256',
    name: '',
    type: 'uint256'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: false,
  inputs: [{
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'value',
    type: 'uint256'
  }],
  name: 'transfer',
  outputs: [{
    internalType: 'bool',
    name: '',
    type: 'bool'
  }],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  constant: false,
  inputs: [{
    internalType: 'address',
    name: 'from',
    type: 'address'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'value',
    type: 'uint256'
  }],
  name: 'transferFrom',
  outputs: [{
    internalType: 'bool',
    name: '',
    type: 'bool'
  }],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}]);

/***/ }),

/***/ "./src/swap/defi/abi/UNISWAP_V2_ROUTER_ABI.js":
/*!****************************************************!*\
  !*** ./src/swap/defi/abi/UNISWAP_V2_ROUTER_ABI.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
// Source: https://ftmscan.com/address/0xf491e7b69e4244ad4002bc14e878a34207e38c29#code
/* harmony default export */ __webpack_exports__["default"] = ([{
  inputs: [{
    internalType: 'address',
    name: '_factory',
    type: 'address'
  }, {
    internalType: 'address',
    name: '_WETH',
    type: 'address'
  }],
  stateMutability: 'nonpayable',
  type: 'constructor'
}, {
  inputs: [],
  name: 'WETH',
  outputs: [{
    internalType: 'address',
    name: '',
    type: 'address'
  }],
  stateMutability: 'view',
  type: 'function'
}, {
  inputs: [{
    internalType: 'address',
    name: 'tokenA',
    type: 'address'
  }, {
    internalType: 'address',
    name: 'tokenB',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'amountADesired',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountBDesired',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountAMin',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountBMin',
    type: 'uint256'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'addLiquidity',
  outputs: [{
    internalType: 'uint256',
    name: 'amountA',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountB',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'liquidity',
    type: 'uint256'
  }],
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'address',
    name: 'token',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'amountTokenDesired',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountTokenMin',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountETHMin',
    type: 'uint256'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'addLiquidityETH',
  outputs: [{
    internalType: 'uint256',
    name: 'amountToken',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountETH',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'liquidity',
    type: 'uint256'
  }],
  stateMutability: 'payable',
  type: 'function'
}, {
  inputs: [],
  name: 'factory',
  outputs: [{
    internalType: 'address',
    name: '',
    type: 'address'
  }],
  stateMutability: 'view',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountOut',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'reserveIn',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'reserveOut',
    type: 'uint256'
  }],
  name: 'getAmountIn',
  outputs: [{
    internalType: 'uint256',
    name: 'amountIn',
    type: 'uint256'
  }],
  stateMutability: 'pure',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountIn',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'reserveIn',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'reserveOut',
    type: 'uint256'
  }],
  name: 'getAmountOut',
  outputs: [{
    internalType: 'uint256',
    name: 'amountOut',
    type: 'uint256'
  }],
  stateMutability: 'pure',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountOut',
    type: 'uint256'
  }, {
    internalType: 'address[]',
    name: 'path',
    type: 'address[]'
  }],
  name: 'getAmountsIn',
  outputs: [{
    internalType: 'uint256[]',
    name: 'amounts',
    type: 'uint256[]'
  }],
  stateMutability: 'view',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountIn',
    type: 'uint256'
  }, {
    internalType: 'address[]',
    name: 'path',
    type: 'address[]'
  }],
  name: 'getAmountsOut',
  outputs: [{
    internalType: 'uint256[]',
    name: 'amounts',
    type: 'uint256[]'
  }],
  stateMutability: 'view',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountA',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'reserveA',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'reserveB',
    type: 'uint256'
  }],
  name: 'quote',
  outputs: [{
    internalType: 'uint256',
    name: 'amountB',
    type: 'uint256'
  }],
  stateMutability: 'pure',
  type: 'function'
}, {
  inputs: [{
    internalType: 'address',
    name: 'tokenA',
    type: 'address'
  }, {
    internalType: 'address',
    name: 'tokenB',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'liquidity',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountAMin',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountBMin',
    type: 'uint256'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'removeLiquidity',
  outputs: [{
    internalType: 'uint256',
    name: 'amountA',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountB',
    type: 'uint256'
  }],
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'address',
    name: 'token',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'liquidity',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountTokenMin',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountETHMin',
    type: 'uint256'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'removeLiquidityETH',
  outputs: [{
    internalType: 'uint256',
    name: 'amountToken',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountETH',
    type: 'uint256'
  }],
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'address',
    name: 'token',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'liquidity',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountTokenMin',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountETHMin',
    type: 'uint256'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'removeLiquidityETHSupportingFeeOnTransferTokens',
  outputs: [{
    internalType: 'uint256',
    name: 'amountETH',
    type: 'uint256'
  }],
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'address',
    name: 'token',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'liquidity',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountTokenMin',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountETHMin',
    type: 'uint256'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }, {
    internalType: 'bool',
    name: 'approveMax',
    type: 'bool'
  }, {
    internalType: 'uint8',
    name: 'v',
    type: 'uint8'
  }, {
    internalType: 'bytes32',
    name: 'r',
    type: 'bytes32'
  }, {
    internalType: 'bytes32',
    name: 's',
    type: 'bytes32'
  }],
  name: 'removeLiquidityETHWithPermit',
  outputs: [{
    internalType: 'uint256',
    name: 'amountToken',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountETH',
    type: 'uint256'
  }],
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'address',
    name: 'token',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'liquidity',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountTokenMin',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountETHMin',
    type: 'uint256'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }, {
    internalType: 'bool',
    name: 'approveMax',
    type: 'bool'
  }, {
    internalType: 'uint8',
    name: 'v',
    type: 'uint8'
  }, {
    internalType: 'bytes32',
    name: 'r',
    type: 'bytes32'
  }, {
    internalType: 'bytes32',
    name: 's',
    type: 'bytes32'
  }],
  name: 'removeLiquidityETHWithPermitSupportingFeeOnTransferTokens',
  outputs: [{
    internalType: 'uint256',
    name: 'amountETH',
    type: 'uint256'
  }],
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'address',
    name: 'tokenA',
    type: 'address'
  }, {
    internalType: 'address',
    name: 'tokenB',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'liquidity',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountAMin',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountBMin',
    type: 'uint256'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }, {
    internalType: 'bool',
    name: 'approveMax',
    type: 'bool'
  }, {
    internalType: 'uint8',
    name: 'v',
    type: 'uint8'
  }, {
    internalType: 'bytes32',
    name: 'r',
    type: 'bytes32'
  }, {
    internalType: 'bytes32',
    name: 's',
    type: 'bytes32'
  }],
  name: 'removeLiquidityWithPermit',
  outputs: [{
    internalType: 'uint256',
    name: 'amountA',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountB',
    type: 'uint256'
  }],
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountOut',
    type: 'uint256'
  }, {
    internalType: 'address[]',
    name: 'path',
    type: 'address[]'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'swapETHForExactTokens',
  outputs: [{
    internalType: 'uint256[]',
    name: 'amounts',
    type: 'uint256[]'
  }],
  stateMutability: 'payable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountOutMin',
    type: 'uint256'
  }, {
    internalType: 'address[]',
    name: 'path',
    type: 'address[]'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'swapExactETHForTokens',
  outputs: [{
    internalType: 'uint256[]',
    name: 'amounts',
    type: 'uint256[]'
  }],
  stateMutability: 'payable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountOutMin',
    type: 'uint256'
  }, {
    internalType: 'address[]',
    name: 'path',
    type: 'address[]'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'swapExactETHForTokensSupportingFeeOnTransferTokens',
  outputs: [],
  stateMutability: 'payable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountIn',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountOutMin',
    type: 'uint256'
  }, {
    internalType: 'address[]',
    name: 'path',
    type: 'address[]'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'swapExactTokensForETH',
  outputs: [{
    internalType: 'uint256[]',
    name: 'amounts',
    type: 'uint256[]'
  }],
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountIn',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountOutMin',
    type: 'uint256'
  }, {
    internalType: 'address[]',
    name: 'path',
    type: 'address[]'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'swapExactTokensForETHSupportingFeeOnTransferTokens',
  outputs: [],
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountIn',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountOutMin',
    type: 'uint256'
  }, {
    internalType: 'address[]',
    name: 'path',
    type: 'address[]'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'swapExactTokensForTokens',
  outputs: [{
    internalType: 'uint256[]',
    name: 'amounts',
    type: 'uint256[]'
  }],
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountIn',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountOutMin',
    type: 'uint256'
  }, {
    internalType: 'address[]',
    name: 'path',
    type: 'address[]'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'swapExactTokensForTokensSupportingFeeOnTransferTokens',
  outputs: [],
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountOut',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountInMax',
    type: 'uint256'
  }, {
    internalType: 'address[]',
    name: 'path',
    type: 'address[]'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'swapTokensForExactETH',
  outputs: [{
    internalType: 'uint256[]',
    name: 'amounts',
    type: 'uint256[]'
  }],
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  inputs: [{
    internalType: 'uint256',
    name: 'amountOut',
    type: 'uint256'
  }, {
    internalType: 'uint256',
    name: 'amountInMax',
    type: 'uint256'
  }, {
    internalType: 'address[]',
    name: 'path',
    type: 'address[]'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'deadline',
    type: 'uint256'
  }],
  name: 'swapTokensForExactTokens',
  outputs: [{
    internalType: 'uint256[]',
    name: 'amounts',
    type: 'uint256[]'
  }],
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  stateMutability: 'payable',
  type: 'receive'
}]);

/***/ }),

/***/ "./src/swap/defi/abi/WRAPPED_FTM_ABI.js":
/*!**********************************************!*\
  !*** ./src/swap/defi/abi/WRAPPED_FTM_ABI.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
// Source: https://ftmscan.com/address/0x21be370d5312f44cb42ce377bc9b8a0cef1a4c83#code
/* harmony default export */ __webpack_exports__["default"] = ([{
  inputs: [],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'constructor'
}, {
  anonymous: false,
  inputs: [{
    indexed: true,
    internalType: 'address',
    name: 'owner',
    type: 'address'
  }, {
    indexed: true,
    internalType: 'address',
    name: 'spender',
    type: 'address'
  }, {
    indexed: false,
    internalType: 'uint256',
    name: 'value',
    type: 'uint256'
  }],
  name: 'Approval',
  type: 'event'
}, {
  anonymous: false,
  inputs: [{
    indexed: false,
    internalType: 'address',
    name: 'account',
    type: 'address'
  }],
  name: 'Paused',
  type: 'event'
}, {
  anonymous: false,
  inputs: [{
    indexed: true,
    internalType: 'address',
    name: 'account',
    type: 'address'
  }],
  name: 'PauserAdded',
  type: 'event'
}, {
  anonymous: false,
  inputs: [{
    indexed: true,
    internalType: 'address',
    name: 'account',
    type: 'address'
  }],
  name: 'PauserRemoved',
  type: 'event'
}, {
  anonymous: false,
  inputs: [{
    indexed: true,
    internalType: 'address',
    name: 'from',
    type: 'address'
  }, {
    indexed: true,
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    indexed: false,
    internalType: 'uint256',
    name: 'value',
    type: 'uint256'
  }],
  name: 'Transfer',
  type: 'event'
}, {
  anonymous: false,
  inputs: [{
    indexed: false,
    internalType: 'address',
    name: 'account',
    type: 'address'
  }],
  name: 'Unpaused',
  type: 'event'
}, {
  constant: true,
  inputs: [],
  name: 'ERR_INVALID_ZERO_VALUE',
  outputs: [{
    internalType: 'uint256',
    name: '',
    type: 'uint256'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: true,
  inputs: [],
  name: 'ERR_NO_ERROR',
  outputs: [{
    internalType: 'uint256',
    name: '',
    type: 'uint256'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: false,
  inputs: [{
    internalType: 'address',
    name: 'account',
    type: 'address'
  }],
  name: 'addPauser',
  outputs: [],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  constant: true,
  inputs: [{
    internalType: 'address',
    name: 'owner',
    type: 'address'
  }, {
    internalType: 'address',
    name: 'spender',
    type: 'address'
  }],
  name: 'allowance',
  outputs: [{
    internalType: 'uint256',
    name: '',
    type: 'uint256'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: false,
  inputs: [{
    internalType: 'address',
    name: 'spender',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'value',
    type: 'uint256'
  }],
  name: 'approve',
  outputs: [{
    internalType: 'bool',
    name: '',
    type: 'bool'
  }],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  constant: true,
  inputs: [{
    internalType: 'address',
    name: 'account',
    type: 'address'
  }],
  name: 'balanceOf',
  outputs: [{
    internalType: 'uint256',
    name: '',
    type: 'uint256'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: true,
  inputs: [],
  name: 'decimals',
  outputs: [{
    internalType: 'uint8',
    name: '',
    type: 'uint8'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: false,
  inputs: [{
    internalType: 'address',
    name: 'spender',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'subtractedValue',
    type: 'uint256'
  }],
  name: 'decreaseAllowance',
  outputs: [{
    internalType: 'bool',
    name: '',
    type: 'bool'
  }],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  constant: false,
  inputs: [],
  name: 'deposit',
  outputs: [{
    internalType: 'uint256',
    name: '',
    type: 'uint256'
  }],
  payable: true,
  stateMutability: 'payable',
  type: 'function'
}, {
  constant: false,
  inputs: [{
    internalType: 'address',
    name: 'spender',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'addedValue',
    type: 'uint256'
  }],
  name: 'increaseAllowance',
  outputs: [{
    internalType: 'bool',
    name: '',
    type: 'bool'
  }],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  constant: true,
  inputs: [{
    internalType: 'address',
    name: 'account',
    type: 'address'
  }],
  name: 'isPauser',
  outputs: [{
    internalType: 'bool',
    name: '',
    type: 'bool'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: true,
  inputs: [],
  name: 'name',
  outputs: [{
    internalType: 'string',
    name: '',
    type: 'string'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: false,
  inputs: [],
  name: 'pause',
  outputs: [],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  constant: true,
  inputs: [],
  name: 'paused',
  outputs: [{
    internalType: 'bool',
    name: '',
    type: 'bool'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: false,
  inputs: [],
  name: 'renouncePauser',
  outputs: [],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  constant: true,
  inputs: [],
  name: 'symbol',
  outputs: [{
    internalType: 'string',
    name: '',
    type: 'string'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: true,
  inputs: [],
  name: 'totalSupply',
  outputs: [{
    internalType: 'uint256',
    name: '',
    type: 'uint256'
  }],
  payable: false,
  stateMutability: 'view',
  type: 'function'
}, {
  constant: false,
  inputs: [{
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'value',
    type: 'uint256'
  }],
  name: 'transfer',
  outputs: [{
    internalType: 'bool',
    name: '',
    type: 'bool'
  }],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  constant: false,
  inputs: [{
    internalType: 'address',
    name: 'from',
    type: 'address'
  }, {
    internalType: 'address',
    name: 'to',
    type: 'address'
  }, {
    internalType: 'uint256',
    name: 'value',
    type: 'uint256'
  }],
  name: 'transferFrom',
  outputs: [{
    internalType: 'bool',
    name: '',
    type: 'bool'
  }],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  constant: false,
  inputs: [],
  name: 'unpause',
  outputs: [],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}, {
  constant: false,
  inputs: [{
    internalType: 'uint256',
    name: 'amount',
    type: 'uint256'
  }],
  name: 'withdraw',
  outputs: [{
    internalType: 'uint256',
    name: '',
    type: 'uint256'
  }],
  payable: false,
  stateMutability: 'nonpayable',
  type: 'function'
}]);

/***/ }),

/***/ "./src/swap/defi/defiUtils.js":
/*!************************************!*\
  !*** ./src/swap/defi/defiUtils.js ***!
  \************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getMetaTokenAddress": function() { return /* binding */ getMetaTokenAddress; },
/* harmony export */   "getInOutTokenAddresses": function() { return /* binding */ getInOutTokenAddresses; }
/* harmony export */ });
/**
 * Get the token contract addresses from the wallet's EdgeMetaTokens
 */
var getMetaTokenAddress = function getMetaTokenAddress(metaTokens, tokenCurrencyCode) {
  var _metaToken$contractAd;

  var metaToken = metaTokens.find(function (mt) {
    return mt.currencyCode === tokenCurrencyCode;
  });
  if (metaToken == null || (metaToken === null || metaToken === void 0 ? void 0 : metaToken.contractAddress) === undefined) throw new Error('Could not find contract address for ' + tokenCurrencyCode);
  return (_metaToken$contractAd = metaToken.contractAddress) !== null && _metaToken$contractAd !== void 0 ? _metaToken$contractAd : '';
};
/**
 * Determine if the tokens are wrapped and return the appropriate wrapped
 * contract addresses, if different.
 */

var getInOutTokenAddresses = function getInOutTokenAddresses(currencyInfo, fromCurrencyCode, toCurrencyCode) {
  var nativeCurrencyCode = currencyInfo.currencyCode,
      metaTokens = currencyInfo.metaTokens;
  var wrappedCurrencyCode = "W".concat(nativeCurrencyCode);
  var isFromNativeCurrency = fromCurrencyCode === nativeCurrencyCode;
  var isToNativeCurrency = toCurrencyCode === nativeCurrencyCode;
  var isFromWrappedCurrency = fromCurrencyCode === wrappedCurrencyCode;
  var isToWrappedCurrency = toCurrencyCode === wrappedCurrencyCode;
  var isWrappingSwap = isFromNativeCurrency && isToWrappedCurrency || isFromWrappedCurrency && isToNativeCurrency;
  var fromTokenAddress = getMetaTokenAddress(metaTokens, isFromNativeCurrency ? wrappedCurrencyCode : fromCurrencyCode);
  var toTokenAddress = getMetaTokenAddress(metaTokens, isToNativeCurrency ? wrappedCurrencyCode : toCurrencyCode);
  return {
    fromTokenAddress: fromTokenAddress,
    toTokenAddress: toTokenAddress,
    isWrappingSwap: isWrappingSwap
  };
};

/***/ }),

/***/ "./src/swap/defi/uni-v2-based/plugins/spookySwap.js":
/*!**********************************************************!*\
  !*** ./src/swap/defi/uni-v2-based/plugins/spookySwap.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeSpookySwapPlugin": function() { return /* binding */ makeSpookySwapPlugin; }
/* harmony export */ });
/* harmony import */ var ethers__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ethers */ "./node_modules/@ethersproject/units/lib.esm/index.js");
/* harmony import */ var _defiUtils_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../../defiUtils.js */ "./src/swap/defi/defiUtils.js");
/* harmony import */ var _uniV2Contracts_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../uniV2Contracts.js */ "./src/swap/defi/uni-v2-based/uniV2Contracts.js");
/* harmony import */ var _uniV2Utils_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../uniV2Utils.js */ "./src/swap/defi/uni-v2-based/uniV2Utils.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }





var EXPIRATION_MS = 1000 * 20 * 60;
var SLIPPAGE = '0.05';
var swapInfo = {
  pluginId: 'spookySwap',
  displayName: 'SpookySwap',
  supportEmail: '',
  supportUrl: 'https://discord.com/invite/weXbvPAH4Q'
};
function makeSpookySwapPlugin(opts) {
  var provider = (0,_uniV2Contracts_js__WEBPACK_IMPORTED_MODULE_1__.getFtmProvider)(opts.initOptions.quiknodeApiKey);
  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var fromWallet, toWallet, fromCurrencyCode, toCurrencyCode, quoteFor, _getInOutTokenAddress, fromTokenAddress, toTokenAddress, isWrappingSwap, spookySwapRouter, _yield$getSwapAmounts, amountToSwap, expectedAmountOut, fromAddress, toAddress, expirationDate, deadline, swapTxs, pluginId, edgeUnsignedTxs;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                fromWallet = request.fromWallet, toWallet = request.toWallet, fromCurrencyCode = request.fromCurrencyCode, toCurrencyCode = request.toCurrencyCode, quoteFor = request.quoteFor; // Sanity check: Both wallets should be of the same chain.

                if (!(fromWallet.currencyInfo.currencyCode !== toWallet.currencyInfo.currencyCode)) {
                  _context2.next = 3;
                  break;
                }

                throw new Error("".concat(swapInfo.displayName, ": Mismatched wallet chain"));

              case 3:
                // Parse input/output token addresses. If either from or to swap sources
                // are for the native currency, convert the address to the wrapped equivalent.
                _getInOutTokenAddress = (0,_defiUtils_js__WEBPACK_IMPORTED_MODULE_0__.getInOutTokenAddresses)(fromWallet.currencyInfo, fromCurrencyCode, toCurrencyCode), fromTokenAddress = _getInOutTokenAddress.fromTokenAddress, toTokenAddress = _getInOutTokenAddress.toTokenAddress, isWrappingSwap = _getInOutTokenAddress.isWrappingSwap; // Calculate swap amounts

                spookySwapRouter = (0,_uniV2Contracts_js__WEBPACK_IMPORTED_MODULE_1__.makeSpookySwapRouterContract)(provider);
                _context2.next = 7;
                return (0,_uniV2Utils_js__WEBPACK_IMPORTED_MODULE_2__.getSwapAmounts)(spookySwapRouter, quoteFor, request.nativeAmount, fromTokenAddress, toTokenAddress, isWrappingSwap);

              case 7:
                _yield$getSwapAmounts = _context2.sent;
                amountToSwap = _yield$getSwapAmounts.amountToSwap;
                expectedAmountOut = _yield$getSwapAmounts.expectedAmountOut;
                _context2.next = 12;
                return fromWallet.getReceiveAddress();

              case 12:
                fromAddress = _context2.sent.publicAddress;
                _context2.next = 15;
                return toWallet.getReceiveAddress();

              case 15:
                toAddress = _context2.sent.publicAddress;
                expirationDate = new Date(Date.now() + EXPIRATION_MS);
                deadline = Math.round(expirationDate.getTime() / 1000); // unix timestamp

                _context2.next = 20;
                return (0,_uniV2Utils_js__WEBPACK_IMPORTED_MODULE_2__.getSwapTransactions)(provider, request, spookySwapRouter, amountToSwap, expectedAmountOut, toAddress, SLIPPAGE, deadline);

              case 20:
                swapTxs = _context2.sent;
                pluginId = swapInfo.pluginId;
                _context2.next = 24;
                return Promise.all(swapTxs.map( /*#__PURE__*/function () {
                  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(swapTx) {
                    var edgeSpendInfo, edgeUnsignedTx;
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            // Convert to our spendInfo
                            edgeSpendInfo = {
                              pluginId: pluginId,
                              currencyCode: request.fromCurrencyCode,
                              // what is being sent out, only if token. Blank if not token
                              spendTargets: [{
                                nativeAmount: swapTx.value ? swapTx.value.toString() : '0',
                                // biggy/number string integer
                                publicAddress: swapTx.to,
                                otherParams: {
                                  data: swapTx.data
                                }
                              }],
                              customNetworkFee: {
                                gasPrice: ethers__WEBPACK_IMPORTED_MODULE_3__.formatUnits(swapTx.gasPrice, 'gwei').toString(),
                                gasLimit: swapTx.gasLimit.toString()
                              },
                              networkFeeOption: 'custom',
                              swapData: {
                                isEstimate: false,
                                payoutAddress: toAddress,
                                payoutCurrencyCode: request.toCurrencyCode,
                                payoutNativeAmount: expectedAmountOut.toString(),
                                payoutWalletId: request.toWallet.id,
                                plugin: _objectSpread({}, swapInfo),
                                refundAddress: fromAddress
                              }
                            };
                            _context.next = 3;
                            return request.fromWallet.makeSpend(edgeSpendInfo);

                          case 3:
                            edgeUnsignedTx = _context.sent;
                            return _context.abrupt("return", edgeUnsignedTx);

                          case 5:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));

                  return function (_x) {
                    return _ref.apply(this, arguments);
                  };
                }()));

              case 24:
                edgeUnsignedTxs = _context2.sent;
                return _context2.abrupt("return", (0,_uniV2Utils_js__WEBPACK_IMPORTED_MODULE_2__.makeUniV2EdgeSwapQuote)(request, amountToSwap.toString(), expectedAmountOut.toString(), edgeUnsignedTxs, toAddress, pluginId, true, expirationDate));

              case 26:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/swap/defi/uni-v2-based/plugins/tombSwap.js":
/*!********************************************************!*\
  !*** ./src/swap/defi/uni-v2-based/plugins/tombSwap.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeTombSwapPlugin": function() { return /* binding */ makeTombSwapPlugin; }
/* harmony export */ });
/* harmony import */ var ethers__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ethers */ "./node_modules/@ethersproject/units/lib.esm/index.js");
/* harmony import */ var _defiUtils_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../../defiUtils.js */ "./src/swap/defi/defiUtils.js");
/* harmony import */ var _uniV2Contracts_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../uniV2Contracts.js */ "./src/swap/defi/uni-v2-based/uniV2Contracts.js");
/* harmony import */ var _uniV2Utils_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../uniV2Utils.js */ "./src/swap/defi/uni-v2-based/uniV2Utils.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }





var EXPIRATION_MS = 1000 * 20 * 60;
var SLIPPAGE = '0.05';
var swapInfo = {
  pluginId: 'tombSwap',
  displayName: 'TombSwap',
  supportEmail: '',
  supportUrl: 'https://discord.gg/vANnESmVdz'
};
function makeTombSwapPlugin(opts) {
  var provider = (0,_uniV2Contracts_js__WEBPACK_IMPORTED_MODULE_1__.getFtmProvider)(opts.initOptions.quiknodeApiKey);
  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var fromWallet, toWallet, fromCurrencyCode, toCurrencyCode, quoteFor, _getInOutTokenAddress, fromTokenAddress, toTokenAddress, isWrappingSwap, tombSwapRouter, _yield$getSwapAmounts, amountToSwap, expectedAmountOut, toAddress, expirationDate, deadline, swapTxs, fromAddress, pluginId, edgeUnsignedTxs;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                fromWallet = request.fromWallet, toWallet = request.toWallet, fromCurrencyCode = request.fromCurrencyCode, toCurrencyCode = request.toCurrencyCode, quoteFor = request.quoteFor; // Sanity check: Both wallets should be of the same chain.

                if (!(fromWallet.currencyInfo.currencyCode !== toWallet.currencyInfo.currencyCode)) {
                  _context2.next = 3;
                  break;
                }

                throw new Error("".concat(swapInfo.displayName, ": Mismatched wallet chain"));

              case 3:
                // Parse input/output token addresses. If either from or to swap sources
                // are for the native currency, convert the address to the wrapped equivalent.
                _getInOutTokenAddress = (0,_defiUtils_js__WEBPACK_IMPORTED_MODULE_0__.getInOutTokenAddresses)(fromWallet.currencyInfo, fromCurrencyCode, toCurrencyCode), fromTokenAddress = _getInOutTokenAddress.fromTokenAddress, toTokenAddress = _getInOutTokenAddress.toTokenAddress, isWrappingSwap = _getInOutTokenAddress.isWrappingSwap; // Calculate swap amounts

                tombSwapRouter = (0,_uniV2Contracts_js__WEBPACK_IMPORTED_MODULE_1__.makeTombSwapRouterContract)(provider);
                _context2.next = 7;
                return (0,_uniV2Utils_js__WEBPACK_IMPORTED_MODULE_2__.getSwapAmounts)(tombSwapRouter, quoteFor, request.nativeAmount, fromTokenAddress, toTokenAddress, isWrappingSwap);

              case 7:
                _yield$getSwapAmounts = _context2.sent;
                amountToSwap = _yield$getSwapAmounts.amountToSwap;
                expectedAmountOut = _yield$getSwapAmounts.expectedAmountOut;
                _context2.next = 12;
                return toWallet.getReceiveAddress();

              case 12:
                toAddress = _context2.sent.publicAddress;
                expirationDate = new Date(Date.now() + EXPIRATION_MS);
                deadline = Math.round(expirationDate.getTime() / 1000); // unix timestamp

                _context2.next = 17;
                return (0,_uniV2Utils_js__WEBPACK_IMPORTED_MODULE_2__.getSwapTransactions)(provider, request, tombSwapRouter, amountToSwap, expectedAmountOut, toAddress, SLIPPAGE, deadline);

              case 17:
                swapTxs = _context2.sent;
                _context2.next = 20;
                return fromWallet.getReceiveAddress();

              case 20:
                fromAddress = _context2.sent.publicAddress;
                pluginId = swapInfo.pluginId; // toEdgeUnsignedTxs

                _context2.next = 24;
                return Promise.all(swapTxs.map( /*#__PURE__*/function () {
                  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(swapTx) {
                    var edgeSpendInfo, edgeUnsignedTx;
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            // Convert to our spendInfo
                            edgeSpendInfo = {
                              pluginId: pluginId,
                              currencyCode: request.fromCurrencyCode,
                              // what is being sent out, only if token. Blank if not token
                              spendTargets: [{
                                nativeAmount: swapTx.value ? swapTx.value.toString() : '0',
                                // biggy/number string integer
                                publicAddress: swapTx.to,
                                otherParams: {
                                  data: swapTx.data
                                }
                              }],
                              customNetworkFee: {
                                gasPrice: ethers__WEBPACK_IMPORTED_MODULE_3__.formatUnits(swapTx.gasPrice, 'gwei').toString(),
                                gasLimit: swapTx.gasLimit.toString()
                              },
                              networkFeeOption: 'custom',
                              swapData: {
                                isEstimate: false,
                                payoutAddress: toAddress,
                                payoutCurrencyCode: request.toCurrencyCode,
                                payoutNativeAmount: expectedAmountOut.toString(),
                                payoutWalletId: request.toWallet.id,
                                plugin: _objectSpread({}, swapInfo),
                                refundAddress: fromAddress
                              }
                            };
                            _context.next = 3;
                            return request.fromWallet.makeSpend(edgeSpendInfo);

                          case 3:
                            edgeUnsignedTx = _context.sent;
                            return _context.abrupt("return", edgeUnsignedTx);

                          case 5:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));

                  return function (_x) {
                    return _ref.apply(this, arguments);
                  };
                }()));

              case 24:
                edgeUnsignedTxs = _context2.sent;
                return _context2.abrupt("return", (0,_uniV2Utils_js__WEBPACK_IMPORTED_MODULE_2__.makeUniV2EdgeSwapQuote)(request, amountToSwap.toString(), expectedAmountOut.toString(), edgeUnsignedTxs, toAddress, pluginId, true, expirationDate));

              case 26:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/swap/defi/uni-v2-based/uniV2Contracts.js":
/*!******************************************************!*\
  !*** ./src/swap/defi/uni-v2-based/uniV2Contracts.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "FTM_FALLBACK_PROVIDER_URL": function() { return /* binding */ FTM_FALLBACK_PROVIDER_URL; },
/* harmony export */   "FTM_BASE_QUIKNODE_URL": function() { return /* binding */ FTM_BASE_QUIKNODE_URL; },
/* harmony export */   "getFtmProvider": function() { return /* binding */ getFtmProvider; },
/* harmony export */   "makeSpookySwapRouterContract": function() { return /* binding */ makeSpookySwapRouterContract; },
/* harmony export */   "makeTombSwapRouterContract": function() { return /* binding */ makeTombSwapRouterContract; },
/* harmony export */   "makeWrappedFtmContract": function() { return /* binding */ makeWrappedFtmContract; },
/* harmony export */   "makeErc20Contract": function() { return /* binding */ makeErc20Contract; }
/* harmony export */ });
/* harmony import */ var ethers__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ethers */ "./node_modules/@ethersproject/providers/lib.esm/index.js");
/* harmony import */ var ethers__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ethers */ "./node_modules/@ethersproject/contracts/lib.esm/index.js");
/* harmony import */ var _abi_UNISWAP_V2_ERC20_ABI__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../abi/UNISWAP_V2_ERC20_ABI */ "./src/swap/defi/abi/UNISWAP_V2_ERC20_ABI.js");
/* harmony import */ var _abi_UNISWAP_V2_ROUTER_ABI__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../abi/UNISWAP_V2_ROUTER_ABI */ "./src/swap/defi/abi/UNISWAP_V2_ROUTER_ABI.js");
/* harmony import */ var _abi_WRAPPED_FTM_ABI__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../abi/WRAPPED_FTM_ABI */ "./src/swap/defi/abi/WRAPPED_FTM_ABI.js");




 //
// Providers
//
// TOOD: Use FallbackProvider when it's patched https://github.com/ethers-io/ethers.js/issues/2837

var FTM_FALLBACK_PROVIDER_URL = 'https://rpc.ftm.tools';
var FTM_BASE_QUIKNODE_URL = 'https://polished-empty-cloud.fantom.quiknode.pro/';
var getFtmProvider = function getFtmProvider(quiknodeApiKey) {
  return new ethers__WEBPACK_IMPORTED_MODULE_3__.JsonRpcProvider(quiknodeApiKey != null && quiknodeApiKey !== '' ? "".concat(FTM_BASE_QUIKNODE_URL).concat(quiknodeApiKey) : FTM_FALLBACK_PROVIDER_URL);
}; //
// Contracts
//
// Routers

var SPOOKYSWAP_ROUTER_ADDRESS = '0xF491e7B69E4244ad4002BC14e878a34207E38c29';
var makeSpookySwapRouterContract = function makeSpookySwapRouterContract(provider) {
  return new ethers__WEBPACK_IMPORTED_MODULE_4__.Contract(SPOOKYSWAP_ROUTER_ADDRESS, _abi_UNISWAP_V2_ROUTER_ABI__WEBPACK_IMPORTED_MODULE_1__.default, provider);
};
var TOMBSWAP_ROUTER_ADDRESS = '0x6D0176C5ea1e44b08D3dd001b0784cE42F47a3A7';
var makeTombSwapRouterContract = function makeTombSwapRouterContract(provider) {
  return new ethers__WEBPACK_IMPORTED_MODULE_4__.Contract(TOMBSWAP_ROUTER_ADDRESS, _abi_UNISWAP_V2_ROUTER_ABI__WEBPACK_IMPORTED_MODULE_1__.default, provider);
}; // Wrapped Tokens

var WFTM_TOKEN_ADDRESS = '0x21be370D5312f44cB42ce377BC9b8a0cEF1A4C83';
var makeWrappedFtmContract = function makeWrappedFtmContract(provider) {
  return new ethers__WEBPACK_IMPORTED_MODULE_4__.Contract(WFTM_TOKEN_ADDRESS, _abi_WRAPPED_FTM_ABI__WEBPACK_IMPORTED_MODULE_2__.default, provider);
};
var makeErc20Contract = function makeErc20Contract(provider, tokenAddress) {
  return new ethers__WEBPACK_IMPORTED_MODULE_4__.Contract(tokenAddress, _abi_UNISWAP_V2_ERC20_ABI__WEBPACK_IMPORTED_MODULE_0__.default, provider);
};

/***/ }),

/***/ "./src/swap/defi/uni-v2-based/uniV2Utils.js":
/*!**************************************************!*\
  !*** ./src/swap/defi/uni-v2-based/uniV2Utils.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getSwapAmounts": function() { return /* binding */ getSwapAmounts; },
/* harmony export */   "getSwapTransactions": function() { return /* binding */ getSwapTransactions; },
/* harmony export */   "makeUniV2EdgeSwapQuote": function() { return /* binding */ makeUniV2EdgeSwapQuote; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
/* harmony import */ var ethers__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ethers */ "./node_modules/@ethersproject/constants/lib.esm/bignumbers.js");
/* harmony import */ var _util_biggystringplus_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../../util/biggystringplus.js */ "./src/util/biggystringplus.js");
/* harmony import */ var _defiUtils_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../defiUtils.js */ "./src/swap/defi/defiUtils.js");
/* harmony import */ var _uniV2Contracts_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./uniV2Contracts.js */ "./src/swap/defi/uni-v2-based/uniV2Contracts.js");
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }







/**
 * Get the output swap amounts based on the requested input amount.
 * Call the router contract to calculate amounts and check if the swap path is
 * supported.
 */

var getSwapAmounts = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(router, quoteFor, nativeAmount, fromTokenAddress, toTokenAddress, isWrappingSwap) {
    var path, _map, _map2, amountToSwap, expectedAmountOut;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            path = [fromTokenAddress, toTokenAddress];

            if (!isWrappingSwap) {
              _context.next = 5;
              break;
            }

            _context.t0 = [nativeAmount, nativeAmount];
            _context.next = 20;
            break;

          case 5:
            if (!(quoteFor === 'to')) {
              _context.next = 11;
              break;
            }

            _context.next = 8;
            return router.getAmountsIn(nativeAmount, path);

          case 8:
            _context.t1 = _context.sent;
            _context.next = 19;
            break;

          case 11:
            if (!(quoteFor === 'from')) {
              _context.next = 17;
              break;
            }

            _context.next = 14;
            return router.getAmountsOut(nativeAmount, path);

          case 14:
            _context.t2 = _context.sent;
            _context.next = 18;
            break;

          case 17:
            _context.t2 = [];

          case 18:
            _context.t1 = _context.t2;

          case 19:
            _context.t0 = _context.t1;

          case 20:
            _map = _context.t0.map(String);
            _map2 = _slicedToArray(_map, 2);
            amountToSwap = _map2[0];
            expectedAmountOut = _map2[1];

            if (!(!amountToSwap || !expectedAmountOut)) {
              _context.next = 26;
              break;
            }

            throw new Error("Failed to calculate amounts");

          case 26:
            return _context.abrupt("return", {
              amountToSwap: amountToSwap,
              expectedAmountOut: expectedAmountOut
            });

          case 27:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getSwapAmounts(_x, _x2, _x3, _x4, _x5, _x6) {
    return _ref.apply(this, arguments);
  };
}();
/**
 * Get smart contract transaction(s) necessary to swap based on swap params
 */

var getSwapTransactions = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(provider, swapRequest, router, amountToSwap, expectedAmountOut, toAddress, slippage, deadline) {
    var fromWallet, fromCurrencyCode, toCurrencyCode, _fromWallet$currencyI, nativeCurrencyCode, metaTokens, fromAddress, wrappedCurrencyCode, isFromNativeCurrency, isToNativeCurrency, isFromWrappedCurrency, isToWrappedCurrency, fromTokenAddress, toTokenAddress, path, gasPrice, addressToApproveTxs, txs;

    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            fromWallet = swapRequest.fromWallet, fromCurrencyCode = swapRequest.fromCurrencyCode, toCurrencyCode = swapRequest.toCurrencyCode;
            _fromWallet$currencyI = fromWallet.currencyInfo, nativeCurrencyCode = _fromWallet$currencyI.currencyCode, metaTokens = _fromWallet$currencyI.metaTokens;
            _context4.next = 4;
            return fromWallet.getReceiveAddress();

          case 4:
            fromAddress = _context4.sent.publicAddress;
            // TODO: Use our new denom implementation to get native amounts
            wrappedCurrencyCode = "W".concat(nativeCurrencyCode);
            isFromNativeCurrency = fromCurrencyCode === nativeCurrencyCode;
            isToNativeCurrency = toCurrencyCode === nativeCurrencyCode;
            isFromWrappedCurrency = fromCurrencyCode === wrappedCurrencyCode;
            isToWrappedCurrency = toCurrencyCode === wrappedCurrencyCode;
            fromTokenAddress = (0,_defiUtils_js__WEBPACK_IMPORTED_MODULE_2__.getMetaTokenAddress)(metaTokens, isFromNativeCurrency ? wrappedCurrencyCode : fromCurrencyCode);
            toTokenAddress = (0,_defiUtils_js__WEBPACK_IMPORTED_MODULE_2__.getMetaTokenAddress)(metaTokens, isToNativeCurrency ? wrappedCurrencyCode : toCurrencyCode); // Determine router method name and params

            if (!(isFromNativeCurrency && isToNativeCurrency)) {
              _context4.next = 14;
              break;
            }

            throw new Error('Invalid swap: Cannot swap to the same native currency');

          case 14:
            path = [fromTokenAddress, toTokenAddress];
            _context4.next = 17;
            return provider.getGasPrice();

          case 17:
            gasPrice = _context4.sent;

            addressToApproveTxs = /*#__PURE__*/function () {
              var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(tokenAddress, contractAddress) {
                var tokenContract, allowence;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        tokenContract = (0,_uniV2Contracts_js__WEBPACK_IMPORTED_MODULE_3__.makeErc20Contract)(provider, tokenAddress);
                        _context2.next = 3;
                        return tokenContract.allowance(fromAddress, contractAddress);

                      case 3:
                        allowence = _context2.sent;

                        if (!allowence.sub(amountToSwap).lt(0)) {
                          _context2.next = 6;
                          break;
                        }

                        return _context2.abrupt("return", tokenContract.populateTransaction.approve(contractAddress, ethers__WEBPACK_IMPORTED_MODULE_4__.MaxUint256, {
                          gasLimit: '60000',
                          gasPrice: gasPrice
                        }));

                      case 6:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function addressToApproveTxs(_x15, _x16) {
                return _ref3.apply(this, arguments);
              };
            }();

            _context4.next = 21;
            return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
              var slippageMultiplier;
              return regeneratorRuntime.wrap(function _callee3$(_context3) {
                while (1) {
                  switch (_context3.prev = _context3.next) {
                    case 0:
                      if (!(isFromNativeCurrency && isToWrappedCurrency)) {
                        _context3.next = 2;
                        break;
                      }

                      return _context3.abrupt("return", [_uniV2Contracts_js__WEBPACK_IMPORTED_MODULE_3__.makeWrappedFtmContract.populateTransaction.deposit({
                        gasLimit: '51000',
                        gasPrice: gasPrice,
                        value: amountToSwap
                      })]);

                    case 2:
                      if (!(isFromWrappedCurrency && isToNativeCurrency)) {
                        _context3.next = 4;
                        break;
                      }

                      return _context3.abrupt("return", [// Deposit Tx
                      _uniV2Contracts_js__WEBPACK_IMPORTED_MODULE_3__.makeWrappedFtmContract.populateTransaction.withdraw(amountToSwap, {
                        gasLimit: '51000',
                        gasPrice: gasPrice
                      })]);

                    case 4:
                      // Swap native currency for token
                      slippageMultiplier = (0,biggystring__WEBPACK_IMPORTED_MODULE_0__.sub)('1', slippage);

                      if (!(isFromNativeCurrency && !isToNativeCurrency)) {
                        _context3.next = 7;
                        break;
                      }

                      return _context3.abrupt("return", [// Swap Tx
                      router.populateTransaction.swapExactETHForTokens((0,_util_biggystringplus_js__WEBPACK_IMPORTED_MODULE_1__.round)((0,biggystring__WEBPACK_IMPORTED_MODULE_0__.mul)(expectedAmountOut, slippageMultiplier)), path, toAddress, deadline, {
                        gasLimit: '250000',
                        gasPrice: gasPrice,
                        value: amountToSwap
                      })]);

                    case 7:
                      if (!(!isFromNativeCurrency && isToNativeCurrency)) {
                        _context3.next = 13;
                        break;
                      }

                      _context3.next = 10;
                      return addressToApproveTxs(path[0], router.address);

                    case 10:
                      _context3.t0 = _context3.sent;
                      _context3.t1 = // Swap Tx
                      router.populateTransaction.swapExactTokensForETH(amountToSwap, (0,_util_biggystringplus_js__WEBPACK_IMPORTED_MODULE_1__.round)((0,biggystring__WEBPACK_IMPORTED_MODULE_0__.mul)(expectedAmountOut, slippageMultiplier)), path, toAddress, deadline, {
                        gasLimit: '250000',
                        gasPrice: gasPrice
                      });
                      return _context3.abrupt("return", [_context3.t0, _context3.t1]);

                    case 13:
                      if (!(!isFromNativeCurrency && !isToNativeCurrency)) {
                        _context3.next = 19;
                        break;
                      }

                      _context3.next = 16;
                      return addressToApproveTxs(path[0], router.address);

                    case 16:
                      _context3.t2 = _context3.sent;
                      _context3.t3 = // Swap Tx
                      router.populateTransaction.swapExactTokensForTokens(amountToSwap, (0,_util_biggystringplus_js__WEBPACK_IMPORTED_MODULE_1__.round)((0,biggystring__WEBPACK_IMPORTED_MODULE_0__.mul)(expectedAmountOut, slippageMultiplier)), path, toAddress, deadline, {
                        gasLimit: '600000',
                        gasPrice: gasPrice
                      });
                      return _context3.abrupt("return", [_context3.t2, _context3.t3]);

                    case 19:
                      throw new Error('Unhandled swap type');

                    case 20:
                    case "end":
                      return _context3.stop();
                  }
                }
              }, _callee3);
            }))();

          case 21:
            txs = _context4.sent;
            _context4.next = 24;
            return Promise.all(txs.filter(function (tx) {
              return tx != null;
            }));

          case 24:
            return _context4.abrupt("return", _context4.sent);

          case 25:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function getSwapTransactions(_x7, _x8, _x9, _x10, _x11, _x12, _x13, _x14) {
    return _ref2.apply(this, arguments);
  };
}();
/**
 * Generate the quote with approve() method
 * */

function makeUniV2EdgeSwapQuote(request, fromNativeAmount, toNativeAmount, txs, toAddress, pluginId) {
  var isEstimate = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : false;
  var expirationDate = arguments.length > 7 ? arguments[7] : undefined;
  var quoteId = arguments.length > 8 ? arguments[8] : undefined;
  var fromWallet = request.fromWallet;
  var swapTx = txs[txs.length - 1];
  var out = {
    fromNativeAmount: fromNativeAmount,
    toNativeAmount: toNativeAmount,
    networkFee: {
      currencyCode: fromWallet.currencyInfo.currencyCode,
      nativeAmount: swapTx.parentNetworkFee != null ? swapTx.parentNetworkFee : swapTx.networkFee
    },
    toAddress: toAddress,
    pluginId: pluginId,
    expirationDate: expirationDate,
    quoteId: quoteId,
    isEstimate: isEstimate,
    approve: function approve() {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
        var swapTx, index, _i3, tx, signedTransaction, lastTransactionIndex;

        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                index = 0;
                _i3 = 0;

              case 2:
                if (!(_i3 < txs.length)) {
                  _context5.next = 18;
                  break;
                }

                tx = txs[_i3];
                _context5.next = 6;
                return fromWallet.signTx(tx);

              case 6:
                signedTransaction = _context5.sent;
                _context5.next = 9;
                return fromWallet.broadcastTx(signedTransaction);

              case 9:
                swapTx = _context5.sent;
                lastTransactionIndex = txs.length - 1; // if it's the last transaction of the array then assign `nativeAmount` data
                // (after signing and broadcasting) for metadata purposes

                if (index === lastTransactionIndex) {
                  tx.nativeAmount = "-".concat(fromNativeAmount);
                }

                _context5.next = 14;
                return fromWallet.saveTx(signedTransaction);

              case 14:
                index++;

              case 15:
                _i3++;
                _context5.next = 2;
                break;

              case 18:
                if (swapTx) {
                  _context5.next = 20;
                  break;
                }

                throw new Error("No ".concat(pluginId, " swapTx generated."));

              case 20:
                return _context5.abrupt("return", {
                  transaction: swapTx,
                  orderId: swapTx.txid,
                  toAddress: toAddress
                });

              case 21:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }))();
    },
    close: function close() {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/swap/exolix.js":
/*!****************************!*\
  !*** ./src/swap/exolix.js ***!
  \****************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeExolixPlugin": function() { return /* binding */ makeExolixPlugin; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../swap-helpers.js */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }




var INVALID_CURRENCY_CODES = {
  from: {
    binancesmartchain: 'allCodes'
  },
  to: {
    binancesmartchain: 'allCodes',
    zcash: ['ZEC']
  }
};
var pluginId = 'exolix';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Exolix',
  supportEmail: 'support@exolix.com'
};
var orderUri = 'https://exolix.com/transaction/';
var uri = 'https://exolix.com/api/';
var expirationMs = 1000 * 60 * 60;
var dontUseLegacy = {
  DGB: true
};

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(wallet, currencyCode) {
    var addressInfo;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context4.sent;
            return _context4.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _getAddress.apply(this, arguments);
}

function makeExolixPlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;

  if (initOptions.apiKey == null) {
    throw new Error('No Exolix apiKey provided.');
  }

  var apiKey = initOptions.apiKey;

  function call(_x3, _x4) {
    return _call.apply(this, arguments);
  }

  function _call() {
    _call = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(route, params) {
      var body, headers, response;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              body = JSON.stringify(params);
              headers = {
                Accept: 'application/json',
                'Content-Type': 'application/json',
                Authorization: "".concat(apiKey)
              };
              _context3.next = 4;
              return fetchCors(uri + route, {
                method: 'POST',
                body: body,
                headers: headers
              });

            case 4:
              response = _context3.sent;

              if (response.ok) {
                _context3.next = 9;
                break;
              }

              if (!(response.status === 422)) {
                _context3.next = 8;
                break;
              }

              throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapCurrencyError(swapInfo, params.coin_from, params.coin_to);

            case 8:
              throw new Error("Exolix returned error code ".concat(response.status));

            case 9:
              return _context3.abrupt("return", response.json());

            case 10:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));
    return _call.apply(this, arguments);
  }

  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings) {
      var _this = this;

      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var fixedPromise, fixedResult;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo);
                fixedPromise = _this.getFixedQuote(request, userSettings);
                _context.next = 4;
                return fixedPromise;

              case 4:
                fixedResult = _context.sent;
                return _context.abrupt("return", fixedResult);

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },
    getFixedQuote: function getFixedQuote(request, userSettings) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var _yield$Promise$all, _yield$Promise$all2, fromAddress, toAddress, quoteAmount, _getCodes, fromCurrencyCode, toCurrencyCode, fromMainnetCode, toMainnetCode, safeFromCurrencyCode, safeToCurrencyCode, quoteParams, rateResponse, nativeMin, exchangeParams, quoteInfo, fromNativeAmount, toNativeAmount, spendInfo, tx;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

              case 2:
                _yield$Promise$all = _context2.sent;
                _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
                fromAddress = _yield$Promise$all2[0];
                toAddress = _yield$Promise$all2[1];

                if (!(request.quoteFor === 'from')) {
                  _context2.next = 12;
                  break;
                }

                _context2.next = 9;
                return request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode);

              case 9:
                _context2.t0 = _context2.sent;
                _context2.next = 15;
                break;

              case 12:
                _context2.next = 14;
                return request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

              case 14:
                _context2.t0 = _context2.sent;

              case 15:
                quoteAmount = _context2.t0;
                _getCodes = (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.getCodes)(request), fromCurrencyCode = _getCodes.fromCurrencyCode, toCurrencyCode = _getCodes.toCurrencyCode, fromMainnetCode = _getCodes.fromMainnetCode, toMainnetCode = _getCodes.toMainnetCode; // The Exolix documentation doesn't detail this mainnetCode:currencyCode functionality
                // but it's been verified by testing

                safeFromCurrencyCode = "".concat(fromMainnetCode, ":").concat(fromCurrencyCode);
                safeToCurrencyCode = "".concat(toMainnetCode, ":").concat(toCurrencyCode); // Swap the currencies if we need a reverse quote:

                quoteParams = request.quoteFor === 'from' ? {
                  coin_from: safeFromCurrencyCode,
                  coin_to: safeToCurrencyCode,
                  deposit_amount: quoteAmount,
                  rate_type: 'fixed'
                } : {
                  coin_from: safeToCurrencyCode,
                  coin_to: safeFromCurrencyCode,
                  deposit_amount: quoteAmount,
                  rate_type: 'fixed'
                }; // Get Rate

                _context2.next = 22;
                return call('rate', quoteParams);

              case 22:
                rateResponse = _context2.sent;
                _context2.next = 25;
                return request.fromWallet.denominationToNative(rateResponse.min_amount, request.fromCurrencyCode);

              case 25:
                nativeMin = _context2.sent;

                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(request.nativeAmount, nativeMin)) {
                  _context2.next = 28;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapBelowLimitError(swapInfo, nativeMin);

              case 28:
                // Make the transaction:
                exchangeParams = {
                  coin_from: quoteParams.coin_from,
                  coin_to: quoteParams.coin_to,
                  deposit_amount: quoteAmount,
                  destination_address: toAddress,
                  destination_extra: '',
                  refund_address: fromAddress,
                  refund_extra: '',
                  rate_type: 'fixed'
                };
                _context2.next = 31;
                return call('exchange', exchangeParams);

              case 31:
                quoteInfo = _context2.sent;
                _context2.next = 34;
                return request.fromWallet.denominationToNative(quoteInfo.amount_from.toString(), request.fromCurrencyCode);

              case 34:
                fromNativeAmount = _context2.sent;
                _context2.next = 37;
                return request.toWallet.denominationToNative(quoteInfo.amount_to.toString(), request.toCurrencyCode);

              case 37:
                toNativeAmount = _context2.sent;
                spendInfo = {
                  currencyCode: request.fromCurrencyCode,
                  spendTargets: [{
                    nativeAmount: fromNativeAmount,
                    publicAddress: quoteInfo.deposit_address,
                    uniqueIdentifier: quoteInfo.deposit_extra || undefined
                  }],
                  networkFeeOption: request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                  swapData: {
                    orderId: quoteInfo.id,
                    orderUri: orderUri + quoteInfo.id,
                    isEstimate: false,
                    payoutAddress: toAddress,
                    payoutCurrencyCode: request.toCurrencyCode,
                    payoutNativeAmount: toNativeAmount,
                    payoutWalletId: request.toWallet.id,
                    plugin: _objectSpread({}, swapInfo),
                    refundAddress: fromAddress
                  }
                };
                _context2.next = 41;
                return request.fromWallet.makeSpend(spendInfo);

              case 41:
                tx = _context2.sent;
                return _context2.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.makeSwapPluginQuote)(request, fromNativeAmount, toNativeAmount, tx, toAddress, pluginId, false, new Date(Date.now() + expirationMs), quoteInfo.id));

              case 43:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/swap/foxExchange.js":
/*!*********************************!*\
  !*** ./src/swap/foxExchange.js ***!
  \*********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeFoxExchangePlugin": function() { return /* binding */ makeFoxExchangePlugin; }
/* harmony export */ });
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _swap_helpers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../swap-helpers */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }



var pluginId = 'foxExchange';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Fox Exchange',
  supportEmail: 'support@fox.exchange'
};
var orderUri = 'https://fox.exchange/tx/';
var uri = 'https://fox.exchange/api/cs';
var expirationMs = 1000 * 60 * 20;
var INVALID_CURRENCY_CODES = {
  from: {
    ethereum: ['MATIC'],
    avalanche: 'allTokens',
    binancesmartchain: 'allCodes',
    celo: 'allTokens',
    fantom: 'allCodes',
    polygon: 'allCodes'
  },
  to: {
    ethereum: ['MATIC'],
    avalanche: 'allTokens',
    binancesmartchain: 'allCodes',
    celo: 'allTokens',
    fantom: 'allCodes',
    polygon: 'allCodes',
    zcash: ['ZEC']
  }
};
var dontUseLegacy = {
  DGB: true,
  LTC: true,
  BCH: true
};

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(wallet, currencyCode) {
    var addressInfo;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context5.sent;
            return _context5.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _getAddress.apply(this, arguments);
}

function makeFoxExchangePlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;

  if (initOptions.apiKey == null) {
    throw new Error('No fox.exchange apiKey provided.');
  }

  var apiKey = initOptions.apiKey;
  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var post, _post, rateReq, rateResp, sourceAmount, targetAmount, dummyAddress, dummyTx, destinationAddress, quote;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _post = function _post3() {
                  _post = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(path, data) {
                    var body, response, json;
                    return regeneratorRuntime.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            log("request to ".concat(path), data);
                            body = JSON.stringify(data);
                            _context3.next = 4;
                            return fetchCors("".concat(uri).concat(path), {
                              method: 'POST',
                              body: body,
                              headers: {
                                'Content-Type': 'application/json',
                                Accept: 'application/json',
                                'X-API-Key': apiKey,
                                'X-User-IP': 'same_as_requester'
                              }
                            });

                          case 4:
                            response = _context3.sent;
                            _context3.next = 7;
                            return response.json();

                          case 7:
                            json = _context3.sent;
                            log("reply to ".concat(path, " (").concat(response.status, ")"), json);

                            if (json) {
                              _context3.next = 13;
                              break;
                            }

                            throw new Error("fox returned error code ".concat(response.status));

                          case 13:
                            if (json.success) {
                              _context3.next = 30;
                              break;
                            }

                            if (!(json.code === 'invalid_symbol' || json.code === 'trade_pair_disabled')) {
                              _context3.next = 18;
                              break;
                            }

                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

                          case 18:
                            if (!(json.code === 'region_lock')) {
                              _context3.next = 22;
                              break;
                            }

                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapPermissionError(swapInfo, 'geoRestriction');

                          case 22:
                            if (!(json.code === 'min_limit_breached')) {
                              _context3.next = 26;
                              break;
                            }

                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapBelowLimitError(swapInfo, request.nativeAmount);

                          case 26:
                            if (!(json.code === 'max_limit_breached')) {
                              _context3.next = 28;
                              break;
                            }

                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapAboveLimitError(swapInfo, request.nativeAmount);

                          case 28:
                            log.error('error:', json);
                            throw new Error('fox.exchange replied: ' + json.error || 0);

                          case 30:
                            return _context3.abrupt("return", json.data);

                          case 31:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));
                  return _post.apply(this, arguments);
                };

                post = function _post2(_x3, _x4) {
                  return _post.apply(this, arguments);
                };

                (0,_swap_helpers__WEBPACK_IMPORTED_MODULE_1__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo);
                _context4.prev = 3;
                rateReq = {
                  depositCoin: request.fromCurrencyCode,
                  destinationCoin: request.toCurrencyCode,
                  requestFixed: true,
                  requestDummyAddress: true
                };

                if (!(request.quoteFor === 'from')) {
                  _context4.next = 13;
                  break;
                }

                _context4.t0 = Number;
                _context4.next = 9;
                return request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode);

              case 9:
                _context4.t1 = _context4.sent;
                rateReq.depositCoinAmount = (0, _context4.t0)(_context4.t1);
                _context4.next = 18;
                break;

              case 13:
                _context4.t2 = Number;
                _context4.next = 16;
                return request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

              case 16:
                _context4.t3 = _context4.sent;
                rateReq.destinationCoinAmount = (0, _context4.t2)(_context4.t3);

              case 18:
                _context4.next = 20;
                return post('/rate', rateReq);

              case 20:
                rateResp = _context4.sent;

                if (!(request.quoteFor === 'from')) {
                  _context4.next = 47;
                  break;
                }

                if (!rateResp.destinationCoinAmount) {
                  _context4.next = 26;
                  break;
                }

                targetAmount = rateResp.destinationCoinAmount;
                _context4.next = 45;
                break;

              case 26:
                if (!(rateReq.depositCoinAmount && rateResp.limitMinDepositCoin && rateReq.depositCoinAmount < rateResp.limitMinDepositCoin)) {
                  _context4.next = 35;
                  break;
                }

                _context4.t4 = edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapBelowLimitError;
                _context4.t5 = swapInfo;
                _context4.next = 31;
                return request.fromWallet.denominationToNative(String(rateResp.limitMinDepositCoin), request.fromCurrencyCode);

              case 31:
                _context4.t6 = _context4.sent;
                throw new _context4.t4(_context4.t5, _context4.t6);

              case 35:
                if (!(rateReq.depositCoinAmount && rateResp.limitMaxDepositCoin && rateReq.depositCoinAmount > rateResp.limitMaxDepositCoin)) {
                  _context4.next = 44;
                  break;
                }

                _context4.t7 = edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapAboveLimitError;
                _context4.t8 = swapInfo;
                _context4.next = 40;
                return request.fromWallet.denominationToNative(String(rateResp.limitMaxDepositCoin), request.fromCurrencyCode);

              case 40:
                _context4.t9 = _context4.sent;
                throw new _context4.t7(_context4.t8, _context4.t9);

              case 44:
                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

              case 45:
                _context4.next = 70;
                break;

              case 47:
                if (!rateResp.depositCoinAmount) {
                  _context4.next = 51;
                  break;
                }

                sourceAmount = rateResp.depositCoinAmount;
                _context4.next = 70;
                break;

              case 51:
                if (!(rateReq.destinationCoinAmount && rateResp.limitMinDestinationCoin && rateReq.destinationCoinAmount < rateResp.limitMinDestinationCoin)) {
                  _context4.next = 60;
                  break;
                }

                _context4.t10 = edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapBelowLimitError;
                _context4.t11 = swapInfo;
                _context4.next = 56;
                return request.toWallet.denominationToNative(String(rateResp.limitMinDestinationCoin), request.toCurrencyCode);

              case 56:
                _context4.t12 = _context4.sent;
                throw new _context4.t10(_context4.t11, _context4.t12);

              case 60:
                if (!(rateReq.destinationCoinAmount && rateResp.limitMaxDestinationCoin && rateReq.destinationCoinAmount > rateResp.limitMaxDestinationCoin)) {
                  _context4.next = 69;
                  break;
                }

                _context4.t13 = edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapAboveLimitError;
                _context4.t14 = swapInfo;
                _context4.next = 65;
                return request.toWallet.denominationToNative(String(rateResp.limitMaxDestinationCoin), request.toCurrencyCode);

              case 65:
                _context4.t15 = _context4.sent;
                throw new _context4.t13(_context4.t14, _context4.t15);

              case 69:
                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

              case 70:
                _context4.t16 = rateResp.dummyAddress;

                if (_context4.t16) {
                  _context4.next = 80;
                  break;
                }

                if (!(request.fromCurrencyCode === 'ETH')) {
                  _context4.next = 76;
                  break;
                }

                _context4.t17 = '0x0000000000000000000000000000000000000000';
                _context4.next = 79;
                break;

              case 76:
                _context4.next = 78;
                return getAddress(request.fromWallet, request.fromCurrencyCode);

              case 78:
                _context4.t17 = _context4.sent;

              case 79:
                _context4.t16 = _context4.t17;

              case 80:
                dummyAddress = _context4.t16;
                _context4.t18 = request.fromWallet;
                _context4.t19 = request.fromCurrencyCode;

                if (!(request.quoteFor === 'from')) {
                  _context4.next = 87;
                  break;
                }

                _context4.t20 = request.nativeAmount;
                _context4.next = 90;
                break;

              case 87:
                _context4.next = 89;
                return request.fromWallet.denominationToNative(String(sourceAmount), request.fromCurrencyCode);

              case 89:
                _context4.t20 = _context4.sent;

              case 90:
                _context4.t21 = _context4.t20;
                _context4.t22 = dummyAddress;
                _context4.t23 = {
                  nativeAmount: _context4.t21,
                  publicAddress: _context4.t22
                };
                _context4.t24 = [_context4.t23];
                _context4.t25 = request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard';
                _context4.t26 = {
                  currencyCode: _context4.t19,
                  spendTargets: _context4.t24,
                  networkFeeOption: _context4.t25
                };
                _context4.next = 98;
                return _context4.t18.makeSpend.call(_context4.t18, _context4.t26);

              case 98:
                dummyTx = _context4.sent;
                _context4.next = 101;
                return getAddress(request.toWallet, request.toCurrencyCode);

              case 101:
                destinationAddress = _context4.sent;

                if (!(request.quoteFor === 'from')) {
                  _context4.next = 106;
                  break;
                }

                _context4.t27 = request.nativeAmount;
                _context4.next = 109;
                break;

              case 106:
                _context4.next = 108;
                return request.fromWallet.denominationToNative(String(sourceAmount), request.fromCurrencyCode);

              case 108:
                _context4.t27 = _context4.sent;

              case 109:
                _context4.t28 = _context4.t27;

                if (!(request.quoteFor === 'from')) {
                  _context4.next = 116;
                  break;
                }

                _context4.next = 113;
                return request.toWallet.denominationToNative(String(targetAmount), request.toCurrencyCode);

              case 113:
                _context4.t29 = _context4.sent;
                _context4.next = 117;
                break;

              case 116:
                _context4.t29 = request.nativeAmount;

              case 117:
                _context4.t30 = _context4.t29;
                _context4.t31 = {
                  currencyCode: request.fromWallet.currencyInfo.currencyCode,
                  nativeAmount: dummyTx.parentNetworkFee != null ? dummyTx.parentNetworkFee : dummyTx.networkFee
                };
                _context4.t32 = destinationAddress;
                _context4.t33 = pluginId;
                _context4.t34 = new Date(rateResp.validTill || Date.now() + expirationMs);
                _context4.t35 = rateResp.futureOrderId;
                _context4.t36 = !rateResp.quoteToken;

                _context4.t37 = function approve() {
                  return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                    var orderResp, tx, signedTransaction, broadcastedTransaction;
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.next = 2;
                            return post('/order', {
                              depositCoin: request.fromCurrencyCode,
                              destinationCoin: request.toCurrencyCode,
                              depositCoinAmount: rateReq.depositCoinAmount || rateResp.depositCoinAmount,
                              destinationAddress: {
                                address: destinationAddress,
                                tag: null
                              },
                              futureOrderId: rateResp.futureOrderId,
                              quoteToken: rateResp.quoteToken
                            });

                          case 2:
                            orderResp = _context.sent;
                            log("transaction ID: ".concat(orderResp.orderId));
                            _context.t0 = request.fromWallet;
                            _context.t1 = request.fromCurrencyCode;
                            _context.next = 8;
                            return request.fromWallet.denominationToNative(String(orderResp.expectedDepositCoinAmount), request.fromCurrencyCode);

                          case 8:
                            _context.t2 = _context.sent;
                            _context.t3 = orderResp.exchangeAddress.address;
                            _context.t4 = orderResp.exchangeAddress.tag || undefined;
                            _context.t5 = {
                              nativeAmount: _context.t2,
                              publicAddress: _context.t3,
                              uniqueIdentifier: _context.t4
                            };
                            _context.t6 = [_context.t5];
                            _context.t7 = request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard';
                            _context.t8 = {
                              orderId: rateResp.futureOrderId,
                              orderUri: orderUri + rateResp.futureOrderId,
                              isEstimate: !rateResp.quoteToken,
                              payoutAddress: destinationAddress,
                              payoutCurrencyCode: request.toCurrencyCode,
                              payoutNativeAmount: quote.toNativeAmount,
                              payoutWalletId: request.toWallet.id,
                              plugin: _objectSpread({}, swapInfo),
                              refundAddress: undefined
                            };
                            _context.t9 = {
                              currencyCode: _context.t1,
                              spendTargets: _context.t6,
                              networkFeeOption: _context.t7,
                              swapData: _context.t8
                            };
                            _context.next = 18;
                            return _context.t0.makeSpend.call(_context.t0, _context.t9);

                          case 18:
                            tx = _context.sent;
                            _context.next = 21;
                            return request.fromWallet.signTx(tx);

                          case 21:
                            signedTransaction = _context.sent;
                            _context.next = 24;
                            return request.fromWallet.broadcastTx(signedTransaction);

                          case 24:
                            broadcastedTransaction = _context.sent;
                            _context.next = 27;
                            return request.fromWallet.saveTx(signedTransaction);

                          case 27:
                            return _context.abrupt("return", {
                              transaction: broadcastedTransaction,
                              orderId: rateResp.futureOrderId,
                              destinationAddress: destinationAddress
                            });

                          case 28:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }))();
                };

                _context4.t38 = function close() {
                  return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
                    return regeneratorRuntime.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            _context2.prev = 0;
                            _context2.next = 3;
                            return post('/cancelQuote', {
                              futureOrderId: rateResp.futureOrderId,
                              quoteToken: rateResp.quoteToken
                            });

                          case 3:
                            _context2.next = 7;
                            break;

                          case 5:
                            _context2.prev = 5;
                            _context2.t0 = _context2["catch"](0);

                          case 7:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2, null, [[0, 5]]);
                  }))();
                };

                quote = {
                  fromNativeAmount: _context4.t28,
                  toNativeAmount: _context4.t30,
                  networkFee: _context4.t31,
                  destinationAddress: _context4.t32,
                  pluginId: _context4.t33,
                  expirationDate: _context4.t34,
                  quoteId: _context4.t35,
                  isEstimate: _context4.t36,
                  approve: _context4.t37,
                  close: _context4.t38
                };
                return _context4.abrupt("return", quote);

              case 130:
                _context4.prev = 130;
                _context4.t39 = _context4["catch"](3);
                log("exception", _context4.t39);
                throw _context4.t39;

              case 134:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, null, [[3, 130]]);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/swap/godex.js":
/*!***************************!*\
  !*** ./src/swap/godex.js ***!
  \***************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeGodexPlugin": function() { return /* binding */ makeGodexPlugin; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../swap-helpers.js */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }




var pluginId = 'godex';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Godex',
  supportEmail: 'support@godex.io'
};
var orderUri = 'https://godex.io/exchange/waiting/';
var uri = 'https://api.godex.io/api/v1/';
var expirationMs = 1000 * 60 * 20;
var dontUseLegacy = {
  DGB: true
};
var INVALID_CURRENCY_CODES = {
  from: {
    ethereum: ['MATIC'],
    avalanche: 'allTokens',
    celo: 'allTokens',
    fantom: 'allTokens',
    polygon: 'allCodes',
    digibyte: 'allCodes'
  },
  to: {
    ethereum: ['MATIC'],
    avalanche: 'allTokens',
    celo: 'allTokens',
    fantom: 'allTokens',
    polygon: 'allCodes',
    zcash: ['ZEC']
  }
}; // Network names that don't match parent network currency code

var MAINNET_CODE_TRANSCRIPTION = {
  rsk: 'RSK',
  binancesmartchain: 'BSC',
  avalanche: 'AVAXC'
};

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(wallet, currencyCode) {
    var addressInfo;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context3.sent;
            return _context3.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _getAddress.apply(this, arguments);
}

function makeGodexPlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;

  function call(_x3, _x4, _x5) {
    return _call.apply(this, arguments);
  }

  function _call() {
    _call = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(url, request, data) {
      var body, headers, response;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              body = JSON.stringify(data.params);
              headers = {
                'Content-Type': 'application/json',
                Accept: 'application/json'
              };
              _context2.next = 4;
              return fetchCors(url, {
                method: 'POST',
                body: body,
                headers: headers
              });

            case 4:
              response = _context2.sent;

              if (response.ok) {
                _context2.next = 9;
                break;
              }

              if (!(response.status === 422)) {
                _context2.next = 8;
                break;
              }

              throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

            case 8:
              throw new Error("godex returned error code ".concat(response.status));

            case 9:
              return _context2.abrupt("return", response.json());

            case 10:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return _call.apply(this, arguments);
  }

  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _yield$Promise$all, _yield$Promise$all2, fromAddress, toAddress, quoteAmount, quoteParams, fromAmount, fromNativeAmount, toNativeAmount, reply, nativeMin, promoCode, _getCodesWithMainnetT, fromMainnetCode, toMainnetCode, sendReply, quoteInfo, spendInfo, tx;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo); // Grab addresses:

                _context.next = 3;
                return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

              case 3:
                _yield$Promise$all = _context.sent;
                _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
                fromAddress = _yield$Promise$all2[0];
                toAddress = _yield$Promise$all2[1];

                if (!(request.quoteFor === 'from')) {
                  _context.next = 13;
                  break;
                }

                _context.next = 10;
                return request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode);

              case 10:
                _context.t0 = _context.sent;
                _context.next = 16;
                break;

              case 13:
                _context.next = 15;
                return request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

              case 15:
                _context.t0 = _context.sent;

              case 16:
                quoteAmount = _context.t0;
                // Swap the currencies if we need a reverse quote:
                quoteParams = {
                  from: request.fromCurrencyCode,
                  to: request.toCurrencyCode,
                  amount: quoteAmount
                };
                log('quoteParams:', quoteParams); // Calculate the amounts:

                if (!(request.quoteFor === 'from')) {
                  _context.next = 30;
                  break;
                }

                _context.next = 22;
                return call(uri + 'info', request, {
                  params: quoteParams
                });

              case 22:
                reply = _context.sent;
                fromAmount = quoteAmount;
                fromNativeAmount = request.nativeAmount;
                _context.next = 27;
                return request.toWallet.denominationToNative(reply.amount.toString(), request.toCurrencyCode);

              case 27:
                toNativeAmount = _context.sent;
                _context.next = 38;
                break;

              case 30:
                _context.next = 32;
                return call(uri + 'info-revert', request, {
                  params: quoteParams
                });

              case 32:
                reply = _context.sent;
                fromAmount = reply.amount;
                _context.next = 36;
                return request.fromWallet.denominationToNative(fromAmount.toString(), request.fromCurrencyCode);

              case 36:
                fromNativeAmount = _context.sent;
                toNativeAmount = request.nativeAmount;

              case 38:
                log('fromNativeAmount' + fromNativeAmount);
                log('toNativeAmount' + toNativeAmount); // Check the minimum:

                _context.next = 42;
                return request.fromWallet.denominationToNative(reply.min_amount, request.fromCurrencyCode);

              case 42:
                nativeMin = _context.sent;

                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(fromNativeAmount, nativeMin)) {
                  _context.next = 45;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapBelowLimitError(swapInfo, nativeMin);

              case 45:
                promoCode = opts.promoCode;
                _getCodesWithMainnetT = (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.getCodesWithMainnetTranscription)(request, MAINNET_CODE_TRANSCRIPTION), fromMainnetCode = _getCodesWithMainnetT.fromMainnetCode, toMainnetCode = _getCodesWithMainnetT.toMainnetCode;
                _context.next = 49;
                return call(uri + 'transaction' + (promoCode != null ? "?promo=".concat(promoCode) : ''), request, {
                  params: {
                    deposit_amount: fromAmount,
                    coin_from: request.fromCurrencyCode,
                    coin_to: request.toCurrencyCode,
                    withdrawal: toAddress,
                    "return": fromAddress,
                    // return_extra_id: 'empty',
                    // withdrawal_extra_id: 'empty',
                    return_extra_id: null,
                    withdrawal_extra_id: null,
                    affiliate_id: initOptions.apiKey,
                    type: 'edge',
                    isEstimate: false,
                    coin_from_network: fromMainnetCode,
                    coin_to_network: toMainnetCode
                  }
                });

              case 49:
                sendReply = _context.sent;
                log('sendReply' + sendReply);
                quoteInfo = sendReply; // Make the transaction:

                spendInfo = {
                  currencyCode: request.fromCurrencyCode,
                  spendTargets: [{
                    nativeAmount: fromNativeAmount,
                    publicAddress: quoteInfo.deposit,
                    uniqueIdentifier: quoteInfo.deposit_extra_id
                  }],
                  networkFeeOption: request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                  swapData: {
                    orderId: quoteInfo.transaction_id,
                    orderUri: orderUri + quoteInfo.transaction_id,
                    isEstimate: false,
                    payoutAddress: toAddress,
                    payoutCurrencyCode: request.toCurrencyCode,
                    payoutNativeAmount: toNativeAmount,
                    payoutWalletId: request.toWallet.id,
                    plugin: _objectSpread({}, swapInfo),
                    refundAddress: fromAddress
                  }
                };
                log('spendInfo', spendInfo);
                _context.next = 56;
                return request.fromWallet.makeSpend(spendInfo);

              case 56:
                tx = _context.sent;
                return _context.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.makeSwapPluginQuote)(request, fromNativeAmount, toNativeAmount, tx, toAddress, 'godex', false, // isEstimate, correct?
                new Date(Date.now() + expirationMs), quoteInfo.transaction_id));

              case 58:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/swap/sideshift.js":
/*!*******************************!*\
  !*** ./src/swap/sideshift.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeSideshiftPlugin": function() { return /* binding */ makeSideshiftPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../swap-helpers.js */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }



 // Invalid currency codes should *not* have transcribed codes
// because currency codes with transcribed versions are NOT invalid

var CURRENCY_CODE_TRANSCRIPTION = {
  // Edge currencyCode: exchangeCurrencyCode
  ethereum: {
    USDT: 'usdtErc20'
  },
  binancesmartchain: {
    BNB: 'bsc'
  },
  zcash: {
    ZEC: 'zaddr'
  },
  avalanche: {
    AVAX: 'avaxc',
    'USDT.e': 'usdtavaxc'
  },
  polygon: {
    MATIC: 'polygon'
  },
  AVAX: {
    AVAX: 'avaxc'
  }
};
var INVALID_CURRENCY_CODES = {
  from: {
    ethereum: ['FTM', 'MATIC'],
    avalanche: 'allTokens',
    binancesmartchain: 'allTokens',
    celo: 'allTokens',
    fantom: 'allCodes',
    binance: 'allCodes',
    polygon: 'allTokens'
  },
  to: {
    ethereum: ['FTM', 'MATIC'],
    avalanche: 'allTokens',
    binancesmartchain: 'allTokens',
    celo: 'allTokens',
    fantom: 'allCodes',
    binance: 'allCodes',
    polygon: 'allTokens'
  }
};
var SIDESHIFT_BASE_URL = 'https://sideshift.ai/api/v1';
var pluginId = 'sideshift';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'SideShift.ai',
  supportEmail: 'help@sideshift.ai'
};
var ORDER_STATUS_URL = 'https://sideshift.ai/orders/';
var LOWER_CASE_CODES = true;

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(wallet, currencyCode) {
    var _addressInfo$segwitAd;

    var addressInfo;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context3.sent;
            return _context3.abrupt("return", (_addressInfo$segwitAd = addressInfo.segwitAddress) !== null && _addressInfo$segwitAd !== void 0 ? _addressInfo$segwitAd : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _getAddress.apply(this, arguments);
}

function checkQuoteError(_x3, _x4, _x5) {
  return _checkQuoteError.apply(this, arguments);
}

function _checkQuoteError() {
  _checkQuoteError = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(rate, request, quoteErrorMessage) {
    var fromCurrencyCode, fromWallet, toCurrencyCode, nativeMin, nativeMax;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            fromCurrencyCode = request.fromCurrencyCode, fromWallet = request.fromWallet, toCurrencyCode = request.toCurrencyCode;

            if (!(quoteErrorMessage === 'Amount too low')) {
              _context4.next = 6;
              break;
            }

            _context4.next = 4;
            return fromWallet.denominationToNative(rate.min, fromCurrencyCode);

          case 4:
            nativeMin = _context4.sent;
            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapBelowLimitError(swapInfo, nativeMin);

          case 6:
            if (!(quoteErrorMessage === 'Amount too high')) {
              _context4.next = 11;
              break;
            }

            _context4.next = 9;
            return fromWallet.denominationToNative(rate.max, fromCurrencyCode);

          case 9:
            nativeMax = _context4.sent;
            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapAboveLimitError(swapInfo, nativeMax);

          case 11:
            if (!(/method/i.test(quoteErrorMessage) && /disabled/i.test(quoteErrorMessage))) {
              _context4.next = 13;
              break;
            }

            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapCurrencyError(swapInfo, fromCurrencyCode, toCurrencyCode);

          case 13:
            if (!/country-blocked/i.test(quoteErrorMessage)) {
              _context4.next = 15;
              break;
            }

            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapPermissionError(swapInfo, 'geoRestriction');

          case 15:
            throw new Error("SideShift.ai error ".concat(quoteErrorMessage));

          case 16:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _checkQuoteError.apply(this, arguments);
}

var createSideshiftApi = function createSideshiftApi(baseUrl, fetch) {
  function request(_x6, _x7, _x8) {
    return _request.apply(this, arguments);
  }

  function _request() {
    _request = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(method, path, body) {
      var url, reply;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              url = "".concat(baseUrl).concat(path);
              _context.next = 3;
              return method === 'GET' ? fetch(url) : fetch(url, {
                method: method,
                headers: {
                  'Content-Type': 'application/json'
                },
                body: JSON.stringify(body)
              });

            case 3:
              reply = _context.sent;
              _context.prev = 4;
              _context.next = 7;
              return reply.json();

            case 7:
              return _context.abrupt("return", _context.sent);

            case 10:
              _context.prev = 10;
              _context.t0 = _context["catch"](4);
              throw new Error("SideShift.ai returned error code ".concat(reply.status));

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[4, 10]]);
    }));
    return _request.apply(this, arguments);
  }

  return {
    get: function get(path) {
      return request('GET', path);
    },
    post: function post(path, body) {
      return request('POST', path, body);
    }
  };
};

var createFetchSwapQuote = function createFetchSwapQuote(api, affiliateId) {
  return /*#__PURE__*/function () {
    var _fetchSwapQuote = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(request) {
      var _order$depositAddress;

      var _yield$Promise$all, _yield$Promise$all2, depositAddress, settleAddress, _safeCurrencyCodes, safeFromCurrencyCode, safeToCurrencyCode, rate, permissions, quoteAmount, depositAmount, fixedQuoteRequest, fixedQuote, orderRequest, order, spendInfoAmount, amountExpectedFromNative, amountExpectedToNative, isEstimate, destinationTag, spendInfo, tx;

      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo);
              _context2.next = 3;
              return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

            case 3:
              _yield$Promise$all = _context2.sent;
              _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
              depositAddress = _yield$Promise$all2[0];
              settleAddress = _yield$Promise$all2[1];
              _safeCurrencyCodes = (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.safeCurrencyCodes)(CURRENCY_CODE_TRANSCRIPTION, request, LOWER_CASE_CODES), safeFromCurrencyCode = _safeCurrencyCodes.safeFromCurrencyCode, safeToCurrencyCode = _safeCurrencyCodes.safeToCurrencyCode;
              _context2.t0 = asRate;
              _context2.next = 11;
              return api.get("/pairs/".concat(safeFromCurrencyCode, "/").concat(safeToCurrencyCode));

            case 11:
              _context2.t1 = _context2.sent;
              rate = (0, _context2.t0)(_context2.t1);

              if (!rate.error) {
                _context2.next = 15;
                break;
              }

              throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

            case 15:
              _context2.t2 = asPermissions;
              _context2.next = 18;
              return api.get('/permissions');

            case 18:
              _context2.t3 = _context2.sent;
              permissions = (0, _context2.t2)(_context2.t3);

              if (!(!permissions.createOrder || !permissions.createQuote)) {
                _context2.next = 22;
                break;
              }

              throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapPermissionError(swapInfo, 'geoRestriction');

            case 22:
              _context2.next = 24;
              return request.quoteFor === 'from' ? request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode) : request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

            case 24:
              quoteAmount = _context2.sent;
              depositAmount = request.quoteFor === 'from' ? quoteAmount : (parseFloat(quoteAmount) / parseFloat(rate.rate)).toFixed(8).toString();
              fixedQuoteRequest = asFixedQuoteRequest({
                depositMethod: safeFromCurrencyCode,
                settleMethod: safeToCurrencyCode,
                depositAmount: depositAmount
              });
              _context2.t4 = asFixedQuote;
              _context2.next = 30;
              return api.post('/quotes', fixedQuoteRequest);

            case 30:
              _context2.t5 = _context2.sent;
              fixedQuote = (0, _context2.t4)(_context2.t5);

              if (!fixedQuote.error) {
                _context2.next = 36;
                break;
              }

              _context2.next = 35;
              return checkQuoteError(rate, request, fixedQuote.error.message);

            case 35:
              throw new Error("SideShift.ai error ".concat(fixedQuote.error.message));

            case 36:
              orderRequest = asOrderRequest({
                type: 'fixed',
                quoteId: fixedQuote.id,
                affiliateId: affiliateId,
                settleAddress: settleAddress,
                refundAddress: depositAddress
              });
              _context2.t6 = asOrder;
              _context2.next = 40;
              return api.post('/orders', orderRequest);

            case 40:
              _context2.t7 = _context2.sent;
              order = (0, _context2.t6)(_context2.t7);

              if (!order.error) {
                _context2.next = 46;
                break;
              }

              _context2.next = 45;
              return checkQuoteError(rate, request, order.error.message);

            case 45:
              throw new Error("SideShift.ai error ".concat(order.error.message));

            case 46:
              _context2.next = 48;
              return request.fromWallet.denominationToNative(order.depositAmount, request.fromCurrencyCode.toUpperCase());

            case 48:
              spendInfoAmount = _context2.sent;
              _context2.next = 51;
              return request.fromWallet.denominationToNative(order.depositAmount, request.fromCurrencyCode);

            case 51:
              amountExpectedFromNative = _context2.sent;
              _context2.next = 54;
              return request.toWallet.denominationToNative(order.settleAmount, request.toCurrencyCode);

            case 54:
              amountExpectedToNative = _context2.sent;
              isEstimate = false;
              destinationTag = order.depositAddress.destinationTag != null ? "".concat(order.depositAddress.destinationTag) : undefined;
              spendInfo = {
                currencyCode: request.fromCurrencyCode,
                spendTargets: [{
                  nativeAmount: spendInfoAmount,
                  publicAddress: order.depositAddress.address,
                  uniqueIdentifier: (_order$depositAddress = order.depositAddress.memo) !== null && _order$depositAddress !== void 0 ? _order$depositAddress : destinationTag
                }],
                networkFeeOption: request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                swapData: {
                  orderId: order.orderId,
                  orderUri: ORDER_STATUS_URL + order.orderId,
                  isEstimate: isEstimate,
                  payoutAddress: settleAddress,
                  payoutCurrencyCode: request.toCurrencyCode,
                  payoutNativeAmount: amountExpectedToNative,
                  payoutWalletId: request.toWallet.id,
                  plugin: _objectSpread({}, swapInfo),
                  refundAddress: depositAddress
                }
              };
              _context2.next = 60;
              return request.fromWallet.makeSpend(spendInfo);

            case 60:
              tx = _context2.sent;
              return _context2.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.makeSwapPluginQuote)(request, amountExpectedFromNative, amountExpectedToNative, tx, settleAddress, pluginId, isEstimate, (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.ensureInFuture)(new Date(order.expiresAtISO)), order.id));

            case 62:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    function fetchSwapQuote(_x9) {
      return _fetchSwapQuote.apply(this, arguments);
    }

    return fetchSwapQuote;
  }();
};

function makeSideshiftPlugin(opts) {
  var io = opts.io,
      initOptions = opts.initOptions;
  var api = createSideshiftApi(SIDESHIFT_BASE_URL, io.fetchCors || io.fetch);
  var fetchSwapQuote = createFetchSwapQuote(api, initOptions.affiliateId);
  return {
    swapInfo: swapInfo,
    fetchSwapQuote: fetchSwapQuote
  };
}
var asError = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  error: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
    message: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
  })
});
var asPermissions = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  createOrder: cleaners__WEBPACK_IMPORTED_MODULE_0__.asBoolean,
  createQuote: cleaners__WEBPACK_IMPORTED_MODULE_0__.asBoolean
});
var asRate = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asEither)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  rate: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  min: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  max: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
}), asError);
var asFixedQuoteRequest = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  depositMethod: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  settleMethod: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  depositAmount: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
});
var asFixedQuote = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asEither)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  id: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
}), asError);
var asOrderRequest = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  type: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  quoteId: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  affiliateId: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  settleAddress: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  refundAddress: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
});
var asOrder = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asEither)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  expiresAtISO: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  depositAddress: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
    address: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
    memo: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asString),
    destinationTag: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asNumber)
  }),
  id: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  orderId: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  settleAmount: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  depositAmount: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
}), asError);

/***/ }),

/***/ "./src/swap/switchain.js":
/*!*******************************!*\
  !*** ./src/swap/switchain.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeSwitchainPlugin": function() { return /* binding */ makeSwitchainPlugin; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _swap_helpers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../swap-helpers */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }




var pluginId = 'switchain';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Switchain',
  supportEmail: 'help@switchain.com'
};
var apiUrl = 'https://api.switchain.com/rest/v1';
var orderUri = 'https://www.switchain.com/order-status/';
var INVALID_CURRENCY_CODES = {
  from: {
    ethereum: ['MATIC'],
    avalanche: 'allTokens',
    binancesmartchain: 'allCodes',
    celo: 'allTokens',
    fantom: 'allCodes',
    polygon: 'allCodes'
  },
  to: {
    ethereum: ['MATIC'],
    avalanche: 'allTokens',
    binancesmartchain: 'allCodes',
    celo: 'allTokens',
    fantom: 'allCodes',
    polygon: 'allCodes',
    zcash: ['ZEC']
  }
};
var dontUseLegacy = {
  DGB: true,
  LTC: true
};
var dummyAddresses = {
  ETH: '0x0000000000000000000000000000000000000000',
  XRP: 'rEb8TK3gBgk5auZkwc6sHnwrGVJH8DuaLh',
  XLM: 'GAHK7EEG2WWHVKDNT4CEQFZGKF2LGDSW2IVM4S5DP42RBW3K6BTODB4A',
  BNB: 'bnb136ns6lfw4zs5hg4n85vdthaad7hq5m4gtkgf23',
  XTZ: 'tz1dD2rBsYYLnsZtijtGqT4tynCEVaEJ6DeL',
  EOS: 'binancecleos'
};
function makeSwitchainPlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io;

  if (!initOptions.apiKey) {
    throw new Error('No Switchain API key provided.');
  }

  function getAddress(_x, _x2) {
    return _getAddress.apply(this, arguments);
  }

  function _getAddress() {
    _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(wallet, currencyCode) {
      var addressInfo;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return wallet.getReceiveAddress({
                currencyCode: currencyCode
              });

            case 2:
              addressInfo = _context4.sent;
              return _context4.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

            case 4:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));
    return _getAddress.apply(this, arguments);
  }

  function swHttpCall(_x3, _x4, _x5, _x6) {
    return _swHttpCall.apply(this, arguments);
  }

  function _swHttpCall() {
    _swHttpCall = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(path, method, body, query) {
      var requestOpts, queryParams, queryStringList, _i3, _Object$keys2, k, uri, reply, replyJson;

      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              requestOpts = {
                headers: {
                  'Content-Type': 'application/json',
                  Authorization: "Bearer ".concat(initOptions.apiKey)
                },
                method: method
              };

              if (body) {
                requestOpts = _objectSpread(_objectSpread({}, requestOpts), {}, {
                  body: JSON.stringify(body)
                });
              }

              queryParams = '';

              if (query) {
                queryStringList = [];

                for (_i3 = 0, _Object$keys2 = Object.keys(query); _i3 < _Object$keys2.length; _i3++) {
                  k = _Object$keys2[_i3];
                  queryStringList.push([k, query[k]]);
                }

                queryParams = "?".concat(new URLSearchParams(queryStringList).toString());
              }

              uri = "".concat(apiUrl).concat(path).concat(queryParams);
              _context5.next = 7;
              return io.fetch(uri, requestOpts);

            case 7:
              reply = _context5.sent;
              _context5.prev = 8;
              _context5.next = 11;
              return reply.json();

            case 11:
              replyJson = _context5.sent;
              _context5.next = 17;
              break;

            case 14:
              _context5.prev = 14;
              _context5.t0 = _context5["catch"](8);
              throw new Error("Switchain ".concat(uri, " returned error code ").concat(reply.status, " (no JSON)"));

            case 17:
              if (!(reply.status !== 200)) {
                _context5.next = 21;
                break;
              }

              if (!replyJson.reason) {
                _context5.next = 20;
                break;
              }

              throw new Error(replyJson.reason);

            case 20:
              throw new Error("Switchain ".concat(uri, " returned error code ").concat(replyJson.status, " with JSON ").concat(JSON.stringify(replyJson)));

            case 21:
              return _context5.abrupt("return", replyJson);

            case 22:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, null, [[8, 14]]);
    }));
    return _swHttpCall.apply(this, arguments);
  }

  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var fromWallet, nativeAmount, quoteFor, toCurrencyCode, toWallet, fromCurrencyCode, promoCode, pair, _yield$Promise$all, _yield$Promise$all2, fromAddress, toAddress, queryParameters, json, maxLimit, minLimit, minerFee, quote, signature, expiryTs, orderId, _yield$Promise$all3, _yield$Promise$all4, nativeMax, nativeMin, _yield$Promise$all5, _yield$Promise$all6, fromAmount, toAmount, quoteForFrom, toAmountInFrom, quoteAmount, orderCreationBody, fromNativeAmount, toNativeAmount, expirationDate, spendInfo, preliminaryTx, out;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                fromWallet = request.fromWallet, nativeAmount = request.nativeAmount, quoteFor = request.quoteFor, toCurrencyCode = request.toCurrencyCode, toWallet = request.toWallet;
                fromCurrencyCode = request.fromCurrencyCode;
                promoCode = opts.promoCode;
                (0,_swap_helpers__WEBPACK_IMPORTED_MODULE_2__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo);

                if (!(toCurrencyCode === fromCurrencyCode)) {
                  _context3.next = 6;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapCurrencyError(swapInfo, fromCurrencyCode, toCurrencyCode);

              case 6:
                // convert TBTC to BTC for testing purposes
                if (fromCurrencyCode.toUpperCase() === 'TESTBTC') {
                  fromCurrencyCode = 'BTC';
                  apiUrl = 'https://api-testnet.switchain.com/rest/v1';
                } else {
                  apiUrl = 'https://api.switchain.com/rest/v1';
                }

                pair = "".concat(fromCurrencyCode.toUpperCase(), "-").concat(toCurrencyCode.toUpperCase()); // get wallet addresses for exchange

                _context3.next = 10;
                return Promise.all([getAddress(fromWallet, fromCurrencyCode), getAddress(toWallet, toCurrencyCode)]);

              case 10:
                _yield$Promise$all = _context3.sent;
                _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
                fromAddress = _yield$Promise$all2[0];
                toAddress = _yield$Promise$all2[1];
                // retrieve quote for pair
                queryParameters = {
                  pair: pair,
                  orderIdSeed: toAddress
                };
                if (promoCode != null) queryParameters.promotionCode = promoCode;
                _context3.next = 18;
                return swHttpCall('/offer', 'GET', null, queryParameters);

              case 18:
                json = _context3.sent;
                maxLimit = json.maxLimit, minLimit = json.minLimit, minerFee = json.minerFee, quote = json.quote, signature = json.signature, expiryTs = json.expiryTs, orderId = json.orderId; // get native min max limits

                _context3.next = 22;
                return Promise.all([fromWallet.denominationToNative(maxLimit.toString(), fromCurrencyCode), fromWallet.denominationToNative(minLimit.toString(), fromCurrencyCode)]);

              case 22:
                _yield$Promise$all3 = _context3.sent;
                _yield$Promise$all4 = _slicedToArray(_yield$Promise$all3, 2);
                nativeMax = _yield$Promise$all4[0];
                nativeMin = _yield$Promise$all4[1];
                _context3.next = 28;
                return Promise.all([fromWallet.nativeToDenomination(nativeAmount, fromCurrencyCode), toWallet.nativeToDenomination(nativeAmount, toCurrencyCode)]);

              case 28:
                _yield$Promise$all5 = _context3.sent;
                _yield$Promise$all6 = _slicedToArray(_yield$Promise$all5, 2);
                fromAmount = _yield$Promise$all6[0];
                toAmount = _yield$Promise$all6[1];
                quoteForFrom = quoteFor === 'from'; // check for min / max limits

                if (!quoteForFrom) {
                  _context3.next = 40;
                  break;
                }

                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(nativeAmount, nativeMin)) {
                  _context3.next = 36;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapBelowLimitError(swapInfo, nativeMin);

              case 36:
                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.gt)(nativeAmount, nativeMax)) {
                  _context3.next = 38;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapAboveLimitError(swapInfo, nativeMax);

              case 38:
                _context3.next = 45;
                break;

              case 40:
                toAmountInFrom = (0,biggystring__WEBPACK_IMPORTED_MODULE_0__.div)(toAmount, quote, 8);

                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(toAmountInFrom, minLimit)) {
                  _context3.next = 43;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapBelowLimitError(swapInfo, nativeMin);

              case 43:
                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.gt)(toAmountInFrom, maxLimit)) {
                  _context3.next = 45;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapAboveLimitError(swapInfo, nativeMax);

              case 45:
                // order creation body
                quoteAmount = quoteForFrom ? {
                  fromAmount: fromAmount
                } : {
                  toAmount: toAmount
                };
                orderCreationBody = _objectSpread({
                  pair: pair,
                  toAddress: toAddress,
                  refundAddress: fromAddress,
                  signature: signature,
                  orderId: orderId
                }, quoteAmount);
                if (promoCode != null) orderCreationBody.promotionCode = promoCode; // plugin output creation

                fromNativeAmount = nativeAmount;
                _context3.next = 51;
                return toWallet.denominationToNative((0,biggystring__WEBPACK_IMPORTED_MODULE_0__.sub)((0,biggystring__WEBPACK_IMPORTED_MODULE_0__.mul)(quote, fromAmount), minerFee), toCurrencyCode);

              case 51:
                toNativeAmount = _context3.sent;

                if (quoteForFrom) {
                  _context3.next = 57;
                  break;
                }

                _context3.next = 55;
                return fromWallet.denominationToNative((0,biggystring__WEBPACK_IMPORTED_MODULE_0__.div)((0,biggystring__WEBPACK_IMPORTED_MODULE_0__.add)(toAmount, minerFee), quote, 8), fromCurrencyCode);

              case 55:
                fromNativeAmount = _context3.sent;
                toNativeAmount = nativeAmount;

              case 57:
                expirationDate = new Date(expiryTs * 1000); // create preliminary tx using our recieve address to calculate a networkFee

                spendInfo = {
                  currencyCode: fromCurrencyCode,
                  networkFeeOption: fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                  spendTargets: [{
                    nativeAmount: fromNativeAmount,
                    publicAddress: dummyAddresses[fromWallet.currencyInfo.currencyCode] || fromAddress
                  }]
                };
                _context3.next = 61;
                return fromWallet.makeSpend(spendInfo);

              case 61:
                preliminaryTx = _context3.sent;
                // convert that to the output format:
                out = {
                  isEstimate: false,
                  fromNativeAmount: fromNativeAmount,
                  toNativeAmount: toNativeAmount,
                  networkFee: {
                    currencyCode: fromWallet.currencyInfo.currencyCode,
                    nativeAmount: preliminaryTx.parentNetworkFee != null ? preliminaryTx.parentNetworkFee : preliminaryTx.networkFee
                  },
                  expirationDate: expirationDate,
                  pluginId: pluginId,
                  approve: function approve() {
                    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                      var json, orderId, exchangeAddress, exchangeAddressTag, spendTarget, spendInfo, completeTx, signedTransaction, broadcastedTransaction;
                      return regeneratorRuntime.wrap(function _callee$(_context) {
                        while (1) {
                          switch (_context.prev = _context.next) {
                            case 0:
                              _context.next = 2;
                              return swHttpCall('/order', 'POST', orderCreationBody);

                            case 2:
                              json = _context.sent;
                              orderId = json.orderId, exchangeAddress = json.exchangeAddress, exchangeAddressTag = json.exchangeAddressTag; // create tx with response and send

                              spendTarget = {
                                nativeAmount: fromNativeAmount,
                                publicAddress: exchangeAddress,
                                uniqueIdentifier: exchangeAddressTag
                              };
                              spendInfo = {
                                currencyCode: fromCurrencyCode,
                                spendTargets: [spendTarget],
                                networkFeeOption: fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                                swapData: {
                                  orderId: orderId,
                                  orderUri: orderUri + orderId,
                                  isEstimate: false,
                                  payoutAddress: toAddress,
                                  payoutCurrencyCode: request.toCurrencyCode,
                                  payoutNativeAmount: toNativeAmount,
                                  payoutWalletId: request.toWallet.id,
                                  plugin: _objectSpread({}, swapInfo),
                                  refundAddress: fromAddress
                                }
                              };
                              _context.next = 8;
                              return fromWallet.makeSpend(spendInfo);

                            case 8:
                              completeTx = _context.sent;
                              _context.next = 11;
                              return fromWallet.signTx(completeTx);

                            case 11:
                              signedTransaction = _context.sent;
                              _context.next = 14;
                              return fromWallet.broadcastTx(signedTransaction);

                            case 14:
                              broadcastedTransaction = _context.sent;
                              _context.next = 17;
                              return fromWallet.saveTx(signedTransaction);

                            case 17:
                              return _context.abrupt("return", {
                                transaction: broadcastedTransaction,
                                destinationAddress: exchangeAddress,
                                orderId: orderId
                              });

                            case 18:
                            case "end":
                              return _context.stop();
                          }
                        }
                      }, _callee);
                    }))();
                  },
                  close: function close() {
                    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
                      return regeneratorRuntime.wrap(function _callee2$(_context2) {
                        while (1) {
                          switch (_context2.prev = _context2.next) {
                            case 0:
                            case "end":
                              return _context2.stop();
                          }
                        }
                      }, _callee2);
                    }))();
                  }
                };
                return _context3.abrupt("return", out);

              case 64:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/swap/transfer.js":
/*!******************************!*\
  !*** ./src/swap/transfer.js ***!
  \******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeTransferPlugin": function() { return /* binding */ makeTransferPlugin; }
/* harmony export */ });
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../swap-helpers.js */ "./src/swap-helpers.js");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }



var pluginId = 'transfer';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Transfer',
  orderUri: undefined,
  supportEmail: 'support@edge.com'
};
function makeTransferPlugin(opts) {
  var log = opts.log;
  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _yield$request$toWall, toAddress, tx, quote;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(request.fromWallet.currencyInfo.pluginId !== request.toWallet.currencyInfo.pluginId || request.fromCurrencyCode !== request.toCurrencyCode)) {
                  _context.next = 2;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

              case 2:
                _context.next = 4;
                return request.toWallet.getReceiveAddress();

              case 4:
                _yield$request$toWall = _context.sent;
                toAddress = _yield$request$toWall.publicAddress;
                _context.next = 8;
                return request.fromWallet.makeSpend({
                  currencyCode: request.fromCurrencyCode,
                  spendTargets: [{
                    nativeAmount: request.nativeAmount,
                    publicAddress: toAddress
                  }]
                });

              case 8:
                tx = _context.sent;
                quote = (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_1__.makeSwapPluginQuote)(request, request.nativeAmount, request.nativeAmount, tx, toAddress, 'transfer');
                log(quote);
                return _context.abrupt("return", quote);

              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/util/biggystringplus.js":
/*!*************************************!*\
  !*** ./src/util/biggystringplus.js ***!
  \*************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "round": function() { return /* binding */ round; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }


var round = function round(num) {
  var _num$split = num.split('.'),
      _num$split2 = _slicedToArray(_num$split, 2),
      out = _num$split2[0],
      _num$split2$ = _num$split2[1],
      r = _num$split2$ === void 0 ? '0' : _num$split2$;

  return (0,biggystring__WEBPACK_IMPORTED_MODULE_0__.add)(out, (0,biggystring__WEBPACK_IMPORTED_MODULE_0__.gte)(r[0], '5') ? '1' : '0');
};

/***/ }),

/***/ "./node_modules/cleaners/lib/index.mjs":
/*!*********************************************!*\
  !*** ./node_modules/cleaners/lib/index.mjs ***!
  \*********************************************/
/***/ (function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "asArray": function() { return /* binding */ asArray; },
/* harmony export */   "asBoolean": function() { return /* binding */ asBoolean; },
/* harmony export */   "asCodec": function() { return /* binding */ asCodec; },
/* harmony export */   "asDate": function() { return /* binding */ asDate; },
/* harmony export */   "asEither": function() { return /* binding */ asEither; },
/* harmony export */   "asJSON": function() { return /* binding */ asJSON; },
/* harmony export */   "asMap": function() { return /* binding */ asMap; },
/* harmony export */   "asMaybe": function() { return /* binding */ asMaybe; },
/* harmony export */   "asNone": function() { return /* binding */ asNone; },
/* harmony export */   "asNull": function() { return /* binding */ asNull; },
/* harmony export */   "asNumber": function() { return /* binding */ asNumber; },
/* harmony export */   "asObject": function() { return /* binding */ asObject; },
/* harmony export */   "asOptional": function() { return /* binding */ asOptional; },
/* harmony export */   "asString": function() { return /* binding */ asString; },
/* harmony export */   "asUndefined": function() { return /* binding */ asUndefined; },
/* harmony export */   "asUnknown": function() { return /* binding */ asUnknown; },
/* harmony export */   "asValue": function() { return /* binding */ asValue; },
/* harmony export */   "uncleaner": function() { return /* binding */ uncleaner; }
/* harmony export */ });
/* harmony import */ var _index_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./index.js */ "./node_modules/cleaners/lib/index.js");
// Generated by rollup-plugin-mjs-entry



const asArray = _index_js__WEBPACK_IMPORTED_MODULE_0__.asArray;
const asBoolean = _index_js__WEBPACK_IMPORTED_MODULE_0__.asBoolean;
const asCodec = _index_js__WEBPACK_IMPORTED_MODULE_0__.asCodec;
const asDate = _index_js__WEBPACK_IMPORTED_MODULE_0__.asDate;
const asEither = _index_js__WEBPACK_IMPORTED_MODULE_0__.asEither;
const asJSON = _index_js__WEBPACK_IMPORTED_MODULE_0__.asJSON;
const asMap = _index_js__WEBPACK_IMPORTED_MODULE_0__.asMap;
const asMaybe = _index_js__WEBPACK_IMPORTED_MODULE_0__.asMaybe;
const asNone = _index_js__WEBPACK_IMPORTED_MODULE_0__.asNone;
const asNull = _index_js__WEBPACK_IMPORTED_MODULE_0__.asNull;
const asNumber = _index_js__WEBPACK_IMPORTED_MODULE_0__.asNumber;
const asObject = _index_js__WEBPACK_IMPORTED_MODULE_0__.asObject;
const asOptional = _index_js__WEBPACK_IMPORTED_MODULE_0__.asOptional;
const asString = _index_js__WEBPACK_IMPORTED_MODULE_0__.asString;
const asUndefined = _index_js__WEBPACK_IMPORTED_MODULE_0__.asUndefined;
const asUnknown = _index_js__WEBPACK_IMPORTED_MODULE_0__.asUnknown;
const asValue = _index_js__WEBPACK_IMPORTED_MODULE_0__.asValue;
const uncleaner = _index_js__WEBPACK_IMPORTED_MODULE_0__.uncleaner;


/***/ }),

/***/ "?3521":
/*!************************!*\
  !*** buffer (ignored) ***!
  \************************/
/***/ (function() {

/* (ignored) */

/***/ }),

/***/ "?8131":
/*!************************!*\
  !*** buffer (ignored) ***!
  \************************/
/***/ (function() {

/* (ignored) */

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			id: moduleId,
/******/ 			loaded: false,
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/amd options */
/******/ 	!function() {
/******/ 		__webpack_require__.amdO = {};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	!function() {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = function(module) {
/******/ 			var getter = module && module.__esModule ?
/******/ 				function() { return module['default']; } :
/******/ 				function() { return module; };
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	!function() {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = function(exports, definition) {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/global */
/******/ 	!function() {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/node module decorator */
/******/ 	!function() {
/******/ 		__webpack_require__.nmd = function(module) {
/******/ 			module.paths = [];
/******/ 			if (!module.children) module.children = [];
/******/ 			return module;
/******/ 		};
/******/ 	}();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
!function() {
"use strict";
/*!*****************************!*\
  !*** ./src/react-native.js ***!
  \*****************************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var regenerator_runtime_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! regenerator-runtime/runtime */ "./node_modules/regenerator-runtime/runtime.js");
/* harmony import */ var regenerator_runtime_runtime__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(regenerator_runtime_runtime__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _index_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./index.js */ "./src/index.js");


window.addEdgeCorePlugins(_index_js__WEBPACK_IMPORTED_MODULE_1__.default);
}();
/******/ })()
;
//# sourceMappingURL=edge-exchange-plugins.js.map